"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require("../");
var core_1 = require("../core");
var wall_1 = require("../core/wall");
var regex_1 = require("../core/regex");
var namespace_types_1 = require("./namespace.types");
var sExpression_1 = require("../utils/sExpression");
// TODO
// const C = Clause.withRegistry(nsObj);
var PredClause = _1.fclause({
    args: _1.cat('x', core_1.any()),
    ret: _1.isBool
});
var DescribeFnClause = _1.fclause({
    args: _1.cat('expression', _1.default('clause.types/Expression'), 'replacer', _1.default.zeroOrOne(_1.fclause({
        args: _1.cat(core_1.ExprClause),
        ret: _1.or(_1.isUndefined, _1.isNull, core_1.collOf(_1.isStr)),
    })), 'space', _1.default.zeroOrOne(_1.default.isNatInt)),
    ret: _1.isStr,
});
var SExpressionFnClause = _1.fclause({
    args: _1.cat('expression', _1.default('clause.types/Expression')),
    ret: sExpression_1.SExpressionClause
});
var MatchFnClause = _1.fclause({
    args: _1.cat('keyValMap', _1.isObj, 'handlers', _1.mapOf(_1.isStr, _1.fclause({
        args: _1.cat('val', core_1.any),
        ret: core_1.any,
    })))
});
var SingleArgPredClause = function () { return _1.fclause({
    args: _1.cat('x', core_1.any()),
    ret: _1.isBool,
}); };
var IsUuidFnClause = _1.fclause({
    args: _1.cat('x', _1.isStr),
    ret: _1.isBool,
});
var AnyClause = _1.fclause({
    ret: core_1.ClauseClause,
});
var FclauseClause = _1.isFclause;
var SCatFnClause = _1.fclause({
    args: _1.cat('string', _1.isStr),
    ret: core_1.ClauseClause,
});
var FclauseFnClause = _1.fclause({
    args: _1.cat(_1.shape({
        optional: {
            'args': _1.default('clause.types/Expression'),
            'ret': _1.default('clause.types/Expression'),
            'fn': _1.fclause({
                args: _1.cat('conformedArguments', core_1.any, 'conformedReturnValue', core_1.any),
                ret: core_1.any
            }),
        }
    })),
});
var clauseTransformFnClause = function () { return _1.fclause({
    args: _1.cat(core_1.ExprClause),
    ret: core_1.ClauseClause,
}); };
var InstanceOfFnClause = _1.fclause({
    args: _1.cat('instanceType', _1.isFn),
    ret: SingleArgPredClause(),
});
var NotFnClause = _1.fclause({
    args: _1.cat('predicateToNegate', _1.default('clause.types/Predicate')),
    ret: SingleArgPredClause(),
});
var EqualsFnClause = _1.fclause({
    args: _1.cat('valueToCompareWith', core_1.any()),
    ret: SingleArgPredClause(),
});
var OneOfFnClause = _1.fclause({
    args: _1.cat('valueOptions', core_1.collOf(_1.default('clause.types/Primitive'))),
    ret: SingleArgPredClause(),
});
var PrimitiveClause = _1.or(_1.isStr, _1.isNum, _1.isBool, _1.isNull, _1.isUndefined);
var EnforceFnClause = _1.fclause({
    args: _1.cat('expression', core_1.ExprClause, 'valueToCheck', core_1.any()),
    ret: _1.isUndefined
});
var ConformFnClause = _1.fclause({
    args: _1.cat('expression', core_1.ExprClause, 'valueToConform', core_1.any()),
    ret: _1.or('conformedValue', core_1.any(), 'problem', _1.default('clause.types/Problem')),
});
var DelayedFnClause = _1.fclause({
    args: _1.cat('getFn', _1.fclause({
        args: _1.cat(),
        ret: core_1.ExprClause,
    })),
    ret: core_1.DelayedClauseClause,
});
_1.default('/clause', namespace_types_1.NamespaceFnClause);
_1.default('clause.compose.regex/cat', core_1.CatFnClause);
_1.default('clause.compose.regex/or', core_1.OrFnClause);
_1.default('clause.compose.regex/zeroOrMore', core_1.ZeroOrMoreFnClause);
_1.default('clause.compose.regex/oneOrMore', core_1.OneOrMoreFnClause);
_1.default('clause.compose.regex/zeroOrOne', core_1.ZeroOrOneFnClause);
_1.default('clause.compose.string/scat', SCatFnClause);
_1.default('clause.compose/and', core_1.AndFnClause);
_1.default('clause.compose/collOf', core_1.CollOfClause);
_1.default('clause.compose/mapOf', regex_1.MapOfFnClause);
_1.default('clause.compose/shape', regex_1.ShapeFnClause);
_1.default('clause.compose/any', AnyClause);
_1.default('clause.compose/wall', wall_1.WallFnClause);
_1.default('clause.compose/fclause', FclauseFnClause);
_1.default('clause.compose/delayed', DelayedFnClause);
_1.default('clause.compose/nullable', clauseTransformFnClause());
_1.default('clause.compose/undefinable', clauseTransformFnClause());
_1.default('clause.compose/maybe', clauseTransformFnClause());
_1.default('clause.utils/enforce', EnforceFnClause);
_1.default('clause.utils/conform', ConformFnClause);
_1.default('clause.utils/describe', DescribeFnClause);
_1.default('clause.utils/sExpression', SExpressionFnClause);
_1.default('clause.utils/match', MatchFnClause);
_1.default('clause.utils/isProblem', SingleArgPredClause());
_1.default('clause.preds/not', NotFnClause);
_1.default('clause.preds/isObj', SingleArgPredClause());
_1.default('clause.preds/isPlainObj', SingleArgPredClause());
_1.default('clause.preds/isStr', SingleArgPredClause());
_1.default('clause.preds/isArray', SingleArgPredClause());
_1.default('clause.preds/isDate', SingleArgPredClause());
_1.default('clause.preds/isNull', SingleArgPredClause());
_1.default('clause.preds/isUndefined', SingleArgPredClause());
_1.default('clause.preds/notEmpty', SingleArgPredClause());
_1.default('clause.preds/isBool', SingleArgPredClause());
_1.default('clause.preds/isFn', SingleArgPredClause());
_1.default('clause.preds/isNum', SingleArgPredClause());
_1.default('clause.preds/isInt', SingleArgPredClause());
_1.default('clause.preds/isNatInt', SingleArgPredClause());
_1.default('clause.preds/isUuid', IsUuidFnClause);
_1.default('clause.preds/oneOf', OneOfFnClause);
_1.default('clause.preds/equals', EqualsFnClause);
_1.default('clause.preds/instanceOf', InstanceOfFnClause);
_1.default('/clause.namespace/set', namespace_types_1.SetNSFnClause);
_1.default('/clause.namespace/get', namespace_types_1.GetNSFnClause);
_1.default('/clause.namespace/resolve', namespace_types_1.ResolveFnClause);
_1.default('/clause.namespace/setMeta', namespace_types_1.SetMetaFnClause);
_1.default('/clause.namespace/getMeta', namespace_types_1.GetMetaFnClause);
_1.default('clause.types/Expression', core_1.ExprClause);
_1.default('clause.types/Clause', core_1.ClauseClause);
_1.default('clause.types/Problem', _1.isProblem);
_1.default('clause.types/FClause', FclauseClause);
_1.default('clause.types/Predicate', PredClause);
_1.default('clause.types/DelayedClause', core_1.DelayedClauseClause);
_1.default('clause.types/ClauseReference', core_1.ClauseRefClause);
_1.default('clause.types/NamespaceObj', namespace_types_1.NamespaceObjClause);
_1.default('clause.types/NamespacePath', namespace_types_1.isNamespacePath);
_1.default('clause.types/ClauseLabel', _1.isClauseName);
_1.default('clause.types/SExpression', sExpression_1.SExpressionClause);
_1.default('clause.types/Primitive', PrimitiveClause);
_1.default('clause.types/String', _1.isStr);
_1.default('clause.types/Bool', _1.isBool);
_1.default('clause.types/Number', _1.isNum);
_1.default('clause.types/Object', _1.isObj);
_1.default('clause.types/PlainObject', _1.isPlainObj);
_1.default('clause.types/Undefined', _1.isUndefined);
_1.default('clause.types/Null', _1.isNull);
exports.default = _1.default.getRegistry();
//# sourceMappingURL=index.js.map