"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var utils_1 = require("../utils");
exports.isClauseRef = utils_1.isClauseRef;
var utils_2 = require("../utils");
exports.isNamespacePath = utils_2.isNamespacePath;
var preds_1 = require("../preds");
var isExpr_1 = require("../utils/isExpr");
var ExprOrPartialRefMapClause = 
// or(
//  'expression',
utils_1.delayed(function () {
    //TODO
    return core_1.ExprClause;
});
// );
exports.GetArgClause = core_1.cat('nsPath', utils_1.isNamespacePath);
exports.GetNSFnClause = core_1.fclause({
    args: exports.GetArgClause,
    ret: utils_1.isClauseRef,
});
exports.SetArgClause = core_1.cat('nsPath', utils_1.isNamespacePath, 'expression', ExprOrPartialRefMapClause);
exports.SetNSFnClause = core_1.fclause({
    args: exports.SetArgClause,
    ret: preds_1.isBool,
});
exports.NamespaceArgsCLause = core_1.or('register', exports.SetArgClause, 'retrieve', exports.GetArgClause);
exports.NamespaceFnClause = core_1.fclause({
    args: exports.NamespaceArgsCLause,
    ret: core_1.or(preds_1.isUndefined, utils_1.isClauseRef)
});
exports.SetMetaFnClause = core_1.fclause({
    args: core_1.cat('source', core_1.or('namespacePath', utils_1.isNamespacePath, 'expression', core_1.ExprClause), 'metaObj', preds_1.isObj, 'registry', core_1.zeroOrOne(preds_1.isObj)),
    ret: preds_1.isUndefined,
});
exports.GetMetaFnClause = core_1.fclause({
    args: core_1.cat('source', core_1.or('namespacePath', utils_1.isNamespacePath, 'expression', core_1.ExprClause), 'registry', core_1.zeroOrOne(preds_1.isObj)),
    ret: core_1.maybe(preds_1.isObj)
});
exports.ResolveFnClause = core_1.fclause({
    args: core_1.cat('expression', core_1.ExprClause, 'registry', core_1.zeroOrOne(preds_1.isObj)),
    ret: utils_1.isNamespacePath,
});
function isNamespaceFragment(x) {
    return !!/^[^.@%\&\*#]+/.test(x);
}
exports.isNamespaceFragment = isNamespaceFragment;
exports.NamespaceObjClause = core_1.shape({
    optional: {
        subNamespaces: [isNamespaceFragment, utils_1.delayed(function () {
                return exports.NamespaceObjClause;
            })],
        '.meta': preds_1.isObj,
        '.expr': isExpr_1.default,
    }
});
//# sourceMappingURL=namespace.types.js.map