"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Clause_1 = require("../models/Clause");
var coerceIntoClause_1 = require("../utils/coerceIntoClause");
var regex_1 = require("./regex");
var fclause_1 = require("./fclause");
var walk_1 = require("../walk");
exports.WallFnClause = fclause_1.default({
    args: regex_1.cat(regex_1.ExprClause),
    ret: regex_1.ExprClause,
});
function wallOp(expr) {
    var clause = coerceIntoClause_1.default(expr);
    var wallS = new Clause_1.default({
        type: 'WALL',
        exprs: [clause],
        opts: { enclosedClause: clause },
        conformFn: null,
        generateFn: null
    });
    wallS.conform = function andConform(x) {
        return walk_1.default(wallS, x, { conform: true });
    };
    return wallS;
}
var wall = exports.WallFnClause.instrument(wallOp);
exports.default = wall;
//# sourceMappingURL=wall.js.map