"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var simulate_1 = require("../core/nfa/simulate");
var getMatch_1 = require("../core/nfa/getMatch");
var compile_1 = require("../core/nfa/compile");
var Problem_1 = require("../models/Problem");
function nfaWalker(clause, walkFn) {
    var nfa;
    return {
        trailblaze: nfaTrailblaze,
        reconstruct: nfaReconstruct,
    };
    function nfaTrailblaze(x, walkOpts) {
        if (!nfa) {
            //lazy
            nfa = compile_1.default(clause);
        }
        var _a = simulate_1.default(nfa, x, walkFn, walkOpts), chain = _a.chain, matched = _a.matched, lastProblem = _a.lastProblem;
        if (matched === true) {
            return { chain: chain };
        }
        else {
            var subproblems = void 0;
            if (lastProblem) {
                var name_1 = lastProblem.name, position = lastProblem.position, problem = lastProblem.problem;
                subproblems = (_b = {}, _b[name_1 ? "\"" + name_1 + "\"" : "<At position " + position + ">"] = problem, _b);
            }
            else {
                subproblems = [];
            }
            return new Problem_1.default(x, clause, subproblems, 'Clause ' + clause.type + ' did not match value');
        }
        var _b;
    }
    function nfaReconstruct(_a, walkOpts) {
        var chain = _a.chain;
        var result = getMatch_1.default(chain, walkFn, walkOpts);
        return result;
    }
}
exports.default = nfaWalker;
//# sourceMappingURL=nfaWalker.js.map