// @license magnet:?xt=urn:btih:1f739d935676111cfff4b4693e3816e664797050&dn=gpl-3.0.txt GPL-v3-or-Later

var initMirrorCustomExtensions = function() {
              CodeMirror.extendMode("css", {
                commentStart: "/*",
                commentEnd: "*/",
                newlineAfterToken: function(type, content) {
                  return /^[;{}]$/.test(content);
                }
              });
              CodeMirror.extendMode("javascript", {
                commentStart: "/*",
                commentEnd: "*/",
                // FIXME semicolons inside of for
                newlineAfterToken: function(type, content, textAfter, state) {
                  if (this.jsonMode) {
                    return /^[\[,{]$/.test(content) || /^}/.test(textAfter);
                  } else {
                    if (content == ";" && state.lexical && state.lexical.type == ")") return false;
                    return /^[;{}]$/.test(content) && !/^;/.test(textAfter);
                  }
                }
              });
              CodeMirror.extendMode("xml", {
                commentStart: "<!--",
                commentEnd: "-->",
                newlineAfterToken: function(type, content, textAfter) {
                  return type == "tag" && />$/.test(content) || /^</.test(textAfter);
                }
              });
              // Comment/uncomment the specified range
              CodeMirror.defineExtension("commentRange", function (isComment, from, to) {
                var cm = this, curMode = CodeMirror.innerMode(cm.getMode(), cm.getTokenAt(from).state).mode;
                cm.operation(function() {
                  if (isComment) { // Comment range
                    cm.replaceRange(curMode.commentEnd, to);
                    cm.replaceRange(curMode.commentStart, from);
                    if (from.line == to.line && from.ch == to.ch) // An empty comment inserted - put cursor inside
                      cm.setCursor(from.line, from.ch + curMode.commentStart.length);
                  } else { // Uncomment range
                    var selText = cm.getRange(from, to);
                    var startIndex = selText.indexOf(curMode.commentStart);
                    var endIndex = selText.lastIndexOf(curMode.commentEnd);
                    if (startIndex > -1 && endIndex > -1 && endIndex > startIndex) {
                      // Take string till comment start
                      selText = selText.substr(0, startIndex)
                      // From comment start till comment end
                        + selText.substring(startIndex + curMode.commentStart.length, endIndex)
                      // From comment end till string end
                        + selText.substr(endIndex + curMode.commentEnd.length);
                    }
                    cm.replaceRange(selText, from, to);
                  }
                });
              });
              // Applies automatic mode-aware indentation to the specified range
              CodeMirror.defineExtension("autoIndentRange", function (from, to) {
                var cmInstance = this;
                this.operation(function () {
                  for (var i = from.line; i <= to.line; i++) {
                    cmInstance.indentLine(i, "smart");
                  }
                });
              });
              // Applies automatic formatting to the specified range
              CodeMirror.defineExtension("autoFormatRange", function (from, to) {
                var cm = this;
                var outer = cm.getMode(), text = cm.getRange(from, to).split("\n");
                var state = CodeMirror.copyState(outer, cm.getTokenAt(from).state);
                var tabSize = cm.getOption("tabSize");
                var out = "", lines = 0, atSol = from.ch == 0;
                function newline() {
                  out += "\n";
                  atSol = true;
                  ++lines;
                }
                for (var i = 0; i < text.length; ++i) {
                  var stream = new CodeMirror.StringStream(text[i], tabSize);
                  while (!stream.eol()) {
                    var inner = CodeMirror.innerMode(outer, state);
                    var style = outer.token(stream, state), cur = stream.current();
                    stream.start = stream.pos;
                    if (!atSol || /\S/.test(cur)) {
                      out += cur;
                      atSol = false;
                    }
                    if (!atSol && inner.mode.newlineAfterToken &&
                        inner.mode.newlineAfterToken(style, cur, stream.string.slice(stream.pos) || text[i+1] || "", inner.state))
                      newline();
                  }
                  if (!stream.pos && outer.blankLine) outer.blankLine(state);
                  if (!atSol) newline();
                }
                cm.operation(function () {
                  cm.replaceRange(out, from, to);
                  for (var cur = from.line + 1, end = from.line + lines; cur <= end; ++cur)
                    cm.indentLine(cur, "smart");
                  cm.setSelection(from, cm.getCursor(false));
                });
              });
            };
if(typeof Math.imul == "undefined" || (Math.imul(0xffffffff,5) == 0)) {
    Math.imul = function (a, b) {
        var ah  = (a >>> 16) & 0xffff;
        var al = a & 0xffff;
        var bh  = (b >>> 16) & 0xffff;
        var bl = b & 0xffff;
        // the shift by 0 fixes the sign on the high part
        // the final |0 converts the unsigned value into a signed value
        return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0)|0);
    }
}

(function(q){if("object"==typeof exports&&"object"==typeof module)module.exports=q();else{if("function"==typeof define&&define.amd)return define([],q);(this||window).CodeMirror=q()}})(function(){function q(a,b){if(!(this instanceof q))return new q(a,b);this.options=b=b?X(b):{};X(wf,b,!1);wc(b);var c=b.value;"string"==typeof c&&(c=new Q(c,b.mode,null,b.lineSeparator));this.doc=c;var d=new q.inputStyles[b.inputStyle](this),d=this.display=new xf(a,c,d);d.wrapper.CodeMirror=this;zd(this);Ad(this);b.lineWrapping&&
(this.display.wrapper.className+=" CodeMirror-wrap");b.autofocus&&!ab&&d.input.focus();Bd(this);this.state={keyMaps:[],overlays:[],modeGen:0,overwrite:!1,delayingBlurEvent:!1,focused:!1,suppressEdits:!1,pasteIncoming:!1,cutIncoming:!1,selectingText:!1,draggingText:!1,highlight:new ua,keySeq:null,specialChars:null};var e=this;A&&11>B&&setTimeout(function(){e.display.input.reset(!0)},20);yf(this);Cd||(zf(),Cd=!0);Ja(this);this.curOp.forceUpdate=!0;Dd(this,c);b.autofocus&&!ab||e.hasFocus()?setTimeout(xc(yc,
this),20):bb(this);for(var f in Ka)if(Ka.hasOwnProperty(f))Ka[f](this,b[f],Ed);Fd(this);b.finishInit&&b.finishInit(this);for(c=0;c<zc.length;++c)zc[c](this);La(this);K&&b.lineWrapping&&"optimizelegibility"==getComputedStyle(d.lineDiv).textRendering&&(d.lineDiv.style.textRendering="auto")}function xf(a,b,c){this.input=c;this.scrollbarFiller=s("div",null,"CodeMirror-scrollbar-filler");this.scrollbarFiller.setAttribute("cm-not-content","true");this.gutterFiller=s("div",null,"CodeMirror-gutter-filler");
this.gutterFiller.setAttribute("cm-not-content","true");this.lineDiv=s("div",null,"CodeMirror-code");this.selectionDiv=s("div",null,null,"position: relative; z-index: 1");this.cursorDiv=s("div",null,"CodeMirror-cursors");this.measure=s("div",null,"CodeMirror-measure");this.lineMeasure=s("div",null,"CodeMirror-measure");this.lineSpace=s("div",[this.measure,this.lineMeasure,this.selectionDiv,this.cursorDiv,this.lineDiv],null,"position: relative; outline: none");this.mover=s("div",[s("div",[this.lineSpace],
"CodeMirror-lines")],null,"position: relative");this.sizer=s("div",[this.mover],"CodeMirror-sizer");this.sizerWidth=null;this.heightForcer=s("div",null,null,"position: absolute; height: "+Gd+"px; width: 1px;");this.gutters=s("div",null,"CodeMirror-gutters");this.lineGutter=null;this.scroller=s("div",[this.sizer,this.heightForcer,this.gutters],"CodeMirror-scroll");this.scroller.setAttribute("tabIndex","-1");this.wrapper=s("div",[this.scrollbarFiller,this.gutterFiller,this.scroller],"CodeMirror");A&&
8>B&&(this.gutters.style.zIndex=-1,this.scroller.style.paddingRight=0);K||oa&&ab||(this.scroller.draggable=!0);a&&(a.appendChild?a.appendChild(this.wrapper):a(this.wrapper));this.reportedViewFrom=this.reportedViewTo=this.viewFrom=this.viewTo=b.first;this.view=[];this.externalMeasured=this.renderedView=null;this.lastWrapHeight=this.lastWrapWidth=this.viewOffset=0;this.updateLineNumbers=null;this.nativeBarWidth=this.barHeight=this.barWidth=0;this.scrollbarsClipped=!1;this.lineNumWidth=this.lineNumInnerWidth=
this.lineNumChars=null;this.alignWidgets=!1;this.maxLine=this.cachedCharWidth=this.cachedTextHeight=this.cachedPaddingH=null;this.maxLineLength=0;this.maxLineChanged=!1;this.wheelDX=this.wheelDY=this.wheelStartX=this.wheelStartY=null;this.shift=!1;this.activeTouch=this.selForContextMenu=null;c.init(this)}function Ac(a){a.doc.mode=q.getMode(a.options,a.doc.modeOption);cb(a)}function cb(a){a.doc.iter(function(a){a.stateAfter&&(a.stateAfter=null);a.styles&&(a.styles=null)});a.doc.frontier=a.doc.first;
db(a,100);a.state.modeGen++;a.curOp&&M(a)}function Hd(a){var b=va(a.display),c=a.options.lineWrapping,d=c&&Math.max(5,a.display.scroller.clientWidth/eb(a.display)-3);return function(e){if(wa(a.doc,e))return 0;var f=0;if(e.widgets)for(var g=0;g<e.widgets.length;g++)e.widgets[g].height&&(f+=e.widgets[g].height);return c?f+(Math.ceil(e.text.length/d)||1)*b:f+b}}function Bc(a){var b=a.doc,c=Hd(a);b.iter(function(a){var b=c(a);b!=a.height&&ca(a,b)})}function Ad(a){a.display.wrapper.className=a.display.wrapper.className.replace(/\s*cm-s-\S+/g,
"")+a.options.theme.replace(/(^|\s)\s*/g," cm-s-");fb(a)}function gb(a){zd(a);M(a);setTimeout(function(){Cc(a)},20)}function zd(a){var b=a.display.gutters,c=a.options.gutters;pa(b);for(var d=0;d<c.length;++d){var e=c[d],f=b.appendChild(s("div",null,"CodeMirror-gutter "+e));"CodeMirror-linenumbers"==e&&(a.display.lineGutter=f,f.style.width=(a.display.lineNumWidth||1)+"px")}b.style.display=d?"":"none";Dc(a)}function Dc(a){a.display.sizer.style.marginLeft=a.display.gutters.offsetWidth+"px"}function Ib(a){if(0==
a.height)return 0;for(var b=a.text.length,c,d=a;c=xa(d,!0);)c=c.find(0,!0),d=c.from.line,b+=c.from.ch-c.to.ch;for(d=a;c=xa(d,!1);)c=c.find(0,!0),b-=d.text.length-c.from.ch,d=c.to.line,b+=d.text.length-c.to.ch;return b}function Ec(a){var b=a.display;a=a.doc;b.maxLine=t(a,a.first);b.maxLineLength=Ib(b.maxLine);b.maxLineChanged=!0;a.iter(function(a){var d=Ib(a);d>b.maxLineLength&&(b.maxLineLength=d,b.maxLine=a)})}function wc(a){var b=D(a.gutters,"CodeMirror-linenumbers");-1==b&&a.lineNumbers?a.gutters=
a.gutters.concat(["CodeMirror-linenumbers"]):-1<b&&!a.lineNumbers&&(a.gutters=a.gutters.slice(0),a.gutters.splice(b,1))}function hb(a){var b=a.display,c=b.gutters.offsetWidth,d=Math.round(a.doc.height+Fc(a.display));return{clientHeight:b.scroller.clientHeight,viewHeight:b.wrapper.clientHeight,scrollWidth:b.scroller.scrollWidth,clientWidth:b.scroller.clientWidth,viewWidth:b.wrapper.clientWidth,barLeft:a.options.fixedGutter?c:0,docHeight:d,scrollHeight:d+da(a)+b.barHeight,nativeBarWidth:b.nativeBarWidth,
gutterWidth:c}}function Gc(a,b,c){this.cm=c;var d=this.vert=s("div",[s("div",null,null,"min-width: 1px")],"CodeMirror-vscrollbar"),e=this.horiz=s("div",[s("div",null,null,"height: 100%; min-height: 1px")],"CodeMirror-hscrollbar");a(d);a(e);v(d,"scroll",function(){d.clientHeight&&b(d.scrollTop,"vertical")});v(e,"scroll",function(){e.clientWidth&&b(e.scrollLeft,"horizontal")});this.checkedZeroWidth=!1;A&&8>B&&(this.horiz.style.minHeight=this.vert.style.minWidth="18px")}function Hc(){}function Bd(a){a.display.scrollbars&&
(a.display.scrollbars.clear(),a.display.scrollbars.addClass&&ib(a.display.wrapper,a.display.scrollbars.addClass));a.display.scrollbars=new q.scrollbarModel[a.options.scrollbarStyle](function(b){a.display.wrapper.insertBefore(b,a.display.scrollbarFiller);v(b,"mousedown",function(){a.state.focused&&setTimeout(function(){a.display.input.focus()},0)});b.setAttribute("cm-not-content","true")},function(b,c){"horizontal"==c?Ma(a,b):jb(a,b)},a);a.display.scrollbars.addClass&&kb(a.display.wrapper,a.display.scrollbars.addClass)}
function Na(a,b){b||(b=hb(a));var c=a.display.barWidth,d=a.display.barHeight;Id(a,b);for(var e=0;4>e&&c!=a.display.barWidth||d!=a.display.barHeight;e++)c!=a.display.barWidth&&a.options.lineWrapping&&Jb(a),Id(a,hb(a)),c=a.display.barWidth,d=a.display.barHeight}function Id(a,b){var c=a.display,d=c.scrollbars.update(b);c.sizer.style.paddingRight=(c.barWidth=d.right)+"px";c.sizer.style.paddingBottom=(c.barHeight=d.bottom)+"px";c.heightForcer.style.borderBottom=d.bottom+"px solid transparent";d.right&&
d.bottom?(c.scrollbarFiller.style.display="block",c.scrollbarFiller.style.height=d.bottom+"px",c.scrollbarFiller.style.width=d.right+"px"):c.scrollbarFiller.style.display="";d.bottom&&a.options.coverGutterNextToScrollbar&&a.options.fixedGutter?(c.gutterFiller.style.display="block",c.gutterFiller.style.height=d.bottom+"px",c.gutterFiller.style.width=b.gutterWidth+"px"):c.gutterFiller.style.display=""}function Ic(a,b,c){var d=c&&null!=c.top?Math.max(0,c.top):a.scroller.scrollTop,d=Math.floor(d-a.lineSpace.offsetTop),
e=c&&null!=c.bottom?c.bottom:d+a.wrapper.clientHeight,d=ya(b,d),e=ya(b,e);if(c&&c.ensure){var f=c.ensure.from.line;c=c.ensure.to.line;f<d?(d=f,e=ya(b,ea(t(b,f))+a.wrapper.clientHeight)):Math.min(c,b.lastLine())>=e&&(d=ya(b,ea(t(b,c))-a.wrapper.clientHeight),e=c)}return{from:d,to:Math.max(e,d+1)}}function Cc(a){var b=a.display,c=b.view;if(b.alignWidgets||b.gutters.firstChild&&a.options.fixedGutter){for(var d=Jc(b)-b.scroller.scrollLeft+a.doc.scrollLeft,e=b.gutters.offsetWidth,f=d+"px",g=0;g<c.length;g++)if(!c[g].hidden){a.options.fixedGutter&&
(c[g].gutter&&(c[g].gutter.style.left=f),c[g].gutterBackground&&(c[g].gutterBackground.style.left=f));var h=c[g].alignable;if(h)for(var k=0;k<h.length;k++)h[k].style.left=f}a.options.fixedGutter&&(b.gutters.style.left=d+e+"px")}}function Fd(a){if(!a.options.lineNumbers)return!1;var b=a.doc,b=Kc(a.options,b.first+b.size-1),c=a.display;if(b.length!=c.lineNumChars){var d=c.measure.appendChild(s("div",[s("div",b)],"CodeMirror-linenumber CodeMirror-gutter-elt")),e=d.firstChild.offsetWidth,d=d.offsetWidth-
e;c.lineGutter.style.width="";c.lineNumInnerWidth=Math.max(e,c.lineGutter.offsetWidth-d)+1;c.lineNumWidth=c.lineNumInnerWidth+d;c.lineNumChars=c.lineNumInnerWidth?b.length:-1;c.lineGutter.style.width=c.lineNumWidth+"px";Dc(a);return!0}return!1}function Kc(a,b){return String(a.lineNumberFormatter(b+a.firstLineNumber))}function Jc(a){return a.scroller.getBoundingClientRect().left-a.sizer.getBoundingClientRect().left}function Kb(a,b,c){var d=a.display;this.viewport=b;this.visible=Ic(d,a.doc,b);this.editorIsHidden=
!d.wrapper.offsetWidth;this.wrapperHeight=d.wrapper.clientHeight;this.wrapperWidth=d.wrapper.clientWidth;this.oldDisplayWidth=za(a);this.force=c;this.dims=Lc(a);this.events=[]}function Mc(a,b){var c=a.display,d=a.doc;if(b.editorIsHidden)return qa(a),!1;if(!b.force&&b.visible.from>=c.viewFrom&&b.visible.to<=c.viewTo&&(null==c.updateLineNumbers||c.updateLineNumbers>=c.viewTo)&&c.renderedView==c.view&&0==Jd(a))return!1;Fd(a)&&(qa(a),b.dims=Lc(a));var e=d.first+d.size,f=Math.max(b.visible.from-a.options.viewportMargin,
d.first),g=Math.min(e,b.visible.to+a.options.viewportMargin);c.viewFrom<f&&20>f-c.viewFrom&&(f=Math.max(d.first,c.viewFrom));c.viewTo>g&&20>c.viewTo-g&&(g=Math.min(e,c.viewTo));ra&&(f=Nc(a.doc,f),g=Kd(a.doc,g));d=f!=c.viewFrom||g!=c.viewTo||c.lastWrapHeight!=b.wrapperHeight||c.lastWrapWidth!=b.wrapperWidth;e=a.display;0==e.view.length||f>=e.viewTo||g<=e.viewFrom?(e.view=Lb(a,f,g),e.viewFrom=f):(e.viewFrom>f?e.view=Lb(a,f,e.viewFrom).concat(e.view):e.viewFrom<f&&(e.view=e.view.slice(Aa(a,f))),e.viewFrom=
f,e.viewTo<g?e.view=e.view.concat(Lb(a,e.viewTo,g)):e.viewTo>g&&(e.view=e.view.slice(0,Aa(a,g))));e.viewTo=g;c.viewOffset=ea(t(a.doc,c.viewFrom));a.display.mover.style.top=c.viewOffset+"px";g=Jd(a);if(!d&&0==g&&!b.force&&c.renderedView==c.view&&(null==c.updateLineNumbers||c.updateLineNumbers>=c.viewTo))return!1;f=fa();4<g&&(c.lineDiv.style.display="none");Af(a,c.updateLineNumbers,b.dims);4<g&&(c.lineDiv.style.display="");c.renderedView=c.view;f&&fa()!=f&&f.offsetHeight&&f.focus();pa(c.cursorDiv);
pa(c.selectionDiv);c.gutters.style.height=c.sizer.style.minHeight=0;d&&(c.lastWrapHeight=b.wrapperHeight,c.lastWrapWidth=b.wrapperWidth,db(a,400));c.updateLineNumbers=null;return!0}function Ld(a,b){for(var c=b.viewport,d=!0;;d=!1){if(!d||!a.options.lineWrapping||b.oldDisplayWidth==za(a))if(c&&null!=c.top&&(c={top:Math.min(a.doc.height+Fc(a.display)-Oc(a),c.top)}),b.visible=Ic(a.display,a.doc,c),b.visible.from>=a.display.viewFrom&&b.visible.to<=a.display.viewTo)break;if(!Mc(a,b))break;Jb(a);d=hb(a);
lb(a);Na(a,d);Pc(a,d)}b.signal(a,"update",a);if(a.display.viewFrom!=a.display.reportedViewFrom||a.display.viewTo!=a.display.reportedViewTo)b.signal(a,"viewportChange",a,a.display.viewFrom,a.display.viewTo),a.display.reportedViewFrom=a.display.viewFrom,a.display.reportedViewTo=a.display.viewTo}function Qc(a,b){var c=new Kb(a,b);if(Mc(a,c)){Jb(a);Ld(a,c);var d=hb(a);lb(a);Na(a,d);Pc(a,d);c.finish()}}function Pc(a,b){a.display.sizer.style.minHeight=b.docHeight+"px";a.display.heightForcer.style.top=b.docHeight+
"px";a.display.gutters.style.height=b.docHeight+a.display.barHeight+da(a)+"px"}function Jb(a){a=a.display;for(var b=a.lineDiv.offsetTop,c=0;c<a.view.length;c++){var d=a.view[c],e;if(!d.hidden){if(A&&8>B){var f=d.node.offsetTop+d.node.offsetHeight;e=f-b;b=f}else e=d.node.getBoundingClientRect(),e=e.bottom-e.top;f=d.line.height-e;2>e&&(e=va(a));if(.001<f||-.001>f)if(ca(d.line,e),Md(d.line),d.rest)for(e=0;e<d.rest.length;e++)Md(d.rest[e])}}}function Md(a){if(a.widgets)for(var b=0;b<a.widgets.length;++b)a.widgets[b].height=
a.widgets[b].node.parentNode.offsetHeight}function Lc(a){for(var b=a.display,c={},d={},e=b.gutters.clientLeft,f=b.gutters.firstChild,g=0;f;f=f.nextSibling,++g)c[a.options.gutters[g]]=f.offsetLeft+f.clientLeft+e,d[a.options.gutters[g]]=f.clientWidth;return{fixedPos:Jc(b),gutterTotalWidth:b.gutters.offsetWidth,gutterLeft:c,gutterWidth:d,wrapperWidth:b.wrapper.clientWidth}}function Af(a,b,c){function d(b){var c=b.nextSibling;K&&Y&&a.display.currentWheelTarget==b?b.style.display="none":b.parentNode.removeChild(b);
return c}for(var e=a.display,f=a.options.lineNumbers,g=e.lineDiv,h=g.firstChild,k=e.view,e=e.viewFrom,l=0;l<k.length;l++){var m=k[l];if(!m.hidden)if(m.node&&m.node.parentNode==g){for(;h!=m.node;)h=d(h);h=f&&null!=b&&b<=e&&m.lineNumber;m.changes&&(-1<D(m.changes,"gutter")&&(h=!1),Nd(a,m,e,c));h&&(pa(m.lineNumber),m.lineNumber.appendChild(document.createTextNode(Kc(a.options,e))));h=m.node.nextSibling}else{var p=Bf(a,m,e,c);g.insertBefore(p,h)}e+=m.size}for(;h;)h=d(h)}function Nd(a,b,c,d){for(var e=
0;e<b.changes.length;e++){var f=b.changes[e];if("text"==f){var f=b,g=f.text.className,h=Od(a,f);f.text==f.node&&(f.node=h.pre);f.text.parentNode.replaceChild(h.pre,f.text);f.text=h.pre;h.bgClass!=f.bgClass||h.textClass!=f.textClass?(f.bgClass=h.bgClass,f.textClass=h.textClass,Rc(f)):g&&(f.text.className=g)}else if("gutter"==f)Pd(a,b,c,d);else if("class"==f)Rc(b);else if("widget"==f){f=a;g=b;h=d;g.alignable&&(g.alignable=null);for(var k=g.node.firstChild,l=void 0;k;k=l)l=k.nextSibling,"CodeMirror-linewidget"==
k.className&&g.node.removeChild(k);Qd(f,g,h)}}b.changes=null}function mb(a){a.node==a.text&&(a.node=s("div",null,null,"position: relative"),a.text.parentNode&&a.text.parentNode.replaceChild(a.node,a.text),a.node.appendChild(a.text),A&&8>B&&(a.node.style.zIndex=2));return a.node}function Od(a,b){var c=a.display.externalMeasured;return c&&c.line==b.line?(a.display.externalMeasured=null,b.measure=c.measure,c.built):Rd(a,b)}function Rc(a){var b=a.bgClass?a.bgClass+" "+(a.line.bgClass||""):a.line.bgClass;
b&&(b+=" CodeMirror-linebackground");if(a.background)b?a.background.className=b:(a.background.parentNode.removeChild(a.background),a.background=null);else if(b){var c=mb(a);a.background=c.insertBefore(s("div",null,b),c.firstChild)}a.line.wrapClass?mb(a).className=a.line.wrapClass:a.node!=a.text&&(a.node.className="");a.text.className=(a.textClass?a.textClass+" "+(a.line.textClass||""):a.line.textClass)||""}function Pd(a,b,c,d){b.gutter&&(b.node.removeChild(b.gutter),b.gutter=null);b.gutterBackground&&
(b.node.removeChild(b.gutterBackground),b.gutterBackground=null);if(b.line.gutterClass){var e=mb(b);b.gutterBackground=s("div",null,"CodeMirror-gutter-background "+b.line.gutterClass,"left: "+(a.options.fixedGutter?d.fixedPos:-d.gutterTotalWidth)+"px; width: "+d.gutterTotalWidth+"px");e.insertBefore(b.gutterBackground,b.text)}var f=b.line.gutterMarkers;if(a.options.lineNumbers||f){var e=mb(b),g=b.gutter=s("div",null,"CodeMirror-gutter-wrapper","left: "+(a.options.fixedGutter?d.fixedPos:-d.gutterTotalWidth)+
"px");a.display.input.setUneditable(g);e.insertBefore(g,b.text);b.line.gutterClass&&(g.className+=" "+b.line.gutterClass);!a.options.lineNumbers||f&&f["CodeMirror-linenumbers"]||(b.lineNumber=g.appendChild(s("div",Kc(a.options,c),"CodeMirror-linenumber CodeMirror-gutter-elt","left: "+d.gutterLeft["CodeMirror-linenumbers"]+"px; width: "+a.display.lineNumInnerWidth+"px")));if(f)for(b=0;b<a.options.gutters.length;++b)c=a.options.gutters[b],(e=f.hasOwnProperty(c)&&f[c])&&g.appendChild(s("div",[e],"CodeMirror-gutter-elt",
"left: "+d.gutterLeft[c]+"px; width: "+d.gutterWidth[c]+"px"))}}function Bf(a,b,c,d){var e=Od(a,b);b.text=b.node=e.pre;e.bgClass&&(b.bgClass=e.bgClass);e.textClass&&(b.textClass=e.textClass);Rc(b);Pd(a,b,c,d);Qd(a,b,d);return b.node}function Qd(a,b,c){Sd(a,b.line,b,c,!0);if(b.rest)for(var d=0;d<b.rest.length;d++)Sd(a,b.rest[d],b,c,!1)}function Sd(a,b,c,d,e){if(b.widgets){var f=mb(c),g=0;for(b=b.widgets;g<b.length;++g){var h=b[g],k=s("div",[h.node],"CodeMirror-linewidget");h.handleMouseEvents||k.setAttribute("cm-ignore-events",
"true");var l=h,m=k,p=d;if(l.noHScroll){(c.alignable||(c.alignable=[])).push(m);var n=p.wrapperWidth;m.style.left=p.fixedPos+"px";l.coverGutter||(n-=p.gutterTotalWidth,m.style.paddingLeft=p.gutterTotalWidth+"px");m.style.width=n+"px"}l.coverGutter&&(m.style.zIndex=5,m.style.position="relative",l.noHScroll||(m.style.marginLeft=-p.gutterTotalWidth+"px"));a.display.input.setUneditable(k);e&&h.above?f.insertBefore(k,c.gutter||c.text):f.appendChild(k);R(h,"redraw")}}}function Sc(a){return r(a.line,a.ch)}
function Mb(a,b){return 0>w(a,b)?b:a}function Nb(a,b){return 0>w(a,b)?a:b}function Td(a){a.state.focused||(a.display.input.focus(),yc(a))}function Ob(a,b,c,d,e){var f=a.doc;a.display.shift=!1;d||(d=f.sel);var g=a.state.pasteIncoming||"paste"==e,h=f.splitLines(b),k=null;if(g&&1<d.ranges.length)if(P&&P.text.join("\n")==b){if(0==d.ranges.length%P.text.length)for(var k=[],l=0;l<P.text.length;l++)k.push(f.splitLines(P.text[l]))}else h.length==d.ranges.length&&(k=Pb(h,function(a){return[a]}));for(l=d.ranges.length-
1;0<=l;l--){var m=d.ranges[l],p=m.from(),n=m.to();m.empty()&&(c&&0<c?p=r(p.line,p.ch-c):a.state.overwrite&&!g?n=r(n.line,Math.min(t(f,n.line).text.length,n.ch+z(h).length)):P&&P.lineWise&&P.text.join("\n")==b&&(p=n=r(p.line,0)));m=a.curOp.updateInput;p={from:p,to:n,text:k?k[l%k.length]:h,origin:e||(g?"paste":a.state.cutIncoming?"cut":"+input")};Oa(a.doc,p);R(a,"inputRead",a,p)}b&&!g&&Ud(a,b);Pa(a);a.curOp.updateInput=m;a.curOp.typing=!0;a.state.pasteIncoming=a.state.cutIncoming=!1}function Vd(a,b){var c=
a.clipboardData&&a.clipboardData.getData("Text");if(c)return a.preventDefault(),b.isReadOnly()||b.options.disableInput||T(b,function(){Ob(b,c,0,null,"paste")}),!0}function Ud(a,b){if(a.options.electricChars&&a.options.smartIndent)for(var c=a.doc.sel,d=c.ranges.length-1;0<=d;d--){var e=c.ranges[d];if(!(100<e.head.ch||d&&c.ranges[d-1].head.line==e.head.line)){var f=a.getModeAt(e.head),g=!1;if(f.electricChars)for(var h=0;h<f.electricChars.length;h++){if(-1<b.indexOf(f.electricChars.charAt(h))){g=nb(a,
e.head.line,"smart");break}}else f.electricInput&&f.electricInput.test(t(a.doc,e.head.line).text.slice(0,e.head.ch))&&(g=nb(a,e.head.line,"smart"));g&&R(a,"electricInput",a,e.head.line)}}}function Wd(a){for(var b=[],c=[],d=0;d<a.doc.sel.ranges.length;d++){var e=a.doc.sel.ranges[d].head.line,e={anchor:r(e,0),head:r(e+1,0)};c.push(e);b.push(a.getRange(e.anchor,e.head))}return{text:b,ranges:c}}function Xd(a,b){a.setAttribute("autocorrect","off");a.setAttribute("autocapitalize","off");a.setAttribute("spellcheck",
!!b)}function Tc(a){this.cm=a;this.prevInput="";this.pollingFast=!1;this.polling=new ua;this.hasSelection=this.inaccurateSelection=!1;this.composing=null}function Yd(){var a=s("textarea",null,null,"position: absolute; bottom: -1em; padding: 0; width: 1px; height: 1em; outline: none"),b=s("div",[a],null,"overflow: hidden; position: relative; width: 3px; height: 0px;");K?a.style.width="1000px":a.setAttribute("wrap","off");ob&&(a.style.border="1px solid black");Xd(a);return b}function Uc(a){this.cm=
a;this.lastAnchorNode=this.lastAnchorOffset=this.lastFocusNode=this.lastFocusOffset=null;this.polling=new ua;this.gracePeriod=!1}function Zd(a,b){var c=Vc(a,b.line);if(!c||c.hidden)return null;var d=t(a.doc,b.line),c=$d(c,d,b.line),d=Z(d),e="left";d&&(e=Qb(d,b.ch)%2?"right":"left");c=ae(c.map,b.ch,e);c.offset="right"==c.collapse?c.end:c.start;return c}function Qa(a,b){b&&(a.bad=!0);return a}function Rb(a,b,c){var d;if(b==a.display.lineDiv){d=a.display.lineDiv.childNodes[c];if(!d)return Qa(a.clipPos(r(a.display.viewTo-
1)),!0);b=null;c=0}else for(d=b;;d=d.parentNode){if(!d||d==a.display.lineDiv)return null;if(d.parentNode&&d.parentNode==a.display.lineDiv)break}for(var e=0;e<a.display.view.length;e++){var f=a.display.view[e];if(f.node==d)return Cf(f,b,c)}}function Cf(a,b,c){function d(b,c,d){for(var e=-1;e<(l?l.length:0);e++)for(var f=0>e?k.map:l[e],g=0;g<f.length;g+=3){var h=f[g+2];if(h==b||h==c){c=F(0>e?a.line:a.rest[e]);e=f[g]+d;if(0>d||h!=b)e=f[g+(d?1:0)];return r(c,e)}}}var e=a.text.firstChild,f=!1;if(!b||!Wc(e,
b))return Qa(r(F(a.line),0),!0);if(b==e&&(f=!0,b=e.childNodes[c],c=0,!b))return c=a.rest?z(a.rest):a.line,Qa(r(F(c),c.text.length),f);var g=3==b.nodeType?b:null,h=b;g||1!=b.childNodes.length||3!=b.firstChild.nodeType||(g=b.firstChild,c&&(c=g.nodeValue.length));for(;h.parentNode!=e;)h=h.parentNode;var k=a.measure,l=k.maps;if(b=d(g,h,c))return Qa(b,f);e=h.nextSibling;for(g=g?g.nodeValue.length-c:0;e;e=e.nextSibling){if(b=d(e,e.firstChild,0))return Qa(r(b.line,b.ch-g),f);g+=e.textContent.length}h=h.previousSibling;
for(g=c;h;h=h.previousSibling){if(b=d(h,h.firstChild,-1))return Qa(r(b.line,b.ch+g),f);g+=h.textContent.length}}function Df(a,b,c,d,e){function f(a){return function(b){return b.id==a}}function g(b){if(1==b.nodeType){var c=b.getAttribute("cm-text");if(null!=c)""==c&&(c=b.textContent.replace(/\u200b/g,"")),h+=c;else{var c=b.getAttribute("cm-marker"),n;if(c)b=a.findMarks(r(d,0),r(e+1,0),f(+c)),b.length&&(n=b[0].find())&&(h+=Ba(a.doc,n.from,n.to).join(l));else if("false"!=b.getAttribute("contenteditable")){for(n=
0;n<b.childNodes.length;n++)g(b.childNodes[n]);/^(pre|div|p)$/i.test(b.nodeName)&&(k=!0)}}}else 3==b.nodeType&&(b=b.nodeValue)&&(k&&(h+=l,k=!1),h+=b)}for(var h="",k=!1,l=a.doc.lineSeparator();;){g(b);if(b==c)break;b=b.nextSibling}return h}function ka(a,b){this.ranges=a;this.primIndex=b}function y(a,b){this.anchor=a;this.head=b}function $(a,b){var c=a[b];a.sort(function(a,b){return w(a.from(),b.from())});b=D(a,c);for(c=1;c<a.length;c++){var d=a[c],e=a[c-1];if(0<=w(e.to(),d.from())){var f=Nb(e.from(),
d.from()),g=Mb(e.to(),d.to()),d=e.empty()?d.from()==d.head:e.from()==e.head;c<=b&&--b;a.splice(--c,2,new y(d?g:f,d?f:g))}}return new ka(a,b)}function ga(a,b){return new ka([new y(a,b||a)],0)}function x(a,b){if(b.line<a.first)return r(a.first,0);var c=a.first+a.size-1;if(b.line>c)return r(c,t(a,c).text.length);var c=t(a,b.line).text.length,d=b.ch,c=null==d||d>c?r(b.line,c):0>d?r(b.line,0):b;return c}function pb(a,b){return b>=a.first&&b<a.first+a.size}function be(a,b){for(var c=[],d=0;d<b.length;d++)c[d]=
x(a,b[d]);return c}function qb(a,b,c,d){return a.cm&&a.cm.display.shift||a.extend?(a=b.anchor,d&&(b=0>w(c,a),b!=0>w(d,a)?(a=c,c=d):b!=0>w(c,d)&&(c=d)),new y(a,c)):new y(d||c,c)}function Sb(a,b,c,d){C(a,new ka([qb(a,a.sel.primary(),b,c)],0),d)}function ce(a,b,c){for(var d=[],e=0;e<a.sel.ranges.length;e++)d[e]=qb(a,a.sel.ranges[e],b[e],null);b=$(d,a.sel.primIndex);C(a,b,c)}function Xc(a,b,c,d){var e=a.sel.ranges.slice(0);e[b]=c;C(a,$(e,a.sel.primIndex),d)}function Ef(a,b,c){c={ranges:b.ranges,update:function(b){this.ranges=
[];for(var c=0;c<b.length;c++)this.ranges[c]=new y(x(a,b[c].anchor),x(a,b[c].head))},origin:c&&c.origin};J(a,"beforeSelectionChange",a,c);a.cm&&J(a.cm,"beforeSelectionChange",a.cm,c);return c.ranges!=b.ranges?$(c.ranges,c.ranges.length-1):b}function de(a,b,c){var d=a.history.done,e=z(d);e&&e.ranges?(d[d.length-1]=b,Tb(a,b,c)):C(a,b,c)}function C(a,b,c){Tb(a,b,c);b=a.sel;var d=a.cm?a.cm.curOp.id:NaN,e=a.history,f=c&&c.origin,g;if(!(g=d==e.lastSelOp)&&(g=f&&e.lastSelOrigin==f)&&!(g=e.lastModTime==e.lastSelTime&&
e.lastOrigin==f)){g=z(e.done);var h=f.charAt(0);g="*"==h||"+"==h&&g.ranges.length==b.ranges.length&&g.somethingSelected()==b.somethingSelected()&&new Date-a.history.lastSelTime<=(a.cm?a.cm.options.historyEventDelay:500)}g?e.done[e.done.length-1]=b:Ub(b,e.done);e.lastSelTime=+new Date;e.lastSelOrigin=f;e.lastSelOp=d;c&&!1!==c.clearRedo&&ee(e.undone)}function Tb(a,b,c){if(W(a,"beforeSelectionChange")||a.cm&&W(a.cm,"beforeSelectionChange"))b=Ef(a,b,c);var d=c&&c.bias||(0>w(b.primary().head,a.sel.primary().head)?
-1:1);fe(a,ge(a,b,d,!0));c&&!1===c.scroll||!a.cm||Pa(a.cm)}function fe(a,b){b.equals(a.sel)||(a.sel=b,a.cm&&(a.cm.curOp.updateInput=a.cm.curOp.selectionChanged=!0,he(a.cm)),R(a,"cursorActivity",a))}function ie(a){fe(a,ge(a,a.sel,null,!1),ha)}function ge(a,b,c,d){for(var e,f=0;f<b.ranges.length;f++){var g=b.ranges[f],h=b.ranges.length==a.sel.ranges.length&&a.sel.ranges[f],k=Yc(a,g.anchor,h&&h.anchor,c,d),h=Yc(a,g.head,h&&h.head,c,d);if(e||k!=g.anchor||h!=g.head)e||(e=b.ranges.slice(0,f)),e[f]=new y(k,
h)}return e?$(e,b.primIndex):b}function Ra(a,b,c,d,e){var f=t(a,b.line);if(f.markedSpans)for(var g=0;g<f.markedSpans.length;++g){var h=f.markedSpans[g],k=h.marker;if((null==h.from||(k.inclusiveLeft?h.from<=b.ch:h.from<b.ch))&&(null==h.to||(k.inclusiveRight?h.to>=b.ch:h.to>b.ch))){if(e&&(J(k,"beforeCursorEnter"),k.explicitlyCleared))if(f.markedSpans){--g;continue}else break;if(k.atomic){if(c){var g=k.find(0>d?1:-1),l;if(0>d?k.inclusiveRight:k.inclusiveLeft)g=je(a,g,-d,g&&g.line==b.line?f:null);if(g&&
g.line==b.line&&(l=w(g,c))&&(0>d?0>l:0<l))return Ra(a,g,b,d,e)}c=k.find(0>d?-1:1);if(0>d?k.inclusiveLeft:k.inclusiveRight)c=je(a,c,d,c.line==b.line?f:null);return c?Ra(a,c,b,d,e):null}}}return b}function Yc(a,b,c,d,e){d=d||1;b=Ra(a,b,c,d,e)||!e&&Ra(a,b,c,d,!0)||Ra(a,b,c,-d,e)||!e&&Ra(a,b,c,-d,!0);return b?b:(a.cantEdit=!0,r(a.first,0))}function je(a,b,c,d){return 0>c&&0==b.ch?b.line>a.first?x(a,r(b.line-1)):null:0<c&&b.ch==(d||t(a,b.line)).text.length?b.line<a.first+a.size-1?r(b.line+1,0):null:new r(b.line,
b.ch+c)}function lb(a){a.display.input.showSelection(a.display.input.prepareSelection())}function ke(a,b){for(var c=a.doc,d={},e=d.cursors=document.createDocumentFragment(),f=d.selection=document.createDocumentFragment(),g=0;g<c.sel.ranges.length;g++)if(!1!==b||g!=c.sel.primIndex){var h=c.sel.ranges[g];if(!(h.from().line>=a.display.viewTo||h.to().line<a.display.viewFrom)){var k=h.empty();(k||a.options.showCursorWhenSelecting)&&le(a,h.head,e);k||Ff(a,h,f)}}return d}function le(a,b,c){b=la(a,b,"div",
null,null,!a.options.singleCursorHeightPerLine);var d=c.appendChild(s("div"," ","CodeMirror-cursor"));d.style.left=b.left+"px";d.style.top=b.top+"px";d.style.height=Math.max(0,b.bottom-b.top)*a.options.cursorHeight+"px";b.other&&(a=c.appendChild(s("div"," ","CodeMirror-cursor CodeMirror-secondarycursor")),a.style.display="",a.style.left=b.other.left+"px",a.style.top=b.other.top+"px",a.style.height=.85*(b.other.bottom-b.other.top)+"px")}function Ff(a,b,c){function d(a,b,c,d){0>b&&(b=0);b=Math.round(b);
d=Math.round(d);h.appendChild(s("div",null,"CodeMirror-selected","position: absolute; left: "+a+"px; top: "+b+"px; width: "+(null==c?m-a:c)+"px; height: "+(d-b)+"px"))}function e(b,c,e){var f=t(g,b),h=f.text.length,k,p;Gf(Z(f),c||0,null==e?h:e,function(g,q,s){var t=Vb(a,r(b,g),"div",f,"left"),v,u;g==q?(v=t,s=u=t.left):(v=Vb(a,r(b,q-1),"div",f,"right"),"rtl"==s&&(s=t,t=v,v=s),s=t.left,u=v.right);null==c&&0==g&&(s=l);3<v.top-t.top&&(d(s,t.top,null,t.bottom),s=l,t.bottom<v.top&&d(s,t.bottom,null,v.top));
null==e&&q==h&&(u=m);if(!k||t.top<k.top||t.top==k.top&&t.left<k.left)k=t;if(!p||v.bottom>p.bottom||v.bottom==p.bottom&&v.right>p.right)p=v;s<l+1&&(s=l);d(s,v.top,u-s,v.bottom)});return{start:k,end:p}}var f=a.display,g=a.doc,h=document.createDocumentFragment(),k=me(a.display),l=k.left,m=Math.max(f.sizerWidth,za(a)-f.sizer.offsetLeft)-k.right,f=b.from();b=b.to();if(f.line==b.line)e(f.line,f.ch,b.ch);else{var p=t(g,f.line),k=t(g,b.line),k=ia(p)==ia(k),f=e(f.line,f.ch,k?p.text.length+1:null).end;b=e(b.line,
k?0:null,b.ch).start;k&&(f.top<b.top-2?(d(f.right,f.top,null,f.bottom),d(l,b.top,b.left,b.bottom)):d(f.right,f.top,b.left-f.right,f.bottom));f.bottom<b.top&&d(l,f.bottom,null,b.top)}c.appendChild(h)}function Zc(a){if(a.state.focused){var b=a.display;clearInterval(b.blinker);var c=!0;b.cursorDiv.style.visibility="";0<a.options.cursorBlinkRate?b.blinker=setInterval(function(){b.cursorDiv.style.visibility=(c=!c)?"":"hidden"},a.options.cursorBlinkRate):0>a.options.cursorBlinkRate&&(b.cursorDiv.style.visibility=
"hidden")}}function db(a,b){a.doc.mode.startState&&a.doc.frontier<a.display.viewTo&&a.state.highlight.set(b,xc(Hf,a))}function Hf(a){var b=a.doc;b.frontier<b.first&&(b.frontier=b.first);if(!(b.frontier>=a.display.viewTo)){var c=+new Date+a.options.workTime,d=sa(b.mode,rb(a,b.frontier)),e=[];b.iter(b.frontier,Math.min(b.first+b.size,a.display.viewTo+500),function(f){if(b.frontier>=a.display.viewFrom){var g=f.styles,h=f.text.length>a.options.maxHighlightLength,k=ne(a,f,h?sa(b.mode,d):d,!0);f.styles=
k.styles;var l=f.styleClasses;(k=k.classes)?f.styleClasses=k:l&&(f.styleClasses=null);l=!g||g.length!=f.styles.length||l!=k&&(!l||!k||l.bgClass!=k.bgClass||l.textClass!=k.textClass);for(k=0;!l&&k<g.length;++k)l=g[k]!=f.styles[k];l&&e.push(b.frontier);f.stateAfter=h?d:sa(b.mode,d)}else f.text.length<=a.options.maxHighlightLength&&$c(a,f.text,d),f.stateAfter=0==b.frontier%5?sa(b.mode,d):null;++b.frontier;if(+new Date>c)return db(a,a.options.workDelay),!0});e.length&&T(a,function(){for(var b=0;b<e.length;b++)ma(a,
e[b],"text")})}}function If(a,b,c){for(var d,e,f=a.doc,g=c?-1:b-(a.doc.mode.innerMode?1E3:100);b>g;--b){if(b<=f.first)return f.first;var h=t(f,b-1);if(h.stateAfter&&(!c||b<=f.frontier))return b;h=aa(h.text,null,a.options.tabSize);if(null==e||d>h)e=b-1,d=h}return e}function rb(a,b,c){var d=a.doc,e=a.display;if(!d.mode.startState)return!0;var f=If(a,b,c),g=f>d.first&&t(d,f-1).stateAfter,g=g?sa(d.mode,g):Jf(d.mode);d.iter(f,b,function(c){$c(a,c.text,g);c.stateAfter=f==b-1||0==f%5||f>=e.viewFrom&&f<e.viewTo?
sa(d.mode,g):null;++f});c&&(d.frontier=f);return g}function Fc(a){return a.mover.offsetHeight-a.lineSpace.offsetHeight}function me(a){if(a.cachedPaddingH)return a.cachedPaddingH;var b=U(a.measure,s("pre","x")),b=window.getComputedStyle?window.getComputedStyle(b):b.currentStyle,b={left:parseInt(b.paddingLeft),right:parseInt(b.paddingRight)};isNaN(b.left)||isNaN(b.right)||(a.cachedPaddingH=b);return b}function da(a){return Gd-a.display.nativeBarWidth}function za(a){return a.display.scroller.clientWidth-
da(a)-a.display.barWidth}function Oc(a){return a.display.scroller.clientHeight-da(a)-a.display.barHeight}function $d(a,b,c){if(a.line==b)return{map:a.measure.map,cache:a.measure.cache};for(var d=0;d<a.rest.length;d++)if(a.rest[d]==b)return{map:a.measure.maps[d],cache:a.measure.caches[d]};for(d=0;d<a.rest.length;d++)if(F(a.rest[d])>c)return{map:a.measure.maps[d],cache:a.measure.caches[d],before:!0}}function Vc(a,b){if(b>=a.display.viewFrom&&b<a.display.viewTo)return a.display.view[Aa(a,b)];var c=a.display.externalMeasured;
if(c&&b>=c.lineN&&b<c.lineN+c.size)return c}function Wb(a,b){var c=F(b),d=Vc(a,c);d&&!d.text?d=null:d&&d.changes&&(Nd(a,d,c,Lc(a)),a.curOp.forceUpdate=!0);if(!d){var e;e=ia(b);d=F(e);e=a.display.externalMeasured=new oe(a.doc,e,d);e.lineN=d;d=e.built=Rd(a,e);e.text=d.pre;U(a.display.lineMeasure,d.pre);d=e}c=$d(d,b,c);return{line:b,view:d,rect:null,map:c.map,cache:c.cache,before:c.before,hasHeights:!1}}function Xb(a,b,c,d,e){b.before&&(c=-1);var f=c+(d||"");if(b.cache.hasOwnProperty(f))a=b.cache[f];
else{b.rect||(b.rect=b.view.text.getBoundingClientRect());if(!b.hasHeights){var g=b.view,h=b.rect,k=a.options.lineWrapping,l=k&&za(a);if(!g.measure.heights||k&&g.measure.width!=l){var m=g.measure.heights=[];if(k)for(g.measure.width=l,g=g.text.firstChild.getClientRects(),k=0;k<g.length-1;k++){var l=g[k],p=g[k+1];2<Math.abs(l.bottom-p.bottom)&&m.push((l.bottom+p.top)/2-h.top)}m.push(h.bottom-h.top)}b.hasHeights=!0}m=d;g=ae(b.map,c,m);d=g.node;h=g.start;k=g.end;c=g.collapse;var n;if(3==d.nodeType){for(var E=
0;4>E;E++){for(;h&&sb(b.line.text.charAt(g.coverStart+h));)--h;for(;g.coverStart+k<g.coverEnd&&sb(b.line.text.charAt(g.coverStart+k));)++k;if(A&&9>B&&0==h&&k==g.coverEnd-g.coverStart)n=d.parentNode.getBoundingClientRect();else{n=Sa(d,h,k).getClientRects();k=pe;if("left"==m)for(l=0;l<n.length&&(k=n[l]).left==k.right;l++);else for(l=n.length-1;0<=l&&(k=n[l]).left==k.right;l--);n=k}if(n.left||n.right||0==h)break;k=h;--h;c="right"}A&&11>B&&((E=!window.screen||null==screen.logicalXDPI||screen.logicalXDPI==
screen.deviceXDPI)||(null!=ad?E=ad:(m=U(a.display.measure,s("span","x")),E=m.getBoundingClientRect(),m=Sa(m,0,1).getBoundingClientRect(),E=ad=1<Math.abs(E.left-m.left)),E=!E),E||(E=screen.logicalXDPI/screen.deviceXDPI,m=screen.logicalYDPI/screen.deviceYDPI,n={left:n.left*E,right:n.right*E,top:n.top*m,bottom:n.bottom*m}))}else 0<h&&(c=m="right"),n=a.options.lineWrapping&&1<(E=d.getClientRects()).length?E["right"==m?E.length-1:0]:d.getBoundingClientRect();!(A&&9>B)||h||n&&(n.left||n.right)||(n=(n=d.parentNode.getClientRects()[0])?
{left:n.left,right:n.left+eb(a.display),top:n.top,bottom:n.bottom}:pe);d=n.top-b.rect.top;h=n.bottom-b.rect.top;m=(d+h)/2;g=b.view.measure.heights;for(E=0;E<g.length-1&&!(m<g[E]);E++);c={left:("right"==c?n.right:n.left)-b.rect.left,right:("left"==c?n.left:n.right)-b.rect.left,top:E?g[E-1]:0,bottom:g[E]};n.left||n.right||(c.bogus=!0);a.options.singleCursorHeightPerLine||(c.rtop=d,c.rbottom=h);a=c;a.bogus||(b.cache[f]=a)}return{left:a.left,right:a.right,top:e?a.rtop:a.top,bottom:e?a.rbottom:a.bottom}}
function ae(a,b,c){for(var d,e,f,g,h=0;h<a.length;h+=3){var k=a[h],l=a[h+1];if(b<k)e=0,f=1,g="left";else if(b<l)e=b-k,f=e+1;else if(h==a.length-3||b==l&&a[h+3]>b)f=l-k,e=f-1,b>=l&&(g="right");if(null!=e){d=a[h+2];k==l&&c==(d.insertLeft?"left":"right")&&(g=c);if("left"==c&&0==e)for(;h&&a[h-2]==a[h-3]&&a[h-1].insertLeft;)d=a[(h-=3)+2],g="left";if("right"==c&&e==l-k)for(;h<a.length-3&&a[h+3]==a[h+4]&&!a[h+5].insertLeft;)d=a[(h+=3)+2],g="right";break}}return{node:d,start:e,end:f,collapse:g,coverStart:k,
coverEnd:l}}function qe(a){if(a.measure&&(a.measure.cache={},a.measure.heights=null,a.rest))for(var b=0;b<a.rest.length;b++)a.measure.caches[b]={}}function re(a){a.display.externalMeasure=null;pa(a.display.lineMeasure);for(var b=0;b<a.display.view.length;b++)qe(a.display.view[b])}function fb(a){re(a);a.display.cachedCharWidth=a.display.cachedTextHeight=a.display.cachedPaddingH=null;a.options.lineWrapping||(a.display.maxLineChanged=!0);a.display.lineNumChars=null}function bd(a,b,c,d){if(b.widgets)for(var e=
0;e<b.widgets.length;++e)if(b.widgets[e].above){var f=tb(b.widgets[e]);c.top+=f;c.bottom+=f}if("line"==d)return c;d||(d="local");b=ea(b);b="local"==d?b+a.display.lineSpace.offsetTop:b-a.display.viewOffset;if("page"==d||"window"==d)a=a.display.lineSpace.getBoundingClientRect(),b+=a.top+("window"==d?0:window.pageYOffset||(document.documentElement||document.body).scrollTop),d=a.left+("window"==d?0:window.pageXOffset||(document.documentElement||document.body).scrollLeft),c.left+=d,c.right+=d;c.top+=b;
c.bottom+=b;return c}function se(a,b,c){if("div"==c)return b;var d=b.left;b=b.top;"page"==c?(d-=window.pageXOffset||(document.documentElement||document.body).scrollLeft,b-=window.pageYOffset||(document.documentElement||document.body).scrollTop):"local"!=c&&c||(c=a.display.sizer.getBoundingClientRect(),d+=c.left,b+=c.top);a=a.display.lineSpace.getBoundingClientRect();return{left:d-a.left,top:b-a.top}}function Vb(a,b,c,d,e){d||(d=t(a.doc,b.line));var f=d;b=b.ch;d=Xb(a,Wb(a,d),b,e);return bd(a,f,d,c)}
function la(a,b,c,d,e,f){function g(b,g){var h=Xb(a,e,b,g?"right":"left",f);g?h.left=h.right:h.right=h.left;return bd(a,d,h,c)}function h(a,b){var c=k[b],d=c.level%2;a==cd(c)&&b&&c.level<k[b-1].level?(c=k[--b],a=dd(c)-(c.level%2?0:1),d=!0):a==dd(c)&&b<k.length-1&&c.level<k[b+1].level&&(c=k[++b],a=cd(c)-c.level%2,d=!1);return d&&a==c.to&&a>c.from?g(a-1):g(a,d)}d=d||t(a.doc,b.line);e||(e=Wb(a,d));var k=Z(d);b=b.ch;if(!k)return g(b);var l=Qb(k,b),l=h(b,l);null!=ub&&(l.other=h(b,ub));return l}function te(a,
b){var c=0;b=x(a.doc,b);a.options.lineWrapping||(c=eb(a.display)*b.ch);var d=t(a.doc,b.line),e=ea(d)+a.display.lineSpace.offsetTop;return{left:c,right:c,top:e,bottom:e+d.height}}function Yb(a,b,c,d){a=r(a,b);a.xRel=d;c&&(a.outside=!0);return a}function ed(a,b,c){var d=a.doc;c+=a.display.viewOffset;if(0>c)return Yb(d.first,0,!0,-1);var e=ya(d,c),f=d.first+d.size-1;if(e>f)return Yb(d.first+d.size-1,t(d,f).text.length,!0,1);0>b&&(b=0);for(d=t(d,e);;)if(e=Kf(a,d,e,b,c),f=(d=xa(d,!1))&&d.find(0,!0),d&&
(e.ch>f.from.ch||e.ch==f.from.ch&&0<e.xRel))e=F(d=f.to.line);else return e}function Kf(a,b,c,d,e){function f(d){d=la(a,r(c,d),"line",b,l);h=!0;if(g>d.bottom)return d.left-k;if(g<d.top)return d.left+k;h=!1;return d.left}var g=e-ea(b),h=!1,k=2*a.display.wrapper.clientWidth,l=Wb(a,b);e=Z(b);var m=b.text.length,p=Zb(b),n=$b(b),E=f(p),q=h,s=f(n),t=h;if(d>s)return Yb(c,n,t,1);for(;;){if(e?n==p||n==fd(b,p,1):1>=n-p){m=d<E||d-E<=s-d?p:n;q=m==p?q:t;p=d-(m==p?E:s);t&&!e&&!/\s/.test(b.text.charAt(m))&&0<p&&
m<b.text.length&&1<l.view.measure.heights.length&&(e=Xb(a,l,m,"right"),g<=e.bottom&&g>=e.top&&Math.abs(d-e.right)<p&&(q=!1,m++,p=d-e.right));for(;sb(b.text.charAt(m));)++m;return Yb(c,m,q,-1>p?-1:1<p?1:0)}var v=Math.ceil(m/2),u=p+v;if(e)for(var u=p,w=0;w<v;++w)u=fd(b,u,1);w=f(u);if(w>d){n=u;s=w;if(t=h)s+=1E3;m=v}else p=u,E=w,q=h,m-=v}}function va(a){if(null!=a.cachedTextHeight)return a.cachedTextHeight;if(null==Ca){Ca=s("pre");for(var b=0;49>b;++b)Ca.appendChild(document.createTextNode("x")),Ca.appendChild(s("br"));
Ca.appendChild(document.createTextNode("x"))}U(a.measure,Ca);b=Ca.offsetHeight/50;3<b&&(a.cachedTextHeight=b);pa(a.measure);return b||1}function eb(a){if(null!=a.cachedCharWidth)return a.cachedCharWidth;var b=s("span","xxxxxxxxxx"),c=s("pre",[b]);U(a.measure,c);b=b.getBoundingClientRect();b=(b.right-b.left)/10;2<b&&(a.cachedCharWidth=b);return b||10}function Ja(a){a.curOp={cm:a,viewChanged:!1,startHeight:a.doc.height,forceUpdate:!1,updateInput:null,typing:!1,changeObjs:null,cursorActivityHandlers:null,
cursorActivityCalled:0,selectionChanged:!1,updateMaxLine:!1,scrollLeft:null,scrollTop:null,scrollToPos:null,focus:!1,id:++Lf};Ta?Ta.ops.push(a.curOp):a.curOp.ownsGroup=Ta={ops:[a.curOp],delayedCallbacks:[]}}function La(a){if(a=a.curOp.ownsGroup)try{var b=a.delayedCallbacks,c=0;do{for(;c<b.length;c++)b[c].call(null);for(var d=0;d<a.ops.length;d++){var e=a.ops[d];if(e.cursorActivityHandlers)for(;e.cursorActivityCalled<e.cursorActivityHandlers.length;)e.cursorActivityHandlers[e.cursorActivityCalled++].call(null,
e.cm)}}while(c<b.length)}finally{Ta=null;for(b=0;b<a.ops.length;b++)a.ops[b].cm.curOp=null;a=a.ops;for(b=0;b<a.length;b++){var e=a[b],c=e.cm,f=d=c.display;!f.scrollbarsClipped&&f.scroller.offsetWidth&&(f.nativeBarWidth=f.scroller.offsetWidth-f.scroller.clientWidth,f.heightForcer.style.height=da(c)+"px",f.sizer.style.marginBottom=-f.nativeBarWidth+"px",f.sizer.style.borderRightWidth=da(c)+"px",f.scrollbarsClipped=!0);e.updateMaxLine&&Ec(c);e.mustUpdate=e.viewChanged||e.forceUpdate||null!=e.scrollTop||
e.scrollToPos&&(e.scrollToPos.from.line<d.viewFrom||e.scrollToPos.to.line>=d.viewTo)||d.maxLineChanged&&c.options.lineWrapping;e.update=e.mustUpdate&&new Kb(c,e.mustUpdate&&{top:e.scrollTop,ensure:e.scrollToPos},e.forceUpdate)}for(b=0;b<a.length;b++)e=a[b],e.updatedDisplay=e.mustUpdate&&Mc(e.cm,e.update);for(b=0;b<a.length;b++)if(e=a[b],c=e.cm,d=c.display,e.updatedDisplay&&Jb(c),e.barMeasure=hb(c),d.maxLineChanged&&!c.options.lineWrapping&&(f=void 0,f=d.maxLine.text.length,f=Xb(c,Wb(c,d.maxLine),
f,void 0),e.adjustWidthTo=f.left+3,c.display.sizerWidth=e.adjustWidthTo,e.barMeasure.scrollWidth=Math.max(d.scroller.clientWidth,d.sizer.offsetLeft+e.adjustWidthTo+da(c)+c.display.barWidth),e.maxScrollLeft=Math.max(0,d.sizer.offsetLeft+e.adjustWidthTo-za(c))),e.updatedDisplay||e.selectionChanged)e.preparedSelection=d.input.prepareSelection(e.focus);for(b=0;b<a.length;b++)e=a[b],c=e.cm,null!=e.adjustWidthTo&&(c.display.sizer.style.minWidth=e.adjustWidthTo+"px",e.maxScrollLeft<c.doc.scrollLeft&&Ma(c,
Math.min(c.display.scroller.scrollLeft,e.maxScrollLeft),!0),c.display.maxLineChanged=!1),d=e.focus&&e.focus==fa()&&(!document.hasFocus||document.hasFocus()),e.preparedSelection&&c.display.input.showSelection(e.preparedSelection,d),(e.updatedDisplay||e.startHeight!=c.doc.height)&&Na(c,e.barMeasure),e.updatedDisplay&&Pc(c,e.barMeasure),e.selectionChanged&&Zc(c),c.state.focused&&e.updateInput&&c.display.input.reset(e.typing),d&&Td(e.cm);for(b=0;b<a.length;b++){e=a[b];c=e.cm;d=c.display;f=c.doc;e.updatedDisplay&&
Ld(c,e.update);null==d.wheelStartX||null==e.scrollTop&&null==e.scrollLeft&&!e.scrollToPos||(d.wheelStartX=d.wheelStartY=null);null==e.scrollTop||d.scroller.scrollTop==e.scrollTop&&!e.forceScroll||(f.scrollTop=Math.max(0,Math.min(d.scroller.scrollHeight-d.scroller.clientHeight,e.scrollTop)),d.scrollbars.setScrollTop(f.scrollTop),d.scroller.scrollTop=f.scrollTop);null==e.scrollLeft||d.scroller.scrollLeft==e.scrollLeft&&!e.forceScroll||(f.scrollLeft=Math.max(0,Math.min(d.scroller.scrollWidth-d.scroller.clientWidth,
e.scrollLeft)),d.scrollbars.setScrollLeft(f.scrollLeft),d.scroller.scrollLeft=f.scrollLeft,Cc(c));if(e.scrollToPos){var g=void 0,h=x(f,e.scrollToPos.from),g=x(f,e.scrollToPos.to),k=e.scrollToPos.margin;null==k&&(k=0);for(var l=0;5>l;l++){var m=!1,p=la(c,h),n=g&&g!=h?la(c,g):p,n=ac(c,Math.min(p.left,n.left),Math.min(p.top,n.top)-k,Math.max(p.left,n.left),Math.max(p.bottom,n.bottom)+k),q=c.doc.scrollTop,r=c.doc.scrollLeft;null!=n.scrollTop&&(jb(c,n.scrollTop),1<Math.abs(c.doc.scrollTop-q)&&(m=!0));
null!=n.scrollLeft&&(Ma(c,n.scrollLeft),1<Math.abs(c.doc.scrollLeft-r)&&(m=!0));if(!m)break}g=p;e.scrollToPos.isCursor&&c.state.focused&&(H(c,"scrollCursorIntoView")||(k=c.display,l=k.sizer.getBoundingClientRect(),h=null,0>g.top+l.top?h=!0:g.bottom+l.top>(window.innerHeight||document.documentElement.clientHeight)&&(h=!1),null==h||Mf||(g=s("div","​",null,"position: absolute; top: "+(g.top-k.viewOffset-c.display.lineSpace.offsetTop)+"px; height: "+(g.bottom-g.top+da(c)+k.barHeight)+"px; left: "+g.left+
"px; width: 2px;"),c.display.lineSpace.appendChild(g),g.scrollIntoView(h),c.display.lineSpace.removeChild(g))))}h=e.maybeHiddenMarkers;g=e.maybeUnhiddenMarkers;if(h)for(k=0;k<h.length;++k)h[k].lines.length||J(h[k],"hide");if(g)for(k=0;k<g.length;++k)g[k].lines.length&&J(g[k],"unhide");d.wrapper.offsetHeight&&(f.scrollTop=c.display.scroller.scrollTop);e.changeObjs&&J(c,"changes",c,e.changeObjs);e.update&&e.update.finish()}}}function T(a,b){if(a.curOp)return b();Ja(a);try{return b()}finally{La(a)}}
function G(a,b){return function(){if(a.curOp)return b.apply(a,arguments);Ja(a);try{return b.apply(a,arguments)}finally{La(a)}}}function L(a){return function(){if(this.curOp)return a.apply(this,arguments);Ja(this);try{return a.apply(this,arguments)}finally{La(this)}}}function N(a){return function(){var b=this.cm;if(!b||b.curOp)return a.apply(this,arguments);Ja(b);try{return a.apply(this,arguments)}finally{La(b)}}}function oe(a,b,c){for(var d=this.line=b,e;d=xa(d,!1);)d=d.find(1,!0).line,(e||(e=[])).push(d);
this.size=(this.rest=e)?F(z(this.rest))-c+1:1;this.node=this.text=null;this.hidden=wa(a,b)}function Lb(a,b,c){var d=[],e;for(e=b;e<c;)b=new oe(a.doc,t(a.doc,e),e),e+=b.size,d.push(b);return d}function M(a,b,c,d){null==b&&(b=a.doc.first);null==c&&(c=a.doc.first+a.doc.size);d||(d=0);var e=a.display;d&&c<e.viewTo&&(null==e.updateLineNumbers||e.updateLineNumbers>b)&&(e.updateLineNumbers=b);a.curOp.viewChanged=!0;if(b>=e.viewTo)ra&&Nc(a.doc,b)<e.viewTo&&qa(a);else if(c<=e.viewFrom)ra&&Kd(a.doc,c+d)>e.viewFrom?
qa(a):(e.viewFrom+=d,e.viewTo+=d);else if(b<=e.viewFrom&&c>=e.viewTo)qa(a);else if(b<=e.viewFrom){var f=bc(a,c,c+d,1);f?(e.view=e.view.slice(f.index),e.viewFrom=f.lineN,e.viewTo+=d):qa(a)}else if(c>=e.viewTo)(f=bc(a,b,b,-1))?(e.view=e.view.slice(0,f.index),e.viewTo=f.lineN):qa(a);else{var f=bc(a,b,b,-1),g=bc(a,c,c+d,1);f&&g?(e.view=e.view.slice(0,f.index).concat(Lb(a,f.lineN,g.lineN)).concat(e.view.slice(g.index)),e.viewTo+=d):qa(a)}if(a=e.externalMeasured)c<a.lineN?a.lineN+=d:b<a.lineN+a.size&&(e.externalMeasured=
null)}function ma(a,b,c){a.curOp.viewChanged=!0;var d=a.display,e=a.display.externalMeasured;e&&b>=e.lineN&&b<e.lineN+e.size&&(d.externalMeasured=null);b<d.viewFrom||b>=d.viewTo||(a=d.view[Aa(a,b)],null!=a.node&&(a=a.changes||(a.changes=[]),-1==D(a,c)&&a.push(c)))}function qa(a){a.display.viewFrom=a.display.viewTo=a.doc.first;a.display.view=[];a.display.viewOffset=0}function Aa(a,b){if(b>=a.display.viewTo)return null;b-=a.display.viewFrom;if(0>b)return null;for(var c=a.display.view,d=0;d<c.length;d++)if(b-=
c[d].size,0>b)return d}function bc(a,b,c,d){var e=Aa(a,b),f=a.display.view;if(!ra||c==a.doc.first+a.doc.size)return{index:e,lineN:c};for(var g=0,h=a.display.viewFrom;g<e;g++)h+=f[g].size;if(h!=b){if(0<d){if(e==f.length-1)return null;b=h+f[e].size-b;e++}else b=h-b;c+=b}for(;Nc(a.doc,c)!=c;){if(e==(0>d?0:f.length-1))return null;c+=d*f[e-(0>d?1:0)].size;e+=d}return{index:e,lineN:c}}function Jd(a){a=a.display.view;for(var b=0,c=0;c<a.length;c++){var d=a[c];d.hidden||d.node&&!d.changes||++b}return b}function yf(a){function b(){d.activeTouch&&
(e=setTimeout(function(){d.activeTouch=null},1E3),f=d.activeTouch,f.end=+new Date)}function c(a,b){if(null==b.left)return!0;var c=b.left-a.left,d=b.top-a.top;return 400<c*c+d*d}var d=a.display;v(d.scroller,"mousedown",G(a,Nf));A&&11>B?v(d.scroller,"dblclick",G(a,function(b){if(!H(a,b)){var c=Da(a,b);!c||gd(a,b,"gutterClick",!0)||na(a.display,b)||(O(b),b=a.findWordAt(c),Sb(a.doc,b.anchor,b.head))}})):v(d.scroller,"dblclick",function(b){H(a,b)||O(b)});hd||v(d.scroller,"contextmenu",function(b){ue(a,
b)});var e,f={end:0};v(d.scroller,"touchstart",function(b){var c;if(c=!H(a,b))1!=b.touches.length?c=!1:(c=b.touches[0],c=1>=c.radiusX&&1>=c.radiusY),c=!c;c&&(clearTimeout(e),c=+new Date,d.activeTouch={start:c,moved:!1,prev:300>=c-f.end?f:null},1==b.touches.length&&(d.activeTouch.left=b.touches[0].pageX,d.activeTouch.top=b.touches[0].pageY))});v(d.scroller,"touchmove",function(){d.activeTouch&&(d.activeTouch.moved=!0)});v(d.scroller,"touchend",function(e){var f=d.activeTouch;if(f&&!na(d,e)&&null!=
f.left&&!f.moved&&300>new Date-f.start){var g=a.coordsChar(d.activeTouch,"page"),f=!f.prev||c(f,f.prev)?new y(g,g):!f.prev.prev||c(f,f.prev.prev)?a.findWordAt(g):new y(r(g.line,0),x(a.doc,r(g.line+1,0)));a.setSelection(f.anchor,f.head);a.focus();O(e)}b()});v(d.scroller,"touchcancel",b);v(d.scroller,"scroll",function(){d.scroller.clientHeight&&(jb(a,d.scroller.scrollTop),Ma(a,d.scroller.scrollLeft,!0),J(a,"scroll",a))});v(d.scroller,"mousewheel",function(b){ve(a,b)});v(d.scroller,"DOMMouseScroll",
function(b){ve(a,b)});v(d.wrapper,"scroll",function(){d.wrapper.scrollTop=d.wrapper.scrollLeft=0});d.dragFunctions={enter:function(b){H(a,b)||cc(b)},over:function(b){if(!H(a,b)){var c=Da(a,b);if(c){var d=document.createDocumentFragment();le(a,c,d);a.display.dragCursor||(a.display.dragCursor=s("div",null,"CodeMirror-cursors CodeMirror-dragcursors"),a.display.lineSpace.insertBefore(a.display.dragCursor,a.display.cursorDiv));U(a.display.dragCursor,d)}cc(b)}},start:function(b){if(A&&(!a.state.draggingText||
100>+new Date-we))cc(b);else if(!H(a,b)&&!na(a.display,b)&&(b.dataTransfer.setData("Text",a.getSelection()),b.dataTransfer.effectAllowed="copyMove",b.dataTransfer.setDragImage&&!xe)){var c=s("img",null,null,"position: fixed; left: 0; top: 0;");c.src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw\x3d\x3d";ba&&(c.width=c.height=1,a.display.wrapper.appendChild(c),c._top=c.offsetTop);b.dataTransfer.setDragImage(c,0,0);ba&&c.parentNode.removeChild(c)}},drop:G(a,Of),leave:function(b){H(a,
b)||ye(a)}};var g=d.input.getField();v(g,"keyup",function(b){ze.call(a,b)});v(g,"keydown",G(a,Ae));v(g,"keypress",G(a,Be));v(g,"focus",function(b){yc(a,b)});v(g,"blur",function(b){bb(a,b)})}function Pf(a){var b=a.display;if(b.lastWrapHeight!=b.wrapper.clientHeight||b.lastWrapWidth!=b.wrapper.clientWidth)b.cachedCharWidth=b.cachedTextHeight=b.cachedPaddingH=null,b.scrollbarsClipped=!1,a.setSize()}function na(a,b){for(var c=b.target||b.srcElement;c!=a.wrapper;c=c.parentNode)if(!c||1==c.nodeType&&"true"==
c.getAttribute("cm-ignore-events")||c.parentNode==a.sizer&&c!=a.mover)return!0}function Da(a,b,c,d){var e=a.display;if(!c&&"true"==(b.target||b.srcElement).getAttribute("cm-not-content"))return null;var f,g;c=e.lineSpace.getBoundingClientRect();try{f=b.clientX-c.left,g=b.clientY-c.top}catch(h){return null}b=ed(a,f,g);var k;d&&1==b.xRel&&(k=t(a.doc,b.line).text).length==b.ch&&(d=aa(k,k.length,a.options.tabSize)-k.length,b=r(b.line,Math.max(0,Math.round((f-me(a.display).left)/eb(a.display))-d)));return b}
function Nf(a){var b=this.display;if(!(H(this,a)||b.activeTouch&&b.input.supportsTouch()))if(b.shift=a.shiftKey,na(b,a))K||(b.scroller.draggable=!1,setTimeout(function(){b.scroller.draggable=!0},100));else if(!gd(this,a,"gutterClick",!0)){var c=Da(this,a);window.focus();switch(Ce(a)){case 1:this.state.selectingText?this.state.selectingText(a):c?Qf(this,a,c):(a.target||a.srcElement)==b.scroller&&O(a);break;case 2:K&&(this.state.lastMiddleDown=+new Date);c&&Sb(this.doc,c);setTimeout(function(){b.input.focus()},
20);O(a);break;case 3:hd?ue(this,a):Rf(this)}}}function Qf(a,b,c){A?setTimeout(xc(Td,a),0):a.curOp.focus=fa();var d=+new Date,e;dc&&dc.time>d-400&&0==w(dc.pos,c)?e="triple":ec&&ec.time>d-400&&0==w(ec.pos,c)?(e="double",dc={time:d,pos:c}):(e="single",ec={time:d,pos:c});var d=a.doc.sel,f=Y?b.metaKey:b.ctrlKey,g;a.options.dragDrop&&Sf&&!a.isReadOnly()&&"single"==e&&-1<(g=d.contains(c))&&(0>w((g=d.ranges[g]).from(),c)||0<c.xRel)&&(0<w(g.to(),c)||0>c.xRel)?Tf(a,b,c,f):Uf(a,b,c,e,f)}function Tf(a,b,c,d){var e=
a.display,f=+new Date,g=G(a,function(h){K&&(e.scroller.draggable=!1);a.state.draggingText=!1;ja(document,"mouseup",g);ja(e.scroller,"drop",g);10>Math.abs(b.clientX-h.clientX)+Math.abs(b.clientY-h.clientY)&&(O(h),!d&&+new Date-200<f&&Sb(a.doc,c),K||A&&9==B?setTimeout(function(){document.body.focus();e.input.focus()},20):e.input.focus())});K&&(e.scroller.draggable=!0);a.state.draggingText=g;g.copy=Y?b.altKey:b.ctrlKey;e.scroller.dragDrop&&e.scroller.dragDrop();v(document,"mouseup",g);v(e.scroller,"drop",
g)}function Uf(a,b,c,d,e){function f(b){if(0!=w(u,b))if(u=b,"rect"==d){for(var e=[],f=a.options.tabSize,g=aa(t(l,c.line).text,c.ch,f),h=aa(t(l,b.line).text,b.ch,f),k=Math.min(g,h),g=Math.max(g,h),h=Math.min(c.line,b.line),q=Math.min(a.lastLine(),Math.max(c.line,b.line));h<=q;h++){var s=t(l,h).text,E=De(s,k,f);k==g?e.push(new y(r(h,E),r(h,E))):s.length>E&&e.push(new y(r(h,E),r(h,De(s,g,f))))}e.length||e.push(new y(c,c));C(l,$(n.ranges.slice(0,p).concat(e),p),{origin:"*mouse",scroll:!1});a.scrollIntoView(b)}else e=
m,f=e.anchor,k=b,"single"!=d&&(b="double"==d?a.findWordAt(b):new y(r(b.line,0),x(l,r(b.line+1,0))),0<w(b.anchor,f)?(k=b.head,f=Nb(e.from(),b.anchor)):(k=b.anchor,f=Mb(e.to(),b.head))),e=n.ranges.slice(0),e[p]=new y(x(l,f),k),C(l,$(e,p),id)}function g(b){var c=++z,e=Da(a,b,!0,"rect"==d);if(e)if(0!=w(e,u)){a.curOp.focus=fa();f(e);var h=Ic(k,l);(e.line>=h.to||e.line<h.from)&&setTimeout(G(a,function(){z==c&&g(b)}),150)}else{var m=b.clientY<A.top?-20:b.clientY>A.bottom?20:0;m&&setTimeout(G(a,function(){z==
c&&(k.scroller.scrollTop+=m,g(b))}),50)}}function h(b){a.state.selectingText=!1;z=Infinity;O(b);k.input.focus();ja(document,"mousemove",F);ja(document,"mouseup",B);l.history.lastSelOrigin=null}var k=a.display,l=a.doc;O(b);var m,p,n=l.sel,q=n.ranges;e&&!b.shiftKey?(p=l.sel.contains(c),m=-1<p?q[p]:new y(c,c)):(m=l.sel.primary(),p=l.sel.primIndex);if(Vf?b.shiftKey&&b.metaKey:b.altKey)d="rect",e||(m=new y(c,c)),c=Da(a,b,!0,!0),p=-1;else if("double"==d){var s=a.findWordAt(c);m=a.display.shift||l.extend?
qb(l,m,s.anchor,s.head):s}else"triple"==d?(s=new y(r(c.line,0),x(l,r(c.line+1,0))),m=a.display.shift||l.extend?qb(l,m,s.anchor,s.head):s):m=qb(l,m,c);e?-1==p?(p=q.length,C(l,$(q.concat([m]),p),{scroll:!1,origin:"*mouse"})):1<q.length&&q[p].empty()&&"single"==d&&!b.shiftKey?(C(l,$(q.slice(0,p).concat(q.slice(p+1)),0),{scroll:!1,origin:"*mouse"}),n=l.sel):Xc(l,p,m,id):(p=0,C(l,new ka([m],0),id),n=l.sel);var u=c,A=k.wrapper.getBoundingClientRect(),z=0,F=G(a,function(a){Ce(a)?g(a):h(a)}),B=G(a,h);a.state.selectingText=
B;v(document,"mousemove",F);v(document,"mouseup",B)}function gd(a,b,c,d){try{var e=b.clientX,f=b.clientY}catch(g){return!1}if(e>=Math.floor(a.display.gutters.getBoundingClientRect().right))return!1;d&&O(b);d=a.display;var h=d.lineDiv.getBoundingClientRect();if(f>h.bottom||!W(a,c))return jd(b);f-=h.top-d.viewOffset;for(h=0;h<a.options.gutters.length;++h){var k=d.gutters.childNodes[h];if(k&&k.getBoundingClientRect().right>=e)return e=ya(a.doc,f),J(a,c,a,e,a.options.gutters[h],b),jd(b)}}function Of(a){var b=
this;ye(b);if(!H(b,a)&&!na(b.display,a)){O(a);A&&(we=+new Date);var c=Da(b,a,!0),d=a.dataTransfer.files;if(c&&!b.isReadOnly())if(d&&d.length&&window.FileReader&&window.File){var e=d.length,f=Array(e),g=0;a=function(a,d){if(!b.options.allowDropFileTypes||-1!=D(b.options.allowDropFileTypes,a.type)){var h=new FileReader;h.onload=G(b,function(){var a=h.result;/[\x00-\x08\x0e-\x1f]{2}/.test(a)&&(a="");f[d]=a;++g==e&&(c=x(b.doc,c),a={from:c,to:c,text:b.doc.splitLines(f.join(b.doc.lineSeparator())),origin:"paste"},
Oa(b.doc,a),de(b.doc,ga(c,Ea(a))))});h.readAsText(a)}};for(var h=0;h<e;++h)a(d[h],h)}else if(b.state.draggingText&&-1<b.doc.sel.contains(c))b.state.draggingText(a),setTimeout(function(){b.display.input.focus()},20);else try{if(f=a.dataTransfer.getData("Text")){if(b.state.draggingText&&!b.state.draggingText.copy)var k=b.listSelections();Tb(b.doc,ga(c,c));if(k)for(h=0;h<k.length;++h)Ua(b.doc,"",k[h].anchor,k[h].head,"drag");b.replaceSelection(f,"around","paste");b.display.input.focus()}}catch(l){}}}
function ye(a){a.display.dragCursor&&(a.display.lineSpace.removeChild(a.display.dragCursor),a.display.dragCursor=null)}function jb(a,b){2>Math.abs(a.doc.scrollTop-b)||(a.doc.scrollTop=b,oa||Qc(a,{top:b}),a.display.scroller.scrollTop!=b&&(a.display.scroller.scrollTop=b),a.display.scrollbars.setScrollTop(b),oa&&Qc(a),db(a,100))}function Ma(a,b,c){(c?b==a.doc.scrollLeft:2>Math.abs(a.doc.scrollLeft-b))||(b=Math.min(b,a.display.scroller.scrollWidth-a.display.scroller.clientWidth),a.doc.scrollLeft=b,Cc(a),
a.display.scroller.scrollLeft!=b&&(a.display.scroller.scrollLeft=b),a.display.scrollbars.setScrollLeft(b))}function ve(a,b){var c=Ee(b),d=c.x,c=c.y,e=a.display,f=e.scroller,g=f.scrollWidth>f.clientWidth,h=f.scrollHeight>f.clientHeight;if(d&&g||c&&h){if(c&&Y&&K){var g=b.target,k=e.view;a:for(;g!=f;g=g.parentNode)for(var l=0;l<k.length;l++)if(k[l].node==g){a.display.currentWheelTarget=g;break a}}!d||oa||ba||null==V?(c&&null!=V&&(h=c*V,g=a.doc.scrollTop,k=g+e.wrapper.clientHeight,0>h?g=Math.max(0,g+
h-50):k=Math.min(a.doc.height,k+h+50),Qc(a,{top:g,bottom:k})),20>fc&&(null==e.wheelStartX?(e.wheelStartX=f.scrollLeft,e.wheelStartY=f.scrollTop,e.wheelDX=d,e.wheelDY=c,setTimeout(function(){if(null!=e.wheelStartX){var a=f.scrollLeft-e.wheelStartX,b=f.scrollTop-e.wheelStartY,a=b&&e.wheelDY&&b/e.wheelDY||a&&e.wheelDX&&a/e.wheelDX;e.wheelStartX=e.wheelStartY=null;a&&(V=(V*fc+a)/(fc+1),++fc)}},200)):(e.wheelDX+=d,e.wheelDY+=c))):(c&&h&&jb(a,Math.max(0,Math.min(f.scrollTop+c*V,f.scrollHeight-f.clientHeight))),
Ma(a,Math.max(0,Math.min(f.scrollLeft+d*V,f.scrollWidth-f.clientWidth))),(!c||c&&h)&&O(b),e.wheelStartX=null)}}function gc(a,b,c){if("string"==typeof b&&(b=hc[b],!b))return!1;a.display.input.ensurePolled();var d=a.display.shift,e=!1;try{a.isReadOnly()&&(a.state.suppressEdits=!0),c&&(a.display.shift=!1),e=b(a)!=Fe}finally{a.display.shift=d,a.state.suppressEdits=!1}return e}function Wf(a,b,c){for(var d=0;d<a.state.keyMaps.length;d++){var e=vb(b,a.state.keyMaps[d],c,a);if(e)return e}return a.options.extraKeys&&
vb(b,a.options.extraKeys,c,a)||vb(b,a.options.keyMap,c,a)}function ic(a,b,c,d){var e=a.state.keySeq;if(e){if(Xf(b))return"handled";Yf.set(50,function(){a.state.keySeq==e&&(a.state.keySeq=null,a.display.input.reset())});b=e+" "+b}d=Wf(a,b,d);"multi"==d&&(a.state.keySeq=b);"handled"==d&&R(a,"keyHandled",a,b,c);if("handled"==d||"multi"==d)O(c),Zc(a);return e&&!d&&/\'$/.test(b)?(O(c),!0):!!d}function Ge(a,b){var c=Zf(b,!0);return c?b.shiftKey&&!a.state.keySeq?ic(a,"Shift-"+c,b,function(b){return gc(a,
b,!0)})||ic(a,c,b,function(b){if("string"==typeof b?/^go[A-Z]/.test(b):b.motion)return gc(a,b)}):ic(a,c,b,function(b){return gc(a,b)}):!1}function $f(a,b,c){return ic(a,"'"+c+"'",b,function(b){return gc(a,b,!0)})}function Ae(a){this.curOp.focus=fa();if(!H(this,a)){A&&11>B&&27==a.keyCode&&(a.returnValue=!1);var b=a.keyCode;this.display.shift=16==b||a.shiftKey;var c=Ge(this,a);ba&&(kd=c?b:null,!c&&88==b&&!He&&(Y?a.metaKey:a.ctrlKey)&&this.replaceSelection("",null,"cut"));18!=b||/\bCodeMirror-crosshair\b/.test(this.display.lineDiv.className)||
ag(this)}}function ag(a){function b(a){18!=a.keyCode&&a.altKey||(ib(c,"CodeMirror-crosshair"),ja(document,"keyup",b),ja(document,"mouseover",b))}var c=a.display.lineDiv;kb(c,"CodeMirror-crosshair");v(document,"keyup",b);v(document,"mouseover",b)}function ze(a){16==a.keyCode&&(this.doc.sel.shift=!1);H(this,a)}function Be(a){if(!(na(this.display,a)||H(this,a)||a.ctrlKey&&!a.altKey||Y&&a.metaKey)){var b=a.keyCode,c=a.charCode;if(ba&&b==kd)kd=null,O(a);else if(!ba||a.which&&!(10>a.which)||!Ge(this,a))if(b=
String.fromCharCode(null==c?b:c),!$f(this,a,b))this.display.input.onKeyPress(a)}}function Rf(a){a.state.delayingBlurEvent=!0;setTimeout(function(){a.state.delayingBlurEvent&&(a.state.delayingBlurEvent=!1,bb(a))},100)}function yc(a,b){a.state.delayingBlurEvent&&(a.state.delayingBlurEvent=!1);"nocursor"!=a.options.readOnly&&(a.state.focused||(J(a,"focus",a,b),a.state.focused=!0,kb(a.display.wrapper,"CodeMirror-focused"),a.curOp||a.display.selForContextMenu==a.doc.sel||(a.display.input.reset(),K&&setTimeout(function(){a.display.input.reset(!0)},
20)),a.display.input.receivedFocus()),Zc(a))}function bb(a,b){a.state.delayingBlurEvent||(a.state.focused&&(J(a,"blur",a,b),a.state.focused=!1,ib(a.display.wrapper,"CodeMirror-focused")),clearInterval(a.display.blinker),setTimeout(function(){a.state.focused||(a.display.shift=!1)},150))}function ue(a,b){var c;(c=na(a.display,b))||(c=W(a,"gutterContextMenu")?gd(a,b,"gutterContextMenu",!1):!1);if(!c&&!H(a,b,"contextmenu"))a.display.input.onContextMenu(b)}function Ie(a,b){if(0>w(a,b.from))return a;if(0>=
w(a,b.to))return Ea(b);var c=a.line+b.text.length-(b.to.line-b.from.line)-1,d=a.ch;a.line==b.to.line&&(d+=Ea(b).ch-b.to.ch);return r(c,d)}function ld(a,b){for(var c=[],d=0;d<a.sel.ranges.length;d++){var e=a.sel.ranges[d];c.push(new y(Ie(e.anchor,b),Ie(e.head,b)))}return $(c,a.sel.primIndex)}function Je(a,b,c){return a.line==b.line?r(c.line,a.ch-b.ch+c.ch):r(c.line+(a.line-b.line),a.ch)}function Ke(a,b,c){b={canceled:!1,from:b.from,to:b.to,text:b.text,origin:b.origin,cancel:function(){this.canceled=
!0}};c&&(b.update=function(b,c,f,g){b&&(this.from=x(a,b));c&&(this.to=x(a,c));f&&(this.text=f);void 0!==g&&(this.origin=g)});J(a,"beforeChange",a,b);a.cm&&J(a.cm,"beforeChange",a.cm,b);return b.canceled?null:{from:b.from,to:b.to,text:b.text,origin:b.origin}}function Oa(a,b,c){if(a.cm){if(!a.cm.curOp)return G(a.cm,Oa)(a,b,c);if(a.cm.state.suppressEdits)return}if(W(a,"beforeChange")||a.cm&&W(a.cm,"beforeChange"))if(b=Ke(a,b,!0),!b)return;if(c=Le&&!c&&bg(a,b.from,b.to))for(var d=c.length-1;0<=d;--d)Me(a,
{from:c[d].from,to:c[d].to,text:d?[""]:b.text});else Me(a,b)}function Me(a,b){if(1!=b.text.length||""!=b.text[0]||0!=w(b.from,b.to)){var c=ld(a,b);Ne(a,b,c,a.cm?a.cm.curOp.id:NaN);wb(a,b,c,md(a,b));var d=[];Fa(a,function(a,c){c||-1!=D(d,a.history)||(Oe(a.history,b),d.push(a.history));wb(a,b,null,md(a,b))})}}function jc(a,b,c){if(!a.cm||!a.cm.state.suppressEdits||c){for(var d=a.history,e,f=a.sel,g="undo"==b?d.done:d.undone,h="undo"==b?d.undone:d.done,k=0;k<g.length&&(e=g[k],c?!e.ranges||e.equals(a.sel):
e.ranges);k++);if(k!=g.length){for(d.lastOrigin=d.lastSelOrigin=null;;)if(e=g.pop(),e.ranges){Ub(e,h);if(c&&!e.equals(a.sel)){C(a,e,{clearRedo:!1});return}f=e}else break;c=[];Ub(f,h);h.push({changes:c,generation:d.generation});d.generation=e.generation||++d.maxGeneration;d=W(a,"beforeChange")||a.cm&&W(a.cm,"beforeChange");for(k=e.changes.length-1;0<=k;--k){var l=e.changes[k];l.origin=b;if(d&&!Ke(a,l,!1)){g.length=0;break}c.push(nd(a,l));f=k?ld(a,l):z(g);wb(a,l,f,Pe(a,l));!k&&a.cm&&a.cm.scrollIntoView({from:l.from,
to:Ea(l)});var m=[];Fa(a,function(a,b){b||-1!=D(m,a.history)||(Oe(a.history,l),m.push(a.history));wb(a,l,null,Pe(a,l))})}}}}function Qe(a,b){if(0!=b&&(a.first+=b,a.sel=new ka(Pb(a.sel.ranges,function(a){return new y(r(a.anchor.line+b,a.anchor.ch),r(a.head.line+b,a.head.ch))}),a.sel.primIndex),a.cm)){M(a.cm,a.first,a.first-b,b);for(var c=a.cm.display,d=c.viewFrom;d<c.viewTo;d++)ma(a.cm,d,"gutter")}}function wb(a,b,c,d){if(a.cm&&!a.cm.curOp)return G(a.cm,wb)(a,b,c,d);if(b.to.line<a.first)Qe(a,b.text.length-
1-(b.to.line-b.from.line));else if(!(b.from.line>a.lastLine())){if(b.from.line<a.first){var e=b.text.length-1-(a.first-b.from.line);Qe(a,e);b={from:r(a.first,0),to:r(b.to.line+e,b.to.ch),text:[z(b.text)],origin:b.origin}}e=a.lastLine();b.to.line>e&&(b={from:b.from,to:r(e,t(a,e).text.length),text:[b.text[0]],origin:b.origin});b.removed=Ba(a,b.from,b.to);c||(c=ld(a,b));a.cm?cg(a.cm,b,d):od(a,b,d);Tb(a,c,ha)}}function cg(a,b,c){var d=a.doc,e=a.display,f=b.from,g=b.to,h=!1,k=f.line;a.options.lineWrapping||
(k=F(ia(t(d,f.line))),d.iter(k,g.line+1,function(a){if(a==e.maxLine)return h=!0}));-1<d.sel.contains(b.from,b.to)&&he(a);od(d,b,c,Hd(a));a.options.lineWrapping||(d.iter(k,f.line+b.text.length,function(a){var b=Ib(a);b>e.maxLineLength&&(e.maxLine=a,e.maxLineLength=b,e.maxLineChanged=!0,h=!1)}),h&&(a.curOp.updateMaxLine=!0));d.frontier=Math.min(d.frontier,f.line);db(a,400);c=b.text.length-(g.line-f.line)-1;b.full?M(a):f.line!=g.line||1!=b.text.length||Re(a.doc,b)?M(a,f.line,g.line+1,c):ma(a,f.line,
"text");c=W(a,"changes");if((d=W(a,"change"))||c)b={from:f,to:g,text:b.text,removed:b.removed,origin:b.origin},d&&R(a,"change",a,b),c&&(a.curOp.changeObjs||(a.curOp.changeObjs=[])).push(b);a.display.selForContextMenu=null}function Ua(a,b,c,d,e){d||(d=c);if(0>w(d,c)){var f=d;d=c;c=f}"string"==typeof b&&(b=a.splitLines(b));Oa(a,{from:c,to:d,text:b,origin:e})}function ac(a,b,c,d,e){var f=a.display,g=va(a.display);0>c&&(c=0);var h=a.curOp&&null!=a.curOp.scrollTop?a.curOp.scrollTop:f.scroller.scrollTop,
k=Oc(a),l={};e-c>k&&(e=c+k);var m=a.doc.height+Fc(f),p=c<g,g=e>m-g;c<h?l.scrollTop=p?0:c:e>h+k&&(c=Math.min(c,(g?m:e)-k),c!=h&&(l.scrollTop=c));h=a.curOp&&null!=a.curOp.scrollLeft?a.curOp.scrollLeft:f.scroller.scrollLeft;a=za(a)-(a.options.fixedGutter?f.gutters.offsetWidth:0);(f=d-b>a)&&(d=b+a);10>b?l.scrollLeft=0:b<h?l.scrollLeft=Math.max(0,b-(f?0:10)):d>a+h-3&&(l.scrollLeft=d+(f?0:10)-a);return l}function kc(a,b,c){null==b&&null==c||lc(a);null!=b&&(a.curOp.scrollLeft=(null==a.curOp.scrollLeft?a.doc.scrollLeft:
a.curOp.scrollLeft)+b);null!=c&&(a.curOp.scrollTop=(null==a.curOp.scrollTop?a.doc.scrollTop:a.curOp.scrollTop)+c)}function Pa(a){lc(a);var b=a.getCursor(),c=b,d=b;a.options.lineWrapping||(c=b.ch?r(b.line,b.ch-1):b,d=r(b.line,b.ch+1));a.curOp.scrollToPos={from:c,to:d,margin:a.options.cursorScrollMargin,isCursor:!0}}function lc(a){var b=a.curOp.scrollToPos;if(b){a.curOp.scrollToPos=null;var c=te(a,b.from),d=te(a,b.to),b=ac(a,Math.min(c.left,d.left),Math.min(c.top,d.top)-b.margin,Math.max(c.right,d.right),
Math.max(c.bottom,d.bottom)+b.margin);a.scrollTo(b.scrollLeft,b.scrollTop)}}function nb(a,b,c,d){var e=a.doc,f;null==c&&(c="add");"smart"==c&&(e.mode.indent?f=rb(a,b):c="prev");var g=a.options.tabSize,h=t(e,b),k=aa(h.text,null,g);h.stateAfter&&(h.stateAfter=null);var l=h.text.match(/^\s*/)[0],m;if(!d&&!/\S/.test(h.text))m=0,c="not";else if("smart"==c&&(m=e.mode.indent(f,h.text.slice(l.length),h.text),m==Fe||150<m)){if(!d)return;c="prev"}"prev"==c?m=b>e.first?aa(t(e,b-1).text,null,g):0:"add"==c?m=
k+a.options.indentUnit:"subtract"==c?m=k-a.options.indentUnit:"number"==typeof c&&(m=k+c);m=Math.max(0,m);c="";d=0;if(a.options.indentWithTabs)for(a=Math.floor(m/g);a;--a)d+=g,c+="\t";d<m&&(c+=pd(m-d));if(c!=l)return Ua(e,c,r(b,0),r(b,l.length),"+input"),h.stateAfter=null,!0;for(a=0;a<e.sel.ranges.length;a++)if(g=e.sel.ranges[a],g.head.line==b&&g.head.ch<l.length){d=r(b,l.length);Xc(e,a,new y(d,d));break}}function mc(a,b,c,d){var e=b,f=b;"number"==typeof b?f=t(a,Math.max(a.first,Math.min(b,a.first+
a.size-1))):e=F(b);if(null==e)return null;d(f,e)&&a.cm&&ma(a.cm,e,c);return f}function Va(a,b){for(var c=a.doc.sel.ranges,d=[],e=0;e<c.length;e++){for(var f=b(c[e]);d.length&&0>=w(f.from,z(d).to);){var g=d.pop();if(0>w(g.from,f.from)){f.from=g.from;break}}d.push(f)}T(a,function(){for(var b=d.length-1;0<=b;b--)Ua(a.doc,"",d[b].from,d[b].to,"+delete");Pa(a)})}function qd(a,b,c,d,e){function f(b){var d=(e?fd:Se)(l,h,c,!0);if(null==d){if(b=!b)b=g+c,b<a.first||b>=a.first+a.size?b=!1:(g=b,b=l=t(a,b));if(b)h=
e?(0>c?$b:Zb)(l):0>c?l.text.length:0;else return!1}else h=d;return!0}var g=b.line,h=b.ch,k=c,l=t(a,g);if("char"==d)f();else if("column"==d)f(!0);else if("word"==d||"group"==d){var m=null;d="group"==d;for(var p=a.cm&&a.cm.getHelper(b,"wordChars"),n=!0;!(0>c)||f(!n);n=!1){var q=l.text.charAt(h)||"\n",q=nc(q,p)?"w":d&&"\n"==q?"n":!d||/\s/.test(q)?null:"p";!d||n||q||(q="s");if(m&&m!=q){0>c&&(c=1,f());break}q&&(m=q);if(0<c&&!f(!n))break}}k=Yc(a,r(g,h),b,k,!0);w(b,k)||(k.hitSide=!0);return k}function Te(a,
b,c,d){var e=a.doc,f=b.left,g;"page"==d?(g=Math.min(a.display.wrapper.clientHeight,window.innerHeight||document.documentElement.clientHeight),g=Math.max(g-.5*va(a.display),3),g=(0<c?b.bottom:b.top)+c*g):"line"==d&&(g=0<c?b.bottom+3:b.top-3);for(;;){b=ed(a,f,g);if(!b.outside)break;if(0>c?0>=g:g>=e.height){b.hitSide=!0;break}g+=5*c}return b}function u(a,b,c,d){q.defaults[a]=b;c&&(Ka[a]=d?function(a,b,d){d!=Ed&&c(a,b,d)}:c)}function dg(a){var b=a.split(/-(?!$)/);a=b[b.length-1];for(var c,d,e,f,g=0;g<
b.length-1;g++){var h=b[g];if(/^(cmd|meta|m)$/i.test(h))f=!0;else if(/^a(lt)?$/i.test(h))c=!0;else if(/^(c|ctrl|control)$/i.test(h))d=!0;else if(/^s(hift)$/i.test(h))e=!0;else throw Error("Unrecognized modifier name: "+h);}c&&(a="Alt-"+a);d&&(a="Ctrl-"+a);f&&(a="Cmd-"+a);e&&(a="Shift-"+a);return a}function oc(a){return"string"==typeof a?ta[a]:a}function Wa(a,b,c,d,e){if(d&&d.shared)return eg(a,b,c,d,e);if(a.cm&&!a.cm.curOp)return G(a.cm,Wa)(a,b,c,d,e);var f=new Ga(a,e);e=w(b,c);d&&X(d,f,!1);if(0<
e||0==e&&!1!==f.clearWhenEmpty)return f;f.replacedWith&&(f.collapsed=!0,f.widgetNode=s("span",[f.replacedWith],"CodeMirror-widget"),d.handleMouseEvents||f.widgetNode.setAttribute("cm-ignore-events","true"),d.insertLeft&&(f.widgetNode.insertLeft=!0));if(f.collapsed){if(Ue(a,b.line,b,c,f)||b.line!=c.line&&Ue(a,c.line,b,c,f))throw Error("Inserting collapsed marker partially overlapping an existing one");ra=!0}f.addToHistory&&Ne(a,{from:b,to:c,origin:"markText"},a.sel,NaN);var g=b.line,h=a.cm,k;a.iter(g,
c.line+1,function(a){h&&f.collapsed&&!h.options.lineWrapping&&ia(a)==h.display.maxLine&&(k=!0);f.collapsed&&g!=b.line&&ca(a,0);var d=new pc(f,g==b.line?b.ch:null,g==c.line?c.ch:null);a.markedSpans=a.markedSpans?a.markedSpans.concat([d]):[d];d.marker.attachLine(a);++g});f.collapsed&&a.iter(b.line,c.line+1,function(b){wa(a,b)&&ca(b,0)});f.clearOnEnter&&v(f,"beforeCursorEnter",function(){f.clear()});f.readOnly&&(Le=!0,(a.history.done.length||a.history.undone.length)&&a.clearHistory());f.collapsed&&(f.id=
++rd,f.atomic=!0);if(h){k&&(h.curOp.updateMaxLine=!0);if(f.collapsed)M(h,b.line,c.line+1);else if(f.className||f.title||f.startStyle||f.endStyle||f.css)for(d=b.line;d<=c.line;d++)ma(h,d,"text");f.atomic&&ie(h.doc);R(h,"markerAdded",h,f)}return f}function eg(a,b,c,d,e){d=X(d);d.shared=!1;var f=[Wa(a,b,c,d,e)],g=f[0],h=d.widgetNode;Fa(a,function(a){h&&(d.widgetNode=h.cloneNode(!0));f.push(Wa(a,x(a,b),x(a,c),d,e));for(var l=0;l<a.linked.length;++l)if(a.linked[l].isParent)return;g=z(f)});return new qc(f,
g)}function Ve(a){return a.findMarks(r(a.first,0),a.clipPos(r(a.lastLine())),function(a){return a.parent})}function fg(a){for(var b=0;b<a.length;b++){var c=a[b],d=[c.primary.doc];Fa(c.primary.doc,function(a){d.push(a)});for(var e=0;e<c.markers.length;e++){var f=c.markers[e];-1==D(d,f.doc)&&(f.parent=null,c.markers.splice(e--,1))}}}function pc(a,b,c){this.marker=a;this.from=b;this.to=c}function xb(a,b){if(a)for(var c=0;c<a.length;++c){var d=a[c];if(d.marker==b)return d}}function md(a,b){if(b.full)return null;
var c=pb(a,b.from.line)&&t(a,b.from.line).markedSpans,d=pb(a,b.to.line)&&t(a,b.to.line).markedSpans;if(!c&&!d)return null;var e=b.from.ch,f=b.to.ch,g=0==w(b.from,b.to);if(c)for(var h=0,k;h<c.length;++h){var l=c[h],m=l.marker;if(null==l.from||(m.inclusiveLeft?l.from<=e:l.from<e)||!(l.from!=e||"bookmark"!=m.type||g&&l.marker.insertLeft)){var p=null==l.to||(m.inclusiveRight?l.to>=e:l.to>e);(k||(k=[])).push(new pc(m,l.from,p?null:l.to))}}c=k;if(d)for(var h=0,n;h<d.length;++h)if(k=d[h],l=k.marker,null==
k.to||(l.inclusiveRight?k.to>=f:k.to>f)||k.from==f&&"bookmark"==l.type&&(!g||k.marker.insertLeft))m=null==k.from||(l.inclusiveLeft?k.from<=f:k.from<f),(n||(n=[])).push(new pc(l,m?null:k.from-f,null==k.to?null:k.to-f));d=n;g=1==b.text.length;n=z(b.text).length+(g?e:0);if(c)for(f=0;f<c.length;++f)if(h=c[f],null==h.to)(k=xb(d,h.marker),k)?g&&(h.to=null==k.to?null:k.to+n):h.to=e;if(d)for(f=0;f<d.length;++f)h=d[f],null!=h.to&&(h.to+=n),null==h.from?(k=xb(c,h.marker),k||(h.from=n,g&&(c||(c=[])).push(h))):
(h.from+=n,g&&(c||(c=[])).push(h));c&&(c=We(c));d&&d!=c&&(d=We(d));e=[c];if(!g){var g=b.text.length-2,q;if(0<g&&c)for(f=0;f<c.length;++f)null==c[f].to&&(q||(q=[])).push(new pc(c[f].marker,null,null));for(f=0;f<g;++f)e.push(q);e.push(d)}return e}function We(a){for(var b=0;b<a.length;++b){var c=a[b];null!=c.from&&c.from==c.to&&!1!==c.marker.clearWhenEmpty&&a.splice(b--,1)}return a.length?a:null}function Pe(a,b){var c;if(c=b["spans_"+a.id]){for(var d=0,e=[];d<b.text.length;++d)e.push(gg(c[d]));c=e}else c=
null;d=md(a,b);if(!c)return d;if(!d)return c;for(e=0;e<c.length;++e){var f=c[e],g=d[e];if(f&&g){var h=0;a:for(;h<g.length;++h){for(var k=g[h],l=0;l<f.length;++l)if(f[l].marker==k.marker)continue a;f.push(k)}}else g&&(c[e]=g)}return c}function bg(a,b,c){var d=null;a.iter(b.line,c.line+1,function(a){if(a.markedSpans)for(var b=0;b<a.markedSpans.length;++b){var c=a.markedSpans[b].marker;!c.readOnly||d&&-1!=D(d,c)||(d||(d=[])).push(c)}});if(!d)return null;a=[{from:b,to:c}];for(b=0;b<d.length;++b){c=d[b];
for(var e=c.find(0),f=0;f<a.length;++f){var g=a[f];if(!(0>w(g.to,e.from)||0<w(g.from,e.to))){var h=[f,1],k=w(g.from,e.from),l=w(g.to,e.to);(0>k||!c.inclusiveLeft&&!k)&&h.push({from:g.from,to:e.from});(0<l||!c.inclusiveRight&&!l)&&h.push({from:e.to,to:g.to});a.splice.apply(a,h);f+=h.length-1}}}return a}function Xe(a){var b=a.markedSpans;if(b){for(var c=0;c<b.length;++c)b[c].marker.detachLine(a);a.markedSpans=null}}function Ye(a,b){if(b){for(var c=0;c<b.length;++c)b[c].marker.attachLine(a);a.markedSpans=
b}}function Ze(a,b){var c=a.lines.length-b.lines.length;if(0!=c)return c;var c=a.find(),d=b.find(),e=w(c.from,d.from)||(a.inclusiveLeft?-1:0)-(b.inclusiveLeft?-1:0);return e?-e:(c=w(c.to,d.to)||(a.inclusiveRight?1:0)-(b.inclusiveRight?1:0))?c:b.id-a.id}function xa(a,b){var c=ra&&a.markedSpans,d;if(c)for(var e,f=0;f<c.length;++f)e=c[f],e.marker.collapsed&&null==(b?e.from:e.to)&&(!d||0>Ze(d,e.marker))&&(d=e.marker);return d}function Ue(a,b,c,d,e){a=t(a,b);if(a=ra&&a.markedSpans)for(b=0;b<a.length;++b){var f=
a[b];if(f.marker.collapsed){var g=f.marker.find(0),h=w(g.from,c)||(f.marker.inclusiveLeft?-1:0)-(e.inclusiveLeft?-1:0),k=w(g.to,d)||(f.marker.inclusiveRight?1:0)-(e.inclusiveRight?1:0);if(!(0<=h&&0>=k||0>=h&&0<=k)&&(0>=h&&(f.marker.inclusiveRight&&e.inclusiveLeft?0<=w(g.to,c):0<w(g.to,c))||0<=h&&(f.marker.inclusiveRight&&e.inclusiveLeft?0>=w(g.from,d):0>w(g.from,d))))return!0}}}function ia(a){for(var b;b=xa(a,!0);)a=b.find(-1,!0).line;return a}function Nc(a,b){var c=t(a,b),d=ia(c);return c==d?b:F(d)}
function Kd(a,b){if(b>a.lastLine())return b;var c=t(a,b),d;if(!wa(a,c))return b;for(;d=xa(c,!1);)c=d.find(1,!0).line;return F(c)+1}function wa(a,b){var c=ra&&b.markedSpans;if(c)for(var d,e=0;e<c.length;++e)if(d=c[e],d.marker.collapsed&&(null==d.from||!d.marker.widgetNode&&0==d.from&&d.marker.inclusiveLeft&&sd(a,b,d)))return!0}function sd(a,b,c){if(null==c.to)return b=c.marker.find(1,!0),sd(a,b.line,xb(b.line.markedSpans,c.marker));if(c.marker.inclusiveRight&&c.to==b.text.length)return!0;for(var d,
e=0;e<b.markedSpans.length;++e)if(d=b.markedSpans[e],d.marker.collapsed&&!d.marker.widgetNode&&d.from==c.to&&(null==d.to||d.to!=c.from)&&(d.marker.inclusiveLeft||c.marker.inclusiveRight)&&sd(a,b,d))return!0}function tb(a){if(null!=a.height)return a.height;var b=a.doc.cm;if(!b)return 0;if(!Wc(document.body,a.node)){var c="position: relative;";a.coverGutter&&(c+="margin-left: -"+b.display.gutters.offsetWidth+"px;");a.noHScroll&&(c+="width: "+b.display.wrapper.clientWidth+"px;");U(b.display.measure,
s("div",[a.node],null,c))}return a.height=a.node.parentNode.offsetHeight}function hg(a,b,c,d){var e=new rc(a,c,d),f=a.cm;f&&e.noHScroll&&(f.display.alignWidgets=!0);mc(a,b,"widget",function(b){var c=b.widgets||(b.widgets=[]);null==e.insertAt?c.push(e):c.splice(Math.min(c.length-1,Math.max(0,e.insertAt)),0,e);e.line=b;f&&!wa(a,b)&&(c=ea(b)<a.scrollTop,ca(b,b.height+tb(e)),c&&kc(f,null,e.height),f.curOp.forceUpdate=!0);return!0});return e}function $e(a,b){if(a)for(;;){var c=a.match(/(?:^|\s+)line-(background-)?(\S+)/);
if(!c)break;a=a.slice(0,c.index)+a.slice(c.index+c[0].length);var d=c[1]?"bgClass":"textClass";null==b[d]?b[d]=c[2]:(new RegExp("(?:^|s)"+c[2]+"(?:$|s)")).test(b[d])||(b[d]+=" "+c[2])}return a}function af(a,b){if(a.blankLine)return a.blankLine(b);if(a.innerMode){var c=q.innerMode(a,b);if(c.mode.blankLine)return c.mode.blankLine(c.state)}}function td(a,b,c,d){for(var e=0;10>e;e++){d&&(d[0]=q.innerMode(a,c).mode);var f=a.token(b,c);if(b.pos>b.start)return f}throw Error("Mode "+a.name+" failed to advance stream.");
}function bf(a,b,c,d){function e(a){return{start:m.start,end:m.pos,string:m.current(),type:h||null,state:a?sa(f.mode,l):l}}var f=a.doc,g=f.mode,h;b=x(f,b);var k=t(f,b.line),l=rb(a,b.line,c),m=new sc(k.text,a.options.tabSize),p;for(d&&(p=[]);(d||m.pos<b.ch)&&!m.eol();)m.start=m.pos,h=td(g,m,l),d&&p.push(e(!0));return d?p:e()}function cf(a,b,c,d,e,f,g){var h=c.flattenSpans;null==h&&(h=a.options.flattenSpans);var k=0,l=null,m=new sc(b,a.options.tabSize),p,n=a.options.addModeClass&&[null];for(""==b&&
$e(af(c,d),f);!m.eol();){m.pos>a.options.maxHighlightLength?(h=!1,g&&$c(a,b,d,m.pos),m.pos=b.length,p=null):p=$e(td(c,m,d,n),f);if(n){var q=n[0].name;q&&(p="m-"+(p?q+" "+p:q))}if(!h||l!=p){for(;k<m.start;)k=Math.min(m.start,k+5E3),e(k,l);l=p}m.start=m.pos}for(;k<m.pos;)a=Math.min(m.pos,k+5E3),e(a,l),k=a}function ne(a,b,c,d){var e=[a.state.modeGen],f={};cf(a,b.text,a.doc.mode,c,function(a,b){e.push(a,b)},f,d);for(c=0;c<a.state.overlays.length;++c){var g=a.state.overlays[c],h=1,k=0;cf(a,b.text,g.mode,
!0,function(a,b){for(var c=h;k<a;){var d=e[h];d>a&&e.splice(h,1,a,e[h+1],d);h+=2;k=Math.min(a,d)}if(b)if(g.opaque)e.splice(c,h-c,a,"cm-overlay "+b),h=c+2;else for(;c<h;c+=2)d=e[c+1],e[c+1]=(d?d+" ":"")+"cm-overlay "+b},f)}return{styles:e,classes:f.bgClass||f.textClass?f:null}}function df(a,b,c){if(!b.styles||b.styles[0]!=a.state.modeGen){var d=rb(a,F(b)),e=ne(a,b,b.text.length>a.options.maxHighlightLength?sa(a.doc.mode,d):d);b.stateAfter=d;b.styles=e.styles;e.classes?b.styleClasses=e.classes:b.styleClasses&&
(b.styleClasses=null);c===a.doc.frontier&&a.doc.frontier++}return b.styles}function $c(a,b,c,d){var e=a.doc.mode;a=new sc(b,a.options.tabSize);a.start=a.pos=d||0;for(""==b&&af(e,c);!a.eol();)td(e,a,c),a.start=a.pos}function ef(a,b){if(!a||/^\s*$/.test(a))return null;var c=b.addModeClass?ig:jg;return c[a]||(c[a]=a.replace(/\S+/g,"cm-$\x26"))}function Rd(a,b){var c=s("span",null,null,K?"padding-right: .1px":null),c={pre:s("pre",[c],"CodeMirror-line"),content:c,col:0,pos:0,cm:a,trailingSpace:!1,splitSpaces:(A||
K)&&a.getOption("lineWrapping")};b.measure={};for(var d=0;d<=(b.rest?b.rest.length:0);d++){var e=d?b.rest[d-1]:b.line,f;c.pos=0;c.addToken=kg;var g;g=a.display.measure;if(null!=ud)g=ud;else{var h=U(g,document.createTextNode("AخA")),k=Sa(h,0,1).getBoundingClientRect(),h=Sa(h,1,2).getBoundingClientRect();pa(g);g=k&&k.left!=k.right?ud=3>h.right-k.right:!1}g&&(f=Z(e))&&(c.addToken=lg(c.addToken,f));c.map=[];k=b!=a.display.externalMeasured&&F(e);a:{g=c;var k=df(a,e,k),h=e.markedSpans,l=e.text,m=0;if(h)for(var p=
l.length,n=0,q=1,r="",t=void 0,v=void 0,u=0,w=void 0,x=void 0,z=void 0,B=void 0,y=void 0;;){if(u==n){for(var w=x=z=B=v="",y=null,u=Infinity,G=[],H,C=0;C<h.length;++C){var I=h[C],D=I.marker;"bookmark"==D.type&&I.from==n&&D.widgetNode?G.push(D):I.from<=n&&(null==I.to||I.to>n||D.collapsed&&I.to==n&&I.from==n)?(null!=I.to&&I.to!=n&&u>I.to&&(u=I.to,x=""),D.className&&(w+=" "+D.className),D.css&&(v=(v?v+";":"")+D.css),D.startStyle&&I.from==n&&(z+=" "+D.startStyle),D.endStyle&&I.to==u&&(H||(H=[])).push(D.endStyle,
I.to),D.title&&!B&&(B=D.title),D.collapsed&&(!y||0>Ze(y.marker,D))&&(y=I)):I.from>n&&u>I.from&&(u=I.from)}if(H)for(C=0;C<H.length;C+=2)H[C+1]==u&&(x+=" "+H[C]);if(!y||y.from==n)for(C=0;C<G.length;++C)ff(g,0,G[C]);if(y&&(y.from||0)==n){ff(g,(null==y.to?p+1:y.to)-n,y.marker,null==y.from);if(null==y.to)break a;y.to==n&&(y=!1)}}if(n>=p)break;for(G=Math.min(p,u);;){if(r){C=n+r.length;y||(I=C>G?r.slice(0,G-n):r,g.addToken(g,I,t?t+w:w,z,n+I.length==u?x:"",B,v));if(C>=G){r=r.slice(G-n);n=G;break}n=C;z=""}r=
l.slice(m,m=k[q++]);t=ef(k[q++],g.cm.options)}}else for(var q=1;q<k.length;q+=2)g.addToken(g,l.slice(m,m=k[q]),ef(k[q+1],g.cm.options))}e.styleClasses&&(e.styleClasses.bgClass&&(c.bgClass=vd(e.styleClasses.bgClass,c.bgClass||"")),e.styleClasses.textClass&&(c.textClass=vd(e.styleClasses.textClass,c.textClass||"")));0==c.map.length&&c.map.push(0,0,c.content.appendChild(mg(a.display.measure)));0==d?(b.measure.map=c.map,b.measure.cache={}):((b.measure.maps||(b.measure.maps=[])).push(c.map),(b.measure.caches||
(b.measure.caches=[])).push({}))}K&&(f=c.content.lastChild,/\bcm-tab\b/.test(f.className)||f.querySelector&&f.querySelector(".cm-tab"))&&(c.content.className="cm-tab-wrap-hack");J(a,"renderLine",a,b.line,c.pre);c.pre.className&&(c.textClass=vd(c.pre.className,c.textClass||""));return c}function kg(a,b,c,d,e,f,g){if(b){var h;if(a.splitSpaces)if(h=a.trailingSpace,1<b.length&&!/  /.test(b))h=b;else{for(var k="",l=0;l<b.length;l++){var m=b.charAt(l);" "!=m||!h||l!=b.length-1&&32!=b.charCodeAt(l+1)||(m=
" ");k+=m;h=" "==m}h=k}else h=b;k=h;l=a.cm.state.specialChars;m=!1;if(l.test(b)){h=document.createDocumentFragment();for(var p=0;;){l.lastIndex=p;var n=l.exec(b),q=n?n.index-p:b.length-p;if(q){var r=document.createTextNode(k.slice(p,p+q));A&&9>B?h.appendChild(s("span",[r])):h.appendChild(r);a.map.push(a.pos,a.pos+q,r);a.col+=q;a.pos+=q}if(!n)break;p+=q+1;"\t"==n[0]?(r=a.cm.options.tabSize,n=r-a.col%r,r=h.appendChild(s("span",pd(n),"cm-tab")),r.setAttribute("role","presentation"),r.setAttribute("cm-text",
"\t"),a.col+=n):("\r"==n[0]||"\n"==n[0]?(r=h.appendChild(s("span","\r"==n[0]?"␍":"␤","cm-invalidchar")),r.setAttribute("cm-text",n[0])):(r=a.cm.options.specialCharPlaceholder(n[0]),r.setAttribute("cm-text",n[0]),A&&9>B?h.appendChild(s("span",[r])):h.appendChild(r)),a.col+=1);a.map.push(a.pos,a.pos+1,r);a.pos++}}else a.col+=b.length,h=document.createTextNode(k),a.map.push(a.pos,a.pos+b.length,h),A&&9>B&&(m=!0),a.pos+=b.length;a.trailingSpace=32==k.charCodeAt(b.length-1);if(c||d||e||m||g)return b=c||
"",d&&(b+=d),e&&(b+=e),d=s("span",[h],b,g),f&&(d.title=f),a.content.appendChild(d);a.content.appendChild(h)}}function lg(a,b){return function(c,d,e,f,g,h,k){e=e?e+" cm-force-border":"cm-force-border";for(var l=c.pos,m=l+d.length;;){for(var p=0;p<b.length;p++){var n=b[p];if(n.to>l&&n.from<=l)break}if(n.to>=m)return a(c,d,e,f,g,h,k);a(c,d.slice(0,n.to-l),e,f,null,h,k);f=null;d=d.slice(n.to-l);l=n.to}}}function ff(a,b,c,d){var e=!d&&c.widgetNode;e&&a.map.push(a.pos,a.pos+b,e);!d&&a.cm.display.input.needsContentAttribute&&
(e||(e=a.content.appendChild(document.createElement("span"))),e.setAttribute("cm-marker",c.id));e&&(a.cm.display.input.setUneditable(e),a.content.appendChild(e));a.pos+=b;a.trailingSpace=!1}function Re(a,b){return 0==b.from.ch&&0==b.to.ch&&""==z(b.text)&&(!a.cm||a.cm.options.wholeLineUpdateBefore)}function od(a,b,c,d){function e(a,c,e){a.text=c;a.stateAfter&&(a.stateAfter=null);a.styles&&(a.styles=null);null!=a.order&&(a.order=null);Xe(a);Ye(a,e);c=d?d(a):1;c!=a.height&&ca(a,c);R(a,"change",a,b)}
function f(a,b){for(var e=a,f=[];e<b;++e)f.push(new yb(k[e],c?c[e]:null,d));return f}var g=b.from,h=b.to,k=b.text,l=t(a,g.line),m=t(a,h.line),p=z(k),n=c?c[k.length-1]:null,q=h.line-g.line;if(b.full)a.insert(0,f(0,k.length)),a.remove(k.length,a.size-k.length);else if(Re(a,b)){var r=f(0,k.length-1);e(m,m.text,n);q&&a.remove(g.line,q);r.length&&a.insert(g.line,r)}else l==m?1==k.length?e(l,l.text.slice(0,g.ch)+p+l.text.slice(h.ch),n):(r=f(1,k.length-1),r.push(new yb(p+l.text.slice(h.ch),n,d)),e(l,l.text.slice(0,
g.ch)+k[0],c?c[0]:null),a.insert(g.line+1,r)):1==k.length?(e(l,l.text.slice(0,g.ch)+k[0]+m.text.slice(h.ch),c?c[0]:null),a.remove(g.line+1,q)):(e(l,l.text.slice(0,g.ch)+k[0],c?c[0]:null),e(m,p+m.text.slice(h.ch),n),r=f(1,k.length-1),1<q&&a.remove(g.line+1,q-1),a.insert(g.line+1,r));R(a,"change",a,b)}function zb(a){this.lines=a;this.parent=null;for(var b=0,c=0;b<a.length;++b)a[b].parent=this,c+=a[b].height;this.height=c}function Ab(a){this.children=a;for(var b=0,c=0,d=0;d<a.length;++d){var e=a[d],
b=b+e.chunkSize(),c=c+e.height;e.parent=this}this.size=b;this.height=c;this.parent=null}function Fa(a,b,c){function d(a,f,g){if(a.linked)for(var h=0;h<a.linked.length;++h){var k=a.linked[h];if(k.doc!=f){var l=g&&k.sharedHist;if(!c||l)b(k.doc,l),d(k.doc,a,l)}}}d(a,null,!0)}function Dd(a,b){if(b.cm)throw Error("This document is already in use.");a.doc=b;b.cm=a;Bc(a);Ac(a);a.options.lineWrapping||Ec(a);a.options.mode=b.modeOption;M(a)}function t(a,b){b-=a.first;if(0>b||b>=a.size)throw Error("There is no line "+
(b+a.first)+" in the document.");for(var c=a;!c.lines;)for(var d=0;;++d){var e=c.children[d],f=e.chunkSize();if(b<f){c=e;break}b-=f}return c.lines[b]}function Ba(a,b,c){var d=[],e=b.line;a.iter(b.line,c.line+1,function(a){a=a.text;e==c.line&&(a=a.slice(0,c.ch));e==b.line&&(a=a.slice(b.ch));d.push(a);++e});return d}function wd(a,b,c){var d=[];a.iter(b,c,function(a){d.push(a.text)});return d}function ca(a,b){var c=b-a.height;if(c)for(var d=a;d;d=d.parent)d.height+=c}function F(a){if(null==a.parent)return null;
var b=a.parent;a=D(b.lines,a);for(var c=b.parent;c;b=c,c=c.parent)for(var d=0;c.children[d]!=b;++d)a+=c.children[d].chunkSize();return a+b.first}function ya(a,b){var c=a.first;a:do{for(var d=0;d<a.children.length;++d){var e=a.children[d],f=e.height;if(b<f){a=e;continue a}b-=f;c+=e.chunkSize()}return c}while(!a.lines);for(d=0;d<a.lines.length;++d){e=a.lines[d].height;if(b<e)break;b-=e}return c+d}function ea(a){a=ia(a);for(var b=0,c=a.parent,d=0;d<c.lines.length;++d){var e=c.lines[d];if(e==a)break;
else b+=e.height}for(a=c.parent;a;c=a,a=c.parent)for(d=0;d<a.children.length&&(e=a.children[d],e!=c);++d)b+=e.height;return b}function Z(a){var b=a.order;null==b&&(b=a.order=ng(a.text));return b}function tc(a){this.done=[];this.undone=[];this.undoDepth=Infinity;this.lastModTime=this.lastSelTime=0;this.lastOrigin=this.lastSelOrigin=this.lastOp=this.lastSelOp=null;this.generation=this.maxGeneration=a||1}function nd(a,b){var c={from:Sc(b.from),to:Ea(b),text:Ba(a,b.from,b.to)};gf(a,c,b.from.line,b.to.line+
1);Fa(a,function(a){gf(a,c,b.from.line,b.to.line+1)},!0);return c}function ee(a){for(;a.length;)if(z(a).ranges)a.pop();else break}function Ne(a,b,c,d){var e=a.history;e.undone.length=0;var f=+new Date,g,h;if(h=e.lastOp==d||e.lastOrigin==b.origin&&b.origin&&("+"==b.origin.charAt(0)&&a.cm&&e.lastModTime>f-a.cm.options.historyEventDelay||"*"==b.origin.charAt(0)))e.lastOp==d?(ee(e.done),g=z(e.done)):e.done.length&&!z(e.done).ranges?g=z(e.done):1<e.done.length&&!e.done[e.done.length-2].ranges?(e.done.pop(),
g=z(e.done)):g=void 0,h=g;if(h){var k=z(g.changes);0==w(b.from,b.to)&&0==w(b.from,k.to)?k.to=Ea(b):g.changes.push(nd(a,b))}else for((g=z(e.done))&&g.ranges||Ub(a.sel,e.done),g={changes:[nd(a,b)],generation:e.generation},e.done.push(g);e.done.length>e.undoDepth;)e.done.shift(),e.done[0].ranges||e.done.shift();e.done.push(c);e.generation=++e.maxGeneration;e.lastModTime=e.lastSelTime=f;e.lastOp=e.lastSelOp=d;e.lastOrigin=e.lastSelOrigin=b.origin;k||J(a,"historyAdded")}function Ub(a,b){var c=z(b);c&&
c.ranges&&c.equals(a)||b.push(a)}function gf(a,b,c,d){var e=b["spans_"+a.id],f=0;a.iter(Math.max(a.first,c),Math.min(a.first+a.size,d),function(c){c.markedSpans&&((e||(e=b["spans_"+a.id]={}))[f]=c.markedSpans);++f})}function gg(a){if(!a)return null;for(var b=0,c;b<a.length;++b)a[b].marker.explicitlyCleared?c||(c=a.slice(0,b)):c&&c.push(a[b]);return c?c.length?c:null:a}function Xa(a,b,c){for(var d=0,e=[];d<a.length;++d){var f=a[d];if(f.ranges)e.push(c?ka.prototype.deepCopy.call(f):f);else{var f=f.changes,
g=[];e.push({changes:g});for(var h=0;h<f.length;++h){var k=f[h],l;g.push({from:k.from,to:k.to,text:k.text});if(b)for(var m in k)(l=m.match(/^spans_(\d+)$/))&&-1<D(b,Number(l[1]))&&(z(g)[m]=k[m],delete k[m])}}}return e}function hf(a,b,c,d){c<a.line?a.line+=d:b<a.line&&(a.line=b,a.ch=0)}function jf(a,b,c,d){for(var e=0;e<a.length;++e){var f=a[e],g=!0;if(f.ranges){f.copied||(f=a[e]=f.deepCopy(),f.copied=!0);for(var h=0;h<f.ranges.length;h++)hf(f.ranges[h].anchor,b,c,d),hf(f.ranges[h].head,b,c,d)}else{for(h=
0;h<f.changes.length;++h){var k=f.changes[h];if(c<k.from.line)k.from=r(k.from.line+d,k.from.ch),k.to=r(k.to.line+d,k.to.ch);else if(b<=k.to.line){g=!1;break}}g||(a.splice(0,e+1),e=0)}}}function Oe(a,b){var c=b.from.line,d=b.to.line,e=b.text.length-(d-c)-1;jf(a.done,c,d,e);jf(a.undone,c,d,e)}function jd(a){return null!=a.defaultPrevented?a.defaultPrevented:0==a.returnValue}function Ce(a){var b=a.which;null==b&&(a.button&1?b=1:a.button&2?b=3:a.button&4&&(b=2));Y&&a.ctrlKey&&1==b&&(b=3);return b}function uc(a,
b,c){a=a._handlers&&a._handlers[b];return c?a&&0<a.length?a.slice():kf:a||kf}function R(a,b){function c(a){return function(){a.apply(null,e)}}var d=uc(a,b,!1);if(d.length){var e=Array.prototype.slice.call(arguments,2),f;Ta?f=Ta.delayedCallbacks:Bb?f=Bb:(f=Bb=[],setTimeout(og,0));for(var g=0;g<d.length;++g)f.push(c(d[g]))}}function og(){var a=Bb;Bb=null;for(var b=0;b<a.length;++b)a[b]()}function H(a,b,c){"string"==typeof b&&(b={type:b,preventDefault:function(){this.defaultPrevented=!0}});J(a,c||b.type,
a,b);return jd(b)||b.codemirrorIgnore}function he(a){var b=a._handlers&&a._handlers.cursorActivity;if(b){a=a.curOp.cursorActivityHandlers||(a.curOp.cursorActivityHandlers=[]);for(var c=0;c<b.length;++c)-1==D(a,b[c])&&a.push(b[c])}}function W(a,b){return 0<uc(a,b).length}function Ya(a){a.prototype.on=function(a,c){v(this,a,c)};a.prototype.off=function(a,c){ja(this,a,c)}}function ua(){this.id=null}function pd(a){for(;vc.length<=a;)vc.push(z(vc)+" ");return vc[a]}function z(a){return a[a.length-1]}function D(a,
b){for(var c=0;c<a.length;++c)if(a[c]==b)return c;return-1}function Pb(a,b){for(var c=[],d=0;d<a.length;d++)c[d]=b(a[d],d);return c}function pg(a,b,c){for(var d=0,e=c(b);d<a.length&&c(a[d])<=e;)d++;a.splice(d,0,b)}function Cb(){}function lf(a,b){var c;Object.create?c=Object.create(a):(Cb.prototype=a,c=new Cb);b&&X(b,c);return c}function X(a,b,c){b||(b={});for(var d in a)!a.hasOwnProperty(d)||!1===c&&b.hasOwnProperty(d)||(b[d]=a[d]);return b}function xc(a){var b=Array.prototype.slice.call(arguments,
1);return function(){return a.apply(null,b)}}function nc(a,b){return b?-1<b.source.indexOf("\\w")&&mf(a)?!0:b.test(a):mf(a)}function nf(a){for(var b in a)if(a.hasOwnProperty(b)&&a[b])return!1;return!0}function sb(a){return 768<=a.charCodeAt(0)&&qg.test(a)}function s(a,b,c,d){a=document.createElement(a);c&&(a.className=c);d&&(a.style.cssText=d);if("string"==typeof b)a.appendChild(document.createTextNode(b));else if(b)for(c=0;c<b.length;++c)a.appendChild(b[c]);return a}function pa(a){for(var b=a.childNodes.length;0<
b;--b)a.removeChild(a.firstChild);return a}function U(a,b){return pa(a).appendChild(b)}function fa(){for(var a=document.activeElement;a&&a.root&&a.root.activeElement;)a=a.root.activeElement;return a}function Db(a){return new RegExp("(^|\\s)"+a+"(?:$|\\s)\\s*")}function vd(a,b){for(var c=a.split(" "),d=0;d<c.length;d++)c[d]&&!Db(c[d]).test(b)&&(b+=" "+c[d]);return b}function of(a){if(document.body.getElementsByClassName)for(var b=document.body.getElementsByClassName("CodeMirror"),c=0;c<b.length;c++){var d=
b[c].CodeMirror;d&&a(d)}}function zf(){var a;v(window,"resize",function(){null==a&&(a=setTimeout(function(){a=null;of(Pf)},100))});v(window,"blur",function(){of(bb)})}function mg(a){if(null==xd){var b=s("span","​");U(a,s("span",[b,document.createTextNode("x")]));0!=a.firstChild.offsetHeight&&(xd=1>=b.offsetWidth&&2<b.offsetHeight&&!(A&&8>B))}a=xd?s("span","​"):s("span"," ",null,"display: inline-block; width: 1px; margin-right: -1px");a.setAttribute("cm-text","");return a}function Gf(a,b,c,d){if(!a)return d(b,
c,"ltr");for(var e=!1,f=0;f<a.length;++f){var g=a[f];if(g.from<c&&g.to>b||b==c&&g.to==b)d(Math.max(g.from,b),Math.min(g.to,c),1==g.level?"rtl":"ltr"),e=!0}e||d(b,c,"ltr")}function cd(a){return a.level%2?a.to:a.from}function dd(a){return a.level%2?a.from:a.to}function Zb(a){return(a=Z(a))?cd(a[0]):0}function $b(a){var b=Z(a);return b?dd(z(b)):a.text.length}function pf(a,b){var c=t(a.doc,b),d=ia(c);d!=c&&(b=F(d));d=(c=Z(d))?c[0].level%2?$b(d):Zb(d):0;return r(b,d)}function qf(a,b){var c=pf(a,b.line),
d=t(a.doc,c.line),e=Z(d);return e&&0!=e[0].level?c:(d=Math.max(0,d.text.search(/\S/)),r(c.line,b.line==c.line&&b.ch<=d&&b.ch?0:d))}function Qb(a,b){ub=null;for(var c=0,d;c<a.length;++c){var e=a[c];if(e.from<b&&e.to>b)return c;if(e.from==b||e.to==b)if(null==d)d=c;else{var f;f=e.level;var g=a[d].level,h=a[0].level;f=f==h?!0:g==h?!1:f<g;if(f)return e.from!=e.to&&(ub=d),c;e.from!=e.to&&(ub=c);break}}return d}function yd(a,b,c,d){if(!d)return b+c;do b+=c;while(0<b&&sb(a.text.charAt(b)));return b}function fd(a,
b,c,d){var e=Z(a);if(!e)return Se(a,b,c,d);var f=Qb(e,b),g=e[f];for(b=yd(a,b,g.level%2?-c:c,d);;){if(b>g.from&&b<g.to)return b;if(b==g.from||b==g.to){if(Qb(e,b)==f)return b;g=e[f+c];return 0<c==g.level%2?g.to:g.from}g=e[f+=c];if(!g)return null;b=0<c==g.level%2?yd(a,g.to,-1,d):yd(a,g.from,1,d)}}function Se(a,b,c,d){b+=c;if(d)for(;0<b&&sb(a.text.charAt(b));)b+=c;return 0>b||b>a.text.length?null:b}var S=navigator.userAgent,rf=navigator.platform,oa=/gecko\/\d/i.test(S),sf=/MSIE \d/.test(S),tf=/Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(S),
A=sf||tf,B=A&&(sf?document.documentMode||6:tf[1]),K=/WebKit\//.test(S),rg=K&&/Qt\/\d+\.\d+/.test(S),sg=/Chrome\//.test(S),ba=/Opera\//.test(S),xe=/Apple Computer/.test(navigator.vendor),tg=/Mac OS X 1\d\D([8-9]|\d\d)\D/.test(S),Mf=/PhantomJS/.test(S),ob=/AppleWebKit/.test(S)&&/Mobile\/\w+/.test(S),ab=ob||/Android|webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(S),Y=ob||/Mac/.test(rf),Vf=/\bCrOS\b/.test(S),ug=/win/i.test(rf),Ha=ba&&S.match(/Version\/(\d*\.\d*)/);Ha&&(Ha=Number(Ha[1]));Ha&&15<=
Ha&&(ba=!1,K=!0);var uf=Y&&(rg||ba&&(null==Ha||12.11>Ha)),hd=oa||A&&9<=B,Le=!1,ra=!1;Gc.prototype=X({update:function(a){var b=a.scrollWidth>a.clientWidth+1,c=a.scrollHeight>a.clientHeight+1,d=a.nativeBarWidth;c?(this.vert.style.display="block",this.vert.style.bottom=b?d+"px":"0",this.vert.firstChild.style.height=Math.max(0,a.scrollHeight-a.clientHeight+(a.viewHeight-(b?d:0)))+"px"):(this.vert.style.display="",this.vert.firstChild.style.height="0");b?(this.horiz.style.display="block",this.horiz.style.right=
c?d+"px":"0",this.horiz.style.left=a.barLeft+"px",this.horiz.firstChild.style.width=a.scrollWidth-a.clientWidth+(a.viewWidth-a.barLeft-(c?d:0))+"px"):(this.horiz.style.display="",this.horiz.firstChild.style.width="0");!this.checkedZeroWidth&&0<a.clientHeight&&(0==d&&this.zeroWidthHack(),this.checkedZeroWidth=!0);return{right:c?d:0,bottom:b?d:0}},setScrollLeft:function(a){this.horiz.scrollLeft!=a&&(this.horiz.scrollLeft=a);this.disableHoriz&&this.enableZeroWidthBar(this.horiz,this.disableHoriz)},setScrollTop:function(a){this.vert.scrollTop!=
a&&(this.vert.scrollTop=a);this.disableVert&&this.enableZeroWidthBar(this.vert,this.disableVert)},zeroWidthHack:function(){this.horiz.style.height=this.vert.style.width=Y&&!tg?"12px":"18px";this.horiz.style.pointerEvents=this.vert.style.pointerEvents="none";this.disableHoriz=new ua;this.disableVert=new ua},enableZeroWidthBar:function(a,b){function c(){var d=a.getBoundingClientRect();document.elementFromPoint(d.left+1,d.bottom-1)!=a?a.style.pointerEvents="none":b.set(1E3,c)}a.style.pointerEvents="auto";
b.set(1E3,c)},clear:function(){var a=this.horiz.parentNode;a.removeChild(this.horiz);a.removeChild(this.vert)}},Gc.prototype);Hc.prototype=X({update:function(){return{bottom:0,right:0}},setScrollLeft:function(){},setScrollTop:function(){},clear:function(){}},Hc.prototype);q.scrollbarModel={"native":Gc,"null":Hc};Kb.prototype.signal=function(a,b){W(a,b)&&this.events.push(arguments)};Kb.prototype.finish=function(){for(var a=0;a<this.events.length;a++)J.apply(null,this.events[a])};var r=q.Pos=function(a,
b){if(!(this instanceof r))return new r(a,b);this.line=a;this.ch=b},w=q.cmpPos=function(a,b){return a.line-b.line||a.ch-b.ch},P=null;Tc.prototype=X({init:function(a){function b(a){if(!H(d,a)){if(d.somethingSelected())P={lineWise:!1,text:d.getSelections()},c.inaccurateSelection&&(c.prevInput="",c.inaccurateSelection=!1,f.value=P.text.join("\n"),Za(f));else if(d.options.lineWiseCopyCut){var b=Wd(d);P={lineWise:!0,text:b.text};"cut"==a.type?d.setSelections(b.ranges,null,ha):(c.prevInput="",f.value=b.text.join("\n"),
Za(f))}else return;"cut"==a.type&&(d.state.cutIncoming=!0)}}var c=this,d=this.cm,e=this.wrapper=Yd(),f=this.textarea=e.firstChild;a.wrapper.insertBefore(e,a.wrapper.firstChild);ob&&(f.style.width="0px");v(f,"input",function(){A&&9<=B&&c.hasSelection&&(c.hasSelection=null);c.poll()});v(f,"paste",function(a){H(d,a)||Vd(a,d)||(d.state.pasteIncoming=!0,c.fastPoll())});v(f,"cut",b);v(f,"copy",b);v(a.scroller,"paste",function(b){na(a,b)||H(d,b)||(d.state.pasteIncoming=!0,c.focus())});v(a.lineSpace,"selectstart",
function(b){na(a,b)||O(b)});v(f,"compositionstart",function(){var a=d.getCursor("from");c.composing&&c.composing.range.clear();c.composing={start:a,range:d.markText(a,d.getCursor("to"),{className:"CodeMirror-composing"})}});v(f,"compositionend",function(){c.composing&&(c.poll(),c.composing.range.clear(),c.composing=null)})},prepareSelection:function(){var a=this.cm,b=a.display,c=a.doc,d=ke(a);if(a.options.moveInputWithCursor){var a=la(a,c.sel.primary().head,"div"),c=b.wrapper.getBoundingClientRect(),
e=b.lineDiv.getBoundingClientRect();d.teTop=Math.max(0,Math.min(b.wrapper.clientHeight-10,a.top+e.top-c.top));d.teLeft=Math.max(0,Math.min(b.wrapper.clientWidth-10,a.left+e.left-c.left))}return d},showSelection:function(a){var b=this.cm.display;U(b.cursorDiv,a.cursors);U(b.selectionDiv,a.selection);null!=a.teTop&&(this.wrapper.style.top=a.teTop+"px",this.wrapper.style.left=a.teLeft+"px")},reset:function(a){if(!this.contextMenuPending){var b,c,d=this.cm,e=d.doc;d.somethingSelected()?(this.prevInput=
"",b=e.sel.primary(),c=(b=He&&(100<b.to().line-b.from().line||1E3<(c=d.getSelection()).length))?"-":c||d.getSelection(),this.textarea.value=c,d.state.focused&&Za(this.textarea),A&&9<=B&&(this.hasSelection=c)):a||(this.prevInput=this.textarea.value="",A&&9<=B&&(this.hasSelection=null));this.inaccurateSelection=b}},getField:function(){return this.textarea},supportsTouch:function(){return!1},focus:function(){if("nocursor"!=this.cm.options.readOnly&&(!ab||fa()!=this.textarea))try{this.textarea.focus()}catch(a){}},
blur:function(){this.textarea.blur()},resetPosition:function(){this.wrapper.style.top=this.wrapper.style.left=0},receivedFocus:function(){this.slowPoll()},slowPoll:function(){var a=this;a.pollingFast||a.polling.set(this.cm.options.pollInterval,function(){a.poll();a.cm.state.focused&&a.slowPoll()})},fastPoll:function(){function a(){c.poll()||b?(c.pollingFast=!1,c.slowPoll()):(b=!0,c.polling.set(60,a))}var b=!1,c=this;c.pollingFast=!0;c.polling.set(20,a)},poll:function(){var a=this.cm,b=this.textarea,
c=this.prevInput;if(this.contextMenuPending||!a.state.focused||vg(b)&&!c&&!this.composing||a.isReadOnly()||a.options.disableInput||a.state.keySeq)return!1;var d=b.value;if(d==c&&!a.somethingSelected())return!1;if(A&&9<=B&&this.hasSelection===d||Y&&/[\uf700-\uf7ff]/.test(d))return a.display.input.reset(),!1;if(a.doc.sel==a.display.selForContextMenu){var e=d.charCodeAt(0);8203!=e||c||(c="​");if(8666==e)return this.reset(),this.cm.execCommand("undo")}for(var f=0,e=Math.min(c.length,d.length);f<e&&c.charCodeAt(f)==
d.charCodeAt(f);)++f;var g=this;T(a,function(){Ob(a,d.slice(f),c.length-f,null,g.composing?"*compose":null);1E3<d.length||-1<d.indexOf("\n")?b.value=g.prevInput="":g.prevInput=d;g.composing&&(g.composing.range.clear(),g.composing.range=a.markText(g.composing.start,a.getCursor("to"),{className:"CodeMirror-composing"}))});return!0},ensurePolled:function(){this.pollingFast&&this.poll()&&(this.pollingFast=!1)},onKeyPress:function(){A&&9<=B&&(this.hasSelection=null);this.fastPoll()},onContextMenu:function(a){function b(){if(null!=
g.selectionStart){var a=e.somethingSelected(),b="​"+(a?g.value:"");g.value="⇚";g.value=b;d.prevInput=a?"":"​";g.selectionStart=1;g.selectionEnd=b.length;f.selForContextMenu=e.doc.sel}}function c(){d.contextMenuPending=!1;d.wrapper.style.cssText=m;g.style.cssText=l;A&&9>B&&f.scrollbars.setScrollTop(f.scroller.scrollTop=k);if(null!=g.selectionStart){(!A||A&&9>B)&&b();var a=0,c=function(){f.selForContextMenu==e.doc.sel&&0==g.selectionStart&&0<g.selectionEnd&&"​"==d.prevInput?G(e,hc.selectAll)(e):10>
a++?f.detectingSelectAll=setTimeout(c,500):f.input.reset()};f.detectingSelectAll=setTimeout(c,200)}}var d=this,e=d.cm,f=e.display,g=d.textarea,h=Da(e,a),k=f.scroller.scrollTop;if(h&&!ba){e.options.resetSelectionOnContextMenu&&-1==e.doc.sel.contains(h)&&G(e,C)(e.doc,ga(h),ha);var l=g.style.cssText,m=d.wrapper.style.cssText;d.wrapper.style.cssText="position: absolute";h=d.wrapper.getBoundingClientRect();g.style.cssText="position: absolute; width: 30px; height: 30px; top: "+(a.clientY-h.top-5)+"px; left: "+
(a.clientX-h.left-5)+"px; z-index: 1000; background: "+(A?"rgba(255, 255, 255, .05)":"transparent")+"; outline: none; border-width: 0; outline: none; overflow: hidden; opacity: .05; filter: alpha(opacity\x3d5);";if(K)var p=window.scrollY;f.input.focus();K&&window.scrollTo(null,p);f.input.reset();e.somethingSelected()||(g.value=d.prevInput=" ");d.contextMenuPending=!0;f.selForContextMenu=e.doc.sel;clearTimeout(f.detectingSelectAll);A&&9<=B&&b();if(hd){cc(a);var n=function(){ja(window,"mouseup",n);
setTimeout(c,20)};v(window,"mouseup",n)}else setTimeout(c,50)}},readOnlyChanged:function(a){a||this.reset()},setUneditable:Cb,needsContentAttribute:!1},Tc.prototype);Uc.prototype=X({init:function(a){function b(a){if(!H(d,a)){if(d.somethingSelected())P={lineWise:!1,text:d.getSelections()},"cut"==a.type&&d.replaceSelection("",null,"cut");else if(d.options.lineWiseCopyCut){var b=Wd(d);P={lineWise:!0,text:b.text};"cut"==a.type&&d.operation(function(){d.setSelections(b.ranges,0,ha);d.replaceSelection("",
null,"cut")})}else return;if(a.clipboardData){a.clipboardData.clearData();var h=P.text.join("\n");a.clipboardData.setData("Text",h);if(a.clipboardData.getData("Text")==h){a.preventDefault();return}}var k=Yd();a=k.firstChild;d.display.lineSpace.insertBefore(k,d.display.lineSpace.firstChild);a.value=P.text.join("\n");var l=document.activeElement;Za(a);setTimeout(function(){d.display.lineSpace.removeChild(k);l.focus();l==e&&c.showPrimarySelection()},50)}}var c=this,d=c.cm,e=c.div=a.lineDiv;Xd(e,d.options.spellcheck);
v(e,"paste",function(a){H(d,a)||Vd(a,d)||11>=B&&setTimeout(G(d,function(){c.pollContent()||M(d)}),20)});v(e,"compositionstart",function(a){a=a.data;c.composing={sel:d.doc.sel,data:a,startData:a};if(a){var b=d.doc.sel.primary(),e=d.getLine(b.head.line).indexOf(a,Math.max(0,b.head.ch-a.length));-1<e&&e<=b.head.ch&&(c.composing.sel=ga(r(b.head.line,e),r(b.head.line,e+a.length)))}});v(e,"compositionupdate",function(a){c.composing.data=a.data});v(e,"compositionend",function(a){var b=c.composing;b&&(a.data==
b.startData||/\u200b/.test(a.data)||(b.data=a.data),setTimeout(function(){b.handled||c.applyComposition(b);c.composing==b&&(c.composing=null)},50))});v(e,"touchstart",function(){c.forceCompositionEnd()});v(e,"input",function(){c.composing||!d.isReadOnly()&&c.pollContent()||T(c.cm,function(){M(d)})});v(e,"copy",b);v(e,"cut",b)},prepareSelection:function(){var a=ke(this.cm,!1);a.focus=this.cm.state.focused;return a},showSelection:function(a,b){a&&this.cm.display.view.length&&((a.focus||b)&&this.showPrimarySelection(),
this.showMultipleSelections(a))},showPrimarySelection:function(){var a=window.getSelection(),b=this.cm.doc.sel.primary(),c=Rb(this.cm,a.anchorNode,a.anchorOffset),d=Rb(this.cm,a.focusNode,a.focusOffset);if(!c||c.bad||!d||d.bad||0!=w(Nb(c,d),b.from())||0!=w(Mb(c,d),b.to()))if(c=Zd(this.cm,b.from()),d=Zd(this.cm,b.to()),c||d){var e=this.cm.display.view,b=a.rangeCount&&a.getRangeAt(0);c?d||(d=e[e.length-1].measure,d=d.maps?d.maps[d.maps.length-1]:d.map,d={node:d[d.length-1],offset:d[d.length-2]-d[d.length-
3]}):c={node:e[0].measure.map[2],offset:0};try{var f=Sa(c.node,c.offset,d.offset,d.node)}catch(g){}f&&(!oa&&this.cm.state.focused?(a.collapse(c.node,c.offset),f.collapsed||a.addRange(f)):(a.removeAllRanges(),a.addRange(f)),b&&null==a.anchorNode?a.addRange(b):oa&&this.startGracePeriod());this.rememberSelection()}},startGracePeriod:function(){var a=this;clearTimeout(this.gracePeriod);this.gracePeriod=setTimeout(function(){a.gracePeriod=!1;a.selectionChanged()&&a.cm.operation(function(){a.cm.curOp.selectionChanged=
!0})},20)},showMultipleSelections:function(a){U(this.cm.display.cursorDiv,a.cursors);U(this.cm.display.selectionDiv,a.selection)},rememberSelection:function(){var a=window.getSelection();this.lastAnchorNode=a.anchorNode;this.lastAnchorOffset=a.anchorOffset;this.lastFocusNode=a.focusNode;this.lastFocusOffset=a.focusOffset},selectionInEditor:function(){var a=window.getSelection();if(!a.rangeCount)return!1;a=a.getRangeAt(0).commonAncestorContainer;return Wc(this.div,a)},focus:function(){"nocursor"!=
this.cm.options.readOnly&&this.div.focus()},blur:function(){this.div.blur()},getField:function(){return this.div},supportsTouch:function(){return!0},receivedFocus:function(){function a(){b.cm.state.focused&&(b.pollSelection(),b.polling.set(b.cm.options.pollInterval,a))}var b=this;this.selectionInEditor()?this.pollSelection():T(this.cm,function(){b.cm.curOp.selectionChanged=!0});this.polling.set(this.cm.options.pollInterval,a)},selectionChanged:function(){var a=window.getSelection();return a.anchorNode!=
this.lastAnchorNode||a.anchorOffset!=this.lastAnchorOffset||a.focusNode!=this.lastFocusNode||a.focusOffset!=this.lastFocusOffset},pollSelection:function(){if(!this.composing&&!this.gracePeriod&&this.selectionChanged()){var a=window.getSelection(),b=this.cm;this.rememberSelection();var c=Rb(b,a.anchorNode,a.anchorOffset),d=Rb(b,a.focusNode,a.focusOffset);c&&d&&T(b,function(){C(b.doc,ga(c,d),ha);if(c.bad||d.bad)b.curOp.selectionChanged=!0})}},pollContent:function(){var a=this.cm,b=a.display,c=a.doc.sel.primary(),
d=c.from(),c=c.to();if(d.line<b.viewFrom||c.line>b.viewTo-1)return!1;var e;d.line==b.viewFrom||0==(e=Aa(a,d.line))?(d=F(b.view[0].line),e=b.view[0].node):(d=F(b.view[e].line),e=b.view[e-1].node.nextSibling);var f=Aa(a,c.line);f==b.view.length-1?(c=b.viewTo-1,b=b.lineDiv.lastChild):(c=F(b.view[f+1].line)-1,b=b.view[f+1].node.previousSibling);b=a.doc.splitLines(Df(a,e,b,d,c));for(e=Ba(a.doc,r(d,0),r(c,t(a.doc,c).text.length));1<b.length&&1<e.length;)if(z(b)==z(e))b.pop(),e.pop(),c--;else if(b[0]==e[0])b.shift(),
e.shift(),d++;else break;for(var g=0,f=0,h=b[0],k=e[0],l=Math.min(h.length,k.length);g<l&&h.charCodeAt(g)==k.charCodeAt(g);)++g;h=z(b);k=z(e);for(l=Math.min(h.length-(1==b.length?g:0),k.length-(1==e.length?g:0));f<l&&h.charCodeAt(h.length-f-1)==k.charCodeAt(k.length-f-1);)++f;b[b.length-1]=h.slice(0,h.length-f);b[0]=b[0].slice(g);d=r(d,g);c=r(c,e.length?z(e).length-f:0);if(1<b.length||b[0]||w(d,c))return Ua(a.doc,b,d,c,"+input"),!0},ensurePolled:function(){this.forceCompositionEnd()},reset:function(){this.forceCompositionEnd()},
forceCompositionEnd:function(){this.composing&&!this.composing.handled&&(this.applyComposition(this.composing),this.composing.handled=!0,this.div.blur(),this.div.focus())},applyComposition:function(a){this.cm.isReadOnly()?G(this.cm,M)(this.cm):a.data&&a.data!=a.startData&&G(this.cm,Ob)(this.cm,a.data,0,a.sel)},setUneditable:function(a){a.contentEditable="false"},onKeyPress:function(a){a.preventDefault();this.cm.isReadOnly()||G(this.cm,Ob)(this.cm,String.fromCharCode(null==a.charCode?a.keyCode:a.charCode),
0)},readOnlyChanged:function(a){this.div.contentEditable=String("nocursor"!=a)},onContextMenu:Cb,resetPosition:Cb,needsContentAttribute:!0},Uc.prototype);q.inputStyles={textarea:Tc,contenteditable:Uc};ka.prototype={primary:function(){return this.ranges[this.primIndex]},equals:function(a){if(a==this)return!0;if(a.primIndex!=this.primIndex||a.ranges.length!=this.ranges.length)return!1;for(var b=0;b<this.ranges.length;b++){var c=this.ranges[b],d=a.ranges[b];if(0!=w(c.anchor,d.anchor)||0!=w(c.head,d.head))return!1}return!0},
deepCopy:function(){for(var a=[],b=0;b<this.ranges.length;b++)a[b]=new y(Sc(this.ranges[b].anchor),Sc(this.ranges[b].head));return new ka(a,this.primIndex)},somethingSelected:function(){for(var a=0;a<this.ranges.length;a++)if(!this.ranges[a].empty())return!0;return!1},contains:function(a,b){b||(b=a);for(var c=0;c<this.ranges.length;c++){var d=this.ranges[c];if(0<=w(b,d.from())&&0>=w(a,d.to()))return c}return-1}};y.prototype={from:function(){return Nb(this.anchor,this.head)},to:function(){return Mb(this.anchor,
this.head)},empty:function(){return this.head.line==this.anchor.line&&this.head.ch==this.anchor.ch}};var pe={left:0,right:0,top:0,bottom:0},Ca,Ta=null,Lf=0,ec,dc,we=0,fc=0,V=null;A?V=-.53:oa?V=15:sg?V=-.7:xe&&(V=-1/3);var Ee=function(a){var b=a.wheelDeltaX,c=a.wheelDeltaY;null==b&&a.detail&&a.axis==a.HORIZONTAL_AXIS&&(b=a.detail);null==c&&a.detail&&a.axis==a.VERTICAL_AXIS?c=a.detail:null==c&&(c=a.wheelDelta);return{x:b,y:c}};q.wheelEventPixels=function(a){a=Ee(a);a.x*=V;a.y*=V;return a};var Yf=new ua,
kd=null,Ea=q.changeEnd=function(a){return a.text?r(a.from.line+a.text.length-1,z(a.text).length+(1==a.text.length?a.from.ch:0)):a.to};q.prototype={constructor:q,focus:function(){window.focus();this.display.input.focus()},setOption:function(a,b){var c=this.options,d=c[a];if(c[a]!=b||"mode"==a)c[a]=b,Ka.hasOwnProperty(a)&&G(this,Ka[a])(this,b,d)},getOption:function(a){return this.options[a]},getDoc:function(){return this.doc},addKeyMap:function(a,b){this.state.keyMaps[b?"push":"unshift"](oc(a))},removeKeyMap:function(a){for(var b=
this.state.keyMaps,c=0;c<b.length;++c)if(b[c]==a||b[c].name==a)return b.splice(c,1),!0},addOverlay:L(function(a,b){var c=a.token?a:q.getMode(this.options,a);if(c.startState)throw Error("Overlays may not be stateful.");pg(this.state.overlays,{mode:c,modeSpec:a,opaque:b&&b.opaque,priority:b&&b.priority||0},function(a){return a.priority});this.state.modeGen++;M(this)}),removeOverlay:L(function(a){for(var b=this.state.overlays,c=0;c<b.length;++c){var d=b[c].modeSpec;if(d==a||"string"==typeof a&&d.name==
a){b.splice(c,1);this.state.modeGen++;M(this);break}}}),indentLine:L(function(a,b,c){"string"!=typeof b&&"number"!=typeof b&&(b=null==b?this.options.smartIndent?"smart":"prev":b?"add":"subtract");pb(this.doc,a)&&nb(this,a,b,c)}),indentSelection:L(function(a){for(var b=this.doc.sel.ranges,c=-1,d=0;d<b.length;d++){var e=b[d];if(e.empty())e.head.line>c&&(nb(this,e.head.line,a,!0),c=e.head.line,d==this.doc.sel.primIndex&&Pa(this));else{for(var f=e.from(),e=e.to(),g=Math.max(c,f.line),c=Math.min(this.lastLine(),
e.line-(e.ch?0:1))+1,e=g;e<c;++e)nb(this,e,a);e=this.doc.sel.ranges;0==f.ch&&b.length==e.length&&0<e[d].from().ch&&Xc(this.doc,d,new y(f,e[d].to()),ha)}}}),getTokenAt:function(a,b){return bf(this,a,b)},getLineTokens:function(a,b){return bf(this,r(a),b,!0)},getTokenTypeAt:function(a){a=x(this.doc,a);var b=df(this,t(this.doc,a.line)),c=0,d=(b.length-1)/2;a=a.ch;if(0==a)b=b[2];else for(;;){var e=c+d>>1;if((e?b[2*e-1]:0)>=a)d=e;else if(b[2*e+1]<a)c=e+1;else{b=b[2*e+2];break}}c=b?b.indexOf("cm-overlay "):
-1;return 0>c?b:0==c?null:b.slice(0,c-1)},getModeAt:function(a){var b=this.doc.mode;return b.innerMode?q.innerMode(b,this.getTokenAt(a).state).mode:b},getHelper:function(a,b){return this.getHelpers(a,b)[0]},getHelpers:function(a,b){var c=[];if(!$a.hasOwnProperty(b))return c;var d=$a[b],e=this.getModeAt(a);if("string"==typeof e[b])d[e[b]]&&c.push(d[e[b]]);else if(e[b])for(var f=0;f<e[b].length;f++){var g=d[e[b][f]];g&&c.push(g)}else e.helperType&&d[e.helperType]?c.push(d[e.helperType]):d[e.name]&&
c.push(d[e.name]);for(f=0;f<d._global.length;f++)g=d._global[f],g.pred(e,this)&&-1==D(c,g.val)&&c.push(g.val);return c},getStateAfter:function(a,b){var c=this.doc;a=Math.max(c.first,Math.min(null==a?c.first+c.size-1:a,c.first+c.size-1));return rb(this,a+1,b)},cursorCoords:function(a,b){var c;c=this.doc.sel.primary();c=null==a?c.head:"object"==typeof a?x(this.doc,a):a?c.from():c.to();return la(this,c,b||"page")},charCoords:function(a,b){return Vb(this,x(this.doc,a),b||"page")},coordsChar:function(a,
b){a=se(this,a,b||"page");return ed(this,a.left,a.top)},lineAtHeight:function(a,b){a=se(this,{top:a,left:0},b||"page").top;return ya(this.doc,a+this.display.viewOffset)},heightAtLine:function(a,b){var c=!1,d;"number"==typeof a?(d=this.doc.first+this.doc.size-1,a<this.doc.first?a=this.doc.first:a>d&&(a=d,c=!0),d=t(this.doc,a)):d=a;return bd(this,d,{top:0,left:0},b||"page").top+(c?this.doc.height-ea(d):0)},defaultTextHeight:function(){return va(this.display)},defaultCharWidth:function(){return eb(this.display)},
setGutterMarker:L(function(a,b,c){return mc(this.doc,a,"gutter",function(a){var e=a.gutterMarkers||(a.gutterMarkers={});e[b]=c;!c&&nf(e)&&(a.gutterMarkers=null);return!0})}),clearGutter:L(function(a){var b=this,c=b.doc,d=c.first;c.iter(function(c){c.gutterMarkers&&c.gutterMarkers[a]&&(c.gutterMarkers[a]=null,ma(b,d,"gutter"),nf(c.gutterMarkers)&&(c.gutterMarkers=null));++d})}),lineInfo:function(a){if("number"==typeof a){if(!pb(this.doc,a))return null;var b=a;a=t(this.doc,a);if(!a)return null}else if(b=
F(a),null==b)return null;return{line:b,handle:a,text:a.text,gutterMarkers:a.gutterMarkers,textClass:a.textClass,bgClass:a.bgClass,wrapClass:a.wrapClass,widgets:a.widgets}},getViewport:function(){return{from:this.display.viewFrom,to:this.display.viewTo}},addWidget:function(a,b,c,d,e){var f=this.display;a=la(this,x(this.doc,a));var g=a.bottom,h=a.left;b.style.position="absolute";b.setAttribute("cm-ignore-events","true");this.display.input.setUneditable(b);f.sizer.appendChild(b);if("over"==d)g=a.top;
else if("above"==d||"near"==d){var k=Math.max(f.wrapper.clientHeight,this.doc.height),l=Math.max(f.sizer.clientWidth,f.lineSpace.clientWidth);("above"==d||a.bottom+b.offsetHeight>k)&&a.top>b.offsetHeight?g=a.top-b.offsetHeight:a.bottom+b.offsetHeight<=k&&(g=a.bottom);h+b.offsetWidth>l&&(h=l-b.offsetWidth)}b.style.top=g+"px";b.style.left=b.style.right="";"right"==e?(h=f.sizer.clientWidth-b.offsetWidth,b.style.right="0px"):("left"==e?h=0:"middle"==e&&(h=(f.sizer.clientWidth-b.offsetWidth)/2),b.style.left=
h+"px");c&&(a=ac(this,h,g,h+b.offsetWidth,g+b.offsetHeight),null!=a.scrollTop&&jb(this,a.scrollTop),null!=a.scrollLeft&&Ma(this,a.scrollLeft))},triggerOnKeyDown:L(Ae),triggerOnKeyPress:L(Be),triggerOnKeyUp:ze,execCommand:function(a){if(hc.hasOwnProperty(a))return hc[a].call(null,this)},triggerElectric:L(function(a){Ud(this,a)}),findPosH:function(a,b,c,d){var e=1;0>b&&(e=-1,b=-b);var f=0;for(a=x(this.doc,a);f<b&&(a=qd(this.doc,a,e,c,d),!a.hitSide);++f);return a},moveH:L(function(a,b){var c=this;c.extendSelectionsBy(function(d){return c.display.shift||
c.doc.extend||d.empty()?qd(c.doc,d.head,a,b,c.options.rtlMoveVisually):0>a?d.from():d.to()},Eb)}),deleteH:L(function(a,b){var c=this.doc;this.doc.sel.somethingSelected()?c.replaceSelection("",null,"+delete"):Va(this,function(d){var e=qd(c,d.head,a,b,!1);return 0>a?{from:e,to:d.head}:{from:d.head,to:e}})}),findPosV:function(a,b,c,d){var e=1;0>b&&(e=-1,b=-b);var f=0;for(a=x(this.doc,a);f<b&&(a=la(this,a,"div"),null==d?d=a.left:a.left=d,a=Te(this,a,e,c),!a.hitSide);++f);return a},moveV:L(function(a,
b){var c=this,d=this.doc,e=[],f=!c.display.shift&&!d.extend&&d.sel.somethingSelected();d.extendSelectionsBy(function(g){if(f)return 0>a?g.from():g.to();var k=la(c,g.head,"div");null!=g.goalColumn&&(k.left=g.goalColumn);e.push(k.left);var l=Te(c,k,a,b);"page"==b&&g==d.sel.primary()&&kc(c,null,Vb(c,l,"div").top-k.top);return l},Eb);if(e.length)for(var g=0;g<d.sel.ranges.length;g++)d.sel.ranges[g].goalColumn=e[g]}),findWordAt:function(a){var b=t(this.doc,a.line).text,c=a.ch,d=a.ch;if(b){var e=this.getHelper(a,
"wordChars");(0>a.xRel||d==b.length)&&c?--c:++d;for(var f=b.charAt(c),f=nc(f,e)?function(a){return nc(a,e)}:/\s/.test(f)?function(a){return/\s/.test(a)}:function(a){return!/\s/.test(a)&&!nc(a)};0<c&&f(b.charAt(c-1));)--c;for(;d<b.length&&f(b.charAt(d));)++d}return new y(r(a.line,c),r(a.line,d))},toggleOverwrite:function(a){if(null==a||a!=this.state.overwrite)(this.state.overwrite=!this.state.overwrite)?kb(this.display.cursorDiv,"CodeMirror-overwrite"):ib(this.display.cursorDiv,"CodeMirror-overwrite"),
J(this,"overwriteToggle",this,this.state.overwrite)},hasFocus:function(){return this.display.input.getField()==fa()},isReadOnly:function(){return!(!this.options.readOnly&&!this.doc.cantEdit)},scrollTo:L(function(a,b){null==a&&null==b||lc(this);null!=a&&(this.curOp.scrollLeft=a);null!=b&&(this.curOp.scrollTop=b)}),getScrollInfo:function(){var a=this.display.scroller;return{left:a.scrollLeft,top:a.scrollTop,height:a.scrollHeight-da(this)-this.display.barHeight,width:a.scrollWidth-da(this)-this.display.barWidth,
clientHeight:Oc(this),clientWidth:za(this)}},scrollIntoView:L(function(a,b){null==a?(a={from:this.doc.sel.primary().head,to:null},null==b&&(b=this.options.cursorScrollMargin)):"number"==typeof a?a={from:r(a,0),to:null}:null==a.from&&(a={from:a,to:null});a.to||(a.to=a.from);a.margin=b||0;if(null!=a.from.line)lc(this),this.curOp.scrollToPos=a;else{var c=ac(this,Math.min(a.from.left,a.to.left),Math.min(a.from.top,a.to.top)-a.margin,Math.max(a.from.right,a.to.right),Math.max(a.from.bottom,a.to.bottom)+
a.margin);this.scrollTo(c.scrollLeft,c.scrollTop)}}),setSize:L(function(a,b){function c(a){return"number"==typeof a||/^\d+$/.test(String(a))?a+"px":a}var d=this;null!=a&&(d.display.wrapper.style.width=c(a));null!=b&&(d.display.wrapper.style.height=c(b));d.options.lineWrapping&&re(this);var e=d.display.viewFrom;d.doc.iter(e,d.display.viewTo,function(a){if(a.widgets)for(var b=0;b<a.widgets.length;b++)if(a.widgets[b].noHScroll){ma(d,e,"widget");break}++e});d.curOp.forceUpdate=!0;J(d,"refresh",this)}),
operation:function(a){return T(this,a)},refresh:L(function(){var a=this.display.cachedTextHeight;M(this);this.curOp.forceUpdate=!0;fb(this);this.scrollTo(this.doc.scrollLeft,this.doc.scrollTop);Dc(this);(null==a||.5<Math.abs(a-va(this.display)))&&Bc(this);J(this,"refresh",this)}),swapDoc:L(function(a){var b=this.doc;b.cm=null;Dd(this,a);fb(this);this.display.input.reset();this.scrollTo(a.scrollLeft,a.scrollTop);this.curOp.forceScroll=!0;R(this,"swapDoc",this,b);return b}),getInputField:function(){return this.display.input.getField()},
getWrapperElement:function(){return this.display.wrapper},getScrollerElement:function(){return this.display.scroller},getGutterElement:function(){return this.display.gutters}};Ya(q);var wf=q.defaults={},Ka=q.optionHandlers={},Ed=q.Init={toString:function(){return"CodeMirror.Init"}};u("value","",function(a,b){a.setValue(b)},!0);u("mode",null,function(a,b){a.doc.modeOption=b;Ac(a)},!0);u("indentUnit",2,Ac,!0);u("indentWithTabs",!1);u("smartIndent",!0);u("tabSize",4,function(a){cb(a);fb(a);M(a)},!0);
u("lineSeparator",null,function(a,b){if(a.doc.lineSep=b){var c=[],d=a.doc.first;a.doc.iter(function(a){for(var e=0;;){var h=a.text.indexOf(b,e);if(-1==h)break;e=h+b.length;c.push(r(d,h))}d++});for(var e=c.length-1;0<=e;e--)Ua(a.doc,b,c[e],r(c[e].line,c[e].ch+b.length))}});u("specialChars",/[\u0000-\u001f\u007f\u00ad\u200b-\u200f\u2028\u2029\ufeff]/g,function(a,b,c){a.state.specialChars=new RegExp(b.source+(b.test("\t")?"":"|\t"),"g");c!=q.Init&&a.refresh()});u("specialCharPlaceholder",function(a){var b=
s("span","•","cm-invalidchar");b.title="\\u"+a.charCodeAt(0).toString(16);b.setAttribute("aria-label",b.title);return b},function(a){a.refresh()},!0);u("electricChars",!0);u("inputStyle",ab?"contenteditable":"textarea",function(){throw Error("inputStyle can not (yet) be changed in a running editor");},!0);u("spellcheck",!1,function(a,b){a.getInputField().spellcheck=b},!0);u("rtlMoveVisually",!ug);u("wholeLineUpdateBefore",!0);u("theme","default",function(a){Ad(a);gb(a)},!0);u("keyMap","default",function(a,
b,c){b=oc(b);(c=c!=q.Init&&oc(c))&&c.detach&&c.detach(a,b);b.attach&&b.attach(a,c||null)});u("extraKeys",null);u("lineWrapping",!1,function(a){a.options.lineWrapping?(kb(a.display.wrapper,"CodeMirror-wrap"),a.display.sizer.style.minWidth="",a.display.sizerWidth=null):(ib(a.display.wrapper,"CodeMirror-wrap"),Ec(a));Bc(a);M(a);fb(a);setTimeout(function(){Na(a)},100)},!0);u("gutters",[],function(a){wc(a.options);gb(a)},!0);u("fixedGutter",!0,function(a,b){a.display.gutters.style.left=b?Jc(a.display)+
"px":"0";a.refresh()},!0);u("coverGutterNextToScrollbar",!1,function(a){Na(a)},!0);u("scrollbarStyle","native",function(a){Bd(a);Na(a);a.display.scrollbars.setScrollTop(a.doc.scrollTop);a.display.scrollbars.setScrollLeft(a.doc.scrollLeft)},!0);u("lineNumbers",!1,function(a){wc(a.options);gb(a)},!0);u("firstLineNumber",1,gb,!0);u("lineNumberFormatter",function(a){return a},gb,!0);u("showCursorWhenSelecting",!1,lb,!0);u("resetSelectionOnContextMenu",!0);u("lineWiseCopyCut",!0);u("readOnly",!1,function(a,
b){"nocursor"==b?(bb(a),a.display.input.blur(),a.display.disabled=!0):a.display.disabled=!1;a.display.input.readOnlyChanged(b)});u("disableInput",!1,function(a,b){b||a.display.input.reset()},!0);u("dragDrop",!0,function(a,b,c){!b!=!(c&&c!=q.Init)&&(c=a.display.dragFunctions,b=b?v:ja,b(a.display.scroller,"dragstart",c.start),b(a.display.scroller,"dragenter",c.enter),b(a.display.scroller,"dragover",c.over),b(a.display.scroller,"dragleave",c.leave),b(a.display.scroller,"drop",c.drop))});u("allowDropFileTypes",
null);u("cursorBlinkRate",530);u("cursorScrollMargin",0);u("cursorHeight",1,lb,!0);u("singleCursorHeightPerLine",!0,lb,!0);u("workTime",100);u("workDelay",100);u("flattenSpans",!0,cb,!0);u("addModeClass",!1,cb,!0);u("pollInterval",100);u("undoDepth",200,function(a,b){a.doc.history.undoDepth=b});u("historyEventDelay",1250);u("viewportMargin",10,function(a){a.refresh()},!0);u("maxHighlightLength",1E4,cb,!0);u("moveInputWithCursor",!0,function(a,b){b||a.display.input.resetPosition()});u("tabindex",null,
function(a,b){a.display.input.getField().tabIndex=b||""});u("autofocus",null);var vf=q.modes={},Fb=q.mimeModes={};q.defineMode=function(a,b){q.defaults.mode||"null"==a||(q.defaults.mode=a);2<arguments.length&&(b.dependencies=Array.prototype.slice.call(arguments,2));vf[a]=b};q.defineMIME=function(a,b){Fb[a]=b};q.resolveMode=function(a){if("string"==typeof a&&Fb.hasOwnProperty(a))a=Fb[a];else if(a&&"string"==typeof a.name&&Fb.hasOwnProperty(a.name)){var b=Fb[a.name];"string"==typeof b&&(b={name:b});
a=lf(b,a);a.name=b.name}else{if("string"==typeof a&&/^[\w\-]+\/[\w\-]+\+xml$/.test(a))return q.resolveMode("application/xml");if("string"==typeof a&&/^[\w\-]+\/[\w\-]+\+json$/.test(a))return q.resolveMode("application/json")}return"string"==typeof a?{name:a}:a||{name:"null"}};q.getMode=function(a,b){b=q.resolveMode(b);var c=vf[b.name];if(!c)return q.getMode(a,"text/plain");c=c(a,b);if(Gb.hasOwnProperty(b.name)){var d=Gb[b.name],e;for(e in d)d.hasOwnProperty(e)&&(c.hasOwnProperty(e)&&(c["_"+e]=c[e]),
c[e]=d[e])}c.name=b.name;b.helperType&&(c.helperType=b.helperType);if(b.modeProps)for(e in b.modeProps)c[e]=b.modeProps[e];return c};q.defineMode("null",function(){return{token:function(a){a.skipToEnd()}}});q.defineMIME("text/plain","null");var Gb=q.modeExtensions={};q.extendMode=function(a,b){var c=Gb.hasOwnProperty(a)?Gb[a]:Gb[a]={};X(b,c)};q.defineExtension=function(a,b){q.prototype[a]=b};q.defineDocExtension=function(a,b){Q.prototype[a]=b};q.defineOption=u;var zc=[];q.defineInitHook=function(a){zc.push(a)};
var $a=q.helpers={};q.registerHelper=function(a,b,c){$a.hasOwnProperty(a)||($a[a]=q[a]={_global:[]});$a[a][b]=c};q.registerGlobalHelper=function(a,b,c,d){q.registerHelper(a,b,d);$a[a]._global.push({pred:c,val:d})};var sa=q.copyState=function(a,b){if(!0===b)return b;if(a.copyState)return a.copyState(b);var c={},d;for(d in b){var e=b[d];e instanceof Array&&(e=e.concat([]));c[d]=e}return c},Jf=q.startState=function(a,b,c){return a.startState?a.startState(b,c):!0};q.innerMode=function(a,b){for(;a.innerMode;){var c=
a.innerMode(b);if(!c||c.mode==a)break;b=c.state;a=c.mode}return c||{mode:a,state:b}};var hc=q.commands={selectAll:function(a){a.setSelection(r(a.firstLine(),0),r(a.lastLine()),ha)},singleSelection:function(a){a.setSelection(a.getCursor("anchor"),a.getCursor("head"),ha)},killLine:function(a){Va(a,function(b){if(b.empty()){var c=t(a.doc,b.head.line).text.length;return b.head.ch==c&&b.head.line<a.lastLine()?{from:b.head,to:r(b.head.line+1,0)}:{from:b.head,to:r(b.head.line,c)}}return{from:b.from(),to:b.to()}})},
deleteLine:function(a){Va(a,function(b){return{from:r(b.from().line,0),to:x(a.doc,r(b.to().line+1,0))}})},delLineLeft:function(a){Va(a,function(a){return{from:r(a.from().line,0),to:a.from()}})},delWrappedLineLeft:function(a){Va(a,function(b){var c=a.charCoords(b.head,"div").top+5;return{from:a.coordsChar({left:0,top:c},"div"),to:b.from()}})},delWrappedLineRight:function(a){Va(a,function(b){var c=a.charCoords(b.head,"div").top+5,c=a.coordsChar({left:a.display.lineDiv.offsetWidth+100,top:c},"div");
return{from:b.from(),to:c}})},undo:function(a){a.undo()},redo:function(a){a.redo()},undoSelection:function(a){a.undoSelection()},redoSelection:function(a){a.redoSelection()},goDocStart:function(a){a.extendSelection(r(a.firstLine(),0))},goDocEnd:function(a){a.extendSelection(r(a.lastLine()))},goLineStart:function(a){a.extendSelectionsBy(function(b){return pf(a,b.head.line)},{origin:"+move",bias:1})},goLineStartSmart:function(a){a.extendSelectionsBy(function(b){return qf(a,b.head)},{origin:"+move",
bias:1})},goLineEnd:function(a){a.extendSelectionsBy(function(b){b=b.head.line;for(var c,d=t(a.doc,b);c=xa(d,!1);)d=c.find(1,!0).line,b=null;c=(c=Z(d))?c[0].level%2?Zb(d):$b(d):d.text.length;return r(null==b?F(d):b,c)},{origin:"+move",bias:-1})},goLineRight:function(a){a.extendSelectionsBy(function(b){b=a.charCoords(b.head,"div").top+5;return a.coordsChar({left:a.display.lineDiv.offsetWidth+100,top:b},"div")},Eb)},goLineLeft:function(a){a.extendSelectionsBy(function(b){b=a.charCoords(b.head,"div").top+
5;return a.coordsChar({left:0,top:b},"div")},Eb)},goLineLeftSmart:function(a){a.extendSelectionsBy(function(b){var c=a.charCoords(b.head,"div").top+5,c=a.coordsChar({left:0,top:c},"div");return c.ch<a.getLine(c.line).search(/\S/)?qf(a,b.head):c},Eb)},goLineUp:function(a){a.moveV(-1,"line")},goLineDown:function(a){a.moveV(1,"line")},goPageUp:function(a){a.moveV(-1,"page")},goPageDown:function(a){a.moveV(1,"page")},goCharLeft:function(a){a.moveH(-1,"char")},goCharRight:function(a){a.moveH(1,"char")},
goColumnLeft:function(a){a.moveH(-1,"column")},goColumnRight:function(a){a.moveH(1,"column")},goWordLeft:function(a){a.moveH(-1,"word")},goGroupRight:function(a){a.moveH(1,"group")},goGroupLeft:function(a){a.moveH(-1,"group")},goWordRight:function(a){a.moveH(1,"word")},delCharBefore:function(a){a.deleteH(-1,"char")},delCharAfter:function(a){a.deleteH(1,"char")},delWordBefore:function(a){a.deleteH(-1,"word")},delWordAfter:function(a){a.deleteH(1,"word")},delGroupBefore:function(a){a.deleteH(-1,"group")},
delGroupAfter:function(a){a.deleteH(1,"group")},indentAuto:function(a){a.indentSelection("smart")},indentMore:function(a){a.indentSelection("add")},indentLess:function(a){a.indentSelection("subtract")},insertTab:function(a){a.replaceSelection("\t")},insertSoftTab:function(a){for(var b=[],c=a.listSelections(),d=a.options.tabSize,e=0;e<c.length;e++){var f=c[e].from(),f=aa(a.getLine(f.line),f.ch,d);b.push(pd(d-f%d))}a.replaceSelections(b)},defaultTab:function(a){a.somethingSelected()?a.indentSelection("add"):
a.execCommand("insertTab")},transposeChars:function(a){T(a,function(){for(var b=a.listSelections(),c=[],d=0;d<b.length;d++){var e=b[d].head,f=t(a.doc,e.line).text;if(f)if(e.ch==f.length&&(e=new r(e.line,e.ch-1)),0<e.ch)e=new r(e.line,e.ch+1),a.replaceRange(f.charAt(e.ch-1)+f.charAt(e.ch-2),r(e.line,e.ch-2),e,"+transpose");else if(e.line>a.doc.first){var g=t(a.doc,e.line-1).text;g&&a.replaceRange(f.charAt(0)+a.doc.lineSeparator()+g.charAt(g.length-1),r(e.line-1,g.length-1),r(e.line,1),"+transpose")}c.push(new y(e,
e))}a.setSelections(c)})},newlineAndIndent:function(a){T(a,function(){for(var b=a.listSelections().length,c=0;c<b;c++){var d=a.listSelections()[c];a.replaceRange(a.doc.lineSeparator(),d.anchor,d.head,"+input");a.indentLine(d.from().line+1,null,!0)}Pa(a)})},openLine:function(a){a.replaceSelection("\n","start")},toggleOverwrite:function(a){a.toggleOverwrite()}},ta=q.keyMap={};ta.basic={Left:"goCharLeft",Right:"goCharRight",Up:"goLineUp",Down:"goLineDown",End:"goLineEnd",Home:"goLineStartSmart",PageUp:"goPageUp",
PageDown:"goPageDown",Delete:"delCharAfter",Backspace:"delCharBefore","Shift-Backspace":"delCharBefore",Tab:"defaultTab","Shift-Tab":"indentAuto",Enter:"newlineAndIndent",Insert:"toggleOverwrite",Esc:"singleSelection"};ta.pcDefault={"Ctrl-A":"selectAll","Ctrl-D":"deleteLine","Ctrl-Z":"undo","Shift-Ctrl-Z":"redo","Ctrl-Y":"redo","Ctrl-Home":"goDocStart","Ctrl-End":"goDocEnd","Ctrl-Up":"goLineUp","Ctrl-Down":"goLineDown","Ctrl-Left":"goGroupLeft","Ctrl-Right":"goGroupRight","Alt-Left":"goLineStart",
"Alt-Right":"goLineEnd","Ctrl-Backspace":"delGroupBefore","Ctrl-Delete":"delGroupAfter","Ctrl-S":"save","Ctrl-F":"find","Ctrl-G":"findNext","Shift-Ctrl-G":"findPrev","Shift-Ctrl-F":"replace","Shift-Ctrl-R":"replaceAll","Ctrl-[":"indentLess","Ctrl-]":"indentMore","Ctrl-U":"undoSelection","Shift-Ctrl-U":"redoSelection","Alt-U":"redoSelection",fallthrough:"basic"};ta.emacsy={"Ctrl-F":"goCharRight","Ctrl-B":"goCharLeft","Ctrl-P":"goLineUp","Ctrl-N":"goLineDown","Alt-F":"goWordRight","Alt-B":"goWordLeft",
"Ctrl-A":"goLineStart","Ctrl-E":"goLineEnd","Ctrl-V":"goPageDown","Shift-Ctrl-V":"goPageUp","Ctrl-D":"delCharAfter","Ctrl-H":"delCharBefore","Alt-D":"delWordAfter","Alt-Backspace":"delWordBefore","Ctrl-K":"killLine","Ctrl-T":"transposeChars","Ctrl-O":"openLine"};ta.macDefault={"Cmd-A":"selectAll","Cmd-D":"deleteLine","Cmd-Z":"undo","Shift-Cmd-Z":"redo","Cmd-Y":"redo","Cmd-Home":"goDocStart","Cmd-Up":"goDocStart","Cmd-End":"goDocEnd","Cmd-Down":"goDocEnd","Alt-Left":"goGroupLeft","Alt-Right":"goGroupRight",
"Cmd-Left":"goLineLeft","Cmd-Right":"goLineRight","Alt-Backspace":"delGroupBefore","Ctrl-Alt-Backspace":"delGroupAfter","Alt-Delete":"delGroupAfter","Cmd-S":"save","Cmd-F":"find","Cmd-G":"findNext","Shift-Cmd-G":"findPrev","Cmd-Alt-F":"replace","Shift-Cmd-Alt-F":"replaceAll","Cmd-[":"indentLess","Cmd-]":"indentMore","Cmd-Backspace":"delWrappedLineLeft","Cmd-Delete":"delWrappedLineRight","Cmd-U":"undoSelection","Shift-Cmd-U":"redoSelection","Ctrl-Up":"goDocStart","Ctrl-Down":"goDocEnd",fallthrough:["basic",
"emacsy"]};ta["default"]=Y?ta.macDefault:ta.pcDefault;q.normalizeKeyMap=function(a){var b={},c;for(c in a)if(a.hasOwnProperty(c)){var d=a[c];if(!/^(name|fallthrough|(de|at)tach)$/.test(c)){if("..."!=d)for(var e=Pb(c.split(" "),dg),f=0;f<e.length;f++){var g,h;f==e.length-1?(h=e.join(" "),g=d):(h=e.slice(0,f+1).join(" "),g="...");var k=b[h];if(!k)b[h]=g;else if(k!=g)throw Error("Inconsistent bindings for "+h);}delete a[c]}}for(var l in b)a[l]=b[l];return a};var vb=q.lookupKey=function(a,b,c,d){b=oc(b);
var e=b.call?b.call(a,d):b[a];if(!1===e)return"nothing";if("..."===e)return"multi";if(null!=e&&c(e))return"handled";if(b.fallthrough){if("[object Array]"!=Object.prototype.toString.call(b.fallthrough))return vb(a,b.fallthrough,c,d);for(e=0;e<b.fallthrough.length;e++){var f=vb(a,b.fallthrough[e],c,d);if(f)return f}}},Xf=q.isModifierKey=function(a){a="string"==typeof a?a:Ia[a.keyCode];return"Ctrl"==a||"Alt"==a||"Shift"==a||"Mod"==a},Zf=q.keyName=function(a,b){if(ba&&34==a.keyCode&&a["char"])return!1;
var c=Ia[a.keyCode],d=c;if(null==d||a.altGraphKey)return!1;a.altKey&&"Alt"!=c&&(d="Alt-"+d);(uf?a.metaKey:a.ctrlKey)&&"Ctrl"!=c&&(d="Ctrl-"+d);(uf?a.ctrlKey:a.metaKey)&&"Cmd"!=c&&(d="Cmd-"+d);!b&&a.shiftKey&&"Shift"!=c&&(d="Shift-"+d);return d};q.fromTextArea=function(a,b){function c(){a.value=k.getValue()}b=b?X(b):{};b.value=a.value;!b.tabindex&&a.tabIndex&&(b.tabindex=a.tabIndex);!b.placeholder&&a.placeholder&&(b.placeholder=a.placeholder);if(null==b.autofocus){var d=fa();b.autofocus=d==a||null!=
a.getAttribute("autofocus")&&d==document.body}if(a.form&&(v(a.form,"submit",c),!b.leaveSubmitMethodAlone)){var e=a.form,f=e.submit;try{var g=e.submit=function(){c();e.submit=f;e.submit();e.submit=g}}catch(h){}}b.finishInit=function(b){b.save=c;b.getTextArea=function(){return a};b.toTextArea=function(){b.toTextArea=isNaN;c();a.parentNode.removeChild(b.getWrapperElement());a.style.display="";a.form&&(ja(a.form,"submit",c),"function"==typeof a.form.submit&&(a.form.submit=f))}};a.style.display="none";
var k=q(function(b){a.parentNode.insertBefore(b,a.nextSibling)},b);return k};var sc=q.StringStream=function(a,b){this.pos=this.start=0;this.string=a;this.tabSize=b||8;this.lineStart=this.lastColumnPos=this.lastColumnValue=0};sc.prototype={eol:function(){return this.pos>=this.string.length},sol:function(){return this.pos==this.lineStart},peek:function(){return this.string.charAt(this.pos)||void 0},next:function(){if(this.pos<this.string.length)return this.string.charAt(this.pos++)},eat:function(a){var b=
this.string.charAt(this.pos);if("string"==typeof a?b==a:b&&(a.test?a.test(b):a(b)))return++this.pos,b},eatWhile:function(a){for(var b=this.pos;this.eat(a););return this.pos>b},eatSpace:function(){for(var a=this.pos;/[\s\u00a0]/.test(this.string.charAt(this.pos));)++this.pos;return this.pos>a},skipToEnd:function(){this.pos=this.string.length},skipTo:function(a){a=this.string.indexOf(a,this.pos);if(-1<a)return this.pos=a,!0},backUp:function(a){this.pos-=a},column:function(){this.lastColumnPos<this.start&&
(this.lastColumnValue=aa(this.string,this.start,this.tabSize,this.lastColumnPos,this.lastColumnValue),this.lastColumnPos=this.start);return this.lastColumnValue-(this.lineStart?aa(this.string,this.lineStart,this.tabSize):0)},indentation:function(){return aa(this.string,null,this.tabSize)-(this.lineStart?aa(this.string,this.lineStart,this.tabSize):0)},match:function(a,b,c){if("string"==typeof a){var d=function(a){return c?a.toLowerCase():a},e=this.string.substr(this.pos,a.length);if(d(e)==d(a))return!1!==
b&&(this.pos+=a.length),!0}else{if((a=this.string.slice(this.pos).match(a))&&0<a.index)return null;a&&!1!==b&&(this.pos+=a[0].length);return a}},current:function(){return this.string.slice(this.start,this.pos)},hideFirstChars:function(a,b){this.lineStart+=a;try{return b()}finally{this.lineStart-=a}}};var rd=0,Ga=q.TextMarker=function(a,b){this.lines=[];this.type=b;this.doc=a;this.id=++rd};Ya(Ga);Ga.prototype.clear=function(){if(!this.explicitlyCleared){var a=this.doc.cm,b=a&&!a.curOp;b&&Ja(a);if(W(this,
"clear")){var c=this.find();c&&R(this,"clear",c.from,c.to)}for(var d=c=null,e=0;e<this.lines.length;++e){var f=this.lines[e],g=xb(f.markedSpans,this);a&&!this.collapsed?ma(a,F(f),"text"):a&&(null!=g.to&&(d=F(f)),null!=g.from&&(c=F(f)));for(var h=f,k=f.markedSpans,l=g,m=void 0,p=0;p<k.length;++p)k[p]!=l&&(m||(m=[])).push(k[p]);h.markedSpans=m;null==g.from&&this.collapsed&&!wa(this.doc,f)&&a&&ca(f,va(a.display))}if(a&&this.collapsed&&!a.options.lineWrapping)for(e=0;e<this.lines.length;++e)f=ia(this.lines[e]),
g=Ib(f),g>a.display.maxLineLength&&(a.display.maxLine=f,a.display.maxLineLength=g,a.display.maxLineChanged=!0);null!=c&&a&&this.collapsed&&M(a,c,d+1);this.lines.length=0;this.explicitlyCleared=!0;this.atomic&&this.doc.cantEdit&&(this.doc.cantEdit=!1,a&&ie(a.doc));a&&R(a,"markerCleared",a,this);b&&La(a);this.parent&&this.parent.clear()}};Ga.prototype.find=function(a,b){null==a&&"bookmark"==this.type&&(a=1);for(var c,d,e=0;e<this.lines.length;++e){var f=this.lines[e],g=xb(f.markedSpans,this);if(null!=
g.from&&(c=r(b?f:F(f),g.from),-1==a))return c;if(null!=g.to&&(d=r(b?f:F(f),g.to),1==a))return d}return c&&{from:c,to:d}};Ga.prototype.changed=function(){var a=this.find(-1,!0),b=this,c=this.doc.cm;a&&c&&T(c,function(){var d=a.line,e=F(a.line);if(e=Vc(c,e))qe(e),c.curOp.selectionChanged=c.curOp.forceUpdate=!0;c.curOp.updateMaxLine=!0;wa(b.doc,d)||null==b.height||(e=b.height,b.height=null,(e=tb(b)-e)&&ca(d,d.height+e))})};Ga.prototype.attachLine=function(a){if(!this.lines.length&&this.doc.cm){var b=
this.doc.cm.curOp;b.maybeHiddenMarkers&&-1!=D(b.maybeHiddenMarkers,this)||(b.maybeUnhiddenMarkers||(b.maybeUnhiddenMarkers=[])).push(this)}this.lines.push(a)};Ga.prototype.detachLine=function(a){this.lines.splice(D(this.lines,a),1);!this.lines.length&&this.doc.cm&&(a=this.doc.cm.curOp,(a.maybeHiddenMarkers||(a.maybeHiddenMarkers=[])).push(this))};var rd=0,qc=q.SharedTextMarker=function(a,b){this.markers=a;this.primary=b;for(var c=0;c<a.length;++c)a[c].parent=this};Ya(qc);qc.prototype.clear=function(){if(!this.explicitlyCleared){this.explicitlyCleared=
!0;for(var a=0;a<this.markers.length;++a)this.markers[a].clear();R(this,"clear")}};qc.prototype.find=function(a,b){return this.primary.find(a,b)};var rc=q.LineWidget=function(a,b,c){if(c)for(var d in c)c.hasOwnProperty(d)&&(this[d]=c[d]);this.doc=a;this.node=b};Ya(rc);rc.prototype.clear=function(){var a=this.doc.cm,b=this.line.widgets,c=this.line,d=F(c);if(null!=d&&b){for(var e=0;e<b.length;++e)b[e]==this&&b.splice(e--,1);b.length||(c.widgets=null);var f=tb(this);ca(c,Math.max(0,c.height-f));a&&T(a,
function(){var b=-f;ea(c)<(a.curOp&&a.curOp.scrollTop||a.doc.scrollTop)&&kc(a,null,b);ma(a,d,"widget")})}};rc.prototype.changed=function(){var a=this.height,b=this.doc.cm,c=this.line;this.height=null;var d=tb(this)-a;d&&(ca(c,c.height+d),b&&T(b,function(){b.curOp.forceUpdate=!0;ea(c)<(b.curOp&&b.curOp.scrollTop||b.doc.scrollTop)&&kc(b,null,d)}))};var yb=q.Line=function(a,b,c){this.text=a;Ye(this,b);this.height=c?c(this):1};Ya(yb);yb.prototype.lineNo=function(){return F(this)};var jg={},ig={};zb.prototype=
{chunkSize:function(){return this.lines.length},removeInner:function(a,b){for(var c=a,d=a+b;c<d;++c){var e=this.lines[c];this.height-=e.height;var f=e;f.parent=null;Xe(f);R(e,"delete")}this.lines.splice(a,b)},collapse:function(a){a.push.apply(a,this.lines)},insertInner:function(a,b,c){this.height+=c;this.lines=this.lines.slice(0,a).concat(b).concat(this.lines.slice(a));for(a=0;a<b.length;++a)b[a].parent=this},iterN:function(a,b,c){for(b=a+b;a<b;++a)if(c(this.lines[a]))return!0}};Ab.prototype={chunkSize:function(){return this.size},
removeInner:function(a,b){this.size-=b;for(var c=0;c<this.children.length;++c){var d=this.children[c],e=d.chunkSize();if(a<e){var f=Math.min(b,e-a),g=d.height;d.removeInner(a,f);this.height-=g-d.height;e==f&&(this.children.splice(c--,1),d.parent=null);if(0==(b-=f))break;a=0}else a-=e}25>this.size-b&&(1<this.children.length||!(this.children[0]instanceof zb))&&(c=[],this.collapse(c),this.children=[new zb(c)],this.children[0].parent=this)},collapse:function(a){for(var b=0;b<this.children.length;++b)this.children[b].collapse(a)},
insertInner:function(a,b,c){this.size+=b.length;this.height+=c;for(var d=0;d<this.children.length;++d){var e=this.children[d],f=e.chunkSize();if(a<=f){e.insertInner(a,b,c);if(e.lines&&50<e.lines.length){for(b=a=e.lines.length%25+25;b<e.lines.length;)c=new zb(e.lines.slice(b,b+=25)),e.height-=c.height,this.children.splice(++d,0,c),c.parent=this;e.lines=e.lines.slice(0,a);this.maybeSpill()}break}a-=f}},maybeSpill:function(){if(!(10>=this.children.length)){var a=this;do{var b=a.children.splice(a.children.length-
5,5),b=new Ab(b);if(a.parent){a.size-=b.size;a.height-=b.height;var c=D(a.parent.children,a);a.parent.children.splice(c+1,0,b)}else c=new Ab(a.children),c.parent=a,a.children=[c,b],a=c;b.parent=a.parent}while(10<a.children.length);a.parent.maybeSpill()}},iterN:function(a,b,c){for(var d=0;d<this.children.length;++d){var e=this.children[d],f=e.chunkSize();if(a<f){f=Math.min(b,f-a);if(e.iterN(a,f,c))return!0;if(0==(b-=f))break;a=0}else a-=f}}};var wg=0,Q=q.Doc=function(a,b,c,d){if(!(this instanceof Q))return new Q(a,
b,c,d);null==c&&(c=0);Ab.call(this,[new zb([new yb("",null)])]);this.first=c;this.scrollTop=this.scrollLeft=0;this.cantEdit=!1;this.cleanGeneration=1;this.frontier=c;c=r(c,0);this.sel=ga(c);this.history=new tc(null);this.id=++wg;this.modeOption=b;this.lineSep=d;this.extend=!1;"string"==typeof a&&(a=this.splitLines(a));od(this,{from:c,to:c,text:a});C(this,ga(c),ha)};Q.prototype=lf(Ab.prototype,{constructor:Q,iter:function(a,b,c){c?this.iterN(a-this.first,b-a,c):this.iterN(this.first,this.first+this.size,
a)},insert:function(a,b){for(var c=0,d=0;d<b.length;++d)c+=b[d].height;this.insertInner(a-this.first,b,c)},remove:function(a,b){this.removeInner(a-this.first,b)},getValue:function(a){var b=wd(this,this.first,this.first+this.size);return!1===a?b:b.join(a||this.lineSeparator())},setValue:N(function(a){var b=r(this.first,0),c=this.first+this.size-1;Oa(this,{from:b,to:r(c,t(this,c).text.length),text:this.splitLines(a),origin:"setValue",full:!0},!0);C(this,ga(b))}),replaceRange:function(a,b,c,d){b=x(this,
b);c=c?x(this,c):b;Ua(this,a,b,c,d)},getRange:function(a,b,c){a=Ba(this,x(this,a),x(this,b));return!1===c?a:a.join(c||this.lineSeparator())},getLine:function(a){return(a=this.getLineHandle(a))&&a.text},getLineHandle:function(a){if(pb(this,a))return t(this,a)},getLineNumber:function(a){return F(a)},getLineHandleVisualStart:function(a){"number"==typeof a&&(a=t(this,a));return ia(a)},lineCount:function(){return this.size},firstLine:function(){return this.first},lastLine:function(){return this.first+
this.size-1},clipPos:function(a){return x(this,a)},getCursor:function(a){var b=this.sel.primary();return null==a||"head"==a?b.head:"anchor"==a?b.anchor:"end"==a||"to"==a||!1===a?b.to():b.from()},listSelections:function(){return this.sel.ranges},somethingSelected:function(){return this.sel.somethingSelected()},setCursor:N(function(a,b,c){a=x(this,"number"==typeof a?r(a,b||0):a);C(this,ga(a,null),c)}),setSelection:N(function(a,b,c){var d=x(this,a);a=x(this,b||a);C(this,ga(d,a),c)}),extendSelection:N(function(a,
b,c){Sb(this,x(this,a),b&&x(this,b),c)}),extendSelections:N(function(a,b){ce(this,be(this,a),b)}),extendSelectionsBy:N(function(a,b){var c=Pb(this.sel.ranges,a);ce(this,be(this,c),b)}),setSelections:N(function(a,b,c){if(a.length){for(var d=0,e=[];d<a.length;d++)e[d]=new y(x(this,a[d].anchor),x(this,a[d].head));null==b&&(b=Math.min(a.length-1,this.sel.primIndex));C(this,$(e,b),c)}}),addSelection:N(function(a,b,c){var d=this.sel.ranges.slice(0);d.push(new y(x(this,a),x(this,b||a)));C(this,$(d,d.length-
1),c)}),getSelection:function(a){for(var b=this.sel.ranges,c,d=0;d<b.length;d++){var e=Ba(this,b[d].from(),b[d].to());c=c?c.concat(e):e}return!1===a?c:c.join(a||this.lineSeparator())},getSelections:function(a){for(var b=[],c=this.sel.ranges,d=0;d<c.length;d++){var e=Ba(this,c[d].from(),c[d].to());!1!==a&&(e=e.join(a||this.lineSeparator()));b[d]=e}return b},replaceSelection:function(a,b,c){for(var d=[],e=0;e<this.sel.ranges.length;e++)d[e]=a;this.replaceSelections(d,b,c||"+input")},replaceSelections:N(function(a,
b,c){for(var d=[],e=this.sel,f=0;f<e.ranges.length;f++){var g=e.ranges[f];d[f]={from:g.from(),to:g.to(),text:this.splitLines(a[f]),origin:c}}if(f=b&&"end"!=b){f=[];c=a=r(this.first,0);for(e=0;e<d.length;e++){var h=d[e],g=Je(h.from,a,c),k=Je(Ea(h),a,c);a=h.to;c=k;"around"==b?(h=this.sel.ranges[e],h=0>w(h.head,h.anchor),f[e]=new y(h?k:g,h?g:k)):f[e]=new y(g,g)}f=new ka(f,this.sel.primIndex)}b=f;for(f=d.length-1;0<=f;f--)Oa(this,d[f]);b?de(this,b):this.cm&&Pa(this.cm)}),undo:N(function(){jc(this,"undo")}),
redo:N(function(){jc(this,"redo")}),undoSelection:N(function(){jc(this,"undo",!0)}),redoSelection:N(function(){jc(this,"redo",!0)}),setExtending:function(a){this.extend=a},getExtending:function(){return this.extend},historySize:function(){for(var a=this.history,b=0,c=0,d=0;d<a.done.length;d++)a.done[d].ranges||++b;for(d=0;d<a.undone.length;d++)a.undone[d].ranges||++c;return{undo:b,redo:c}},clearHistory:function(){this.history=new tc(this.history.maxGeneration)},markClean:function(){this.cleanGeneration=
this.changeGeneration(!0)},changeGeneration:function(a){a&&(this.history.lastOp=this.history.lastSelOp=this.history.lastOrigin=null);return this.history.generation},isClean:function(a){return this.history.generation==(a||this.cleanGeneration)},getHistory:function(){return{done:Xa(this.history.done),undone:Xa(this.history.undone)}},setHistory:function(a){var b=this.history=new tc(this.history.maxGeneration);b.done=Xa(a.done.slice(0),null,!0);b.undone=Xa(a.undone.slice(0),null,!0)},addLineClass:N(function(a,
b,c){return mc(this,a,"gutter"==b?"gutter":"class",function(a){var e="text"==b?"textClass":"background"==b?"bgClass":"gutter"==b?"gutterClass":"wrapClass";if(a[e]){if(Db(c).test(a[e]))return!1;a[e]+=" "+c}else a[e]=c;return!0})}),removeLineClass:N(function(a,b,c){return mc(this,a,"gutter"==b?"gutter":"class",function(a){var e="text"==b?"textClass":"background"==b?"bgClass":"gutter"==b?"gutterClass":"wrapClass",f=a[e];if(f)if(null==c)a[e]=null;else{var g=f.match(Db(c));if(!g)return!1;var h=g.index+
g[0].length;a[e]=f.slice(0,g.index)+(g.index&&h!=f.length?" ":"")+f.slice(h)||null}else return!1;return!0})}),addLineWidget:N(function(a,b,c){return hg(this,a,b,c)}),removeLineWidget:function(a){a.clear()},markText:function(a,b,c){return Wa(this,x(this,a),x(this,b),c,c&&c.type||"range")},setBookmark:function(a,b){var c={replacedWith:b&&(null==b.nodeType?b.widget:b),insertLeft:b&&b.insertLeft,clearWhenEmpty:!1,shared:b&&b.shared,handleMouseEvents:b&&b.handleMouseEvents};a=x(this,a);return Wa(this,
a,a,c,"bookmark")},findMarksAt:function(a){a=x(this,a);var b=[],c=t(this,a.line).markedSpans;if(c)for(var d=0;d<c.length;++d){var e=c[d];(null==e.from||e.from<=a.ch)&&(null==e.to||e.to>=a.ch)&&b.push(e.marker.parent||e.marker)}return b},findMarks:function(a,b,c){a=x(this,a);b=x(this,b);var d=[],e=a.line;this.iter(a.line,b.line+1,function(f){if(f=f.markedSpans)for(var g=0;g<f.length;g++){var h=f[g];null!=h.to&&e==a.line&&a.ch>=h.to||null==h.from&&e!=a.line||null!=h.from&&e==b.line&&h.from>=b.ch||c&&
!c(h.marker)||d.push(h.marker.parent||h.marker)}++e});return d},getAllMarks:function(){var a=[];this.iter(function(b){if(b=b.markedSpans)for(var c=0;c<b.length;++c)null!=b[c].from&&a.push(b[c].marker)});return a},posFromIndex:function(a){var b,c=this.first,d=this.lineSeparator().length;this.iter(function(e){e=e.text.length+d;if(e>a)return b=a,!0;a-=e;++c});return x(this,r(c,b))},indexFromPos:function(a){a=x(this,a);var b=a.ch;if(a.line<this.first||0>a.ch)return 0;var c=this.lineSeparator().length;
this.iter(this.first,a.line,function(a){b+=a.text.length+c});return b},copy:function(a){var b=new Q(wd(this,this.first,this.first+this.size),this.modeOption,this.first,this.lineSep);b.scrollTop=this.scrollTop;b.scrollLeft=this.scrollLeft;b.sel=this.sel;b.extend=!1;a&&(b.history.undoDepth=this.history.undoDepth,b.setHistory(this.getHistory()));return b},linkedDoc:function(a){a||(a={});var b=this.first,c=this.first+this.size;null!=a.from&&a.from>b&&(b=a.from);null!=a.to&&a.to<c&&(c=a.to);b=new Q(wd(this,
b,c),a.mode||this.modeOption,b,this.lineSep);a.sharedHist&&(b.history=this.history);(this.linked||(this.linked=[])).push({doc:b,sharedHist:a.sharedHist});b.linked=[{doc:this,isParent:!0,sharedHist:a.sharedHist}];a=Ve(this);for(c=0;c<a.length;c++){var d=a[c],e=d.find(),f=b.clipPos(e.from),e=b.clipPos(e.to);w(f,e)&&(f=Wa(b,f,e,d.primary,d.primary.type),d.markers.push(f),f.parent=d)}return b},unlinkDoc:function(a){a instanceof q&&(a=a.doc);if(this.linked)for(var b=0;b<this.linked.length;++b)if(this.linked[b].doc==
a){this.linked.splice(b,1);a.unlinkDoc(this);fg(Ve(this));break}if(a.history==this.history){var c=[a.id];Fa(a,function(a){c.push(a.id)},!0);a.history=new tc(null);a.history.done=Xa(this.history.done,c);a.history.undone=Xa(this.history.undone,c)}},iterLinkedDocs:function(a){Fa(this,a)},getMode:function(){return this.mode},getEditor:function(){return this.cm},splitLines:function(a){return this.lineSep?a.split(this.lineSep):xg(a)},lineSeparator:function(){return this.lineSep||"\n"}});Q.prototype.eachLine=
Q.prototype.iter;var yg="iter insert remove copy getEditor constructor".split(" "),Hb;for(Hb in Q.prototype)Q.prototype.hasOwnProperty(Hb)&&0>D(yg,Hb)&&(q.prototype[Hb]=function(a){return function(){return a.apply(this.doc,arguments)}}(Q.prototype[Hb]));Ya(Q);var O=q.e_preventDefault=function(a){a.preventDefault?a.preventDefault():a.returnValue=!1},zg=q.e_stopPropagation=function(a){a.stopPropagation?a.stopPropagation():a.cancelBubble=!0},cc=q.e_stop=function(a){O(a);zg(a)},v=q.on=function(a,b,c){a.addEventListener?
a.addEventListener(b,c,!1):a.attachEvent?a.attachEvent("on"+b,c):(a=a._handlers||(a._handlers={}),(a[b]||(a[b]=[])).push(c))},kf=[],ja=q.off=function(a,b,c){if(a.removeEventListener)a.removeEventListener(b,c,!1);else if(a.detachEvent)a.detachEvent("on"+b,c);else for(a=uc(a,b,!1),b=0;b<a.length;++b)if(a[b]==c){a.splice(b,1);break}},J=q.signal=function(a,b){var c=uc(a,b,!0);if(c.length)for(var d=Array.prototype.slice.call(arguments,2),e=0;e<c.length;++e)c[e].apply(null,d)},Bb=null,Gd=30,Fe=q.Pass={toString:function(){return"CodeMirror.Pass"}},
ha={scroll:!1},id={origin:"*mouse"},Eb={origin:"+move"};ua.prototype.set=function(a,b){clearTimeout(this.id);this.id=setTimeout(b,a)};var aa=q.countColumn=function(a,b,c,d,e){null==b&&(b=a.search(/[^\s\u00a0]/),-1==b&&(b=a.length));d=d||0;for(e=e||0;;){var f=a.indexOf("\t",d);if(0>f||f>=b)return e+(b-d);e+=f-d;e+=c-e%c;d=f+1}},De=q.findColumn=function(a,b,c){for(var d=0,e=0;;){var f=a.indexOf("\t",d);-1==f&&(f=a.length);var g=f-d;if(f==a.length||e+g>=b)return d+Math.min(g,b-e);e+=f-d;e+=c-e%c;d=f+
1;if(e>=b)return d}},vc=[""],Za=function(a){a.select()};ob?Za=function(a){a.selectionStart=0;a.selectionEnd=a.value.length}:A&&(Za=function(a){try{a.select()}catch(b){}});var Ag=/[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/,mf=q.isWordChar=function(a){return/\w/.test(a)||""<a&&(a.toUpperCase()!=a.toLowerCase()||Ag.test(a))},qg=/[\u0300-\u036f\u0483-\u0489\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u065e\u0670\u06d6-\u06dc\u06de-\u06e4\u06e7\u06e8\u06ea-\u06ed\u0711\u0730-\u074a\u07a6-\u07b0\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0900-\u0902\u093c\u0941-\u0948\u094d\u0951-\u0955\u0962\u0963\u0981\u09bc\u09be\u09c1-\u09c4\u09cd\u09d7\u09e2\u09e3\u0a01\u0a02\u0a3c\u0a41\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a70\u0a71\u0a75\u0a81\u0a82\u0abc\u0ac1-\u0ac5\u0ac7\u0ac8\u0acd\u0ae2\u0ae3\u0b01\u0b3c\u0b3e\u0b3f\u0b41-\u0b44\u0b4d\u0b56\u0b57\u0b62\u0b63\u0b82\u0bbe\u0bc0\u0bcd\u0bd7\u0c3e-\u0c40\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0cbc\u0cbf\u0cc2\u0cc6\u0ccc\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0d3e\u0d41-\u0d44\u0d4d\u0d57\u0d62\u0d63\u0dca\u0dcf\u0dd2-\u0dd4\u0dd6\u0ddf\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0f18\u0f19\u0f35\u0f37\u0f39\u0f71-\u0f7e\u0f80-\u0f84\u0f86\u0f87\u0f90-\u0f97\u0f99-\u0fbc\u0fc6\u102d-\u1030\u1032-\u1037\u1039\u103a\u103d\u103e\u1058\u1059\u105e-\u1060\u1071-\u1074\u1082\u1085\u1086\u108d\u109d\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b7-\u17bd\u17c6\u17c9-\u17d3\u17dd\u180b-\u180d\u18a9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193b\u1a17\u1a18\u1a56\u1a58-\u1a5e\u1a60\u1a62\u1a65-\u1a6c\u1a73-\u1a7c\u1a7f\u1b00-\u1b03\u1b34\u1b36-\u1b3a\u1b3c\u1b42\u1b6b-\u1b73\u1b80\u1b81\u1ba2-\u1ba5\u1ba8\u1ba9\u1c2c-\u1c33\u1c36\u1c37\u1cd0-\u1cd2\u1cd4-\u1ce0\u1ce2-\u1ce8\u1ced\u1dc0-\u1de6\u1dfd-\u1dff\u200c\u200d\u20d0-\u20f0\u2cef-\u2cf1\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua66f-\ua672\ua67c\ua67d\ua6f0\ua6f1\ua802\ua806\ua80b\ua825\ua826\ua8c4\ua8e0-\ua8f1\ua926-\ua92d\ua947-\ua951\ua980-\ua982\ua9b3\ua9b6-\ua9b9\ua9bc\uaa29-\uaa2e\uaa31\uaa32\uaa35\uaa36\uaa43\uaa4c\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uabe5\uabe8\uabed\udc00-\udfff\ufb1e\ufe00-\ufe0f\ufe20-\ufe26\uff9e\uff9f]/,
Sa;Sa=document.createRange?function(a,b,c,d){var e=document.createRange();e.setEnd(d||a,c);e.setStart(a,b);return e}:function(a,b,c){var d=document.body.createTextRange();try{d.moveToElementText(a.parentNode)}catch(e){return d}d.collapse(!0);d.moveEnd("character",c);d.moveStart("character",b);return d};var Wc=q.contains=function(a,b){3==b.nodeType&&(b=b.parentNode);if(a.contains)return a.contains(b);do if(11==b.nodeType&&(b=b.host),b==a)return!0;while(b=b.parentNode)};A&&11>B&&(fa=function(){try{return document.activeElement}catch(a){return document.body}});
var ib=q.rmClass=function(a,b){var c=a.className,d=Db(b).exec(c);if(d){var e=c.slice(d.index+d[0].length);a.className=c.slice(0,d.index)+(e?d[1]+e:"")}},kb=q.addClass=function(a,b){var c=a.className;Db(b).test(c)||(a.className+=(c?" ":"")+b)},Cd=!1,Sf=function(){if(A&&9>B)return!1;var a=s("div");return"draggable"in a||"dragDrop"in a}(),xd,ud,xg=q.splitLines=3!="\n\nb".split(/\n/).length?function(a){for(var b=0,c=[],d=a.length;b<=d;){var e=a.indexOf("\n",b);-1==e&&(e=a.length);var f=a.slice(b,"\r"==
a.charAt(e-1)?e-1:e),g=f.indexOf("\r");-1!=g?(c.push(f.slice(0,g)),b+=g+1):(c.push(f),b=e+1)}return c}:function(a){return a.split(/\r\n?|\n/)},vg=window.getSelection?function(a){try{return a.selectionStart!=a.selectionEnd}catch(b){return!1}}:function(a){try{var b=a.ownerDocument.selection.createRange()}catch(c){}return b&&b.parentElement()==a?0!=b.compareEndPoints("StartToEnd",b):!1},He=function(){var a=s("div");if("oncopy"in a)return!0;a.setAttribute("oncopy","return;");return"function"==typeof a.oncopy}(),
ad=null,Ia=q.keyNames={3:"Enter",8:"Backspace",9:"Tab",13:"Enter",16:"Shift",17:"Ctrl",18:"Alt",19:"Pause",20:"CapsLock",27:"Esc",32:"Space",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"Left",38:"Up",39:"Right",40:"Down",44:"PrintScrn",45:"Insert",46:"Delete",59:";",61:"\x3d",91:"Mod",92:"Mod",93:"Mod",106:"*",107:"\x3d",109:"-",110:".",111:"/",127:"Delete",173:"-",186:";",187:"\x3d",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'",63232:"Up",63233:"Down",63234:"Left",
63235:"Right",63272:"Delete",63273:"Home",63275:"End",63276:"PageUp",63277:"PageDown",63302:"Insert"};(function(){for(var a=0;10>a;a++)Ia[a+48]=Ia[a+96]=String(a);for(a=65;90>=a;a++)Ia[a]=String.fromCharCode(a);for(a=1;12>=a;a++)Ia[a+111]=Ia[a+63235]="F"+a})();var ub,ng=function(){function a(a){return 247>=a?"bbbbbbbbbtstwsbbbbbbbbbbbbbbssstwNN%%%NNNNNN,N,N1111111111NNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNbbbbbbsbbbbbbbbbbbbbbbbbbbbbbbbbb,N%%%%NNNNLNNNNN%%11NLNNN1LNNNNNLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLN".charAt(a):
1424<=a&&1524>=a?"R":1536<=a&&1773>=a?"rrrrrrrrrrrr,rNNmmmmmmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmrrrrrrrnnnnnnnnnn%nnrrrmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmmmmmmNmmmm".charAt(a-1536):1774<=a&&2220>=a?"r":8192<=a&&8203>=a?"w":8204==a?"b":"L"}function b(a,b,c){this.level=a;this.from=b;this.to=c}var c=/[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/,d=/[stwN]/,e=/[LRr]/,f=/[Lb1n]/,g=/[1n]/;return function(h){if(!c.test(h))return!1;
for(var k=h.length,l=[],m=0,p;m<k;++m)l.push(a(h.charCodeAt(m)));for(var m=0,n="L";m<k;++m)p=l[m],"m"==p?l[m]=n:n=p;m=0;for(n="L";m<k;++m)p=l[m],"1"==p&&"r"==n?l[m]="n":e.test(p)&&(n=p,"r"==p&&(l[m]="R"));m=1;for(n=l[0];m<k-1;++m)p=l[m],"+"==p&&"1"==n&&"1"==l[m+1]?l[m]="1":","!=p||n!=l[m+1]||"1"!=n&&"n"!=n||(l[m]=n),n=p;for(m=0;m<k;++m)if(p=l[m],","==p)l[m]="N";else if("%"==p){for(n=m+1;n<k&&"%"==l[n];++n);var q=m&&"!"==l[m-1]||n<k&&"1"==l[n]?"1":"N";for(p=m;p<n;++p)l[p]=q;m=n-1}m=0;for(n="L";m<k;++m)p=
l[m],"L"==n&&"1"==p?l[m]="L":e.test(p)&&(n=p);for(m=0;m<k;++m)if(d.test(l[m])){for(n=m+1;n<k&&d.test(l[n]);++n);p="L"==(n<k?l[n]:"L");q="L"==(m?l[m-1]:"L")||p?"L":"R";for(p=m;p<n;++p)l[p]=q;m=n-1}for(var n=[],r,m=0;m<k;)if(f.test(l[m])){p=m;for(++m;m<k&&f.test(l[m]);++m);n.push(new b(0,p,m))}else{var s=m,q=n.length;for(++m;m<k&&"L"!=l[m];++m);for(p=s;p<m;)if(g.test(l[p])){s<p&&n.splice(q,0,new b(1,s,p));s=p;for(++p;p<m&&g.test(l[p]);++p);n.splice(q,0,new b(2,s,p));s=p}else++p;s<m&&n.splice(q,0,new b(1,
s,m))}1==n[0].level&&(r=h.match(/^\s+/))&&(n[0].from=r[0].length,n.unshift(new b(0,0,r[0].length)));1==z(n).level&&(r=h.match(/\s+$/))&&(z(n).to-=r[0].length,n.push(new b(0,k-r[0].length,k)));2==n[0].level&&n.unshift(new b(1,n[0].to,n[0].to));n[0].level!=z(n).level&&n.push(new b(n[0].level,k,k));return n}}();q.version="5.19.0";return q});
// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
  CodeMirror.defineOption("placeholder", "", function(cm, val, old) {
    var prev = old && old != CodeMirror.Init;
    if (val && !prev) {
      cm.on("blur", onBlur);
      cm.on("change", onChange);
      cm.on("swapDoc", onChange);
      onChange(cm);
    } else if (!val && prev) {
      cm.off("blur", onBlur);
      cm.off("change", onChange);
      cm.off("swapDoc", onChange);
      clearPlaceholder(cm);
      var wrapper = cm.getWrapperElement();
      wrapper.className = wrapper.className.replace(" CodeMirror-empty", "");
    }

    if (val && !cm.hasFocus()) onBlur(cm);
  });

  function clearPlaceholder(cm) {
    if (cm.state.placeholder) {
      cm.state.placeholder.parentNode.removeChild(cm.state.placeholder);
      cm.state.placeholder = null;
    }
  }
  function setPlaceholder(cm) {
    clearPlaceholder(cm);
    var elt = cm.state.placeholder = document.createElement("pre");
    elt.style.cssText = "height: 0; overflow: visible";
    elt.className = "CodeMirror-placeholder";
    var placeHolder = cm.getOption("placeholder")
    if (typeof placeHolder == "string") placeHolder = document.createTextNode(placeHolder)
    elt.appendChild(placeHolder)
    cm.display.lineSpace.insertBefore(elt, cm.display.lineSpace.firstChild);
  }

  function onBlur(cm) {
    if (isEmpty(cm)) setPlaceholder(cm);
  }
  function onChange(cm) {
    var wrapper = cm.getWrapperElement(), empty = isEmpty(cm);
    wrapper.className = wrapper.className.replace(" CodeMirror-empty", "") + (empty ? " CodeMirror-empty" : "");

    if (empty) setPlaceholder(cm);
    else clearPlaceholder(cm);
  }

  function isEmpty(cm) {
    return (cm.lineCount() === 1) && (cm.getLine(0) === "");
  }
});

// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

/**
 * Author: Hans Engel
 * Branched from CodeMirror's Scheme mode (by Koh Zi Han, based on implementation by Koh Zi Chun)
 */

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
"use strict";

CodeMirror.defineMode("clojure", function (options) {
    var BUILTIN = "builtin", COMMENT = "comment", STRING = "string", CHARACTER = "string-2",
        ATOM = "atom", NUMBER = "number", BRACKET = "bracket", KEYWORD = "keyword", VAR = "variable";
    var INDENT_WORD_SKIP = options.indentUnit || 2;
    var NORMAL_INDENT_UNIT = options.indentUnit || 2;

    function makeKeywords(str) {
        var obj = {}, words = str.split(" ");
        for (var i = 0; i < words.length; ++i) obj[words[i]] = true;
        return obj;
    }

    var atoms = makeKeywords("true false nil");

    var keywords = makeKeywords(
      "defn defn- def def- defonce defmulti defmethod defmacro defstruct deftype defprotocol defrecord defproject deftest " +
      "slice defalias defhinted defmacro- defn-memo defnk defnk defonce- defunbound defunbound- defvar defvar- let letfn " +
      "do case cond condp for loop recur when when-not when-let when-first if if-let if-not . .. -> ->> doto and or dosync " +
      "doseq dotimes dorun doall load import unimport ns in-ns refer try catch finally throw with-open with-local-vars " +
      "binding gen-class gen-and-load-class gen-and-save-class handler-case handle");

    var builtins = makeKeywords(
        "* *' *1 *2 *3 *agent* *allow-unresolved-vars* *assert* *clojure-version* *command-line-args* *compile-files* " +
        "*compile-path* *compiler-options* *data-readers* *e *err* *file* *flush-on-newline* *fn-loader* *in* " +
        "*math-context* *ns* *out* *print-dup* *print-length* *print-level* *print-meta* *print-readably* *read-eval* " +
        "*source-path* *unchecked-math* *use-context-classloader* *verbose-defrecords* *warn-on-reflection* + +' - -' -> " +
        "->> ->ArrayChunk ->Vec ->VecNode ->VecSeq -cache-protocol-fn -reset-methods .. / < <= = == > >= EMPTY-NODE accessor " +
        "aclone add-classpath add-watch agent agent-error agent-errors aget alength alias all-ns alter alter-meta! " +
        "alter-var-root amap ancestors and apply areduce array-map aset aset-boolean aset-byte aset-char aset-double " +
        "aset-float aset-int aset-long aset-short assert assoc assoc! assoc-in associative? atom await await-for await1 " +
        "bases bean bigdec bigint biginteger binding bit-and bit-and-not bit-clear bit-flip bit-not bit-or bit-set " +
        "bit-shift-left bit-shift-right bit-test bit-xor boolean boolean-array booleans bound-fn bound-fn* bound? butlast " +
        "byte byte-array bytes case cat cast char char-array char-escape-string char-name-string char? chars chunk chunk-append " +
        "chunk-buffer chunk-cons chunk-first chunk-next chunk-rest chunked-seq? class class? clear-agent-errors " +
        "clojure-version coll? comment commute comp comparator compare compare-and-set! compile complement completing concat cond condp " +
        "conj conj! cons constantly construct-proxy contains? count counted? create-ns create-struct cycle dec dec' decimal? " +
        "declare dedupe default-data-readers definline definterface defmacro defmethod defmulti defn defn- defonce defprotocol " +
        "defrecord defstruct deftype delay delay? deliver denominator deref derive descendants destructure disj disj! dissoc " +
        "dissoc! distinct distinct? doall dorun doseq dosync dotimes doto double double-array doubles drop drop-last " +
        "drop-while eduction empty empty? ensure enumeration-seq error-handler error-mode eval even? every-pred every? ex-data ex-info " +
        "extend extend-protocol extend-type extenders extends? false? ffirst file-seq filter filterv find find-keyword " +
        "find-ns find-protocol-impl find-protocol-method find-var first flatten float float-array float? floats flush fn fn? " +
        "fnext fnil for force format frequencies future future-call future-cancel future-cancelled? future-done? future? " +
        "gen-class gen-interface gensym get get-in get-method get-proxy-class get-thread-bindings get-validator group-by hash " +
        "hash-combine hash-map hash-set identical? identity if-let if-not ifn? import in-ns inc inc' init-proxy instance? " +
        "int int-array integer? interleave intern interpose into into-array ints io! isa? iterate iterator-seq juxt keep " +
        "keep-indexed key keys keyword keyword? last lazy-cat lazy-seq let letfn line-seq list list* list? load load-file " +
        "load-reader load-string loaded-libs locking long long-array longs loop macroexpand macroexpand-1 make-array " +
        "make-hierarchy map map-indexed map? mapcat mapv max max-key memfn memoize merge merge-with meta method-sig methods " +
        "min min-key mod munge name namespace namespace-munge neg? newline next nfirst nil? nnext not not-any? not-empty " +
        "not-every? not= ns ns-aliases ns-imports ns-interns ns-map ns-name ns-publics ns-refers ns-resolve ns-unalias " +
        "ns-unmap nth nthnext nthrest num number? numerator object-array odd? or parents partial partition partition-all " +
        "partition-by pcalls peek persistent! pmap pop pop! pop-thread-bindings pos? pr pr-str prefer-method prefers " +
        "primitives-classnames print print-ctor print-dup print-method print-simple print-str printf println println-str " +
        "prn prn-str promise proxy proxy-call-with-super proxy-mappings proxy-name proxy-super push-thread-bindings pvalues " +
        "quot rand rand-int rand-nth random-sample range ratio? rational? rationalize re-find re-groups re-matcher re-matches re-pattern " +
        "re-seq read read-line read-string realized? reduce reduce-kv reductions ref ref-history-count ref-max-history " +
        "ref-min-history ref-set refer refer-clojure reify release-pending-sends rem remove remove-all-methods " +
        "remove-method remove-ns remove-watch repeat repeatedly replace replicate require reset! reset-meta! resolve rest " +
        "restart-agent resultset-seq reverse reversible? rseq rsubseq satisfies? second select-keys send send-off seq seq? " +
        "seque sequence sequential? set set-error-handler! set-error-mode! set-validator! set? short short-array shorts " +
        "shuffle shutdown-agents slurp some some-fn sort sort-by sorted-map sorted-map-by sorted-set sorted-set-by sorted? " +
        "special-symbol? spit split-at split-with str string? struct struct-map subs subseq subvec supers swap! symbol " +
        "symbol? sync take take-last take-nth take-while test the-ns thread-bound? time to-array to-array-2d trampoline transduce " +
        "transient tree-seq true? type unchecked-add unchecked-add-int unchecked-byte unchecked-char unchecked-dec " +
        "unchecked-dec-int unchecked-divide-int unchecked-double unchecked-float unchecked-inc unchecked-inc-int " +
        "unchecked-int unchecked-long unchecked-multiply unchecked-multiply-int unchecked-negate unchecked-negate-int "+
        "unchecked-remainder-int unchecked-short unchecked-subtract unchecked-subtract-int underive unquote " +
        "unquote-splicing update update-in update-proxy use val vals var-get var-set var? vary-meta vec vector vector-of " +
        "vector? volatile! volatile? vreset! vswap! when when-first when-let when-not while with-bindings with-bindings* with-in-str with-loading-context " +
        "with-local-vars with-meta with-open with-out-str with-precision with-redefs with-redefs-fn xml-seq zero? zipmap " +
        "*default-data-reader-fn* as-> cond-> cond->> reduced reduced? send-via set-agent-send-executor! " +
        "set-agent-send-off-executor! some-> some->>");

    var indentKeys = makeKeywords(
        // Built-ins
        "ns fn def defn defmethod bound-fn if if-not case condp when while when-not when-first do future comment doto " +
        "locking proxy with-open with-precision reify deftype defrecord defprotocol extend extend-protocol extend-type " +
        "try catch " +

        // Binding forms
        "let letfn binding loop for doseq dotimes when-let if-let " +

        // Data structures
        "defstruct struct-map assoc " +

        // clojure.test
        "testing deftest " +

        // contrib
        "handler-case handle dotrace deftrace");

    var tests = {
        digit: /\d/,
        digit_or_colon: /[\d:]/,
        hex: /[0-9a-f]/i,
        sign: /[+-]/,
        exponent: /e/i,
        keyword_char: /[^\s\(\[\;\)\]]/,
        symbol: /[\w*+!\-\._?:<>\/\xa1-\uffff]/,
        block_indent: /^(?:def|with)[^\/]+$|\/(?:def|with)/
    };

    function stateStack(indent, type, prev) { // represents a state stack object
        this.indent = indent;
        this.type = type;
        this.prev = prev;
    }

    function pushStack(state, indent, type) {
        state.indentStack = new stateStack(indent, type, state.indentStack);
    }

    function popStack(state) {
        state.indentStack = state.indentStack.prev;
    }

    function isNumber(ch, stream){
        // hex
        if ( ch === '0' && stream.eat(/x/i) ) {
            stream.eatWhile(tests.hex);
            return true;
        }

        // leading sign
        if ( ( ch == '+' || ch == '-' ) && ( tests.digit.test(stream.peek()) ) ) {
          stream.eat(tests.sign);
          ch = stream.next();
        }

        if ( tests.digit.test(ch) ) {
            stream.eat(ch);
            stream.eatWhile(tests.digit);

            if ( '.' == stream.peek() ) {
                stream.eat('.');
                stream.eatWhile(tests.digit);
            } else if ('/' == stream.peek() ) {
                stream.eat('/');
                stream.eatWhile(tests.digit);
            }

            if ( stream.eat(tests.exponent) ) {
                stream.eat(tests.sign);
                stream.eatWhile(tests.digit);
            }

            return true;
        }

        return false;
    }

    // Eat character that starts after backslash \
    function eatCharacter(stream) {
        var first = stream.next();
        // Read special literals: backspace, newline, space, return.
        // Just read all lowercase letters.
        if (first && first.match(/[a-z]/) && stream.match(/[a-z]+/, true)) {
            return;
        }
        // Read unicode character: \u1000 \uA0a1
        if (first === "u") {
            stream.match(/[0-9a-z]{4}/i, true);
        }
    }

    return {
        startState: function () {
            return {
                indentStack: null,
                indentation: 0,
                mode: false
            };
        },

        token: function (stream, state) {
            if (state.indentStack == null && stream.sol()) {
                // update indentation, but only if indentStack is empty
                state.indentation = stream.indentation();
            }

            // skip spaces
            if (state.mode != "string" && stream.eatSpace()) {
                return null;
            }
            var returnType = null;

            switch(state.mode){
                case "string": // multi-line string parsing mode
                    var next, escaped = false;
                    while ((next = stream.next()) != null) {
                        if (next == "\"" && !escaped) {

                            state.mode = false;
                            break;
                        }
                        escaped = !escaped && next == "\\";
                    }
                    returnType = STRING; // continue on in string mode
                    break;
                default: // default parsing mode
                    var ch = stream.next();

                    if (ch == "\"") {
                        state.mode = "string";
                        returnType = STRING;
                    } else if (ch == "\\") {
                        eatCharacter(stream);
                        returnType = CHARACTER;
                    } else if (ch == "'" && !( tests.digit_or_colon.test(stream.peek()) )) {
                        returnType = ATOM;
                    } else if (ch == ";") { // comment
                        stream.skipToEnd(); // rest of the line is a comment
                        returnType = COMMENT;
                    } else if (isNumber(ch,stream)){
                        returnType = NUMBER;
                    } else if (ch == "(" || ch == "[" || ch == "{" ) {
                        var keyWord = '', indentTemp = stream.column(), letter;
                        /**
                        Either
                        (indent-word ..
                        (non-indent-word ..
                        (;something else, bracket, etc.
                        */

                        if (ch == "(") while ((letter = stream.eat(tests.keyword_char)) != null) {
                            keyWord += letter;
                        }

                        if (keyWord.length > 0 && (indentKeys.propertyIsEnumerable(keyWord) ||
                                                   tests.block_indent.test(keyWord))) { // indent-word
                            pushStack(state, indentTemp + INDENT_WORD_SKIP, ch);
                        } else { // non-indent word
                            // we continue eating the spaces
                            stream.eatSpace();
                            if (stream.eol() || stream.peek() == ";") {
                                // nothing significant after
                                // we restart indentation the user defined spaces after
                                pushStack(state, indentTemp + NORMAL_INDENT_UNIT, ch);
                            } else {
                                pushStack(state, indentTemp + stream.current().length, ch); // else we match
                            }
                        }
                        stream.backUp(stream.current().length - 1); // undo all the eating

                        returnType = BRACKET;
                    } else if (ch == ")" || ch == "]" || ch == "}") {
                        returnType = BRACKET;
                        if (state.indentStack != null && state.indentStack.type == (ch == ")" ? "(" : (ch == "]" ? "[" :"{"))) {
                            popStack(state);
                        }
                    } else if ( ch == ":" ) {
                        stream.eatWhile(tests.symbol);
                        return ATOM;
                    } else {
                        stream.eatWhile(tests.symbol);

                        if (keywords && keywords.propertyIsEnumerable(stream.current())) {
                            returnType = KEYWORD;
                        } else if (builtins && builtins.propertyIsEnumerable(stream.current())) {
                            returnType = BUILTIN;
                        } else if (atoms && atoms.propertyIsEnumerable(stream.current())) {
                            returnType = ATOM;
                        } else {
                          returnType = VAR;
                        }
                    }
            }

            return returnType;
        },

        indent: function (state) {
            if (state.indentStack == null) return state.indentation;
            return state.indentStack.indent;
        },

        closeBrackets: {pairs: "()[]{}\"\""},
        lineComment: ";;"
    };
});

CodeMirror.defineMIME("text/x-clojure", "clojure");
CodeMirror.defineMIME("text/x-clojurescript", "clojure");
CodeMirror.defineMIME("application/edn", "clojure");

});

// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
"use strict";

function expressionAllowed(stream, state, backUp) {
  return /^(?:operator|sof|keyword c|case|new|[\[{}\(,;:]|=>)$/.test(state.lastType) ||
    (state.lastType == "quasi" && /\{\s*$/.test(stream.string.slice(0, stream.pos - (backUp || 0))))
}

CodeMirror.defineMode("javascript", function(config, parserConfig) {
  var indentUnit = config.indentUnit;
  var statementIndent = parserConfig.statementIndent;
  var jsonldMode = parserConfig.jsonld;
  var jsonMode = parserConfig.json || jsonldMode;
  var isTS = parserConfig.typescript;
  var wordRE = parserConfig.wordCharacters || /[\w$\xa1-\uffff]/;

  // Tokenizer

  var keywords = function(){
    function kw(type) {return {type: type, style: "keyword"};}
    var A = kw("keyword a"), B = kw("keyword b"), C = kw("keyword c");
    var operator = kw("operator"), atom = {type: "atom", style: "atom"};

    var jsKeywords = {
      "if": kw("if"), "while": A, "with": A, "else": B, "do": B, "try": B, "finally": B,
      "return": C, "break": C, "continue": C, "new": kw("new"), "delete": C, "throw": C, "debugger": C,
      "var": kw("var"), "const": kw("var"), "let": kw("var"),
      "function": kw("function"), "catch": kw("catch"),
      "for": kw("for"), "switch": kw("switch"), "case": kw("case"), "default": kw("default"),
      "in": operator, "typeof": operator, "instanceof": operator,
      "true": atom, "false": atom, "null": atom, "undefined": atom, "NaN": atom, "Infinity": atom,
      "this": kw("this"), "class": kw("class"), "super": kw("atom"),
      "yield": C, "export": kw("export"), "import": kw("import"), "extends": C,
      "await": C, "async": kw("async")
    };

    // Extend the 'normal' keywords with the TypeScript language extensions
    if (isTS) {
      var type = {type: "variable", style: "variable-3"};
      var tsKeywords = {
        // object-like things
        "interface": kw("class"),
        "implements": C,
        "namespace": C,
        "module": kw("module"),
        "enum": kw("module"),
        "type": kw("type"),

        // scope modifiers
        "public": kw("modifier"),
        "private": kw("modifier"),
        "protected": kw("modifier"),
        "abstract": kw("modifier"),

        // operators
        "as": operator,

        // types
        "string": type, "number": type, "boolean": type, "any": type
      };

      for (var attr in tsKeywords) {
        jsKeywords[attr] = tsKeywords[attr];
      }
    }

    return jsKeywords;
  }();

  var isOperatorChar = /[+\-*&%=<>!?|~^]/;
  var isJsonldKeyword = /^@(context|id|value|language|type|container|list|set|reverse|index|base|vocab|graph)"/;

  function readRegexp(stream) {
    var escaped = false, next, inSet = false;
    while ((next = stream.next()) != null) {
      if (!escaped) {
        if (next == "/" && !inSet) return;
        if (next == "[") inSet = true;
        else if (inSet && next == "]") inSet = false;
      }
      escaped = !escaped && next == "\\";
    }
  }

  // Used as scratch variables to communicate multiple values without
  // consing up tons of objects.
  var type, content;
  function ret(tp, style, cont) {
    type = tp; content = cont;
    return style;
  }
  function tokenBase(stream, state) {
    var ch = stream.next();
    if (ch == '"' || ch == "'") {
      state.tokenize = tokenString(ch);
      return state.tokenize(stream, state);
    } else if (ch == "." && stream.match(/^\d+(?:[eE][+\-]?\d+)?/)) {
      return ret("number", "number");
    } else if (ch == "." && stream.match("..")) {
      return ret("spread", "meta");
    } else if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
      return ret(ch);
    } else if (ch == "=" && stream.eat(">")) {
      return ret("=>", "operator");
    } else if (ch == "0" && stream.eat(/x/i)) {
      stream.eatWhile(/[\da-f]/i);
      return ret("number", "number");
    } else if (ch == "0" && stream.eat(/o/i)) {
      stream.eatWhile(/[0-7]/i);
      return ret("number", "number");
    } else if (ch == "0" && stream.eat(/b/i)) {
      stream.eatWhile(/[01]/i);
      return ret("number", "number");
    } else if (/\d/.test(ch)) {
      stream.match(/^\d*(?:\.\d*)?(?:[eE][+\-]?\d+)?/);
      return ret("number", "number");
    } else if (ch == "/") {
      if (stream.eat("*")) {
        state.tokenize = tokenComment;
        return tokenComment(stream, state);
      } else if (stream.eat("/")) {
        stream.skipToEnd();
        return ret("comment", "comment");
      } else if (expressionAllowed(stream, state, 1)) {
        readRegexp(stream);
        stream.match(/^\b(([gimyu])(?![gimyu]*\2))+\b/);
        return ret("regexp", "string-2");
      } else {
        stream.eatWhile(isOperatorChar);
        return ret("operator", "operator", stream.current());
      }
    } else if (ch == "`") {
      state.tokenize = tokenQuasi;
      return tokenQuasi(stream, state);
    } else if (ch == "#") {
      stream.skipToEnd();
      return ret("error", "error");
    } else if (isOperatorChar.test(ch)) {
      stream.eatWhile(isOperatorChar);
      return ret("operator", "operator", stream.current());
    } else if (wordRE.test(ch)) {
      stream.eatWhile(wordRE);
      var word = stream.current(), known = keywords.propertyIsEnumerable(word) && keywords[word];
      return (known && state.lastType != ".") ? ret(known.type, known.style, word) :
                     ret("variable", "variable", word);
    }
  }

  function tokenString(quote) {
    return function(stream, state) {
      var escaped = false, next;
      if (jsonldMode && stream.peek() == "@" && stream.match(isJsonldKeyword)){
        state.tokenize = tokenBase;
        return ret("jsonld-keyword", "meta");
      }
      while ((next = stream.next()) != null) {
        if (next == quote && !escaped) break;
        escaped = !escaped && next == "\\";
      }
      if (!escaped) state.tokenize = tokenBase;
      return ret("string", "string");
    };
  }

  function tokenComment(stream, state) {
    var maybeEnd = false, ch;
    while (ch = stream.next()) {
      if (ch == "/" && maybeEnd) {
        state.tokenize = tokenBase;
        break;
      }
      maybeEnd = (ch == "*");
    }
    return ret("comment", "comment");
  }

  function tokenQuasi(stream, state) {
    var escaped = false, next;
    while ((next = stream.next()) != null) {
      if (!escaped && (next == "`" || next == "$" && stream.eat("{"))) {
        state.tokenize = tokenBase;
        break;
      }
      escaped = !escaped && next == "\\";
    }
    return ret("quasi", "string-2", stream.current());
  }

  var brackets = "([{}])";
  // This is a crude lookahead trick to try and notice that we're
  // parsing the argument patterns for a fat-arrow function before we
  // actually hit the arrow token. It only works if the arrow is on
  // the same line as the arguments and there's no strange noise
  // (comments) in between. Fallback is to only notice when we hit the
  // arrow, and not declare the arguments as locals for the arrow
  // body.
  function findFatArrow(stream, state) {
    if (state.fatArrowAt) state.fatArrowAt = null;
    var arrow = stream.string.indexOf("=>", stream.start);
    if (arrow < 0) return;

    var depth = 0, sawSomething = false;
    for (var pos = arrow - 1; pos >= 0; --pos) {
      var ch = stream.string.charAt(pos);
      var bracket = brackets.indexOf(ch);
      if (bracket >= 0 && bracket < 3) {
        if (!depth) { ++pos; break; }
        if (--depth == 0) { if (ch == "(") sawSomething = true; break; }
      } else if (bracket >= 3 && bracket < 6) {
        ++depth;
      } else if (wordRE.test(ch)) {
        sawSomething = true;
      } else if (/["'\/]/.test(ch)) {
        return;
      } else if (sawSomething && !depth) {
        ++pos;
        break;
      }
    }
    if (sawSomething && !depth) state.fatArrowAt = pos;
  }

  // Parser

  var atomicTypes = {"atom": true, "number": true, "variable": true, "string": true, "regexp": true, "this": true, "jsonld-keyword": true};

  function JSLexical(indented, column, type, align, prev, info) {
    this.indented = indented;
    this.column = column;
    this.type = type;
    this.prev = prev;
    this.info = info;
    if (align != null) this.align = align;
  }

  function inScope(state, varname) {
    for (var v = state.localVars; v; v = v.next)
      if (v.name == varname) return true;
    for (var cx = state.context; cx; cx = cx.prev) {
      for (var v = cx.vars; v; v = v.next)
        if (v.name == varname) return true;
    }
  }

  function parseJS(state, style, type, content, stream) {
    var cc = state.cc;
    // Communicate our context to the combinators.
    // (Less wasteful than consing up a hundred closures on every call.)
    cx.state = state; cx.stream = stream; cx.marked = null, cx.cc = cc; cx.style = style;

    if (!state.lexical.hasOwnProperty("align"))
      state.lexical.align = true;

    while(true) {
      var combinator = cc.length ? cc.pop() : jsonMode ? expression : statement;
      if (combinator(type, content)) {
        while(cc.length && cc[cc.length - 1].lex)
          cc.pop()();
        if (cx.marked) return cx.marked;
        if (type == "variable" && inScope(state, content)) return "variable-2";
        return style;
      }
    }
  }

  // Combinator utils

  var cx = {state: null, column: null, marked: null, cc: null};
  function pass() {
    for (var i = arguments.length - 1; i >= 0; i--) cx.cc.push(arguments[i]);
  }
  function cont() {
    pass.apply(null, arguments);
    return true;
  }
  function register(varname) {
    function inList(list) {
      for (var v = list; v; v = v.next)
        if (v.name == varname) return true;
      return false;
    }
    var state = cx.state;
    cx.marked = "def";
    if (state.context) {
      if (inList(state.localVars)) return;
      state.localVars = {name: varname, next: state.localVars};
    } else {
      if (inList(state.globalVars)) return;
      if (parserConfig.globalVars)
        state.globalVars = {name: varname, next: state.globalVars};
    }
  }

  // Combinators

  var defaultVars = {name: "this", next: {name: "arguments"}};
  function pushcontext() {
    cx.state.context = {prev: cx.state.context, vars: cx.state.localVars};
    cx.state.localVars = defaultVars;
  }
  function popcontext() {
    cx.state.localVars = cx.state.context.vars;
    cx.state.context = cx.state.context.prev;
  }
  function pushlex(type, info) {
    var result = function() {
      var state = cx.state, indent = state.indented;
      if (state.lexical.type == "stat") indent = state.lexical.indented;
      else for (var outer = state.lexical; outer && outer.type == ")" && outer.align; outer = outer.prev)
        indent = outer.indented;
      state.lexical = new JSLexical(indent, cx.stream.column(), type, null, state.lexical, info);
    };
    result.lex = true;
    return result;
  }
  function poplex() {
    var state = cx.state;
    if (state.lexical.prev) {
      if (state.lexical.type == ")")
        state.indented = state.lexical.indented;
      state.lexical = state.lexical.prev;
    }
  }
  poplex.lex = true;

  function expect(wanted) {
    function exp(type) {
      if (type == wanted) return cont();
      else if (wanted == ";") return pass();
      else return cont(exp);
    };
    return exp;
  }

  function statement(type, value) {
    if (type == "var") return cont(pushlex("vardef", value.length), vardef, expect(";"), poplex);
    if (type == "keyword a") return cont(pushlex("form"), parenExpr, statement, poplex);
    if (type == "keyword b") return cont(pushlex("form"), statement, poplex);
    if (type == "{") return cont(pushlex("}"), block, poplex);
    if (type == ";") return cont();
    if (type == "if") {
      if (cx.state.lexical.info == "else" && cx.state.cc[cx.state.cc.length - 1] == poplex)
        cx.state.cc.pop()();
      return cont(pushlex("form"), parenExpr, statement, poplex, maybeelse);
    }
    if (type == "function") return cont(functiondef);
    if (type == "for") return cont(pushlex("form"), forspec, statement, poplex);
    if (type == "variable") return cont(pushlex("stat"), maybelabel);
    if (type == "switch") return cont(pushlex("form"), parenExpr, pushlex("}", "switch"), expect("{"),
                                      block, poplex, poplex);
    if (type == "case") return cont(expression, expect(":"));
    if (type == "default") return cont(expect(":"));
    if (type == "catch") return cont(pushlex("form"), pushcontext, expect("("), funarg, expect(")"),
                                     statement, poplex, popcontext);
    if (type == "class") return cont(pushlex("form"), className, poplex);
    if (type == "export") return cont(pushlex("stat"), afterExport, poplex);
    if (type == "import") return cont(pushlex("stat"), afterImport, poplex);
    if (type == "module") return cont(pushlex("form"), pattern, pushlex("}"), expect("{"), block, poplex, poplex)
    if (type == "type") return cont(typeexpr, expect("operator"), typeexpr, expect(";"));
    if (type == "async") return cont(statement)
    return pass(pushlex("stat"), expression, expect(";"), poplex);
  }
  function expression(type) {
    return expressionInner(type, false);
  }
  function expressionNoComma(type) {
    return expressionInner(type, true);
  }
  function parenExpr(type) {
    if (type != "(") return pass()
    return cont(pushlex(")"), expression, expect(")"), poplex)
  }
  function expressionInner(type, noComma) {
    if (cx.state.fatArrowAt == cx.stream.start) {
      var body = noComma ? arrowBodyNoComma : arrowBody;
      if (type == "(") return cont(pushcontext, pushlex(")"), commasep(pattern, ")"), poplex, expect("=>"), body, popcontext);
      else if (type == "variable") return pass(pushcontext, pattern, expect("=>"), body, popcontext);
    }

    var maybeop = noComma ? maybeoperatorNoComma : maybeoperatorComma;
    if (atomicTypes.hasOwnProperty(type)) return cont(maybeop);
    if (type == "function") return cont(functiondef, maybeop);
    if (type == "keyword c" || type == "async") return cont(noComma ? maybeexpressionNoComma : maybeexpression);
    if (type == "(") return cont(pushlex(")"), maybeexpression, expect(")"), poplex, maybeop);
    if (type == "operator" || type == "spread") return cont(noComma ? expressionNoComma : expression);
    if (type == "[") return cont(pushlex("]"), arrayLiteral, poplex, maybeop);
    if (type == "{") return contCommasep(objprop, "}", null, maybeop);
    if (type == "quasi") return pass(quasi, maybeop);
    if (type == "new") return cont(maybeTarget(noComma));
    return cont();
  }
  function maybeexpression(type) {
    if (type.match(/[;\}\)\],]/)) return pass();
    return pass(expression);
  }
  function maybeexpressionNoComma(type) {
    if (type.match(/[;\}\)\],]/)) return pass();
    return pass(expressionNoComma);
  }

  function maybeoperatorComma(type, value) {
    if (type == ",") return cont(expression);
    return maybeoperatorNoComma(type, value, false);
  }
  function maybeoperatorNoComma(type, value, noComma) {
    var me = noComma == false ? maybeoperatorComma : maybeoperatorNoComma;
    var expr = noComma == false ? expression : expressionNoComma;
    if (type == "=>") return cont(pushcontext, noComma ? arrowBodyNoComma : arrowBody, popcontext);
    if (type == "operator") {
      if (/\+\+|--/.test(value)) return cont(me);
      if (value == "?") return cont(expression, expect(":"), expr);
      return cont(expr);
    }
    if (type == "quasi") { return pass(quasi, me); }
    if (type == ";") return;
    if (type == "(") return contCommasep(expressionNoComma, ")", "call", me);
    if (type == ".") return cont(property, me);
    if (type == "[") return cont(pushlex("]"), maybeexpression, expect("]"), poplex, me);
  }
  function quasi(type, value) {
    if (type != "quasi") return pass();
    if (value.slice(value.length - 2) != "${") return cont(quasi);
    return cont(expression, continueQuasi);
  }
  function continueQuasi(type) {
    if (type == "}") {
      cx.marked = "string-2";
      cx.state.tokenize = tokenQuasi;
      return cont(quasi);
    }
  }
  function arrowBody(type) {
    findFatArrow(cx.stream, cx.state);
    return pass(type == "{" ? statement : expression);
  }
  function arrowBodyNoComma(type) {
    findFatArrow(cx.stream, cx.state);
    return pass(type == "{" ? statement : expressionNoComma);
  }
  function maybeTarget(noComma) {
    return function(type) {
      if (type == ".") return cont(noComma ? targetNoComma : target);
      else return pass(noComma ? expressionNoComma : expression);
    };
  }
  function target(_, value) {
    if (value == "target") { cx.marked = "keyword"; return cont(maybeoperatorComma); }
  }
  function targetNoComma(_, value) {
    if (value == "target") { cx.marked = "keyword"; return cont(maybeoperatorNoComma); }
  }
  function maybelabel(type) {
    if (type == ":") return cont(poplex, statement);
    return pass(maybeoperatorComma, expect(";"), poplex);
  }
  function property(type) {
    if (type == "variable") {cx.marked = "property"; return cont();}
  }
  function objprop(type, value) {
    if (type == "async") {
      cx.marked = "property";
      return cont(objprop);
    } else if (type == "variable" || cx.style == "keyword") {
      cx.marked = "property";
      if (value == "get" || value == "set") return cont(getterSetter);
      return cont(afterprop);
    } else if (type == "number" || type == "string") {
      cx.marked = jsonldMode ? "property" : (cx.style + " property");
      return cont(afterprop);
    } else if (type == "jsonld-keyword") {
      return cont(afterprop);
    } else if (type == "modifier") {
      return cont(objprop)
    } else if (type == "[") {
      return cont(expression, expect("]"), afterprop);
    } else if (type == "spread") {
      return cont(expression);
    } else if (type == ":") {
      return pass(afterprop)
    }
  }
  function getterSetter(type) {
    if (type != "variable") return pass(afterprop);
    cx.marked = "property";
    return cont(functiondef);
  }
  function afterprop(type) {
    if (type == ":") return cont(expressionNoComma);
    if (type == "(") return pass(functiondef);
  }
  function commasep(what, end) {
    function proceed(type, value) {
      if (type == ",") {
        var lex = cx.state.lexical;
        if (lex.info == "call") lex.pos = (lex.pos || 0) + 1;
        return cont(function(type, value) {
          if (type == end || value == end) return pass()
          return pass(what)
        }, proceed);
      }
      if (type == end || value == end) return cont();
      return cont(expect(end));
    }
    return function(type, value) {
      if (type == end || value == end) return cont();
      return pass(what, proceed);
    };
  }
  function contCommasep(what, end, info) {
    for (var i = 3; i < arguments.length; i++)
      cx.cc.push(arguments[i]);
    return cont(pushlex(end, info), commasep(what, end), poplex);
  }
  function block(type) {
    if (type == "}") return cont();
    return pass(statement, block);
  }
  function maybetype(type, value) {
    if (isTS) {
      if (type == ":") return cont(typeexpr);
      if (value == "?") return cont(maybetype);
    }
  }
  function maybedefault(_, value) {
    if (value == "=") return cont(expressionNoComma);
  }
  function typeexpr(type) {
    if (type == "variable") {cx.marked = "variable-3"; return cont(afterType);}
    if (type == "{") return cont(commasep(typeprop, "}"))
    if (type == "(") return cont(commasep(typearg, ")"), maybeReturnType)
  }
  function maybeReturnType(type) {
    if (type == "=>") return cont(typeexpr)
  }
  function typeprop(type) {
    if (type == "variable" || cx.style == "keyword") {
      cx.marked = "property"
      return cont(typeprop)
    } else if (type == ":") {
      return cont(typeexpr)
    }
  }
  function typearg(type) {
    if (type == "variable") return cont(typearg)
    else if (type == ":") return cont(typeexpr)
  }
  function afterType(type, value) {
    if (value == "<") return cont(commasep(typeexpr, ">"), afterType)
    if (type == "[") return cont(expect("]"), afterType)
  }
  function vardef() {
    return pass(pattern, maybetype, maybeAssign, vardefCont);
  }
  function pattern(type, value) {
    if (type == "modifier") return cont(pattern)
    if (type == "variable") { register(value); return cont(); }
    if (type == "spread") return cont(pattern);
    if (type == "[") return contCommasep(pattern, "]");
    if (type == "{") return contCommasep(proppattern, "}");
  }
  function proppattern(type, value) {
    if (type == "variable" && !cx.stream.match(/^\s*:/, false)) {
      register(value);
      return cont(maybeAssign);
    }
    if (type == "variable") cx.marked = "property";
    if (type == "spread") return cont(pattern);
    if (type == "}") return pass();
    return cont(expect(":"), pattern, maybeAssign);
  }
  function maybeAssign(_type, value) {
    if (value == "=") return cont(expressionNoComma);
  }
  function vardefCont(type) {
    if (type == ",") return cont(vardef);
  }
  function maybeelse(type, value) {
    if (type == "keyword b" && value == "else") return cont(pushlex("form", "else"), statement, poplex);
  }
  function forspec(type) {
    if (type == "(") return cont(pushlex(")"), forspec1, expect(")"), poplex);
  }
  function forspec1(type) {
    if (type == "var") return cont(vardef, expect(";"), forspec2);
    if (type == ";") return cont(forspec2);
    if (type == "variable") return cont(formaybeinof);
    return pass(expression, expect(";"), forspec2);
  }
  function formaybeinof(_type, value) {
    if (value == "in" || value == "of") { cx.marked = "keyword"; return cont(expression); }
    return cont(maybeoperatorComma, forspec2);
  }
  function forspec2(type, value) {
    if (type == ";") return cont(forspec3);
    if (value == "in" || value == "of") { cx.marked = "keyword"; return cont(expression); }
    return pass(expression, expect(";"), forspec3);
  }
  function forspec3(type) {
    if (type != ")") cont(expression);
  }
  function functiondef(type, value) {
    if (value == "*") {cx.marked = "keyword"; return cont(functiondef);}
    if (type == "variable") {register(value); return cont(functiondef);}
    if (type == "(") return cont(pushcontext, pushlex(")"), commasep(funarg, ")"), poplex, maybetype, statement, popcontext);
  }
  function funarg(type) {
    if (type == "spread") return cont(funarg);
    return pass(pattern, maybetype, maybedefault);
  }
  function className(type, value) {
    if (type == "variable") {register(value); return cont(classNameAfter);}
  }
  function classNameAfter(type, value) {
    if (value == "extends") return cont(isTS ? typeexpr : expression, classNameAfter);
    if (type == "{") return cont(pushlex("}"), classBody, poplex);
  }
  function classBody(type, value) {
    if (type == "variable" || cx.style == "keyword") {
      if ((value == "static" || value == "get" || value == "set" ||
           (isTS && (value == "public" || value == "private" || value == "protected"))) &&
          cx.stream.match(/^\s+[\w$\xa1-\uffff]/, false)) {
        cx.marked = "keyword";
        return cont(classBody);
      }
      cx.marked = "property";
      return cont(isTS ? classfield : functiondef, classBody);
    }
    if (value == "*") {
      cx.marked = "keyword";
      return cont(classBody);
    }
    if (type == ";") return cont(classBody);
    if (type == "}") return cont();
  }
  function classfield(type) {
    if (type == ":") return cont(typeexpr)
    return pass(functiondef)
  }
  function afterExport(_type, value) {
    if (value == "*") { cx.marked = "keyword"; return cont(maybeFrom, expect(";")); }
    if (value == "default") { cx.marked = "keyword"; return cont(expression, expect(";")); }
    return pass(statement);
  }
  function afterImport(type) {
    if (type == "string") return cont();
    return pass(importSpec, maybeFrom);
  }
  function importSpec(type, value) {
    if (type == "{") return contCommasep(importSpec, "}");
    if (type == "variable") register(value);
    if (value == "*") cx.marked = "keyword";
    return cont(maybeAs);
  }
  function maybeAs(_type, value) {
    if (value == "as") { cx.marked = "keyword"; return cont(importSpec); }
  }
  function maybeFrom(_type, value) {
    if (value == "from") { cx.marked = "keyword"; return cont(expression); }
  }
  function arrayLiteral(type) {
    if (type == "]") return cont();
    return pass(commasep(expressionNoComma, "]"));
  }

  function isContinuedStatement(state, textAfter) {
    return state.lastType == "operator" || state.lastType == "," ||
      isOperatorChar.test(textAfter.charAt(0)) ||
      /[,.]/.test(textAfter.charAt(0));
  }

  // Interface

  return {
    startState: function(basecolumn) {
      var state = {
        tokenize: tokenBase,
        lastType: "sof",
        cc: [],
        lexical: new JSLexical((basecolumn || 0) - indentUnit, 0, "block", false),
        localVars: parserConfig.localVars,
        context: parserConfig.localVars && {vars: parserConfig.localVars},
        indented: basecolumn || 0
      };
      if (parserConfig.globalVars && typeof parserConfig.globalVars == "object")
        state.globalVars = parserConfig.globalVars;
      return state;
    },

    token: function(stream, state) {
      if (stream.sol()) {
        if (!state.lexical.hasOwnProperty("align"))
          state.lexical.align = false;
        state.indented = stream.indentation();
        findFatArrow(stream, state);
      }
      if (state.tokenize != tokenComment && stream.eatSpace()) return null;
      var style = state.tokenize(stream, state);
      if (type == "comment") return style;
      state.lastType = type == "operator" && (content == "++" || content == "--") ? "incdec" : type;
      return parseJS(state, style, type, content, stream);
    },

    indent: function(state, textAfter) {
      if (state.tokenize == tokenComment) return CodeMirror.Pass;
      if (state.tokenize != tokenBase) return 0;
      var firstChar = textAfter && textAfter.charAt(0), lexical = state.lexical, top
      // Kludge to prevent 'maybelse' from blocking lexical scope pops
      if (!/^\s*else\b/.test(textAfter)) for (var i = state.cc.length - 1; i >= 0; --i) {
        var c = state.cc[i];
        if (c == poplex) lexical = lexical.prev;
        else if (c != maybeelse) break;
      }
      while ((lexical.type == "stat" || lexical.type == "form") &&
             (firstChar == "}" || ((top = state.cc[state.cc.length - 1]) &&
                                   (top == maybeoperatorComma || top == maybeoperatorNoComma) &&
                                   !/^[,\.=+\-*:?[\(]/.test(textAfter))))
        lexical = lexical.prev;
      if (statementIndent && lexical.type == ")" && lexical.prev.type == "stat")
        lexical = lexical.prev;
      var type = lexical.type, closing = firstChar == type;

      if (type == "vardef") return lexical.indented + (state.lastType == "operator" || state.lastType == "," ? lexical.info + 1 : 0);
      else if (type == "form" && firstChar == "{") return lexical.indented;
      else if (type == "form") return lexical.indented + indentUnit;
      else if (type == "stat")
        return lexical.indented + (isContinuedStatement(state, textAfter) ? statementIndent || indentUnit : 0);
      else if (lexical.info == "switch" && !closing && parserConfig.doubleIndentSwitch != false)
        return lexical.indented + (/^(?:case|default)\b/.test(textAfter) ? indentUnit : 2 * indentUnit);
      else if (lexical.align) return lexical.column + (closing ? 0 : 1);
      else return lexical.indented + (closing ? 0 : indentUnit);
    },

    electricInput: /^\s*(?:case .*?:|default:|\{|\})$/,
    blockCommentStart: jsonMode ? null : "/*",
    blockCommentEnd: jsonMode ? null : "*/",
    lineComment: jsonMode ? null : "//",
    fold: "brace",
    closeBrackets: "()[]{}''\"\"``",

    helperType: jsonMode ? "json" : "javascript",
    jsonldMode: jsonldMode,
    jsonMode: jsonMode,

    expressionAllowed: expressionAllowed,
    skipExpression: function(state) {
      var top = state.cc[state.cc.length - 1]
      if (top == expression || top == expressionNoComma) state.cc.pop()
    }
  };
});

CodeMirror.registerHelper("wordChars", "javascript", /[\w$]/);

CodeMirror.defineMIME("text/javascript", "javascript");
CodeMirror.defineMIME("text/ecmascript", "javascript");
CodeMirror.defineMIME("application/javascript", "javascript");
CodeMirror.defineMIME("application/x-javascript", "javascript");
CodeMirror.defineMIME("application/ecmascript", "javascript");
CodeMirror.defineMIME("application/json", {name: "javascript", json: true});
CodeMirror.defineMIME("application/x-json", {name: "javascript", json: true});
CodeMirror.defineMIME("application/ld+json", {name: "javascript", jsonld: true});
CodeMirror.defineMIME("text/typescript", { name: "javascript", typescript: true });
CodeMirror.defineMIME("application/typescript", { name: "javascript", typescript: true });

});

// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
  var ie_lt8 = /MSIE \d/.test(navigator.userAgent) &&
    (document.documentMode == null || document.documentMode < 8);

  var Pos = CodeMirror.Pos;

  var matching = {"(": ")>", ")": "(<", "[": "]>", "]": "[<", "{": "}>", "}": "{<"};

  function findMatchingBracket(cm, where, strict, config) {
    var line = cm.getLineHandle(where.line), pos = where.ch - 1;
    var match = (pos >= 0 && matching[line.text.charAt(pos)]) || matching[line.text.charAt(++pos)];
    if (!match) return null;
    var dir = match.charAt(1) == ">" ? 1 : -1;
    if (strict && (dir > 0) != (pos == where.ch)) return null;
    var style = cm.getTokenTypeAt(Pos(where.line, pos + 1));

    var found = scanForBracket(cm, Pos(where.line, pos + (dir > 0 ? 1 : 0)), dir, style || null, config);
    if (found == null) return null;
    return {from: Pos(where.line, pos), to: found && found.pos,
            match: found && found.ch == match.charAt(0), forward: dir > 0};
  }

  // bracketRegex is used to specify which type of bracket to scan
  // should be a regexp, e.g. /[[\]]/
  //
  // Note: If "where" is on an open bracket, then this bracket is ignored.
  //
  // Returns false when no bracket was found, null when it reached
  // maxScanLines and gave up
  function scanForBracket(cm, where, dir, style, config) {
    var maxScanLen = (config && config.maxScanLineLength) || 10000;
    var maxScanLines = (config && config.maxScanLines) || 1000;

    var stack = [];
    var re = config && config.bracketRegex ? config.bracketRegex : /[(){}[\]]/;
    var lineEnd = dir > 0 ? Math.min(where.line + maxScanLines, cm.lastLine() + 1)
                          : Math.max(cm.firstLine() - 1, where.line - maxScanLines);
    for (var lineNo = where.line; lineNo != lineEnd; lineNo += dir) {
      var line = cm.getLine(lineNo);
      if (!line) continue;
      var pos = dir > 0 ? 0 : line.length - 1, end = dir > 0 ? line.length : -1;
      if (line.length > maxScanLen) continue;
      if (lineNo == where.line) pos = where.ch - (dir < 0 ? 1 : 0);
      for (; pos != end; pos += dir) {
        var ch = line.charAt(pos);
        if (re.test(ch) && (style === undefined || cm.getTokenTypeAt(Pos(lineNo, pos + 1)) == style)) {
          var match = matching[ch];
          if ((match.charAt(1) == ">") == (dir > 0)) stack.push(ch);
          else if (!stack.length) return {pos: Pos(lineNo, pos), ch: ch};
          else stack.pop();
        }
      }
    }
    return lineNo - dir == (dir > 0 ? cm.lastLine() : cm.firstLine()) ? false : null;
  }

  function matchBrackets(cm, autoclear, config) {
    // Disable brace matching in long lines, since it'll cause hugely slow updates
    var maxHighlightLen = cm.state.matchBrackets.maxHighlightLineLength || 1000;
    var marks = [], ranges = cm.listSelections();
    for (var i = 0; i < ranges.length; i++) {
      var match = ranges[i].empty() && findMatchingBracket(cm, ranges[i].head, false, config);
      if (match && cm.getLine(match.from.line).length <= maxHighlightLen) {
        var style = match.match ? "CodeMirror-matchingbracket" : "CodeMirror-nonmatchingbracket";
        marks.push(cm.markText(match.from, Pos(match.from.line, match.from.ch + 1), {className: style}));
        if (match.to && cm.getLine(match.to.line).length <= maxHighlightLen)
          marks.push(cm.markText(match.to, Pos(match.to.line, match.to.ch + 1), {className: style}));
      }
    }

    if (marks.length) {
      // Kludge to work around the IE bug from issue #1193, where text
      // input stops going to the textare whever this fires.
      if (ie_lt8 && cm.state.focused) cm.focus();

      var clear = function() {
        cm.operation(function() {
          for (var i = 0; i < marks.length; i++) marks[i].clear();
        });
      };
      if (autoclear) setTimeout(clear, 800);
      else return clear;
    }
  }

  var currentlyHighlighted = null;
  function doMatchBrackets(cm) {
    cm.operation(function() {
      if (currentlyHighlighted) {currentlyHighlighted(); currentlyHighlighted = null;}
      currentlyHighlighted = matchBrackets(cm, false, cm.state.matchBrackets);
    });
  }

  CodeMirror.defineOption("matchBrackets", false, function(cm, val, old) {
    if (old && old != CodeMirror.Init) {
      cm.off("cursorActivity", doMatchBrackets);
      if (currentlyHighlighted) {currentlyHighlighted(); currentlyHighlighted = null;}
    }
    if (val) {
      cm.state.matchBrackets = typeof val == "object" ? val : {};
      cm.on("cursorActivity", doMatchBrackets);
    }
  });

  CodeMirror.defineExtension("matchBrackets", function() {matchBrackets(this, true);});
  CodeMirror.defineExtension("findMatchingBracket", function(pos, strict, config){
    return findMatchingBracket(this, pos, strict, config);
  });
  CodeMirror.defineExtension("scanForBracket", function(pos, dir, style, config){
    return scanForBracket(this, pos, dir, style, config);
  });
});

// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
  "use strict";

  function Bar(cls, orientation, scroll) {
    this.orientation = orientation;
    this.scroll = scroll;
    this.screen = this.total = this.size = 1;
    this.pos = 0;

    this.node = document.createElement("div");
    this.node.className = cls + "-" + orientation;
    this.inner = this.node.appendChild(document.createElement("div"));

    var self = this;
    CodeMirror.on(this.inner, "mousedown", function(e) {
      if (e.which != 1) return;
      CodeMirror.e_preventDefault(e);
      var axis = self.orientation == "horizontal" ? "pageX" : "pageY";
      var start = e[axis], startpos = self.pos;
      function done() {
        CodeMirror.off(document, "mousemove", move);
        CodeMirror.off(document, "mouseup", done);
      }
      function move(e) {
        if (e.which != 1) return done();
        self.moveTo(startpos + (e[axis] - start) * (self.total / self.size));
      }
      CodeMirror.on(document, "mousemove", move);
      CodeMirror.on(document, "mouseup", done);
    });

    CodeMirror.on(this.node, "click", function(e) {
      CodeMirror.e_preventDefault(e);
      var innerBox = self.inner.getBoundingClientRect(), where;
      if (self.orientation == "horizontal")
        where = e.clientX < innerBox.left ? -1 : e.clientX > innerBox.right ? 1 : 0;
      else
        where = e.clientY < innerBox.top ? -1 : e.clientY > innerBox.bottom ? 1 : 0;
      self.moveTo(self.pos + where * self.screen);
    });

    function onWheel(e) {
      var moved = CodeMirror.wheelEventPixels(e)[self.orientation == "horizontal" ? "x" : "y"];
      var oldPos = self.pos;
      self.moveTo(self.pos + moved);
      if (self.pos != oldPos) CodeMirror.e_preventDefault(e);
    }
    CodeMirror.on(this.node, "mousewheel", onWheel);
    CodeMirror.on(this.node, "DOMMouseScroll", onWheel);
  }

  Bar.prototype.setPos = function(pos, force) {
    if (pos < 0) pos = 0;
    if (pos > this.total - this.screen) pos = this.total - this.screen;
    if (!force && pos == this.pos) return false;
    this.pos = pos;
    this.inner.style[this.orientation == "horizontal" ? "left" : "top"] =
      (pos * (this.size / this.total)) + "px";
    return true
  };

  Bar.prototype.moveTo = function(pos) {
    if (this.setPos(pos)) this.scroll(pos, this.orientation);
  }

  var minButtonSize = 10;

  Bar.prototype.update = function(scrollSize, clientSize, barSize) {
    var sizeChanged = this.screen != clientSize || this.total != scrollSize || this.size != barSize
    if (sizeChanged) {
      this.screen = clientSize;
      this.total = scrollSize;
      this.size = barSize;
    }

    var buttonSize = this.screen * (this.size / this.total);
    if (buttonSize < minButtonSize) {
      this.size -= minButtonSize - buttonSize;
      buttonSize = minButtonSize;
    }
    this.inner.style[this.orientation == "horizontal" ? "width" : "height"] =
      buttonSize + "px";
    this.setPos(this.pos, sizeChanged);
  };

  function SimpleScrollbars(cls, place, scroll) {
    this.addClass = cls;
    this.horiz = new Bar(cls, "horizontal", scroll);
    place(this.horiz.node);
    this.vert = new Bar(cls, "vertical", scroll);
    place(this.vert.node);
    this.width = null;
  }

  SimpleScrollbars.prototype.update = function(measure) {
    if (this.width == null) {
      var style = window.getComputedStyle ? window.getComputedStyle(this.horiz.node) : this.horiz.node.currentStyle;
      if (style) this.width = parseInt(style.height);
    }
    var width = this.width || 0;

    var needsH = measure.scrollWidth > measure.clientWidth + 1;
    var needsV = measure.scrollHeight > measure.clientHeight + 1;
    this.vert.node.style.display = needsV ? "block" : "none";
    this.horiz.node.style.display = needsH ? "block" : "none";

    if (needsV) {
      this.vert.update(measure.scrollHeight, measure.clientHeight,
                       measure.viewHeight - (needsH ? width : 0));
      this.vert.node.style.bottom = needsH ? width + "px" : "0";
    }
    if (needsH) {
      this.horiz.update(measure.scrollWidth, measure.clientWidth,
                        measure.viewWidth - (needsV ? width : 0) - measure.barLeft);
      this.horiz.node.style.right = needsV ? width + "px" : "0";
      this.horiz.node.style.left = measure.barLeft + "px";
    }

    return {right: needsV ? width : 0, bottom: needsH ? width : 0};
  };

  SimpleScrollbars.prototype.setScrollTop = function(pos) {
    this.vert.setPos(pos);
  };

  SimpleScrollbars.prototype.setScrollLeft = function(pos) {
    this.horiz.setPos(pos);
  };

  SimpleScrollbars.prototype.clear = function() {
    var parent = this.horiz.node.parentNode;
    parent.removeChild(this.horiz.node);
    parent.removeChild(this.vert.node);
  };

  CodeMirror.scrollbarModel.simple = function(place, scroll) {
    return new SimpleScrollbars("CodeMirror-simplescroll", place, scroll);
  };
  CodeMirror.scrollbarModel.overlay = function(place, scroll) {
    return new SimpleScrollbars("CodeMirror-overlayscroll", place, scroll);
  };
});

// CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE

(function(mod) {
  if (typeof exports == "object" && typeof module == "object") // CommonJS
    mod(require("../../lib/codemirror"));
  else if (typeof define == "function" && define.amd) // AMD
    define(["../../lib/codemirror"], mod);
  else // Plain browser env
    mod(CodeMirror);
})(function(CodeMirror) {
  var defaults = {
    pairs: "()[]{}''\"\"",
    triples: "",
    explode: "[]{}"
  };

  var Pos = CodeMirror.Pos;

  CodeMirror.defineOption("autoCloseBrackets", false, function(cm, val, old) {
    if (old && old != CodeMirror.Init) {
      cm.removeKeyMap(keyMap);
      cm.state.closeBrackets = null;
    }
    if (val) {
      cm.state.closeBrackets = val;
      cm.addKeyMap(keyMap);
    }
  });

  function getOption(conf, name) {
    if (name == "pairs" && typeof conf == "string") return conf;
    if (typeof conf == "object" && conf[name] != null) return conf[name];
    return defaults[name];
  }

  var bind = defaults.pairs + "`";
  var keyMap = {Backspace: handleBackspace, Enter: handleEnter};
  for (var i = 0; i < bind.length; i++)
    keyMap["'" + bind.charAt(i) + "'"] = handler(bind.charAt(i));

  function handler(ch) {
    return function(cm) { return handleChar(cm, ch); };
  }

  function getConfig(cm) {
    var deflt = cm.state.closeBrackets;
    if (!deflt) return null;
    var mode = cm.getModeAt(cm.getCursor());
    return mode.closeBrackets || deflt;
  }

  function handleBackspace(cm) {
    var conf = getConfig(cm);
    if (!conf || cm.getOption("disableInput")) return CodeMirror.Pass;

    var pairs = getOption(conf, "pairs");
    var ranges = cm.listSelections();
    for (var i = 0; i < ranges.length; i++) {
      if (!ranges[i].empty()) return CodeMirror.Pass;
      var around = charsAround(cm, ranges[i].head);
      if (!around || pairs.indexOf(around) % 2 != 0) return CodeMirror.Pass;
    }
    for (var i = ranges.length - 1; i >= 0; i--) {
      var cur = ranges[i].head;
      cm.replaceRange("", Pos(cur.line, cur.ch - 1), Pos(cur.line, cur.ch + 1), "+delete");
    }
  }

  function handleEnter(cm) {
    var conf = getConfig(cm);
    var explode = conf && getOption(conf, "explode");
    if (!explode || cm.getOption("disableInput")) return CodeMirror.Pass;

    var ranges = cm.listSelections();
    for (var i = 0; i < ranges.length; i++) {
      if (!ranges[i].empty()) return CodeMirror.Pass;
      var around = charsAround(cm, ranges[i].head);
      if (!around || explode.indexOf(around) % 2 != 0) return CodeMirror.Pass;
    }
    cm.operation(function() {
      cm.replaceSelection("\n\n", null);
      cm.execCommand("goCharLeft");
      ranges = cm.listSelections();
      for (var i = 0; i < ranges.length; i++) {
        var line = ranges[i].head.line;
        cm.indentLine(line, null, true);
        cm.indentLine(line + 1, null, true);
      }
    });
  }

  function contractSelection(sel) {
    var inverted = CodeMirror.cmpPos(sel.anchor, sel.head) > 0;
    return {anchor: new Pos(sel.anchor.line, sel.anchor.ch + (inverted ? -1 : 1)),
            head: new Pos(sel.head.line, sel.head.ch + (inverted ? 1 : -1))};
  }

  function handleChar(cm, ch) {
    var conf = getConfig(cm);
    if (!conf || cm.getOption("disableInput")) return CodeMirror.Pass;

    var pairs = getOption(conf, "pairs");
    var pos = pairs.indexOf(ch);
    if (pos == -1) return CodeMirror.Pass;
    var triples = getOption(conf, "triples");

    var identical = pairs.charAt(pos + 1) == ch;
    var ranges = cm.listSelections();
    var opening = pos % 2 == 0;

    var type;
    for (var i = 0; i < ranges.length; i++) {
      var range = ranges[i], cur = range.head, curType;
      var next = cm.getRange(cur, Pos(cur.line, cur.ch + 1));
      if (opening && !range.empty()) {
        curType = "surround";
      } else if ((identical || !opening) && next == ch) {
        if (triples.indexOf(ch) >= 0 && cm.getRange(cur, Pos(cur.line, cur.ch + 3)) == ch + ch + ch)
          curType = "skipThree";
        else
          curType = "skip";
      } else if (identical && cur.ch > 1 && triples.indexOf(ch) >= 0 &&
                 cm.getRange(Pos(cur.line, cur.ch - 2), cur) == ch + ch &&
                 (cur.ch <= 2 || cm.getRange(Pos(cur.line, cur.ch - 3), Pos(cur.line, cur.ch - 2)) != ch)) {
        curType = "addFour";
      } else if (identical) {
        if (!CodeMirror.isWordChar(next) && enteringString(cm, cur, ch)) curType = "both";
        else return CodeMirror.Pass;
      } else if (opening && (cm.getLine(cur.line).length == cur.ch ||
                             isClosingBracket(next, pairs) ||
                             /\s/.test(next))) {
        curType = "both";
      } else {
        return CodeMirror.Pass;
      }
      if (!type) type = curType;
      else if (type != curType) return CodeMirror.Pass;
    }

    var left = pos % 2 ? pairs.charAt(pos - 1) : ch;
    var right = pos % 2 ? ch : pairs.charAt(pos + 1);
    cm.operation(function() {
      if (type == "skip") {
        cm.execCommand("goCharRight");
      } else if (type == "skipThree") {
        for (var i = 0; i < 3; i++)
          cm.execCommand("goCharRight");
      } else if (type == "surround") {
        var sels = cm.getSelections();
        for (var i = 0; i < sels.length; i++)
          sels[i] = left + sels[i] + right;
        cm.replaceSelections(sels, "around");
        sels = cm.listSelections().slice();
        for (var i = 0; i < sels.length; i++)
          sels[i] = contractSelection(sels[i]);
        cm.setSelections(sels);
      } else if (type == "both") {
        cm.replaceSelection(left + right, null);
        cm.triggerElectric(left + right);
        cm.execCommand("goCharLeft");
      } else if (type == "addFour") {
        cm.replaceSelection(left + left + left + left, "before");
        cm.execCommand("goCharRight");
      }
    });
  }

  function isClosingBracket(ch, pairs) {
    var pos = pairs.lastIndexOf(ch);
    return pos > -1 && pos % 2 == 1;
  }

  function charsAround(cm, pos) {
    var str = cm.getRange(Pos(pos.line, pos.ch - 1),
                          Pos(pos.line, pos.ch + 1));
    return str.length == 2 ? str : null;
  }

  // Project the token type that will exists after the given char is
  // typed, and use it to determine whether it would cause the start
  // of a string token.
  function enteringString(cm, pos, ch) {
    var line = cm.getLine(pos.line);
    var token = cm.getTokenAt(pos);
    if (/\bstring2?\b/.test(token.type)) return false;
    var stream = new CodeMirror.StringStream(line.slice(0, pos.ch) + ch + line.slice(pos.ch), 4);
    stream.pos = stream.start = token.start;
    for (;;) {
      var type1 = cm.getMode().token(stream, token.state);
      if (stream.pos >= pos.ch + 1) return /\bstring2?\b/.test(type1);
      stream.start = stream.pos;
    }
  }
});

;(function(){
var h, aa = aa || {}, ca = this;
function da(a) {
  return void 0 !== a;
}
function ea() {
}
function p(a) {
  var b = typeof a;
  if ("object" == b) {
    if (a) {
      if (a instanceof Array) {
        return "array";
      }
      if (a instanceof Object) {
        return b;
      }
      var c = Object.prototype.toString.call(a);
      if ("[object Window]" == c) {
        return "object";
      }
      if ("[object Array]" == c || "number" == typeof a.length && "undefined" != typeof a.splice && "undefined" != typeof a.propertyIsEnumerable && !a.propertyIsEnumerable("splice")) {
        return "array";
      }
      if ("[object Function]" == c || "undefined" != typeof a.call && "undefined" != typeof a.propertyIsEnumerable && !a.propertyIsEnumerable("call")) {
        return "function";
      }
    } else {
      return "null";
    }
  } else {
    if ("function" == b && "undefined" == typeof a.call) {
      return "object";
    }
  }
  return b;
}
function fa(a) {
  return "array" == p(a);
}
function ga(a) {
  var b = p(a);
  return "array" == b || "object" == b && "number" == typeof a.length;
}
function ha(a) {
  return "string" == typeof a;
}
function ja(a) {
  return "function" == p(a);
}
function ka(a) {
  var b = typeof a;
  return "object" == b && null != a || "function" == b;
}
function la(a) {
  return a[ma] || (a[ma] = ++na);
}
var ma = "closure_uid_" + (1E9 * Math.random() >>> 0), na = 0;
function oa(a, b, c) {
  return a.call.apply(a.bind, arguments);
}
function qa(a, b, c) {
  if (!a) {
    throw Error();
  }
  if (2 < arguments.length) {
    var d = Array.prototype.slice.call(arguments, 2);
    return function() {
      var c = Array.prototype.slice.call(arguments);
      Array.prototype.unshift.apply(c, d);
      return a.apply(b, c);
    };
  }
  return function() {
    return a.apply(b, arguments);
  };
}
function sa(a, b, c) {
  sa = Function.prototype.bind && -1 != Function.prototype.bind.toString().indexOf("native code") ? oa : qa;
  return sa.apply(null, arguments);
}
var ta = Date.now || function() {
  return +new Date;
};
function ua(a, b) {
  var c = a.split("."), d = ca;
  c[0] in d || !d.execScript || d.execScript("var " + c[0]);
  for (var e;c.length && (e = c.shift());) {
    !c.length && da(b) ? d[e] = b : d = d[e] ? d[e] : d[e] = {};
  }
}
function wa(a, b) {
  function c() {
  }
  c.prototype = b.prototype;
  a.Vf = b.prototype;
  a.prototype = new c;
  a.prototype.constructor = a;
  a.base = function(a, c, f) {
    for (var d = Array(arguments.length - 2), e = 2;e < arguments.length;e++) {
      d[e - 2] = arguments[e];
    }
    return b.prototype[c].apply(a, d);
  };
}
;function xa(a, b) {
  for (var c = a.split("%s"), d = "", e = Array.prototype.slice.call(arguments, 1);e.length && 1 < c.length;) {
    d += c.shift() + e.shift();
  }
  return d + c.join("%s");
}
function ya(a) {
  return /^[\s\xa0]*$/.test(a);
}
var Ba = String.prototype.trim ? function(a) {
  return a.trim();
} : function(a) {
  return a.replace(/^[\s\xa0]+|[\s\xa0]+$/g, "");
};
function Ca(a) {
  if (!Da.test(a)) {
    return a;
  }
  -1 != a.indexOf("\x26") && (a = a.replace(Ea, "\x26amp;"));
  -1 != a.indexOf("\x3c") && (a = a.replace(Fa, "\x26lt;"));
  -1 != a.indexOf("\x3e") && (a = a.replace(Ga, "\x26gt;"));
  -1 != a.indexOf('"') && (a = a.replace(Ha, "\x26quot;"));
  -1 != a.indexOf("'") && (a = a.replace(Ia, "\x26#39;"));
  -1 != a.indexOf("\x00") && (a = a.replace(Ka, "\x26#0;"));
  return a;
}
var Ea = /&/g, Fa = /</g, Ga = />/g, Ha = /"/g, Ia = /'/g, Ka = /\x00/g, Da = /[\x00&<>"']/;
function Ma(a) {
  return null == a ? "" : String(a);
}
function Oa(a, b) {
  return a < b ? -1 : a > b ? 1 : 0;
}
;function Ra(a, b) {
  for (var c in a) {
    b.call(void 0, a[c], c, a);
  }
}
function Sa(a, b) {
  for (var c in a) {
    if (b.call(void 0, a[c], c, a)) {
      return !0;
    }
  }
  return !1;
}
function Ta(a) {
  var b = [], c = 0, d;
  for (d in a) {
    b[c++] = a[d];
  }
  return b;
}
function Ua(a) {
  var b = [], c = 0, d;
  for (d in a) {
    b[c++] = d;
  }
  return b;
}
var Va = "constructor hasOwnProperty isPrototypeOf propertyIsEnumerable toLocaleString toString valueOf".split(" ");
function Wa(a, b) {
  for (var c, d, e = 1;e < arguments.length;e++) {
    d = arguments[e];
    for (c in d) {
      a[c] = d[c];
    }
    for (var f = 0;f < Va.length;f++) {
      c = Va[f], Object.prototype.hasOwnProperty.call(d, c) && (a[c] = d[c]);
    }
  }
}
;function Xa(a, b) {
  this.pa = [];
  this.Ab = b;
  for (var c = !0, d = a.length - 1;0 <= d;d--) {
    var e = a[d] | 0;
    c && e == b || (this.pa[d] = e, c = !1);
  }
}
var Ya = {};
function Za(a) {
  if (-128 <= a && 128 > a) {
    var b = Ya[a];
    if (b) {
      return b;
    }
  }
  b = new Xa([a | 0], 0 > a ? -1 : 0);
  -128 <= a && 128 > a && (Ya[a] = b);
  return b;
}
function $a(a) {
  if (isNaN(a) || !isFinite(a)) {
    return bb;
  }
  if (0 > a) {
    return $a(-a).da();
  }
  for (var b = [], c = 1, d = 0;a >= c;d++) {
    b[d] = a / c | 0, c *= cb;
  }
  return new Xa(b, 0);
}
var cb = 4294967296, bb = Za(0), db = Za(1), eb = Za(16777216);
h = Xa.prototype;
h.Pd = function() {
  return 0 < this.pa.length ? this.pa[0] : this.Ab;
};
h.Ob = function() {
  if (this.sa()) {
    return -this.da().Ob();
  }
  for (var a = 0, b = 1, c = 0;c < this.pa.length;c++) {
    var d = fb(this, c), a = a + (0 <= d ? d : cb + d) * b, b = b * cb
  }
  return a;
};
h.toString = function(a) {
  a = a || 10;
  if (2 > a || 36 < a) {
    throw Error("radix out of range: " + a);
  }
  if (this.Za()) {
    return "0";
  }
  if (this.sa()) {
    return "-" + this.da().toString(a);
  }
  for (var b = $a(Math.pow(a, 6)), c = this, d = "";;) {
    var e = gb(c, b), f = (c.ec(e.multiply(b)).Pd() >>> 0).toString(a), c = e;
    if (c.Za()) {
      return f + d;
    }
    for (;6 > f.length;) {
      f = "0" + f;
    }
    d = "" + f + d;
  }
};
function fb(a, b) {
  return 0 > b ? 0 : b < a.pa.length ? a.pa[b] : a.Ab;
}
h.Za = function() {
  if (0 != this.Ab) {
    return !1;
  }
  for (var a = 0;a < this.pa.length;a++) {
    if (0 != this.pa[a]) {
      return !1;
    }
  }
  return !0;
};
h.sa = function() {
  return -1 == this.Ab;
};
h.Oe = function() {
  return 0 == this.pa.length && -1 == this.Ab || 0 < this.pa.length && 0 != (this.pa[0] & 1);
};
h.eb = function(a) {
  if (this.Ab != a.Ab) {
    return !1;
  }
  for (var b = Math.max(this.pa.length, a.pa.length), c = 0;c < b;c++) {
    if (fb(this, c) != fb(a, c)) {
      return !1;
    }
  }
  return !0;
};
h.ce = function(a) {
  return 0 < this.compare(a);
};
h.Le = function(a) {
  return 0 <= this.compare(a);
};
h.Zc = function(a) {
  return 0 > this.compare(a);
};
h.Pe = function(a) {
  return 0 >= this.compare(a);
};
h.compare = function(a) {
  a = this.ec(a);
  return a.sa() ? -1 : a.Za() ? 0 : 1;
};
h.da = function() {
  return this.Qe().add(db);
};
h.add = function(a) {
  for (var b = Math.max(this.pa.length, a.pa.length), c = [], d = 0, e = 0;e <= b;e++) {
    var f = d + (fb(this, e) & 65535) + (fb(a, e) & 65535), g = (f >>> 16) + (fb(this, e) >>> 16) + (fb(a, e) >>> 16), d = g >>> 16, f = f & 65535, g = g & 65535;
    c[e] = g << 16 | f;
  }
  return new Xa(c, c[c.length - 1] & -2147483648 ? -1 : 0);
};
h.ec = function(a) {
  return this.add(a.da());
};
h.multiply = function(a) {
  if (this.Za() || a.Za()) {
    return bb;
  }
  if (this.sa()) {
    return a.sa() ? this.da().multiply(a.da()) : this.da().multiply(a).da();
  }
  if (a.sa()) {
    return this.multiply(a.da()).da();
  }
  if (this.Zc(eb) && a.Zc(eb)) {
    return $a(this.Ob() * a.Ob());
  }
  for (var b = this.pa.length + a.pa.length, c = [], d = 0;d < 2 * b;d++) {
    c[d] = 0;
  }
  for (d = 0;d < this.pa.length;d++) {
    for (var e = 0;e < a.pa.length;e++) {
      var f = fb(this, d) >>> 16, g = fb(this, d) & 65535, k = fb(a, e) >>> 16, l = fb(a, e) & 65535;
      c[2 * d + 2 * e] += g * l;
      ib(c, 2 * d + 2 * e);
      c[2 * d + 2 * e + 1] += f * l;
      ib(c, 2 * d + 2 * e + 1);
      c[2 * d + 2 * e + 1] += g * k;
      ib(c, 2 * d + 2 * e + 1);
      c[2 * d + 2 * e + 2] += f * k;
      ib(c, 2 * d + 2 * e + 2);
    }
  }
  for (d = 0;d < b;d++) {
    c[d] = c[2 * d + 1] << 16 | c[2 * d];
  }
  for (d = b;d < 2 * b;d++) {
    c[d] = 0;
  }
  return new Xa(c, 0);
};
function ib(a, b) {
  for (;(a[b] & 65535) != a[b];) {
    a[b + 1] += a[b] >>> 16, a[b] &= 65535;
  }
}
function gb(a, b) {
  if (b.Za()) {
    throw Error("division by zero");
  }
  if (a.Za()) {
    return bb;
  }
  if (a.sa()) {
    return b.sa() ? gb(a.da(), b.da()) : gb(a.da(), b).da();
  }
  if (b.sa()) {
    return gb(a, b.da()).da();
  }
  if (30 < a.pa.length) {
    if (a.sa() || b.sa()) {
      throw Error("slowDivide_ only works with positive integers.");
    }
    for (var c = db, d = b;d.Pe(a);) {
      c = c.shiftLeft(1), d = d.shiftLeft(1);
    }
    for (var e = c.uc(1), f = d.uc(1), g, d = d.uc(2), c = c.uc(2);!d.Za();) {
      g = f.add(d), g.Pe(a) && (e = e.add(c), f = g), d = d.uc(1), c = c.uc(1);
    }
    return e;
  }
  c = bb;
  for (d = a;d.Le(b);) {
    e = Math.max(1, Math.floor(d.Ob() / b.Ob()));
    f = Math.ceil(Math.log(e) / Math.LN2);
    f = 48 >= f ? 1 : Math.pow(2, f - 48);
    g = $a(e);
    for (var k = g.multiply(b);k.sa() || k.ce(d);) {
      e -= f, g = $a(e), k = g.multiply(b);
    }
    g.Za() && (g = db);
    c = c.add(g);
    d = d.ec(k);
  }
  return c;
}
h.Qe = function() {
  for (var a = this.pa.length, b = [], c = 0;c < a;c++) {
    b[c] = ~this.pa[c];
  }
  return new Xa(b, ~this.Ab);
};
h.df = function(a) {
  for (var b = Math.max(this.pa.length, a.pa.length), c = [], d = 0;d < b;d++) {
    c[d] = fb(this, d) & fb(a, d);
  }
  return new Xa(c, this.Ab & a.Ab);
};
h.shiftLeft = function(a) {
  var b = a >> 5;
  a %= 32;
  for (var c = this.pa.length + b + (0 < a ? 1 : 0), d = [], e = 0;e < c;e++) {
    d[e] = 0 < a ? fb(this, e - b) << a | fb(this, e - b - 1) >>> 32 - a : fb(this, e - b);
  }
  return new Xa(d, this.Ab);
};
h.uc = function(a) {
  var b = a >> 5;
  a %= 32;
  for (var c = this.pa.length - b, d = [], e = 0;e < c;e++) {
    d[e] = 0 < a ? fb(this, e + b) >>> a | fb(this, e + b + 1) << 32 - a : fb(this, e + b);
  }
  return new Xa(d, this.Ab);
};
function jb(a, b) {
  null != a && this.append.apply(this, arguments);
}
h = jb.prototype;
h.ic = "";
h.set = function(a) {
  this.ic = "" + a;
};
h.append = function(a, b, c) {
  this.ic += String(a);
  if (null != b) {
    for (var d = 1;d < arguments.length;d++) {
      this.ic += arguments[d];
    }
  }
  return this;
};
h.clear = function() {
  this.ic = "";
};
h.toString = function() {
  return this.ic;
};
function kb(a) {
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, kb);
  } else {
    var b = Error().stack;
    b && (this.stack = b);
  }
  a && (this.message = String(a));
}
wa(kb, Error);
kb.prototype.name = "CustomError";
function lb(a, b) {
  b.unshift(a);
  kb.call(this, xa.apply(null, b));
  b.shift();
}
wa(lb, kb);
lb.prototype.name = "AssertionError";
function mb(a, b) {
  throw new lb("Failure" + (a ? ": " + a : ""), Array.prototype.slice.call(arguments, 1));
}
;var nb = Array.prototype.indexOf ? function(a, b, c) {
  return Array.prototype.indexOf.call(a, b, c);
} : function(a, b, c) {
  c = null == c ? 0 : 0 > c ? Math.max(0, a.length + c) : c;
  if (ha(a)) {
    return ha(b) && 1 == b.length ? a.indexOf(b, c) : -1;
  }
  for (;c < a.length;c++) {
    if (c in a && a[c] === b) {
      return c;
    }
  }
  return -1;
}, ob = Array.prototype.forEach ? function(a, b, c) {
  Array.prototype.forEach.call(a, b, c);
} : function(a, b, c) {
  for (var d = a.length, e = ha(a) ? a.split("") : a, f = 0;f < d;f++) {
    f in e && b.call(c, e[f], f, a);
  }
}, pb = Array.prototype.some ? function(a, b, c) {
  return Array.prototype.some.call(a, b, c);
} : function(a, b, c) {
  for (var d = a.length, e = ha(a) ? a.split("") : a, f = 0;f < d;f++) {
    if (f in e && b.call(c, e[f], f, a)) {
      return !0;
    }
  }
  return !1;
};
function qb(a) {
  var b;
  a: {
    b = rb;
    for (var c = a.length, d = ha(a) ? a.split("") : a, e = 0;e < c;e++) {
      if (e in d && b.call(void 0, d[e], e, a)) {
        b = e;
        break a;
      }
    }
    b = -1;
  }
  return 0 > b ? null : ha(a) ? a.charAt(b) : a[b];
}
function sb(a) {
  return Array.prototype.concat.apply(Array.prototype, arguments);
}
function tb(a) {
  var b = a.length;
  if (0 < b) {
    for (var c = Array(b), d = 0;d < b;d++) {
      c[d] = a[d];
    }
    return c;
  }
  return [];
}
function ub(a, b) {
  a.sort(b || wb);
}
function xb(a, b) {
  for (var c = Array(a.length), d = 0;d < a.length;d++) {
    c[d] = {index:d, value:a[d]};
  }
  var e = b || wb;
  ub(c, function(a, b) {
    return e(a.value, b.value) || a.index - b.index;
  });
  for (d = 0;d < a.length;d++) {
    a[d] = c[d].value;
  }
}
function wb(a, b) {
  return a > b ? 1 : a < b ? -1 : 0;
}
;function yb(a) {
  yb[" "](a);
  return a;
}
yb[" "] = ea;
function zb(a, b, c) {
  return Object.prototype.hasOwnProperty.call(a, b) ? a[b] : a[b] = c(b);
}
;function Ab(a, b) {
  this.Ba = a | 0;
  this.Ta = b | 0;
}
var Bb = {}, Cb = {};
function Db(a) {
  return -128 <= a && 128 > a ? zb(Bb, a, function(a) {
    return new Ab(a | 0, 0 > a ? -1 : 0);
  }) : new Ab(a | 0, 0 > a ? -1 : 0);
}
function Eb(a) {
  return isNaN(a) ? Fb() : a <= -Gb ? Ib() : a + 1 >= Gb ? Jb() : 0 > a ? Eb(-a).da() : new Ab(a % Kb | 0, a / Kb | 0);
}
function Lb(a, b) {
  return new Ab(a, b);
}
function Mb(a, b) {
  if (0 == a.length) {
    throw Error("number format error: empty string");
  }
  var c = b || 10;
  if (2 > c || 36 < c) {
    throw Error("radix out of range: " + c);
  }
  if ("-" == a.charAt(0)) {
    return Mb(a.substring(1), c).da();
  }
  if (0 <= a.indexOf("-")) {
    throw Error('number format error: interior "-" character: ' + a);
  }
  for (var d = Eb(Math.pow(c, 8)), e = Fb(), f = 0;f < a.length;f += 8) {
    var g = Math.min(8, a.length - f), k = parseInt(a.substring(f, f + g), c);
    8 > g ? (g = Eb(Math.pow(c, g)), e = e.multiply(g).add(Eb(k))) : (e = e.multiply(d), e = e.add(Eb(k)));
  }
  return e;
}
var Kb = 4294967296, Gb = Kb * Kb / 2;
function Fb() {
  return zb(Cb, Nb, function() {
    return Db(0);
  });
}
function Ob() {
  return zb(Cb, Pb, function() {
    return Db(1);
  });
}
function Qb() {
  return zb(Cb, Rb, function() {
    return Db(-1);
  });
}
function Jb() {
  return zb(Cb, Sb, function() {
    return Lb(-1, 2147483647);
  });
}
function Ib() {
  return zb(Cb, Tb, function() {
    return Lb(0, -2147483648);
  });
}
function Ub() {
  return zb(Cb, Vb, function() {
    return Db(16777216);
  });
}
h = Ab.prototype;
h.Pd = function() {
  return this.Ba;
};
h.Ob = function() {
  return this.Ta * Kb + (0 <= this.Ba ? this.Ba : Kb + this.Ba);
};
h.toString = function(a) {
  a = a || 10;
  if (2 > a || 36 < a) {
    throw Error("radix out of range: " + a);
  }
  if (this.Za()) {
    return "0";
  }
  if (this.sa()) {
    if (this.eb(Ib())) {
      var b = Eb(a), c = this.div(b), b = c.multiply(b).ec(this);
      return c.toString(a) + b.Pd().toString(a);
    }
    return "-" + this.da().toString(a);
  }
  for (var c = Eb(Math.pow(a, 6)), b = this, d = "";;) {
    var e = b.div(c), f = (b.ec(e.multiply(c)).Pd() >>> 0).toString(a), b = e;
    if (b.Za()) {
      return f + d;
    }
    for (;6 > f.length;) {
      f = "0" + f;
    }
    d = "" + f + d;
  }
};
h.Za = function() {
  return 0 == this.Ta && 0 == this.Ba;
};
h.sa = function() {
  return 0 > this.Ta;
};
h.Oe = function() {
  return 1 == (this.Ba & 1);
};
h.eb = function(a) {
  return this.Ta == a.Ta && this.Ba == a.Ba;
};
h.Zc = function(a) {
  return 0 > this.compare(a);
};
h.Pe = function(a) {
  return 0 >= this.compare(a);
};
h.ce = function(a) {
  return 0 < this.compare(a);
};
h.Le = function(a) {
  return 0 <= this.compare(a);
};
h.compare = function(a) {
  if (this.eb(a)) {
    return 0;
  }
  var b = this.sa(), c = a.sa();
  return b && !c ? -1 : !b && c ? 1 : this.ec(a).sa() ? -1 : 1;
};
h.da = function() {
  return this.eb(Ib()) ? Ib() : this.Qe().add(Ob());
};
h.add = function(a) {
  var b = this.Ta >>> 16, c = this.Ta & 65535, d = this.Ba >>> 16, e = a.Ta >>> 16, f = a.Ta & 65535, g = a.Ba >>> 16;
  a = 0 + ((this.Ba & 65535) + (a.Ba & 65535));
  g = 0 + (a >>> 16) + (d + g);
  d = 0 + (g >>> 16);
  d += c + f;
  b = 0 + (d >>> 16) + (b + e) & 65535;
  return Lb((g & 65535) << 16 | a & 65535, b << 16 | d & 65535);
};
h.ec = function(a) {
  return this.add(a.da());
};
h.multiply = function(a) {
  if (this.Za() || a.Za()) {
    return Fb();
  }
  if (this.eb(Ib())) {
    return a.Oe() ? Ib() : Fb();
  }
  if (a.eb(Ib())) {
    return this.Oe() ? Ib() : Fb();
  }
  if (this.sa()) {
    return a.sa() ? this.da().multiply(a.da()) : this.da().multiply(a).da();
  }
  if (a.sa()) {
    return this.multiply(a.da()).da();
  }
  if (this.Zc(Ub()) && a.Zc(Ub())) {
    return Eb(this.Ob() * a.Ob());
  }
  var b = this.Ta >>> 16, c = this.Ta & 65535, d = this.Ba >>> 16, e = this.Ba & 65535, f = a.Ta >>> 16, g = a.Ta & 65535, k = a.Ba >>> 16;
  a = a.Ba & 65535;
  var l, m, n, t;
  t = 0 + e * a;
  n = 0 + (t >>> 16) + d * a;
  m = 0 + (n >>> 16);
  n = (n & 65535) + e * k;
  m += n >>> 16;
  m += c * a;
  l = 0 + (m >>> 16);
  m = (m & 65535) + d * k;
  l += m >>> 16;
  m = (m & 65535) + e * g;
  l = l + (m >>> 16) + (b * a + c * k + d * g + e * f) & 65535;
  return Lb((n & 65535) << 16 | t & 65535, l << 16 | m & 65535);
};
h.div = function(a) {
  if (a.Za()) {
    throw Error("division by zero");
  }
  if (this.Za()) {
    return Fb();
  }
  if (this.eb(Ib())) {
    if (a.eb(Ob()) || a.eb(Qb())) {
      return Ib();
    }
    if (a.eb(Ib())) {
      return Ob();
    }
    var b = this.uc(1).div(a).shiftLeft(1);
    if (b.eb(Fb())) {
      return a.sa() ? Ob() : Qb();
    }
    var c = this.ec(a.multiply(b));
    return b.add(c.div(a));
  }
  if (a.eb(Ib())) {
    return Fb();
  }
  if (this.sa()) {
    return a.sa() ? this.da().div(a.da()) : this.da().div(a).da();
  }
  if (a.sa()) {
    return this.div(a.da()).da();
  }
  for (var d = Fb(), c = this;c.Le(a);) {
    for (var b = Math.max(1, Math.floor(c.Ob() / a.Ob())), e = Math.ceil(Math.log(b) / Math.LN2), e = 48 >= e ? 1 : Math.pow(2, e - 48), f = Eb(b), g = f.multiply(a);g.sa() || g.ce(c);) {
      b -= e, f = Eb(b), g = f.multiply(a);
    }
    f.Za() && (f = Ob());
    d = d.add(f);
    c = c.ec(g);
  }
  return d;
};
h.Qe = function() {
  return Lb(~this.Ba, ~this.Ta);
};
h.df = function(a) {
  return Lb(this.Ba & a.Ba, this.Ta & a.Ta);
};
h.shiftLeft = function(a) {
  a &= 63;
  if (0 == a) {
    return this;
  }
  var b = this.Ba;
  return 32 > a ? Lb(b << a, this.Ta << a | b >>> 32 - a) : Lb(0, b << a - 32);
};
h.uc = function(a) {
  a &= 63;
  if (0 == a) {
    return this;
  }
  var b = this.Ta;
  return 32 > a ? Lb(this.Ba >>> a | b << 32 - a, b >> a) : Lb(b >> a - 32, 0 <= b ? 0 : -1);
};
function Wb(a, b) {
  b &= 63;
  if (0 == b) {
    return a;
  }
  var c = a.Ta;
  return 32 > b ? Lb(a.Ba >>> b | c << 32 - b, c >>> b) : 32 == b ? Lb(c, 0) : Lb(c >>> b - 32, 0);
}
var Sb = 1, Tb = 2, Nb = 3, Pb = 4, Rb = 5, Vb = 6;
var Xb;
if ("undefined" === typeof q) {
  var q = {}
}
if ("undefined" === typeof Yb) {
  var Yb = function() {
    throw Error("No *print-fn* fn set for evaluation environment");
  }
}
if ("undefined" === typeof Zb) {
  var Zb = function() {
    throw Error("No *print-err-fn* fn set for evaluation environment");
  }
}
var ac = null;
if ("undefined" === typeof bc) {
  var bc = null
}
function cc() {
  return new u(null, 5, [dc, !0, ec, !0, fc, !1, gc, !1, hc, null], null);
}
function w(a) {
  return null != a && !1 !== a;
}
function ic(a) {
  return null == a;
}
function jc(a) {
  return a instanceof Array;
}
function kc(a) {
  return null == a ? !0 : !1 === a ? !0 : !1;
}
function lc(a) {
  return ha(a);
}
function mc() {
  return !0;
}
function oc(a, b) {
  return a[p(null == b ? null : b)] ? !0 : a._ ? !0 : !1;
}
function pc(a) {
  return null == a ? null : a.constructor;
}
function qc(a, b) {
  var c = pc(b), c = w(w(c) ? c.Db : c) ? c.ob : p(b);
  return Error(["No protocol method ", a, " defined for type ", c, ": ", b].join(""));
}
function rc(a) {
  var b = a.ob;
  return w(b) ? b : "" + y(a);
}
var sc = "undefined" !== typeof Symbol && "function" === p(Symbol) ? Symbol.iterator : "@@iterator";
function tc(a) {
  for (var b = a.length, c = Array(b), d = 0;;) {
    if (d < b) {
      c[d] = a[d], d += 1;
    } else {
      break;
    }
  }
  return c;
}
function uc(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return vc(arguments[0]);
    case 2:
      return vc(arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function wc(a) {
  return vc(a);
}
function vc(a) {
  function b(a, b) {
    a.push(b);
    return a;
  }
  var c = [];
  return xc ? xc(b, c, a) : yc.call(null, b, c, a);
}
function zc() {
}
var Ac = function Ac(b) {
  if (null != b && null != b.Xa) {
    return b.Xa(b);
  }
  var c = Ac[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Ac._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ICloneable.-clone", b);
};
function Cc() {
}
var Dc = function Dc(b) {
  if (null != b && null != b.ja) {
    return b.ja(b);
  }
  var c = Dc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Dc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ICounted.-count", b);
}, Ec = function Ec(b) {
  if (null != b && null != b.na) {
    return b.na(b);
  }
  var c = Ec[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Ec._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IEmptyableCollection.-empty", b);
};
function Fc() {
}
var Gc = function Gc(b, c) {
  if (null != b && null != b.fa) {
    return b.fa(b, c);
  }
  var d = Gc[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Gc._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("ICollection.-conj", b);
};
function Hc() {
}
var Ic = function Ic(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return Ic.j(arguments[0], arguments[1]);
    case 3:
      return Ic.l(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Ic.j = function(a, b) {
  if (null != a && null != a.aa) {
    return a.aa(a, b);
  }
  var c = Ic[p(null == a ? null : a)];
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  c = Ic._;
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  throw qc("IIndexed.-nth", a);
};
Ic.l = function(a, b, c) {
  if (null != a && null != a.cb) {
    return a.cb(a, b, c);
  }
  var d = Ic[p(null == a ? null : a)];
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  d = Ic._;
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  throw qc("IIndexed.-nth", a);
};
Ic.L = 3;
function Jc() {
}
var Kc = function Kc(b) {
  if (null != b && null != b.za) {
    return b.za(b);
  }
  var c = Kc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Kc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ISeq.-first", b);
}, Lc = function Lc(b) {
  if (null != b && null != b.Ra) {
    return b.Ra(b);
  }
  var c = Lc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Lc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ISeq.-rest", b);
};
function Mc() {
}
function Nc() {
}
var Oc = function Oc(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return Oc.j(arguments[0], arguments[1]);
    case 3:
      return Oc.l(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Oc.j = function(a, b) {
  if (null != a && null != a.R) {
    return a.R(a, b);
  }
  var c = Oc[p(null == a ? null : a)];
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  c = Oc._;
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  throw qc("ILookup.-lookup", a);
};
Oc.l = function(a, b, c) {
  if (null != a && null != a.N) {
    return a.N(a, b, c);
  }
  var d = Oc[p(null == a ? null : a)];
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  d = Oc._;
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  throw qc("ILookup.-lookup", a);
};
Oc.L = 3;
function Pc() {
}
var Qc = function Qc(b, c) {
  if (null != b && null != b.Ud) {
    return b.Ud(b, c);
  }
  var d = Qc[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Qc._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IAssociative.-contains-key?", b);
}, Rc = function Rc(b, c, d) {
  if (null != b && null != b.Qb) {
    return b.Qb(b, c, d);
  }
  var e = Rc[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = Rc._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("IAssociative.-assoc", b);
};
function Sc() {
}
var Tc = function Tc(b, c) {
  if (null != b && null != b.Tc) {
    return b.Tc(b, c);
  }
  var d = Tc[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Tc._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IMap.-dissoc", b);
};
function Uc() {
}
var Vc = function Vc(b) {
  if (null != b && null != b.nd) {
    return b.nd(b);
  }
  var c = Vc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Vc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IMapEntry.-key", b);
}, Wc = function Wc(b) {
  if (null != b && null != b.od) {
    return b.od(b);
  }
  var c = Wc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Wc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IMapEntry.-val", b);
};
function Xc() {
}
var Yc = function Yc(b) {
  if (null != b && null != b.kc) {
    return b.kc(b);
  }
  var c = Yc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Yc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IStack.-peek", b);
}, Zc = function Zc(b) {
  if (null != b && null != b.lc) {
    return b.lc(b);
  }
  var c = Zc[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Zc._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IStack.-pop", b);
};
function $c() {
}
var ad = function ad(b, c, d) {
  if (null != b && null != b.Ac) {
    return b.Ac(b, c, d);
  }
  var e = ad[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = ad._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("IVector.-assoc-n", b);
}, bd = function bd(b) {
  if (null != b && null != b.ld) {
    return b.ld(b);
  }
  var c = bd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = bd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IDeref.-deref", b);
};
function cd() {
}
var dd = function dd(b) {
  if (null != b && null != b.S) {
    return b.S(b);
  }
  var c = dd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = dd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IMeta.-meta", b);
};
function ed() {
}
var fd = function fd(b, c) {
  if (null != b && null != b.T) {
    return b.T(b, c);
  }
  var d = fd[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = fd._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IWithMeta.-with-meta", b);
};
function gd() {
}
var hd = function hd(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return hd.j(arguments[0], arguments[1]);
    case 3:
      return hd.l(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
hd.j = function(a, b) {
  if (null != a && null != a.xa) {
    return a.xa(a, b);
  }
  var c = hd[p(null == a ? null : a)];
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  c = hd._;
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  throw qc("IReduce.-reduce", a);
};
hd.l = function(a, b, c) {
  if (null != a && null != a.ya) {
    return a.ya(a, b, c);
  }
  var d = hd[p(null == a ? null : a)];
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  d = hd._;
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  throw qc("IReduce.-reduce", a);
};
hd.L = 3;
var id = function id(b, c, d) {
  if (null != b && null != b.Sc) {
    return b.Sc(b, c, d);
  }
  var e = id[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = id._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("IKVReduce.-kv-reduce", b);
}, jd = function jd(b, c) {
  if (null != b && null != b.I) {
    return b.I(b, c);
  }
  var d = jd[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = jd._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IEquiv.-equiv", b);
}, kd = function kd(b) {
  if (null != b && null != b.V) {
    return b.V(b);
  }
  var c = kd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = kd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IHash.-hash", b);
};
function ld() {
}
var md = function md(b) {
  if (null != b && null != b.ea) {
    return b.ea(b);
  }
  var c = md[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = md._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ISeqable.-seq", b);
};
function nd() {
}
function od() {
}
function pd() {
}
function rd() {
}
var sd = function sd(b) {
  if (null != b && null != b.Uc) {
    return b.Uc(b);
  }
  var c = sd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = sd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IReversible.-rseq", b);
}, td = function td(b, c) {
  if (null != b && null != b.tf) {
    return b.tf(0, c);
  }
  var d = td[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = td._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IWriter.-write", b);
}, ud = function ud(b, c, d) {
  if (null != b && null != b.sf) {
    return b.sf(0, c, d);
  }
  var e = ud[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = ud._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("IWatchable.-notify-watches", b);
}, vd = function vd(b) {
  if (null != b && null != b.Rc) {
    return b.Rc(b);
  }
  var c = vd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = vd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IEditableCollection.-as-transient", b);
}, wd = function wd(b, c) {
  if (null != b && null != b.sd) {
    return b.sd(b, c);
  }
  var d = wd[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = wd._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("ITransientCollection.-conj!", b);
}, xd = function xd(b) {
  if (null != b && null != b.ud) {
    return b.ud(b);
  }
  var c = xd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = xd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("ITransientCollection.-persistent!", b);
}, yd = function yd(b, c, d) {
  if (null != b && null != b.rd) {
    return b.rd(b, c, d);
  }
  var e = yd[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = yd._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("ITransientAssociative.-assoc!", b);
}, zd = function zd(b, c, d) {
  if (null != b && null != b.qf) {
    return b.qf(0, c, d);
  }
  var e = zd[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = zd._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("ITransientVector.-assoc-n!", b);
};
function Ad() {
}
var Bd = function Bd(b, c) {
  if (null != b && null != b.Zb) {
    return b.Zb(b, c);
  }
  var d = Bd[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Bd._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IComparable.-compare", b);
}, Cd = function Cd(b) {
  if (null != b && null != b.lf) {
    return b.lf();
  }
  var c = Cd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Cd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IChunk.-drop-first", b);
}, Dd = function Dd(b) {
  if (null != b && null != b.ye) {
    return b.ye(b);
  }
  var c = Dd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Dd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IChunkedSeq.-chunked-first", b);
}, Ed = function Ed(b) {
  if (null != b && null != b.ze) {
    return b.ze(b);
  }
  var c = Ed[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Ed._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IChunkedSeq.-chunked-rest", b);
}, Fd = function Fd(b) {
  if (null != b && null != b.xe) {
    return b.xe(b);
  }
  var c = Fd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Fd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IChunkedNext.-chunked-next", b);
}, Gd = function Gd(b) {
  if (null != b && null != b.pd) {
    return b.pd(b);
  }
  var c = Gd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Gd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("INamed.-name", b);
}, Hd = function Hd(b) {
  if (null != b && null != b.qd) {
    return b.qd(b);
  }
  var c = Hd[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Hd._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("INamed.-namespace", b);
}, Id = function Id(b, c) {
  if (null != b && null != b.mg) {
    return b.mg(b, c);
  }
  var d = Id[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Id._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IReset.-reset!", b);
}, Jd = function Jd(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return Jd.j(arguments[0], arguments[1]);
    case 3:
      return Jd.l(arguments[0], arguments[1], arguments[2]);
    case 4:
      return Jd.H(arguments[0], arguments[1], arguments[2], arguments[3]);
    case 5:
      return Jd.O(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Jd.j = function(a, b) {
  if (null != a && null != a.og) {
    return a.og(a, b);
  }
  var c = Jd[p(null == a ? null : a)];
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  c = Jd._;
  if (null != c) {
    return c.j ? c.j(a, b) : c.call(null, a, b);
  }
  throw qc("ISwap.-swap!", a);
};
Jd.l = function(a, b, c) {
  if (null != a && null != a.pg) {
    return a.pg(a, b, c);
  }
  var d = Jd[p(null == a ? null : a)];
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  d = Jd._;
  if (null != d) {
    return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
  }
  throw qc("ISwap.-swap!", a);
};
Jd.H = function(a, b, c, d) {
  if (null != a && null != a.qg) {
    return a.qg(a, b, c, d);
  }
  var e = Jd[p(null == a ? null : a)];
  if (null != e) {
    return e.H ? e.H(a, b, c, d) : e.call(null, a, b, c, d);
  }
  e = Jd._;
  if (null != e) {
    return e.H ? e.H(a, b, c, d) : e.call(null, a, b, c, d);
  }
  throw qc("ISwap.-swap!", a);
};
Jd.O = function(a, b, c, d, e) {
  if (null != a && null != a.rg) {
    return a.rg(a, b, c, d, e);
  }
  var f = Jd[p(null == a ? null : a)];
  if (null != f) {
    return f.O ? f.O(a, b, c, d, e) : f.call(null, a, b, c, d, e);
  }
  f = Jd._;
  if (null != f) {
    return f.O ? f.O(a, b, c, d, e) : f.call(null, a, b, c, d, e);
  }
  throw qc("ISwap.-swap!", a);
};
Jd.L = 5;
var Kd = function Kd(b, c) {
  if (null != b && null != b.rf) {
    return b.rf(0, c);
  }
  var d = Kd[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = Kd._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IVolatile.-vreset!", b);
}, Ld = function Ld(b) {
  if (null != b && null != b.mb) {
    return b.mb(b);
  }
  var c = Ld[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = Ld._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IIterable.-iterator", b);
};
function Md(a) {
  this.fh = a;
  this.w = 1073741824;
  this.K = 0;
}
Md.prototype.tf = function(a, b) {
  return this.fh.append(b);
};
function Nd(a) {
  var b = new jb;
  a.W(null, new Md(b), cc());
  return "" + y(b);
}
var Od = "undefined" !== typeof Math.imul && 0 !== Math.imul(4294967295, 5) ? function(a, b) {
  return Math.imul(a, b);
} : function(a, b) {
  var c = a & 65535, d = b & 65535;
  return c * d + ((a >>> 16 & 65535) * d + c * (b >>> 16 & 65535) << 16 >>> 0) | 0;
};
function Pd(a) {
  a = Od(a | 0, -862048943);
  return Od(a << 15 | a >>> -15, 461845907);
}
function Qd(a, b) {
  var c = (a | 0) ^ (b | 0);
  return Od(c << 13 | c >>> -13, 5) + -430675100 | 0;
}
function Rd(a, b) {
  var c = (a | 0) ^ b, c = Od(c ^ c >>> 16, -2048144789), c = Od(c ^ c >>> 13, -1028477387);
  return c ^ c >>> 16;
}
function Sd(a) {
  var b;
  a: {
    b = 1;
    for (var c = 0;;) {
      if (b < a.length) {
        var d = b + 2, c = Qd(c, Pd(a.charCodeAt(b - 1) | a.charCodeAt(b) << 16));
        b = d;
      } else {
        b = c;
        break a;
      }
    }
  }
  b = 1 === (a.length & 1) ? b ^ Pd(a.charCodeAt(a.length - 1)) : b;
  return Rd(b, Od(2, a.length));
}
var Td = {}, Ud = 0;
function Vd(a) {
  255 < Ud && (Td = {}, Ud = 0);
  if (null == a) {
    return 0;
  }
  var b = Td[a];
  if ("number" !== typeof b) {
    a: {
      if (null != a) {
        if (b = a.length, 0 < b) {
          for (var c = 0, d = 0;;) {
            if (c < b) {
              var e = c + 1, d = Od(31, d) + a.charCodeAt(c), c = e
            } else {
              b = d;
              break a;
            }
          }
        } else {
          b = 0;
        }
      } else {
        b = 0;
      }
    }
    Td[a] = b;
    Ud += 1;
  }
  return a = b;
}
function Wd(a) {
  if (null != a && (a.w & 4194304 || q === a.Be)) {
    return a.V(null);
  }
  if ("number" === typeof a) {
    if (w(isFinite(a))) {
      return Math.floor(a) % 2147483647;
    }
    switch(a) {
      case Infinity:
        return 2146435072;
      case -Infinity:
        return -1048576;
      default:
        return 2146959360;
    }
  } else {
    return !0 === a ? a = 1231 : !1 === a ? a = 1237 : "string" === typeof a ? (a = Vd(a), 0 !== a && (a = Pd(a), a = Qd(0, a), a = Rd(a, 4))) : a = a instanceof Date ? a.valueOf() : null == a ? 0 : kd(a), a;
  }
}
function Xd(a, b) {
  return a ^ b + 2654435769 + (a << 6) + (a >> 2);
}
function Yd(a, b) {
  if (a.ab === b.ab) {
    return 0;
  }
  var c = kc(a.Wa);
  if (w(c ? b.Wa : c)) {
    return -1;
  }
  if (w(a.Wa)) {
    if (kc(b.Wa)) {
      return 1;
    }
    c = wb(a.Wa, b.Wa);
    return 0 === c ? wb(a.name, b.name) : c;
  }
  return wb(a.name, b.name);
}
function A(a, b, c, d, e) {
  this.Wa = a;
  this.name = b;
  this.ab = c;
  this.Mc = d;
  this.bb = e;
  this.w = 2154168321;
  this.K = 4096;
}
h = A.prototype;
h.toString = function() {
  return this.ab;
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.I = function(a, b) {
  return b instanceof A ? this.ab === b.ab : !1;
};
h.call = function() {
  function a(a, b, c) {
    return C.l ? C.l(b, this, c) : C.call(null, b, this, c);
  }
  function b(a, b) {
    return C.j ? C.j(b, this) : C.call(null, b, this);
  }
  var c = null, c = function(c, e, f) {
    switch(arguments.length) {
      case 2:
        return b.call(this, 0, e);
      case 3:
        return a.call(this, 0, e, f);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  c.j = b;
  c.l = a;
  return c;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return C.j ? C.j(a, this) : C.call(null, a, this);
};
h.j = function(a, b) {
  return C.l ? C.l(a, this, b) : C.call(null, a, this, b);
};
h.S = function() {
  return this.bb;
};
h.T = function(a, b) {
  return new A(this.Wa, this.name, this.ab, this.Mc, b);
};
h.V = function() {
  var a = this.Mc;
  return null != a ? a : this.Mc = a = Xd(Sd(this.name), Vd(this.Wa));
};
h.pd = function() {
  return this.name;
};
h.qd = function() {
  return this.Wa;
};
h.W = function(a, b) {
  return td(b, this.ab);
};
var Zd = function Zd(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return Zd.h(arguments[0]);
    case 2:
      return Zd.j(arguments[0], arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Zd.h = function(a) {
  if (a instanceof A) {
    return a;
  }
  var b = a.indexOf("/");
  return 1 > b ? Zd.j(null, a) : Zd.j(a.substring(0, b), a.substring(b + 1, a.length));
};
Zd.j = function(a, b) {
  var c = null != a ? [y(a), y("/"), y(b)].join("") : b;
  return new A(a, b, c, null, null);
};
Zd.L = 2;
function D(a) {
  if (null == a) {
    return null;
  }
  if (null != a && (a.w & 8388608 || q === a.ng)) {
    return a.ea(null);
  }
  if (jc(a) || "string" === typeof a) {
    return 0 === a.length ? null : new F(a, 0, null);
  }
  if (oc(ld, a)) {
    return md(a);
  }
  throw Error([y(a), y(" is not ISeqable")].join(""));
}
function G(a) {
  if (null == a) {
    return null;
  }
  if (null != a && (a.w & 64 || q === a.M)) {
    return a.za(null);
  }
  a = D(a);
  return null == a ? null : Kc(a);
}
function $d(a) {
  return null != a ? null != a && (a.w & 64 || q === a.M) ? a.Ra(null) : (a = D(a)) ? Lc(a) : ae : ae;
}
function H(a) {
  return null == a ? null : null != a && (a.w & 128 || q === a.Vd) ? a.Ya(null) : D($d(a));
}
var J = function J(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return J.h(arguments[0]);
    case 2:
      return J.j(arguments[0], arguments[1]);
    default:
      return J.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
J.h = function() {
  return !0;
};
J.j = function(a, b) {
  return null == a ? null == b : a === b || jd(a, b);
};
J.B = function(a, b, c) {
  for (;;) {
    if (J.j(a, b)) {
      if (H(c)) {
        a = b, b = G(c), c = H(c);
      } else {
        return J.j(b, G(c));
      }
    } else {
      return !1;
    }
  }
};
J.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return J.B(b, a, c);
};
J.L = 2;
function ce(a) {
  this.s = a;
}
ce.prototype.next = function() {
  if (null != this.s) {
    var a = G(this.s);
    this.s = H(this.s);
    return {value:a, done:!1};
  }
  return {value:null, done:!0};
};
function de(a) {
  return new ce(D(a));
}
function ee(a, b) {
  var c = Pd(a), c = Qd(0, c);
  return Rd(c, b);
}
function fe(a) {
  var b = 0, c = 1;
  for (a = D(a);;) {
    if (null != a) {
      b += 1, c = Od(31, c) + Wd(G(a)) | 0, a = H(a);
    } else {
      return ee(c, b);
    }
  }
}
var ge = ee(1, 0);
function he(a) {
  var b = 0, c = 0;
  for (a = D(a);;) {
    if (null != a) {
      b += 1, c = c + Wd(G(a)) | 0, a = H(a);
    } else {
      return ee(c, b);
    }
  }
}
var ie = ee(0, 0);
Cc["null"] = !0;
Dc["null"] = function() {
  return 0;
};
Date.prototype.I = function(a, b) {
  return b instanceof Date && this.valueOf() === b.valueOf();
};
Date.prototype.zc = q;
Date.prototype.Zb = function(a, b) {
  if (b instanceof Date) {
    return wb(this.valueOf(), b.valueOf());
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
jd.number = function(a, b) {
  return a === b;
};
zc["function"] = !0;
cd["function"] = !0;
dd["function"] = function() {
  return null;
};
kd._ = function(a) {
  return la(a);
};
function je(a) {
  return a + 1;
}
function ke(a) {
  this.G = a;
  this.w = 32768;
  this.K = 0;
}
ke.prototype.ld = function() {
  return this.G;
};
function le(a) {
  return a instanceof ke;
}
function L(a) {
  return bd(a);
}
function me(a, b) {
  var c = Dc(a);
  if (0 === c) {
    return b.v ? b.v() : b.call(null);
  }
  for (var d = Ic.j(a, 0), e = 1;;) {
    if (e < c) {
      var f = Ic.j(a, e), d = b.j ? b.j(d, f) : b.call(null, d, f);
      if (le(d)) {
        return bd(d);
      }
      e += 1;
    } else {
      return d;
    }
  }
}
function ne(a, b, c) {
  var d = Dc(a), e = c;
  for (c = 0;;) {
    if (c < d) {
      var f = Ic.j(a, c), e = b.j ? b.j(e, f) : b.call(null, e, f);
      if (le(e)) {
        return bd(e);
      }
      c += 1;
    } else {
      return e;
    }
  }
}
function oe(a, b) {
  var c = a.length;
  if (0 === a.length) {
    return b.v ? b.v() : b.call(null);
  }
  for (var d = a[0], e = 1;;) {
    if (e < c) {
      var f = a[e], d = b.j ? b.j(d, f) : b.call(null, d, f);
      if (le(d)) {
        return bd(d);
      }
      e += 1;
    } else {
      return d;
    }
  }
}
function pe(a, b, c) {
  var d = a.length, e = c;
  for (c = 0;;) {
    if (c < d) {
      var f = a[c], e = b.j ? b.j(e, f) : b.call(null, e, f);
      if (le(e)) {
        return bd(e);
      }
      c += 1;
    } else {
      return e;
    }
  }
}
function qe(a, b, c, d) {
  for (var e = a.length;;) {
    if (d < e) {
      var f = a[d];
      c = b.j ? b.j(c, f) : b.call(null, c, f);
      if (le(c)) {
        return bd(c);
      }
      d += 1;
    } else {
      return c;
    }
  }
}
function re(a) {
  return null != a ? a.w & 2 || q === a.dg ? !0 : a.w ? !1 : oc(Cc, a) : oc(Cc, a);
}
function se(a) {
  return null != a ? a.w & 16 || q === a.mf ? !0 : a.w ? !1 : oc(Hc, a) : oc(Hc, a);
}
function N(a, b, c) {
  var d = O.h ? O.h(a) : O.call(null, a);
  if (c >= d) {
    return -1;
  }
  !(0 < c) && 0 > c && (c += d, c = 0 > c ? 0 : c);
  for (;;) {
    if (c < d) {
      if (J.j(te ? te(a, c) : ue.call(null, a, c), b)) {
        return c;
      }
      c += 1;
    } else {
      return -1;
    }
  }
}
function ve(a, b, c) {
  var d = O.h ? O.h(a) : O.call(null, a);
  if (0 === d) {
    return -1;
  }
  0 < c ? (--d, c = d < c ? d : c) : c = 0 > c ? d + c : c;
  for (;;) {
    if (0 <= c) {
      if (J.j(te ? te(a, c) : ue.call(null, a, c), b)) {
        return c;
      }
      --c;
    } else {
      return -1;
    }
  }
}
function we(a, b) {
  this.o = a;
  this.i = b;
}
we.prototype.Da = function() {
  return this.i < this.o.length;
};
we.prototype.next = function() {
  var a = this.o[this.i];
  this.i += 1;
  return a;
};
function F(a, b, c) {
  this.o = a;
  this.i = b;
  this.meta = c;
  this.w = 166592766;
  this.K = 8192;
}
h = F.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O.h ? O.h(this) : O.call(null, this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.aa = function(a, b) {
  var c = b + this.i;
  return c < this.o.length ? this.o[c] : null;
};
h.cb = function(a, b, c) {
  a = b + this.i;
  return a < this.o.length ? this.o[a] : c;
};
h.mb = function() {
  return new we(this.o, this.i);
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new F(this.o, this.i, this.meta);
};
h.Ya = function() {
  return this.i + 1 < this.o.length ? new F(this.o, this.i + 1, null) : null;
};
h.ja = function() {
  var a = this.o.length - this.i;
  return 0 > a ? 0 : a;
};
h.Uc = function() {
  var a = Dc(this);
  return 0 < a ? new xe(this, a - 1, null) : null;
};
h.V = function() {
  return fe(this);
};
h.I = function(a, b) {
  return ye.j ? ye.j(this, b) : ye.call(null, this, b);
};
h.na = function() {
  return ae;
};
h.xa = function(a, b) {
  return qe(this.o, b, this.o[this.i], this.i + 1);
};
h.ya = function(a, b, c) {
  return qe(this.o, b, c, this.i);
};
h.za = function() {
  return this.o[this.i];
};
h.Ra = function() {
  return this.i + 1 < this.o.length ? new F(this.o, this.i + 1, null) : ae;
};
h.ea = function() {
  return this.i < this.o.length ? this : null;
};
h.T = function(a, b) {
  return new F(this.o, this.i, b);
};
h.fa = function(a, b) {
  return ze.j ? ze.j(b, this) : ze.call(null, b, this);
};
F.prototype[sc] = function() {
  return de(this);
};
function Ae(a, b) {
  return b < a.length ? new F(a, b, null) : null;
}
function P(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return Ae(arguments[0], 0);
    case 2:
      return Ae(arguments[0], arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function xe(a, b, c) {
  this.kd = a;
  this.i = b;
  this.meta = c;
  this.w = 32374990;
  this.K = 8192;
}
h = xe.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O.h ? O.h(this) : O.call(null, this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new xe(this.kd, this.i, this.meta);
};
h.Ya = function() {
  return 0 < this.i ? new xe(this.kd, this.i - 1, null) : null;
};
h.ja = function() {
  return this.i + 1;
};
h.V = function() {
  return fe(this);
};
h.I = function(a, b) {
  return ye.j ? ye.j(this, b) : ye.call(null, this, b);
};
h.na = function() {
  var a = ae, b = this.meta;
  return Be.j ? Be.j(a, b) : Be.call(null, a, b);
};
h.xa = function(a, b) {
  return Ce ? Ce(b, this) : De.call(null, b, this);
};
h.ya = function(a, b, c) {
  return Ee ? Ee(b, c, this) : De.call(null, b, c, this);
};
h.za = function() {
  return Ic.j(this.kd, this.i);
};
h.Ra = function() {
  return 0 < this.i ? new xe(this.kd, this.i - 1, null) : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new xe(this.kd, this.i, b);
};
h.fa = function(a, b) {
  return ze.j ? ze.j(b, this) : ze.call(null, b, this);
};
xe.prototype[sc] = function() {
  return de(this);
};
function Fe(a) {
  return G(H(a));
}
jd._ = function(a, b) {
  return a === b;
};
var Ge = function Ge(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return Ge.v();
    case 1:
      return Ge.h(arguments[0]);
    case 2:
      return Ge.j(arguments[0], arguments[1]);
    default:
      return Ge.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
Ge.v = function() {
  return He;
};
Ge.h = function(a) {
  return a;
};
Ge.j = function(a, b) {
  return null != a ? Gc(a, b) : Gc(ae, b);
};
Ge.B = function(a, b, c) {
  for (;;) {
    if (w(c)) {
      a = Ge.j(a, b), b = G(c), c = H(c);
    } else {
      return Ge.j(a, b);
    }
  }
};
Ge.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return Ge.B(b, a, c);
};
Ge.L = 2;
function O(a) {
  if (null != a) {
    if (null != a && (a.w & 2 || q === a.dg)) {
      a = a.ja(null);
    } else {
      if (jc(a)) {
        a = a.length;
      } else {
        if ("string" === typeof a) {
          a = a.length;
        } else {
          if (null != a && (a.w & 8388608 || q === a.ng)) {
            a: {
              a = D(a);
              for (var b = 0;;) {
                if (re(a)) {
                  a = b + Dc(a);
                  break a;
                }
                a = H(a);
                b += 1;
              }
            }
          } else {
            a = Dc(a);
          }
        }
      }
    }
  } else {
    a = 0;
  }
  return a;
}
function Ie(a, b, c) {
  for (;;) {
    if (null == a) {
      return c;
    }
    if (0 === b) {
      return D(a) ? G(a) : c;
    }
    if (se(a)) {
      return Ic.l(a, b, c);
    }
    if (D(a)) {
      a = H(a), --b;
    } else {
      return c;
    }
  }
}
function ue(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 2:
      return te(arguments[0], arguments[1]);
    case 3:
      return S(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function te(a, b) {
  if ("number" !== typeof b) {
    throw Error("Index argument to nth must be a number");
  }
  if (null == a) {
    return a;
  }
  if (null != a && (a.w & 16 || q === a.mf)) {
    return a.aa(null, b);
  }
  if (jc(a)) {
    if (0 <= b && b < a.length) {
      return a[b];
    }
    throw Error("Index out of bounds");
  }
  if ("string" === typeof a) {
    if (0 <= b && b < a.length) {
      return a.charAt(b);
    }
    throw Error("Index out of bounds");
  }
  if (null != a && (a.w & 64 || q === a.M)) {
    var c;
    a: {
      c = a;
      for (var d = b;;) {
        if (null == c) {
          throw Error("Index out of bounds");
        }
        if (0 === d) {
          if (D(c)) {
            c = G(c);
            break a;
          }
          throw Error("Index out of bounds");
        }
        if (se(c)) {
          c = Ic.j(c, d);
          break a;
        }
        if (D(c)) {
          c = H(c), --d;
        } else {
          throw Error("Index out of bounds");
        }
      }
    }
    return c;
  }
  if (oc(Hc, a)) {
    return Ic.j(a, b);
  }
  throw Error([y("nth not supported on this type "), y(rc(pc(a)))].join(""));
}
function S(a, b, c) {
  if ("number" !== typeof b) {
    throw Error("Index argument to nth must be a number.");
  }
  if (null == a) {
    return c;
  }
  if (null != a && (a.w & 16 || q === a.mf)) {
    return a.cb(null, b, c);
  }
  if (jc(a)) {
    return 0 <= b && b < a.length ? a[b] : c;
  }
  if ("string" === typeof a) {
    return 0 <= b && b < a.length ? a.charAt(b) : c;
  }
  if (null != a && (a.w & 64 || q === a.M)) {
    return Ie(a, b, c);
  }
  if (oc(Hc, a)) {
    return Ic.j(a, b);
  }
  throw Error([y("nth not supported on this type "), y(rc(pc(a)))].join(""));
}
var C = function C(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return C.j(arguments[0], arguments[1]);
    case 3:
      return C.l(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
C.j = function(a, b) {
  return null == a ? null : null != a && (a.w & 256 || q === a.ig) ? a.R(null, b) : jc(a) ? b < a.length ? a[b | 0] : null : "string" === typeof a ? null != b && b < a.length ? a[b | 0] : null : oc(Nc, a) ? Oc.j(a, b) : null;
};
C.l = function(a, b, c) {
  return null != a ? null != a && (a.w & 256 || q === a.ig) ? a.N(null, b, c) : jc(a) ? b < a.length ? a[b | 0] : c : "string" === typeof a ? b < a.length ? a[b | 0] : c : oc(Nc, a) ? Oc.l(a, b, c) : c : c;
};
C.L = 3;
var Je = function Je(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 3:
      return Je.l(arguments[0], arguments[1], arguments[2]);
    default:
      return Je.B(arguments[0], arguments[1], arguments[2], new F(c.slice(3), 0, null));
  }
};
Je.l = function(a, b, c) {
  return null != a ? Rc(a, b, c) : Ke([b], [c]);
};
Je.B = function(a, b, c, d) {
  for (;;) {
    if (a = Je.l(a, b, c), w(d)) {
      b = G(d), c = Fe(d), d = H(H(d));
    } else {
      return a;
    }
  }
};
Je.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), d = H(d);
  return Je.B(b, a, c, d);
};
Je.L = 3;
var Le = function Le(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return Le.h(arguments[0]);
    case 2:
      return Le.j(arguments[0], arguments[1]);
    default:
      return Le.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
Le.h = function(a) {
  return a;
};
Le.j = function(a, b) {
  return null == a ? null : Tc(a, b);
};
Le.B = function(a, b, c) {
  for (;;) {
    if (null == a) {
      return null;
    }
    a = Le.j(a, b);
    if (w(c)) {
      b = G(c), c = H(c);
    } else {
      return a;
    }
  }
};
Le.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return Le.B(b, a, c);
};
Le.L = 2;
function Me(a, b) {
  this.A = a;
  this.meta = b;
  this.w = 393217;
  this.K = 0;
}
h = Me.prototype;
h.S = function() {
  return this.meta;
};
h.T = function(a, b) {
  return new Me(this.A, b);
};
h.cg = q;
h.call = function() {
  function a(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V, U) {
    a = this;
    return Ne.md ? Ne.md(a.A, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V, U) : Ne.call(null, a.A, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V, U);
  }
  function b(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V) {
    a = this;
    return a.A.Oa ? a.A.Oa(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I, V);
  }
  function c(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I) {
    a = this;
    return a.A.Na ? a.A.Na(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E, I);
  }
  function d(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E) {
    a = this;
    return a.A.Ma ? a.A.Ma(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K, E);
  }
  function e(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K) {
    a = this;
    return a.A.La ? a.A.La(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, K);
  }
  function f(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) {
    a = this;
    return a.A.Ka ? a.A.Ka(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
  }
  function g(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) {
    a = this;
    return a.A.Ja ? a.A.Ja(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z);
  }
  function k(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) {
    a = this;
    return a.A.Ia ? a.A.Ia(b, c, d, e, f, g, k, l, m, n, t, r, v, x) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x);
  }
  function l(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
    a = this;
    return a.A.Ha ? a.A.Ha(b, c, d, e, f, g, k, l, m, n, t, r, v) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v);
  }
  function m(a, b, c, d, e, f, g, k, l, m, n, t, r) {
    a = this;
    return a.A.Ga ? a.A.Ga(b, c, d, e, f, g, k, l, m, n, t, r) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t, r);
  }
  function n(a, b, c, d, e, f, g, k, l, m, n, t) {
    a = this;
    return a.A.Fa ? a.A.Fa(b, c, d, e, f, g, k, l, m, n, t) : a.A.call(null, b, c, d, e, f, g, k, l, m, n, t);
  }
  function t(a, b, c, d, e, f, g, k, l, m, n) {
    a = this;
    return a.A.Ea ? a.A.Ea(b, c, d, e, f, g, k, l, m, n) : a.A.call(null, b, c, d, e, f, g, k, l, m, n);
  }
  function r(a, b, c, d, e, f, g, k, l, m) {
    a = this;
    return a.A.Qa ? a.A.Qa(b, c, d, e, f, g, k, l, m) : a.A.call(null, b, c, d, e, f, g, k, l, m);
  }
  function v(a, b, c, d, e, f, g, k, l) {
    a = this;
    return a.A.Pa ? a.A.Pa(b, c, d, e, f, g, k, l) : a.A.call(null, b, c, d, e, f, g, k, l);
  }
  function x(a, b, c, d, e, f, g, k) {
    a = this;
    return a.A.wa ? a.A.wa(b, c, d, e, f, g, k) : a.A.call(null, b, c, d, e, f, g, k);
  }
  function z(a, b, c, d, e, f, g) {
    a = this;
    return a.A.ua ? a.A.ua(b, c, d, e, f, g) : a.A.call(null, b, c, d, e, f, g);
  }
  function B(a, b, c, d, e, f) {
    a = this;
    return a.A.O ? a.A.O(b, c, d, e, f) : a.A.call(null, b, c, d, e, f);
  }
  function I(a, b, c, d, e) {
    a = this;
    return a.A.H ? a.A.H(b, c, d, e) : a.A.call(null, b, c, d, e);
  }
  function U(a, b, c, d) {
    a = this;
    return a.A.l ? a.A.l(b, c, d) : a.A.call(null, b, c, d);
  }
  function V(a, b, c) {
    a = this;
    return a.A.j ? a.A.j(b, c) : a.A.call(null, b, c);
  }
  function Q(a, b) {
    a = this;
    return a.A.h ? a.A.h(b) : a.A.call(null, b);
  }
  function K(a) {
    a = this;
    return a.A.v ? a.A.v() : a.A.call(null);
  }
  var E = null, E = function(ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be, il) {
    switch(arguments.length) {
      case 1:
        return K.call(this, ba);
      case 2:
        return Q.call(this, ba, R);
      case 3:
        return V.call(this, ba, R, pa);
      case 4:
        return U.call(this, ba, R, pa, E);
      case 5:
        return I.call(this, ba, R, pa, E, ia);
      case 6:
        return B.call(this, ba, R, pa, E, ia, ra);
      case 7:
        return z.call(this, ba, R, pa, E, ia, ra, va);
      case 8:
        return x.call(this, ba, R, pa, E, ia, ra, va, Aa);
      case 9:
        return v.call(this, ba, R, pa, E, ia, ra, va, Aa, La);
      case 10:
        return r.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na);
      case 11:
        return t.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa);
      case 12:
        return n.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja);
      case 13:
        return m.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa);
      case 14:
        return l.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab);
      case 15:
        return k.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb);
      case 16:
        return g.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb);
      case 17:
        return f.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b);
      case 18:
        return e.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc);
      case 19:
        return d.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc);
      case 20:
        return c.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd);
      case 21:
        return b.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be);
      case 22:
        return a.call(this, ba, R, pa, E, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be, il);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  E.h = K;
  E.j = Q;
  E.l = V;
  E.H = U;
  E.O = I;
  E.ua = B;
  E.wa = z;
  E.Pa = x;
  E.Qa = v;
  E.Ea = r;
  E.Fa = t;
  E.Ga = n;
  E.Ha = m;
  E.Ia = l;
  E.Ja = k;
  E.Ka = g;
  E.La = f;
  E.Ma = e;
  E.Na = d;
  E.Oa = c;
  E.Ae = b;
  E.md = a;
  return E;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.v = function() {
  return this.A.v ? this.A.v() : this.A.call(null);
};
h.h = function(a) {
  return this.A.h ? this.A.h(a) : this.A.call(null, a);
};
h.j = function(a, b) {
  return this.A.j ? this.A.j(a, b) : this.A.call(null, a, b);
};
h.l = function(a, b, c) {
  return this.A.l ? this.A.l(a, b, c) : this.A.call(null, a, b, c);
};
h.H = function(a, b, c, d) {
  return this.A.H ? this.A.H(a, b, c, d) : this.A.call(null, a, b, c, d);
};
h.O = function(a, b, c, d, e) {
  return this.A.O ? this.A.O(a, b, c, d, e) : this.A.call(null, a, b, c, d, e);
};
h.ua = function(a, b, c, d, e, f) {
  return this.A.ua ? this.A.ua(a, b, c, d, e, f) : this.A.call(null, a, b, c, d, e, f);
};
h.wa = function(a, b, c, d, e, f, g) {
  return this.A.wa ? this.A.wa(a, b, c, d, e, f, g) : this.A.call(null, a, b, c, d, e, f, g);
};
h.Pa = function(a, b, c, d, e, f, g, k) {
  return this.A.Pa ? this.A.Pa(a, b, c, d, e, f, g, k) : this.A.call(null, a, b, c, d, e, f, g, k);
};
h.Qa = function(a, b, c, d, e, f, g, k, l) {
  return this.A.Qa ? this.A.Qa(a, b, c, d, e, f, g, k, l) : this.A.call(null, a, b, c, d, e, f, g, k, l);
};
h.Ea = function(a, b, c, d, e, f, g, k, l, m) {
  return this.A.Ea ? this.A.Ea(a, b, c, d, e, f, g, k, l, m) : this.A.call(null, a, b, c, d, e, f, g, k, l, m);
};
h.Fa = function(a, b, c, d, e, f, g, k, l, m, n) {
  return this.A.Fa ? this.A.Fa(a, b, c, d, e, f, g, k, l, m, n) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n);
};
h.Ga = function(a, b, c, d, e, f, g, k, l, m, n, t) {
  return this.A.Ga ? this.A.Ga(a, b, c, d, e, f, g, k, l, m, n, t) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t);
};
h.Ha = function(a, b, c, d, e, f, g, k, l, m, n, t, r) {
  return this.A.Ha ? this.A.Ha(a, b, c, d, e, f, g, k, l, m, n, t, r) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r);
};
h.Ia = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
  return this.A.Ia ? this.A.Ia(a, b, c, d, e, f, g, k, l, m, n, t, r, v) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v);
};
h.Ja = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) {
  return this.A.Ja ? this.A.Ja(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x);
};
h.Ka = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) {
  return this.A.Ka ? this.A.Ka(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z);
};
h.La = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) {
  return this.A.La ? this.A.La(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
};
h.Ma = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) {
  return this.A.Ma ? this.A.Ma(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I);
};
h.Na = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) {
  return this.A.Na ? this.A.Na(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U);
};
h.Oa = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) {
  return this.A.Oa ? this.A.Oa(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) : this.A.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V);
};
h.Ae = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q) {
  return Ne.md ? Ne.md(this.A, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q) : Ne.call(null, this.A, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q);
};
function Be(a, b) {
  return ja(a) ? new Me(a, b) : null == a ? null : fd(a, b);
}
function Oe(a) {
  var b = null != a;
  return (b ? null != a ? a.w & 131072 || q === a.nf || (a.w ? 0 : oc(cd, a)) : oc(cd, a) : b) ? dd(a) : null;
}
function Pe(a) {
  return null == a || kc(D(a));
}
function Qe(a) {
  return null == a ? !1 : null != a ? a.w & 8 || q === a.ph ? !0 : a.w ? !1 : oc(Fc, a) : oc(Fc, a);
}
function Re(a) {
  return null == a ? !1 : null != a ? a.w & 4096 || q === a.wh ? !0 : a.w ? !1 : oc(Xc, a) : oc(Xc, a);
}
function Se(a) {
  return null != a ? a.w & 16777216 || q === a.vh ? !0 : a.w ? !1 : oc(nd, a) : oc(nd, a);
}
function Te(a) {
  return null == a ? !1 : null != a ? a.w & 1024 || q === a.jg ? !0 : a.w ? !1 : oc(Sc, a) : oc(Sc, a);
}
function Ue(a) {
  return null != a ? a.w & 67108864 || q === a.sh ? !0 : a.w ? !1 : oc(pd, a) : oc(pd, a);
}
function Ve(a) {
  return null != a ? a.w & 16384 || q === a.xh ? !0 : a.w ? !1 : oc($c, a) : oc($c, a);
}
function We(a) {
  return null != a ? a.K & 512 || q === a.oh ? !0 : !1 : !1;
}
function Xe(a) {
  var b = [];
  Ra(a, function(a, b) {
    return function(a, c) {
      return b.push(c);
    };
  }(a, b));
  return b;
}
function Ye(a, b, c, d, e) {
  for (;0 !== e;) {
    c[d] = a[b], d += 1, --e, b += 1;
  }
}
var Ze = {};
function $e(a) {
  return null == a ? !1 : null != a ? a.w & 64 || q === a.M ? !0 : a.w ? !1 : oc(Jc, a) : oc(Jc, a);
}
function af(a) {
  return null == a ? !1 : !1 === a ? !1 : !0;
}
function bf(a) {
  return "number" === typeof a && !isNaN(a) && Infinity !== a && parseFloat(a) === parseInt(a, 10);
}
function cf(a, b) {
  return C.l(a, b, Ze) === Ze ? !1 : !0;
}
function df(a, b) {
  var c;
  if (c = null != a) {
    c = null != a ? a.w & 512 || q === a.nh ? !0 : a.w ? !1 : oc(Pc, a) : oc(Pc, a);
  }
  return c && cf(a, b) ? new T(null, 2, 5, W, [b, C.j(a, b)], null) : null;
}
function ef(a, b) {
  if (a === b) {
    return 0;
  }
  if (null == a) {
    return -1;
  }
  if (null == b) {
    return 1;
  }
  if ("number" === typeof a) {
    if ("number" === typeof b) {
      return wb(a, b);
    }
    throw Error([y("Cannot compare "), y(a), y(" to "), y(b)].join(""));
  }
  if (null != a ? a.K & 2048 || q === a.zc || (a.K ? 0 : oc(Ad, a)) : oc(Ad, a)) {
    return Bd(a, b);
  }
  if ("string" !== typeof a && !jc(a) && !0 !== a && !1 !== a || pc(a) !== pc(b)) {
    throw Error([y("Cannot compare "), y(a), y(" to "), y(b)].join(""));
  }
  return wb(a, b);
}
function ff(a, b) {
  var c = O(a), d = O(b);
  if (c < d) {
    c = -1;
  } else {
    if (c > d) {
      c = 1;
    } else {
      if (0 === c) {
        c = 0;
      } else {
        a: {
          for (d = 0;;) {
            var e = ef(te(a, d), te(b, d));
            if (0 === e && d + 1 < c) {
              d += 1;
            } else {
              c = e;
              break a;
            }
          }
        }
      }
    }
  }
  return c;
}
function gf() {
  return J.j(ef, ef) ? ef : function(a, b) {
    var c = ef.j ? ef.j(a, b) : ef.call(null, a, b);
    return "number" === typeof c ? c : w(c) ? -1 : w(ef.j ? ef.j(b, a) : ef.call(null, b, a)) ? 1 : 0;
  };
}
function hf(a) {
  if (D(a)) {
    a = jf.h ? jf.h(a) : jf.call(null, a);
    var b = gf();
    xb(a, b);
    return D(a);
  }
  return ae;
}
function De(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 2:
      return Ce(arguments[0], arguments[1]);
    case 3:
      return Ee(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function Ce(a, b) {
  var c = D(b);
  if (c) {
    var d = G(c), c = H(c);
    return xc ? xc(a, d, c) : yc.call(null, a, d, c);
  }
  return a.v ? a.v() : a.call(null);
}
function Ee(a, b, c) {
  for (c = D(c);;) {
    if (c) {
      var d = G(c);
      b = a.j ? a.j(b, d) : a.call(null, b, d);
      if (le(b)) {
        return bd(b);
      }
      c = H(c);
    } else {
      return b;
    }
  }
}
function yc(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 2:
      return kf(arguments[0], arguments[1]);
    case 3:
      return xc(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function kf(a, b) {
  return null != b && (b.w & 524288 || q === b.lg) ? b.xa(null, a) : jc(b) ? oe(b, a) : "string" === typeof b ? oe(b, a) : oc(gd, b) ? hd.j(b, a) : Ce(a, b);
}
function xc(a, b, c) {
  return null != c && (c.w & 524288 || q === c.lg) ? c.ya(null, a, b) : jc(c) ? pe(c, a, b) : "string" === typeof c ? pe(c, a, b) : oc(gd, c) ? hd.l(c, a, b) : Ee(a, b, c);
}
function lf(a, b) {
  var c = ["^ "];
  return null != b ? id(b, a, c) : c;
}
function mf(a) {
  return a;
}
function nf(a, b, c, d) {
  a = a.h ? a.h(b) : a.call(null, b);
  c = xc(a, c, d);
  return a.h ? a.h(c) : a.call(null, c);
}
function of(a) {
  return a - 1;
}
function pf(a) {
  a = (a - a % 2) / 2;
  return 0 <= a ? Math.floor(a) : Math.ceil(a);
}
function qf(a) {
  a -= a >> 1 & 1431655765;
  a = (a & 858993459) + (a >> 2 & 858993459);
  return 16843009 * (a + (a >> 4) & 252645135) >> 24;
}
function rf(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return !0;
    case 2:
      return jd(arguments[0], arguments[1]);
    default:
      a: {
        for (c = arguments[0], d = arguments[1], b = new F(b.slice(2), 0, null);;) {
          if (c === d) {
            if (H(b)) {
              c = d, d = G(b), b = H(b);
            } else {
              c = d === G(b);
              break a;
            }
          } else {
            c = !1;
            break a;
          }
        }
      }
      return c;
  }
}
function sf(a, b) {
  return jd(a, b);
}
var y = function y(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return y.v();
    case 1:
      return y.h(arguments[0]);
    default:
      return y.B(arguments[0], new F(c.slice(1), 0, null));
  }
};
y.v = function() {
  return "";
};
y.h = function(a) {
  return null == a ? "" : "" + a;
};
y.B = function(a, b) {
  for (var c = new jb("" + y(a)), d = b;;) {
    if (w(d)) {
      c = c.append("" + y(G(d))), d = H(d);
    } else {
      return c.toString();
    }
  }
};
y.J = function(a) {
  var b = G(a);
  a = H(a);
  return y.B(b, a);
};
y.L = 1;
function tf(a, b, c) {
  return a.substring(b, c);
}
function ye(a, b) {
  var c;
  if (Se(b)) {
    if (re(a) && re(b) && O(a) !== O(b)) {
      c = !1;
    } else {
      a: {
        c = D(a);
        for (var d = D(b);;) {
          if (null == c) {
            c = null == d;
            break a;
          }
          if (null != d && J.j(G(c), G(d))) {
            c = H(c), d = H(d);
          } else {
            c = !1;
            break a;
          }
        }
      }
    }
  } else {
    c = null;
  }
  return af(c);
}
function uf(a) {
  var b = 0;
  for (a = D(a);;) {
    if (a) {
      var c = G(a), b = (b + (Wd(vf.h ? vf.h(c) : vf.call(null, c)) ^ Wd(wf.h ? wf.h(c) : wf.call(null, c)))) % 4503599627370496;
      a = H(a);
    } else {
      return b;
    }
  }
}
function xf(a, b, c, d, e) {
  this.meta = a;
  this.first = b;
  this.Mb = c;
  this.count = d;
  this.F = e;
  this.w = 65937646;
  this.K = 8192;
}
h = xf.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, this.count);
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new xf(this.meta, this.first, this.Mb, this.count, this.F);
};
h.Ya = function() {
  return 1 === this.count ? null : this.Mb;
};
h.ja = function() {
  return this.count;
};
h.kc = function() {
  return this.first;
};
h.lc = function() {
  return Lc(this);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return fd(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return this.first;
};
h.Ra = function() {
  return 1 === this.count ? ae : this.Mb;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new xf(b, this.first, this.Mb, this.count, this.F);
};
h.fa = function(a, b) {
  return new xf(this.meta, b, this, this.count + 1, null);
};
function yf(a) {
  return null != a ? a.w & 33554432 || q === a.rh ? !0 : a.w ? !1 : oc(od, a) : oc(od, a);
}
xf.prototype[sc] = function() {
  return de(this);
};
function zf(a) {
  this.meta = a;
  this.w = 65937614;
  this.K = 8192;
}
h = zf.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new zf(this.meta);
};
h.Ya = function() {
  return null;
};
h.ja = function() {
  return 0;
};
h.kc = function() {
  return null;
};
h.lc = function() {
  throw Error("Can't pop empty list");
};
h.V = function() {
  return ge;
};
h.I = function(a, b) {
  return yf(b) || Se(b) ? null == D(b) : !1;
};
h.na = function() {
  return this;
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return null;
};
h.Ra = function() {
  return ae;
};
h.ea = function() {
  return null;
};
h.T = function(a, b) {
  return new zf(b);
};
h.fa = function(a, b) {
  return new xf(this.meta, b, null, 1, null);
};
var ae = new zf(null);
zf.prototype[sc] = function() {
  return de(this);
};
function Af(a) {
  return (null != a ? a.w & 134217728 || q === a.uh || (a.w ? 0 : oc(rd, a)) : oc(rd, a)) ? sd(a) : xc(Ge, ae, a);
}
var Bf = function Bf(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  return Bf.B(0 < c.length ? new F(c.slice(0), 0, null) : null);
};
Bf.B = function(a) {
  var b;
  if (a instanceof F && 0 === a.i) {
    b = a.o;
  } else {
    a: {
      for (b = [];;) {
        if (null != a) {
          b.push(a.za(null)), a = a.Ya(null);
        } else {
          break a;
        }
      }
    }
  }
  a = b.length;
  for (var c = ae;;) {
    if (0 < a) {
      var d = a - 1, c = c.fa(null, b[a - 1]);
      a = d;
    } else {
      return c;
    }
  }
};
Bf.L = 0;
Bf.J = function(a) {
  return Bf.B(D(a));
};
function Cf(a, b, c, d) {
  this.meta = a;
  this.first = b;
  this.Mb = c;
  this.F = d;
  this.w = 65929452;
  this.K = 8192;
}
h = Cf.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new Cf(this.meta, this.first, this.Mb, this.F);
};
h.Ya = function() {
  return null == this.Mb ? null : D(this.Mb);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return this.first;
};
h.Ra = function() {
  return null == this.Mb ? ae : this.Mb;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new Cf(b, this.first, this.Mb, this.F);
};
h.fa = function(a, b) {
  return new Cf(null, b, this, null);
};
Cf.prototype[sc] = function() {
  return de(this);
};
function ze(a, b) {
  var c = null == b;
  return (c ? c : null != b && (b.w & 64 || q === b.M)) ? new Cf(null, a, b, null) : new Cf(null, a, D(b), null);
}
function Df(a, b) {
  if (a.fb === b.fb) {
    return 0;
  }
  var c = kc(a.Wa);
  if (w(c ? b.Wa : c)) {
    return -1;
  }
  if (w(a.Wa)) {
    if (kc(b.Wa)) {
      return 1;
    }
    c = wb(a.Wa, b.Wa);
    return 0 === c ? wb(a.name, b.name) : c;
  }
  return wb(a.name, b.name);
}
function X(a, b, c, d) {
  this.Wa = a;
  this.name = b;
  this.fb = c;
  this.Mc = d;
  this.w = 2153775105;
  this.K = 4096;
}
h = X.prototype;
h.toString = function() {
  return [y(":"), y(this.fb)].join("");
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.I = function(a, b) {
  return b instanceof X ? this.fb === b.fb : !1;
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return C.j(c, this);
      case 3:
        return C.l(c, this, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return C.j(c, this);
  };
  a.l = function(a, c, d) {
    return C.l(c, this, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return C.j(a, this);
};
h.j = function(a, b) {
  return C.l(a, this, b);
};
h.V = function() {
  var a = this.Mc;
  return null != a ? a : this.Mc = a = Xd(Sd(this.name), Vd(this.Wa)) + 2654435769 | 0;
};
h.pd = function() {
  return this.name;
};
h.qd = function() {
  return this.Wa;
};
h.W = function(a, b) {
  return td(b, [y(":"), y(this.fb)].join(""));
};
function Y(a, b) {
  return a === b ? !0 : a instanceof X && b instanceof X ? a.fb === b.fb : !1;
}
function Ef(a) {
  if (null != a && (a.K & 4096 || q === a.pf)) {
    return a.qd(null);
  }
  throw Error([y("Doesn't support namespace: "), y(a)].join(""));
}
var Ff = function Ff(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return Ff.h(arguments[0]);
    case 2:
      return Ff.j(arguments[0], arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Ff.h = function(a) {
  if (a instanceof X) {
    return a;
  }
  if (a instanceof A) {
    return new X(Ef(a), Gf.h ? Gf.h(a) : Gf.call(null, a), a.ab, null);
  }
  if ("string" === typeof a) {
    var b = a.split("/");
    return 2 === b.length ? new X(b[0], b[1], a, null) : new X(null, b[0], a, null);
  }
  return null;
};
Ff.j = function(a, b) {
  var c = a instanceof X ? Gf.h ? Gf.h(a) : Gf.call(null, a) : a instanceof A ? Gf.h ? Gf.h(a) : Gf.call(null, a) : a, d = b instanceof X ? Gf.h ? Gf.h(b) : Gf.call(null, b) : b instanceof A ? Gf.h ? Gf.h(b) : Gf.call(null, b) : b;
  return new X(c, d, [y(w(c) ? [y(c), y("/")].join("") : null), y(d)].join(""), null);
};
Ff.L = 2;
function Hf(a, b, c, d) {
  this.meta = a;
  this.Sb = b;
  this.s = c;
  this.F = d;
  this.w = 32374988;
  this.K = 1;
}
h = Hf.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
function If(a) {
  null != a.Sb && (a.s = a.Sb.v ? a.Sb.v() : a.Sb.call(null), a.Sb = null);
  return a.s;
}
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Ya = function() {
  md(this);
  return null == this.s ? null : H(this.s);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  md(this);
  return null == this.s ? null : G(this.s);
};
h.Ra = function() {
  md(this);
  return null != this.s ? $d(this.s) : ae;
};
h.ea = function() {
  If(this);
  if (null == this.s) {
    return null;
  }
  for (var a = this.s;;) {
    if (a instanceof Hf) {
      a = If(a);
    } else {
      return this.s = a, D(this.s);
    }
  }
};
h.T = function(a, b) {
  return new Hf(b, this.Sb, this.s, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
Hf.prototype[sc] = function() {
  return de(this);
};
function Jf(a, b) {
  this.Y = a;
  this.end = b;
  this.w = 2;
  this.K = 0;
}
Jf.prototype.add = function(a) {
  this.Y[this.end] = a;
  return this.end += 1;
};
Jf.prototype.ib = function() {
  var a = new Kf(this.Y, 0, this.end);
  this.Y = null;
  return a;
};
Jf.prototype.ja = function() {
  return this.end;
};
function Kf(a, b, c) {
  this.o = a;
  this.off = b;
  this.end = c;
  this.w = 524306;
  this.K = 0;
}
h = Kf.prototype;
h.ja = function() {
  return this.end - this.off;
};
h.aa = function(a, b) {
  return this.o[this.off + b];
};
h.cb = function(a, b, c) {
  return 0 <= b && b < this.end - this.off ? this.o[this.off + b] : c;
};
h.lf = function() {
  if (this.off === this.end) {
    throw Error("-drop-first of empty chunk");
  }
  return new Kf(this.o, this.off + 1, this.end);
};
h.xa = function(a, b) {
  return qe(this.o, b, this.o[this.off], this.off + 1);
};
h.ya = function(a, b, c) {
  return qe(this.o, b, c, this.off);
};
function Lf(a, b, c, d) {
  this.ib = a;
  this.Ub = b;
  this.meta = c;
  this.F = d;
  this.w = 31850732;
  this.K = 1536;
}
h = Lf.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Ya = function() {
  if (1 < Dc(this.ib)) {
    return new Lf(Cd(this.ib), this.Ub, this.meta, null);
  }
  var a = md(this.Ub);
  return null == a ? null : a;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.za = function() {
  return Ic.j(this.ib, 0);
};
h.Ra = function() {
  return 1 < Dc(this.ib) ? new Lf(Cd(this.ib), this.Ub, this.meta, null) : null == this.Ub ? ae : this.Ub;
};
h.ea = function() {
  return this;
};
h.ye = function() {
  return this.ib;
};
h.ze = function() {
  return null == this.Ub ? ae : this.Ub;
};
h.T = function(a, b) {
  return new Lf(this.ib, this.Ub, b, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
h.xe = function() {
  return null == this.Ub ? null : this.Ub;
};
Lf.prototype[sc] = function() {
  return de(this);
};
function Mf(a, b) {
  return 0 === Dc(a) ? b : new Lf(a, b, null, null);
}
function Nf(a, b) {
  a.add(b);
}
function jf(a) {
  for (var b = [];;) {
    if (D(a)) {
      b.push(G(a)), a = H(a);
    } else {
      return b;
    }
  }
}
function Of(a) {
  if ("number" === typeof a) {
    a: {
      var b = Array(a);
      if ($e(null)) {
        for (var c = 0, d = D(null);;) {
          if (d && c < a) {
            b[c] = G(d), c += 1, d = H(d);
          } else {
            a = b;
            break a;
          }
        }
      } else {
        for (c = 0;;) {
          if (c < a) {
            b[c] = null, c += 1;
          } else {
            break;
          }
        }
        a = b;
      }
    }
  } else {
    a = vc(a);
  }
  return a;
}
function Pf(a, b) {
  if (re(b)) {
    return O(b);
  }
  for (var c = 0, d = D(b);;) {
    if (null != d && c < a) {
      c += 1, d = H(d);
    } else {
      return c;
    }
  }
}
var Qf = function Qf(b) {
  var c;
  if (null == b) {
    c = null;
  } else {
    if (null == H(b)) {
      c = D(G(b));
    } else {
      c = ze;
      var d = G(b);
      b = H(b);
      b = Qf.h ? Qf.h(b) : Qf.call(null, b);
      c = c(d, b);
    }
  }
  return c;
}, Rf = function Rf(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return Rf.v();
    case 1:
      return Rf.h(arguments[0]);
    case 2:
      return Rf.j(arguments[0], arguments[1]);
    default:
      return Rf.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
Rf.v = function() {
  return new Hf(null, function() {
    return null;
  }, null, null);
};
Rf.h = function(a) {
  return new Hf(null, function() {
    return a;
  }, null, null);
};
Rf.j = function(a, b) {
  return new Hf(null, function() {
    var c = D(a);
    return c ? We(c) ? Mf(Dd(c), Rf.j(Ed(c), b)) : ze(G(c), Rf.j($d(c), b)) : b;
  }, null, null);
};
Rf.B = function(a, b, c) {
  return function e(a, b) {
    return new Hf(null, function() {
      var c = D(a);
      return c ? We(c) ? Mf(Dd(c), e(Ed(c), b)) : ze(G(c), e($d(c), b)) : w(b) ? e(G(b), H(b)) : null;
    }, null, null);
  }(Rf.j(a, b), c);
};
Rf.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return Rf.B(b, a, c);
};
Rf.L = 2;
var Sf = function Sf(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return Sf.v();
    case 1:
      return Sf.h(arguments[0]);
    case 2:
      return Sf.j(arguments[0], arguments[1]);
    default:
      return Sf.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
Sf.v = function() {
  return vd(He);
};
Sf.h = function(a) {
  return a;
};
Sf.j = function(a, b) {
  return wd(a, b);
};
Sf.B = function(a, b, c) {
  for (;;) {
    if (a = wd(a, b), w(c)) {
      b = G(c), c = H(c);
    } else {
      return a;
    }
  }
};
Sf.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return Sf.B(b, a, c);
};
Sf.L = 2;
var Tf = function Tf(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 3:
      return Tf.l(arguments[0], arguments[1], arguments[2]);
    default:
      return Tf.B(arguments[0], arguments[1], arguments[2], new F(c.slice(3), 0, null));
  }
};
Tf.l = function(a, b, c) {
  return yd(a, b, c);
};
Tf.B = function(a, b, c, d) {
  for (;;) {
    if (a = yd(a, b, c), w(d)) {
      b = G(d), c = Fe(d), d = H(H(d));
    } else {
      return a;
    }
  }
};
Tf.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), d = H(d);
  return Tf.B(b, a, c, d);
};
Tf.L = 3;
function Uf(a, b, c) {
  var d = D(c);
  if (0 === b) {
    return a.v ? a.v() : a.call(null);
  }
  c = Kc(d);
  var e = Lc(d);
  if (1 === b) {
    return a.h ? a.h(c) : a.h ? a.h(c) : a.call(null, c);
  }
  var d = Kc(e), f = Lc(e);
  if (2 === b) {
    return a.j ? a.j(c, d) : a.j ? a.j(c, d) : a.call(null, c, d);
  }
  var e = Kc(f), g = Lc(f);
  if (3 === b) {
    return a.l ? a.l(c, d, e) : a.l ? a.l(c, d, e) : a.call(null, c, d, e);
  }
  var f = Kc(g), k = Lc(g);
  if (4 === b) {
    return a.H ? a.H(c, d, e, f) : a.H ? a.H(c, d, e, f) : a.call(null, c, d, e, f);
  }
  var g = Kc(k), l = Lc(k);
  if (5 === b) {
    return a.O ? a.O(c, d, e, f, g) : a.O ? a.O(c, d, e, f, g) : a.call(null, c, d, e, f, g);
  }
  var k = Kc(l), m = Lc(l);
  if (6 === b) {
    return a.ua ? a.ua(c, d, e, f, g, k) : a.ua ? a.ua(c, d, e, f, g, k) : a.call(null, c, d, e, f, g, k);
  }
  var l = Kc(m), n = Lc(m);
  if (7 === b) {
    return a.wa ? a.wa(c, d, e, f, g, k, l) : a.wa ? a.wa(c, d, e, f, g, k, l) : a.call(null, c, d, e, f, g, k, l);
  }
  var m = Kc(n), t = Lc(n);
  if (8 === b) {
    return a.Pa ? a.Pa(c, d, e, f, g, k, l, m) : a.Pa ? a.Pa(c, d, e, f, g, k, l, m) : a.call(null, c, d, e, f, g, k, l, m);
  }
  var n = Kc(t), r = Lc(t);
  if (9 === b) {
    return a.Qa ? a.Qa(c, d, e, f, g, k, l, m, n) : a.Qa ? a.Qa(c, d, e, f, g, k, l, m, n) : a.call(null, c, d, e, f, g, k, l, m, n);
  }
  var t = Kc(r), v = Lc(r);
  if (10 === b) {
    return a.Ea ? a.Ea(c, d, e, f, g, k, l, m, n, t) : a.Ea ? a.Ea(c, d, e, f, g, k, l, m, n, t) : a.call(null, c, d, e, f, g, k, l, m, n, t);
  }
  var r = Kc(v), x = Lc(v);
  if (11 === b) {
    return a.Fa ? a.Fa(c, d, e, f, g, k, l, m, n, t, r) : a.Fa ? a.Fa(c, d, e, f, g, k, l, m, n, t, r) : a.call(null, c, d, e, f, g, k, l, m, n, t, r);
  }
  var v = Kc(x), z = Lc(x);
  if (12 === b) {
    return a.Ga ? a.Ga(c, d, e, f, g, k, l, m, n, t, r, v) : a.Ga ? a.Ga(c, d, e, f, g, k, l, m, n, t, r, v) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v);
  }
  var x = Kc(z), B = Lc(z);
  if (13 === b) {
    return a.Ha ? a.Ha(c, d, e, f, g, k, l, m, n, t, r, v, x) : a.Ha ? a.Ha(c, d, e, f, g, k, l, m, n, t, r, v, x) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x);
  }
  var z = Kc(B), I = Lc(B);
  if (14 === b) {
    return a.Ia ? a.Ia(c, d, e, f, g, k, l, m, n, t, r, v, x, z) : a.Ia ? a.Ia(c, d, e, f, g, k, l, m, n, t, r, v, x, z) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z);
  }
  var B = Kc(I), U = Lc(I);
  if (15 === b) {
    return a.Ja ? a.Ja(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : a.Ja ? a.Ja(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
  }
  var I = Kc(U), V = Lc(U);
  if (16 === b) {
    return a.Ka ? a.Ka(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) : a.Ka ? a.Ka(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I);
  }
  var U = Kc(V), Q = Lc(V);
  if (17 === b) {
    return a.La ? a.La(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) : a.La ? a.La(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U);
  }
  var V = Kc(Q), K = Lc(Q);
  if (18 === b) {
    return a.Ma ? a.Ma(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) : a.Ma ? a.Ma(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V);
  }
  Q = Kc(K);
  K = Lc(K);
  if (19 === b) {
    return a.Na ? a.Na(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q) : a.Na ? a.Na(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q);
  }
  var E = Kc(K);
  Lc(K);
  if (20 === b) {
    return a.Oa ? a.Oa(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q, E) : a.Oa ? a.Oa(c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q, E) : a.call(null, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q, E);
  }
  throw Error("Only up to 20 arguments supported on functions");
}
function Ne(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 2:
      return Vf(arguments[0], arguments[1]);
    case 3:
      return Wf(arguments[0], arguments[1], arguments[2]);
    case 4:
      return Xf(arguments[0], arguments[1], arguments[2], arguments[3]);
    case 5:
      return Yf(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    default:
      return Zf(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], new F(b.slice(5), 0, null));
  }
}
function Vf(a, b) {
  var c = a.L;
  if (a.J) {
    var d = Pf(c + 1, b);
    return d <= c ? Uf(a, d, b) : a.J(b);
  }
  return a.apply(a, jf(b));
}
function Wf(a, b, c) {
  b = ze(b, c);
  c = a.L;
  if (a.J) {
    var d = Pf(c + 1, b);
    return d <= c ? Uf(a, d, b) : a.J(b);
  }
  return a.apply(a, jf(b));
}
function Xf(a, b, c, d) {
  b = ze(b, ze(c, d));
  c = a.L;
  return a.J ? (d = Pf(c + 1, b), d <= c ? Uf(a, d, b) : a.J(b)) : a.apply(a, jf(b));
}
function Yf(a, b, c, d, e) {
  b = ze(b, ze(c, ze(d, e)));
  c = a.L;
  return a.J ? (d = Pf(c + 1, b), d <= c ? Uf(a, d, b) : a.J(b)) : a.apply(a, jf(b));
}
function Zf(a, b, c, d, e, f) {
  b = ze(b, ze(c, ze(d, ze(e, Qf(f)))));
  c = a.L;
  return a.J ? (d = Pf(c + 1, b), d <= c ? Uf(a, d, b) : a.J(b)) : a.apply(a, jf(b));
}
var $f = function $f(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return $f.h(arguments[0]);
    case 2:
      return $f.j(arguments[0], arguments[1]);
    default:
      return $f.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
$f.h = function() {
  return !1;
};
$f.j = function(a, b) {
  return !J.j(a, b);
};
$f.B = function(a, b, c) {
  return kc(Xf(J, a, b, c));
};
$f.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return $f.B(b, a, c);
};
$f.L = 2;
function ag(a) {
  return D(a) ? a : null;
}
function bg() {
  "undefined" === typeof Xb && (Xb = function(a) {
    this.Eg = a;
    this.w = 393216;
    this.K = 0;
  }, Xb.prototype.T = function(a, b) {
    return new Xb(b);
  }, Xb.prototype.S = function() {
    return this.Eg;
  }, Xb.prototype.Da = function() {
    return !1;
  }, Xb.prototype.next = function() {
    return Error("No such element");
  }, Xb.prototype.remove = function() {
    return Error("Unsupported operation");
  }, Xb.cc = function() {
    return new T(null, 1, 5, W, [cg], null);
  }, Xb.Db = !0, Xb.ob = "cljs.core/t_cljs$core60419", Xb.Rb = function(a, b) {
    return td(b, "cljs.core/t_cljs$core60419");
  });
  return new Xb(dg);
}
function eg(a, b) {
  for (;;) {
    if (null == D(b)) {
      return !0;
    }
    var c;
    c = G(b);
    c = a.h ? a.h(c) : a.call(null, c);
    if (w(c)) {
      c = a;
      var d = H(b);
      a = c;
      b = d;
    } else {
      return !1;
    }
  }
}
function fg(a, b) {
  for (;;) {
    if (D(b)) {
      var c;
      c = G(b);
      c = a.h ? a.h(c) : a.call(null, c);
      if (w(c)) {
        return c;
      }
      c = a;
      var d = H(b);
      a = c;
      b = d;
    } else {
      return null;
    }
  }
}
function gg(a) {
  return function() {
    function b(b, c) {
      return kc(a.j ? a.j(b, c) : a.call(null, b, c));
    }
    function c(b) {
      return kc(a.h ? a.h(b) : a.call(null, b));
    }
    function d() {
      return kc(a.v ? a.v() : a.call(null));
    }
    var e = null, f = function() {
      function b(a, b, d) {
        var e = null;
        if (2 < arguments.length) {
          for (var e = 0, f = Array(arguments.length - 2);e < f.length;) {
            f[e] = arguments[e + 2], ++e;
          }
          e = new F(f, 0);
        }
        return c.call(this, a, b, e);
      }
      function c(b, c, d) {
        return kc(Xf(a, b, c, d));
      }
      b.L = 2;
      b.J = function(a) {
        var b = G(a);
        a = H(a);
        var d = G(a);
        a = $d(a);
        return c(b, d, a);
      };
      b.B = c;
      return b;
    }(), e = function(a, e, l) {
      switch(arguments.length) {
        case 0:
          return d.call(this);
        case 1:
          return c.call(this, a);
        case 2:
          return b.call(this, a, e);
        default:
          var g = null;
          if (2 < arguments.length) {
            for (var g = 0, k = Array(arguments.length - 2);g < k.length;) {
              k[g] = arguments[g + 2], ++g;
            }
            g = new F(k, 0);
          }
          return f.B(a, e, g);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    e.L = 2;
    e.J = f.J;
    e.v = d;
    e.h = c;
    e.j = b;
    e.B = f.B;
    return e;
  }();
}
function hg() {
  return function() {
    function a(a) {
      if (0 < arguments.length) {
        for (var b = 0, d = Array(arguments.length - 0);b < d.length;) {
          d[b] = arguments[b + 0], ++b;
        }
      }
      return !1;
    }
    a.L = 0;
    a.J = function(a) {
      D(a);
      return !1;
    };
    a.B = function() {
      return !1;
    };
    return a;
  }();
}
var ig = function ig(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return ig.v();
    case 1:
      return ig.h(arguments[0]);
    case 2:
      return ig.j(arguments[0], arguments[1]);
    case 3:
      return ig.l(arguments[0], arguments[1], arguments[2]);
    default:
      return ig.B(arguments[0], arguments[1], arguments[2], new F(c.slice(3), 0, null));
  }
};
ig.v = function() {
  return mf;
};
ig.h = function(a) {
  return a;
};
ig.j = function(a, b) {
  return function() {
    function c(c, d, e) {
      c = b.l ? b.l(c, d, e) : b.call(null, c, d, e);
      return a.h ? a.h(c) : a.call(null, c);
    }
    function d(c, d) {
      var e = b.j ? b.j(c, d) : b.call(null, c, d);
      return a.h ? a.h(e) : a.call(null, e);
    }
    function e(c) {
      c = b.h ? b.h(c) : b.call(null, c);
      return a.h ? a.h(c) : a.call(null, c);
    }
    function f() {
      var c = b.v ? b.v() : b.call(null);
      return a.h ? a.h(c) : a.call(null, c);
    }
    var g = null, k = function() {
      function c(a, b, c, e) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return d.call(this, a, b, c, f);
      }
      function d(c, d, e, f) {
        c = Yf(b, c, d, e, f);
        return a.h ? a.h(c) : a.call(null, c);
      }
      c.L = 3;
      c.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var e = G(a);
        a = $d(a);
        return d(b, c, e, a);
      };
      c.B = d;
      return c;
    }(), g = function(a, b, g, t) {
      switch(arguments.length) {
        case 0:
          return f.call(this);
        case 1:
          return e.call(this, a);
        case 2:
          return d.call(this, a, b);
        case 3:
          return c.call(this, a, b, g);
        default:
          var l = null;
          if (3 < arguments.length) {
            for (var l = 0, m = Array(arguments.length - 3);l < m.length;) {
              m[l] = arguments[l + 3], ++l;
            }
            l = new F(m, 0);
          }
          return k.B(a, b, g, l);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    g.L = 3;
    g.J = k.J;
    g.v = f;
    g.h = e;
    g.j = d;
    g.l = c;
    g.B = k.B;
    return g;
  }();
};
ig.l = function(a, b, c) {
  return function() {
    function d(d, e, f) {
      d = c.l ? c.l(d, e, f) : c.call(null, d, e, f);
      d = b.h ? b.h(d) : b.call(null, d);
      return a.h ? a.h(d) : a.call(null, d);
    }
    function e(d, e) {
      var f;
      f = c.j ? c.j(d, e) : c.call(null, d, e);
      f = b.h ? b.h(f) : b.call(null, f);
      return a.h ? a.h(f) : a.call(null, f);
    }
    function f(d) {
      d = c.h ? c.h(d) : c.call(null, d);
      d = b.h ? b.h(d) : b.call(null, d);
      return a.h ? a.h(d) : a.call(null, d);
    }
    function g() {
      var d;
      d = c.v ? c.v() : c.call(null);
      d = b.h ? b.h(d) : b.call(null, d);
      return a.h ? a.h(d) : a.call(null, d);
    }
    var k = null, l = function() {
      function d(a, b, c, d) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return e.call(this, a, b, c, f);
      }
      function e(d, e, f, g) {
        d = Yf(c, d, e, f, g);
        d = b.h ? b.h(d) : b.call(null, d);
        return a.h ? a.h(d) : a.call(null, d);
      }
      d.L = 3;
      d.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var d = G(a);
        a = $d(a);
        return e(b, c, d, a);
      };
      d.B = e;
      return d;
    }(), k = function(a, b, c, k) {
      switch(arguments.length) {
        case 0:
          return g.call(this);
        case 1:
          return f.call(this, a);
        case 2:
          return e.call(this, a, b);
        case 3:
          return d.call(this, a, b, c);
        default:
          var m = null;
          if (3 < arguments.length) {
            for (var m = 0, n = Array(arguments.length - 3);m < n.length;) {
              n[m] = arguments[m + 3], ++m;
            }
            m = new F(n, 0);
          }
          return l.B(a, b, c, m);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    k.L = 3;
    k.J = l.J;
    k.v = g;
    k.h = f;
    k.j = e;
    k.l = d;
    k.B = l.B;
    return k;
  }();
};
ig.B = function(a, b, c, d) {
  return function(a) {
    return function() {
      function b(a) {
        var b = null;
        if (0 < arguments.length) {
          for (var b = 0, d = Array(arguments.length - 0);b < d.length;) {
            d[b] = arguments[b + 0], ++b;
          }
          b = new F(d, 0);
        }
        return c.call(this, b);
      }
      function c(b) {
        b = Vf(G(a), b);
        for (var c = H(a);;) {
          if (c) {
            b = G(c).call(null, b), c = H(c);
          } else {
            return b;
          }
        }
      }
      b.L = 0;
      b.J = function(a) {
        a = D(a);
        return c(a);
      };
      b.B = c;
      return b;
    }();
  }(Af(ze(a, ze(b, ze(c, d)))));
};
ig.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), d = H(d);
  return ig.B(b, a, c, d);
};
ig.L = 3;
function jg(a, b) {
  return function() {
    function c(c, d, e) {
      return a.H ? a.H(b, c, d, e) : a.call(null, b, c, d, e);
    }
    function d(c, d) {
      return a.l ? a.l(b, c, d) : a.call(null, b, c, d);
    }
    function e(c) {
      return a.j ? a.j(b, c) : a.call(null, b, c);
    }
    function f() {
      return a.h ? a.h(b) : a.call(null, b);
    }
    var g = null, k = function() {
      function c(a, b, c, e) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return d.call(this, a, b, c, f);
      }
      function d(c, d, e, f) {
        return Zf(a, b, c, d, e, P([f], 0));
      }
      c.L = 3;
      c.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var e = G(a);
        a = $d(a);
        return d(b, c, e, a);
      };
      c.B = d;
      return c;
    }(), g = function(a, b, g, t) {
      switch(arguments.length) {
        case 0:
          return f.call(this);
        case 1:
          return e.call(this, a);
        case 2:
          return d.call(this, a, b);
        case 3:
          return c.call(this, a, b, g);
        default:
          var l = null;
          if (3 < arguments.length) {
            for (var l = 0, m = Array(arguments.length - 3);l < m.length;) {
              m[l] = arguments[l + 3], ++l;
            }
            l = new F(m, 0);
          }
          return k.B(a, b, g, l);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    g.L = 3;
    g.J = k.J;
    g.v = f;
    g.h = e;
    g.j = d;
    g.l = c;
    g.B = k.B;
    return g;
  }();
}
function kg(a, b, c) {
  var d = lg;
  return function() {
    function e(e, f, g) {
      return d.ua ? d.ua(a, b, c, e, f, g) : d.call(null, a, b, c, e, f, g);
    }
    function f(e, f) {
      return d.O ? d.O(a, b, c, e, f) : d.call(null, a, b, c, e, f);
    }
    function g(e) {
      return d.H ? d.H(a, b, c, e) : d.call(null, a, b, c, e);
    }
    function k() {
      return d.l ? d.l(a, b, c) : d.call(null, a, b, c);
    }
    var l = null, m = function() {
      function e(a, b, c, d) {
        var e = null;
        if (3 < arguments.length) {
          for (var e = 0, g = Array(arguments.length - 3);e < g.length;) {
            g[e] = arguments[e + 3], ++e;
          }
          e = new F(g, 0);
        }
        return f.call(this, a, b, c, e);
      }
      function f(e, f, g, k) {
        return Zf(d, a, b, c, e, P([f, g, k], 0));
      }
      e.L = 3;
      e.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var d = G(a);
        a = $d(a);
        return f(b, c, d, a);
      };
      e.B = f;
      return e;
    }(), l = function(a, b, c, d) {
      switch(arguments.length) {
        case 0:
          return k.call(this);
        case 1:
          return g.call(this, a);
        case 2:
          return f.call(this, a, b);
        case 3:
          return e.call(this, a, b, c);
        default:
          var l = null;
          if (3 < arguments.length) {
            for (var l = 0, n = Array(arguments.length - 3);l < n.length;) {
              n[l] = arguments[l + 3], ++l;
            }
            l = new F(n, 0);
          }
          return m.B(a, b, c, l);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    l.L = 3;
    l.J = m.J;
    l.v = k;
    l.h = g;
    l.j = f;
    l.l = e;
    l.B = m.B;
    return l;
  }();
}
function mg(a, b, c, d) {
  this.state = a;
  this.meta = b;
  this.lh = c;
  this.Xf = d;
  this.K = 16386;
  this.w = 6455296;
}
h = mg.prototype;
h.equiv = function(a) {
  return this.I(null, a);
};
h.I = function(a, b) {
  return this === b;
};
h.ld = function() {
  return this.state;
};
h.S = function() {
  return this.meta;
};
h.sf = function(a, b, c) {
  a = D(this.Xf);
  for (var d = null, e = 0, f = 0;;) {
    if (f < e) {
      var g = d.aa(null, f), k = S(g, 0, null), g = S(g, 1, null);
      g.H ? g.H(k, this, b, c) : g.call(null, k, this, b, c);
      f += 1;
    } else {
      if (a = D(a)) {
        We(a) ? (d = Dd(a), a = Ed(a), k = d, e = O(d), d = k) : (d = G(a), k = S(d, 0, null), g = S(d, 1, null), g.H ? g.H(k, this, b, c) : g.call(null, k, this, b, c), a = H(a), d = null, e = 0), f = 0;
      } else {
        return null;
      }
    }
  }
};
h.V = function() {
  return la(this);
};
function ng(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return og(arguments[0]);
    default:
      return c = arguments[0], b = new F(b.slice(1), 0, null), d = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, b = C.j(d, fc), d = C.j(d, qg), new mg(c, b, d, null);
  }
}
function og(a) {
  return new mg(a, null, null, null);
}
function rg(a, b) {
  if (a instanceof mg) {
    var c = a.lh;
    if (null != c && !w(c.h ? c.h(b) : c.call(null, b))) {
      throw Error("Validator rejected reference state");
    }
    c = a.state;
    a.state = b;
    null != a.Xf && ud(a, c, b);
    return b;
  }
  return Id(a, b);
}
var sg = function sg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return sg.j(arguments[0], arguments[1]);
    case 3:
      return sg.l(arguments[0], arguments[1], arguments[2]);
    case 4:
      return sg.H(arguments[0], arguments[1], arguments[2], arguments[3]);
    default:
      return sg.B(arguments[0], arguments[1], arguments[2], arguments[3], new F(c.slice(4), 0, null));
  }
};
sg.j = function(a, b) {
  var c;
  a instanceof mg ? (c = a.state, c = b.h ? b.h(c) : b.call(null, c), c = rg(a, c)) : c = Jd.j(a, b);
  return c;
};
sg.l = function(a, b, c) {
  if (a instanceof mg) {
    var d = a.state;
    b = b.j ? b.j(d, c) : b.call(null, d, c);
    a = rg(a, b);
  } else {
    a = Jd.l(a, b, c);
  }
  return a;
};
sg.H = function(a, b, c, d) {
  if (a instanceof mg) {
    var e = a.state;
    b = b.l ? b.l(e, c, d) : b.call(null, e, c, d);
    a = rg(a, b);
  } else {
    a = Jd.H(a, b, c, d);
  }
  return a;
};
sg.B = function(a, b, c, d, e) {
  return a instanceof mg ? rg(a, Yf(b, a.state, c, d, e)) : Jd.O(a, b, c, d, e);
};
sg.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), e = H(d), d = G(e), e = H(e);
  return sg.B(b, a, c, d, e);
};
sg.L = 4;
function tg(a) {
  this.state = a;
  this.w = 32768;
  this.K = 0;
}
tg.prototype.rf = function(a, b) {
  return this.state = b;
};
tg.prototype.ld = function() {
  return this.state;
};
var ug = function ug(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return ug.h(arguments[0]);
    case 2:
      return ug.j(arguments[0], arguments[1]);
    case 3:
      return ug.l(arguments[0], arguments[1], arguments[2]);
    default:
      return ug.B(arguments[0], arguments[1], arguments[2], new F(c.slice(3), 0, null));
  }
};
ug.h = function(a) {
  return function() {
    function b(b, c, d) {
      b = a.h ? a.h(b) : a.call(null, b);
      w(b) ? (c = a.h ? a.h(c) : a.call(null, c), d = w(c) ? a.h ? a.h(d) : a.call(null, d) : c) : d = b;
      return af(d);
    }
    function c(b, c) {
      var d;
      d = a.h ? a.h(b) : a.call(null, b);
      d = w(d) ? a.h ? a.h(c) : a.call(null, c) : d;
      return af(d);
    }
    function d(b) {
      return af(a.h ? a.h(b) : a.call(null, b));
    }
    var e = null, f = function() {
      function b(a, b, d, e) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return c.call(this, a, b, d, f);
      }
      function c(b, c, d, f) {
        b = e.l(b, c, d);
        f = w(b) ? eg(a, f) : b;
        return af(f);
      }
      b.L = 3;
      b.J = function(a) {
        var b = G(a);
        a = H(a);
        var d = G(a);
        a = H(a);
        var e = G(a);
        a = $d(a);
        return c(b, d, e, a);
      };
      b.B = c;
      return b;
    }(), e = function(a, e, l, m) {
      switch(arguments.length) {
        case 0:
          return !0;
        case 1:
          return d.call(this, a);
        case 2:
          return c.call(this, a, e);
        case 3:
          return b.call(this, a, e, l);
        default:
          var g = null;
          if (3 < arguments.length) {
            for (var g = 0, k = Array(arguments.length - 3);g < k.length;) {
              k[g] = arguments[g + 3], ++g;
            }
            g = new F(k, 0);
          }
          return f.B(a, e, l, g);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    e.L = 3;
    e.J = f.J;
    e.v = function() {
      return !0;
    };
    e.h = d;
    e.j = c;
    e.l = b;
    e.B = f.B;
    return e;
  }();
};
ug.j = function(a, b) {
  return function() {
    function c(c, d, e) {
      return af(function() {
        var f = a.h ? a.h(c) : a.call(null, c);
        return w(f) && (f = a.h ? a.h(d) : a.call(null, d), w(f) && (f = a.h ? a.h(e) : a.call(null, e), w(f) && (f = b.h ? b.h(c) : b.call(null, c), w(f)))) ? (f = b.h ? b.h(d) : b.call(null, d), w(f) ? b.h ? b.h(e) : b.call(null, e) : f) : f;
      }());
    }
    function d(c, d) {
      return af(function() {
        var e = a.h ? a.h(c) : a.call(null, c);
        return w(e) && (e = a.h ? a.h(d) : a.call(null, d), w(e)) ? (e = b.h ? b.h(c) : b.call(null, c), w(e) ? b.h ? b.h(d) : b.call(null, d) : e) : e;
      }());
    }
    function e(c) {
      var d = a.h ? a.h(c) : a.call(null, c);
      c = w(d) ? b.h ? b.h(c) : b.call(null, c) : d;
      return af(c);
    }
    var f = null, g = function() {
      function c(a, b, c, e) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return d.call(this, a, b, c, f);
      }
      function d(c, d, e, g) {
        return af(function() {
          var k = f.l(c, d, e);
          return w(k) ? eg(function() {
            return function(c) {
              var d = a.h ? a.h(c) : a.call(null, c);
              return w(d) ? b.h ? b.h(c) : b.call(null, c) : d;
            };
          }(k), g) : k;
        }());
      }
      c.L = 3;
      c.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var e = G(a);
        a = $d(a);
        return d(b, c, e, a);
      };
      c.B = d;
      return c;
    }(), f = function(a, b, f, n) {
      switch(arguments.length) {
        case 0:
          return !0;
        case 1:
          return e.call(this, a);
        case 2:
          return d.call(this, a, b);
        case 3:
          return c.call(this, a, b, f);
        default:
          var k = null;
          if (3 < arguments.length) {
            for (var k = 0, l = Array(arguments.length - 3);k < l.length;) {
              l[k] = arguments[k + 3], ++k;
            }
            k = new F(l, 0);
          }
          return g.B(a, b, f, k);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    f.L = 3;
    f.J = g.J;
    f.v = function() {
      return !0;
    };
    f.h = e;
    f.j = d;
    f.l = c;
    f.B = g.B;
    return f;
  }();
};
ug.l = function(a, b, c) {
  return function() {
    function d(d, e, f) {
      return af(function() {
        var g = a.h ? a.h(d) : a.call(null, d);
        return w(g) && (g = b.h ? b.h(d) : b.call(null, d), w(g) && (g = c.h ? c.h(d) : c.call(null, d), w(g) && (g = a.h ? a.h(e) : a.call(null, e), w(g) && (g = b.h ? b.h(e) : b.call(null, e), w(g) && (g = c.h ? c.h(e) : c.call(null, e), w(g) && (g = a.h ? a.h(f) : a.call(null, f), w(g))))))) ? (g = b.h ? b.h(f) : b.call(null, f), w(g) ? c.h ? c.h(f) : c.call(null, f) : g) : g;
      }());
    }
    function e(d, e) {
      return af(function() {
        var f = a.h ? a.h(d) : a.call(null, d);
        return w(f) && (f = b.h ? b.h(d) : b.call(null, d), w(f) && (f = c.h ? c.h(d) : c.call(null, d), w(f) && (f = a.h ? a.h(e) : a.call(null, e), w(f)))) ? (f = b.h ? b.h(e) : b.call(null, e), w(f) ? c.h ? c.h(e) : c.call(null, e) : f) : f;
      }());
    }
    function f(d) {
      var e = a.h ? a.h(d) : a.call(null, d);
      w(e) ? (e = b.h ? b.h(d) : b.call(null, d), d = w(e) ? c.h ? c.h(d) : c.call(null, d) : e) : d = e;
      return af(d);
    }
    var g = null, k = function() {
      function d(a, b, c, d) {
        var f = null;
        if (3 < arguments.length) {
          for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
            g[f] = arguments[f + 3], ++f;
          }
          f = new F(g, 0);
        }
        return e.call(this, a, b, c, f);
      }
      function e(d, e, f, k) {
        return af(function() {
          var l = g.l(d, e, f);
          return w(l) ? eg(function() {
            return function(d) {
              var e = a.h ? a.h(d) : a.call(null, d);
              return w(e) ? (e = b.h ? b.h(d) : b.call(null, d), w(e) ? c.h ? c.h(d) : c.call(null, d) : e) : e;
            };
          }(l), k) : l;
        }());
      }
      d.L = 3;
      d.J = function(a) {
        var b = G(a);
        a = H(a);
        var c = G(a);
        a = H(a);
        var d = G(a);
        a = $d(a);
        return e(b, c, d, a);
      };
      d.B = e;
      return d;
    }(), g = function(a, b, c, g) {
      switch(arguments.length) {
        case 0:
          return !0;
        case 1:
          return f.call(this, a);
        case 2:
          return e.call(this, a, b);
        case 3:
          return d.call(this, a, b, c);
        default:
          var l = null;
          if (3 < arguments.length) {
            for (var l = 0, m = Array(arguments.length - 3);l < m.length;) {
              m[l] = arguments[l + 3], ++l;
            }
            l = new F(m, 0);
          }
          return k.B(a, b, c, l);
      }
      throw Error("Invalid arity: " + arguments.length);
    };
    g.L = 3;
    g.J = k.J;
    g.v = function() {
      return !0;
    };
    g.h = f;
    g.j = e;
    g.l = d;
    g.B = k.B;
    return g;
  }();
};
ug.B = function(a, b, c, d) {
  return function(a) {
    return function() {
      function b(b, c, d) {
        return eg(function() {
          return function(a) {
            var e = a.h ? a.h(b) : a.call(null, b);
            return w(e) ? (e = a.h ? a.h(c) : a.call(null, c), w(e) ? a.h ? a.h(d) : a.call(null, d) : e) : e;
          };
        }(a), a);
      }
      function c(b, c) {
        return eg(function() {
          return function(a) {
            var d = a.h ? a.h(b) : a.call(null, b);
            return w(d) ? a.h ? a.h(c) : a.call(null, c) : d;
          };
        }(a), a);
      }
      function d(b) {
        return eg(function() {
          return function(a) {
            return a.h ? a.h(b) : a.call(null, b);
          };
        }(a), a);
      }
      var e = null, m = function() {
        function b(a, b, d, e) {
          var f = null;
          if (3 < arguments.length) {
            for (var f = 0, g = Array(arguments.length - 3);f < g.length;) {
              g[f] = arguments[f + 3], ++f;
            }
            f = new F(g, 0);
          }
          return c.call(this, a, b, d, f);
        }
        function c(b, c, d, f) {
          return af(function() {
            var g = e.l(b, c, d);
            return w(g) ? eg(function() {
              return function(a) {
                return eg(a, f);
              };
            }(g, a), a) : g;
          }());
        }
        b.L = 3;
        b.J = function(a) {
          var b = G(a);
          a = H(a);
          var d = G(a);
          a = H(a);
          var e = G(a);
          a = $d(a);
          return c(b, d, e, a);
        };
        b.B = c;
        return b;
      }(), e = function(a, e, f, g) {
        switch(arguments.length) {
          case 0:
            return !0;
          case 1:
            return d.call(this, a);
          case 2:
            return c.call(this, a, e);
          case 3:
            return b.call(this, a, e, f);
          default:
            var k = null;
            if (3 < arguments.length) {
              for (var k = 0, l = Array(arguments.length - 3);k < l.length;) {
                l[k] = arguments[k + 3], ++k;
              }
              k = new F(l, 0);
            }
            return m.B(a, e, f, k);
        }
        throw Error("Invalid arity: " + arguments.length);
      };
      e.L = 3;
      e.J = m.J;
      e.v = function() {
        return !0;
      };
      e.h = d;
      e.j = c;
      e.l = b;
      e.B = m.B;
      return e;
    }();
  }(ze(a, ze(b, ze(c, d))));
};
ug.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), d = H(d);
  return ug.B(b, a, c, d);
};
ug.L = 3;
var vg = function vg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return vg.h(arguments[0]);
    case 2:
      return vg.j(arguments[0], arguments[1]);
    case 3:
      return vg.l(arguments[0], arguments[1], arguments[2]);
    case 4:
      return vg.H(arguments[0], arguments[1], arguments[2], arguments[3]);
    default:
      return vg.B(arguments[0], arguments[1], arguments[2], arguments[3], new F(c.slice(4), 0, null));
  }
};
vg.h = function(a) {
  return function(b) {
    return function() {
      function c(c, d) {
        var e = a.h ? a.h(d) : a.call(null, d);
        return b.j ? b.j(c, e) : b.call(null, c, e);
      }
      function d(a) {
        return b.h ? b.h(a) : b.call(null, a);
      }
      function e() {
        return b.v ? b.v() : b.call(null);
      }
      var f = null, g = function() {
        function c(a, b, c) {
          var e = null;
          if (2 < arguments.length) {
            for (var e = 0, f = Array(arguments.length - 2);e < f.length;) {
              f[e] = arguments[e + 2], ++e;
            }
            e = new F(f, 0);
          }
          return d.call(this, a, b, e);
        }
        function d(c, d, e) {
          d = Wf(a, d, e);
          return b.j ? b.j(c, d) : b.call(null, c, d);
        }
        c.L = 2;
        c.J = function(a) {
          var b = G(a);
          a = H(a);
          var c = G(a);
          a = $d(a);
          return d(b, c, a);
        };
        c.B = d;
        return c;
      }(), f = function(a, b, f) {
        switch(arguments.length) {
          case 0:
            return e.call(this);
          case 1:
            return d.call(this, a);
          case 2:
            return c.call(this, a, b);
          default:
            var k = null;
            if (2 < arguments.length) {
              for (var k = 0, l = Array(arguments.length - 2);k < l.length;) {
                l[k] = arguments[k + 2], ++k;
              }
              k = new F(l, 0);
            }
            return g.B(a, b, k);
        }
        throw Error("Invalid arity: " + arguments.length);
      };
      f.L = 2;
      f.J = g.J;
      f.v = e;
      f.h = d;
      f.j = c;
      f.B = g.B;
      return f;
    }();
  };
};
vg.j = function(a, b) {
  return new Hf(null, function() {
    var c = D(b);
    if (c) {
      if (We(c)) {
        for (var d = Dd(c), e = O(d), f = new Jf(Array(e), 0), g = 0;;) {
          if (g < e) {
            Nf(f, function() {
              var b = Ic.j(d, g);
              return a.h ? a.h(b) : a.call(null, b);
            }()), g += 1;
          } else {
            break;
          }
        }
        return Mf(f.ib(), vg.j(a, Ed(c)));
      }
      return ze(function() {
        var b = G(c);
        return a.h ? a.h(b) : a.call(null, b);
      }(), vg.j(a, $d(c)));
    }
    return null;
  }, null, null);
};
vg.l = function(a, b, c) {
  return new Hf(null, function() {
    var d = D(b), e = D(c);
    if (d && e) {
      var f = ze, g;
      g = G(d);
      var k = G(e);
      g = a.j ? a.j(g, k) : a.call(null, g, k);
      d = f(g, vg.l(a, $d(d), $d(e)));
    } else {
      d = null;
    }
    return d;
  }, null, null);
};
vg.H = function(a, b, c, d) {
  return new Hf(null, function() {
    var e = D(b), f = D(c), g = D(d);
    if (e && f && g) {
      var k = ze, l;
      l = G(e);
      var m = G(f), n = G(g);
      l = a.l ? a.l(l, m, n) : a.call(null, l, m, n);
      e = k(l, vg.H(a, $d(e), $d(f), $d(g)));
    } else {
      e = null;
    }
    return e;
  }, null, null);
};
vg.B = function(a, b, c, d, e) {
  var f = function k(a) {
    return new Hf(null, function() {
      var b = vg.j(D, a);
      return eg(mf, b) ? ze(vg.j(G, b), k(vg.j($d, b))) : null;
    }, null, null);
  };
  return vg.j(function() {
    return function(b) {
      return Vf(a, b);
    };
  }(f), f(Ge.B(e, d, P([c, b], 0))));
};
vg.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), e = H(d), d = G(e), e = H(e);
  return vg.B(b, a, c, d, e);
};
vg.L = 4;
var wg = function wg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return wg.h(arguments[0]);
    case 2:
      return wg.j(arguments[0], arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
wg.h = function(a) {
  if ("number" !== typeof a) {
    throw Error("Assert failed: (number? n)");
  }
  return function(b) {
    return function(a) {
      return function() {
        function c(c, d) {
          var e = bd(a), f = Kd(a, bd(a) - 1), e = 0 < e ? b.j ? b.j(c, d) : b.call(null, c, d) : c;
          return 0 < f ? e : le(e) ? e : new ke(e);
        }
        function e(a) {
          return b.h ? b.h(a) : b.call(null, a);
        }
        function f() {
          return b.v ? b.v() : b.call(null);
        }
        var g = null, g = function(a, b) {
          switch(arguments.length) {
            case 0:
              return f.call(this);
            case 1:
              return e.call(this, a);
            case 2:
              return c.call(this, a, b);
          }
          throw Error("Invalid arity: " + arguments.length);
        };
        g.v = f;
        g.h = e;
        g.j = c;
        return g;
      }();
    }(new tg(a));
  };
};
wg.j = function(a, b) {
  if ("number" !== typeof a) {
    throw Error("Assert failed: (number? n)");
  }
  return new Hf(null, function() {
    if (0 < a) {
      var c = D(b);
      return c ? ze(G(c), wg.j(a - 1, $d(c))) : null;
    }
    return null;
  }, null, null);
};
wg.L = 2;
function xg(a) {
  return new Hf(null, function(b) {
    return function() {
      return b(1, a);
    };
  }(function(a, c) {
    for (;;) {
      var b = D(c);
      if (0 < a && b) {
        var e = a - 1, b = $d(b);
        a = e;
        c = b;
      } else {
        return b;
      }
    }
  }), null, null);
}
function yg(a, b) {
  return new Hf(null, function(c) {
    return function() {
      return c(a, b);
    };
  }(function(a, b) {
    for (;;) {
      var c = D(b), d;
      if (d = c) {
        d = G(c), d = a.h ? a.h(d) : a.call(null, d);
      }
      if (w(d)) {
        d = a, c = $d(c), a = d, b = c;
      } else {
        return c;
      }
    }
  }), null, null);
}
function zg(a) {
  return new Hf(null, function() {
    return ze(a, zg(a));
  }, null, null);
}
var Ag = function Ag(b, c) {
  return ze(c, new Hf(null, function() {
    var d = b.h ? b.h(c) : b.call(null, c);
    return Ag.j ? Ag.j(b, d) : Ag.call(null, b, d);
  }, null, null));
}, Bg = function Bg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 2:
      return Bg.j(arguments[0], arguments[1]);
    default:
      return Bg.B(arguments[0], arguments[1], new F(c.slice(2), 0, null));
  }
};
Bg.j = function(a, b) {
  return new Hf(null, function() {
    var c = D(a), d = D(b);
    return c && d ? ze(G(c), ze(G(d), Bg.j($d(c), $d(d)))) : null;
  }, null, null);
};
Bg.B = function(a, b, c) {
  return new Hf(null, function() {
    var d = vg.j(D, Ge.B(c, b, P([a], 0)));
    return eg(mf, d) ? Rf.j(vg.j(G, d), Vf(Bg, vg.j($d, d))) : null;
  }, null, null);
};
Bg.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  c = H(c);
  return Bg.B(b, a, c);
};
Bg.L = 2;
function Cg(a, b) {
  return new Hf(null, function() {
    var c = D(b);
    if (c) {
      if (We(c)) {
        for (var d = Dd(c), e = O(d), f = new Jf(Array(e), 0), g = 0;;) {
          if (g < e) {
            var k;
            k = Ic.j(d, g);
            k = a.h ? a.h(k) : a.call(null, k);
            w(k) && Nf(f, Ic.j(d, g));
            g += 1;
          } else {
            break;
          }
        }
        return Mf(f.ib(), Cg(a, Ed(c)));
      }
      d = G(c);
      c = $d(c);
      return w(a.h ? a.h(d) : a.call(null, d)) ? ze(d, Cg(a, c)) : Cg(a, c);
    }
    return null;
  }, null, null);
}
function Dg(a, b) {
  return Cg(gg(a), b);
}
function Eg(a) {
  return function c(a) {
    return new Hf(null, function() {
      var d;
      w(Se.h ? Se.h(a) : Se.call(null, a)) ? (d = P([D.h ? D.h(a) : D.call(null, a)], 0), d = Vf(Rf, Wf(vg, c, d))) : d = null;
      return ze(a, d);
    }, null, null);
  }(a);
}
function Fg(a) {
  return Cg(function(a) {
    return !Se(a);
  }, $d(Eg(a)));
}
var Gg = function Gg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 0:
      return Gg.v();
    case 1:
      return Gg.h(arguments[0]);
    case 2:
      return Gg.j(arguments[0], arguments[1]);
    case 3:
      return Gg.l(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
Gg.v = function() {
  return He;
};
Gg.h = function(a) {
  return a;
};
Gg.j = function(a, b) {
  return null != a ? null != a && (a.K & 4 || q === a.eg) ? Be(xd(xc(wd, vd(a), b)), Oe(a)) : xc(Gc, a, b) : xc(Ge, ae, b);
};
Gg.l = function(a, b, c) {
  return null != a && (a.K & 4 || q === a.eg) ? Be(xd(nf(b, Sf, vd(a), c)), Oe(a)) : nf(b, Ge, a, c);
};
Gg.L = 3;
function Hg(a, b) {
  return xd(xc(function(b, d) {
    return Sf.j(b, a.h ? a.h(d) : a.call(null, d));
  }, vd(He), b));
}
var Ig = function Ig(b, c, d) {
  c = D(c);
  var e = G(c), f = H(c);
  return f ? Je.l(b, e, function() {
    var c = C.j(b, e);
    return Ig.l ? Ig.l(c, f, d) : Ig.call(null, c, f, d);
  }()) : Je.l(b, e, d);
}, Jg = function Jg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 3:
      return Jg.l(arguments[0], arguments[1], arguments[2]);
    case 4:
      return Jg.H(arguments[0], arguments[1], arguments[2], arguments[3]);
    case 5:
      return Jg.O(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    case 6:
      return Jg.ua(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], arguments[5]);
    default:
      return Jg.B(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], arguments[5], new F(c.slice(6), 0, null));
  }
};
Jg.l = function(a, b, c) {
  b = D(b);
  var d = G(b);
  return (b = H(b)) ? Je.l(a, d, Jg.l(C.j(a, d), b, c)) : Je.l(a, d, function() {
    var b = C.j(a, d);
    return c.h ? c.h(b) : c.call(null, b);
  }());
};
Jg.H = function(a, b, c, d) {
  b = D(b);
  var e = G(b);
  return (b = H(b)) ? Je.l(a, e, Jg.H(C.j(a, e), b, c, d)) : Je.l(a, e, function() {
    var b = C.j(a, e);
    return c.j ? c.j(b, d) : c.call(null, b, d);
  }());
};
Jg.O = function(a, b, c, d, e) {
  b = D(b);
  var f = G(b);
  return (b = H(b)) ? Je.l(a, f, Jg.O(C.j(a, f), b, c, d, e)) : Je.l(a, f, function() {
    var b = C.j(a, f);
    return c.l ? c.l(b, d, e) : c.call(null, b, d, e);
  }());
};
Jg.ua = function(a, b, c, d, e, f) {
  b = D(b);
  var g = G(b);
  return (b = H(b)) ? Je.l(a, g, Jg.ua(C.j(a, g), b, c, d, e, f)) : Je.l(a, g, function() {
    var b = C.j(a, g);
    return c.H ? c.H(b, d, e, f) : c.call(null, b, d, e, f);
  }());
};
Jg.B = function(a, b, c, d, e, f, g) {
  var k = D(b);
  b = G(k);
  return (k = H(k)) ? Je.l(a, b, Zf(Jg, C.j(a, b), k, c, d, P([e, f, g], 0))) : Je.l(a, b, Zf(c, C.j(a, b), d, e, f, P([g], 0)));
};
Jg.J = function(a) {
  var b = G(a), c = H(a);
  a = G(c);
  var d = H(c), c = G(d), e = H(d), d = G(e), f = H(e), e = G(f), g = H(f), f = G(g), g = H(g);
  return Jg.B(b, a, c, d, e, f, g);
};
Jg.L = 6;
function Kg(a, b) {
  this.la = a;
  this.o = b;
}
function Lg(a) {
  return new Kg(a, [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null]);
}
function Mg(a, b, c) {
  a.o[b] = c;
}
function Ng(a) {
  return new Kg(a.la, tc(a.o));
}
function Og(a) {
  a = a.D;
  return 32 > a ? 0 : a - 1 >>> 5 << 5;
}
function Pg(a, b, c) {
  for (;;) {
    if (0 === b) {
      return c;
    }
    var d = Lg(a);
    d.o[0] = c;
    c = d;
    b -= 5;
  }
}
var Qg = function Qg(b, c, d, e) {
  var f = Ng(d), g = b.D - 1 >>> c & 31;
  5 === c ? f.o[g] = e : (d = d.o[g], null != d ? (c -= 5, b = Qg.H ? Qg.H(b, c, d, e) : Qg.call(null, b, c, d, e)) : b = Pg(null, c - 5, e), f.o[g] = b);
  return f;
};
function Rg(a, b) {
  throw Error([y("No item "), y(a), y(" in vector of length "), y(b)].join(""));
}
function Sg(a, b) {
  if (b >= Og(a)) {
    return a.ba;
  }
  for (var c = a.root, d = a.shift;;) {
    if (0 < d) {
      var e = d - 5, c = c.o[b >>> d & 31], d = e
    } else {
      return c.o;
    }
  }
}
function Tg(a, b) {
  return 0 <= b && b < a.D ? Sg(a, b) : Rg(b, a.D);
}
var Ug = function Ug(b, c, d, e, f) {
  var g = Ng(d);
  if (0 === c) {
    g.o[e & 31] = f;
  } else {
    var k = e >>> c & 31;
    c -= 5;
    d = d.o[k];
    b = Ug.O ? Ug.O(b, c, d, e, f) : Ug.call(null, b, c, d, e, f);
    Mg(g, k, b);
  }
  return g;
}, Vg = function Vg(b, c, d) {
  var e = b.D - 2 >>> c & 31;
  if (5 < c) {
    c -= 5;
    var f = d.o[e];
    b = Vg.l ? Vg.l(b, c, f) : Vg.call(null, b, c, f);
    if (null == b && 0 === e) {
      return null;
    }
    d = Ng(d);
    d.o[e] = b;
    return d;
  }
  if (0 === e) {
    return null;
  }
  d = Ng(d);
  d.o[e] = null;
  return d;
};
function Wg(a, b, c, d, e, f) {
  this.i = a;
  this.base = b;
  this.o = c;
  this.kb = d;
  this.start = e;
  this.end = f;
}
Wg.prototype.Da = function() {
  return this.i < this.end;
};
Wg.prototype.next = function() {
  32 === this.i - this.base && (this.o = Sg(this.kb, this.i), this.base += 32);
  var a = this.o[this.i & 31];
  this.i += 1;
  return a;
};
function T(a, b, c, d, e, f) {
  this.meta = a;
  this.D = b;
  this.shift = c;
  this.root = d;
  this.ba = e;
  this.F = f;
  this.w = 167668511;
  this.K = 8196;
}
h = T.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return "number" === typeof b ? Ic.l(this, b, c) : c;
};
h.Sc = function(a, b, c) {
  a = 0;
  for (var d = c;;) {
    if (a < this.D) {
      var e = Sg(this, a);
      c = e.length;
      a: {
        for (var f = 0;;) {
          if (f < c) {
            var g = f + a, k = e[f], d = b.l ? b.l(d, g, k) : b.call(null, d, g, k);
            if (le(d)) {
              e = d;
              break a;
            }
            f += 1;
          } else {
            e = d;
            break a;
          }
        }
      }
      if (le(e)) {
        return L.h ? L.h(e) : L.call(null, e);
      }
      a += c;
      d = e;
    } else {
      return d;
    }
  }
};
h.aa = function(a, b) {
  return Tg(this, b)[b & 31];
};
h.cb = function(a, b, c) {
  return 0 <= b && b < this.D ? Sg(this, b)[b & 31] : c;
};
h.Ac = function(a, b, c) {
  if (0 <= b && b < this.D) {
    return Og(this) <= b ? (a = tc(this.ba), a[b & 31] = c, new T(this.meta, this.D, this.shift, this.root, a, null)) : new T(this.meta, this.D, this.shift, Ug(this, this.shift, this.root, b, c), this.ba, null);
  }
  if (b === this.D) {
    return Gc(this, c);
  }
  throw Error([y("Index "), y(b), y(" out of bounds  [0,"), y(this.D), y("]")].join(""));
};
h.mb = function() {
  var a = this.D;
  return new Wg(0, 0, 0 < O(this) ? Sg(this, 0) : null, this, 0, a);
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new T(this.meta, this.D, this.shift, this.root, this.ba, this.F);
};
h.ja = function() {
  return this.D;
};
h.nd = function() {
  return Ic.j(this, 0);
};
h.od = function() {
  return Ic.j(this, 1);
};
h.kc = function() {
  return 0 < this.D ? Ic.j(this, this.D - 1) : null;
};
h.lc = function() {
  if (0 === this.D) {
    throw Error("Can't pop empty vector");
  }
  if (1 === this.D) {
    return fd(He, this.meta);
  }
  if (1 < this.D - Og(this)) {
    return new T(this.meta, this.D - 1, this.shift, this.root, this.ba.slice(0, -1), null);
  }
  var a = Sg(this, this.D - 2), b = Vg(this, this.shift, this.root), b = null == b ? W : b, c = this.D - 1;
  return 5 < this.shift && null == b.o[1] ? new T(this.meta, c, this.shift - 5, b.o[0], a, null) : new T(this.meta, c, this.shift, b, a, null);
};
h.Uc = function() {
  return 0 < this.D ? new xe(this, this.D - 1, null) : null;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  if (b instanceof T) {
    if (this.D === O(b)) {
      for (var c = Ld(this), d = Ld(b);;) {
        if (w(c.Da())) {
          var e = c.next(), f = d.next();
          if (!J.j(e, f)) {
            return !1;
          }
        } else {
          return !0;
        }
      }
    } else {
      return !1;
    }
  } else {
    return ye(this, b);
  }
};
h.Rc = function() {
  return new Xg(this.D, this.shift, Yg.h ? Yg.h(this.root) : Yg.call(null, this.root), Zg.h ? Zg.h(this.ba) : Zg.call(null, this.ba));
};
h.na = function() {
  return Be(He, this.meta);
};
h.xa = function(a, b) {
  return me(this, b);
};
h.ya = function(a, b, c) {
  a = 0;
  for (var d = c;;) {
    if (a < this.D) {
      var e = Sg(this, a);
      c = e.length;
      a: {
        for (var f = 0;;) {
          if (f < c) {
            var g = e[f], d = b.j ? b.j(d, g) : b.call(null, d, g);
            if (le(d)) {
              e = d;
              break a;
            }
            f += 1;
          } else {
            e = d;
            break a;
          }
        }
      }
      if (le(e)) {
        return L.h ? L.h(e) : L.call(null, e);
      }
      a += c;
      d = e;
    } else {
      return d;
    }
  }
};
h.Qb = function(a, b, c) {
  if ("number" === typeof b) {
    return ad(this, b, c);
  }
  throw Error("Vector's key for assoc must be a number.");
};
h.ea = function() {
  if (0 === this.D) {
    return null;
  }
  if (32 >= this.D) {
    return new F(this.ba, 0, null);
  }
  var a;
  a: {
    a = this.root;
    for (var b = this.shift;;) {
      if (0 < b) {
        b -= 5, a = a.o[0];
      } else {
        a = a.o;
        break a;
      }
    }
  }
  return $g ? $g(this, a, 0, 0) : ah.call(null, this, a, 0, 0);
};
h.T = function(a, b) {
  return new T(b, this.D, this.shift, this.root, this.ba, this.F);
};
h.fa = function(a, b) {
  if (32 > this.D - Og(this)) {
    for (var c = this.ba.length, d = Array(c + 1), e = 0;;) {
      if (e < c) {
        d[e] = this.ba[e], e += 1;
      } else {
        break;
      }
    }
    d[c] = b;
    return new T(this.meta, this.D + 1, this.shift, this.root, d, null);
  }
  c = (d = this.D >>> 5 > 1 << this.shift) ? this.shift + 5 : this.shift;
  d ? (d = Lg(null), Mg(d, 0, this.root), Mg(d, 1, Pg(null, this.shift, new Kg(null, this.ba)))) : d = Qg(this, this.shift, this.root, new Kg(null, this.ba));
  return new T(this.meta, this.D + 1, c, d, [b], null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.aa(null, c);
      case 3:
        return this.cb(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.aa(null, c);
  };
  a.l = function(a, c, d) {
    return this.cb(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.aa(null, a);
};
h.j = function(a, b) {
  return this.cb(null, a, b);
};
var W = new Kg(null, [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null]), He = new T(null, 0, 5, W, [], ge);
function bh(a, b) {
  var c = a.length, d = b ? a : tc(a);
  if (32 > c) {
    return new T(null, c, 5, W, d, null);
  }
  for (var e = 32, f = (new T(null, 32, 5, W, d.slice(0, 32), null)).Rc(null);;) {
    if (e < c) {
      var g = e + 1, f = Sf.j(f, d[e]), e = g
    } else {
      return xd(f);
    }
  }
}
T.prototype[sc] = function() {
  return de(this);
};
function ch(a) {
  return jc(a) ? bh(a, !0) : xd(xc(wd, vd(He), a));
}
var dh = function dh(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  return dh.B(0 < c.length ? new F(c.slice(0), 0, null) : null);
};
dh.B = function(a) {
  return a instanceof F && 0 === a.i ? bh(a.o, !0) : ch(a);
};
dh.L = 0;
dh.J = function(a) {
  return dh.B(D(a));
};
function eh(a, b, c, d, e, f) {
  this.lb = a;
  this.node = b;
  this.i = c;
  this.off = d;
  this.meta = e;
  this.F = f;
  this.w = 32375020;
  this.K = 1536;
}
h = eh.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.Ya = function() {
  if (this.off + 1 < this.node.length) {
    var a;
    a = this.lb;
    var b = this.node, c = this.i, d = this.off + 1;
    a = $g ? $g(a, b, c, d) : ah.call(null, a, b, c, d);
    return null == a ? null : a;
  }
  return Fd(this);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(He, this.meta);
};
h.xa = function(a, b) {
  var c;
  c = this.lb;
  var d = this.i + this.off, e = O(this.lb);
  c = fh ? fh(c, d, e) : gh.call(null, c, d, e);
  return me(c, b);
};
h.ya = function(a, b, c) {
  a = this.lb;
  var d = this.i + this.off, e = O(this.lb);
  a = fh ? fh(a, d, e) : gh.call(null, a, d, e);
  return ne(a, b, c);
};
h.za = function() {
  return this.node[this.off];
};
h.Ra = function() {
  if (this.off + 1 < this.node.length) {
    var a;
    a = this.lb;
    var b = this.node, c = this.i, d = this.off + 1;
    a = $g ? $g(a, b, c, d) : ah.call(null, a, b, c, d);
    return null == a ? ae : a;
  }
  return Ed(this);
};
h.ea = function() {
  return this;
};
h.ye = function() {
  var a = this.node;
  return new Kf(a, this.off, a.length);
};
h.ze = function() {
  var a = this.i + this.node.length;
  if (a < Dc(this.lb)) {
    var b = this.lb, c = Sg(this.lb, a);
    return $g ? $g(b, c, a, 0) : ah.call(null, b, c, a, 0);
  }
  return ae;
};
h.T = function(a, b) {
  return hh ? hh(this.lb, this.node, this.i, this.off, b) : ah.call(null, this.lb, this.node, this.i, this.off, b);
};
h.fa = function(a, b) {
  return ze(b, this);
};
h.xe = function() {
  var a = this.i + this.node.length;
  if (a < Dc(this.lb)) {
    var b = this.lb, c = Sg(this.lb, a);
    return $g ? $g(b, c, a, 0) : ah.call(null, b, c, a, 0);
  }
  return null;
};
eh.prototype[sc] = function() {
  return de(this);
};
function ah(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 3:
      return b = arguments[0], c = arguments[1], d = arguments[2], new eh(b, Tg(b, c), c, d, null, null);
    case 4:
      return $g(arguments[0], arguments[1], arguments[2], arguments[3]);
    case 5:
      return hh(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function $g(a, b, c, d) {
  return new eh(a, b, c, d, null, null);
}
function hh(a, b, c, d, e) {
  return new eh(a, b, c, d, e, null);
}
function ih(a, b, c, d, e) {
  this.meta = a;
  this.kb = b;
  this.start = c;
  this.end = d;
  this.F = e;
  this.w = 167666463;
  this.K = 8192;
}
h = ih.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return "number" === typeof b ? Ic.l(this, b, c) : c;
};
h.Sc = function(a, b, c) {
  a = this.start;
  for (var d = 0;;) {
    if (a < this.end) {
      var e = d, f = Ic.j(this.kb, a);
      c = b.l ? b.l(c, e, f) : b.call(null, c, e, f);
      if (le(c)) {
        return L.h ? L.h(c) : L.call(null, c);
      }
      d += 1;
      a += 1;
    } else {
      return c;
    }
  }
};
h.aa = function(a, b) {
  return 0 > b || this.end <= this.start + b ? Rg(b, this.end - this.start) : Ic.j(this.kb, this.start + b);
};
h.cb = function(a, b, c) {
  return 0 > b || this.end <= this.start + b ? c : Ic.l(this.kb, this.start + b, c);
};
h.Ac = function(a, b, c) {
  var d = this.start + b;
  a = this.meta;
  c = Je.l(this.kb, d, c);
  b = this.start;
  var e = this.end, d = d + 1, d = e > d ? e : d;
  return jh.O ? jh.O(a, c, b, d, null) : jh.call(null, a, c, b, d, null);
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new ih(this.meta, this.kb, this.start, this.end, this.F);
};
h.ja = function() {
  return this.end - this.start;
};
h.kc = function() {
  return Ic.j(this.kb, this.end - 1);
};
h.lc = function() {
  if (this.start === this.end) {
    throw Error("Can't pop empty vector");
  }
  var a = this.meta, b = this.kb, c = this.start, d = this.end - 1;
  return jh.O ? jh.O(a, b, c, d, null) : jh.call(null, a, b, c, d, null);
};
h.Uc = function() {
  return this.start !== this.end ? new xe(this, this.end - this.start - 1, null) : null;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(He, this.meta);
};
h.xa = function(a, b) {
  return me(this, b);
};
h.ya = function(a, b, c) {
  return ne(this, b, c);
};
h.Qb = function(a, b, c) {
  if ("number" === typeof b) {
    return ad(this, b, c);
  }
  throw Error("Subvec's key for assoc must be a number.");
};
h.ea = function() {
  var a = this;
  return function(b) {
    return function d(e) {
      return e === a.end ? null : ze(Ic.j(a.kb, e), new Hf(null, function() {
        return function() {
          return d(e + 1);
        };
      }(b), null, null));
    };
  }(this)(a.start);
};
h.T = function(a, b) {
  return jh.O ? jh.O(b, this.kb, this.start, this.end, this.F) : jh.call(null, b, this.kb, this.start, this.end, this.F);
};
h.fa = function(a, b) {
  var c = this.meta, d = ad(this.kb, this.end, b), e = this.start, f = this.end + 1;
  return jh.O ? jh.O(c, d, e, f, null) : jh.call(null, c, d, e, f, null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.aa(null, c);
      case 3:
        return this.cb(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.aa(null, c);
  };
  a.l = function(a, c, d) {
    return this.cb(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.aa(null, a);
};
h.j = function(a, b) {
  return this.cb(null, a, b);
};
ih.prototype[sc] = function() {
  return de(this);
};
function jh(a, b, c, d, e) {
  for (;;) {
    if (b instanceof ih) {
      c = b.start + c, d = b.start + d, b = b.kb;
    } else {
      var f = O(b);
      if (0 > c || 0 > d || c > f || d > f) {
        throw Error("Index out of bounds");
      }
      return new ih(a, b, c, d, e);
    }
  }
}
function gh(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 2:
      return b = arguments[0], fh(b, arguments[1], O(b));
    case 3:
      return fh(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function fh(a, b, c) {
  return jh(null, a, b, c, null);
}
function kh(a, b) {
  return a === b.la ? b : new Kg(a, tc(b.o));
}
function Yg(a) {
  return new Kg({}, tc(a.o));
}
function Zg(a) {
  var b = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
  Ye(a, 0, b, 0, a.length);
  return b;
}
var lh = function lh(b, c, d, e) {
  d = kh(b.root.la, d);
  var f = b.D - 1 >>> c & 31;
  if (5 === c) {
    b = e;
  } else {
    var g = d.o[f];
    null != g ? (c -= 5, b = lh.H ? lh.H(b, c, g, e) : lh.call(null, b, c, g, e)) : b = Pg(b.root.la, c - 5, e);
  }
  Mg(d, f, b);
  return d;
};
function Xg(a, b, c, d) {
  this.D = a;
  this.shift = b;
  this.root = c;
  this.ba = d;
  this.K = 88;
  this.w = 275;
}
h = Xg.prototype;
h.sd = function(a, b) {
  if (this.root.la) {
    if (32 > this.D - Og(this)) {
      this.ba[this.D & 31] = b;
    } else {
      var c = new Kg(this.root.la, this.ba), d = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
      d[0] = b;
      this.ba = d;
      if (this.D >>> 5 > 1 << this.shift) {
        var d = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null], e = this.shift + 5;
        d[0] = this.root;
        d[1] = Pg(this.root.la, this.shift, c);
        this.root = new Kg(this.root.la, d);
        this.shift = e;
      } else {
        this.root = lh(this, this.shift, this.root, c);
      }
    }
    this.D += 1;
    return this;
  }
  throw Error("conj! after persistent!");
};
h.ud = function() {
  if (this.root.la) {
    this.root.la = null;
    var a = this.D - Og(this), b = Array(a);
    Ye(this.ba, 0, b, 0, a);
    return new T(null, this.D, this.shift, this.root, b, null);
  }
  throw Error("persistent! called twice");
};
h.rd = function(a, b, c) {
  if ("number" === typeof b) {
    return zd(this, b, c);
  }
  throw Error("TransientVector's key for assoc! must be a number.");
};
h.qf = function(a, b, c) {
  var d = this;
  if (d.root.la) {
    if (0 <= b && b < d.D) {
      return Og(this) <= b ? d.ba[b & 31] = c : (a = function() {
        return function f(a, k) {
          var g = kh(d.root.la, k);
          if (0 === a) {
            g.o[b & 31] = c;
          } else {
            var m = b >>> a & 31;
            Mg(g, m, f(a - 5, g.o[m]));
          }
          return g;
        };
      }(this).call(null, d.shift, d.root), d.root = a), this;
    }
    if (b === d.D) {
      return wd(this, c);
    }
    throw Error([y("Index "), y(b), y(" out of bounds for TransientVector of length"), y(d.D)].join(""));
  }
  throw Error("assoc! after persistent!");
};
h.ja = function() {
  if (this.root.la) {
    return this.D;
  }
  throw Error("count after persistent!");
};
h.aa = function(a, b) {
  if (this.root.la) {
    return Tg(this, b)[b & 31];
  }
  throw Error("nth after persistent!");
};
h.cb = function(a, b, c) {
  return 0 <= b && b < this.D ? Ic.j(this, b) : c;
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return "number" === typeof b ? Ic.l(this, b, c) : c;
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
function mh(a, b) {
  this.Xc = a;
  this.Od = b;
}
mh.prototype.Da = function() {
  var a = null != this.Xc && D(this.Xc);
  return a ? a : (a = null != this.Od) ? this.Od.Da() : a;
};
mh.prototype.next = function() {
  if (null != this.Xc) {
    var a = G(this.Xc);
    this.Xc = H(this.Xc);
    return a;
  }
  if (null != this.Od && this.Od.Da()) {
    return this.Od.next();
  }
  throw Error("No such element");
};
mh.prototype.remove = function() {
  return Error("Unsupported operation");
};
function nh(a, b, c, d) {
  this.meta = a;
  this.gb = b;
  this.zb = c;
  this.F = d;
  this.w = 31850572;
  this.K = 0;
}
h = nh.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.za = function() {
  return G(this.gb);
};
h.Ra = function() {
  var a = H(this.gb);
  return a ? new nh(this.meta, a, this.zb, null) : null == this.zb ? Ec(this) : new nh(this.meta, this.zb, null, null);
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new nh(b, this.gb, this.zb, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
nh.prototype[sc] = function() {
  return de(this);
};
function oh(a, b, c, d, e) {
  this.meta = a;
  this.count = b;
  this.gb = c;
  this.zb = d;
  this.F = e;
  this.w = 31858766;
  this.K = 8192;
}
h = oh.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, this.count.h ? this.count.h(this) : this.count.call(null, this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.mb = function() {
  return new mh(this.gb, Ld(this.zb));
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new oh(this.meta, this.count, this.gb, this.zb, this.F);
};
h.ja = function() {
  return this.count;
};
h.kc = function() {
  return G(this.gb);
};
h.lc = function() {
  if (w(this.gb)) {
    var a = H(this.gb);
    return a ? new oh(this.meta, this.count - 1, a, this.zb, null) : new oh(this.meta, this.count - 1, D(this.zb), He, null);
  }
  return this;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ph, this.meta);
};
h.za = function() {
  return G(this.gb);
};
h.Ra = function() {
  return $d(D(this));
};
h.ea = function() {
  var a = D(this.zb), b = this.gb;
  return w(w(b) ? b : a) ? new nh(null, this.gb, D(a), null) : null;
};
h.T = function(a, b) {
  return new oh(b, this.count, this.gb, this.zb, this.F);
};
h.fa = function(a, b) {
  var c;
  w(this.gb) ? (c = this.zb, c = new oh(this.meta, this.count + 1, this.gb, Ge.j(w(c) ? c : He, b), null)) : c = new oh(this.meta, this.count + 1, Ge.j(this.gb, b), He, null);
  return c;
};
var ph = new oh(null, 0, null, He, ge);
oh.prototype[sc] = function() {
  return de(this);
};
function qh() {
  this.w = 2097152;
  this.K = 0;
}
qh.prototype.equiv = function(a) {
  return this.I(null, a);
};
qh.prototype.I = function() {
  return !1;
};
var rh = new qh;
function sh(a, b) {
  return af(Te(b) ? O(a) === O(b) ? eg(function(a) {
    return J.j(C.l(b, G(a), rh), Fe(a));
  }, a) : null : null);
}
function th(a, b, c, d, e) {
  this.i = a;
  this.Zg = b;
  this.hf = c;
  this.wg = d;
  this.Df = e;
}
th.prototype.Da = function() {
  var a = this.i < this.hf;
  return a ? a : this.Df.Da();
};
th.prototype.next = function() {
  if (this.i < this.hf) {
    var a = te(this.wg, this.i);
    this.i += 1;
    return new T(null, 2, 5, W, [a, Oc.j(this.Zg, a)], null);
  }
  return this.Df.next();
};
th.prototype.remove = function() {
  return Error("Unsupported operation");
};
function uh(a) {
  this.s = a;
}
uh.prototype.next = function() {
  if (null != this.s) {
    var a = G(this.s), b = S(a, 0, null), a = S(a, 1, null);
    this.s = H(this.s);
    return {value:[b, a], done:!1};
  }
  return {value:null, done:!0};
};
function vh(a) {
  this.s = a;
}
vh.prototype.next = function() {
  if (null != this.s) {
    var a = G(this.s);
    this.s = H(this.s);
    return {value:[a, a], done:!1};
  }
  return {value:null, done:!0};
};
function wh(a, b) {
  var c;
  if (b instanceof X) {
    a: {
      c = a.length;
      for (var d = b.fb, e = 0;;) {
        if (c <= e) {
          c = -1;
          break a;
        }
        if (a[e] instanceof X && d === a[e].fb) {
          c = e;
          break a;
        }
        e += 2;
      }
    }
  } else {
    if (ha(b) || "number" === typeof b) {
      a: {
        for (c = a.length, d = 0;;) {
          if (c <= d) {
            c = -1;
            break a;
          }
          if (b === a[d]) {
            c = d;
            break a;
          }
          d += 2;
        }
      }
    } else {
      if (b instanceof A) {
        a: {
          for (c = a.length, d = b.ab, e = 0;;) {
            if (c <= e) {
              c = -1;
              break a;
            }
            if (a[e] instanceof A && d === a[e].ab) {
              c = e;
              break a;
            }
            e += 2;
          }
        }
      } else {
        if (null == b) {
          a: {
            for (c = a.length, d = 0;;) {
              if (c <= d) {
                c = -1;
                break a;
              }
              if (null == a[d]) {
                c = d;
                break a;
              }
              d += 2;
            }
          }
        } else {
          a: {
            for (c = a.length, d = 0;;) {
              if (c <= d) {
                c = -1;
                break a;
              }
              if (J.j(b, a[d])) {
                c = d;
                break a;
              }
              d += 2;
            }
          }
        }
      }
    }
  }
  return c;
}
function xh(a, b, c) {
  this.o = a;
  this.i = b;
  this.bb = c;
  this.w = 32374990;
  this.K = 0;
}
h = xh.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.bb;
};
h.Ya = function() {
  return this.i < this.o.length - 2 ? new xh(this.o, this.i + 2, this.bb) : null;
};
h.ja = function() {
  return (this.o.length - this.i) / 2;
};
h.V = function() {
  return fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.bb);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return new T(null, 2, 5, W, [this.o[this.i], this.o[this.i + 1]], null);
};
h.Ra = function() {
  return this.i < this.o.length - 2 ? new xh(this.o, this.i + 2, this.bb) : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new xh(this.o, this.i, b);
};
h.fa = function(a, b) {
  return ze(b, this);
};
xh.prototype[sc] = function() {
  return de(this);
};
function yh(a, b, c) {
  this.o = a;
  this.i = b;
  this.D = c;
}
yh.prototype.Da = function() {
  return this.i < this.D;
};
yh.prototype.next = function() {
  var a = new T(null, 2, 5, W, [this.o[this.i], this.o[this.i + 1]], null);
  this.i += 2;
  return a;
};
function u(a, b, c, d) {
  this.meta = a;
  this.D = b;
  this.o = c;
  this.F = d;
  this.w = 16647951;
  this.K = 8196;
}
h = u.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.keys = function() {
  return de(zh.h ? zh.h(this) : zh.call(null, this));
};
h.entries = function() {
  return new uh(D(D(this)));
};
h.values = function() {
  return de(Ah.h ? Ah.h(this) : Ah.call(null, this));
};
h.has = function(a) {
  return cf(this, a);
};
h.get = function(a, b) {
  return this.N(null, a, b);
};
h.forEach = function(a) {
  for (var b = D(this), c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      a.j ? a.j(f, g) : a.call(null, f, g);
      e += 1;
    } else {
      if (b = D(b)) {
        We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
      } else {
        return null;
      }
    }
  }
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  a = wh(this.o, b);
  return -1 === a ? c : this.o[a + 1];
};
h.Sc = function(a, b, c) {
  a = this.o.length;
  for (var d = 0;;) {
    if (d < a) {
      var e = this.o[d], f = this.o[d + 1];
      c = b.l ? b.l(c, e, f) : b.call(null, c, e, f);
      if (le(c)) {
        return L.h ? L.h(c) : L.call(null, c);
      }
      d += 2;
    } else {
      return c;
    }
  }
};
h.mb = function() {
  return new yh(this.o, 0, 2 * this.D);
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new u(this.meta, this.D, this.o, this.F);
};
h.ja = function() {
  return this.D;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = he(this);
};
h.I = function(a, b) {
  if (null != b && (b.w & 1024 || q === b.jg)) {
    var c = this.o.length;
    if (this.D === b.ja(null)) {
      for (var d = 0;;) {
        if (d < c) {
          var e = b.N(null, this.o[d], Ze);
          if (e !== Ze) {
            if (J.j(this.o[d + 1], e)) {
              d += 2;
            } else {
              return !1;
            }
          } else {
            return !1;
          }
        } else {
          return !0;
        }
      }
    } else {
      return !1;
    }
  } else {
    return sh(this, b);
  }
};
h.Rc = function() {
  return new Bh({}, this.o.length, tc(this.o));
};
h.na = function() {
  return fd(dg, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.Tc = function(a, b) {
  if (0 <= wh(this.o, b)) {
    var c = this.o.length, d = c - 2;
    if (0 === d) {
      return Ec(this);
    }
    for (var d = Array(d), e = 0, f = 0;;) {
      if (e >= c) {
        return new u(this.meta, this.D - 1, d, null);
      }
      J.j(b, this.o[e]) || (d[f] = this.o[e], d[f + 1] = this.o[e + 1], f += 2);
      e += 2;
    }
  } else {
    return this;
  }
};
h.Qb = function(a, b, c) {
  a = wh(this.o, b);
  if (-1 === a) {
    if (this.D < Ch) {
      a = this.o;
      for (var d = a.length, e = Array(d + 2), f = 0;;) {
        if (f < d) {
          e[f] = a[f], f += 1;
        } else {
          break;
        }
      }
      e[d] = b;
      e[d + 1] = c;
      return new u(this.meta, this.D + 1, e, null);
    }
    return fd(Rc(Gg.j(Dh, this), b, c), this.meta);
  }
  if (c === this.o[a + 1]) {
    return this;
  }
  b = tc(this.o);
  b[a + 1] = c;
  return new u(this.meta, this.D, b, null);
};
h.Ud = function(a, b) {
  return -1 !== wh(this.o, b);
};
h.ea = function() {
  var a = this.o;
  return 0 <= a.length - 2 ? new xh(a, 0, null) : null;
};
h.T = function(a, b) {
  return new u(b, this.D, this.o, this.F);
};
h.fa = function(a, b) {
  if (Ve(b)) {
    return Rc(this, Ic.j(b, 0), Ic.j(b, 1));
  }
  for (var c = this, d = D(b);;) {
    if (null == d) {
      return c;
    }
    var e = G(d);
    if (Ve(e)) {
      c = Rc(c, Ic.j(e, 0), Ic.j(e, 1)), d = H(d);
    } else {
      throw Error("conj on a map takes map entries or seqables of map entries");
    }
  }
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
var dg = new u(null, 0, [], ie), Ch = 8;
function Eh(a, b, c) {
  a = b ? a : tc(a);
  if (!c) {
    c = [];
    for (b = 0;;) {
      if (b < a.length) {
        var d = a[b], e = a[b + 1];
        -1 === wh(c, d) && (c.push(d), c.push(e));
        b += 2;
      } else {
        break;
      }
    }
    a = c;
  }
  return new u(null, a.length / 2, a, null);
}
u.prototype[sc] = function() {
  return de(this);
};
function Bh(a, b, c) {
  this.Vc = a;
  this.Jc = b;
  this.o = c;
  this.w = 258;
  this.K = 56;
}
h = Bh.prototype;
h.ja = function() {
  if (w(this.Vc)) {
    return pf(this.Jc);
  }
  throw Error("count after persistent!");
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  if (w(this.Vc)) {
    return a = wh(this.o, b), -1 === a ? c : this.o[a + 1];
  }
  throw Error("lookup after persistent!");
};
h.sd = function(a, b) {
  if (w(this.Vc)) {
    if (null != b ? b.w & 2048 || q === b.kg || (b.w ? 0 : oc(Uc, b)) : oc(Uc, b)) {
      return yd(this, vf.h ? vf.h(b) : vf.call(null, b), wf.h ? wf.h(b) : wf.call(null, b));
    }
    for (var c = D(b), d = this;;) {
      var e = G(c);
      if (w(e)) {
        c = H(c), d = yd(d, vf.h ? vf.h(e) : vf.call(null, e), wf.h ? wf.h(e) : wf.call(null, e));
      } else {
        return d;
      }
    }
  } else {
    throw Error("conj! after persistent!");
  }
};
h.ud = function() {
  if (w(this.Vc)) {
    return this.Vc = !1, new u(null, pf(this.Jc), this.o, null);
  }
  throw Error("persistent! called twice");
};
h.rd = function(a, b, c) {
  if (w(this.Vc)) {
    a = wh(this.o, b);
    if (-1 === a) {
      return this.Jc + 2 <= 2 * Ch ? (this.Jc += 2, this.o.push(b), this.o.push(c), this) : Tf.l(Fh.j ? Fh.j(this.Jc, this.o) : Fh.call(null, this.Jc, this.o), b, c);
    }
    c !== this.o[a + 1] && (this.o[a + 1] = c);
    return this;
  }
  throw Error("assoc! after persistent!");
};
function Fh(a, b) {
  for (var c = vd(Dh), d = 0;;) {
    if (d < a) {
      c = Tf.l(c, b[d], b[d + 1]), d += 2;
    } else {
      return c;
    }
  }
}
function Gh() {
  this.G = !1;
}
function Hh(a, b) {
  return a === b ? !0 : Y(a, b) ? !0 : J.j(a, b);
}
function Ih(a, b, c) {
  a = tc(a);
  a[b] = c;
  return a;
}
function Jh(a, b) {
  var c = Array(a.length - 2);
  Ye(a, 0, c, 0, 2 * b);
  Ye(a, 2 * (b + 1), c, 2 * b, c.length - 2 * b);
  return c;
}
function Kh(a, b, c, d) {
  a = a.Bc(b);
  a.o[c] = d;
  return a;
}
function Lh(a, b, c) {
  for (var d = a.length, e = 0, f = c;;) {
    if (e < d) {
      c = a[e];
      if (null != c) {
        var g = a[e + 1];
        c = b.l ? b.l(f, c, g) : b.call(null, f, c, g);
      } else {
        c = a[e + 1], c = null != c ? c.Hc(b, f) : f;
      }
      if (le(c)) {
        return L.h ? L.h(c) : L.call(null, c);
      }
      e += 2;
      f = c;
    } else {
      return f;
    }
  }
}
function Mh(a, b, c, d) {
  this.o = a;
  this.i = b;
  this.Kd = c;
  this.Kb = d;
}
Mh.prototype.advance = function() {
  for (var a = this.o.length;;) {
    if (this.i < a) {
      var b = this.o[this.i], c = this.o[this.i + 1];
      null != b ? b = this.Kd = new T(null, 2, 5, W, [b, c], null) : null != c ? (b = Ld(c), b = b.Da() ? this.Kb = b : !1) : b = !1;
      this.i += 2;
      if (b) {
        return !0;
      }
    } else {
      return !1;
    }
  }
};
Mh.prototype.Da = function() {
  var a = null != this.Kd;
  return a ? a : (a = null != this.Kb) ? a : this.advance();
};
Mh.prototype.next = function() {
  if (null != this.Kd) {
    var a = this.Kd;
    this.Kd = null;
    return a;
  }
  if (null != this.Kb) {
    return a = this.Kb.next(), this.Kb.Da() || (this.Kb = null), a;
  }
  if (this.advance()) {
    return this.next();
  }
  throw Error("No such element");
};
Mh.prototype.remove = function() {
  return Error("Unsupported operation");
};
function Nh(a, b, c) {
  this.la = a;
  this.oa = b;
  this.o = c;
}
h = Nh.prototype;
h.Bc = function(a) {
  if (a === this.la) {
    return this;
  }
  var b = qf(this.oa), c = Array(0 > b ? 4 : 2 * (b + 1));
  Ye(this.o, 0, c, 0, 2 * b);
  return new Nh(a, this.oa, c);
};
h.Fd = function() {
  return Oh ? Oh(this.o) : Ph.call(null, this.o);
};
h.Hc = function(a, b) {
  return Lh(this.o, a, b);
};
h.oc = function(a, b, c, d) {
  var e = 1 << (b >>> a & 31);
  if (0 === (this.oa & e)) {
    return d;
  }
  var f = qf(this.oa & e - 1), e = this.o[2 * f], f = this.o[2 * f + 1];
  return null == e ? f.oc(a + 5, b, c, d) : Hh(c, e) ? f : d;
};
h.Jb = function(a, b, c, d, e, f) {
  var g = 1 << (c >>> b & 31), k = qf(this.oa & g - 1);
  if (0 === (this.oa & g)) {
    var l = qf(this.oa);
    if (2 * l < this.o.length) {
      a = this.Bc(a);
      b = a.o;
      f.G = !0;
      a: {
        for (c = 2 * (l - k), f = 2 * k + (c - 1), l = 2 * (k + 1) + (c - 1);;) {
          if (0 === c) {
            break a;
          }
          b[l] = b[f];
          --l;
          --c;
          --f;
        }
      }
      b[2 * k] = d;
      b[2 * k + 1] = e;
      a.oa |= g;
      return a;
    }
    if (16 <= l) {
      k = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
      k[c >>> b & 31] = Qh.Jb(a, b + 5, c, d, e, f);
      for (e = d = 0;;) {
        if (32 > d) {
          0 !== (this.oa >>> d & 1) && (k[d] = null != this.o[e] ? Qh.Jb(a, b + 5, Wd(this.o[e]), this.o[e], this.o[e + 1], f) : this.o[e + 1], e += 2), d += 1;
        } else {
          break;
        }
      }
      return new Rh(a, l + 1, k);
    }
    b = Array(2 * (l + 4));
    Ye(this.o, 0, b, 0, 2 * k);
    b[2 * k] = d;
    b[2 * k + 1] = e;
    Ye(this.o, 2 * k, b, 2 * (k + 1), 2 * (l - k));
    f.G = !0;
    a = this.Bc(a);
    a.o = b;
    a.oa |= g;
    return a;
  }
  l = this.o[2 * k];
  g = this.o[2 * k + 1];
  if (null == l) {
    return l = g.Jb(a, b + 5, c, d, e, f), l === g ? this : Kh(this, a, 2 * k + 1, l);
  }
  if (Hh(d, l)) {
    return e === g ? this : Kh(this, a, 2 * k + 1, e);
  }
  f.G = !0;
  f = b + 5;
  d = Sh ? Sh(a, f, l, g, c, d, e) : Th.call(null, a, f, l, g, c, d, e);
  e = 2 * k;
  k = 2 * k + 1;
  a = this.Bc(a);
  a.o[e] = null;
  a.o[k] = d;
  return a;
};
h.Ib = function(a, b, c, d, e) {
  var f = 1 << (b >>> a & 31), g = qf(this.oa & f - 1);
  if (0 === (this.oa & f)) {
    var k = qf(this.oa);
    if (16 <= k) {
      g = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
      g[b >>> a & 31] = Qh.Ib(a + 5, b, c, d, e);
      for (d = c = 0;;) {
        if (32 > c) {
          0 !== (this.oa >>> c & 1) && (g[c] = null != this.o[d] ? Qh.Ib(a + 5, Wd(this.o[d]), this.o[d], this.o[d + 1], e) : this.o[d + 1], d += 2), c += 1;
        } else {
          break;
        }
      }
      return new Rh(null, k + 1, g);
    }
    a = Array(2 * (k + 1));
    Ye(this.o, 0, a, 0, 2 * g);
    a[2 * g] = c;
    a[2 * g + 1] = d;
    Ye(this.o, 2 * g, a, 2 * (g + 1), 2 * (k - g));
    e.G = !0;
    return new Nh(null, this.oa | f, a);
  }
  var l = this.o[2 * g], f = this.o[2 * g + 1];
  if (null == l) {
    return k = f.Ib(a + 5, b, c, d, e), k === f ? this : new Nh(null, this.oa, Ih(this.o, 2 * g + 1, k));
  }
  if (Hh(c, l)) {
    return d === f ? this : new Nh(null, this.oa, Ih(this.o, 2 * g + 1, d));
  }
  e.G = !0;
  e = this.oa;
  k = this.o;
  a += 5;
  a = Uh ? Uh(a, l, f, b, c, d) : Th.call(null, a, l, f, b, c, d);
  c = 2 * g;
  g = 2 * g + 1;
  d = tc(k);
  d[c] = null;
  d[g] = a;
  return new Nh(null, e, d);
};
h.Gd = function(a, b, c) {
  var d = 1 << (b >>> a & 31);
  if (0 === (this.oa & d)) {
    return this;
  }
  var e = qf(this.oa & d - 1), f = this.o[2 * e], g = this.o[2 * e + 1];
  return null == f ? (a = g.Gd(a + 5, b, c), a === g ? this : null != a ? new Nh(null, this.oa, Ih(this.o, 2 * e + 1, a)) : this.oa === d ? null : new Nh(null, this.oa ^ d, Jh(this.o, e))) : Hh(c, f) ? new Nh(null, this.oa ^ d, Jh(this.o, e)) : this;
};
h.mb = function() {
  return new Mh(this.o, 0, null, null);
};
var Qh = new Nh(null, 0, []);
function Vh(a, b, c) {
  this.o = a;
  this.i = b;
  this.Kb = c;
}
Vh.prototype.Da = function() {
  for (var a = this.o.length;;) {
    if (null != this.Kb && this.Kb.Da()) {
      return !0;
    }
    if (this.i < a) {
      var b = this.o[this.i];
      this.i += 1;
      null != b && (this.Kb = Ld(b));
    } else {
      return !1;
    }
  }
};
Vh.prototype.next = function() {
  if (this.Da()) {
    return this.Kb.next();
  }
  throw Error("No such element");
};
Vh.prototype.remove = function() {
  return Error("Unsupported operation");
};
function Rh(a, b, c) {
  this.la = a;
  this.D = b;
  this.o = c;
}
h = Rh.prototype;
h.Bc = function(a) {
  return a === this.la ? this : new Rh(a, this.D, tc(this.o));
};
h.Fd = function() {
  return Wh ? Wh(this.o) : Xh.call(null, this.o);
};
h.Hc = function(a, b) {
  for (var c = this.o.length, d = 0, e = b;;) {
    if (d < c) {
      var f = this.o[d];
      if (null != f && (e = f.Hc(a, e), le(e))) {
        return L.h ? L.h(e) : L.call(null, e);
      }
      d += 1;
    } else {
      return e;
    }
  }
};
h.oc = function(a, b, c, d) {
  var e = this.o[b >>> a & 31];
  return null != e ? e.oc(a + 5, b, c, d) : d;
};
h.Jb = function(a, b, c, d, e, f) {
  var g = c >>> b & 31, k = this.o[g];
  if (null == k) {
    return a = Kh(this, a, g, Qh.Jb(a, b + 5, c, d, e, f)), a.D += 1, a;
  }
  b = k.Jb(a, b + 5, c, d, e, f);
  return b === k ? this : Kh(this, a, g, b);
};
h.Ib = function(a, b, c, d, e) {
  var f = b >>> a & 31, g = this.o[f];
  if (null == g) {
    return new Rh(null, this.D + 1, Ih(this.o, f, Qh.Ib(a + 5, b, c, d, e)));
  }
  a = g.Ib(a + 5, b, c, d, e);
  return a === g ? this : new Rh(null, this.D, Ih(this.o, f, a));
};
h.Gd = function(a, b, c) {
  var d = b >>> a & 31, e = this.o[d];
  if (null != e) {
    a = e.Gd(a + 5, b, c);
    if (a === e) {
      d = this;
    } else {
      if (null == a) {
        if (8 >= this.D) {
          a: {
            e = this.o;
            a = e.length;
            b = Array(2 * (this.D - 1));
            c = 0;
            for (var f = 1, g = 0;;) {
              if (c < a) {
                c !== d && null != e[c] && (b[f] = e[c], f += 2, g |= 1 << c), c += 1;
              } else {
                d = new Nh(null, g, b);
                break a;
              }
            }
          }
        } else {
          d = new Rh(null, this.D - 1, Ih(this.o, d, a));
        }
      } else {
        d = new Rh(null, this.D, Ih(this.o, d, a));
      }
    }
    return d;
  }
  return this;
};
h.mb = function() {
  return new Vh(this.o, 0, null);
};
function Yh(a, b, c) {
  b *= 2;
  for (var d = 0;;) {
    if (d < b) {
      if (Hh(c, a[d])) {
        return d;
      }
      d += 2;
    } else {
      return -1;
    }
  }
}
function Zh(a, b, c, d) {
  this.la = a;
  this.$b = b;
  this.D = c;
  this.o = d;
}
h = Zh.prototype;
h.Bc = function(a) {
  if (a === this.la) {
    return this;
  }
  var b = Array(2 * (this.D + 1));
  Ye(this.o, 0, b, 0, 2 * this.D);
  return new Zh(a, this.$b, this.D, b);
};
h.Fd = function() {
  return Oh ? Oh(this.o) : Ph.call(null, this.o);
};
h.Hc = function(a, b) {
  return Lh(this.o, a, b);
};
h.oc = function(a, b, c, d) {
  a = Yh(this.o, this.D, c);
  return 0 > a ? d : Hh(c, this.o[a]) ? this.o[a + 1] : d;
};
h.Jb = function(a, b, c, d, e, f) {
  if (c === this.$b) {
    b = Yh(this.o, this.D, d);
    if (-1 === b) {
      if (this.o.length > 2 * this.D) {
        return b = 2 * this.D, c = 2 * this.D + 1, a = this.Bc(a), a.o[b] = d, a.o[c] = e, f.G = !0, a.D += 1, a;
      }
      c = this.o.length;
      b = Array(c + 2);
      Ye(this.o, 0, b, 0, c);
      b[c] = d;
      b[c + 1] = e;
      f.G = !0;
      d = this.D + 1;
      a === this.la ? (this.o = b, this.D = d, a = this) : a = new Zh(this.la, this.$b, d, b);
      return a;
    }
    return this.o[b + 1] === e ? this : Kh(this, a, b + 1, e);
  }
  return (new Nh(a, 1 << (this.$b >>> b & 31), [null, this, null, null])).Jb(a, b, c, d, e, f);
};
h.Ib = function(a, b, c, d, e) {
  return b === this.$b ? (a = Yh(this.o, this.D, c), -1 === a ? (a = 2 * this.D, b = Array(a + 2), Ye(this.o, 0, b, 0, a), b[a] = c, b[a + 1] = d, e.G = !0, new Zh(null, this.$b, this.D + 1, b)) : J.j(this.o[a + 1], d) ? this : new Zh(null, this.$b, this.D, Ih(this.o, a + 1, d))) : (new Nh(null, 1 << (this.$b >>> a & 31), [null, this])).Ib(a, b, c, d, e);
};
h.Gd = function(a, b, c) {
  a = Yh(this.o, this.D, c);
  return -1 === a ? this : 1 === this.D ? null : new Zh(null, this.$b, this.D - 1, Jh(this.o, pf(a)));
};
h.mb = function() {
  return new Mh(this.o, 0, null, null);
};
function Th(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 6:
      return Uh(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], arguments[5]);
    case 7:
      return Sh(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4], arguments[5], arguments[6]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function Uh(a, b, c, d, e, f) {
  var g = Wd(b);
  if (g === d) {
    return new Zh(null, g, 2, [b, c, e, f]);
  }
  var k = new Gh;
  return Qh.Ib(a, g, b, c, k).Ib(a, d, e, f, k);
}
function Sh(a, b, c, d, e, f, g) {
  var k = Wd(c);
  if (k === e) {
    return new Zh(null, k, 2, [c, d, f, g]);
  }
  var l = new Gh;
  return Qh.Jb(a, b, k, c, d, l).Jb(a, b, e, f, g, l);
}
function $h(a, b, c, d, e) {
  this.meta = a;
  this.qc = b;
  this.i = c;
  this.s = d;
  this.F = e;
  this.w = 32374860;
  this.K = 0;
}
h = $h.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return null == this.s ? new T(null, 2, 5, W, [this.qc[this.i], this.qc[this.i + 1]], null) : G(this.s);
};
h.Ra = function() {
  var a = this, b = null == a.s ? function() {
    var b = a.qc, d = a.i + 2;
    return ai ? ai(b, d, null) : Ph.call(null, b, d, null);
  }() : function() {
    var b = a.qc, d = a.i, e = H(a.s);
    return ai ? ai(b, d, e) : Ph.call(null, b, d, e);
  }();
  return null != b ? b : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new $h(b, this.qc, this.i, this.s, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
$h.prototype[sc] = function() {
  return de(this);
};
function Ph(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return Oh(arguments[0]);
    case 3:
      return ai(arguments[0], arguments[1], arguments[2]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function Oh(a) {
  return ai(a, 0, null);
}
function ai(a, b, c) {
  if (null == c) {
    for (c = a.length;;) {
      if (b < c) {
        if (null != a[b]) {
          return new $h(null, a, b, null, null);
        }
        var d = a[b + 1];
        if (w(d) && (d = d.Fd(), w(d))) {
          return new $h(null, a, b + 2, d, null);
        }
        b += 2;
      } else {
        return null;
      }
    }
  } else {
    return new $h(null, a, b, c, null);
  }
}
function bi(a, b, c, d, e) {
  this.meta = a;
  this.qc = b;
  this.i = c;
  this.s = d;
  this.F = e;
  this.w = 32374860;
  this.K = 0;
}
h = bi.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return G(this.s);
};
h.Ra = function() {
  var a;
  a = this.qc;
  var b = this.i, c = H(this.s);
  a = ci ? ci(null, a, b, c) : Xh.call(null, null, a, b, c);
  return null != a ? a : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new bi(b, this.qc, this.i, this.s, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
bi.prototype[sc] = function() {
  return de(this);
};
function Xh(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 1:
      return Wh(arguments[0]);
    case 4:
      return ci(arguments[0], arguments[1], arguments[2], arguments[3]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function Wh(a) {
  return ci(null, a, 0, null);
}
function ci(a, b, c, d) {
  if (null == d) {
    for (d = b.length;;) {
      if (c < d) {
        var e = b[c];
        if (w(e) && (e = e.Fd(), w(e))) {
          return new bi(a, b, c + 1, e, null);
        }
        c += 1;
      } else {
        return null;
      }
    }
  } else {
    return new bi(a, b, c, d, null);
  }
}
function di(a, b, c) {
  this.Ua = a;
  this.Sf = b;
  this.We = c;
}
di.prototype.Da = function() {
  return kc(this.We) || this.Sf.Da();
};
di.prototype.next = function() {
  if (this.We) {
    return this.Sf.next();
  }
  this.We = !0;
  return new T(null, 2, 5, W, [null, this.Ua], null);
};
di.prototype.remove = function() {
  return Error("Unsupported operation");
};
function ei(a, b, c, d, e, f) {
  this.meta = a;
  this.D = b;
  this.root = c;
  this.Sa = d;
  this.Ua = e;
  this.F = f;
  this.w = 16123663;
  this.K = 8196;
}
h = ei.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.keys = function() {
  return de(zh.h ? zh.h(this) : zh.call(null, this));
};
h.entries = function() {
  return new uh(D(D(this)));
};
h.values = function() {
  return de(Ah.h ? Ah.h(this) : Ah.call(null, this));
};
h.has = function(a) {
  return cf(this, a);
};
h.get = function(a, b) {
  return this.N(null, a, b);
};
h.forEach = function(a) {
  for (var b = D(this), c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      a.j ? a.j(f, g) : a.call(null, f, g);
      e += 1;
    } else {
      if (b = D(b)) {
        We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
      } else {
        return null;
      }
    }
  }
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return null == b ? this.Sa ? this.Ua : c : null == this.root ? c : this.root.oc(0, Wd(b), b, c);
};
h.Sc = function(a, b, c) {
  a = this.Sa ? b.l ? b.l(c, null, this.Ua) : b.call(null, c, null, this.Ua) : c;
  return le(a) ? L.h ? L.h(a) : L.call(null, a) : null != this.root ? this.root.Hc(b, a) : a;
};
h.mb = function() {
  var a = this.root ? Ld(this.root) : bg();
  return this.Sa ? new di(this.Ua, a, !1) : a;
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new ei(this.meta, this.D, this.root, this.Sa, this.Ua, this.F);
};
h.ja = function() {
  return this.D;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = he(this);
};
h.I = function(a, b) {
  return sh(this, b);
};
h.Rc = function() {
  return new fi({}, this.root, this.D, this.Sa, this.Ua);
};
h.na = function() {
  return fd(Dh, this.meta);
};
h.Tc = function(a, b) {
  if (null == b) {
    return this.Sa ? new ei(this.meta, this.D - 1, this.root, !1, null, null) : this;
  }
  if (null == this.root) {
    return this;
  }
  var c = this.root.Gd(0, Wd(b), b);
  return c === this.root ? this : new ei(this.meta, this.D - 1, c, this.Sa, this.Ua, null);
};
h.Qb = function(a, b, c) {
  if (null == b) {
    return this.Sa && c === this.Ua ? this : new ei(this.meta, this.Sa ? this.D : this.D + 1, this.root, !0, c, null);
  }
  a = new Gh;
  b = (null == this.root ? Qh : this.root).Ib(0, Wd(b), b, c, a);
  return b === this.root ? this : new ei(this.meta, a.G ? this.D + 1 : this.D, b, this.Sa, this.Ua, null);
};
h.Ud = function(a, b) {
  return null == b ? this.Sa : null == this.root ? !1 : this.root.oc(0, Wd(b), b, Ze) !== Ze;
};
h.ea = function() {
  if (0 < this.D) {
    var a = null != this.root ? this.root.Fd() : null;
    return this.Sa ? ze(new T(null, 2, 5, W, [null, this.Ua], null), a) : a;
  }
  return null;
};
h.T = function(a, b) {
  return new ei(b, this.D, this.root, this.Sa, this.Ua, this.F);
};
h.fa = function(a, b) {
  if (Ve(b)) {
    return Rc(this, Ic.j(b, 0), Ic.j(b, 1));
  }
  for (var c = this, d = D(b);;) {
    if (null == d) {
      return c;
    }
    var e = G(d);
    if (Ve(e)) {
      c = Rc(c, Ic.j(e, 0), Ic.j(e, 1)), d = H(d);
    } else {
      throw Error("conj on a map takes map entries or seqables of map entries");
    }
  }
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
var Dh = new ei(null, 0, null, !1, null, ie);
function Ke(a, b) {
  for (var c = a.length, d = 0, e = vd(Dh);;) {
    if (d < c) {
      var f = d + 1, e = e.rd(null, a[d], b[d]), d = f
    } else {
      return xd(e);
    }
  }
}
ei.prototype[sc] = function() {
  return de(this);
};
function fi(a, b, c, d, e) {
  this.la = a;
  this.root = b;
  this.count = c;
  this.Sa = d;
  this.Ua = e;
  this.w = 258;
  this.K = 56;
}
function gi(a, b, c) {
  if (a.la) {
    if (null == b) {
      a.Ua !== c && (a.Ua = c), a.Sa || (a.count += 1, a.Sa = !0);
    } else {
      var d = new Gh;
      b = (null == a.root ? Qh : a.root).Jb(a.la, 0, Wd(b), b, c, d);
      b !== a.root && (a.root = b);
      d.G && (a.count += 1);
    }
    return a;
  }
  throw Error("assoc! after persistent!");
}
h = fi.prototype;
h.ja = function() {
  if (this.la) {
    return this.count;
  }
  throw Error("count after persistent!");
};
h.R = function(a, b) {
  return null == b ? this.Sa ? this.Ua : null : null == this.root ? null : this.root.oc(0, Wd(b), b);
};
h.N = function(a, b, c) {
  return null == b ? this.Sa ? this.Ua : c : null == this.root ? c : this.root.oc(0, Wd(b), b, c);
};
h.sd = function(a, b) {
  var c;
  a: {
    if (this.la) {
      if (null != b ? b.w & 2048 || q === b.kg || (b.w ? 0 : oc(Uc, b)) : oc(Uc, b)) {
        c = gi(this, vf.h ? vf.h(b) : vf.call(null, b), wf.h ? wf.h(b) : wf.call(null, b));
      } else {
        c = D(b);
        for (var d = this;;) {
          var e = G(c);
          if (w(e)) {
            c = H(c), d = gi(d, vf.h ? vf.h(e) : vf.call(null, e), wf.h ? wf.h(e) : wf.call(null, e));
          } else {
            c = d;
            break a;
          }
        }
      }
    } else {
      throw Error("conj! after persistent");
    }
  }
  return c;
};
h.ud = function() {
  var a;
  if (this.la) {
    this.la = null, a = new ei(null, this.count, this.root, this.Sa, this.Ua, null);
  } else {
    throw Error("persistent! called twice");
  }
  return a;
};
h.rd = function(a, b, c) {
  return gi(this, b, c);
};
function hi(a, b, c) {
  for (var d = b;;) {
    if (null != a) {
      b = c ? a.left : a.right, d = Ge.j(d, a), a = b;
    } else {
      return d;
    }
  }
}
function ii(a, b, c, d, e) {
  this.meta = a;
  this.stack = b;
  this.Sd = c;
  this.D = d;
  this.F = e;
  this.w = 32374862;
  this.K = 0;
}
h = ii.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.meta;
};
h.ja = function() {
  return 0 > this.D ? O(H(this)) + 1 : this.D;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  var a = this.stack;
  return null == a ? null : Yc(a);
};
h.Ra = function() {
  var a = G(this.stack), a = hi(this.Sd ? a.right : a.left, H(this.stack), this.Sd);
  return null != a ? new ii(null, a, this.Sd, this.D - 1, null) : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new ii(b, this.stack, this.Sd, this.D, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
ii.prototype[sc] = function() {
  return de(this);
};
function ji(a, b, c) {
  return new ii(null, hi(a, null, b), b, c, null);
}
function ki(a, b, c, d) {
  return c instanceof li ? c.left instanceof li ? new li(c.key, c.G, c.left.Yb(), new mi(a, b, c.right, d, null), null) : c.right instanceof li ? new li(c.right.key, c.right.G, new mi(c.key, c.G, c.left, c.right.left, null), new mi(a, b, c.right.right, d, null), null) : new mi(a, b, c, d, null) : new mi(a, b, c, d, null);
}
function ni(a, b, c, d) {
  return d instanceof li ? d.right instanceof li ? new li(d.key, d.G, new mi(a, b, c, d.left, null), d.right.Yb(), null) : d.left instanceof li ? new li(d.left.key, d.left.G, new mi(a, b, c, d.left.left, null), new mi(d.key, d.G, d.left.right, d.right, null), null) : new mi(a, b, c, d, null) : new mi(a, b, c, d, null);
}
function oi(a, b, c, d) {
  if (c instanceof li) {
    return new li(a, b, c.Yb(), d, null);
  }
  if (d instanceof mi) {
    return ni(a, b, c, d.Md());
  }
  if (d instanceof li && d.left instanceof mi) {
    return new li(d.left.key, d.left.G, new mi(a, b, c, d.left.left, null), ni(d.key, d.G, d.left.right, d.right.Md()), null);
  }
  throw Error("red-black tree invariant violation");
}
function pi(a, b, c, d) {
  if (d instanceof li) {
    return new li(a, b, c, d.Yb(), null);
  }
  if (c instanceof mi) {
    return ki(a, b, c.Md(), d);
  }
  if (c instanceof li && c.right instanceof mi) {
    return new li(c.right.key, c.right.G, ki(c.key, c.G, c.left.Md(), c.right.left), new mi(a, b, c.right.right, d, null), null);
  }
  throw Error("red-black tree invariant violation");
}
var qi = function qi(b, c, d) {
  var e = null != b.left ? function() {
    var e = b.left;
    return qi.l ? qi.l(e, c, d) : qi.call(null, e, c, d);
  }() : d;
  if (le(e)) {
    return L.h ? L.h(e) : L.call(null, e);
  }
  var f = function() {
    var d = b.key, f = b.G;
    return c.l ? c.l(e, d, f) : c.call(null, e, d, f);
  }();
  if (le(f)) {
    return L.h ? L.h(f) : L.call(null, f);
  }
  var g = null != b.right ? function() {
    var d = b.right;
    return qi.l ? qi.l(d, c, f) : qi.call(null, d, c, f);
  }() : f;
  return le(g) ? L.h ? L.h(g) : L.call(null, g) : g;
};
function mi(a, b, c, d, e) {
  this.key = a;
  this.G = b;
  this.left = c;
  this.right = d;
  this.F = e;
  this.w = 32402207;
  this.K = 0;
}
h = mi.prototype;
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.cf = function(a) {
  return a.gf(this);
};
h.Md = function() {
  return new li(this.key, this.G, this.left, this.right, null);
};
h.Yb = function() {
  return this;
};
h.bf = function(a) {
  return a.ff(this);
};
h.replace = function(a, b, c, d) {
  return new mi(a, b, c, d, null);
};
h.ff = function(a) {
  return new mi(a.key, a.G, this, a.right, null);
};
h.gf = function(a) {
  return new mi(a.key, a.G, a.left, this, null);
};
h.Hc = function(a, b) {
  return qi(this, a, b);
};
h.R = function(a, b) {
  return Ic.l(this, b, null);
};
h.N = function(a, b, c) {
  return Ic.l(this, b, c);
};
h.aa = function(a, b) {
  return 0 === b ? this.key : 1 === b ? this.G : null;
};
h.cb = function(a, b, c) {
  return 0 === b ? this.key : 1 === b ? this.G : c;
};
h.Ac = function(a, b, c) {
  return (new T(null, 2, 5, W, [this.key, this.G], null)).Ac(null, b, c);
};
h.S = function() {
  return null;
};
h.ja = function() {
  return 2;
};
h.nd = function() {
  return this.key;
};
h.od = function() {
  return this.G;
};
h.kc = function() {
  return this.G;
};
h.lc = function() {
  return new T(null, 1, 5, W, [this.key], null);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return He;
};
h.xa = function(a, b) {
  return me(this, b);
};
h.ya = function(a, b, c) {
  return ne(this, b, c);
};
h.Qb = function(a, b, c) {
  return Je.l(new T(null, 2, 5, W, [this.key, this.G], null), b, c);
};
h.ea = function() {
  var a = this.key;
  return Gc(Gc(ae, this.G), a);
};
h.T = function(a, b) {
  return Be(new T(null, 2, 5, W, [this.key, this.G], null), b);
};
h.fa = function(a, b) {
  return new T(null, 3, 5, W, [this.key, this.G, b], null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
mi.prototype[sc] = function() {
  return de(this);
};
function li(a, b, c, d, e) {
  this.key = a;
  this.G = b;
  this.left = c;
  this.right = d;
  this.F = e;
  this.w = 32402207;
  this.K = 0;
}
h = li.prototype;
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.cf = function(a) {
  return new li(this.key, this.G, this.left, a, null);
};
h.Md = function() {
  throw Error("red-black tree invariant violation");
};
h.Yb = function() {
  return new mi(this.key, this.G, this.left, this.right, null);
};
h.bf = function(a) {
  return new li(this.key, this.G, a, this.right, null);
};
h.replace = function(a, b, c, d) {
  return new li(a, b, c, d, null);
};
h.ff = function(a) {
  return this.left instanceof li ? new li(this.key, this.G, this.left.Yb(), new mi(a.key, a.G, this.right, a.right, null), null) : this.right instanceof li ? new li(this.right.key, this.right.G, new mi(this.key, this.G, this.left, this.right.left, null), new mi(a.key, a.G, this.right.right, a.right, null), null) : new mi(a.key, a.G, this, a.right, null);
};
h.gf = function(a) {
  return this.right instanceof li ? new li(this.key, this.G, new mi(a.key, a.G, a.left, this.left, null), this.right.Yb(), null) : this.left instanceof li ? new li(this.left.key, this.left.G, new mi(a.key, a.G, a.left, this.left.left, null), new mi(this.key, this.G, this.left.right, this.right, null), null) : new mi(a.key, a.G, a.left, this, null);
};
h.Hc = function(a, b) {
  return qi(this, a, b);
};
h.R = function(a, b) {
  return Ic.l(this, b, null);
};
h.N = function(a, b, c) {
  return Ic.l(this, b, c);
};
h.aa = function(a, b) {
  return 0 === b ? this.key : 1 === b ? this.G : null;
};
h.cb = function(a, b, c) {
  return 0 === b ? this.key : 1 === b ? this.G : c;
};
h.Ac = function(a, b, c) {
  return (new T(null, 2, 5, W, [this.key, this.G], null)).Ac(null, b, c);
};
h.S = function() {
  return null;
};
h.ja = function() {
  return 2;
};
h.nd = function() {
  return this.key;
};
h.od = function() {
  return this.G;
};
h.kc = function() {
  return this.G;
};
h.lc = function() {
  return new T(null, 1, 5, W, [this.key], null);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return He;
};
h.xa = function(a, b) {
  return me(this, b);
};
h.ya = function(a, b, c) {
  return ne(this, b, c);
};
h.Qb = function(a, b, c) {
  return Je.l(new T(null, 2, 5, W, [this.key, this.G], null), b, c);
};
h.ea = function() {
  var a = this.key;
  return Gc(Gc(ae, this.G), a);
};
h.T = function(a, b) {
  return Be(new T(null, 2, 5, W, [this.key, this.G], null), b);
};
h.fa = function(a, b) {
  return new T(null, 3, 5, W, [this.key, this.G, b], null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
li.prototype[sc] = function() {
  return de(this);
};
var ri = function ri(b, c, d, e, f) {
  if (null == c) {
    return new li(d, e, null, null, null);
  }
  var g = function() {
    var e = c.key;
    return b.j ? b.j(d, e) : b.call(null, d, e);
  }();
  if (0 === g) {
    return f[0] = c, null;
  }
  if (0 > g) {
    return g = function() {
      var g = c.left;
      return ri.O ? ri.O(b, g, d, e, f) : ri.call(null, b, g, d, e, f);
    }(), null != g ? c.bf(g) : null;
  }
  g = function() {
    var g = c.right;
    return ri.O ? ri.O(b, g, d, e, f) : ri.call(null, b, g, d, e, f);
  }();
  return null != g ? c.cf(g) : null;
}, si = function si(b, c) {
  if (null == b) {
    return c;
  }
  if (null == c) {
    return b;
  }
  if (b instanceof li) {
    if (c instanceof li) {
      var d = function() {
        var d = b.right, f = c.left;
        return si.j ? si.j(d, f) : si.call(null, d, f);
      }();
      return d instanceof li ? new li(d.key, d.G, new li(b.key, b.G, b.left, d.left, null), new li(c.key, c.G, d.right, c.right, null), null) : new li(b.key, b.G, b.left, new li(c.key, c.G, d, c.right, null), null);
    }
    return new li(b.key, b.G, b.left, function() {
      var d = b.right;
      return si.j ? si.j(d, c) : si.call(null, d, c);
    }(), null);
  }
  if (c instanceof li) {
    return new li(c.key, c.G, function() {
      var d = c.left;
      return si.j ? si.j(b, d) : si.call(null, b, d);
    }(), c.right, null);
  }
  d = function() {
    var d = b.right, f = c.left;
    return si.j ? si.j(d, f) : si.call(null, d, f);
  }();
  return d instanceof li ? new li(d.key, d.G, new mi(b.key, b.G, b.left, d.left, null), new mi(c.key, c.G, d.right, c.right, null), null) : oi(b.key, b.G, b.left, new mi(c.key, c.G, d, c.right, null));
}, ti = function ti(b, c, d, e) {
  if (null != c) {
    var f = function() {
      var e = c.key;
      return b.j ? b.j(d, e) : b.call(null, d, e);
    }();
    if (0 === f) {
      return e[0] = c, si(c.left, c.right);
    }
    if (0 > f) {
      return f = function() {
        var f = c.left;
        return ti.H ? ti.H(b, f, d, e) : ti.call(null, b, f, d, e);
      }(), null != f || null != e[0] ? c.left instanceof mi ? oi(c.key, c.G, f, c.right) : new li(c.key, c.G, f, c.right, null) : null;
    }
    f = function() {
      var f = c.right;
      return ti.H ? ti.H(b, f, d, e) : ti.call(null, b, f, d, e);
    }();
    return null != f || null != e[0] ? c.right instanceof mi ? pi(c.key, c.G, c.left, f) : new li(c.key, c.G, c.left, f, null) : null;
  }
  return null;
}, ui = function ui(b, c, d, e) {
  var f = c.key, g = b.j ? b.j(d, f) : b.call(null, d, f);
  return 0 === g ? c.replace(f, e, c.left, c.right) : 0 > g ? c.replace(f, c.G, function() {
    var f = c.left;
    return ui.H ? ui.H(b, f, d, e) : ui.call(null, b, f, d, e);
  }(), c.right) : c.replace(f, c.G, c.left, function() {
    var f = c.right;
    return ui.H ? ui.H(b, f, d, e) : ui.call(null, b, f, d, e);
  }());
};
function vi(a, b, c, d, e) {
  this.pb = a;
  this.Xb = b;
  this.D = c;
  this.meta = d;
  this.F = e;
  this.w = 418776847;
  this.K = 8192;
}
h = vi.prototype;
h.forEach = function(a) {
  for (var b = D(this), c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      a.j ? a.j(f, g) : a.call(null, f, g);
      e += 1;
    } else {
      if (b = D(b)) {
        We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
      } else {
        return null;
      }
    }
  }
};
h.get = function(a, b) {
  return this.N(null, a, b);
};
h.entries = function() {
  return new uh(D(D(this)));
};
h.toString = function() {
  return Nd(this);
};
h.keys = function() {
  return de(zh.h ? zh.h(this) : zh.call(null, this));
};
h.values = function() {
  return de(Ah.h ? Ah.h(this) : Ah.call(null, this));
};
h.equiv = function(a) {
  return this.I(null, a);
};
function wi(a, b) {
  for (var c = a.Xb;;) {
    if (null != c) {
      var d;
      d = c.key;
      d = a.pb.j ? a.pb.j(b, d) : a.pb.call(null, b, d);
      if (0 === d) {
        return c;
      }
      c = 0 > d ? c.left : c.right;
    } else {
      return null;
    }
  }
}
h.has = function(a) {
  return cf(this, a);
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  a = wi(this, b);
  return null != a ? a.G : c;
};
h.Sc = function(a, b, c) {
  return null != this.Xb ? qi(this.Xb, b, c) : c;
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new vi(this.pb, this.Xb, this.D, this.meta, this.F);
};
h.ja = function() {
  return this.D;
};
h.Uc = function() {
  return 0 < this.D ? ji(this.Xb, !1, this.D) : null;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = he(this);
};
h.I = function(a, b) {
  return sh(this, b);
};
h.na = function() {
  return new vi(this.pb, null, 0, this.meta, 0);
};
h.Tc = function(a, b) {
  var c = [null], d = ti(this.pb, this.Xb, b, c);
  return null == d ? null == te(c, 0) ? this : new vi(this.pb, null, 0, this.meta, null) : new vi(this.pb, d.Yb(), this.D - 1, this.meta, null);
};
h.Qb = function(a, b, c) {
  a = [null];
  var d = ri(this.pb, this.Xb, b, c, a);
  return null == d ? (a = te(a, 0), J.j(c, a.G) ? this : new vi(this.pb, ui(this.pb, this.Xb, b, c), this.D, this.meta, null)) : new vi(this.pb, d.Yb(), this.D + 1, this.meta, null);
};
h.Ud = function(a, b) {
  return null != wi(this, b);
};
h.ea = function() {
  return 0 < this.D ? ji(this.Xb, !0, this.D) : null;
};
h.T = function(a, b) {
  return new vi(this.pb, this.Xb, this.D, b, this.F);
};
h.fa = function(a, b) {
  if (Ve(b)) {
    return Rc(this, Ic.j(b, 0), Ic.j(b, 1));
  }
  for (var c = this, d = D(b);;) {
    if (null == d) {
      return c;
    }
    var e = G(d);
    if (Ve(e)) {
      c = Rc(c, Ic.j(e, 0), Ic.j(e, 1)), d = H(d);
    } else {
      throw Error("conj on a map takes map entries or seqables of map entries");
    }
  }
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
vi.prototype[sc] = function() {
  return de(this);
};
var pg = function pg(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  return pg.B(0 < c.length ? new F(c.slice(0), 0, null) : null);
};
pg.B = function(a) {
  a = D(a);
  for (var b = vd(Dh);;) {
    if (a) {
      var c = H(H(a)), b = Tf.l(b, G(a), Fe(a));
      a = c;
    } else {
      return xd(b);
    }
  }
};
pg.L = 0;
pg.J = function(a) {
  return pg.B(D(a));
};
var xi = function xi(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  return xi.B(0 < c.length ? new F(c.slice(0), 0, null) : null);
};
xi.B = function(a) {
  a = a instanceof F && 0 === a.i ? a.o : vc(a);
  return Eh(a, !0, !1);
};
xi.L = 0;
xi.J = function(a) {
  return xi.B(D(a));
};
function yi(a, b) {
  this.X = a;
  this.bb = b;
  this.w = 32374988;
  this.K = 0;
}
h = yi.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.bb;
};
h.Ya = function() {
  var a = (null != this.X ? this.X.w & 128 || q === this.X.Vd || (this.X.w ? 0 : oc(Mc, this.X)) : oc(Mc, this.X)) ? this.X.Ya(null) : H(this.X);
  return null == a ? null : new yi(a, this.bb);
};
h.V = function() {
  return fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.bb);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return this.X.za(null).nd(null);
};
h.Ra = function() {
  var a = (null != this.X ? this.X.w & 128 || q === this.X.Vd || (this.X.w ? 0 : oc(Mc, this.X)) : oc(Mc, this.X)) ? this.X.Ya(null) : H(this.X);
  return null != a ? new yi(a, this.bb) : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new yi(this.X, b);
};
h.fa = function(a, b) {
  return ze(b, this);
};
yi.prototype[sc] = function() {
  return de(this);
};
function zh(a) {
  return (a = D(a)) ? new yi(a, null) : null;
}
function vf(a) {
  return Vc(a);
}
function zi(a, b) {
  this.X = a;
  this.bb = b;
  this.w = 32374988;
  this.K = 0;
}
h = zi.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.S = function() {
  return this.bb;
};
h.Ya = function() {
  var a = (null != this.X ? this.X.w & 128 || q === this.X.Vd || (this.X.w ? 0 : oc(Mc, this.X)) : oc(Mc, this.X)) ? this.X.Ya(null) : H(this.X);
  return null == a ? null : new zi(a, this.bb);
};
h.V = function() {
  return fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.bb);
};
h.xa = function(a, b) {
  return Ce(b, this);
};
h.ya = function(a, b, c) {
  return Ee(b, c, this);
};
h.za = function() {
  return this.X.za(null).od(null);
};
h.Ra = function() {
  var a = (null != this.X ? this.X.w & 128 || q === this.X.Vd || (this.X.w ? 0 : oc(Mc, this.X)) : oc(Mc, this.X)) ? this.X.Ya(null) : H(this.X);
  return null != a ? new zi(a, this.bb) : ae;
};
h.ea = function() {
  return this;
};
h.T = function(a, b) {
  return new zi(this.X, b);
};
h.fa = function(a, b) {
  return ze(b, this);
};
zi.prototype[sc] = function() {
  return de(this);
};
function Ah(a) {
  return (a = D(a)) ? new zi(a, null) : null;
}
function wf(a) {
  return Wc(a);
}
var Ai = function Ai(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  return Ai.B(0 < c.length ? new F(c.slice(0), 0, null) : null);
};
Ai.B = function(a) {
  return w(fg(mf, a)) ? kf(function(a, c) {
    return Ge.j(w(a) ? a : dg, c);
  }, a) : null;
};
Ai.L = 0;
Ai.J = function(a) {
  return Ai.B(D(a));
};
function Bi(a) {
  this.iter = a;
}
Bi.prototype.Da = function() {
  return this.iter.Da();
};
Bi.prototype.next = function() {
  if (this.iter.Da()) {
    return this.iter.next().ba[0];
  }
  throw Error("No such element");
};
Bi.prototype.remove = function() {
  return Error("Unsupported operation");
};
function Ci(a, b, c) {
  this.meta = a;
  this.nc = b;
  this.F = c;
  this.w = 15077647;
  this.K = 8196;
}
h = Ci.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.keys = function() {
  return de(D(this));
};
h.entries = function() {
  return new vh(D(D(this)));
};
h.values = function() {
  return de(D(this));
};
h.has = function(a) {
  return cf(this, a);
};
h.forEach = function(a) {
  for (var b = D(this), c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      a.j ? a.j(f, g) : a.call(null, f, g);
      e += 1;
    } else {
      if (b = D(b)) {
        We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
      } else {
        return null;
      }
    }
  }
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return Qc(this.nc, b) ? b : c;
};
h.mb = function() {
  return new Bi(Ld(this.nc));
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new Ci(this.meta, this.nc, this.F);
};
h.ja = function() {
  return Dc(this.nc);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = he(this);
};
h.I = function(a, b) {
  return Re(b) && O(this) === O(b) && eg(function(a) {
    return function(b) {
      return cf(a, b);
    };
  }(this), b);
};
h.Rc = function() {
  return new Di(vd(this.nc));
};
h.na = function() {
  return Be(Ei, this.meta);
};
h.ea = function() {
  return zh(this.nc);
};
h.T = function(a, b) {
  return new Ci(b, this.nc, this.F);
};
h.fa = function(a, b) {
  return new Ci(this.meta, Je.l(this.nc, b, null), null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
var Ei = new Ci(null, dg, ie);
Ci.prototype[sc] = function() {
  return de(this);
};
function Di(a) {
  this.fc = a;
  this.K = 136;
  this.w = 259;
}
h = Di.prototype;
h.sd = function(a, b) {
  this.fc = Tf.l(this.fc, b, null);
  return this;
};
h.ud = function() {
  return new Ci(null, xd(this.fc), null);
};
h.ja = function() {
  return O(this.fc);
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  return Oc.l(this.fc, b, Ze) === Ze ? c : b;
};
h.call = function() {
  function a(a, b, c) {
    return Oc.l(this.fc, b, Ze) === Ze ? c : b;
  }
  function b(a, b) {
    return Oc.l(this.fc, b, Ze) === Ze ? null : b;
  }
  var c = null, c = function(c, e, f) {
    switch(arguments.length) {
      case 2:
        return b.call(this, 0, e);
      case 3:
        return a.call(this, 0, e, f);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  c.j = b;
  c.l = a;
  return c;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return Oc.l(this.fc, a, Ze) === Ze ? null : a;
};
h.j = function(a, b) {
  return Oc.l(this.fc, a, Ze) === Ze ? b : a;
};
function Fi(a, b, c) {
  this.meta = a;
  this.gc = b;
  this.F = c;
  this.w = 417730831;
  this.K = 8192;
}
h = Fi.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.keys = function() {
  return de(D(this));
};
h.entries = function() {
  return new vh(D(D(this)));
};
h.values = function() {
  return de(D(this));
};
h.has = function(a) {
  return cf(this, a);
};
h.forEach = function(a) {
  for (var b = D(this), c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      a.j ? a.j(f, g) : a.call(null, f, g);
      e += 1;
    } else {
      if (b = D(b)) {
        We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
      } else {
        return null;
      }
    }
  }
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  a = wi(this.gc, b);
  return null != a ? a.key : c;
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new Fi(this.meta, this.gc, this.F);
};
h.ja = function() {
  return O(this.gc);
};
h.Uc = function() {
  return 0 < O(this.gc) ? vg.j(vf, sd(this.gc)) : null;
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = he(this);
};
h.I = function(a, b) {
  return Re(b) && O(this) === O(b) && eg(function(a) {
    return function(b) {
      return cf(a, b);
    };
  }(this), b);
};
h.na = function() {
  return new Fi(this.meta, Ec(this.gc), 0);
};
h.ea = function() {
  return zh(this.gc);
};
h.T = function(a, b) {
  return new Fi(b, this.gc, this.F);
};
h.fa = function(a, b) {
  return new Fi(this.meta, Je.l(this.gc, b, null), null);
};
h.call = function() {
  var a = null, a = function(a, c, d) {
    switch(arguments.length) {
      case 2:
        return this.R(null, c);
      case 3:
        return this.N(null, c, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.j = function(a, c) {
    return this.R(null, c);
  };
  a.l = function(a, c, d) {
    return this.N(null, c, d);
  };
  return a;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.h = function(a) {
  return this.R(null, a);
};
h.j = function(a, b) {
  return this.N(null, a, b);
};
Fi.prototype[sc] = function() {
  return de(this);
};
function Gi(a) {
  var b = Hi;
  if (Ve(a)) {
    var c = O(a);
    return xc(function() {
      return function(a, c) {
        var d = df(b, te(a, c));
        return w(d) ? Je.l(a, c, Fe(d)) : a;
      };
    }(c), a, wg.j(c, Ag(je, 0)));
  }
  return vg.j(function(a) {
    var c = df(b, a);
    return w(c) ? Fe(c) : a;
  }, a);
}
function Gf(a) {
  if (null != a && (a.K & 4096 || q === a.pf)) {
    return a.pd(null);
  }
  if ("string" === typeof a) {
    return a;
  }
  throw Error([y("Doesn't support name: "), y(a)].join(""));
}
function Ii(a, b) {
  for (var c = vd(dg), d = D(a), e = D(b);;) {
    if (d && e) {
      c = Tf.l(c, G(d), G(e)), d = H(d), e = H(e);
    } else {
      return xd(c);
    }
  }
}
function Ji(a, b, c) {
  this.i = a;
  this.end = b;
  this.step = c;
}
Ji.prototype.Da = function() {
  return 0 < this.step ? this.i < this.end : this.i > this.end;
};
Ji.prototype.next = function() {
  var a = this.i;
  this.i += this.step;
  return a;
};
function Ki(a, b, c, d, e) {
  this.meta = a;
  this.start = b;
  this.end = c;
  this.step = d;
  this.F = e;
  this.w = 32375006;
  this.K = 8192;
}
h = Ki.prototype;
h.toString = function() {
  return Nd(this);
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.indexOf = function() {
  var a = null, a = function(a, c) {
    switch(arguments.length) {
      case 1:
        return N(this, a, 0);
      case 2:
        return N(this, a, c);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  a.h = function(a) {
    return N(this, a, 0);
  };
  a.j = function(a, c) {
    return N(this, a, c);
  };
  return a;
}();
h.lastIndexOf = function() {
  function a(a) {
    return ve(this, a, O(this));
  }
  var b = null, b = function(b, d) {
    switch(arguments.length) {
      case 1:
        return a.call(this, b);
      case 2:
        return ve(this, b, d);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  b.h = a;
  b.j = function(a, b) {
    return ve(this, a, b);
  };
  return b;
}();
h.aa = function(a, b) {
  if (b < Dc(this)) {
    return this.start + b * this.step;
  }
  if (this.start > this.end && 0 === this.step) {
    return this.start;
  }
  throw Error("Index out of bounds");
};
h.cb = function(a, b, c) {
  return b < Dc(this) ? this.start + b * this.step : this.start > this.end && 0 === this.step ? this.start : c;
};
h.mb = function() {
  return new Ji(this.start, this.end, this.step);
};
h.S = function() {
  return this.meta;
};
h.Xa = function() {
  return new Ki(this.meta, this.start, this.end, this.step, this.F);
};
h.Ya = function() {
  return 0 < this.step ? this.start + this.step < this.end ? new Ki(this.meta, this.start + this.step, this.end, this.step, null) : null : this.start + this.step > this.end ? new Ki(this.meta, this.start + this.step, this.end, this.step, null) : null;
};
h.ja = function() {
  return kc(md(this)) ? 0 : Math.ceil((this.end - this.start) / this.step);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = fe(this);
};
h.I = function(a, b) {
  return ye(this, b);
};
h.na = function() {
  return Be(ae, this.meta);
};
h.xa = function(a, b) {
  return me(this, b);
};
h.ya = function(a, b, c) {
  for (a = this.start;;) {
    if (0 < this.step ? a < this.end : a > this.end) {
      c = b.j ? b.j(c, a) : b.call(null, c, a);
      if (le(c)) {
        return L.h ? L.h(c) : L.call(null, c);
      }
      a += this.step;
    } else {
      return c;
    }
  }
};
h.za = function() {
  return null == md(this) ? null : this.start;
};
h.Ra = function() {
  return null != md(this) ? new Ki(this.meta, this.start + this.step, this.end, this.step, null) : ae;
};
h.ea = function() {
  return 0 < this.step ? this.start < this.end ? this : null : 0 > this.step ? this.start > this.end ? this : null : this.start === this.end ? null : this;
};
h.T = function(a, b) {
  return new Ki(b, this.start, this.end, this.step, this.F);
};
h.fa = function(a, b) {
  return ze(b, this);
};
Ki.prototype[sc] = function() {
  return de(this);
};
function Li(a) {
  for (;;) {
    if (D(a)) {
      a = H(a);
    } else {
      break;
    }
  }
}
function Mi(a) {
  Li(a);
  return a;
}
function Ni(a, b) {
  if ("string" === typeof b) {
    var c = a.exec(b);
    return J.j(G(c), b) ? 1 === O(c) ? G(c) : ch(c) : null;
  }
  throw new TypeError("re-matches must match against a string.");
}
function Oi(a, b) {
  if ("string" === typeof b) {
    var c = a.exec(b);
    return null == c ? null : 1 === O(c) ? G(c) : ch(c);
  }
  throw new TypeError("re-find must match against a string.");
}
function Pi(a) {
  if (a instanceof RegExp) {
    return a;
  }
  var b = Oi(/^\(\?([idmsux]*)\)/, a), c = S(b, 0, null), b = S(b, 1, null), c = O(c);
  return new RegExp(a.substring(c), w(b) ? b : "");
}
function Qi(a, b, c, d, e, f, g) {
  var k = ac;
  ac = null == ac ? null : ac - 1;
  try {
    if (null != ac && 0 > ac) {
      return td(a, "#");
    }
    td(a, c);
    if (0 === hc.h(f)) {
      D(g) && td(a, function() {
        var a = Ri.h(f);
        return w(a) ? a : "...";
      }());
    } else {
      if (D(g)) {
        var l = G(g);
        b.l ? b.l(l, a, f) : b.call(null, l, a, f);
      }
      for (var m = H(g), n = hc.h(f) - 1;;) {
        if (!m || null != n && 0 === n) {
          D(m) && 0 === n && (td(a, d), td(a, function() {
            var a = Ri.h(f);
            return w(a) ? a : "...";
          }()));
          break;
        } else {
          td(a, d);
          var t = G(m);
          c = a;
          g = f;
          b.l ? b.l(t, c, g) : b.call(null, t, c, g);
          var r = H(m);
          c = n - 1;
          m = r;
          n = c;
        }
      }
    }
    return td(a, e);
  } finally {
    ac = k;
  }
}
function Si(a, b) {
  for (var c = D(b), d = null, e = 0, f = 0;;) {
    if (f < e) {
      var g = d.aa(null, f);
      td(a, g);
      f += 1;
    } else {
      if (c = D(c)) {
        d = c, We(d) ? (c = Dd(d), e = Ed(d), d = c, g = O(c), c = e, e = g) : (g = G(d), td(a, g), c = H(d), d = null, e = 0), f = 0;
      } else {
        return null;
      }
    }
  }
}
var Ti = {'"':'\\"', "\\":"\\\\", "\b":"\\b", "\f":"\\f", "\n":"\\n", "\r":"\\r", "\t":"\\t"};
function Ui(a) {
  return [y('"'), y(a.replace(RegExp('[\\\\"\b\f\n\r\t]', "g"), function(a) {
    return Ti[a];
  })), y('"')].join("");
}
function Vi(a, b) {
  var c = af(C.j(a, fc));
  return c ? (c = null != b ? b.w & 131072 || q === b.nf ? !0 : !1 : !1) ? null != Oe(b) : c : c;
}
function Wi(a, b, c) {
  if (null == a) {
    return td(b, "nil");
  }
  if (Vi(c, a)) {
    td(b, "^");
    var d = Oe(a);
    Xi.l ? Xi.l(d, b, c) : Xi.call(null, d, b, c);
    td(b, " ");
  }
  if (a.Db) {
    return a.Rb(a, b, c);
  }
  if (null != a && (a.w & 2147483648 || q === a.ka)) {
    return a.W(null, b, c);
  }
  if (!0 === a || !1 === a || "number" === typeof a) {
    return td(b, "" + y(a));
  }
  if (null != a && a.constructor === Object) {
    return td(b, "#js "), d = vg.j(function(b) {
      return new T(null, 2, 5, W, [Ff.h(b), a[b]], null);
    }, Xe(a)), Yi.H ? Yi.H(d, Xi, b, c) : Yi.call(null, d, Xi, b, c);
  }
  if (jc(a)) {
    return Qi(b, Xi, "#js [", " ", "]", c, a);
  }
  if (ha(a)) {
    return w(ec.h(c)) ? td(b, Ui(a)) : td(b, a);
  }
  if (ja(a)) {
    var e = a.name;
    c = w(function() {
      var a = null == e;
      return a ? a : ya(e);
    }()) ? "Function" : e;
    return Si(b, P(["#object[", c, ' "', "" + y(a), '"]'], 0));
  }
  if (a instanceof Date) {
    return c = function(a, b) {
      for (var c = "" + y(a);;) {
        if (O(c) < b) {
          c = [y("0"), y(c)].join("");
        } else {
          return c;
        }
      }
    }, Si(b, P(['#inst "', "" + y(a.getUTCFullYear()), "-", c(a.getUTCMonth() + 1, 2), "-", c(a.getUTCDate(), 2), "T", c(a.getUTCHours(), 2), ":", c(a.getUTCMinutes(), 2), ":", c(a.getUTCSeconds(), 2), ".", c(a.getUTCMilliseconds(), 3), "-", '00:00"'], 0));
  }
  if (a instanceof RegExp) {
    return Si(b, P(['#"', a.source, '"'], 0));
  }
  if (w(a.constructor.ob)) {
    return Si(b, P(["#object[", a.constructor.ob.replace(RegExp("/", "g"), "."), "]"], 0));
  }
  e = a.constructor.name;
  c = w(function() {
    var a = null == e;
    return a ? a : ya(e);
  }()) ? "Object" : e;
  return Si(b, P(["#object[", c, " ", "" + y(a), "]"], 0));
}
function Xi(a, b, c) {
  var d = Zi.h(c);
  return w(d) ? (c = Je.l(c, $i, Wi), d.l ? d.l(a, b, c) : d.call(null, a, b, c)) : Wi(a, b, c);
}
function aj(a, b) {
  var c;
  if (Pe(a)) {
    c = "";
  } else {
    c = y;
    var d = new jb;
    a: {
      var e = new Md(d);
      Xi(G(a), e, b);
      for (var f = D(H(a)), g = null, k = 0, l = 0;;) {
        if (l < k) {
          var m = g.aa(null, l);
          td(e, " ");
          Xi(m, e, b);
          l += 1;
        } else {
          if (f = D(f)) {
            g = f, We(g) ? (f = Dd(g), k = Ed(g), g = f, m = O(f), f = k, k = m) : (m = G(g), td(e, " "), Xi(m, e, b), f = H(g), g = null, k = 0), l = 0;
          } else {
            break a;
          }
        }
      }
    }
    c = "" + c(d);
  }
  return c;
}
var bj = function() {
  function a(a) {
    var c = null;
    if (0 < arguments.length) {
      for (var c = 0, e = Array(arguments.length - 0);c < e.length;) {
        e[c] = arguments[c + 0], ++c;
      }
      c = new F(e, 0);
    }
    return b.call(this, c);
  }
  function b(a) {
    var b = Je.l(cc(), ec, !1);
    a = aj(a, b);
    Yb.h ? Yb.h(a) : Yb.call(null, a);
    return null;
  }
  a.L = 0;
  a.J = function(a) {
    a = D(a);
    return b(a);
  };
  a.B = b;
  return a;
}();
function Yi(a, b, c, d) {
  return Qi(c, function(a, c, d) {
    var e = Vc(a);
    b.l ? b.l(e, c, d) : b.call(null, e, c, d);
    td(c, " ");
    a = Wc(a);
    return b.l ? b.l(a, c, d) : b.call(null, a, c, d);
  }, "{", ", ", "}", d, D(a));
}
tg.prototype.ka = q;
tg.prototype.W = function(a, b, c) {
  td(b, "#object [cljs.core.Volatile ");
  Xi(new u(null, 1, [cj, this.state], null), b, c);
  return td(b, "]");
};
F.prototype.ka = q;
F.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
Hf.prototype.ka = q;
Hf.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
ii.prototype.ka = q;
ii.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
$h.prototype.ka = q;
$h.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
mi.prototype.ka = q;
mi.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "[", " ", "]", c, this);
};
xh.prototype.ka = q;
xh.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
Fi.prototype.ka = q;
Fi.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "#{", " ", "}", c, this);
};
eh.prototype.ka = q;
eh.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
Cf.prototype.ka = q;
Cf.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
xe.prototype.ka = q;
xe.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
ei.prototype.ka = q;
ei.prototype.W = function(a, b, c) {
  return Yi(this, Xi, b, c);
};
bi.prototype.ka = q;
bi.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
ih.prototype.ka = q;
ih.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "[", " ", "]", c, this);
};
vi.prototype.ka = q;
vi.prototype.W = function(a, b, c) {
  return Yi(this, Xi, b, c);
};
Ci.prototype.ka = q;
Ci.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "#{", " ", "}", c, this);
};
Lf.prototype.ka = q;
Lf.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
mg.prototype.ka = q;
mg.prototype.W = function(a, b, c) {
  td(b, "#object [cljs.core.Atom ");
  Xi(new u(null, 1, [cj, this.state], null), b, c);
  return td(b, "]");
};
zi.prototype.ka = q;
zi.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
li.prototype.ka = q;
li.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "[", " ", "]", c, this);
};
T.prototype.ka = q;
T.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "[", " ", "]", c, this);
};
nh.prototype.ka = q;
nh.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
zf.prototype.ka = q;
zf.prototype.W = function(a, b) {
  return td(b, "()");
};
oh.prototype.ka = q;
oh.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "#queue [", " ", "]", c, D(this));
};
u.prototype.ka = q;
u.prototype.W = function(a, b, c) {
  return Yi(this, Xi, b, c);
};
Ki.prototype.ka = q;
Ki.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
yi.prototype.ka = q;
yi.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
xf.prototype.ka = q;
xf.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "(", " ", ")", c, this);
};
A.prototype.zc = q;
A.prototype.Zb = function(a, b) {
  if (b instanceof A) {
    return Yd(this, b);
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
X.prototype.zc = q;
X.prototype.Zb = function(a, b) {
  if (b instanceof X) {
    return Df(this, b);
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
ih.prototype.zc = q;
ih.prototype.Zb = function(a, b) {
  if (Ve(b)) {
    return ff(this, b);
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
T.prototype.zc = q;
T.prototype.Zb = function(a, b) {
  if (Ve(b)) {
    return ff(this, b);
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
function dj() {
}
var ej = function ej(b) {
  if (null != b && null != b.hg) {
    return b.hg(b);
  }
  var c = ej[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = ej._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("IEncodeJS.-clj-\x3ejs", b);
};
function fj(a) {
  return (null != a ? q === a.gg || (a.De ? 0 : oc(dj, a)) : oc(dj, a)) ? ej(a) : "string" === typeof a || "number" === typeof a || a instanceof X || a instanceof A ? gj.h ? gj.h(a) : gj.call(null, a) : aj(P([a], 0), cc());
}
var gj = function gj(b) {
  if (null == b) {
    return null;
  }
  if (null != b ? q === b.gg || (b.De ? 0 : oc(dj, b)) : oc(dj, b)) {
    return ej(b);
  }
  if (b instanceof X) {
    return Gf(b);
  }
  if (b instanceof A) {
    return "" + y(b);
  }
  if (Te(b)) {
    var c = {};
    b = D(b);
    for (var d = null, e = 0, f = 0;;) {
      if (f < e) {
        var g = d.aa(null, f), k = S(g, 0, null), g = S(g, 1, null);
        c[fj(k)] = gj.h ? gj.h(g) : gj.call(null, g);
        f += 1;
      } else {
        if (b = D(b)) {
          We(b) ? (e = Dd(b), b = Ed(b), d = e, e = O(e)) : (e = G(b), d = S(e, 0, null), e = S(e, 1, null), c[fj(d)] = gj.h ? gj.h(e) : gj.call(null, e), b = H(b), d = null, e = 0), f = 0;
        } else {
          break;
        }
      }
    }
    return c;
  }
  if (Qe(b)) {
    c = [];
    b = D(vg.j(gj, b));
    d = null;
    for (f = e = 0;;) {
      if (f < e) {
        k = d.aa(null, f), c.push(k), f += 1;
      } else {
        if (b = D(b)) {
          d = b, We(d) ? (b = Dd(d), f = Ed(d), d = b, e = O(b), b = f) : (b = G(d), c.push(b), b = H(d), d = null, e = 0), f = 0;
        } else {
          break;
        }
      }
    }
    return c;
  }
  return b;
};
function hj() {
}
var ij = function ij(b, c) {
  if (null != b && null != b.fg) {
    return b.fg(b, c);
  }
  var d = ij[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = ij._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("IEncodeClojure.-js-\x3eclj", b);
};
function jj(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, kj);
  return function(a, c, d, k) {
    return function m(e) {
      return (null != e ? q === e.qh || (e.De ? 0 : oc(hj, e)) : oc(hj, e)) ? ij(e, Vf(xi, b)) : $e(e) ? Mi(vg.j(m, e)) : Qe(e) ? Gg.j(null == e ? null : Ec(e), vg.j(m, e)) : jc(e) ? ch(vg.j(m, e)) : pc(e) === Object ? Gg.j(dg, function() {
        return function(a, b, c, d) {
          return function B(f) {
            return new Hf(null, function(a, b, c, d) {
              return function() {
                for (;;) {
                  var a = D(f);
                  if (a) {
                    if (We(a)) {
                      var b = Dd(a), c = O(b), g = new Jf(Array(c), 0);
                      a: {
                        for (var k = 0;;) {
                          if (k < c) {
                            var n = Ic.j(b, k);
                            Nf(g, new T(null, 2, 5, W, [d.h ? d.h(n) : d.call(null, n), m(e[n])], null));
                            k += 1;
                          } else {
                            b = !0;
                            break a;
                          }
                        }
                      }
                      return b ? Mf(g.ib(), B(Ed(a))) : Mf(g.ib(), null);
                    }
                    g = G(a);
                    return ze(new T(null, 2, 5, W, [d.h ? d.h(g) : d.call(null, g), m(e[g])], null), B($d(a)));
                  }
                  return null;
                }
              };
            }(a, b, c, d), null, null);
          };
        }(a, c, d, k)(Xe(e));
      }()) : e;
    };
  }(b, c, d, w(d) ? Ff : y)(a);
}
var lj = null;
function mj() {
  if (null == lj) {
    var a = new u(null, 3, [nj, dg, oj, dg, pj, dg], null);
    lj = og ? og(a) : ng.call(null, a);
  }
  return lj;
}
function qj(a, b, c) {
  var d = J.j(b, c);
  if (!d && !(d = cf(pj.h(a).call(null, b), c)) && (d = Ve(c)) && (d = Ve(b))) {
    if (d = O(c) === O(b)) {
      for (var d = !0, e = 0;;) {
        if (d && e !== O(c)) {
          d = qj(a, b.h ? b.h(e) : b.call(null, e), c.h ? c.h(e) : c.call(null, e)), e += 1;
        } else {
          return d;
        }
      }
    } else {
      return d;
    }
  } else {
    return d;
  }
}
function rj(a) {
  var b;
  b = mj();
  b = L.h ? L.h(b) : L.call(null, b);
  return ag(C.j(nj.h(b), a));
}
function sj(a, b, c, d) {
  sg.j(a, function() {
    return L.h ? L.h(b) : L.call(null, b);
  });
  sg.j(c, function() {
    return L.h ? L.h(d) : L.call(null, d);
  });
}
var tj = function tj(b, c, d) {
  var e = (L.h ? L.h(d) : L.call(null, d)).call(null, b), e = w(w(e) ? e.h ? e.h(c) : e.call(null, c) : e) ? !0 : null;
  if (w(e)) {
    return e;
  }
  e = function() {
    for (var e = rj(c);;) {
      if (0 < O(e)) {
        var g = G(e);
        tj.l ? tj.l(b, g, d) : tj.call(null, b, g, d);
        e = $d(e);
      } else {
        return null;
      }
    }
  }();
  if (w(e)) {
    return e;
  }
  e = function() {
    for (var e = rj(b);;) {
      if (0 < O(e)) {
        var g = G(e);
        tj.l ? tj.l(g, c, d) : tj.call(null, g, c, d);
        e = $d(e);
      } else {
        return null;
      }
    }
  }();
  return w(e) ? e : !1;
};
function uj(a, b, c, d) {
  c = tj(a, b, c);
  return w(c) ? c : qj(d, a, b);
}
var vj = function vj(b, c, d, e, f, g, k) {
  var l = xc(function(e, g) {
    var k = S(g, 0, null);
    S(g, 1, null);
    if (qj(L.h ? L.h(d) : L.call(null, d), c, k)) {
      var l;
      l = (l = null == e) ? l : uj(k, G(e), f, L.h ? L.h(d) : L.call(null, d));
      l = w(l) ? g : e;
      if (!w(uj(G(l), k, f, L.h ? L.h(d) : L.call(null, d)))) {
        throw Error([y("Multiple methods in multimethod '"), y(b), y("' match dispatch value: "), y(c), y(" -\x3e "), y(k), y(" and "), y(G(l)), y(", and neither is preferred")].join(""));
      }
      return l;
    }
    return e;
  }, null, L.h ? L.h(e) : L.call(null, e));
  if (w(l)) {
    if (J.j(L.h ? L.h(k) : L.call(null, k), L.h ? L.h(d) : L.call(null, d))) {
      return sg.H(g, Je, c, Fe(l)), Fe(l);
    }
    sj(g, e, k, d);
    return vj.wa ? vj.wa(b, c, d, e, f, g, k) : vj.call(null, b, c, d, e, f, g, k);
  }
  return null;
};
function wj(a, b) {
  throw Error([y("No method in multimethod '"), y(a), y("' for dispatch value: "), y(b)].join(""));
}
function xj(a, b, c, d, e, f, g, k) {
  this.name = a;
  this.C = b;
  this.ug = c;
  this.Dd = d;
  this.$c = e;
  this.Yg = f;
  this.Jd = g;
  this.gd = k;
  this.w = 4194305;
  this.K = 4352;
}
h = xj.prototype;
h.call = function() {
  function a(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V, U) {
    a = this;
    var ba = Zf(a.C, b, c, d, e, P([f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V, U], 0)), R = this.P(ba);
    w(R) || wj(a.name, ba);
    return Zf(R, b, c, d, e, P([f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V, U], 0));
  }
  function b(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V) {
    a = this;
    var ba = a.C.Oa ? a.C.Oa(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V), R = this.P(ba);
    w(R) || wj(a.name, ba);
    return R.Oa ? R.Oa(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V) : R.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I, V);
  }
  function c(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I) {
    a = this;
    var ba = a.C.Na ? a.C.Na(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I), R = this.P(ba);
    w(R) || wj(a.name, ba);
    return R.Na ? R.Na(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I) : R.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E, I);
  }
  function d(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E) {
    a = this;
    var ba = a.C.Ma ? a.C.Ma(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E), R = this.P(ba);
    w(R) || wj(a.name, ba);
    return R.Ma ? R.Ma(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E) : R.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z, E);
  }
  function e(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z) {
    a = this;
    var ba = a.C.La ? a.C.La(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z), E = this.P(ba);
    w(E) || wj(a.name, ba);
    return E.La ? E.La(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z) : E.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K, z);
  }
  function f(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K) {
    a = this;
    var ba = a.C.Ka ? a.C.Ka(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K), z = this.P(ba);
    w(z) || wj(a.name, ba);
    return z.Ka ? z.Ka(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K) : z.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B, K);
  }
  function g(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B) {
    a = this;
    var K = a.C.Ja ? a.C.Ja(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B), ba = this.P(K);
    w(ba) || wj(a.name, K);
    return ba.Ja ? ba.Ja(b, c, d, e, f, g, k, l, m, n, t, r, v, x, B) : ba.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x, B);
  }
  function k(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) {
    a = this;
    var B = a.C.Ia ? a.C.Ia(b, c, d, e, f, g, k, l, m, n, t, r, v, x) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x), K = this.P(B);
    w(K) || wj(a.name, B);
    return K.Ia ? K.Ia(b, c, d, e, f, g, k, l, m, n, t, r, v, x) : K.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v, x);
  }
  function l(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
    a = this;
    var x = a.C.Ha ? a.C.Ha(b, c, d, e, f, g, k, l, m, n, t, r, v) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v), B = this.P(x);
    w(B) || wj(a.name, x);
    return B.Ha ? B.Ha(b, c, d, e, f, g, k, l, m, n, t, r, v) : B.call(null, b, c, d, e, f, g, k, l, m, n, t, r, v);
  }
  function m(a, b, c, d, e, f, g, k, l, m, n, t, r) {
    a = this;
    var v = a.C.Ga ? a.C.Ga(b, c, d, e, f, g, k, l, m, n, t, r) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t, r), x = this.P(v);
    w(x) || wj(a.name, v);
    return x.Ga ? x.Ga(b, c, d, e, f, g, k, l, m, n, t, r) : x.call(null, b, c, d, e, f, g, k, l, m, n, t, r);
  }
  function n(a, b, c, d, e, f, g, k, l, m, n, t) {
    a = this;
    var r = a.C.Fa ? a.C.Fa(b, c, d, e, f, g, k, l, m, n, t) : a.C.call(null, b, c, d, e, f, g, k, l, m, n, t), v = this.P(r);
    w(v) || wj(a.name, r);
    return v.Fa ? v.Fa(b, c, d, e, f, g, k, l, m, n, t) : v.call(null, b, c, d, e, f, g, k, l, m, n, t);
  }
  function t(a, b, c, d, e, f, g, k, l, m, n) {
    a = this;
    var t = a.C.Ea ? a.C.Ea(b, c, d, e, f, g, k, l, m, n) : a.C.call(null, b, c, d, e, f, g, k, l, m, n), r = this.P(t);
    w(r) || wj(a.name, t);
    return r.Ea ? r.Ea(b, c, d, e, f, g, k, l, m, n) : r.call(null, b, c, d, e, f, g, k, l, m, n);
  }
  function r(a, b, c, d, e, f, g, k, l, m) {
    a = this;
    var n = a.C.Qa ? a.C.Qa(b, c, d, e, f, g, k, l, m) : a.C.call(null, b, c, d, e, f, g, k, l, m), t = this.P(n);
    w(t) || wj(a.name, n);
    return t.Qa ? t.Qa(b, c, d, e, f, g, k, l, m) : t.call(null, b, c, d, e, f, g, k, l, m);
  }
  function v(a, b, c, d, e, f, g, k, l) {
    a = this;
    var m = a.C.Pa ? a.C.Pa(b, c, d, e, f, g, k, l) : a.C.call(null, b, c, d, e, f, g, k, l), n = this.P(m);
    w(n) || wj(a.name, m);
    return n.Pa ? n.Pa(b, c, d, e, f, g, k, l) : n.call(null, b, c, d, e, f, g, k, l);
  }
  function x(a, b, c, d, e, f, g, k) {
    a = this;
    var l = a.C.wa ? a.C.wa(b, c, d, e, f, g, k) : a.C.call(null, b, c, d, e, f, g, k), m = this.P(l);
    w(m) || wj(a.name, l);
    return m.wa ? m.wa(b, c, d, e, f, g, k) : m.call(null, b, c, d, e, f, g, k);
  }
  function z(a, b, c, d, e, f, g) {
    a = this;
    var k = a.C.ua ? a.C.ua(b, c, d, e, f, g) : a.C.call(null, b, c, d, e, f, g), l = this.P(k);
    w(l) || wj(a.name, k);
    return l.ua ? l.ua(b, c, d, e, f, g) : l.call(null, b, c, d, e, f, g);
  }
  function B(a, b, c, d, e, f) {
    a = this;
    var g = a.C.O ? a.C.O(b, c, d, e, f) : a.C.call(null, b, c, d, e, f), k = this.P(g);
    w(k) || wj(a.name, g);
    return k.O ? k.O(b, c, d, e, f) : k.call(null, b, c, d, e, f);
  }
  function I(a, b, c, d, e) {
    a = this;
    var f = a.C.H ? a.C.H(b, c, d, e) : a.C.call(null, b, c, d, e), g = this.P(f);
    w(g) || wj(a.name, f);
    return g.H ? g.H(b, c, d, e) : g.call(null, b, c, d, e);
  }
  function U(a, b, c, d) {
    a = this;
    var e = a.C.l ? a.C.l(b, c, d) : a.C.call(null, b, c, d), f = this.P(e);
    w(f) || wj(a.name, e);
    return f.l ? f.l(b, c, d) : f.call(null, b, c, d);
  }
  function V(a, b, c) {
    a = this;
    var d = a.C.j ? a.C.j(b, c) : a.C.call(null, b, c), e = this.P(d);
    w(e) || wj(a.name, d);
    return e.j ? e.j(b, c) : e.call(null, b, c);
  }
  function Q(a, b) {
    a = this;
    var c = a.C.h ? a.C.h(b) : a.C.call(null, b), d = this.P(c);
    w(d) || wj(a.name, c);
    return d.h ? d.h(b) : d.call(null, b);
  }
  function K(a) {
    a = this;
    var b = a.C.v ? a.C.v() : a.C.call(null), c = this.P(b);
    w(c) || wj(a.name, b);
    return c.v ? c.v() : c.call(null);
  }
  var E = null, E = function(E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be, il) {
    switch(arguments.length) {
      case 1:
        return K.call(this, E);
      case 2:
        return Q.call(this, E, R);
      case 3:
        return V.call(this, E, R, pa);
      case 4:
        return U.call(this, E, R, pa, hb);
      case 5:
        return I.call(this, E, R, pa, hb, ia);
      case 6:
        return B.call(this, E, R, pa, hb, ia, ra);
      case 7:
        return z.call(this, E, R, pa, hb, ia, ra, va);
      case 8:
        return x.call(this, E, R, pa, hb, ia, ra, va, Aa);
      case 9:
        return v.call(this, E, R, pa, hb, ia, ra, va, Aa, La);
      case 10:
        return r.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na);
      case 11:
        return t.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa);
      case 12:
        return n.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja);
      case 13:
        return m.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa);
      case 14:
        return l.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab);
      case 15:
        return k.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb);
      case 16:
        return g.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb);
      case 17:
        return f.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b);
      case 18:
        return e.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc);
      case 19:
        return d.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc);
      case 20:
        return c.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd);
      case 21:
        return b.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be);
      case 22:
        return a.call(this, E, R, pa, hb, ia, ra, va, Aa, La, Na, Pa, Ja, Qa, ab, Hb, vb, $b, nc, Bc, qd, be, il);
    }
    throw Error("Invalid arity: " + arguments.length);
  };
  E.h = K;
  E.j = Q;
  E.l = V;
  E.H = U;
  E.O = I;
  E.ua = B;
  E.wa = z;
  E.Pa = x;
  E.Qa = v;
  E.Ea = r;
  E.Fa = t;
  E.Ga = n;
  E.Ha = m;
  E.Ia = l;
  E.Ja = k;
  E.Ka = g;
  E.La = f;
  E.Ma = e;
  E.Na = d;
  E.Oa = c;
  E.Ae = b;
  E.md = a;
  return E;
}();
h.apply = function(a, b) {
  return this.call.apply(this, [this].concat(tc(b)));
};
h.v = function() {
  var a = this.C.v ? this.C.v() : this.C.call(null), b = this.P(a);
  w(b) || wj(this.name, a);
  return b.v ? b.v() : b.call(null);
};
h.h = function(a) {
  var b = this.C.h ? this.C.h(a) : this.C.call(null, a), c = this.P(b);
  w(c) || wj(this.name, b);
  return c.h ? c.h(a) : c.call(null, a);
};
h.j = function(a, b) {
  var c = this.C.j ? this.C.j(a, b) : this.C.call(null, a, b), d = this.P(c);
  w(d) || wj(this.name, c);
  return d.j ? d.j(a, b) : d.call(null, a, b);
};
h.l = function(a, b, c) {
  var d = this.C.l ? this.C.l(a, b, c) : this.C.call(null, a, b, c), e = this.P(d);
  w(e) || wj(this.name, d);
  return e.l ? e.l(a, b, c) : e.call(null, a, b, c);
};
h.H = function(a, b, c, d) {
  var e = this.C.H ? this.C.H(a, b, c, d) : this.C.call(null, a, b, c, d), f = this.P(e);
  w(f) || wj(this.name, e);
  return f.H ? f.H(a, b, c, d) : f.call(null, a, b, c, d);
};
h.O = function(a, b, c, d, e) {
  var f = this.C.O ? this.C.O(a, b, c, d, e) : this.C.call(null, a, b, c, d, e), g = this.P(f);
  w(g) || wj(this.name, f);
  return g.O ? g.O(a, b, c, d, e) : g.call(null, a, b, c, d, e);
};
h.ua = function(a, b, c, d, e, f) {
  var g = this.C.ua ? this.C.ua(a, b, c, d, e, f) : this.C.call(null, a, b, c, d, e, f), k = this.P(g);
  w(k) || wj(this.name, g);
  return k.ua ? k.ua(a, b, c, d, e, f) : k.call(null, a, b, c, d, e, f);
};
h.wa = function(a, b, c, d, e, f, g) {
  var k = this.C.wa ? this.C.wa(a, b, c, d, e, f, g) : this.C.call(null, a, b, c, d, e, f, g), l = this.P(k);
  w(l) || wj(this.name, k);
  return l.wa ? l.wa(a, b, c, d, e, f, g) : l.call(null, a, b, c, d, e, f, g);
};
h.Pa = function(a, b, c, d, e, f, g, k) {
  var l = this.C.Pa ? this.C.Pa(a, b, c, d, e, f, g, k) : this.C.call(null, a, b, c, d, e, f, g, k), m = this.P(l);
  w(m) || wj(this.name, l);
  return m.Pa ? m.Pa(a, b, c, d, e, f, g, k) : m.call(null, a, b, c, d, e, f, g, k);
};
h.Qa = function(a, b, c, d, e, f, g, k, l) {
  var m = this.C.Qa ? this.C.Qa(a, b, c, d, e, f, g, k, l) : this.C.call(null, a, b, c, d, e, f, g, k, l), n = this.P(m);
  w(n) || wj(this.name, m);
  return n.Qa ? n.Qa(a, b, c, d, e, f, g, k, l) : n.call(null, a, b, c, d, e, f, g, k, l);
};
h.Ea = function(a, b, c, d, e, f, g, k, l, m) {
  var n = this.C.Ea ? this.C.Ea(a, b, c, d, e, f, g, k, l, m) : this.C.call(null, a, b, c, d, e, f, g, k, l, m), t = this.P(n);
  w(t) || wj(this.name, n);
  return t.Ea ? t.Ea(a, b, c, d, e, f, g, k, l, m) : t.call(null, a, b, c, d, e, f, g, k, l, m);
};
h.Fa = function(a, b, c, d, e, f, g, k, l, m, n) {
  var t = this.C.Fa ? this.C.Fa(a, b, c, d, e, f, g, k, l, m, n) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n), r = this.P(t);
  w(r) || wj(this.name, t);
  return r.Fa ? r.Fa(a, b, c, d, e, f, g, k, l, m, n) : r.call(null, a, b, c, d, e, f, g, k, l, m, n);
};
h.Ga = function(a, b, c, d, e, f, g, k, l, m, n, t) {
  var r = this.C.Ga ? this.C.Ga(a, b, c, d, e, f, g, k, l, m, n, t) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t), v = this.P(r);
  w(v) || wj(this.name, r);
  return v.Ga ? v.Ga(a, b, c, d, e, f, g, k, l, m, n, t) : v.call(null, a, b, c, d, e, f, g, k, l, m, n, t);
};
h.Ha = function(a, b, c, d, e, f, g, k, l, m, n, t, r) {
  var v = this.C.Ha ? this.C.Ha(a, b, c, d, e, f, g, k, l, m, n, t, r) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r), x = this.P(v);
  w(x) || wj(this.name, v);
  return x.Ha ? x.Ha(a, b, c, d, e, f, g, k, l, m, n, t, r) : x.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r);
};
h.Ia = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
  var x = this.C.Ia ? this.C.Ia(a, b, c, d, e, f, g, k, l, m, n, t, r, v) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v), z = this.P(x);
  w(z) || wj(this.name, x);
  return z.Ia ? z.Ia(a, b, c, d, e, f, g, k, l, m, n, t, r, v) : z.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v);
};
h.Ja = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) {
  var z = this.C.Ja ? this.C.Ja(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x), B = this.P(z);
  w(B) || wj(this.name, z);
  return B.Ja ? B.Ja(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x) : B.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x);
};
h.Ka = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) {
  var B = this.C.Ka ? this.C.Ka(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z), I = this.P(B);
  w(I) || wj(this.name, B);
  return I.Ka ? I.Ka(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) : I.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z);
};
h.La = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) {
  var I = this.C.La ? this.C.La(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B), U = this.P(I);
  w(U) || wj(this.name, I);
  return U.La ? U.La(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B) : U.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
};
h.Ma = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) {
  var U = this.C.Ma ? this.C.Ma(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I), V = this.P(U);
  w(V) || wj(this.name, U);
  return V.Ma ? V.Ma(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I) : V.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I);
};
h.Na = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) {
  var V = this.C.Na ? this.C.Na(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U), Q = this.P(V);
  w(Q) || wj(this.name, V);
  return Q.Na ? Q.Na(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U) : Q.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U);
};
h.Oa = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) {
  var Q = this.C.Oa ? this.C.Oa(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) : this.C.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V), K = this.P(Q);
  w(K) || wj(this.name, Q);
  return K.Oa ? K.Oa(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V) : K.call(null, a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V);
};
h.Ae = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q) {
  var K = Zf(this.C, a, b, c, d, P([e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q], 0)), E = this.P(K);
  w(E) || wj(this.name, K);
  return Zf(E, a, b, c, d, P([e, f, g, k, l, m, n, t, r, v, x, z, B, I, U, V, Q], 0));
};
function yj(a, b, c) {
  sg.H(a.$c, Je, b, c);
  sj(a.Jd, a.$c, a.gd, a.Dd);
}
h.P = function(a) {
  J.j(L.h ? L.h(this.gd) : L.call(null, this.gd), L.h ? L.h(this.Dd) : L.call(null, this.Dd)) || sj(this.Jd, this.$c, this.gd, this.Dd);
  var b = (L.h ? L.h(this.Jd) : L.call(null, this.Jd)).call(null, a);
  if (w(b)) {
    return b;
  }
  a = vj(this.name, a, this.Dd, this.$c, this.Yg, this.Jd, this.gd);
  return w(a) ? a : (L.h ? L.h(this.$c) : L.call(null, this.$c)).call(null, this.ug);
};
h.pd = function() {
  return Gd(this.name);
};
h.qd = function() {
  return Hd(this.name);
};
h.V = function() {
  return la(this);
};
function zj(a, b) {
  this.Pb = a;
  this.F = b;
  this.w = 2153775104;
  this.K = 2048;
}
h = zj.prototype;
h.toString = function() {
  return this.Pb;
};
h.equiv = function(a) {
  return this.I(null, a);
};
h.I = function(a, b) {
  return b instanceof zj && this.Pb === b.Pb;
};
h.W = function(a, b) {
  return td(b, [y('#uuid "'), y(this.Pb), y('"')].join(""));
};
h.V = function() {
  null == this.F && (this.F = Wd(this.Pb));
  return this.F;
};
h.Zb = function(a, b) {
  return wb(this.Pb, b.Pb);
};
function Aj() {
  function a() {
    return Math.floor(16 * Math.random()).toString(16);
  }
  var b = (8 | 3 & Math.floor(16 * Math.random())).toString(16);
  return new zj([y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y("-"), y(a()), y(a()), y(a()), y(a()), y("-"), y("4"), y(a()), y(a()), y(a()), y("-"), y(b), y(a()), y(a()), y(a()), y("-"), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a()), y(a())].join(""), null);
}
;var Bj = new A(null, "form", "form", 16469056, null), Cj = new X(null, "code-mirror", "code-mirror", 575084768), Dj = new X(null, "args", "args", 1315556576), Ej = new X(null, "path", "path", -188191168), Fj = new X(null, "options-in", "options-in", -1968094624), Gj = new X(null, "encoding", "encoding", 1728578272), Hj = new X(null, "req-un", "req-un", 1074571008), Ij = new X(null, "opt-un", "opt-un", 883442496), Jj = new A("cljs.spec", "keys", "cljs.spec/keys", -927379584, null), Kj = new X(null, 
"the-editor-type", "the-editor-type", -672700480), Lj = new A(null, "meta62462", "meta62462", 40254913, null), Mj = new A(null, "unc", "unc", -465250751, null), Nj = new X(null, "offline", "offline", -107631935), Oj = new X(null, "errors", "errors", -908790718), Pj = new X(null, "selector", "selector", 762528866), Qj = new A(null, "map__68541", "map__68541", 1970434146, null), Rj = new X(null, "ret", "ret", -468222814), Sj = new X(null, "codemirror_options_out", "codemirror_options_out", 440175842), 
Tj = new X(null, "default-txt", "default-txt", 27736322), Uj = new X(null, "gfn", "gfn", 791517474), Vj = new X(null, "eval-counter", "eval-counter", -1501705598), Wj = new X(null, "external-libs", "external-libs", 1628481346), Xj = new X(null, "pred-exprs", "pred-exprs", 1792271395), Yj = new X(null, "request", "request", 1772954723), Zj = new X("klipse.plugin", "eval-fn", "klipse.plugin/eval-fn", -51358589), ak = new X(null, "indent?", "indent?", 1381429379), bk = new X(null, "get", "get", 1683182755), 
ck = new A(null, "meta68586", "meta68586", -1777355933, null), dk = new A(null, "map", "map", -1282745308, null), ek = new X(null, "fn", "fn", -1175266204), fk = new X(null, "json-params", "json-params", -1112693596), gk = new X(null, "rep+", "rep+", -281382396), hk = new X(null, "idle-msec", "idle-msec", 1257447972), fc = new X(null, "meta", "meta", 1499536964), ik = new A("cljs.core", "\x3d", "cljs.core/\x3d", -1891498332, null), jk = new X(null, "loop-msec", "loop-msec", 1897277156), kk = new X(null, 
"static-fns", "static-fns", -501950748), lk = new X(null, "file-not-found", "file-not-found", -65398940), mk = new X(null, "jsonp", "jsonp", 226119588), nk = new X("klipse.klipse-editors", "codemirror-options", "klipse.klipse-editors/codemirror-options", -1372888156), ok = new X(null, "compact-max-chars-in-str", "compact-max-chars-in-str", 240586724), pk = new X(null, "opt-keys", "opt-keys", 1262688261), qk = new A(null, "aform", "aform", 531303525, null), rk = new A(null, "blockable", "blockable", 
-28395259, null), gc = new X(null, "dup", "dup", 556298533), sk = new X(null, "editor-type", "editor-type", 198227301), tk = new X(null, "jsCode", "jsCode", -574022139), uk = new X(null, "element", "element", 1974019749), vk = new X(null, "patch", "patch", 380775109), wk = new X(null, "out-mode", "out-mode", -446316699), xk = new X("klipse.plugin", "eval_idle_msec", "klipse.plugin/eval_idle_msec", 15935397), yk = new X("klipse.klipse-editors", "editor-mode", "klipse.klipse-editors/editor-mode", -1678175194), 
zk = new A(null, "opt", "opt", 845825158, null), Ak = new A(null, "argspec", "argspec", -1207762746, null), Bk = new X(null, "editor-out-mode", "editor-out-mode", 1749845542), Ck = new X(null, "cljs_in", "cljs_in", 1284321894), Dk = new X("cljs.spec", "k", "cljs.spec/k", 668466950), Ek = new X(null, "response-type", "response-type", -1493770458), Fk = new X(null, "reset", "reset", -800929946), Gk = new X(null, "protocol", "protocol", 652470118), Hk = new X(null, "ks", "ks", 1900203942), Ik = new X(null, 
"print_length", "print_length", 2140955911), Jk = new A(null, "req-un", "req-un", -1579864761, null), Kk = new A(null, "opt-un", "opt-un", -1770993273, null), Lk = new X(null, "password", "password", 417022471), Mk = new X(null, "transit-params", "transit-params", 357261095), qg = new X(null, "validator", "validator", -1966190681), cg = new A(null, "meta60420", "meta60420", 759100456, null), Nk = new X(null, "method", "method", 55703592), Ok = new X(null, "default", "default", -1987822328), Pk = 
new X(null, "finally-block", "finally-block", 832982472), Qk = new A(null, "cb", "cb", -2064487928, null), Rk = new X(null, "replit-language", "replit-language", -941391192), Tk = new X(null, "on-should-eval", "on-should-eval", 978880168), Uk = new X(null, "result-element-id", "result-element-id", -1916360024), Vk = new X(null, "matchBrackets", "matchBrackets", 1256448936), Wk = new X("klipse.plugin", "klipse-settings", "klipse.plugin/klipse-settings", 1435250729), Xk = new X(null, "name", "name", 
1843675177), Yk = new A(null, "p1__69138#", "p1__69138#", 1864438857, null), Zk = new A(null, "zipmap", "zipmap", -690049687, null), $k = new A("cljs.core", "string?", "cljs.core/string?", -2072921719, null), al = new X(null, "encoding-opts", "encoding-opts", -1805664631), bl = new X(null, "beautify-strings", "beautify-strings", -236207479), cl = new X(null, "req-specs", "req-specs", 553962313), dl = new A(null, "gfn", "gfn", -1862918295, null), el = new X(null, "callback-name", "callback-name", 
336964714), fl = new A(null, "fnspec", "fnspec", -1865712406, null), gl = new A(null, "v", "v", 1661996586, null), hl = new X(null, "username", "username", 1605666410), jl = new A(null, "pred-exprs", "pred-exprs", -862164374, null), kl = new A(null, "keys-pred", "keys-pred", -1795451030, null), ll = new X(null, "beautify?", "beautify?", 1909100619), ml = new X(null, "cwd", "cwd", 14056523), nl = new X(null, "async-code?", "async-code?", -832111541), ol = new X(null, "mode", "mode", 654403691), pl = 
new X(null, "loaded", "loaded", -1246482293), ql = new A("goog.dom", "isElement", "goog.dom/isElement", -1707224949, null), rl = new A(null, "cpred?", "cpred?", 35589515, null), sl = new X(null, "compact-max-elements-in-seq", "compact-max-elements-in-seq", 418251211), tl = new X(null, "editor_type", "editor_type", 195783179), ul = new A(null, "argm", "argm", -181546357, null), vl = new X(null, "settings", "settings", 1556144875), wl = new X(null, "max-function-calls", "max-function-calls", -350003092), 
xl = new X(null, "channel", "channel", 734187692), cj = new X(null, "val", "val", 128701612), yl = new A(null, "fform", "fform", -176049972, null), Z = new X(null, "recur", "recur", -437573268), zl = new A(null, "opt-keys", "opt-keys", -1391747508, null), Al = new X(null, "verbose", "verbose", 1694226060), Bl = new X(null, "catch-block", "catch-block", 1175212748), Cl = new X(null, "delete", "delete", -1768633620), Dl = new X(null, "min-eval-idle-msec", "min-eval-idle-msec", -1547033812), El = new X(null, 
"compilationLevel", "compilationLevel", -1778317460), Fl = new A(null, "pred", "pred", -727012372, null), Gl = new X(null, "src", "src", -1651076051), Hl = new A(null, "p1__69139#", "p1__69139#", -606033843, null), Il = new X(null, "warnings", "warnings", -735437651), $i = new X(null, "fallback-impl", "fallback-impl", -1501286995), Jl = new A("cljs.core", "contains?", "cljs.core/contains?", -976526835, null), Kl = new X(null, "comment-str", "comment-str", 130143853), Ll = new A("cljs.core", "map?", 
"cljs.core/map?", -1390345523, null), Ml = new X(null, "output", "output", -1105869043), Nl = new X(null, "handlers", "handlers", 79528781), dc = new X(null, "flush-on-newline", "flush-on-newline", -151457939), Ol = new X(null, "port", "port", 1534937262), Pl = new A("cljs.core", "zipmap", "cljs.core/zipmap", -1902130674, null), Ql = new X(null, "minimalistic_ui", "minimalistic_ui", -944637362), Rl = new X(null, "abort", "abort", 521193198), Sl = new X(null, "base-url", "base-url", 9540398), Tl = 
new A(null, "%", "%", -950237169, null), Ul = new X(null, "in-mode", "in-mode", 33987599), Vl = new X("cljs.spec", "pcat", "cljs.spec/pcat", -1959753649), Wl = new X(null, "source-code", "source-code", -685884337), Xl = new A("cljs.core", "map", "cljs.core/map", -338988913, null), oj = new X(null, "descendants", "descendants", 1824886031), Yl = new A("cljs.spec", "conformer", "cljs.spec/conformer", -236330417, null), Zl = new X(null, "http-error", "http-error", -1040049553), $l = new A("cljs.core", 
"fn?", "cljs.core/fn?", 71876239, null), am = new X(null, "headers", "headers", -835030129), bm = new X(null, "server-port", "server-port", 663745648), pj = new X(null, "ancestors", "ancestors", -776045424), cm = new A(null, "meta69112", "meta69112", 458988720, null), dm = new A(null, "flag", "flag", -1565787888, null), em = new A(null, "req-specs", "req-specs", -2100473456, null), fm = new X(null, "write", "write", -1857649168), gm = new X(null, "no-error", "no-error", 1984610064), ec = new X(null, 
"readably", "readably", 1129599760), hm = new X(null, "error-code", "error-code", 180497232), im = new A(null, "meta68544", "meta68544", 1160591377, null), Ri = new X(null, "more-marker", "more-marker", -14717935), jm = new X(null, "document", "document", -1329188687), km = new A(null, "re", "re", 1869207729, null), lm = new A("klipse.plugin", "klipsify-with-opts", "klipse.plugin/klipsify-with-opts", 331340081, null), mm = new X(null, "preamble", "preamble", 1641040241), nm = new X(null, "head", 
"head", -771383919), om = new X(null, "req", "req", -326448303), pm = new X(null, "host", "host", -1558485167), qm = new X(null, "blob", "blob", 1636965233), rm = new X(null, "default-headers", "default-headers", -43146094), sm = new X(null, "compile-display-guard", "compile-display-guard", 1291882674), tm = new X(null, "total", "total", 1916810418), um = new X(null, "with-credentials?", "with-credentials?", -1773202222), vm = new X("cljs.spec", "name", "cljs.spec/name", -1902005006), wm = new A("cljs.core", 
"integer?", "cljs.core/integer?", 1710697810, null), xm = new X("cljs.spec", "unknown", "cljs.spec/unknown", -1620309582), ym = new X(null, "beautify_strings", "beautify_strings", 1690445266), zm = new X(null, "ff-silent-error", "ff-silent-error", 189390514), Am = new X(null, "result-element", "result-element", -690233582), Bm = new X(null, "success", "success", 1890645906), Cm = new X("klipse.plugin", "options", "klipse.plugin/options", 1158769650), Dm = new A(null, "meta63614", "meta63614", -1375108909, 
null), Em = new X(null, "form-params", "form-params", 1884296467), Fm = new X(null, "pointer", "pointer", 85071187), Gm = new X(null, "priority", "priority", 1431093715), Hm = new X(null, "readOnly", "readOnly", -1749118317), Im = new A(null, "fn*", "fn*", -752876845, null), Jm = new A(null, "val", "val", 1769233139, null), Km = new X(null, "root", "root", -448657453), Lm = new X(null, "status", "status", -1997798413), hc = new X(null, "print-length", "print-length", 1931866356), Mm = new X(null, 
"id", "id", -1388402092), Nm = new X(null, "class", "class", -2030961996), Om = new X(null, "container-id", "container-id", 1274665684), Pm = new X(null, "ok", "ok", 967785236), Qm = new X(null, "codemirror-options-out", "codemirror-options-out", 1969968980), Rm = new X(null, "stdio", "stdio", -1570777132), Sm = new X(null, "decoding-opts", "decoding-opts", 1050289140), Tm = new A(null, "meta63620", "meta63620", 1965370389, null), Um = new X(null, "catch-exception", "catch-exception", -1997306795), 
Vm = new X(null, "opts", "opts", 155075701), Wm = new X("klipse.plugin", "minimalistic_ui", "klipse.plugin/minimalistic_ui", 231935317), nj = new X(null, "parents", "parents", -2027538891), Xm = new A(null, "/", "/", -1371932971, null), Ym = new X(null, "container", "container", -1736937707), Zm = new A(null, "keys-\x3especs", "keys-\x3especs", -97897643, null), $m = new X(null, "req-keys", "req-keys", 514319221), an = new A(null, "k", "k", -505765866, null), bn = new X(null, "prev", "prev", -1597069226), 
cn = new A("klipse.klipse-editors", "editor-options", "klipse.klipse-editors/editor-options", 1970701494, null), dn = new A("cljs.core", "fn", "cljs.core/fn", -1065745098, null), en = new X(null, "url", "url", 276297046), fn = new X(null, "editor-in-mode", "editor-in-mode", -1964584522), gn = new X(null, "continue-block", "continue-block", -1852047850), hn = new X(null, "error-text", "error-text", 2021893718), jn = new A(null, "retspec", "retspec", -920025354, null), kn = new X("cljs.spec", "accept", 
"cljs.spec/accept", -1753298186), ln = new X(null, "query-params", "query-params", 900640534), mn = new X(null, "opt-specs", "opt-specs", -384905450), nn = new X(null, "in-editor-options", "in-editor-options", -1444530378), on = new X(null, "snippet-num", "snippet-num", -267174090), pn = new X(null, "content-type", "content-type", -508222634), qn = new A(null, "meta63466", "meta63466", 293259543, null), rn = new X(null, "external-scripts", "external-scripts", -699280105), sn = new X(null, "http", 
"http", 382524695), tn = new X(null, "timeslot-function-calls-msec", "timeslot-function-calls-msec", 189712759), un = new X(null, "oauth-token", "oauth-token", 311415191), vn = new X(null, "context", "context", -830191113), wn = new X(null, "post", "post", 269697687), xn = new A("cljs.spec", "cat", "cljs.spec/cat", 850003863, null), yn = new X(null, "options-out", "options-out", 781271031), zn = new A(null, "rform", "rform", -1420499912, null), An = new X(null, "pred-forms", "pred-forms", 172611832), 
Bn = new A(null, "req", "req", 1314083224, null), Cn = new X(null, "error", "error", -978969032), Dn = new X(null, "eval_context", "eval_context", 1307295352), En = new A(null, "meta69128", "meta69128", 396955352, null), Fn = new X("klipse.plugin", "comment-str", "klipse.plugin/comment-str", 1428350840), Gn = new X(null, "cancel", "cancel", -1964088360), Hn = new X(null, "exception", "exception", -335277064), In = new X(null, "scrollbarStyle", "scrollbarStyle", -963515367), Jn = new X("cljs.spec", 
"gfn", "cljs.spec/gfn", -432034727), Kn = new X(null, "uri", "uri", -774711847), Ln = new X(null, "tag", "tag", -1290361223), Mn = new X(null, "anchor", "anchor", 1549638489), Nn = new X(null, "decoding", "decoding", -568180903), Rn = new X(null, "server-name", "server-name", -1012104295), Sn = new X(null, "put", "put", 1299772570), Tn = new X(null, "json", "json", 1279968570), Un = new A(null, "quote", "quote", 1377916282, null), Vn = new X(null, "timeout", "timeout", -318625318), Wn = new X(null, 
"eval-fn", "eval-fn", -1111644294), Xn = new X(null, "query", "query", -1288509510), Yn = new X(null, "transit-opts", "transit-opts", 1104386010), Zn = new X(null, "query-string", "query-string", -1018845061), $n = new A(null, "id", "id", 252129435, null), ao = new X(null, "progress", "progress", 244323547), bo = new X(null, "out-editor-options", "out-editor-options", -95308421), co = new X(null, "hierarchy", "hierarchy", -1053470341), eo = new X(null, "body", "body", -2049205669), Zi = new X(null, 
"alt-impl", "alt-impl", 670969595), fo = new A("cljs.spec", "fspec", "cljs.spec/fspec", 982220571, null), go = new A(null, "specs", "specs", -1227865028, null), ho = new X(null, "array-buffer", "array-buffer", 519008380), io = new A(null, "req-keys", "req-keys", -2140116548, null), jo = new X(null, "download", "download", -300081668), ko = new X(null, "edn-params", "edn-params", 894273052), lo = new X("cljs.spec", "op", "cljs.spec/op", 939378204), kj = new X(null, "keywordize-keys", "keywordize-keys", 
1310784252), mo = new X("cljs.spec", "v", "cljs.spec/v", -1491964132), no = new X(null, "basic-auth", "basic-auth", -673163332), oo = new A(null, "deref", "deref", 1494944732, null), po = new X(null, "codemirror_options_in", "codemirror_options_in", -1220877316), qo = new X("klipse.plugin", "editor-in-mode", "klipse.plugin/editor-in-mode", -880426851), ro = new X(null, "multipart-params", "multipart-params", -1033508707), so = new X("klipse.plugin", "editor-out-mode", "klipse.plugin/editor-out-mode", 
724274461), to = new X(null, "custom-error", "custom-error", -1565161123), uo = new A(null, "opt-specs", "opt-specs", 1255626077, null), vo = new X(null, "no-result", "no-result", 1702657437), wo = new X(null, "scheme", "scheme", 90199613), xo = new A("cljs.core", "or", "cljs.core/or", 1201033885, null), yo = new X(null, "trace-redirects", "trace-redirects", -1149427907), zo = new X(null, "keywordize-keys?", "keywordize-keys?", -254545987), Ao = new X(null, "direction", "direction", -633359395), 
Bo = new X(null, "eval-context", "eval-context", 536255614), Co = new X(null, "eval_idle_msec", "eval_idle_msec", 1104296094), Do = new X(null, "access-denied", "access-denied", 959449406), Eo = new X(null, "upload", "upload", -255769218), Fo = new X(null, "request-method", "request-method", 1764796830), Go = new X(null, "forms", "forms", 2045992350), Ho = new X(null, "dom", "dom", -1236537922), Io = new X(null, "cmd-chan", "cmd-chan", -1229050306), Jo = new A(null, "meta63569", "meta63569", 396838654, 
null), Ko = new X(null, "ps", "ps", 292358046), Lo = new X(null, "remove-ending-comments?", "remove-ending-comments?", 1247259614), Mo = new X(null, "max-eval-duration", "max-eval-duration", -1241643010), No = new A(null, "k-\x3es", "k-\x3es", -1685112801, null), Oo = new A(null, "p__68509", "p__68509", -234401729, null), Po = new X(null, "codemirror-options-in", "codemirror-options-in", -1261564801), Qo = new X("cljs.spec", "kvs-\x3emap", "cljs.spec/kvs-\x3emap", -1189105441), Ro = new X(null, "compiledCode", 
"compiledCode", -1391179489), So = new X("klipse.plugin", "dom-element", "klipse.plugin/dom-element", -271611585), To = new X(null, "html", "html", -998796897), Uo = new X(null, "accept", "accept", 1874130431), Vo = new X(null, "opt", "opt", -794706369), Wo = new X(null, "text", "text", -1790561697), Xo = new X(null, "data", "data", -232669377), Yo = new A(null, "pred-forms", "pred-forms", 1813143359, null), Zo = new A(null, "f", "f", 43394975, null), $o = new X(null, "default-editor", "default-editor", 
758164479);
function ap(a, b) {
  for (var c = new jb, d = D(b);;) {
    if (null != d) {
      c.append("" + y(G(d))), d = H(d), null != d && c.append(a);
    } else {
      return c.toString();
    }
  }
}
function bp(a) {
  return 2 > O(a) ? a.toUpperCase() : [y(a.substring(0, 1).toUpperCase()), y(a.substring(1).toLowerCase())].join("");
}
function cp(a, b) {
  if (0 >= b || b >= 2 + O(a)) {
    return Ge.j(ch(ze("", vg.j(y, D(a)))), "");
  }
  if (w(sf ? jd(1, b) : rf.call(null, 1, b))) {
    return new T(null, 1, 5, W, [a], null);
  }
  if (w(sf ? jd(2, b) : rf.call(null, 2, b))) {
    return new T(null, 2, 5, W, ["", a], null);
  }
  var c = b - 2;
  return Ge.j(ch(ze("", fh(ch(vg.j(y, D(a))), 0, c))), a.substring(c));
}
function dp(a, b) {
  return ep(a, b, 0);
}
function ep(a, b, c) {
  if ("/(?:)/" === "" + y(b)) {
    b = cp(a, c);
  } else {
    if (1 > c) {
      b = ch(("" + y(a)).split(b));
    } else {
      a: {
        for (var d = c, e = He;;) {
          if (1 === d) {
            b = Ge.j(e, a);
            break a;
          }
          var f = Oi(b, a);
          if (null != f) {
            var g = a.indexOf(f), f = a.substring(g + O(f)), d = d - 1, e = Ge.j(e, a.substring(0, g));
            a = f;
          } else {
            b = Ge.j(e, a);
            break a;
          }
        }
      }
    }
  }
  if (0 === c && 1 < O(b)) {
    a: {
      for (c = b;;) {
        if ("" === (null == c ? null : Yc(c))) {
          c = null == c ? null : Zc(c);
        } else {
          break a;
        }
      }
    }
  } else {
    c = b;
  }
  return c;
}
function fp(a) {
  return Ba(a);
}
function gp(a) {
  return ya(Ma(a));
}
;function hp(a) {
  return Gg.j(dg, Dg(ig.j(ic, Fe), a));
}
function ip(a) {
  return Qe(a) ? a : Gc(ae, a);
}
function jp(a) {
  return Ni(/\s*;.*/, a);
}
;if ("undefined" === typeof kp) {
  var kp, lp = dg;
  kp = og ? og(lp) : ng.call(null, lp);
}
if ("undefined" === typeof mp) {
  var mp = new u(null, 4, [wl, 50, tn, 1E3, sl, 5, ok, 10], null)
}
;var Yb = function() {
  function a(a) {
    var c = null;
    if (0 < arguments.length) {
      for (var c = 0, e = Array(arguments.length - 0);c < e.length;) {
        e[c] = arguments[c + 0], ++c;
      }
      c = new F(e, 0);
    }
    return b.call(this, c);
  }
  function b(a) {
    return console.log.apply(console, wc ? vc(a) : uc.call(null, a));
  }
  a.L = 0;
  a.J = function(a) {
    a = D(a);
    return b(a);
  };
  a.B = b;
  return a;
}(), Zb = function() {
  function a(a) {
    var c = null;
    if (0 < arguments.length) {
      for (var c = 0, e = Array(arguments.length - 0);c < e.length;) {
        e[c] = arguments[c + 0], ++c;
      }
      c = new F(e, 0);
    }
    return b.call(this, c);
  }
  function b(a) {
    return console.error.apply(console, wc ? vc(a) : uc.call(null, a));
  }
  a.L = 0;
  a.J = function(a) {
    a = D(a);
    return b(a);
  };
  a.B = b;
  return a;
}(), np = P([wl, 100], 0), op = null != np && (np.w & 64 || q === np.M) ? Vf(pg, np) : np, mp = Ai.B(P([mp, op], 0));
console.info("Klipse ", "5.3.2");
console.info("Clojurescript ", "1.9.293");
var pp, qp, rp, sp = function sp(b, c) {
  if (null != b && null != b.Ce) {
    return b.Ce(0, c);
  }
  var d = sp[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = sp._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("ReadPort.take!", b);
}, tp = function tp(b, c, d) {
  if (null != b && null != b.Xd) {
    return b.Xd(0, c, d);
  }
  var e = tp[p(null == b ? null : b)];
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  e = tp._;
  if (null != e) {
    return e.l ? e.l(b, c, d) : e.call(null, b, c, d);
  }
  throw qc("WritePort.put!", b);
}, up = function up(b) {
  if (null != b && null != b.Wd) {
    return b.Wd();
  }
  var c = up[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = up._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("Channel.close!", b);
}, vp = function vp(b) {
  if (null != b && null != b.nb) {
    return b.nb(b);
  }
  var c = vp[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = vp._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("Handler.active?", b);
}, wp = function wp(b) {
  if (null != b && null != b.hb) {
    return b.hb(b);
  }
  var c = wp[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = wp._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("Handler.commit", b);
}, xp = function xp(b, c) {
  if (null != b && null != b.vf) {
    return b.vf(0, c);
  }
  var d = xp[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = xp._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("Buffer.add!*", b);
}, yp = function yp(b) {
  for (var c = [], d = arguments.length, e = 0;;) {
    if (e < d) {
      c.push(arguments[e]), e += 1;
    } else {
      break;
    }
  }
  switch(c.length) {
    case 1:
      return yp.h(arguments[0]);
    case 2:
      return yp.j(arguments[0], arguments[1]);
    default:
      throw Error([y("Invalid arity: "), y(c.length)].join(""));;
  }
};
yp.h = function(a) {
  return a;
};
yp.j = function(a, b) {
  if (null == b) {
    throw Error("Assert failed: (not (nil? itm))");
  }
  return xp(a, b);
};
yp.L = 2;
function zp(a, b, c, d, e) {
  for (var f = 0;;) {
    if (f < e) {
      c[d + f] = a[b + f], f += 1;
    } else {
      break;
    }
  }
}
function Ap(a, b, c, d) {
  this.head = a;
  this.ba = b;
  this.length = c;
  this.o = d;
}
Ap.prototype.pop = function() {
  if (0 === this.length) {
    return null;
  }
  var a = this.o[this.ba];
  this.o[this.ba] = null;
  this.ba = (this.ba + 1) % this.o.length;
  --this.length;
  return a;
};
Ap.prototype.unshift = function(a) {
  this.o[this.head] = a;
  this.head = (this.head + 1) % this.o.length;
  this.length += 1;
  return null;
};
function Bp(a, b) {
  a.length + 1 === a.o.length && a.resize();
  a.unshift(b);
}
Ap.prototype.resize = function() {
  var a = Array(2 * this.o.length);
  return this.ba < this.head ? (zp(this.o, this.ba, a, 0, this.length), this.ba = 0, this.head = this.length, this.o = a) : this.ba > this.head ? (zp(this.o, this.ba, a, 0, this.o.length - this.ba), zp(this.o, 0, a, this.o.length - this.ba, this.head), this.ba = 0, this.head = this.length, this.o = a) : this.ba === this.head ? (this.head = this.ba = 0, this.o = a) : null;
};
function Cp(a, b) {
  for (var c = a.length, d = 0;;) {
    if (d < c) {
      var e = a.pop();
      (b.h ? b.h(e) : b.call(null, e)) && a.unshift(e);
      d += 1;
    } else {
      break;
    }
  }
}
function Dp(a) {
  if (!(0 < a)) {
    throw Error([y("Assert failed: "), y("Can't create a ring buffer of size 0"), y("\n"), y("(\x3e n 0)")].join(""));
  }
  return new Ap(0, 0, 0, Array(a));
}
function Ep(a, b) {
  this.Y = a;
  this.n = b;
  this.w = 2;
  this.K = 0;
}
function Fp(a) {
  return a.Y.length === a.n;
}
Ep.prototype.vf = function(a, b) {
  Bp(this.Y, b);
  return this;
};
Ep.prototype.ja = function() {
  return this.Y.length;
};
if ("undefined" === typeof Gp) {
  var Gp = {}
}
;var Hp;
a: {
  var Jp = ca.navigator;
  if (Jp) {
    var Kp = Jp.userAgent;
    if (Kp) {
      Hp = Kp;
      break a;
    }
  }
  Hp = "";
}
function Lp(a) {
  return -1 != Hp.indexOf(a);
}
;function Mp() {
  return (Lp("Chrome") || Lp("CriOS")) && !Lp("Edge");
}
;function Np(a) {
  ca.setTimeout(function() {
    throw a;
  }, 0);
}
function Op(a) {
  !ja(ca.setImmediate) || ca.Window && ca.Window.prototype && !Lp("Edge") && ca.Window.prototype.setImmediate == ca.setImmediate ? (Pp || (Pp = Qp()), Pp(a)) : ca.setImmediate(a);
}
var Pp;
function Qp() {
  var a = ca.MessageChannel;
  "undefined" === typeof a && "undefined" !== typeof window && window.postMessage && window.addEventListener && !Lp("Presto") && (a = function() {
    var a = document.createElement("IFRAME");
    a.style.display = "none";
    a.src = "";
    document.documentElement.appendChild(a);
    var b = a.contentWindow, a = b.document;
    a.open();
    a.write("");
    a.close();
    var c = "callImmediate" + Math.random(), d = "file:" == b.location.protocol ? "*" : b.location.protocol + "//" + b.location.host, a = sa(function(a) {
      if (("*" == d || a.origin == d) && a.data == c) {
        this.port1.onmessage();
      }
    }, this);
    b.addEventListener("message", a, !1);
    this.port1 = {};
    this.port2 = {postMessage:function() {
      b.postMessage(c, d);
    }};
  });
  if ("undefined" !== typeof a && !Lp("Trident") && !Lp("MSIE")) {
    var b = new a, c = {}, d = c;
    b.port1.onmessage = function() {
      if (da(c.next)) {
        c = c.next;
        var a = c.jd;
        c.jd = null;
        a();
      }
    };
    return function(a) {
      d.next = {jd:a};
      d = d.next;
      b.port2.postMessage(0);
    };
  }
  return "undefined" !== typeof document && "onreadystatechange" in document.createElement("SCRIPT") ? function(a) {
    var b = document.createElement("SCRIPT");
    b.onreadystatechange = function() {
      b.onreadystatechange = null;
      b.parentNode.removeChild(b);
      b = null;
      a();
      a = null;
    };
    document.documentElement.appendChild(b);
  } : function(a) {
    ca.setTimeout(a, 0);
  };
}
;var Rp = Dp(32), Sp = !1, Tp = !1;
function Up() {
  Sp = !0;
  Tp = !1;
  for (var a = 0;;) {
    var b = Rp.pop();
    if (null != b && (b.v ? b.v() : b.call(null), 1024 > a)) {
      a += 1;
      continue;
    }
    break;
  }
  Sp = !1;
  return 0 < Rp.length ? Vp.v ? Vp.v() : Vp.call(null) : null;
}
function Vp() {
  var a = Tp;
  if (w(w(a) ? Sp : a)) {
    return null;
  }
  Tp = !0;
  return Op(Up);
}
function Wp(a) {
  Bp(Rp, a);
  return Vp();
}
function Xp(a, b) {
  setTimeout(a, b);
}
;var Yp;
function Zp(a) {
  "undefined" === typeof Yp && (Yp = function(a, c) {
    this.G = a;
    this.Fg = c;
    this.w = 425984;
    this.K = 0;
  }, Yp.prototype.T = function(a, c) {
    return new Yp(this.G, c);
  }, Yp.prototype.S = function() {
    return this.Fg;
  }, Yp.prototype.ld = function() {
    return this.G;
  }, Yp.cc = function() {
    return new T(null, 2, 5, W, [Jm, Lj], null);
  }, Yp.Db = !0, Yp.ob = "cljs.core.async.impl.channels/t_cljs$core$async$impl$channels62461", Yp.Rb = function(a, c) {
    return td(c, "cljs.core.async.impl.channels/t_cljs$core$async$impl$channels62461");
  });
  return new Yp(a, dg);
}
function $p(a, b) {
  this.jb = a;
  this.G = b;
}
function aq(a) {
  return vp(a.jb);
}
var bq = function bq(b) {
  if (null != b && null != b.uf) {
    return b.uf();
  }
  var c = bq[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = bq._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("MMC.abort", b);
};
function cq(a, b, c, d, e, f, g) {
  this.Lc = a;
  this.$d = b;
  this.tc = c;
  this.Zd = d;
  this.Y = e;
  this.closed = f;
  this.ub = g;
}
cq.prototype.uf = function() {
  for (;;) {
    var a = this.tc.pop();
    if (null != a) {
      var b = a.jb, c = a.G;
      if (b.nb(null)) {
        var d = b.hb(null);
        Wp(function(a) {
          return function() {
            return a.h ? a.h(!0) : a.call(null, !0);
          };
        }(d, b, c, a, this));
      } else {
        continue;
      }
    }
    break;
  }
  Cp(this.tc, hg());
  return up(this);
};
cq.prototype.Xd = function(a, b, c) {
  var d = this;
  if (null == b) {
    throw Error([y("Assert failed: "), y("Can't put nil in on a channel"), y("\n"), y("(not (nil? val))")].join(""));
  }
  if ((a = d.closed) || !c.nb(null)) {
    return Zp(!a);
  }
  if (w(function() {
    var a = d.Y;
    return w(a) ? kc(Fp(d.Y)) : a;
  }())) {
    c.hb(null);
    for (c = le(d.ub.j ? d.ub.j(d.Y, b) : d.ub.call(null, d.Y, b));;) {
      if (0 < d.Lc.length && 0 < O(d.Y)) {
        var e = d.Lc.pop();
        if (e.nb(null)) {
          var f = e.hb(null), g = d.Y.Y.pop();
          Wp(function(a, b) {
            return function() {
              return a.h ? a.h(b) : a.call(null, b);
            };
          }(f, g, e, c, a, this));
        } else {
          continue;
        }
      }
      break;
    }
    c && bq(this);
    return Zp(!0);
  }
  e = function() {
    for (;;) {
      var a = d.Lc.pop();
      if (w(a)) {
        if (w(a.nb(null))) {
          return a;
        }
      } else {
        return null;
      }
    }
  }();
  if (w(e)) {
    return f = wp(e), c.hb(null), Wp(function(a) {
      return function() {
        return a.h ? a.h(b) : a.call(null, b);
      };
    }(f, e, a, this)), Zp(!0);
  }
  64 < d.Zd ? (d.Zd = 0, Cp(d.tc, aq)) : d.Zd += 1;
  if (w(c.vd(null))) {
    if (!(1024 > d.tc.length)) {
      throw Error([y("Assert failed: "), y([y("No more than "), y(1024), y(" pending puts are allowed on a single channel."), y(" Consider using a windowed buffer.")].join("")), y("\n"), y("(\x3c (.-length puts) impl/MAX-QUEUE-SIZE)")].join(""));
    }
    Bp(d.tc, new $p(c, b));
  }
  return null;
};
cq.prototype.Ce = function(a, b) {
  var c = this;
  if (b.nb(null)) {
    if (null != c.Y && 0 < O(c.Y)) {
      for (var d = b.hb(null), e = Zp(c.Y.Y.pop());;) {
        if (!w(Fp(c.Y))) {
          var f = c.tc.pop();
          if (null != f) {
            var g = f.jb, k = f.G;
            if (g.nb(null)) {
              var l = g.hb(null);
              b.hb(null);
              Wp(function(a) {
                return function() {
                  return a.h ? a.h(!0) : a.call(null, !0);
                };
              }(l, g, k, f, d, e, this));
              le(c.ub.j ? c.ub.j(c.Y, k) : c.ub.call(null, c.Y, k)) && bq(this);
            }
            continue;
          }
        }
        break;
      }
      return e;
    }
    d = function() {
      for (;;) {
        var a = c.tc.pop();
        if (w(a)) {
          if (vp(a.jb)) {
            return a;
          }
        } else {
          return null;
        }
      }
    }();
    if (w(d)) {
      return e = wp(d.jb), b.hb(null), Wp(function(a) {
        return function() {
          return a.h ? a.h(!0) : a.call(null, !0);
        };
      }(e, d, this)), Zp(d.G);
    }
    if (w(c.closed)) {
      return w(c.Y) && (c.ub.h ? c.ub.h(c.Y) : c.ub.call(null, c.Y)), w(function() {
        var a = b.nb(null);
        return w(a) ? b.hb(null) : a;
      }()) ? (d = function() {
        var a = c.Y;
        return w(a) ? 0 < O(c.Y) : a;
      }(), d = w(d) ? c.Y.Y.pop() : null, Zp(d)) : null;
    }
    64 < c.$d ? (c.$d = 0, Cp(c.Lc, vp)) : c.$d += 1;
    if (w(b.vd(null))) {
      if (!(1024 > c.Lc.length)) {
        throw Error([y("Assert failed: "), y([y("No more than "), y(1024), y(" pending takes are allowed on a single channel.")].join("")), y("\n"), y("(\x3c (.-length takes) impl/MAX-QUEUE-SIZE)")].join(""));
      }
      Bp(c.Lc, b);
    }
  }
  return null;
};
cq.prototype.Wd = function() {
  var a = this;
  if (!a.closed) {
    for (a.closed = !0, w(function() {
      var b = a.Y;
      return w(b) ? 0 === a.tc.length : b;
    }()) && (a.ub.h ? a.ub.h(a.Y) : a.ub.call(null, a.Y));;) {
      var b = a.Lc.pop();
      if (null != b) {
        if (b.nb(null)) {
          var c = b.hb(null), d = w(function() {
            var b = a.Y;
            return w(b) ? 0 < O(a.Y) : b;
          }()) ? a.Y.Y.pop() : null;
          Wp(function(a, b) {
            return function() {
              return a.h ? a.h(b) : a.call(null, b);
            };
          }(c, d, b, this));
        }
      } else {
        break;
      }
    }
  }
  return null;
};
function dq(a) {
  console.log(a);
  return null;
}
function eq(a, b) {
  var c = (w(null) ? null : dq).call(null, b);
  return null == c ? a : yp.j(a, c);
}
function fq(a) {
  return new cq(Dp(32), 0, Dp(32), 0, a, !1, function() {
    return function(a) {
      return function() {
        function b(b, c) {
          try {
            return a.j ? a.j(b, c) : a.call(null, b, c);
          } catch (k) {
            return eq(b, k);
          }
        }
        function d(b) {
          try {
            return a.h ? a.h(b) : a.call(null, b);
          } catch (g) {
            return eq(b, g);
          }
        }
        var e = null, e = function(a, c) {
          switch(arguments.length) {
            case 1:
              return d.call(this, a);
            case 2:
              return b.call(this, a, c);
          }
          throw Error("Invalid arity: " + arguments.length);
        };
        e.h = d;
        e.j = b;
        return e;
      }();
    }(w(null) ? null.h ? null.h(yp) : null.call(null, yp) : yp);
  }());
}
;var gq;
function hq(a) {
  "undefined" === typeof gq && (gq = function(a, c) {
    this.zd = a;
    this.Gg = c;
    this.w = 393216;
    this.K = 0;
  }, gq.prototype.T = function(a, c) {
    return new gq(this.zd, c);
  }, gq.prototype.S = function() {
    return this.Gg;
  }, gq.prototype.nb = function() {
    return !0;
  }, gq.prototype.vd = function() {
    return !0;
  }, gq.prototype.hb = function() {
    return this.zd;
  }, gq.cc = function() {
    return new T(null, 2, 5, W, [Zo, qn], null);
  }, gq.Db = !0, gq.ob = "cljs.core.async.impl.ioc-helpers/t_cljs$core$async$impl$ioc_helpers63465", gq.Rb = function(a, c) {
    return td(c, "cljs.core.async.impl.ioc-helpers/t_cljs$core$async$impl$ioc_helpers63465");
  });
  return new gq(a, dg);
}
function iq(a) {
  try {
    return a[0].call(null, a);
  } catch (b) {
    throw b instanceof Object && a[6].Wd(), b;
  }
}
function jq(a, b, c) {
  c = c.Ce(0, hq(function(c) {
    a[2] = c;
    a[1] = b;
    return iq(a);
  }));
  return w(c) ? (a[2] = L.h ? L.h(c) : L.call(null, c), a[1] = b, Z) : null;
}
function kq(a, b, c, d) {
  c = c.Xd(0, d, hq(function(c) {
    a[2] = c;
    a[1] = b;
    return iq(a);
  }));
  return w(c) ? (a[2] = L.h ? L.h(c) : L.call(null, c), a[1] = b, Z) : null;
}
function lq(a, b) {
  var c = a[6];
  null != b && c.Xd(0, b, hq(function() {
    return function() {
      return null;
    };
  }(c)));
  c.Wd();
  return c;
}
function mq(a, b, c, d, e, f, g, k) {
  this.Bb = a;
  this.Cb = b;
  this.Gb = c;
  this.Fb = d;
  this.Lb = e;
  this.ta = f;
  this.ca = g;
  this.F = k;
  this.w = 2229667594;
  this.K = 8192;
}
h = mq.prototype;
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  switch(b instanceof X ? b.fb : null) {
    case "catch-block":
      return this.Bb;
    case "catch-exception":
      return this.Cb;
    case "finally-block":
      return this.Gb;
    case "continue-block":
      return this.Fb;
    case "prev":
      return this.Lb;
    default:
      return C.l(this.ca, b, c);
  }
};
h.W = function(a, b, c) {
  return Qi(b, function() {
    return function(a) {
      return Qi(b, Xi, "", " ", "", c, a);
    };
  }(this), "#cljs.core.async.impl.ioc-helpers.ExceptionFrame{", ", ", "}", c, Rf.j(new T(null, 5, 5, W, [new T(null, 2, 5, W, [Bl, this.Bb], null), new T(null, 2, 5, W, [Um, this.Cb], null), new T(null, 2, 5, W, [Pk, this.Gb], null), new T(null, 2, 5, W, [gn, this.Fb], null), new T(null, 2, 5, W, [bn, this.Lb], null)], null), this.ca));
};
h.mb = function() {
  return new th(0, this, 5, new T(null, 5, 5, W, [Bl, Um, Pk, gn, bn], null), w(this.ca) ? Ld(this.ca) : bg());
};
h.S = function() {
  return this.ta;
};
h.Xa = function() {
  return new mq(this.Bb, this.Cb, this.Gb, this.Fb, this.Lb, this.ta, this.ca, this.F);
};
h.ja = function() {
  return 5 + O(this.ca);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = uf(this);
};
h.I = function(a, b) {
  var c;
  c = w(b) ? (c = this.constructor === b.constructor) ? sh(this, b) : c : b;
  return w(c) ? !0 : !1;
};
h.Tc = function(a, b) {
  return cf(new Ci(null, new u(null, 5, [Pk, null, Bl, null, Um, null, bn, null, gn, null], null), null), b) ? Le.j(Be(Gg.j(dg, this), this.ta), b) : new mq(this.Bb, this.Cb, this.Gb, this.Fb, this.Lb, this.ta, ag(Le.j(this.ca, b)), null);
};
h.Qb = function(a, b, c) {
  return w(Y.j ? Y.j(Bl, b) : Y.call(null, Bl, b)) ? new mq(c, this.Cb, this.Gb, this.Fb, this.Lb, this.ta, this.ca, null) : w(Y.j ? Y.j(Um, b) : Y.call(null, Um, b)) ? new mq(this.Bb, c, this.Gb, this.Fb, this.Lb, this.ta, this.ca, null) : w(Y.j ? Y.j(Pk, b) : Y.call(null, Pk, b)) ? new mq(this.Bb, this.Cb, c, this.Fb, this.Lb, this.ta, this.ca, null) : w(Y.j ? Y.j(gn, b) : Y.call(null, gn, b)) ? new mq(this.Bb, this.Cb, this.Gb, c, this.Lb, this.ta, this.ca, null) : w(Y.j ? Y.j(bn, b) : Y.call(null, 
  bn, b)) ? new mq(this.Bb, this.Cb, this.Gb, this.Fb, c, this.ta, this.ca, null) : new mq(this.Bb, this.Cb, this.Gb, this.Fb, this.Lb, this.ta, Je.l(this.ca, b, c), null);
};
h.ea = function() {
  return D(Rf.j(new T(null, 5, 5, W, [new T(null, 2, 5, W, [Bl, this.Bb], null), new T(null, 2, 5, W, [Um, this.Cb], null), new T(null, 2, 5, W, [Pk, this.Gb], null), new T(null, 2, 5, W, [gn, this.Fb], null), new T(null, 2, 5, W, [bn, this.Lb], null)], null), this.ca));
};
h.T = function(a, b) {
  return new mq(this.Bb, this.Cb, this.Gb, this.Fb, this.Lb, b, this.ca, this.F);
};
h.fa = function(a, b) {
  return Ve(b) ? Rc(this, Ic.j(b, 0), Ic.j(b, 1)) : xc(Gc, this, b);
};
function nq(a, b, c, d, e) {
  a[4] = new mq(b, c, d, e, a[4], null, null, null);
}
function oq(a) {
  for (;;) {
    var b = a[4], c = Bl.h(b), d = Um.h(b), e = a[5];
    if (w(function() {
      var a = e;
      return w(a) ? kc(b) : a;
    }())) {
      throw e;
    }
    if (w(function() {
      var a = e;
      return w(a) ? (a = c, w(a) ? J.j(Ok, d) || e instanceof d : a) : a;
    }())) {
      a[1] = c;
      a[2] = e;
      a[5] = null;
      a[4] = Je.B(b, Bl, null, P([Um, null], 0));
      break;
    }
    if (w(function() {
      var a = e;
      return w(a) ? kc(c) && kc(Pk.h(b)) : a;
    }())) {
      a[4] = bn.h(b);
    } else {
      if (w(function() {
        var a = e;
        return w(a) ? (a = kc(c)) ? Pk.h(b) : a : a;
      }())) {
        a[1] = Pk.h(b);
        a[4] = Je.l(b, Pk, null);
        break;
      }
      if (w(function() {
        var a = kc(e);
        return a ? Pk.h(b) : a;
      }())) {
        a[1] = Pk.h(b);
        a[4] = Je.l(b, Pk, null);
        break;
      }
      if (kc(e) && kc(Pk.h(b))) {
        a[1] = gn.h(b);
        a[4] = bn.h(b);
        break;
      }
      throw Error("No matching clause");
    }
  }
}
;function pq(a, b, c) {
  this.key = a;
  this.G = b;
  this.forward = c;
  this.w = 2155872256;
  this.K = 0;
}
pq.prototype.ea = function() {
  var a = this.key;
  return Gc(Gc(ae, this.G), a);
};
pq.prototype.W = function(a, b, c) {
  return Qi(b, Xi, "[", " ", "]", c, this);
};
function qq(a, b, c) {
  c = Array(c + 1);
  for (var d = 0;;) {
    if (d < c.length) {
      c[d] = null, d += 1;
    } else {
      break;
    }
  }
  return new pq(a, b, c);
}
function rq(a, b, c, d) {
  for (;;) {
    if (0 > c) {
      return a;
    }
    a: {
      for (;;) {
        var e = a.forward[c];
        if (w(e)) {
          if (e.key < b) {
            a = e;
          } else {
            break a;
          }
        } else {
          break a;
        }
      }
    }
    null != d && (d[c] = a);
    --c;
  }
}
function sq(a, b) {
  this.header = a;
  this.level = b;
  this.w = 2155872256;
  this.K = 0;
}
sq.prototype.put = function(a, b) {
  var c = Array(15), d = rq(this.header, a, this.level, c).forward[0];
  if (null != d && d.key === a) {
    return d.G = b;
  }
  a: {
    for (d = 0;;) {
      if (.5 > Math.random() && 15 > d) {
        d += 1;
      } else {
        break a;
      }
    }
  }
  if (d > this.level) {
    for (var e = this.level + 1;;) {
      if (e <= d + 1) {
        c[e] = this.header, e += 1;
      } else {
        break;
      }
    }
    this.level = d;
  }
  for (d = qq(a, b, Array(d));;) {
    return 0 <= this.level ? (c = c[0].forward, d.forward[0] = c[0], c[0] = d) : null;
  }
};
sq.prototype.remove = function(a) {
  var b = Array(15), c = rq(this.header, a, this.level, b).forward[0];
  if (null != c && c.key === a) {
    for (a = 0;;) {
      if (a <= this.level) {
        var d = b[a].forward;
        d[a] === c && (d[a] = c.forward[a]);
        a += 1;
      } else {
        break;
      }
    }
    for (;;) {
      if (0 < this.level && null == this.header.forward[this.level]) {
        --this.level;
      } else {
        return null;
      }
    }
  } else {
    return null;
  }
};
function tq(a) {
  for (var b = uq, c = b.header, d = b.level;;) {
    if (0 > d) {
      return c === b.header ? null : c;
    }
    var e;
    a: {
      for (e = c;;) {
        e = e.forward[d];
        if (null == e) {
          e = null;
          break a;
        }
        if (e.key >= a) {
          break a;
        }
      }
    }
    null != e ? (--d, c = e) : --d;
  }
}
sq.prototype.ea = function() {
  return function(a) {
    return function c(d) {
      return new Hf(null, function() {
        return function() {
          return null == d ? null : ze(new T(null, 2, 5, W, [d.key, d.G], null), c(d.forward[0]));
        };
      }(a), null, null);
    };
  }(this)(this.header.forward[0]);
};
sq.prototype.W = function(a, b, c) {
  return Qi(b, function() {
    return function(a) {
      return Qi(b, Xi, "", " ", "", c, a);
    };
  }(this), "{", ", ", "}", c, this);
};
var uq = new sq(qq(null, null, 0), 0);
function vq(a) {
  var b = (new Date).valueOf() + a, c = tq(b), d = w(w(c) ? c.key < b + 10 : c) ? c.G : null;
  if (w(d)) {
    return d;
  }
  var e = fq(null);
  uq.put(b, e);
  Xp(function(a, b, c) {
    return function() {
      uq.remove(c);
      return up(a);
    };
  }(e, d, b, c), a);
  return e;
}
;function wq(a) {
  "undefined" === typeof pp && (pp = function(a, c, d) {
    this.zd = a;
    this.jf = c;
    this.Hg = d;
    this.w = 393216;
    this.K = 0;
  }, pp.prototype.T = function(a, c) {
    return new pp(this.zd, this.jf, c);
  }, pp.prototype.S = function() {
    return this.Hg;
  }, pp.prototype.nb = function() {
    return !0;
  }, pp.prototype.vd = function() {
    return this.jf;
  }, pp.prototype.hb = function() {
    return this.zd;
  }, pp.cc = function() {
    return new T(null, 3, 5, W, [Zo, rk, Jo], null);
  }, pp.Db = !0, pp.ob = "cljs.core.async/t_cljs$core$async63568", pp.Rb = function(a, c) {
    return td(c, "cljs.core.async/t_cljs$core$async63568");
  });
  return new pp(a, !0, dg);
}
function xq(a) {
  a = J.j(a, 0) ? null : a;
  if (w(null) && !w(a)) {
    throw Error([y("Assert failed: "), y("buffer must be supplied when transducer is"), y("\n"), y("buf-or-n")].join(""));
  }
  a = "number" === typeof a ? new Ep(Dp(a), a) : a;
  return fq(a);
}
function yq(a, b) {
  var c = sp(a, wq(b));
  if (w(c)) {
    var d = L.h ? L.h(c) : L.call(null, c);
    w(!0) ? b.h ? b.h(d) : b.call(null, d) : Wp(function(a) {
      return function() {
        return b.h ? b.h(a) : b.call(null, a);
      };
    }(d, c));
  }
  return null;
}
var zq = wq(function() {
  return null;
});
function Aq(a, b) {
  var c = tp(a, b, zq);
  return w(c) ? L.h ? L.h(c) : L.call(null, c) : !0;
}
function Bq(a) {
  for (var b = Array(a), c = 0;;) {
    if (c < a) {
      b[c] = 0, c += 1;
    } else {
      break;
    }
  }
  for (c = 1;;) {
    if (J.j(c, a)) {
      return b;
    }
    var d = Math.floor(Math.random() * c);
    b[c] = b[d];
    b[d] = c;
    c += 1;
  }
}
function Cq() {
  var a = og ? og(!0) : ng.call(null, !0);
  "undefined" === typeof qp && (qp = function(a, c) {
    this.bc = a;
    this.Ig = c;
    this.w = 393216;
    this.K = 0;
  }, qp.prototype.T = function() {
    return function(a, c) {
      return new qp(this.bc, c);
    };
  }(a), qp.prototype.S = function() {
    return function() {
      return this.Ig;
    };
  }(a), qp.prototype.nb = function() {
    return function() {
      return L.h ? L.h(this.bc) : L.call(null, this.bc);
    };
  }(a), qp.prototype.vd = function() {
    return function() {
      return !0;
    };
  }(a), qp.prototype.hb = function() {
    return function() {
      rg.j ? rg.j(this.bc, null) : rg.call(null, this.bc, null);
      return !0;
    };
  }(a), qp.cc = function() {
    return function() {
      return new T(null, 2, 5, W, [dm, Dm], null);
    };
  }(a), qp.Db = !0, qp.ob = "cljs.core.async/t_cljs$core$async63613", qp.Rb = function() {
    return function(a, c) {
      return td(c, "cljs.core.async/t_cljs$core$async63613");
    };
  }(a));
  return new qp(a, dg);
}
function Dq(a, b) {
  "undefined" === typeof rp && (rp = function(a, b, e) {
    this.bc = a;
    this.jd = b;
    this.Jg = e;
    this.w = 393216;
    this.K = 0;
  }, rp.prototype.T = function(a, b) {
    return new rp(this.bc, this.jd, b);
  }, rp.prototype.S = function() {
    return this.Jg;
  }, rp.prototype.nb = function() {
    return vp(this.bc);
  }, rp.prototype.vd = function() {
    return !0;
  }, rp.prototype.hb = function() {
    wp(this.bc);
    return this.jd;
  }, rp.cc = function() {
    return new T(null, 3, 5, W, [dm, Qk, Tm], null);
  }, rp.Db = !0, rp.ob = "cljs.core.async/t_cljs$core$async63619", rp.Rb = function(a, b) {
    return td(b, "cljs.core.async/t_cljs$core$async63619");
  });
  return new rp(a, b, dg);
}
function Eq(a, b, c) {
  var d = Cq(), e = O(b), f = Bq(e), g = Gm.h(c), k = function() {
    for (var c = 0;;) {
      if (c < e) {
        var k = w(g) ? c : f[c], n = te(b, k), t = Ve(n) ? n.h ? n.h(0) : n.call(null, 0) : null, r = w(t) ? function() {
          var b = n.h ? n.h(1) : n.call(null, 1);
          return tp(t, b, Dq(d, function(b, c, d, e, f) {
            return function(b) {
              b = new T(null, 2, 5, W, [b, f], null);
              return a.h ? a.h(b) : a.call(null, b);
            };
          }(c, b, k, n, t, d, e, f, g)));
        }() : sp(n, Dq(d, function(b, c, d) {
          return function(b) {
            b = new T(null, 2, 5, W, [b, d], null);
            return a.h ? a.h(b) : a.call(null, b);
          };
        }(c, k, n, t, d, e, f, g)));
        if (w(r)) {
          return Zp(new T(null, 2, 5, W, [L.h ? L.h(r) : L.call(null, r), function() {
            var a = t;
            return w(a) ? a : n;
          }()], null));
        }
        c += 1;
      } else {
        return null;
      }
    }
  }();
  return w(k) ? k : cf(c, Ok) && (k = function() {
    var a = vp(d);
    return w(a) ? wp(d) : a;
  }(), w(k)) ? Zp(new T(null, 2, 5, W, [Ok.h(c), Ok], null)) : null;
}
function Fq(a, b) {
  var c = xq(1);
  Wp(function(c) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (v) {
                    if (v instanceof Object) {
                      b[5] = v, oq(b), c = Z;
                    } else {
                      throw v;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(c) {
            var d = c[1];
            return 7 === d ? (c[2] = c[2], c[1] = 3, Z) : 1 === d ? (c[2] = null, c[1] = 2, Z) : 4 === d ? (d = c[2], c[7] = d, c[1] = w(null == d) ? 5 : 6, Z) : 13 === d ? (c[2] = null, c[1] = 14, Z) : 6 === d ? (d = c[7], kq(c, 11, b, d)) : 3 === d ? lq(c, c[2]) : 12 === d ? (c[2] = null, c[1] = 2, Z) : 2 === d ? jq(c, 4, a) : 11 === d ? (c[1] = w(c[2]) ? 12 : 13, Z) : 9 === d ? (c[2] = null, c[1] = 10, Z) : 5 === d ? (c[1] = w(!0) ? 8 : 9, Z) : 14 === d || 10 === d ? (c[2] = c[2], c[1] = 7, Z) : 
            8 === d ? (d = up(b), c[2] = d, c[1] = 10, Z) : null;
          };
        }(c), c);
      }(), f = function() {
        var a = d.v ? d.v() : d.call(null);
        a[6] = c;
        return a;
      }();
      return iq(f);
    };
  }(c));
  return b;
}
function Gq(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  return Hq(arguments[0], arguments[1], arguments[2], 3 < b.length ? new F(b.slice(3), 0, null) : null);
}
function Hq(a, b, c, d) {
  var e = null != d && (d.w & 64 || q === d.M) ? Vf(pg, d) : d;
  a[1] = b;
  b = Eq(function() {
    return function(b) {
      a[2] = b;
      return iq(a);
    };
  }(d, e, e), c, e);
  return w(b) ? (a[2] = L.h ? L.h(b) : L.call(null, b), Z) : null;
}
function Iq(a, b) {
  return Jq(a, b);
}
function Jq(a, b) {
  var c = ch(b), d = xq(null), e = O(c), f = Of(e), g = xq(1), k = og ? og(null) : ng.call(null, null), l = Hg(function(a, b, c, d, e, f) {
    return function(g) {
      return function(a, b, c, d, e, f) {
        return function(a) {
          d[g] = a;
          return 0 === sg.j(f, of) ? Aq(e, d.slice(0)) : null;
        };
      }(a, b, c, d, e, f);
    };
  }(c, d, e, f, g, k), new Ki(null, 0, e, 1, null)), m = xq(1);
  Wp(function(b, c, d, e, f, g, k, l) {
    return function() {
      var m = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (ia) {
                    if (ia instanceof Object) {
                      b[5] = ia, oq(b), c = Z;
                    } else {
                      throw ia;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(b, c, d, e, f, g, k, l) {
          return function(b) {
            var f = b[1];
            if (7 === f) {
              return b[2] = null, b[1] = 8, Z;
            }
            if (1 === f) {
              return b[2] = null, b[1] = 2, Z;
            }
            if (4 === f) {
              return f = b[7], b[1] = w(f < e) ? 6 : 7, Z;
            }
            if (15 === f) {
              return b[2] = b[2], b[1] = 3, Z;
            }
            if (13 === f) {
              return f = up(d), b[2] = f, b[1] = 15, Z;
            }
            if (6 === f) {
              return b[2] = null, b[1] = 11, Z;
            }
            if (3 === f) {
              return lq(b, b[2]);
            }
            if (12 === f) {
              var f = b[2], m = fg(ic, f);
              b[8] = f;
              b[1] = w(m) ? 13 : 14;
              return Z;
            }
            return 2 === f ? (f = rg.j ? rg.j(k, e) : rg.call(null, k, e), b[9] = f, b[7] = 0, b[2] = null, b[1] = 4, Z) : 11 === f ? (f = b[7], nq(b, 10, Object, null, 9), m = c.h ? c.h(f) : c.call(null, f), f = l.h ? l.h(f) : l.call(null, f), f = yq(m, f), b[2] = f, oq(b), Z) : 9 === f ? (f = b[7], m = b[2], b[7] = f + 1, b[10] = m, b[2] = null, b[1] = 4, Z) : 5 === f ? (b[11] = b[2], jq(b, 12, g)) : 14 === f ? (f = b[8], f = Vf(a, f), kq(b, 16, d, f)) : 16 === f ? (b[12] = b[2], b[2] = null, b[1] = 
            2, Z) : 10 === f ? (m = b[2], f = sg.j(k, of), b[13] = m, b[2] = f, oq(b), Z) : 8 === f ? (b[2] = b[2], b[1] = 5, Z) : null;
          };
        }(b, c, d, e, f, g, k, l), b, c, d, e, f, g, k, l);
      }(), n = function() {
        var a = m.v ? m.v() : m.call(null);
        a[6] = b;
        return a;
      }();
      return iq(n);
    };
  }(m, c, d, e, f, g, k, l));
  return d;
}
;var Kq, Lq = dg;
Kq = og ? og(Lq) : ng.call(null, Lq);
var Mq, Nq = dg;
Mq = og ? og(Nq) : ng.call(null, Nq);
function Oq(a) {
  return [y("https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.21.0/mode/"), y(a), y("/"), y(a), y(".min.js")].join("");
}
function Pq(a, b, c) {
  console.info("register-mode: ", a, b);
  sg.H(Kq, Je, b, a);
  sg.H(Mq, Je, a, c);
}
;function Qq(a) {
  return w(a.inspect) ? a.inspect.call(a) : "" + y(a);
}
var Rq = new u(null, 5, [fn, "scheme", Bk, "scheme", Wn, function(a) {
  var b = xq(null), c = new BiwaScheme.Interpreter(function(a) {
    return function(b) {
      return Aq(a, "" + y(b));
    };
  }(b));
  window.exp = a;
  Aq(b, Qq(c.evaluate.call(c, a)));
  return b;
}, rn, new T(null, 2, 5, W, [Oq("scheme"), "https://viebel.github.io/klipse/repo/js/biwascheme-0.6.6-min.js"], null), Kl, ";"], null);
Pq("eval-scheme", "selector_eval_scheme", Rq);
function Sq(a) {
  if (a.Hb && "function" == typeof a.Hb) {
    return a.Hb();
  }
  if (ha(a)) {
    return a.split("");
  }
  if (ga(a)) {
    for (var b = [], c = a.length, d = 0;d < c;d++) {
      b.push(a[d]);
    }
    return b;
  }
  return Ta(a);
}
function Tq(a, b, c) {
  if (a.forEach && "function" == typeof a.forEach) {
    a.forEach(b, c);
  } else {
    if (ga(a) || ha(a)) {
      ob(a, b, c);
    } else {
      var d;
      if (a.rb && "function" == typeof a.rb) {
        d = a.rb();
      } else {
        if (a.Hb && "function" == typeof a.Hb) {
          d = void 0;
        } else {
          if (ga(a) || ha(a)) {
            d = [];
            for (var e = a.length, f = 0;f < e;f++) {
              d.push(f);
            }
          } else {
            d = Ua(a);
          }
        }
      }
      for (var e = Sq(a), f = e.length, g = 0;g < f;g++) {
        b.call(c, e[g], d && d[g], a);
      }
    }
  }
}
;function Uq(a, b) {
  this.Tb = {};
  this.$a = [];
  this.qa = 0;
  var c = arguments.length;
  if (1 < c) {
    if (c % 2) {
      throw Error("Uneven number of arguments");
    }
    for (var d = 0;d < c;d += 2) {
      this.set(arguments[d], arguments[d + 1]);
    }
  } else {
    a && this.addAll(a);
  }
}
h = Uq.prototype;
h.Ef = function() {
  return this.qa;
};
h.Hb = function() {
  Vq(this);
  for (var a = [], b = 0;b < this.$a.length;b++) {
    a.push(this.Tb[this.$a[b]]);
  }
  return a;
};
h.rb = function() {
  Vq(this);
  return this.$a.concat();
};
h.xd = function(a) {
  return Wq(this.Tb, a);
};
h.eb = function(a, b) {
  if (this === a) {
    return !0;
  }
  if (this.qa != a.Ef()) {
    return !1;
  }
  var c = b || Xq;
  Vq(this);
  for (var d, e = 0;d = this.$a[e];e++) {
    if (!c(this.get(d), a.get(d))) {
      return !1;
    }
  }
  return !0;
};
function Xq(a, b) {
  return a === b;
}
h.Ne = function() {
  return 0 == this.qa;
};
h.clear = function() {
  this.Tb = {};
  this.qa = this.$a.length = 0;
};
h.remove = function(a) {
  return Wq(this.Tb, a) ? (delete this.Tb[a], this.qa--, this.$a.length > 2 * this.qa && Vq(this), !0) : !1;
};
function Vq(a) {
  if (a.qa != a.$a.length) {
    for (var b = 0, c = 0;b < a.$a.length;) {
      var d = a.$a[b];
      Wq(a.Tb, d) && (a.$a[c++] = d);
      b++;
    }
    a.$a.length = c;
  }
  if (a.qa != a.$a.length) {
    for (var e = {}, c = b = 0;b < a.$a.length;) {
      d = a.$a[b], Wq(e, d) || (a.$a[c++] = d, e[d] = 1), b++;
    }
    a.$a.length = c;
  }
}
h.get = function(a, b) {
  return Wq(this.Tb, a) ? this.Tb[a] : b;
};
h.set = function(a, b) {
  Wq(this.Tb, a) || (this.qa++, this.$a.push(a));
  this.Tb[a] = b;
};
h.addAll = function(a) {
  var b;
  a instanceof Uq ? (b = a.rb(), a = a.Hb()) : (b = Ua(a), a = Ta(a));
  for (var c = 0;c < b.length;c++) {
    this.set(b[c], a[c]);
  }
};
h.forEach = function(a, b) {
  for (var c = this.rb(), d = 0;d < c.length;d++) {
    var e = c[d], f = this.get(e);
    a.call(b, f, e, this);
  }
};
h.clone = function() {
  return new Uq(this);
};
function Wq(a, b) {
  return Object.prototype.hasOwnProperty.call(a, b);
}
;var Yq = /^(?:([^:/?#.]+):)?(?:\/\/(?:([^/?#]*)@)?([^/#?]*?)(?::([0-9]+))?(?=[/#?]|$))?([^?#]+)?(?:\?([^#]*))?(?:#(.*))?$/;
function Zq(a, b) {
  if (a) {
    for (var c = a.split("\x26"), d = 0;d < c.length;d++) {
      var e = c[d].indexOf("\x3d"), f, g = null;
      0 <= e ? (f = c[d].substring(0, e), g = c[d].substring(e + 1)) : f = c[d];
      b(f, g ? decodeURIComponent(g.replace(/\+/g, " ")) : "");
    }
  }
}
;function $q(a, b) {
  this.ac = this.wc = this.Wb = "";
  this.sc = null;
  this.mc = this.Vb = "";
  this.wb = this.xg = !1;
  var c;
  if (a instanceof $q) {
    this.wb = da(b) ? b : a.wb, ar(this, a.Wb), c = a.wc, br(this), this.wc = c, cr(this, a.ac), dr(this, a.sc), er(this, a.Vb), fr(this, a.yb.clone()), c = a.mc, br(this), this.mc = c;
  } else {
    if (a && (c = String(a).match(Yq))) {
      this.wb = !!b;
      ar(this, c[1] || "", !0);
      var d = c[2] || "";
      br(this);
      this.wc = gr(d);
      cr(this, c[3] || "", !0);
      dr(this, c[4]);
      er(this, c[5] || "", !0);
      fr(this, c[6] || "", !0);
      c = c[7] || "";
      br(this);
      this.mc = gr(c);
    } else {
      this.wb = !!b, this.yb = new hr(null, 0, this.wb);
    }
  }
}
$q.prototype.toString = function() {
  var a = [], b = this.Wb;
  b && a.push(ir(b, jr, !0), ":");
  var c = this.ac;
  if (c || "file" == b) {
    a.push("//"), (b = this.wc) && a.push(ir(b, jr, !0), "@"), a.push(encodeURIComponent(String(c)).replace(/%25([0-9a-fA-F]{2})/g, "%$1")), c = this.sc, null != c && a.push(":", String(c));
  }
  if (c = this.Vb) {
    this.ac && "/" != c.charAt(0) && a.push("/"), a.push(ir(c, "/" == c.charAt(0) ? kr : lr, !0));
  }
  (c = this.yb.toString()) && a.push("?", c);
  (c = this.mc) && a.push("#", ir(c, mr));
  return a.join("");
};
$q.prototype.resolve = function(a) {
  var b = this.clone(), c = !!a.Wb;
  c ? ar(b, a.Wb) : c = !!a.wc;
  if (c) {
    var d = a.wc;
    br(b);
    b.wc = d;
  } else {
    c = !!a.ac;
  }
  c ? cr(b, a.ac) : c = null != a.sc;
  d = a.Vb;
  if (c) {
    dr(b, a.sc);
  } else {
    if (c = !!a.Vb) {
      if ("/" != d.charAt(0)) {
        if (this.ac && !this.Vb) {
          d = "/" + d;
        } else {
          var e = b.Vb.lastIndexOf("/");
          -1 != e && (d = b.Vb.substr(0, e + 1) + d);
        }
      }
      e = d;
      if (".." == e || "." == e) {
        d = "";
      } else {
        if (-1 != e.indexOf("./") || -1 != e.indexOf("/.")) {
          for (var d = 0 == e.lastIndexOf("/", 0), e = e.split("/"), f = [], g = 0;g < e.length;) {
            var k = e[g++];
            "." == k ? d && g == e.length && f.push("") : ".." == k ? ((1 < f.length || 1 == f.length && "" != f[0]) && f.pop(), d && g == e.length && f.push("")) : (f.push(k), d = !0);
          }
          d = f.join("/");
        } else {
          d = e;
        }
      }
    }
  }
  c ? er(b, d) : c = "" !== a.yb.toString();
  c ? fr(b, gr(a.yb.toString())) : c = !!a.mc;
  c && (a = a.mc, br(b), b.mc = a);
  return b;
};
$q.prototype.clone = function() {
  return new $q(this);
};
function ar(a, b, c) {
  br(a);
  a.Wb = c ? gr(b, !0) : b;
  a.Wb && (a.Wb = a.Wb.replace(/:$/, ""));
}
function cr(a, b, c) {
  br(a);
  a.ac = c ? gr(b, !0) : b;
}
function dr(a, b) {
  br(a);
  if (b) {
    b = Number(b);
    if (isNaN(b) || 0 > b) {
      throw Error("Bad port number " + b);
    }
    a.sc = b;
  } else {
    a.sc = null;
  }
}
function er(a, b, c) {
  br(a);
  a.Vb = c ? gr(b, !0) : b;
}
function fr(a, b, c) {
  br(a);
  b instanceof hr ? (a.yb = b, a.yb.Xe(a.wb)) : (c || (b = ir(b, nr)), a.yb = new hr(b, 0, a.wb));
}
function or(a, b, c) {
  br(a);
  fa(c) || (c = [String(c)]);
  pr(a.yb, b, c);
}
function br(a) {
  if (a.xg) {
    throw Error("Tried to modify a read-only Uri");
  }
}
$q.prototype.Xe = function(a) {
  this.wb = a;
  this.yb && this.yb.Xe(a);
  return this;
};
function gr(a, b) {
  return a ? b ? decodeURI(a.replace(/%25/g, "%2525")) : decodeURIComponent(a) : "";
}
function ir(a, b, c) {
  return ha(a) ? (a = encodeURI(a).replace(b, qr), c && (a = a.replace(/%25([0-9a-fA-F]{2})/g, "%$1")), a) : null;
}
function qr(a) {
  a = a.charCodeAt(0);
  return "%" + (a >> 4 & 15).toString(16) + (a & 15).toString(16);
}
var jr = /[#\/\?@]/g, lr = /[\#\?:]/g, kr = /[\#\?]/g, nr = /[\#\?@]/g, mr = /#/g;
function hr(a, b, c) {
  this.qa = this.Aa = null;
  this.qb = a || null;
  this.wb = !!c;
}
function rr(a) {
  a.Aa || (a.Aa = new Uq, a.qa = 0, a.qb && Zq(a.qb, function(b, c) {
    a.add(decodeURIComponent(b.replace(/\+/g, " ")), c);
  }));
}
h = hr.prototype;
h.Ef = function() {
  rr(this);
  return this.qa;
};
h.add = function(a, b) {
  rr(this);
  this.qb = null;
  a = sr(this, a);
  var c = this.Aa.get(a);
  c || this.Aa.set(a, c = []);
  c.push(b);
  this.qa += 1;
  return this;
};
h.remove = function(a) {
  rr(this);
  a = sr(this, a);
  return this.Aa.xd(a) ? (this.qb = null, this.qa -= this.Aa.get(a).length, this.Aa.remove(a)) : !1;
};
h.clear = function() {
  this.Aa = this.qb = null;
  this.qa = 0;
};
h.Ne = function() {
  rr(this);
  return 0 == this.qa;
};
h.xd = function(a) {
  rr(this);
  a = sr(this, a);
  return this.Aa.xd(a);
};
h.rb = function() {
  rr(this);
  for (var a = this.Aa.Hb(), b = this.Aa.rb(), c = [], d = 0;d < b.length;d++) {
    for (var e = a[d], f = 0;f < e.length;f++) {
      c.push(b[d]);
    }
  }
  return c;
};
h.Hb = function(a) {
  rr(this);
  var b = [];
  if (ha(a)) {
    this.xd(a) && (b = sb(b, this.Aa.get(sr(this, a))));
  } else {
    a = this.Aa.Hb();
    for (var c = 0;c < a.length;c++) {
      b = sb(b, a[c]);
    }
  }
  return b;
};
h.set = function(a, b) {
  rr(this);
  this.qb = null;
  a = sr(this, a);
  this.xd(a) && (this.qa -= this.Aa.get(a).length);
  this.Aa.set(a, [b]);
  this.qa += 1;
  return this;
};
h.get = function(a, b) {
  var c = a ? this.Hb(a) : [];
  return 0 < c.length ? String(c[0]) : b;
};
function pr(a, b, c) {
  a.remove(b);
  0 < c.length && (a.qb = null, a.Aa.set(sr(a, b), tb(c)), a.qa += c.length);
}
h.toString = function() {
  if (this.qb) {
    return this.qb;
  }
  if (!this.Aa) {
    return "";
  }
  for (var a = [], b = this.Aa.rb(), c = 0;c < b.length;c++) {
    for (var d = b[c], e = encodeURIComponent(String(d)), d = this.Hb(d), f = 0;f < d.length;f++) {
      var g = e;
      "" !== d[f] && (g += "\x3d" + encodeURIComponent(String(d[f])));
      a.push(g);
    }
  }
  return this.qb = a.join("\x26");
};
h.clone = function() {
  var a = new hr;
  a.qb = this.qb;
  this.Aa && (a.Aa = this.Aa.clone(), a.qa = this.qa);
  return a;
};
function sr(a, b) {
  var c = String(b);
  a.wb && (c = c.toLowerCase());
  return c;
}
h.Xe = function(a) {
  a && !this.wb && (rr(this), this.qb = null, this.Aa.forEach(function(a, c) {
    var b = c.toLowerCase();
    c != b && (this.remove(c), pr(this, b, a));
  }, this));
  this.wb = a;
};
h.extend = function(a) {
  for (var b = 0;b < arguments.length;b++) {
    Tq(arguments[b], function(a, b) {
      this.add(b, a);
    }, this);
  }
};
function tr(a) {
  a.prototype.then = a.prototype.then;
  a.prototype.$goog_Thenable = !0;
}
function ur(a) {
  if (!a) {
    return !1;
  }
  try {
    return !!a.$goog_Thenable;
  } catch (b) {
    return !1;
  }
}
;function vr(a, b, c) {
  this.Bg = c;
  this.sg = a;
  this.eh = b;
  this.ge = 0;
  this.ee = null;
}
vr.prototype.get = function() {
  var a;
  0 < this.ge ? (this.ge--, a = this.ee, this.ee = a.next, a.next = null) : a = this.sg();
  return a;
};
vr.prototype.put = function(a) {
  this.eh(a);
  this.ge < this.Bg && (this.ge++, a.next = this.ee, this.ee = a);
};
function wr() {
  this.pe = this.ed = null;
}
var yr = new vr(function() {
  return new xr;
}, function(a) {
  a.reset();
}, 100);
wr.prototype.add = function(a, b) {
  var c = yr.get();
  c.set(a, b);
  this.pe ? this.pe.next = c : this.ed = c;
  this.pe = c;
};
wr.prototype.remove = function() {
  var a = null;
  this.ed && (a = this.ed, this.ed = this.ed.next, this.ed || (this.pe = null), a.next = null);
  return a;
};
function xr() {
  this.next = this.scope = this.Sb = null;
}
xr.prototype.set = function(a, b) {
  this.Sb = a;
  this.scope = b;
  this.next = null;
};
xr.prototype.reset = function() {
  this.next = this.scope = this.Sb = null;
};
function zr(a, b) {
  Ar || Br();
  Cr || (Ar(), Cr = !0);
  Dr.add(a, b);
}
var Ar;
function Br() {
  if (ca.Promise && ca.Promise.resolve) {
    var a = ca.Promise.resolve(void 0);
    Ar = function() {
      a.then(Er);
    };
  } else {
    Ar = function() {
      Op(Er);
    };
  }
}
var Cr = !1, Dr = new wr;
function Er() {
  for (var a;a = Dr.remove();) {
    try {
      a.Sb.call(a.scope);
    } catch (b) {
      Np(b);
    }
    yr.put(a);
  }
  Cr = !1;
}
;function Fr(a, b) {
  this.Nb = Gr;
  this.dc = void 0;
  this.Qc = this.jc = this.Va = null;
  this.de = this.He = !1;
  if (a != ea) {
    try {
      var c = this;
      a.call(b, function(a) {
        Hr(c, Ir, a);
      }, function(a) {
        if (!(a instanceof Jr)) {
          try {
            if (a instanceof Error) {
              throw a;
            }
            throw Error("Promise rejected.");
          } catch (e) {
          }
        }
        Hr(c, Kr, a);
      });
    } catch (d) {
      Hr(this, Kr, d);
    }
  }
}
var Gr = 0, Ir = 2, Kr = 3;
function Lr() {
  this.next = this.context = this.ad = this.Ld = this.yc = null;
  this.Rd = !1;
}
Lr.prototype.reset = function() {
  this.context = this.ad = this.Ld = this.yc = null;
  this.Rd = !1;
};
var Mr = new vr(function() {
  return new Lr;
}, function(a) {
  a.reset();
}, 100);
function Nr(a, b, c) {
  var d = Mr.get();
  d.Ld = a;
  d.ad = b;
  d.context = c;
  return d;
}
Fr.prototype.then = function(a, b, c) {
  return Or(this, ja(a) ? a : null, ja(b) ? b : null, c);
};
tr(Fr);
Fr.prototype.cancel = function(a) {
  this.Nb == Gr && zr(function() {
    var b = new Jr(a);
    Pr(this, b);
  }, this);
};
function Pr(a, b) {
  if (a.Nb == Gr) {
    if (a.Va) {
      var c = a.Va;
      if (c.jc) {
        for (var d = 0, e = null, f = null, g = c.jc;g && (g.Rd || (d++, g.yc == a && (e = g), !(e && 1 < d)));g = g.next) {
          e || (f = g);
        }
        e && (c.Nb == Gr && 1 == d ? Pr(c, b) : (f ? (d = f, d.next == c.Qc && (c.Qc = d), d.next = d.next.next) : Qr(c), Rr(c, e, Kr, b)));
      }
      a.Va = null;
    } else {
      Hr(a, Kr, b);
    }
  }
}
function Sr(a, b) {
  a.jc || a.Nb != Ir && a.Nb != Kr || Tr(a);
  a.Qc ? a.Qc.next = b : a.jc = b;
  a.Qc = b;
}
function Or(a, b, c, d) {
  var e = Nr(null, null, null);
  e.yc = new Fr(function(a, g) {
    e.Ld = b ? function(c) {
      try {
        var e = b.call(d, c);
        a(e);
      } catch (m) {
        g(m);
      }
    } : a;
    e.ad = c ? function(b) {
      try {
        var e = c.call(d, b);
        !da(e) && b instanceof Jr ? g(b) : a(e);
      } catch (m) {
        g(m);
      }
    } : g;
  });
  e.yc.Va = a;
  Sr(a, e);
  return e.yc;
}
Fr.prototype.hh = function(a) {
  this.Nb = Gr;
  Hr(this, Ir, a);
};
Fr.prototype.ih = function(a) {
  this.Nb = Gr;
  Hr(this, Kr, a);
};
function Hr(a, b, c) {
  if (a.Nb == Gr) {
    a === c && (b = Kr, c = new TypeError("Promise cannot resolve to itself"));
    a.Nb = 1;
    var d;
    a: {
      var e = c, f = a.hh, g = a.ih;
      if (e instanceof Fr) {
        Sr(e, Nr(f || ea, g || null, a)), d = !0;
      } else {
        if (ur(e)) {
          e.then(f, g, a), d = !0;
        } else {
          if (ka(e)) {
            try {
              var k = e.then;
              if (ja(k)) {
                Ur(e, k, f, g, a);
                d = !0;
                break a;
              }
            } catch (l) {
              g.call(a, l);
              d = !0;
              break a;
            }
          }
          d = !1;
        }
      }
    }
    d || (a.dc = c, a.Nb = b, a.Va = null, Tr(a), b != Kr || c instanceof Jr || Vr(a, c));
  }
}
function Ur(a, b, c, d, e) {
  function f(a) {
    k || (k = !0, d.call(e, a));
  }
  function g(a) {
    k || (k = !0, c.call(e, a));
  }
  var k = !1;
  try {
    b.call(a, g, f);
  } catch (l) {
    f(l);
  }
}
function Tr(a) {
  a.He || (a.He = !0, zr(a.vg, a));
}
function Qr(a) {
  var b = null;
  a.jc && (b = a.jc, a.jc = b.next, b.next = null);
  a.jc || (a.Qc = null);
  return b;
}
Fr.prototype.vg = function() {
  for (var a;a = Qr(this);) {
    Rr(this, a, this.Nb, this.dc);
  }
  this.He = !1;
};
function Rr(a, b, c, d) {
  if (c == Kr && b.ad && !b.Rd) {
    for (;a && a.de;a = a.Va) {
      a.de = !1;
    }
  }
  if (b.yc) {
    b.yc.Va = null, Wr(b, c, d);
  } else {
    try {
      b.Rd ? b.Ld.call(b.context) : Wr(b, c, d);
    } catch (e) {
      Xr.call(null, e);
    }
  }
  Mr.put(b);
}
function Wr(a, b, c) {
  b == Ir ? a.Ld.call(a.context, c) : a.ad && a.ad.call(a.context, c);
}
function Vr(a, b) {
  a.de = !0;
  zr(function() {
    a.de && Xr.call(null, b);
  });
}
var Xr = Np;
function Jr(a) {
  kb.call(this, a);
}
wa(Jr, kb);
Jr.prototype.name = "cancel";
/*
 Portions of this code are from MochiKit, received by
 The Closure Authors under the MIT license. All other code is Copyright
 2005-2009 The Closure Authors. All Rights Reserved.
*/
function Yr(a, b) {
  this.je = [];
  this.Lf = a;
  this.Af = b || null;
  this.Bd = this.Wc = !1;
  this.dc = void 0;
  this.Ye = this.Zf = this.ue = !1;
  this.me = 0;
  this.Va = null;
  this.ve = 0;
}
Yr.prototype.cancel = function(a) {
  if (this.Wc) {
    this.dc instanceof Yr && this.dc.cancel();
  } else {
    if (this.Va) {
      var b = this.Va;
      delete this.Va;
      a ? b.cancel(a) : (b.ve--, 0 >= b.ve && b.cancel());
    }
    this.Lf ? this.Lf.call(this.Af, this) : this.Ye = !0;
    this.Wc || (a = new Zr, $r(this), as(this, !1, a));
  }
};
Yr.prototype.yf = function(a, b) {
  this.ue = !1;
  as(this, a, b);
};
function as(a, b, c) {
  a.Wc = !0;
  a.dc = c;
  a.Bd = !b;
  bs(a);
}
function $r(a) {
  if (a.Wc) {
    if (!a.Ye) {
      throw new cs;
    }
    a.Ye = !1;
  }
}
function ds(a, b, c, d) {
  a.je.push([b, c, d]);
  a.Wc && bs(a);
}
Yr.prototype.then = function(a, b, c) {
  var d, e, f = new Fr(function(a, b) {
    d = a;
    e = b;
  });
  ds(this, d, function(a) {
    a instanceof Zr ? f.cancel() : e(a);
  });
  return f.then(a, b, c);
};
tr(Yr);
function es(a) {
  return pb(a.je, function(a) {
    return ja(a[1]);
  });
}
function bs(a) {
  if (a.me && a.Wc && es(a)) {
    var b = a.me, c = fs[b];
    c && (ca.clearTimeout(c.Fc), delete fs[b]);
    a.me = 0;
  }
  a.Va && (a.Va.ve--, delete a.Va);
  for (var b = a.dc, d = c = !1;a.je.length && !a.ue;) {
    var e = a.je.shift(), f = e[0], g = e[1], e = e[2];
    if (f = a.Bd ? g : f) {
      try {
        var k = f.call(e || a.Af, b);
        da(k) && (a.Bd = a.Bd && (k == b || k instanceof Error), a.dc = b = k);
        if (ur(b) || "function" === typeof ca.Promise && b instanceof ca.Promise) {
          d = !0, a.ue = !0;
        }
      } catch (l) {
        b = l, a.Bd = !0, es(a) || (c = !0);
      }
    }
  }
  a.dc = b;
  d && (k = sa(a.yf, a, !0), d = sa(a.yf, a, !1), b instanceof Yr ? (ds(b, k, d), b.Zf = !0) : b.then(k, d));
  c && (b = new gs(b), fs[b.Fc] = b, a.me = b.Fc);
}
function cs() {
  kb.call(this);
}
wa(cs, kb);
cs.prototype.message = "Deferred has already fired";
cs.prototype.name = "AlreadyCalledError";
function Zr() {
  kb.call(this);
}
wa(Zr, kb);
Zr.prototype.message = "Deferred was canceled";
Zr.prototype.name = "CanceledError";
function gs(a) {
  this.Fc = ca.setTimeout(sa(this.gh, this), 0);
  this.ae = a;
}
gs.prototype.gh = function() {
  delete fs[this.Fc];
  throw this.ae;
};
var fs = {};
function hs() {
  return Lp("iPhone") && !Lp("iPod") && !Lp("iPad");
}
;var is = Lp("Opera"), js = Lp("Trident") || Lp("MSIE"), ks = Lp("Edge"), ls = Lp("Gecko") && !(-1 != Hp.toLowerCase().indexOf("webkit") && !Lp("Edge")) && !(Lp("Trident") || Lp("MSIE")) && !Lp("Edge"), ms = -1 != Hp.toLowerCase().indexOf("webkit") && !Lp("Edge");
ms && Lp("Mobile");
Lp("Macintosh");
Lp("Windows");
Lp("Linux") || Lp("CrOS");
var ns = ca.navigator || null;
ns && (ns.appVersion || "").indexOf("X11");
Lp("Android");
hs();
Lp("iPad");
Lp("iPod");
function os() {
  var a = ca.document;
  return a ? a.documentMode : void 0;
}
var ps;
a: {
  var qs = "", rs = function() {
    var a = Hp;
    if (ls) {
      return /rv\:([^\);]+)(\)|;)/.exec(a);
    }
    if (ks) {
      return /Edge\/([\d\.]+)/.exec(a);
    }
    if (js) {
      return /\b(?:MSIE|rv)[: ]([^\);]+)(\)|;)/.exec(a);
    }
    if (ms) {
      return /WebKit\/(\S+)/.exec(a);
    }
    if (is) {
      return /(?:Version)[ \/]?(\S+)/.exec(a);
    }
  }();
  rs && (qs = rs ? rs[1] : "");
  if (js) {
    var ss = os();
    if (null != ss && ss > parseFloat(qs)) {
      ps = String(ss);
      break a;
    }
  }
  ps = qs;
}
var ts = {};
function us(a) {
  var b;
  if (!(b = ts[a])) {
    b = 0;
    for (var c = Ba(String(ps)).split("."), d = Ba(String(a)).split("."), e = Math.max(c.length, d.length), f = 0;0 == b && f < e;f++) {
      var g = c[f] || "", k = d[f] || "", l = RegExp("(\\d*)(\\D*)", "g"), m = RegExp("(\\d*)(\\D*)", "g");
      do {
        var n = l.exec(g) || ["", "", ""], t = m.exec(k) || ["", "", ""];
        if (0 == n[0].length && 0 == t[0].length) {
          break;
        }
        b = Oa(0 == n[1].length ? 0 : parseInt(n[1], 10), 0 == t[1].length ? 0 : parseInt(t[1], 10)) || Oa(0 == n[2].length, 0 == t[2].length) || Oa(n[2], t[2]);
      } while (0 == b);
    }
    b = ts[a] = 0 <= b;
  }
  return b;
}
var vs;
var ws = ca.document;
vs = ws && js ? os() || ("CSS1Compat" == ws.compatMode ? parseInt(ps, 10) : 5) : void 0;
var xs = !js || 9 <= Number(vs);
!ls && !js || js && 9 <= Number(vs) || ls && us("1.9.1");
js && us("9");
function ys(a, b) {
  Ra(b, function(b, d) {
    "style" == d ? a.style.cssText = b : "class" == d ? a.className = b : "for" == d ? a.htmlFor = b : zs.hasOwnProperty(d) ? a.setAttribute(zs[d], b) : 0 == d.lastIndexOf("aria-", 0) || 0 == d.lastIndexOf("data-", 0) ? a.setAttribute(d, b) : a[d] = b;
  });
}
var zs = {cellpadding:"cellPadding", cellspacing:"cellSpacing", colspan:"colSpan", frameborder:"frameBorder", height:"height", maxlength:"maxLength", nonce:"nonce", role:"role", rowspan:"rowSpan", type:"type", usemap:"useMap", valign:"vAlign", width:"width"};
function As(a, b, c) {
  var d = arguments, e = document, f = d[0], g = d[1];
  if (!xs && g && (g.name || g.type)) {
    f = ["\x3c", f];
    g.name && f.push(' name\x3d"', Ca(g.name), '"');
    if (g.type) {
      f.push(' type\x3d"', Ca(g.type), '"');
      var k = {};
      Wa(k, g);
      delete k.type;
      g = k;
    }
    f.push("\x3e");
    f = f.join("");
  }
  f = e.createElement(f);
  g && (ha(g) ? f.className = g : fa(g) ? f.className = g.join(" ") : ys(f, g));
  2 < d.length && Bs(e, f, d);
  return f;
}
function Bs(a, b, c) {
  function d(c) {
    c && b.appendChild(ha(c) ? a.createTextNode(c) : c);
  }
  for (var e = 2;e < c.length;e++) {
    var f = c[e];
    !ga(f) || ka(f) && 0 < f.nodeType ? d(f) : ob(Cs(f) ? tb(f) : f, d);
  }
}
function Ds(a, b) {
  if ("textContent" in a) {
    a.textContent = b;
  } else {
    if (3 == a.nodeType) {
      a.data = b;
    } else {
      if (a.firstChild && 3 == a.firstChild.nodeType) {
        for (;a.lastChild != a.firstChild;) {
          a.removeChild(a.lastChild);
        }
        a.firstChild.data = b;
      } else {
        for (var c;c = a.firstChild;) {
          a.removeChild(c);
        }
        a.appendChild((9 == a.nodeType ? a : a.ownerDocument || a.document).createTextNode(String(b)));
      }
    }
  }
}
function Cs(a) {
  if (a && "number" == typeof a.length) {
    if (ka(a)) {
      return "function" == typeof a.item || "string" == typeof a.item;
    }
    if (ja(a)) {
      return "function" == typeof a.item;
    }
  }
  return !1;
}
;function Es(a, b) {
  var c = b || {}, d = c.document || document, e = document.createElement("SCRIPT"), f = {Tf:e, vc:void 0}, g = new Yr(Fs, f), k = null, l = null != c.timeout ? c.timeout : 5E3;
  0 < l && (k = window.setTimeout(function() {
    Gs(e, !0);
    var b = new Hs(Is, "Timeout reached for loading script " + a);
    $r(g);
    as(g, !1, b);
  }, l), f.vc = k);
  e.onload = e.onreadystatechange = function() {
    e.readyState && "loaded" != e.readyState && "complete" != e.readyState || (Gs(e, c.bg || !1, k), $r(g), as(g, !0, null));
  };
  e.onerror = function() {
    Gs(e, !0, k);
    var b = new Hs(Js, "Error while loading script " + a);
    $r(g);
    as(g, !1, b);
  };
  f = c.attributes || {};
  Wa(f, {type:"text/javascript", charset:"UTF-8", src:a});
  ys(e, f);
  Ks(d).appendChild(e);
  return g;
}
function Ks(a) {
  var b = a.getElementsByTagName("HEAD");
  return b && 0 != b.length ? b[0] : a.documentElement;
}
function Fs() {
  if (this && this.Tf) {
    var a = this.Tf;
    a && "SCRIPT" == a.tagName && Gs(a, !0, this.vc);
  }
}
function Gs(a, b, c) {
  null != c && ca.clearTimeout(c);
  a.onload = ea;
  a.onerror = ea;
  a.onreadystatechange = ea;
  b && window.setTimeout(function() {
    a && a.parentNode && a.parentNode.removeChild(a);
  }, 0);
}
var Js = 0, Is = 1;
function Hs(a, b) {
  var c = "Jsloader error (code #" + a + ")";
  b && (c += ": " + b);
  kb.call(this, c);
  this.code = a;
}
wa(Hs, kb);
function Ls(a, b) {
  this.kh = new $q(a);
  this.ag = b ? b : "callback";
  this.vc = 5E3;
  this.Jf = "";
}
var Ms = 0;
Ls.prototype.send = function(a, b, c, d) {
  a = a || null;
  d = d || "_" + (Ms++).toString(36) + ta().toString(36);
  var e = "_callbacks___" + d, f = this.kh.clone();
  if (a) {
    for (var g in a) {
      a.hasOwnProperty && !a.hasOwnProperty(g) || or(f, g, a[g]);
    }
  }
  b && (ca[e] = Ns(d, b), or(f, this.ag, e));
  b = {timeout:this.vc, bg:!0};
  this.Jf && (b.attributes = {nonce:this.Jf});
  b = Es(f.toString(), b);
  ds(b, null, Os(d, a, c), void 0);
  return {Fc:d, Bf:b};
};
Ls.prototype.cancel = function(a) {
  a && (a.Bf && a.Bf.cancel(), a.Fc && Ps(a.Fc, !1));
};
function Os(a, b, c) {
  return function() {
    Ps(a, !1);
    c && c(b);
  };
}
function Ns(a, b) {
  return function(c) {
    Ps(a, !0);
    b.apply(void 0, arguments);
  };
}
function Ps(a, b) {
  var c = "_callbacks___" + a;
  if (ca[c]) {
    if (b) {
      try {
        delete ca[c];
      } catch (d) {
        ca[c] = void 0;
      }
    } else {
      ca[c] = ea;
    }
  }
}
;function Qs() {
  0 != Rs && la(this);
  this.Fe = this.Fe;
  this.Pg = this.Pg;
}
var Rs = 0;
Qs.prototype.Fe = !1;
var Ss = !js || 9 <= Number(vs), Ts = js && !us("9");
!ms || us("528");
ls && us("1.9b") || js && us("8") || is && us("9.5") || ms && us("528");
ls && !us("8") || js && us("9");
function Us(a, b) {
  this.type = a;
  this.currentTarget = this.target = b;
  this.defaultPrevented = this.Kc = !1;
  this.Rf = !0;
}
Us.prototype.stopPropagation = function() {
  this.Kc = !0;
};
Us.prototype.preventDefault = function() {
  this.defaultPrevented = !0;
  this.Rf = !1;
};
function Vs(a, b) {
  Us.call(this, a ? a.type : "");
  this.relatedTarget = this.currentTarget = this.target = null;
  this.charCode = this.keyCode = this.button = this.screenY = this.screenX = this.clientY = this.clientX = this.offsetY = this.offsetX = 0;
  this.metaKey = this.shiftKey = this.altKey = this.ctrlKey = !1;
  this.yd = this.state = null;
  a && this.Yc(a, b);
}
wa(Vs, Us);
Vs.prototype.Yc = function(a, b) {
  var c = this.type = a.type, d = a.changedTouches ? a.changedTouches[0] : null;
  this.target = a.target || a.srcElement;
  this.currentTarget = b;
  var e = a.relatedTarget;
  if (e) {
    if (ls) {
      var f;
      a: {
        try {
          yb(e.nodeName);
          f = !0;
          break a;
        } catch (g) {
        }
        f = !1;
      }
      f || (e = null);
    }
  } else {
    "mouseover" == c ? e = a.fromElement : "mouseout" == c && (e = a.toElement);
  }
  this.relatedTarget = e;
  null === d ? (this.offsetX = ms || void 0 !== a.offsetX ? a.offsetX : a.layerX, this.offsetY = ms || void 0 !== a.offsetY ? a.offsetY : a.layerY, this.clientX = void 0 !== a.clientX ? a.clientX : a.pageX, this.clientY = void 0 !== a.clientY ? a.clientY : a.pageY, this.screenX = a.screenX || 0, this.screenY = a.screenY || 0) : (this.clientX = void 0 !== d.clientX ? d.clientX : d.pageX, this.clientY = void 0 !== d.clientY ? d.clientY : d.pageY, this.screenX = d.screenX || 0, this.screenY = d.screenY || 
  0);
  this.button = a.button;
  this.keyCode = a.keyCode || 0;
  this.charCode = a.charCode || ("keypress" == c ? a.keyCode : 0);
  this.ctrlKey = a.ctrlKey;
  this.altKey = a.altKey;
  this.shiftKey = a.shiftKey;
  this.metaKey = a.metaKey;
  this.state = a.state;
  this.yd = a;
  a.defaultPrevented && this.preventDefault();
};
Vs.prototype.stopPropagation = function() {
  Vs.Vf.stopPropagation.call(this);
  this.yd.stopPropagation ? this.yd.stopPropagation() : this.yd.cancelBubble = !0;
};
Vs.prototype.preventDefault = function() {
  Vs.Vf.preventDefault.call(this);
  var a = this.yd;
  if (a.preventDefault) {
    a.preventDefault();
  } else {
    if (a.returnValue = !1, Ts) {
      try {
        if (a.ctrlKey || 112 <= a.keyCode && 123 >= a.keyCode) {
          a.keyCode = -1;
        }
      } catch (b) {
      }
    }
  }
};
var Ws = "closure_listenable_" + (1E6 * Math.random() | 0), Xs = 0;
function Ys(a, b, c, d, e) {
  this.listener = a;
  this.ie = null;
  this.src = b;
  this.type = c;
  this.hd = !!d;
  this.jb = e;
  this.key = ++Xs;
  this.bd = this.Td = !1;
}
function Zs(a) {
  a.bd = !0;
  a.listener = null;
  a.ie = null;
  a.src = null;
  a.jb = null;
}
;function $s(a) {
  this.src = a;
  this.sb = {};
  this.le = 0;
}
$s.prototype.add = function(a, b, c, d, e) {
  var f = a.toString();
  a = this.sb[f];
  a || (a = this.sb[f] = [], this.le++);
  var g = at(a, b, d, e);
  -1 < g ? (b = a[g], c || (b.Td = !1)) : (b = new Ys(b, this.src, f, !!d, e), b.Td = c, a.push(b));
  return b;
};
$s.prototype.remove = function(a, b, c, d) {
  a = a.toString();
  if (!(a in this.sb)) {
    return !1;
  }
  var e = this.sb[a];
  b = at(e, b, c, d);
  return -1 < b ? (Zs(e[b]), Array.prototype.splice.call(e, b, 1), 0 == e.length && (delete this.sb[a], this.le--), !0) : !1;
};
function bt(a, b) {
  var c = b.type;
  if (c in a.sb) {
    var d = a.sb[c], e = nb(d, b), f;
    (f = 0 <= e) && Array.prototype.splice.call(d, e, 1);
    f && (Zs(b), 0 == a.sb[c].length && (delete a.sb[c], a.le--));
  }
}
$s.prototype.Ke = function(a, b, c, d) {
  a = this.sb[a.toString()];
  var e = -1;
  a && (e = at(a, b, c, d));
  return -1 < e ? a[e] : null;
};
$s.prototype.hasListener = function(a, b) {
  var c = da(a), d = c ? a.toString() : "", e = da(b);
  return Sa(this.sb, function(a) {
    for (var f = 0;f < a.length;++f) {
      if (!(c && a[f].type != d || e && a[f].hd != b)) {
        return !0;
      }
    }
    return !1;
  });
};
function at(a, b, c, d) {
  for (var e = 0;e < a.length;++e) {
    var f = a[e];
    if (!f.bd && f.listener == b && f.hd == !!c && f.jb == d) {
      return e;
    }
  }
  return -1;
}
;var ct = "closure_lm_" + (1E6 * Math.random() | 0), dt = {}, et = 0;
function ft(a, b, c, d, e) {
  if (fa(b)) {
    for (var f = 0;f < b.length;f++) {
      ft(a, b[f], c, d, e);
    }
  } else {
    if (c = gt(c), a && a[Ws]) {
      ht(a, b, c, d, e);
    } else {
      if (!b) {
        throw Error("Invalid event type");
      }
      var f = !!d, g = it(a);
      g || (a[ct] = g = new $s(a));
      c = g.add(b, c, !1, d, e);
      if (!c.ie) {
        d = jt();
        c.ie = d;
        d.src = a;
        d.listener = c;
        if (a.addEventListener) {
          a.addEventListener(b.toString(), d, f);
        } else {
          if (a.attachEvent) {
            a.attachEvent(kt(b.toString()), d);
          } else {
            throw Error("addEventListener and attachEvent are unavailable.");
          }
        }
        et++;
      }
    }
  }
}
function jt() {
  var a = lt, b = Ss ? function(c) {
    return a.call(b.src, b.listener, c);
  } : function(c) {
    c = a.call(b.src, b.listener, c);
    if (!c) {
      return c;
    }
  };
  return b;
}
function mt(a, b, c, d, e) {
  if (fa(b)) {
    for (var f = 0;f < b.length;f++) {
      mt(a, b[f], c, d, e);
    }
  } else {
    c = gt(c), a && a[Ws] ? a.Cc.remove(String(b), c, d, e) : a && (a = it(a)) && (b = a.Ke(b, c, !!d, e)) && nt(b);
  }
}
function nt(a) {
  if ("number" != typeof a && a && !a.bd) {
    var b = a.src;
    if (b && b[Ws]) {
      bt(b.Cc, a);
    } else {
      var c = a.type, d = a.ie;
      b.removeEventListener ? b.removeEventListener(c, d, a.hd) : b.detachEvent && b.detachEvent(kt(c), d);
      et--;
      (c = it(b)) ? (bt(c, a), 0 == c.le && (c.src = null, b[ct] = null)) : Zs(a);
    }
  }
}
function kt(a) {
  return a in dt ? dt[a] : dt[a] = "on" + a;
}
function ot(a, b, c, d) {
  var e = !0;
  if (a = it(a)) {
    if (b = a.sb[b.toString()]) {
      for (b = b.concat(), a = 0;a < b.length;a++) {
        var f = b[a];
        f && f.hd == c && !f.bd && (f = pt(f, d), e = e && !1 !== f);
      }
    }
  }
  return e;
}
function pt(a, b) {
  var c = a.listener, d = a.jb || a.src;
  a.Td && nt(a);
  return c.call(d, b);
}
function lt(a, b) {
  if (a.bd) {
    return !0;
  }
  if (!Ss) {
    var c;
    if (!(c = b)) {
      a: {
        c = ["window", "event"];
        for (var d = ca, e;e = c.shift();) {
          if (null != d[e]) {
            d = d[e];
          } else {
            c = null;
            break a;
          }
        }
        c = d;
      }
    }
    e = c;
    c = new Vs(e, this);
    d = !0;
    if (!(0 > e.keyCode || void 0 != e.returnValue)) {
      a: {
        var f = !1;
        if (0 == e.keyCode) {
          try {
            e.keyCode = -1;
            break a;
          } catch (l) {
            f = !0;
          }
        }
        if (f || void 0 == e.returnValue) {
          e.returnValue = !0;
        }
      }
      e = [];
      for (f = c.currentTarget;f;f = f.parentNode) {
        e.push(f);
      }
      for (var f = a.type, g = e.length - 1;!c.Kc && 0 <= g;g--) {
        c.currentTarget = e[g];
        var k = ot(e[g], f, !0, c), d = d && k;
      }
      for (g = 0;!c.Kc && g < e.length;g++) {
        c.currentTarget = e[g], k = ot(e[g], f, !1, c), d = d && k;
      }
    }
    return d;
  }
  return pt(a, new Vs(b, this));
}
function it(a) {
  a = a[ct];
  return a instanceof $s ? a : null;
}
var qt = "__closure_events_fn_" + (1E9 * Math.random() >>> 0);
function gt(a) {
  if (ja(a)) {
    return a;
  }
  a[qt] || (a[qt] = function(b) {
    return a.handleEvent(b);
  });
  return a[qt];
}
;function rt() {
  Qs.call(this);
  this.Cc = new $s(this);
  this.Yf = this;
  this.Of = null;
}
wa(rt, Qs);
rt.prototype[Ws] = !0;
h = rt.prototype;
h.addEventListener = function(a, b, c, d) {
  ft(this, a, b, c, d);
};
h.removeEventListener = function(a, b, c, d) {
  mt(this, a, b, c, d);
};
h.dispatchEvent = function(a) {
  var b, c = this.Of;
  if (c) {
    for (b = [];c;c = c.Of) {
      b.push(c);
    }
  }
  var c = this.Yf, d = a.type || a;
  if (ha(a)) {
    a = new Us(a, c);
  } else {
    if (a instanceof Us) {
      a.target = a.target || c;
    } else {
      var e = a;
      a = new Us(d, c);
      Wa(a, e);
    }
  }
  var e = !0, f;
  if (b) {
    for (var g = b.length - 1;!a.Kc && 0 <= g;g--) {
      f = a.currentTarget = b[g], e = st(f, d, !0, a) && e;
    }
  }
  a.Kc || (f = a.currentTarget = c, e = st(f, d, !0, a) && e, a.Kc || (e = st(f, d, !1, a) && e));
  if (b) {
    for (g = 0;!a.Kc && g < b.length;g++) {
      f = a.currentTarget = b[g], e = st(f, d, !1, a) && e;
    }
  }
  return e;
};
function ht(a, b, c, d, e) {
  a.Cc.add(String(b), c, !1, d, e);
}
function st(a, b, c, d) {
  b = a.Cc.sb[String(b)];
  if (!b) {
    return !0;
  }
  b = b.concat();
  for (var e = !0, f = 0;f < b.length;++f) {
    var g = b[f];
    if (g && !g.bd && g.hd == c) {
      var k = g.listener, l = g.jb || g.src;
      g.Td && bt(a.Cc, g);
      e = !1 !== k.call(l, d) && e;
    }
  }
  return e && 0 != d.Rf;
}
h.Ke = function(a, b, c, d) {
  return this.Cc.Ke(String(a), b, c, d);
};
h.hasListener = function(a, b) {
  return this.Cc.hasListener(da(a) ? String(a) : void 0, b);
};
function tt(a, b, c) {
  if (ja(a)) {
    c && (a = sa(a, c));
  } else {
    if (a && "function" == typeof a.handleEvent) {
      a = sa(a.handleEvent, a);
    } else {
      throw Error("Invalid listener argument");
    }
  }
  return 2147483647 < Number(b) ? -1 : ca.setTimeout(a, b || 0);
}
;function ut(a, b, c, d, e) {
  this.reset(a, b, c, d, e);
}
ut.prototype.Cf = null;
var vt = 0;
ut.prototype.reset = function(a, b, c, d, e) {
  "number" == typeof e || vt++;
  d || ta();
  this.Id = a;
  this.Og = b;
  delete this.Cf;
};
ut.prototype.Uf = function(a) {
  this.Id = a;
};
function wt(a) {
  this.If = a;
  this.Ff = this.we = this.Id = this.Va = null;
}
function xt(a, b) {
  this.name = a;
  this.value = b;
}
xt.prototype.toString = function() {
  return this.name;
};
var yt = new xt("SEVERE", 1E3), zt = new xt("INFO", 800), At = new xt("CONFIG", 700), Bt = new xt("FINE", 500);
h = wt.prototype;
h.getName = function() {
  return this.If;
};
h.getParent = function() {
  return this.Va;
};
h.Uf = function(a) {
  this.Id = a;
};
function Ct(a) {
  if (a.Id) {
    return a.Id;
  }
  if (a.Va) {
    return Ct(a.Va);
  }
  mb("Root logger has no level set.");
  return null;
}
h.log = function(a, b, c) {
  if (a.value >= Ct(this).value) {
    for (ja(b) && (b = b()), a = new ut(a, String(b), this.If), c && (a.Cf = c), c = "log:" + a.Og, ca.console && (ca.console.timeStamp ? ca.console.timeStamp(c) : ca.console.markTimeline && ca.console.markTimeline(c)), ca.msWriteProfilerMark && ca.msWriteProfilerMark(c), c = this;c;) {
      b = c;
      var d = a;
      if (b.Ff) {
        for (var e = 0, f;f = b.Ff[e];e++) {
          f(d);
        }
      }
      c = c.getParent();
    }
  }
};
h.info = function(a, b) {
  this.log(zt, a, b);
};
var Dt = {}, Et = null;
function Ft(a) {
  Et || (Et = new wt(""), Dt[""] = Et, Et.Uf(At));
  var b;
  if (!(b = Dt[a])) {
    b = new wt(a);
    var c = a.lastIndexOf("."), d = a.substr(c + 1), c = Ft(a.substr(0, c));
    c.we || (c.we = {});
    c.we[d] = b;
    b.Va = c;
    Dt[a] = b;
  }
  return b;
}
;function Gt(a, b) {
  a && a.log(Bt, b, void 0);
}
;function Ht() {
}
Ht.prototype.kf = null;
function It(a) {
  var b;
  (b = a.kf) || (b = {}, Jt(a) && (b[0] = !0, b[1] = !0), b = a.kf = b);
  return b;
}
;var Kt;
function Lt() {
}
wa(Lt, Ht);
function Mt(a) {
  return (a = Jt(a)) ? new ActiveXObject(a) : new XMLHttpRequest;
}
function Jt(a) {
  if (!a.Gf && "undefined" == typeof XMLHttpRequest && "undefined" != typeof ActiveXObject) {
    for (var b = ["MSXML2.XMLHTTP.6.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"], c = 0;c < b.length;c++) {
      var d = b[c];
      try {
        return new ActiveXObject(d), a.Gf = d;
      } catch (e) {
      }
    }
    throw Error("Could not create ActiveXObject. ActiveX might be disabled, or MSXML might not be installed");
  }
  return a.Gf;
}
Kt = new Lt;
function Nt(a) {
  rt.call(this);
  this.headers = new Uq;
  this.re = a || null;
  this.Oc = !1;
  this.qe = this.U = null;
  this.Hf = this.Hd = "";
  this.Ic = 0;
  this.pc = "";
  this.Ed = this.Me = this.fe = this.Ge = !1;
  this.cd = 0;
  this.ke = null;
  this.Nd = Ot;
  this.oe = this.Qf = this.$e = !1;
}
wa(Nt, rt);
var Ot = "", Pt = Nt.prototype, Qt = Ft("goog.net.XhrIo");
Pt.tb = Qt;
var Rt = /^https?$/i, St = ["POST", "PUT"];
function Tt(a, b) {
  a.Nd = b;
}
h = Nt.prototype;
h.send = function(a, b, c, d) {
  if (this.U) {
    throw Error("[goog.net.XhrIo] Object is active with another request\x3d" + this.Hd + "; newUri\x3d" + a);
  }
  b = b ? b.toUpperCase() : "GET";
  this.Hd = a;
  this.pc = "";
  this.Ic = 0;
  this.Hf = b;
  this.Ge = !1;
  this.Oc = !0;
  this.U = this.re ? Mt(this.re) : Mt(Kt);
  this.qe = this.re ? It(this.re) : It(Kt);
  this.U.onreadystatechange = sa(this.Nf, this);
  this.Qf && "onprogress" in this.U && (this.U.onprogress = sa(function(a) {
    this.Mf(a, !0);
  }, this), this.U.upload && (this.U.upload.onprogress = sa(this.Mf, this)));
  try {
    Gt(this.tb, Ut(this, "Opening Xhr")), this.Me = !0, this.U.open(b, String(a), !0), this.Me = !1;
  } catch (f) {
    Gt(this.tb, Ut(this, "Error opening Xhr: " + f.message));
    this.ae(5, f);
    return;
  }
  a = c || "";
  var e = this.headers.clone();
  d && Tq(d, function(a, b) {
    e.set(b, a);
  });
  d = qb(e.rb());
  c = ca.FormData && a instanceof ca.FormData;
  !(0 <= nb(St, b)) || d || c || e.set("Content-Type", "application/x-www-form-urlencoded;charset\x3dutf-8");
  e.forEach(function(a, b) {
    this.U.setRequestHeader(b, a);
  }, this);
  this.Nd && (this.U.responseType = this.Nd);
  "withCredentials" in this.U && this.U.withCredentials !== this.$e && (this.U.withCredentials = this.$e);
  try {
    Vt(this), 0 < this.cd && (this.oe = Wt(this.U), Gt(this.tb, Ut(this, "Will abort after " + this.cd + "ms if incomplete, xhr2 " + this.oe)), this.oe ? (this.U.timeout = this.cd, this.U.ontimeout = sa(this.vc, this)) : this.ke = tt(this.vc, this.cd, this)), Gt(this.tb, Ut(this, "Sending request")), this.fe = !0, this.U.send(a), this.fe = !1;
  } catch (f) {
    Gt(this.tb, Ut(this, "Send error: " + f.message)), this.ae(5, f);
  }
};
function Wt(a) {
  return js && us(9) && "number" == typeof a.timeout && da(a.ontimeout);
}
function rb(a) {
  return "content-type" == a.toLowerCase();
}
h.vc = function() {
  "undefined" != typeof aa && this.U && (this.pc = "Timed out after " + this.cd + "ms, aborting", this.Ic = 8, Gt(this.tb, Ut(this, this.pc)), this.dispatchEvent("timeout"), this.abort(8));
};
h.ae = function(a, b) {
  this.Oc = !1;
  this.U && (this.Ed = !0, this.U.abort(), this.Ed = !1);
  this.pc = b;
  this.Ic = a;
  Xt(this);
  Yt(this);
};
function Xt(a) {
  a.Ge || (a.Ge = !0, a.dispatchEvent("complete"), a.dispatchEvent("error"));
}
h.abort = function(a) {
  this.U && this.Oc && (Gt(this.tb, Ut(this, "Aborting")), this.Oc = !1, this.Ed = !0, this.U.abort(), this.Ed = !1, this.Ic = a || 7, this.dispatchEvent("complete"), this.dispatchEvent("abort"), Yt(this));
};
h.Nf = function() {
  this.Fe || (this.Me || this.fe || this.Ed ? Zt(this) : this.Qg());
};
h.Qg = function() {
  Zt(this);
};
function Zt(a) {
  if (a.Oc && "undefined" != typeof aa) {
    if (a.qe[1] && 4 == $t(a) && 2 == au(a)) {
      Gt(a.tb, Ut(a, "Local request error detected and ignored"));
    } else {
      if (a.fe && 4 == $t(a)) {
        tt(a.Nf, 0, a);
      } else {
        if (a.dispatchEvent("readystatechange"), 4 == $t(a)) {
          Gt(a.tb, Ut(a, "Request complete"));
          a.Oc = !1;
          try {
            if (bu(a)) {
              a.dispatchEvent("complete"), a.dispatchEvent("success");
            } else {
              a.Ic = 6;
              var b;
              try {
                b = 2 < $t(a) ? a.U.statusText : "";
              } catch (c) {
                Gt(a.tb, "Can not get status: " + c.message), b = "";
              }
              a.pc = b + " [" + au(a) + "]";
              Xt(a);
            }
          } finally {
            Yt(a);
          }
        }
      }
    }
  }
}
h.Mf = function(a, b) {
  this.dispatchEvent(cu(a, "progress"));
  this.dispatchEvent(cu(a, b ? "downloadprogress" : "uploadprogress"));
};
function cu(a, b) {
  return {type:b, lengthComputable:a.lengthComputable, loaded:a.loaded, total:a.total};
}
function Yt(a) {
  if (a.U) {
    Vt(a);
    var b = a.U, c = a.qe[0] ? ea : null;
    a.U = null;
    a.qe = null;
    a.dispatchEvent("ready");
    try {
      b.onreadystatechange = c;
    } catch (d) {
      (a = a.tb) && a.log(yt, "Problem encountered resetting onreadystatechange: " + d.message, void 0);
    }
  }
}
function Vt(a) {
  a.U && a.oe && (a.U.ontimeout = null);
  "number" == typeof a.ke && (ca.clearTimeout(a.ke), a.ke = null);
}
function bu(a) {
  var b = au(a), c;
  a: {
    switch(b) {
      case 200:
      ;
      case 201:
      ;
      case 202:
      ;
      case 204:
      ;
      case 206:
      ;
      case 304:
      ;
      case 1223:
        c = !0;
        break a;
      default:
        c = !1;
    }
  }
  if (!c) {
    if (b = 0 === b) {
      a = String(a.Hd).match(Yq)[1] || null, !a && ca.self && ca.self.location && (a = ca.self.location.protocol, a = a.substr(0, a.length - 1)), b = !Rt.test(a ? a.toLowerCase() : "");
    }
    c = b;
  }
  return c;
}
function $t(a) {
  return a.U ? a.U.readyState : 0;
}
function au(a) {
  try {
    return 2 < $t(a) ? a.U.status : -1;
  } catch (b) {
    return -1;
  }
}
function du(a) {
  try {
    if (!a.U) {
      return null;
    }
    if ("response" in a.U) {
      return a.U.response;
    }
    switch(a.Nd) {
      case Ot:
      ;
      case "text":
        return a.U.responseText;
      case "arraybuffer":
        if ("mozResponseArrayBuffer" in a.U) {
          return a.U.mozResponseArrayBuffer;
        }
      ;
    }
    var b = a.tb;
    b && b.log(yt, "Response type " + a.Nd + " is not supported on this browser", void 0);
    return null;
  } catch (c) {
    return Gt(a.tb, "Can not get response: " + c.message), null;
  }
}
h.getResponseHeader = function(a) {
  return this.U && 4 == $t(this) ? this.U.getResponseHeader(a) : void 0;
};
h.getAllResponseHeaders = function() {
  return this.U && 4 == $t(this) ? this.U.getAllResponseHeaders() : "";
};
function Ut(a, b) {
  return b + " [" + a.Hf + " " + a.Hd + " " + au(a) + "]";
}
;Lp("Firefox");
hs() || Lp("iPod");
Lp("iPad");
!Lp("Android") || Mp() || Lp("Firefox") || Lp("Opera") || Lp("Silk");
Mp();
var eu = Lp("Safari") && !(Mp() || Lp("Coast") || Lp("Opera") || Lp("Edge") || Lp("Silk") || Lp("Android")) && !(hs() || Lp("iPad") || Lp("iPod"));
var fu = null, gu = ls || ms && !eu || is || "function" == typeof ca.btoa;
var hu = function hu(b) {
  if (null != b && null != b.wf) {
    return b.wf();
  }
  var c = hu[p(null == b ? null : b)];
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  c = hu._;
  if (null != c) {
    return c.h ? c.h(b) : c.call(null, b);
  }
  throw qc("PushbackReader.read-char", b);
}, iu = function iu(b, c) {
  if (null != b && null != b.xf) {
    return b.xf(0, c);
  }
  var d = iu[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = iu._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("PushbackReader.unread", b);
};
function ju(a, b, c) {
  this.s = a;
  this.buffer = b;
  this.ga = c;
}
ju.prototype.wf = function() {
  return 0 === this.buffer.length ? (this.ga += 1, this.s[this.ga]) : this.buffer.pop();
};
ju.prototype.xf = function(a, b) {
  return this.buffer.push(b);
};
function ku(a) {
  var b = !/[^\t\n\r ]/.test(a);
  return w(b) ? b : "," === a;
}
function lu(a) {
  throw Error(Vf(y, a));
}
function mu(a, b) {
  for (var c = new jb(b), d = hu(a);;) {
    var e;
    if (!(e = null == d || ku(d))) {
      e = d;
      var f = "#" !== e;
      e = f ? (f = "'" !== e) ? (f = ":" !== e) ? nu.h ? nu.h(e) : nu.call(null, e) : f : f : f;
    }
    if (e) {
      return iu(a, d), c.toString();
    }
    c.append(d);
    d = hu(a);
  }
}
function ou(a) {
  for (;;) {
    var b = hu(a);
    if ("\n" === b || "\r" === b || null == b) {
      return a;
    }
  }
}
var pu = Pi("^([-+]?)(?:(0)|([1-9][0-9]*)|0[xX]([0-9A-Fa-f]+)|0([0-7]+)|([1-9][0-9]?)[rR]([0-9A-Za-z]+))(N)?$"), qu = Pi("^([-+]?[0-9]+)/([0-9]+)$"), ru = Pi("^([-+]?[0-9]+(\\.[0-9]*)?([eE][-+]?[0-9]+)?)(M)?$"), su = Pi("^[:]?([^0-9/].*/)?([^0-9/][^/]*)$");
function tu(a, b) {
  var c = a.exec(b);
  return null != c && c[0] === b ? 1 === c.length ? c[0] : c : null;
}
var uu = Pi("^[0-9A-Fa-f]{2}$"), vu = Pi("^[0-9A-Fa-f]{4}$");
function wu(a, b, c) {
  return w(Ni(a, c)) ? c : lu(P(["Unexpected unicode escape \\", b, c], 0));
}
function xu(a) {
  var b = hu(a), c = "t" === b ? "\t" : "r" === b ? "\r" : "n" === b ? "\n" : "\\" === b ? "\\" : '"' === b ? '"' : "b" === b ? "\b" : "f" === b ? "\f" : null;
  w(c) ? b = c : "x" === b ? (a = (new jb(hu(a), hu(a))).toString(), b = String.fromCharCode(parseInt(wu(uu, b, a), 16))) : "u" === b ? (a = (new jb(hu(a), hu(a), hu(a), hu(a))).toString(), b = String.fromCharCode(parseInt(wu(vu, b, a), 16))) : b = /[^0-9]/.test(b) ? lu(P(["Unexpected unicode escape \\", b], 0)) : String.fromCharCode(b);
  return b;
}
function yu(a, b) {
  for (var c = [];;) {
    var d;
    a: {
      d = b;
      for (var e = ku, f = hu(d);;) {
        if (w(e.h ? e.h(f) : e.call(null, f))) {
          f = hu(d);
        } else {
          d = f;
          break a;
        }
      }
    }
    w(d) || lu(P(["EOF while reading"], 0));
    if (a === d) {
      return c;
    }
    e = nu.h ? nu.h(d) : nu.call(null, d);
    w(e) ? d = e.j ? e.j(b, d) : e.call(null, b, d) : (iu(b, d), d = zu.H ? zu.H(b, !0, null, !0) : zu.call(null, b, !0, null));
    d !== b && c.push(d);
  }
}
function Au(a, b) {
  return lu(P(["Reader for ", b, " not implemented yet"], 0));
}
function Bu(a, b) {
  var c = hu(a), d = Cu.h ? Cu.h(c) : Cu.call(null, c);
  if (w(d)) {
    return d.j ? d.j(a, b) : d.call(null, a, b);
  }
  d = Du.j ? Du.j(a, c) : Du.call(null, a, c);
  return w(d) ? d : lu(P(["No dispatch macro for ", c], 0));
}
function Eu(a, b) {
  return lu(P(["Unmatched delimiter ", b], 0));
}
function Fu(a) {
  a = yu(")", a);
  for (var b = a.length, c = ae;;) {
    if (0 < b) {
      var d = b - 1, c = c.fa(null, a[b - 1]), b = d
    } else {
      return c;
    }
  }
}
function Gu(a) {
  return ch(yu("]", a));
}
function Hu(a) {
  a = yu("}", a);
  var b = a.length;
  if (!bf(b)) {
    throw Error([y("Argument must be an integer: "), y(b)].join(""));
  }
  0 !== (b & 1) && lu(P(["Map literal must contain an even number of forms"], 0));
  if (b <= 2 * Ch) {
    a = Eh(a, !0, !0);
  } else {
    a: {
      for (var b = a.length, c = 0, d = vd(Dh);;) {
        if (c < b) {
          var e = c + 2, d = yd(d, a[c], a[c + 1]), c = e
        } else {
          a = xd(d);
          break a;
        }
      }
    }
  }
  return a;
}
function Iu(a) {
  for (var b = new jb, c = hu(a);;) {
    if (null == c) {
      return lu(P(["EOF while reading"], 0));
    }
    if ("\\" === c) {
      b.append(xu(a));
    } else {
      if ('"' === c) {
        return b.toString();
      }
      b.append(c);
    }
    c = hu(a);
  }
}
function Ju(a) {
  for (var b = new jb, c = hu(a);;) {
    if (null == c) {
      return lu(P(["EOF while reading"], 0));
    }
    if ("\\" === c) {
      b.append(c);
      var d = hu(a);
      if (null == d) {
        return lu(P(["EOF while reading"], 0));
      }
      var e = function() {
        var a = b;
        a.append(d);
        return a;
      }(), f = hu(a);
    } else {
      if ('"' === c) {
        return b.toString();
      }
      e = function() {
        var a = b;
        a.append(c);
        return a;
      }();
      f = hu(a);
    }
    b = e;
    c = f;
  }
}
function Ku(a, b) {
  var c = mu(a, b), d = -1 != c.indexOf("/");
  w(w(d) ? 1 !== c.length : d) ? c = Zd.j(tf(c, 0, c.indexOf("/")), tf(c, c.indexOf("/") + 1, c.length)) : (d = Zd.h(c), c = "nil" === c ? null : "true" === c ? !0 : "false" === c ? !1 : "/" === c ? Xm : d);
  return c;
}
function Lu(a, b) {
  var c = mu(a, b), d = c.substring(1);
  return 1 === d.length ? d : "tab" === d ? "\t" : "return" === d ? "\r" : "newline" === d ? "\n" : "space" === d ? " " : "backspace" === d ? "\b" : "formfeed" === d ? "\f" : "u" === d.charAt(0) ? String.fromCharCode(parseInt(d.substring(1), 16)) : "o" === d.charAt(0) ? Au(0, c) : lu(P(["Unknown character literal: ", c], 0));
}
function Mu(a) {
  a = mu(a, hu(a));
  var b = tu(su, a);
  a = b[0];
  var c = b[1], b = b[2];
  return void 0 !== c && ":/" === c.substring(c.length - 2, c.length) || ":" === b[b.length - 1] || -1 !== a.indexOf("::", 1) ? lu(P(["Invalid token: ", a], 0)) : null != c && 0 < c.length ? Ff.j(c.substring(0, c.indexOf("/")), b) : Ff.h(a);
}
function Nu(a) {
  return function(b) {
    b = zu.H ? zu.H(b, !0, null, !0) : zu.call(null, b, !0, null);
    b = Gc(ae, b);
    return Gc(b, a);
  };
}
function Ou() {
  return function() {
    return lu(P(["Unreadable form"], 0));
  };
}
function Pu(a) {
  var b;
  b = zu.H ? zu.H(a, !0, null, !0) : zu.call(null, a, !0, null);
  b = b instanceof A ? new u(null, 1, [Ln, b], null) : "string" === typeof b ? new u(null, 1, [Ln, b], null) : b instanceof X ? Eh([b, !0], !0, !1) : b;
  Te(b) || lu(P(["Metadata must be Symbol,Keyword,String or Map"], 0));
  a = zu.H ? zu.H(a, !0, null, !0) : zu.call(null, a, !0, null);
  return (null != a ? a.w & 262144 || q === a.yh || (a.w ? 0 : oc(ed, a)) : oc(ed, a)) ? Be(a, Ai.B(P([Oe(a), b], 0))) : lu(P(["Metadata can only be applied to IWithMetas"], 0));
}
function Qu(a) {
  a: {
    a = yu("}", a);
    var b = a.length;
    if (b <= Ch) {
      for (var c = 0, d = vd(dg);;) {
        if (c < b) {
          var e = c + 1, d = yd(d, a[c], null), c = e
        } else {
          a = new Ci(null, xd(d), null);
          break a;
        }
      }
    } else {
      for (c = 0, d = vd(Ei);;) {
        if (c < b) {
          e = c + 1, d = wd(d, a[c]), c = e;
        } else {
          a = xd(d);
          break a;
        }
      }
    }
  }
  return a;
}
function Ru(a) {
  return Pi(Ju(a));
}
function Su(a) {
  zu.H ? zu.H(a, !0, null, !0) : zu.call(null, a, !0, null);
  return a;
}
function nu(a) {
  return '"' === a ? Iu : ":" === a ? Mu : ";" === a ? ou : "'" === a ? Nu(Un) : "@" === a ? Nu(oo) : "^" === a ? Pu : "`" === a ? Au : "~" === a ? Au : "(" === a ? Fu : ")" === a ? Eu : "[" === a ? Gu : "]" === a ? Eu : "{" === a ? Hu : "}" === a ? Eu : "\\" === a ? Lu : "#" === a ? Bu : null;
}
function Cu(a) {
  return "{" === a ? Qu : "\x3c" === a ? Ou() : '"' === a ? Ru : "!" === a ? ou : "_" === a ? Su : null;
}
function zu(a, b, c) {
  for (;;) {
    var d = hu(a);
    if (null == d) {
      return w(b) ? lu(P(["EOF while reading"], 0)) : c;
    }
    if (!ku(d)) {
      if (";" === d) {
        a = ou.j ? ou.j(a, d) : ou.call(null, a);
      } else {
        var e = nu(d);
        if (w(e)) {
          e = e.j ? e.j(a, d) : e.call(null, a, d);
        } else {
          var e = a, f;
          !(f = !/[^0-9]/.test(d)) && (f = "+" === d || "-" === d) && (f = hu(e), iu(e, f), f = !/[^0-9]/.test(f));
          if (f) {
            a: {
              for (e = a, d = new jb(d), f = hu(e);;) {
                var g;
                g = null == f;
                g || (g = (g = ku(f)) ? g : nu.h ? nu.h(f) : nu.call(null, f));
                if (w(g)) {
                  iu(e, f);
                  d = e = d.toString();
                  w(tu(pu, d)) ? (d = tu(pu, d), f = d[2], null != (J.j(f, "") ? null : f) ? d = 0 : (f = w(d[3]) ? [d[3], 10] : w(d[4]) ? [d[4], 16] : w(d[5]) ? [d[5], 8] : w(d[6]) ? [d[7], parseInt(d[6], 10)] : [null, null], g = f[0], null == g ? d = null : (f = parseInt(g, f[1]), d = "-" === d[1] ? -f : f))) : w(tu(qu, d)) ? (d = tu(qu, d), d = parseInt(d[1], 10) / parseInt(d[2], 10)) : d = w(tu(ru, d)) ? parseFloat(d) : null;
                  e = w(d) ? d : lu(P(["Invalid number format [", e, "]"], 0));
                  break a;
                }
                d.append(f);
                f = hu(e);
              }
            }
          } else {
            e = Ku(a, d);
          }
        }
        if (e !== a) {
          return e;
        }
      }
    }
  }
}
function Tu(a) {
  if ("string" !== typeof a) {
    throw Error("Cannot read from non-string object.");
  }
  return zu(new ju(a, [], -1), !1, null);
}
var Uu = function(a, b) {
  return function(c, d) {
    return C.j(w(d) ? b : a, c);
  };
}(new T(null, 13, 5, W, [null, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], null), new T(null, 13, 5, W, [null, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], null)), Vu = /(\d\d\d\d)(?:-(\d\d)(?:-(\d\d)(?:[T](\d\d)(?::(\d\d)(?::(\d\d)(?:[.](\d+))?)?)?)?)?)?(?:[Z]|([-+])(\d\d):(\d\d))?/;
function Wu(a) {
  a = parseInt(a, 10);
  return kc(isNaN(a)) ? a : null;
}
function Xu(a, b, c, d) {
  a <= b && b <= c || lu(P([[y(d), y(" Failed:  "), y(a), y("\x3c\x3d"), y(b), y("\x3c\x3d"), y(c)].join("")], 0));
  return b;
}
function Yu(a) {
  var b = Ni(Vu, a);
  S(b, 0, null);
  var c = S(b, 1, null), d = S(b, 2, null), e = S(b, 3, null), f = S(b, 4, null), g = S(b, 5, null), k = S(b, 6, null), l = S(b, 7, null), m = S(b, 8, null), n = S(b, 9, null), t = S(b, 10, null);
  if (kc(b)) {
    return lu(P([[y("Unrecognized date/time syntax: "), y(a)].join("")], 0));
  }
  var r = Wu(c), v = function() {
    var a = Wu(d);
    return w(a) ? a : 1;
  }();
  a = function() {
    var a = Wu(e);
    return w(a) ? a : 1;
  }();
  var b = function() {
    var a = Wu(f);
    return w(a) ? a : 0;
  }(), c = function() {
    var a = Wu(g);
    return w(a) ? a : 0;
  }(), x = function() {
    var a = Wu(k);
    return w(a) ? a : 0;
  }(), z = function() {
    var a;
    a: {
      if (J.j(3, O(l))) {
        a = l;
      } else {
        if (3 < O(l)) {
          a = l.substring(0, 3);
        } else {
          for (a = new jb(l);;) {
            if (3 > a.ic.length) {
              a = a.append("0");
            } else {
              a = a.toString();
              break a;
            }
          }
        }
      }
    }
    a = Wu(a);
    return w(a) ? a : 0;
  }(), m = (J.j(m, "-") ? -1 : 1) * (60 * function() {
    var a = Wu(n);
    return w(a) ? a : 0;
  }() + function() {
    var a = Wu(t);
    return w(a) ? a : 0;
  }());
  return new T(null, 8, 5, W, [r, Xu(1, v, 12, "timestamp month field must be in range 1..12"), Xu(1, a, function() {
    var a;
    a = 0 === (r % 4 + 4) % 4;
    w(a) && (a = kc(0 === (r % 100 + 100) % 100), a = w(a) ? a : 0 === (r % 400 + 400) % 400);
    return Uu.j ? Uu.j(v, a) : Uu.call(null, v, a);
  }(), "timestamp day field must be in range 1..last day in month"), Xu(0, b, 23, "timestamp hour field must be in range 0..23"), Xu(0, c, 59, "timestamp minute field must be in range 0..59"), Xu(0, x, J.j(c, 59) ? 60 : 59, "timestamp second field must be in range 0..60"), Xu(0, z, 999, "timestamp millisecond field must be in range 0..999"), m], null);
}
var Zu, $u = new u(null, 4, ["inst", function(a) {
  var b;
  if ("string" === typeof a) {
    if (b = Yu(a), w(b)) {
      a = S(b, 0, null);
      var c = S(b, 1, null), d = S(b, 2, null), e = S(b, 3, null), f = S(b, 4, null), g = S(b, 5, null), k = S(b, 6, null);
      b = S(b, 7, null);
      b = new Date(Date.UTC(a, c - 1, d, e, f, g, k) - 6E4 * b);
    } else {
      b = lu(P([[y("Unrecognized date/time syntax: "), y(a)].join("")], 0));
    }
  } else {
    b = lu(P(["Instance literal expects a string for its timestamp."], 0));
  }
  return b;
}, "uuid", function(a) {
  return "string" === typeof a ? new zj(a, null) : lu(P(["UUID literal expects a string as its representation."], 0));
}, "queue", function(a) {
  return Ve(a) ? Gg.j(ph, a) : lu(P(["Queue literal expects a vector for its elements."], 0));
}, "js", function(a) {
  if (Ve(a)) {
    var b = [];
    a = D(a);
    for (var c = null, d = 0, e = 0;;) {
      if (e < d) {
        var f = c.aa(null, e);
        b.push(f);
        e += 1;
      } else {
        if (a = D(a)) {
          c = a, We(c) ? (a = Dd(c), e = Ed(c), c = a, d = O(a), a = e) : (a = G(c), b.push(a), a = H(c), c = null, d = 0), e = 0;
        } else {
          break;
        }
      }
    }
    return b;
  }
  if (Te(a)) {
    b = {};
    a = D(a);
    c = null;
    for (e = d = 0;;) {
      if (e < d) {
        var g = c.aa(null, e), f = S(g, 0, null), g = S(g, 1, null);
        b[Gf(f)] = g;
        e += 1;
      } else {
        if (a = D(a)) {
          We(a) ? (d = Dd(a), a = Ed(a), c = d, d = O(d)) : (d = G(a), c = S(d, 0, null), d = S(d, 1, null), b[Gf(c)] = d, a = H(a), c = null, d = 0), e = 0;
        } else {
          break;
        }
      }
    }
    return b;
  }
  return lu(P([[y("JS literal expects a vector or map containing "), y("only string or unqualified keyword keys")].join("")], 0));
}], null);
Zu = og ? og($u) : ng.call(null, $u);
var av = og ? og(null) : ng.call(null, null);
function Du(a, b) {
  var c = Ku(a, b), d = C.j(L.h ? L.h(Zu) : L.call(null, Zu), "" + y(c)), e = L.h ? L.h(av) : L.call(null, av);
  return w(d) ? (c = zu(a, !0, null), d.h ? d.h(c) : d.call(null, c)) : w(e) ? (d = zu(a, !0, null), e.j ? e.j(c, d) : e.call(null, c, d)) : lu(P(["Could not find tag parser for ", "" + y(c), " in ", aj(P([zh(L.h ? L.h(Zu) : L.call(null, Zu))], 0), cc())], 0));
}
;function bv(a) {
  var b;
  if (w(a)) {
    if (gu) {
      b = ca.btoa(a);
    } else {
      b = [];
      for (var c = 0, d = 0;d < a.length;d++) {
        for (var e = a.charCodeAt(d);255 < e;) {
          b[c++] = e & 255, e >>= 8;
        }
        b[c++] = e;
      }
      if (!fu) {
        for (fu = {}, a = 0;65 > a;a++) {
          fu[a] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\x3d".charAt(a);
        }
      }
      a = fu;
      c = [];
      for (d = 0;d < b.length;d += 3) {
        var f = b[d], g = (e = d + 1 < b.length) ? b[d + 1] : 0, k = d + 2 < b.length, l = k ? b[d + 2] : 0, m = f >> 2, f = (f & 3) << 4 | g >> 4, g = (g & 15) << 2 | l >> 6, l = l & 63;
        k || (l = 64, e || (g = 64));
        c.push(a[m], a[f], a[g], a[l]);
      }
      b = c.join("");
    }
  } else {
    b = null;
  }
  return b;
}
function cv(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  c = arguments[0];
  S(1 < b.length ? new F(b.slice(1), 0, null) : null, 0, null);
  if (w(c)) {
    a: {
      b = "" + y(c), b = encodeURIComponent(b).replace(new RegExp("*".replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g, "\\$1").replace(/\x08/g, "\\x08"), "g"), "%2A");
      break a;
      throw [y("Invalid match arg: "), y("*")].join("");
    }
  } else {
    b = null;
  }
  return b;
}
function dv(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  c = arguments[0];
  S(1 < b.length ? new F(b.slice(1), 0, null) : null, 0, null);
  return w(c) ? decodeURIComponent(c) : null;
}
Ke("TKGMYZEBP".split(""), [Math.pow(1024, 4), Math.pow(1024, 1), Math.pow(1024, 3), Math.pow(1024, 2), Math.pow(1024, 8), Math.pow(1024, 7), Math.pow(1024, 6), Math.pow(1024, 0), Math.pow(1024, 5)]);
var ev = "undefined" != typeof Object.keys ? function(a) {
  return Object.keys(a);
} : function(a) {
  return Ua(a);
}, fv = "undefined" != typeof Array.isArray ? function(a) {
  return Array.isArray(a);
} : function(a) {
  return "array" === p(a);
};
function gv() {
  return Math.round(15 * Math.random()).toString(16);
}
;var hv = 1;
function iv(a, b) {
  if (null == a) {
    return null == b;
  }
  if (a === b) {
    return !0;
  }
  if ("object" === typeof a) {
    if (fv(a)) {
      if (fv(b) && a.length === b.length) {
        for (var c = 0;c < a.length;c++) {
          if (!iv(a[c], b[c])) {
            return !1;
          }
        }
        return !0;
      }
      return !1;
    }
    if (a.vb) {
      return a.vb(b);
    }
    if (null != b && "object" === typeof b) {
      if (b.vb) {
        return b.vb(a);
      }
      var c = 0, d = ev(b).length, e;
      for (e in a) {
        if (a.hasOwnProperty(e) && (c++, !b.hasOwnProperty(e) || !iv(a[e], b[e]))) {
          return !1;
        }
      }
      return c === d;
    }
  }
  return !1;
}
function jv(a, b) {
  return a ^ b + 2654435769 + (a << 6) + (a >> 2);
}
var kv = {}, lv = 0;
function mv(a) {
  var b = 0;
  if (null != a.forEach) {
    a.forEach(function(a, c) {
      b = (b + (nv(c) ^ nv(a))) % 4503599627370496;
    });
  } else {
    for (var c = ev(a), d = 0;d < c.length;d++) {
      var e = c[d], f = a[e], b = (b + (nv(e) ^ nv(f))) % 4503599627370496
    }
  }
  return b;
}
function ov(a) {
  var b = 0;
  if (fv(a)) {
    for (var c = 0;c < a.length;c++) {
      b = jv(b, nv(a[c]));
    }
  } else {
    a.forEach && a.forEach(function(a) {
      b = jv(b, nv(a));
    });
  }
  return b;
}
function nv(a) {
  if (null == a) {
    return 0;
  }
  switch(typeof a) {
    case "number":
      return a;
    case "boolean":
      return !0 === a ? 1 : 0;
    case "string":
      var b = kv[a];
      if (null == b) {
        for (var c = b = 0;c < a.length;++c) {
          b = 31 * b + a.charCodeAt(c), b %= 4294967296;
        }
        lv++;
        256 <= lv && (kv = {}, lv = 1);
        kv[a] = b;
      }
      a = b;
      return a;
    case "function":
      return b = a.transit$hashCode$, b || (b = hv, "undefined" != typeof Object.defineProperty ? Object.defineProperty(a, "transit$hashCode$", {value:b, enumerable:!1}) : a.transit$hashCode$ = b, hv++), b;
    default:
      return a instanceof Date ? a.valueOf() : fv(a) ? ov(a) : a.Eb ? a.Eb() : mv(a);
  }
}
;var pv = "undefined" != typeof Symbol ? Symbol.iterator : "@@iterator";
function qv(a, b) {
  this.tag = a;
  this.Z = b;
  this.ma = -1;
}
qv.prototype.toString = function() {
  return "[TaggedValue: " + this.tag + ", " + this.Z + "]";
};
qv.prototype.equiv = function(a) {
  return iv(this, a);
};
qv.prototype.equiv = qv.prototype.equiv;
qv.prototype.vb = function(a) {
  return a instanceof qv ? this.tag === a.tag && iv(this.Z, a.Z) : !1;
};
qv.prototype.Eb = function() {
  -1 === this.ma && (this.ma = jv(nv(this.tag), nv(this.Z)));
  return this.ma;
};
function rv(a, b) {
  return new qv(a, b);
}
var sv = Mb("9007199254740991"), tv = Mb("-9007199254740991");
Ab.prototype.equiv = function(a) {
  return iv(this, a);
};
Ab.prototype.equiv = Ab.prototype.equiv;
Ab.prototype.vb = function(a) {
  return a instanceof Ab && this.eb(a);
};
Ab.prototype.Eb = function() {
  return this.Pd();
};
function uv(a) {
  this.va = a;
  this.ma = -1;
}
uv.prototype.toString = function() {
  return ":" + this.va;
};
uv.prototype.namespace = function() {
  var a = this.va.indexOf("/");
  return -1 != a ? this.va.substring(0, a) : null;
};
uv.prototype.name = function() {
  var a = this.va.indexOf("/");
  return -1 != a ? this.va.substring(a + 1, this.va.length) : this.va;
};
uv.prototype.equiv = function(a) {
  return iv(this, a);
};
uv.prototype.equiv = uv.prototype.equiv;
uv.prototype.vb = function(a) {
  return a instanceof uv && this.va == a.va;
};
uv.prototype.Eb = function() {
  -1 === this.ma && (this.ma = nv(this.va));
  return this.ma;
};
function vv(a) {
  this.va = a;
  this.ma = -1;
}
vv.prototype.namespace = function() {
  var a = this.va.indexOf("/");
  return -1 != a ? this.va.substring(0, a) : null;
};
vv.prototype.name = function() {
  var a = this.va.indexOf("/");
  return -1 != a ? this.va.substring(a + 1, this.va.length) : this.va;
};
vv.prototype.toString = function() {
  return this.va;
};
vv.prototype.equiv = function(a) {
  return iv(this, a);
};
vv.prototype.equiv = vv.prototype.equiv;
vv.prototype.vb = function(a) {
  return a instanceof vv && this.va == a.va;
};
vv.prototype.Eb = function() {
  -1 === this.ma && (this.ma = nv(this.va));
  return this.ma;
};
function wv(a, b, c) {
  var d = "";
  c = c || b + 1;
  for (var e = 8 * (7 - b), f = Db(255).shiftLeft(e);b < c;b++, e -= 8, f = Wb(f, 8)) {
    var g = Wb(a.df(f), e).toString(16);
    1 == g.length && (g = "0" + g);
    d += g;
  }
  return d;
}
function xv(a, b) {
  this.high = a;
  this.low = b;
  this.ma = -1;
}
xv.prototype.toString = function() {
  var a, b = this.high, c = this.low;
  a = "" + (wv(b, 0, 4) + "-");
  a += wv(b, 4, 6) + "-";
  a += wv(b, 6, 8) + "-";
  a += wv(c, 0, 2) + "-";
  return a += wv(c, 2, 8);
};
xv.prototype.equiv = function(a) {
  return iv(this, a);
};
xv.prototype.equiv = xv.prototype.equiv;
xv.prototype.vb = function(a) {
  return a instanceof xv && this.high.eb(a.high) && this.low.eb(a.low);
};
xv.prototype.Eb = function() {
  -1 === this.ma && (this.ma = nv(this.toString()));
  return this.ma;
};
Date.prototype.vb = function(a) {
  return a instanceof Date ? this.valueOf() === a.valueOf() : !1;
};
Date.prototype.Eb = function() {
  return this.valueOf();
};
function yv(a, b) {
  this.entries = a;
  this.type = b || 0;
  this.ga = 0;
}
yv.prototype.next = function() {
  if (this.ga < this.entries.length) {
    var a = {value:0 === this.type ? this.entries[this.ga] : 1 === this.type ? this.entries[this.ga + 1] : [this.entries[this.ga], this.entries[this.ga + 1]], done:!1};
    this.ga += 2;
    return a;
  }
  return {value:null, done:!0};
};
yv.prototype.next = yv.prototype.next;
yv.prototype[pv] = function() {
  return this;
};
function zv(a, b) {
  this.map = a;
  this.type = b || 0;
  this.keys = this.map.rb();
  this.ga = 0;
  this.xc = null;
  this.hc = 0;
}
zv.prototype.next = function() {
  if (this.ga < this.map.size) {
    null != this.xc && this.hc < this.xc.length || (this.xc = this.map.map[this.keys[this.ga]], this.hc = 0);
    var a = {value:0 === this.type ? this.xc[this.hc] : 1 === this.type ? this.xc[this.hc + 1] : [this.xc[this.hc], this.xc[this.hc + 1]], done:!1};
    this.ga++;
    this.hc += 2;
    return a;
  }
  return {value:null, done:!0};
};
zv.prototype.next = zv.prototype.next;
zv.prototype[pv] = function() {
  return this;
};
function Av(a, b) {
  if (a instanceof Bv && (b instanceof Cv || b instanceof Bv)) {
    if (a.size !== b.size) {
      return !1;
    }
    for (var c in a.map) {
      for (var d = a.map[c], e = 0;e < d.length;e += 2) {
        if (!iv(d[e + 1], b.get(d[e]))) {
          return !1;
        }
      }
    }
    return !0;
  }
  if (a instanceof Cv && (b instanceof Cv || b instanceof Bv)) {
    if (a.size !== b.size) {
      return !1;
    }
    c = a.ia;
    for (e = 0;e < c.length;e += 2) {
      if (!iv(c[e + 1], b.get(c[e]))) {
        return !1;
      }
    }
    return !0;
  }
  if (null != b && "object" === typeof b && (e = ev(b), c = e.length, a.size === c)) {
    for (d = 0;d < c;d++) {
      var f = e[d];
      if (!a.has(f) || !iv(b[f], a.get(f))) {
        return !1;
      }
    }
    return !0;
  }
  return !1;
}
function Dv(a) {
  return null == a ? "null" : fa(a) ? "[" + a.toString() + "]" : ha(a) ? '"' + a + '"' : a.toString();
}
function Ev(a) {
  var b = 0, c = "TransitMap {";
  a.forEach(function(d, e) {
    c += Dv(e) + " \x3d\x3e " + Dv(d);
    b < a.size - 1 && (c += ", ");
    b++;
  });
  return c + "}";
}
function Fv(a) {
  var b = 0, c = "TransitSet {";
  a.forEach(function(d) {
    c += Dv(d);
    b < a.size - 1 && (c += ", ");
    b++;
  });
  return c + "}";
}
function Cv(a) {
  this.ia = a;
  this.ha = null;
  this.ma = -1;
  this.size = a.length / 2;
  this.af = 0;
}
Cv.prototype.toString = function() {
  return Ev(this);
};
Cv.prototype.inspect = function() {
  return this.toString();
};
function Gv(a) {
  if (a.ha) {
    throw Error("Invalid operation, already converted");
  }
  if (8 > a.size) {
    return !1;
  }
  a.af++;
  return 32 < a.af ? (a.ha = Hv(a.ia, !1, !0), a.ia = [], !0) : !1;
}
Cv.prototype.clear = function() {
  this.ma = -1;
  this.ha ? this.ha.clear() : this.ia = [];
  this.size = 0;
};
Cv.prototype.clear = Cv.prototype.clear;
Cv.prototype.keys = function() {
  return this.ha ? this.ha.keys() : new yv(this.ia, 0);
};
Cv.prototype.keys = Cv.prototype.keys;
Cv.prototype.Gc = function() {
  if (this.ha) {
    return this.ha.Gc();
  }
  for (var a = [], b = 0, c = 0;c < this.ia.length;b++, c += 2) {
    a[b] = this.ia[c];
  }
  return a;
};
Cv.prototype.keySet = Cv.prototype.Gc;
Cv.prototype.entries = function() {
  return this.ha ? this.ha.entries() : new yv(this.ia, 2);
};
Cv.prototype.entries = Cv.prototype.entries;
Cv.prototype.values = function() {
  return this.ha ? this.ha.values() : new yv(this.ia, 1);
};
Cv.prototype.values = Cv.prototype.values;
Cv.prototype.forEach = function(a) {
  if (this.ha) {
    this.ha.forEach(a);
  } else {
    for (var b = 0;b < this.ia.length;b += 2) {
      a(this.ia[b + 1], this.ia[b]);
    }
  }
};
Cv.prototype.forEach = Cv.prototype.forEach;
Cv.prototype.get = function(a, b) {
  if (this.ha) {
    return this.ha.get(a);
  }
  if (Gv(this)) {
    return this.get(a);
  }
  for (var c = 0;c < this.ia.length;c += 2) {
    if (iv(this.ia[c], a)) {
      return this.ia[c + 1];
    }
  }
  return b;
};
Cv.prototype.get = Cv.prototype.get;
Cv.prototype.has = function(a) {
  if (this.ha) {
    return this.ha.has(a);
  }
  if (Gv(this)) {
    return this.has(a);
  }
  for (var b = 0;b < this.ia.length;b += 2) {
    if (iv(this.ia[b], a)) {
      return !0;
    }
  }
  return !1;
};
Cv.prototype.has = Cv.prototype.has;
Cv.prototype.set = function(a, b) {
  this.ma = -1;
  if (this.ha) {
    this.ha.set(a, b), this.size = this.ha.size;
  } else {
    for (var c = 0;c < this.ia.length;c += 2) {
      if (iv(this.ia[c], a)) {
        this.ia[c + 1] = b;
        return;
      }
    }
    this.ia.push(a);
    this.ia.push(b);
    this.size++;
    32 < this.size && (this.ha = Hv(this.ia, !1, !0), this.ia = null);
  }
};
Cv.prototype.set = Cv.prototype.set;
Cv.prototype["delete"] = function(a) {
  this.ma = -1;
  if (this.ha) {
    return a = this.ha["delete"](a), this.size = this.ha.size, a;
  }
  for (var b = 0;b < this.ia.length;b += 2) {
    if (iv(this.ia[b], a)) {
      return a = this.ia[b + 1], this.ia.splice(b, 2), this.size--, a;
    }
  }
};
Cv.prototype.clone = function() {
  var a = Hv();
  this.forEach(function(b, c) {
    a.set(c, b);
  });
  return a;
};
Cv.prototype.clone = Cv.prototype.clone;
Cv.prototype[pv] = function() {
  return this.entries();
};
Cv.prototype.Eb = function() {
  if (this.ha) {
    return this.ha.Eb();
  }
  -1 === this.ma && (this.ma = mv(this));
  return this.ma;
};
Cv.prototype.vb = function(a) {
  return this.ha ? Av(this.ha, a) : Av(this, a);
};
function Bv(a, b, c) {
  this.map = b || {};
  this.Nc = a || [];
  this.size = c || 0;
  this.ma = -1;
}
Bv.prototype.toString = function() {
  return Ev(this);
};
Bv.prototype.inspect = function() {
  return this.toString();
};
Bv.prototype.clear = function() {
  this.ma = -1;
  this.map = {};
  this.Nc = [];
  this.size = 0;
};
Bv.prototype.clear = Bv.prototype.clear;
Bv.prototype.rb = function() {
  return null != this.Nc ? this.Nc : ev(this.map);
};
Bv.prototype["delete"] = function(a) {
  this.ma = -1;
  this.Nc = null;
  for (var b = nv(a), c = this.map[b], d = 0;d < c.length;d += 2) {
    if (iv(a, c[d])) {
      return a = c[d + 1], c.splice(d, 2), 0 === c.length && delete this.map[b], this.size--, a;
    }
  }
};
Bv.prototype.entries = function() {
  return new zv(this, 2);
};
Bv.prototype.entries = Bv.prototype.entries;
Bv.prototype.forEach = function(a) {
  for (var b = this.rb(), c = 0;c < b.length;c++) {
    for (var d = this.map[b[c]], e = 0;e < d.length;e += 2) {
      a(d[e + 1], d[e], this);
    }
  }
};
Bv.prototype.forEach = Bv.prototype.forEach;
Bv.prototype.get = function(a, b) {
  var c = nv(a), c = this.map[c];
  if (null != c) {
    for (var d = 0;d < c.length;d += 2) {
      if (iv(a, c[d])) {
        return c[d + 1];
      }
    }
  } else {
    return b;
  }
};
Bv.prototype.get = Bv.prototype.get;
Bv.prototype.has = function(a) {
  var b = nv(a), b = this.map[b];
  if (null != b) {
    for (var c = 0;c < b.length;c += 2) {
      if (iv(a, b[c])) {
        return !0;
      }
    }
  }
  return !1;
};
Bv.prototype.has = Bv.prototype.has;
Bv.prototype.keys = function() {
  return new zv(this, 0);
};
Bv.prototype.keys = Bv.prototype.keys;
Bv.prototype.Gc = function() {
  for (var a = this.rb(), b = [], c = 0;c < a.length;c++) {
    for (var d = this.map[a[c]], e = 0;e < d.length;e += 2) {
      b.push(d[e]);
    }
  }
  return b;
};
Bv.prototype.keySet = Bv.prototype.Gc;
Bv.prototype.set = function(a, b) {
  this.ma = -1;
  var c = nv(a), d = this.map[c];
  if (null == d) {
    this.Nc && this.Nc.push(c), this.map[c] = [a, b], this.size++;
  } else {
    for (var c = !0, e = 0;e < d.length;e += 2) {
      if (iv(b, d[e])) {
        c = !1;
        d[e] = b;
        break;
      }
    }
    c && (d.push(a), d.push(b), this.size++);
  }
};
Bv.prototype.set = Bv.prototype.set;
Bv.prototype.values = function() {
  return new zv(this, 1);
};
Bv.prototype.values = Bv.prototype.values;
Bv.prototype.clone = function() {
  var a = Hv();
  this.forEach(function(b, c) {
    a.set(c, b);
  });
  return a;
};
Bv.prototype.clone = Bv.prototype.clone;
Bv.prototype[pv] = function() {
  return this.entries();
};
Bv.prototype.Eb = function() {
  -1 === this.ma && (this.ma = mv(this));
  return this.ma;
};
Bv.prototype.vb = function(a) {
  return Av(this, a);
};
function Hv(a, b, c) {
  a = a || [];
  b = !1 === b ? b : !0;
  if ((!0 !== c || !c) && 64 >= a.length) {
    if (b) {
      var d = a;
      a = [];
      for (b = 0;b < d.length;b += 2) {
        var e = !1;
        for (c = 0;c < a.length;c += 2) {
          if (iv(a[c], d[b])) {
            a[c + 1] = d[b + 1];
            e = !0;
            break;
          }
        }
        e || (a.push(d[b]), a.push(d[b + 1]));
      }
    }
    return new Cv(a);
  }
  var d = {}, e = [], f = 0;
  for (b = 0;b < a.length;b += 2) {
    c = nv(a[b]);
    var g = d[c];
    if (null == g) {
      e.push(c), d[c] = [a[b], a[b + 1]], f++;
    } else {
      var k = !0;
      for (c = 0;c < g.length;c += 2) {
        if (iv(g[c], a[b])) {
          g[c + 1] = a[b + 1];
          k = !1;
          break;
        }
      }
      k && (g.push(a[b]), g.push(a[b + 1]), f++);
    }
  }
  return new Bv(e, d, f);
}
function Iv(a) {
  this.map = a;
  this.size = a.size;
}
Iv.prototype.toString = function() {
  return Fv(this);
};
Iv.prototype.inspect = function() {
  return this.toString();
};
Iv.prototype.add = function(a) {
  this.map.set(a, a);
  this.size = this.map.size;
};
Iv.prototype.add = Iv.prototype.add;
Iv.prototype.clear = function() {
  this.map = new Bv;
  this.size = 0;
};
Iv.prototype.clear = Iv.prototype.clear;
Iv.prototype["delete"] = function(a) {
  a = this.map["delete"](a);
  this.size = this.map.size;
  return a;
};
Iv.prototype.entries = function() {
  return this.map.entries();
};
Iv.prototype.entries = Iv.prototype.entries;
Iv.prototype.forEach = function(a) {
  var b = this;
  this.map.forEach(function(c, d) {
    a(d, b);
  });
};
Iv.prototype.forEach = Iv.prototype.forEach;
Iv.prototype.has = function(a) {
  return this.map.has(a);
};
Iv.prototype.has = Iv.prototype.has;
Iv.prototype.keys = function() {
  return this.map.keys();
};
Iv.prototype.keys = Iv.prototype.keys;
Iv.prototype.Gc = function() {
  return this.map.Gc();
};
Iv.prototype.keySet = Iv.prototype.Gc;
Iv.prototype.values = function() {
  return this.map.values();
};
Iv.prototype.values = Iv.prototype.values;
Iv.prototype.clone = function() {
  var a = Jv();
  this.forEach(function(b) {
    a.add(b);
  });
  return a;
};
Iv.prototype.clone = Iv.prototype.clone;
Iv.prototype[pv] = function() {
  return this.values();
};
Iv.prototype.vb = function(a) {
  if (a instanceof Iv) {
    if (this.size === a.size) {
      return iv(this.map, a.map);
    }
  } else {
    return !1;
  }
};
Iv.prototype.Eb = function() {
  return nv(this.map);
};
function Jv(a) {
  a = a || [];
  for (var b = {}, c = [], d = 0, e = 0;e < a.length;e++) {
    var f = nv(a[e]), g = b[f];
    if (null == g) {
      c.push(f), b[f] = [a[e], a[e]], d++;
    } else {
      for (var f = !0, k = 0;k < g.length;k += 2) {
        if (iv(g[k], a[e])) {
          f = !1;
          break;
        }
      }
      f && (g.push(a[e]), g.push(a[e]), d++);
    }
  }
  return new Iv(new Bv(c, b, d));
}
;function Kv(a, b) {
  if (3 < a.length) {
    if (b) {
      return !0;
    }
    var c = a.charAt(1);
    return "~" === a.charAt(0) ? ":" === c || "$" === c || "#" === c : !1;
  }
  return !1;
}
function Lv(a) {
  var b = Math.floor(a / 44);
  a = String.fromCharCode(a % 44 + 48);
  return 0 === b ? "^" + a : "^" + String.fromCharCode(b + 48) + a;
}
function Mv() {
  this.$f = this.Ad = this.ga = 0;
  this.cache = {};
}
Mv.prototype.write = function(a, b) {
  if (Kv(a, b)) {
    4096 === this.$f ? (this.clear(), this.Ad = 0, this.cache = {}) : 1936 === this.ga && this.clear();
    var c = this.cache[a];
    return null == c ? (this.cache[a] = [Lv(this.ga), this.Ad], this.ga++, a) : c[1] != this.Ad ? (c[1] = this.Ad, c[0] = Lv(this.ga), this.ga++, a) : c[0];
  }
  return a;
};
Mv.prototype.clear = function() {
  this.ga = 0;
  this.Ad++;
};
function Nv() {
  this.ga = 0;
  this.cache = [];
}
Nv.prototype.write = function(a) {
  1936 == this.ga && (this.ga = 0);
  this.cache[this.ga] = a;
  this.ga++;
  return a;
};
Nv.prototype.read = function(a) {
  return this.cache[2 === a.length ? a.charCodeAt(1) - 48 : 44 * (a.charCodeAt(1) - 48) + (a.charCodeAt(2) - 48)];
};
Nv.prototype.clear = function() {
  this.ga = 0;
};
function Ov(a) {
  this.ab = a;
}
function Pv(a) {
  this.options = a || {};
  this.Ca = {};
  for (var b in this.defaults.Ca) {
    this.Ca[b] = this.defaults.Ca[b];
  }
  for (b in this.options.handlers) {
    a: {
      switch(b) {
        case "_":
        ;
        case "s":
        ;
        case "?":
        ;
        case "i":
        ;
        case "d":
        ;
        case "b":
        ;
        case "'":
        ;
        case "array":
        ;
        case "map":
          a = !0;
          break a;
      }
      a = !1;
    }
    if (a) {
      throw Error('Cannot override handler for ground type "' + b + '"');
    }
    this.Ca[b] = this.options.handlers[b];
  }
  this.he = null != this.options.preferStrings ? this.options.preferStrings : this.defaults.he;
  this.Se = null != this.options.preferBuffers ? this.options.preferBuffers : this.defaults.Se;
  this.Ee = this.options.defaultHandler || this.defaults.Ee;
  this.xb = this.options.mapBuilder;
  this.Pc = this.options.arrayBuilder;
}
Pv.prototype.defaults = {Ca:{_:function() {
  return null;
}, "?":function(a) {
  return "t" === a;
}, b:function(a, b) {
  var c;
  if (b && !1 === b.Se || "undefined" == typeof Buffer) {
    if ("undefined" != typeof Uint8Array) {
      if ("undefined" != typeof atob) {
        c = atob(a);
      } else {
        c = String(a).replace(/=+$/, "");
        if (1 == c.length % 4) {
          throw Error("'atob' failed: The string to be decoded is not correctly encoded.");
        }
        for (var d = 0, e, f, g = 0, k = "";f = c.charAt(g++);~f && (e = d % 4 ? 64 * e + f : f, d++ % 4) ? k += String.fromCharCode(255 & e >> (-2 * d & 6)) : 0) {
          f = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\x3d".indexOf(f);
        }
        c = k;
      }
      d = c.length;
      e = new Uint8Array(d);
      for (f = 0;f < d;f++) {
        e[f] = c.charCodeAt(f);
      }
      c = e;
    } else {
      c = rv("b", a);
    }
  } else {
    c = new Buffer(a, "base64");
  }
  return c;
}, i:function(a) {
  "number" === typeof a || a instanceof Ab || (a = Mb(a, 10), a = a.ce(sv) || a.Zc(tv) ? a : a.Ob());
  return a;
}, n:function(a) {
  return rv("n", a);
}, d:function(a) {
  return parseFloat(a);
}, f:function(a) {
  return rv("f", a);
}, c:function(a) {
  return a;
}, ":":function(a) {
  return new uv(a);
}, $:function(a) {
  return new vv(a);
}, r:function(a) {
  return rv("r", a);
}, z:function(a) {
  a: {
    switch(a) {
      case "-INF":
        a = -Infinity;
        break a;
      case "INF":
        a = Infinity;
        break a;
      case "NaN":
        a = NaN;
        break a;
      default:
        throw Error("Invalid special double value " + a);;
    }
  }
  return a;
}, "'":function(a) {
  return a;
}, m:function(a) {
  a = "number" === typeof a ? a : parseInt(a, 10);
  return new Date(a);
}, t:function(a) {
  return new Date(a);
}, u:function(a) {
  a = a.replace(/-/g, "");
  var b, c, d, e, f;
  f = c = 0;
  for (e = 24;8 > f;f += 2, e -= 8) {
    c |= parseInt(a.substring(f, f + 2), 16) << e;
  }
  d = 0;
  f = 8;
  for (e = 24;16 > f;f += 2, e -= 8) {
    d |= parseInt(a.substring(f, f + 2), 16) << e;
  }
  b = Lb(d, c);
  c = 0;
  f = 16;
  for (e = 24;24 > f;f += 2, e -= 8) {
    c |= parseInt(a.substring(f, f + 2), 16) << e;
  }
  d = 0;
  for (e = f = 24;32 > f;f += 2, e -= 8) {
    d |= parseInt(a.substring(f, f + 2), 16) << e;
  }
  return new xv(b, Lb(d, c));
}, set:function(a) {
  return Jv(a);
}, list:function(a) {
  return rv("list", a);
}, link:function(a) {
  return rv("link", a);
}, cmap:function(a) {
  return Hv(a, !1);
}}, Ee:function(a, b) {
  return rv(a, b);
}, he:!0, Se:!0};
Pv.prototype.decode = function(a, b, c, d) {
  if (null == a) {
    return null;
  }
  switch(typeof a) {
    case "string":
      return Kv(a, c) ? (a = Qv(this, a), b && b.write(a, c), b = a) : b = "^" === a.charAt(0) && " " !== a.charAt(1) ? b.read(a, c) : Qv(this, a), b;
    case "object":
      if (fv(a)) {
        if ("^ " === a[0]) {
          if (this.xb) {
            if (17 > a.length && this.xb.Dc) {
              d = [];
              for (c = 1;c < a.length;c += 2) {
                d.push(this.decode(a[c], b, !0, !1)), d.push(this.decode(a[c + 1], b, !1, !1));
              }
              b = this.xb.Dc(d, a);
            } else {
              d = this.xb.Yc(a);
              for (c = 1;c < a.length;c += 2) {
                d = this.xb.add(d, this.decode(a[c], b, !0, !1), this.decode(a[c + 1], b, !1, !1), a);
              }
              b = this.xb.be(d, a);
            }
          } else {
            d = [];
            for (c = 1;c < a.length;c += 2) {
              d.push(this.decode(a[c], b, !0, !1)), d.push(this.decode(a[c + 1], b, !1, !1));
            }
            b = Hv(d, !1);
          }
        } else {
          b = Rv(this, a, b, c, d);
        }
      } else {
        c = ev(a);
        var e = c[0];
        if ((d = 1 == c.length ? this.decode(e, b, !1, !1) : null) && d instanceof Ov) {
          a = a[e], c = this.Ca[d.ab], b = null != c ? c(this.decode(a, b, !1, !0), this) : rv(d.ab, this.decode(a, b, !1, !1));
        } else {
          if (this.xb) {
            if (16 > c.length && this.xb.Dc) {
              var f = [];
              for (d = 0;d < c.length;d++) {
                e = c[d], f.push(this.decode(e, b, !0, !1)), f.push(this.decode(a[e], b, !1, !1));
              }
              b = this.xb.Dc(f, a);
            } else {
              f = this.xb.Yc(a);
              for (d = 0;d < c.length;d++) {
                e = c[d], f = this.xb.add(f, this.decode(e, b, !0, !1), this.decode(a[e], b, !1, !1), a);
              }
              b = this.xb.be(f, a);
            }
          } else {
            f = [];
            for (d = 0;d < c.length;d++) {
              e = c[d], f.push(this.decode(e, b, !0, !1)), f.push(this.decode(a[e], b, !1, !1));
            }
            b = Hv(f, !1);
          }
        }
      }
      return b;
  }
  return a;
};
Pv.prototype.decode = Pv.prototype.decode;
function Rv(a, b, c, d, e) {
  if (e) {
    var f = [];
    for (e = 0;e < b.length;e++) {
      f.push(a.decode(b[e], c, d, !1));
    }
    return f;
  }
  f = c && c.ga;
  if (2 === b.length && "string" === typeof b[0] && (e = a.decode(b[0], c, !1, !1)) && e instanceof Ov) {
    return b = b[1], f = a.Ca[e.ab], null != f ? f = f(a.decode(b, c, d, !0), a) : rv(e.ab, a.decode(b, c, d, !1));
  }
  c && f != c.ga && (c.ga = f);
  if (a.Pc) {
    if (32 >= b.length && a.Pc.Dc) {
      f = [];
      for (e = 0;e < b.length;e++) {
        f.push(a.decode(b[e], c, d, !1));
      }
      return a.Pc.Dc(f, b);
    }
    f = a.Pc.Yc(b);
    for (e = 0;e < b.length;e++) {
      f = a.Pc.add(f, a.decode(b[e], c, d, !1), b);
    }
    return a.Pc.be(f, b);
  }
  f = [];
  for (e = 0;e < b.length;e++) {
    f.push(a.decode(b[e], c, d, !1));
  }
  return f;
}
function Qv(a, b) {
  if ("~" === b.charAt(0)) {
    var c = b.charAt(1);
    if ("~" === c || "^" === c || "`" === c) {
      return b.substring(1);
    }
    if ("#" === c) {
      return new Ov(b.substring(2));
    }
    var d = a.Ca[c];
    return null == d ? a.Ee(c, b.substring(2)) : d(b.substring(2), a);
  }
  return b;
}
;function Sv(a) {
  this.tg = new Pv(a);
}
function Tv(a, b) {
  this.jh = a;
  this.options = b || {};
  this.cache = this.options.cache ? this.options.cache : new Nv;
}
Tv.prototype.read = function(a) {
  var b = this.cache;
  a = this.jh.tg.decode(JSON.parse(a), b);
  this.cache.clear();
  return a;
};
Tv.prototype.read = Tv.prototype.read;
var Uv = 0, Vv = (8 | 3 & Math.round(14 * Math.random())).toString(16), Wv = "transit$guid$" + (gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv() + "-" + gv() + gv() + gv() + gv() + "-4" + gv() + gv() + gv() + "-" + Vv + gv() + gv() + gv() + "-" + gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv() + gv());
function Xv(a) {
  if (null == a) {
    return "null";
  }
  if (a === String) {
    return "string";
  }
  if (a === Boolean) {
    return "boolean";
  }
  if (a === Number) {
    return "number";
  }
  if (a === Array) {
    return "array";
  }
  if (a === Object) {
    return "map";
  }
  var b = a[Wv];
  null == b && ("undefined" != typeof Object.defineProperty ? (b = ++Uv, Object.defineProperty(a, Wv, {value:b, enumerable:!1})) : a[Wv] = b = ++Uv);
  return b;
}
function Yv(a, b) {
  for (var c = a.toString(), d = c.length;d < b;d++) {
    c = "0" + c;
  }
  return c;
}
function Zv() {
}
Zv.prototype.tag = function() {
  return "_";
};
Zv.prototype.Z = function() {
  return null;
};
Zv.prototype.ra = function() {
  return "null";
};
function $v() {
}
$v.prototype.tag = function() {
  return "s";
};
$v.prototype.Z = function(a) {
  return a;
};
$v.prototype.ra = function(a) {
  return a;
};
function aw() {
}
aw.prototype.tag = function() {
  return "i";
};
aw.prototype.Z = function(a) {
  return a;
};
aw.prototype.ra = function(a) {
  return a.toString();
};
function bw() {
}
bw.prototype.tag = function() {
  return "i";
};
bw.prototype.Z = function(a) {
  return a.toString();
};
bw.prototype.ra = function(a) {
  return a.toString();
};
function cw() {
}
cw.prototype.tag = function() {
  return "?";
};
cw.prototype.Z = function(a) {
  return a;
};
cw.prototype.ra = function(a) {
  return a.toString();
};
function dw() {
}
dw.prototype.tag = function() {
  return "array";
};
dw.prototype.Z = function(a) {
  return a;
};
dw.prototype.ra = function() {
  return null;
};
function ew() {
}
ew.prototype.tag = function() {
  return "map";
};
ew.prototype.Z = function(a) {
  return a;
};
ew.prototype.ra = function() {
  return null;
};
function fw() {
}
fw.prototype.tag = function() {
  return "t";
};
fw.prototype.Z = function(a) {
  return a.getUTCFullYear() + "-" + Yv(a.getUTCMonth() + 1, 2) + "-" + Yv(a.getUTCDate(), 2) + "T" + Yv(a.getUTCHours(), 2) + ":" + Yv(a.getUTCMinutes(), 2) + ":" + Yv(a.getUTCSeconds(), 2) + "." + Yv(a.getUTCMilliseconds(), 3) + "Z";
};
fw.prototype.ra = function(a, b) {
  return b.Z(a);
};
function gw() {
}
gw.prototype.tag = function() {
  return "m";
};
gw.prototype.Z = function(a) {
  return a.valueOf();
};
gw.prototype.ra = function(a) {
  return a.valueOf().toString();
};
function hw() {
}
hw.prototype.tag = function() {
  return "u";
};
hw.prototype.Z = function(a) {
  return a.toString();
};
hw.prototype.ra = function(a) {
  return a.toString();
};
function iw() {
}
iw.prototype.tag = function() {
  return ":";
};
iw.prototype.Z = function(a) {
  return a.va;
};
iw.prototype.ra = function(a, b) {
  return b.Z(a);
};
function jw() {
}
jw.prototype.tag = function() {
  return "$";
};
jw.prototype.Z = function(a) {
  return a.va;
};
jw.prototype.ra = function(a, b) {
  return b.Z(a);
};
function kw() {
}
kw.prototype.tag = function(a) {
  return a.tag;
};
kw.prototype.Z = function(a) {
  return a.Z;
};
kw.prototype.ra = function() {
  return null;
};
function lw() {
}
lw.prototype.tag = function() {
  return "set";
};
lw.prototype.Z = function(a) {
  var b = [];
  a.forEach(function(a) {
    b.push(a);
  });
  return rv("array", b);
};
lw.prototype.ra = function() {
  return null;
};
function mw() {
}
mw.prototype.tag = function() {
  return "map";
};
mw.prototype.Z = function(a) {
  return a;
};
mw.prototype.ra = function() {
  return null;
};
function nw() {
}
nw.prototype.tag = function() {
  return "map";
};
nw.prototype.Z = function(a) {
  return a;
};
nw.prototype.ra = function() {
  return null;
};
function ow() {
}
ow.prototype.tag = function() {
  return "b";
};
ow.prototype.Z = function(a) {
  return a.toString("base64");
};
ow.prototype.ra = function() {
  return null;
};
function pw() {
}
pw.prototype.tag = function() {
  return "b";
};
pw.prototype.Z = function(a) {
  for (var b = 0, c = a.length, d = "", e;b < c;) {
    e = a.subarray(b, Math.min(b + 32768, c)), d += String.fromCharCode.apply(null, e), b += 32768;
  }
  var f;
  if ("undefined" != typeof btoa) {
    f = btoa(d);
  } else {
    a = String(d);
    c = 0;
    d = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\x3d";
    for (e = "";a.charAt(c | 0) || (d = "\x3d", c % 1);e += d.charAt(63 & f >> 8 - c % 1 * 8)) {
      b = a.charCodeAt(c += .75);
      if (255 < b) {
        throw Error("'btoa' failed: The string to be encoded contains characters outside of the Latin1 range.");
      }
      f = f << 8 | b;
    }
    f = e;
  }
  return f;
};
pw.prototype.ra = function() {
  return null;
};
function qw() {
  this.Ca = {};
  this.set(null, new Zv);
  this.set(String, new $v);
  this.set(Number, new aw);
  this.set(Ab, new bw);
  this.set(Boolean, new cw);
  this.set(Array, new dw);
  this.set(Object, new ew);
  this.set(Date, new gw);
  this.set(xv, new hw);
  this.set(uv, new iw);
  this.set(vv, new jw);
  this.set(qv, new kw);
  this.set(Iv, new lw);
  this.set(Cv, new mw);
  this.set(Bv, new nw);
  "undefined" != typeof Buffer && this.set(Buffer, new ow);
  "undefined" != typeof Uint8Array && this.set(Uint8Array, new pw);
}
qw.prototype.get = function(a) {
  a = "string" === typeof a ? this.Ca[a] : this.Ca[Xv(a)];
  return null != a ? a : this.Ca["default"];
};
qw.prototype.get = qw.prototype.get;
qw.prototype.set = function(a, b) {
  var c;
  if (c = "string" === typeof a) {
    a: {
      switch(a) {
        case "null":
        ;
        case "string":
        ;
        case "boolean":
        ;
        case "number":
        ;
        case "array":
        ;
        case "map":
          c = !1;
          break a;
      }
      c = !0;
    }
  }
  c ? this.Ca[a] = b : this.Ca[Xv(a)] = b;
};
function rw(a) {
  this.rc = a || {};
  this.he = null != this.rc.preferStrings ? this.rc.preferStrings : !0;
  this.Kf = this.rc.objectBuilder || null;
  this.Ca = new qw;
  if (a = this.rc.handlers) {
    if (fv(a) || !a.forEach) {
      throw Error('transit writer "handlers" option must be a map');
    }
    var b = this;
    a.forEach(function(a, d) {
      if (void 0 !== d) {
        b.Ca.set(d, a);
      } else {
        throw Error("Cannot create handler for JavaScript undefined");
      }
    });
  }
  this.Cd = this.rc.handlerForForeign;
  this.ne = this.rc.unpack || function(a) {
    return a instanceof Cv && null === a.ha ? a.ia : !1;
  };
  this.Qd = this.rc && this.rc.verbose || !1;
}
rw.prototype.jb = function(a) {
  var b = this.Ca.get(null == a ? null : a.constructor);
  return null != b ? b : (a = a && a.transitTag) ? this.Ca.get(a) : null;
};
function sw(a, b, c, d, e) {
  a = a + b + c;
  return e ? e.write(a, d) : a;
}
function tw(a, b, c) {
  var d = [];
  if (fv(b)) {
    for (var e = 0;e < b.length;e++) {
      d.push(uw(a, b[e], !1, c));
    }
  } else {
    b.forEach(function(b) {
      d.push(uw(a, b, !1, c));
    });
  }
  return d;
}
function vw(a, b) {
  if ("string" !== typeof b) {
    var c = a.jb(b);
    return c && 1 === c.tag(b).length;
  }
  return !0;
}
function ww(a, b) {
  var c = a.ne(b), d = !0;
  if (c) {
    for (var e = 0;e < c.length && (d = vw(a, c[e]), d);e += 2) {
    }
    return d;
  }
  if (b.keys && (c = b.keys(), e = null, c.next)) {
    for (e = c.next();!e.done;) {
      d = vw(a, e.value);
      if (!d) {
        break;
      }
      e = c.next();
    }
    return d;
  }
  if (b.forEach) {
    return b.forEach(function(b, c) {
      d = d && vw(a, c);
    }), d;
  }
  throw Error("Cannot walk keys of object type " + (null == b ? null : b.constructor).name);
}
function xw(a) {
  if (a.constructor.transit$isObject) {
    return !0;
  }
  var b = a.constructor.toString(), b = b.substr(9), b = b.substr(0, b.indexOf("("));
  isObject = "Object" == b;
  "undefined" != typeof Object.defineProperty ? Object.defineProperty(a.constructor, "transit$isObject", {value:isObject, enumerable:!1}) : a.constructor.transit$isObject = isObject;
  return isObject;
}
function yw(a, b, c) {
  var d = null, e = null, f = null, d = null, g = 0;
  if (b.constructor === Object || null != b.forEach || a.Cd && xw(b)) {
    if (a.Qd) {
      if (null != b.forEach) {
        if (ww(a, b)) {
          var k = {};
          b.forEach(function(b, d) {
            k[uw(a, d, !0, !1)] = uw(a, b, !1, c);
          });
        } else {
          d = a.ne(b);
          e = [];
          f = sw("~#", "cmap", "", !0, c);
          if (d) {
            for (;g < d.length;g += 2) {
              e.push(uw(a, d[g], !1, !1)), e.push(uw(a, d[g + 1], !1, c));
            }
          } else {
            b.forEach(function(b, d) {
              e.push(uw(a, d, !1, !1));
              e.push(uw(a, b, !1, c));
            });
          }
          k = {};
          k[f] = e;
        }
      } else {
        for (d = ev(b), k = {};g < d.length;g++) {
          k[uw(a, d[g], !0, !1)] = uw(a, b[d[g]], !1, c);
        }
      }
      return k;
    }
    if (null != b.forEach) {
      if (ww(a, b)) {
        d = a.ne(b);
        k = ["^ "];
        if (d) {
          for (;g < d.length;g += 2) {
            k.push(uw(a, d[g], !0, c)), k.push(uw(a, d[g + 1], !1, c));
          }
        } else {
          b.forEach(function(b, d) {
            k.push(uw(a, d, !0, c));
            k.push(uw(a, b, !1, c));
          });
        }
        return k;
      }
      d = a.ne(b);
      e = [];
      f = sw("~#", "cmap", "", !0, c);
      if (d) {
        for (;g < d.length;g += 2) {
          e.push(uw(a, d[g], !1, c)), e.push(uw(a, d[g + 1], !1, c));
        }
      } else {
        b.forEach(function(b, d) {
          e.push(uw(a, d, !1, c));
          e.push(uw(a, b, !1, c));
        });
      }
      return [f, e];
    }
    k = ["^ "];
    for (d = ev(b);g < d.length;g++) {
      k.push(uw(a, d[g], !0, c)), k.push(uw(a, b[d[g]], !1, c));
    }
    return k;
  }
  if (null != a.Kf) {
    return a.Kf(b, function(b) {
      return uw(a, b, !0, c);
    }, function(b) {
      return uw(a, b, !1, c);
    });
  }
  g = (null == b ? null : b.constructor).name;
  d = Error("Cannot write " + g);
  d.data = {Re:b, type:g};
  throw d;
}
function uw(a, b, c, d) {
  var e = a.jb(b) || (a.Cd ? a.Cd(b, a.Ca) : null), f = e ? e.tag(b) : null, g = e ? e.Z(b) : null;
  if (null != e && null != f) {
    switch(f) {
      case "_":
        return c ? sw("~", "_", "", c, d) : null;
      case "s":
        return 0 < g.length ? (a = g.charAt(0), a = "~" === a || "^" === a || "`" === a ? "~" + g : g) : a = g, sw("", "", a, c, d);
      case "?":
        return c ? sw("~", "?", g.toString()[0], c, d) : g;
      case "i":
        return Infinity === g ? sw("~", "z", "INF", c, d) : -Infinity === g ? sw("~", "z", "-INF", c, d) : isNaN(g) ? sw("~", "z", "NaN", c, d) : c || "string" === typeof g || g instanceof Ab ? sw("~", "i", g.toString(), c, d) : g;
      case "d":
        return c ? sw(g.mh, "d", g, c, d) : g;
      case "b":
        return sw("~", "b", g, c, d);
      case "'":
        return a.Qd ? (b = {}, c = sw("~#", "'", "", !0, d), b[c] = uw(a, g, !1, d), d = b) : d = [sw("~#", "'", "", !0, d), uw(a, g, !1, d)], d;
      case "array":
        return tw(a, g, d);
      case "map":
        return yw(a, g, d);
      default:
        a: {
          if (1 === f.length) {
            if ("string" === typeof g) {
              d = sw("~", f, g, c, d);
              break a;
            }
            if (c || a.he) {
              (a = a.Qd && new fw) ? (f = a.tag(b), g = a.ra(b, a)) : g = e.ra(b, e);
              if (null !== g) {
                d = sw("~", f, g, c, d);
                break a;
              }
              d = Error('Tag "' + f + '" cannot be encoded as string');
              d.data = {tag:f, Z:g, Re:b};
              throw d;
            }
          }
          b = f;
          c = g;
          a.Qd ? (g = {}, g[sw("~#", b, "", !0, d)] = uw(a, c, !1, d), d = g) : d = [sw("~#", b, "", !0, d), uw(a, c, !1, d)];
        }
        return d;
    }
  } else {
    throw d = (null == b ? null : b.constructor).name, a = Error("Cannot write " + d), a.data = {Re:b, type:d}, a;
  }
}
function zw(a, b) {
  var c = a.jb(b) || (a.Cd ? a.Cd(b, a.Ca) : null);
  if (null != c) {
    return 1 === c.tag(b).length ? rv("'", b) : b;
  }
  var c = (null == b ? null : b.constructor).name, d = Error("Cannot write " + c);
  d.data = {Re:b, type:c};
  throw d;
}
function Aw(a, b) {
  this.fd = a;
  this.options = b || {};
  this.cache = !1 === this.options.cache ? null : this.options.cache ? this.options.cache : new Mv;
}
Aw.prototype.Dg = function() {
  return this.fd;
};
Aw.prototype.marshaller = Aw.prototype.Dg;
Aw.prototype.write = function(a, b) {
  var c, d = b || {};
  c = d.asMapKey || !1;
  var e = this.fd.Qd ? !1 : this.cache;
  !1 === d.marshalTop ? c = uw(this.fd, a, c, e) : (d = this.fd, c = JSON.stringify(uw(d, zw(d, a), c, e)));
  null != this.cache && this.cache.clear();
  return c;
};
Aw.prototype.write = Aw.prototype.write;
Aw.prototype.register = function(a, b) {
  this.fd.Ca.set(a, b);
};
Aw.prototype.register = Aw.prototype.register;
function Bw(a, b) {
  if ("json" === a || "json-verbose" === a || null == a) {
    var c = new Sv(b);
    return new Tv(c, b);
  }
  throw Error("Cannot create reader of type " + a);
}
function Cw(a, b) {
  if ("json" === a || "json-verbose" === a || null == a) {
    "json-verbose" === a && (null == b && (b = {}), b.verbose = !0);
    var c = new rw(b);
    return new Aw(c, b);
  }
  c = Error('Type must be "json"');
  c.data = {type:a};
  throw c;
}
;zj.prototype.I = function(a, b) {
  return b instanceof zj ? this.Pb === b.Pb : b instanceof xv ? this.Pb === b.toString() : !1;
};
zj.prototype.zc = q;
zj.prototype.Zb = function(a, b) {
  if (b instanceof zj || b instanceof xv) {
    return ef(this.toString(), b.toString());
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
xv.prototype.zc = q;
xv.prototype.Zb = function(a, b) {
  if (b instanceof zj || b instanceof xv) {
    return ef(this.toString(), b.toString());
  }
  throw Error([y("Cannot compare "), y(this), y(" to "), y(b)].join(""));
};
Ab.prototype.I = function(a, b) {
  return this.equiv(b);
};
xv.prototype.I = function(a, b) {
  return b instanceof zj ? jd(b, this) : this.equiv(b);
};
qv.prototype.I = function(a, b) {
  return this.equiv(b);
};
Ab.prototype.Be = q;
Ab.prototype.V = function() {
  return nv.h ? nv.h(this) : nv.call(null, this);
};
xv.prototype.Be = q;
xv.prototype.V = function() {
  return Wd(this.toString());
};
qv.prototype.Be = q;
qv.prototype.V = function() {
  return nv.h ? nv.h(this) : nv.call(null, this);
};
xv.prototype.ka = q;
xv.prototype.W = function(a, b) {
  return td(b, [y('#uuid "'), y(this.toString()), y('"')].join(""));
};
function Dw(a, b) {
  for (var c = D(Xe(b)), d = null, e = 0, f = 0;;) {
    if (f < e) {
      var g = d.aa(null, f);
      a[g] = b[g];
      f += 1;
    } else {
      if (c = D(c)) {
        d = c, We(d) ? (c = Dd(d), f = Ed(d), d = c, e = O(c), c = f) : (c = G(d), a[c] = b[c], c = H(d), d = null, e = 0), f = 0;
      } else {
        break;
      }
    }
  }
  return a;
}
function Ew() {
}
Ew.prototype.Yc = function() {
  return vd(dg);
};
Ew.prototype.add = function(a, b, c) {
  return Tf.l(a, b, c);
};
Ew.prototype.be = function(a) {
  return xd(a);
};
Ew.prototype.Dc = function(a) {
  return Eh.l ? Eh.l(a, !0, !0) : Eh.call(null, a, !0, !0);
};
function Fw() {
}
Fw.prototype.Yc = function() {
  return vd(He);
};
Fw.prototype.add = function(a, b) {
  return Sf.j(a, b);
};
Fw.prototype.be = function(a) {
  return xd(a);
};
Fw.prototype.Dc = function(a) {
  return bh.j ? bh.j(a, !0) : bh.call(null, a, !0);
};
function Gw(a, b) {
  var c = Gf(a), d = Dw({handlers:gj(Ai.B(P([new u(null, 5, ["$", function() {
    return function(a) {
      return Zd.h(a);
    };
  }(c), ":", function() {
    return function(a) {
      return Ff.h(a);
    };
  }(c), "set", function() {
    return function(a) {
      return Gg.j(Ei, a);
    };
  }(c), "list", function() {
    return function(a) {
      return Gg.j(ae, a.reverse());
    };
  }(c), "cmap", function() {
    return function(a) {
      for (var b = 0, c = vd(dg);;) {
        if (b < a.length) {
          var d = b + 2, c = Tf.l(c, a[b], a[b + 1]), b = d
        } else {
          return xd(c);
        }
      }
    };
  }(c)], null), Nl.h(b)], 0))), mapBuilder:new Ew, arrayBuilder:new Fw, prefersStrings:!1}, gj(Le.j(b, Nl)));
  return Bw.j ? Bw.j(c, d) : Bw.call(null, c, d);
}
function Hw() {
}
Hw.prototype.tag = function() {
  return ":";
};
Hw.prototype.Z = function(a) {
  return a.fb;
};
Hw.prototype.ra = function(a) {
  return a.fb;
};
function Iw() {
}
Iw.prototype.tag = function() {
  return "$";
};
Iw.prototype.Z = function(a) {
  return a.ab;
};
Iw.prototype.ra = function(a) {
  return a.ab;
};
function Jw() {
}
Jw.prototype.tag = function() {
  return "list";
};
Jw.prototype.Z = function(a) {
  var b = [];
  a = D(a);
  for (var c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e);
      b.push(f);
      e += 1;
    } else {
      if (a = D(a)) {
        c = a, We(c) ? (a = Dd(c), e = Ed(c), c = a, d = O(a), a = e) : (a = G(c), b.push(a), a = H(c), c = null, d = 0), e = 0;
      } else {
        break;
      }
    }
  }
  return rv.j ? rv.j("array", b) : rv.call(null, "array", b);
};
Jw.prototype.ra = function() {
  return null;
};
function Kw() {
}
Kw.prototype.tag = function() {
  return "map";
};
Kw.prototype.Z = function(a) {
  return a;
};
Kw.prototype.ra = function() {
  return null;
};
function Lw() {
}
Lw.prototype.tag = function() {
  return "set";
};
Lw.prototype.Z = function(a) {
  var b = [];
  a = D(a);
  for (var c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e);
      b.push(f);
      e += 1;
    } else {
      if (a = D(a)) {
        c = a, We(c) ? (a = Dd(c), e = Ed(c), c = a, d = O(a), a = e) : (a = G(c), b.push(a), a = H(c), c = null, d = 0), e = 0;
      } else {
        break;
      }
    }
  }
  return rv.j ? rv.j("array", b) : rv.call(null, "array", b);
};
Lw.prototype.ra = function() {
  return null;
};
function Mw() {
}
Mw.prototype.tag = function() {
  return "array";
};
Mw.prototype.Z = function(a) {
  var b = [];
  a = D(a);
  for (var c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e);
      b.push(f);
      e += 1;
    } else {
      if (a = D(a)) {
        c = a, We(c) ? (a = Dd(c), e = Ed(c), c = a, d = O(a), a = e) : (a = G(c), b.push(a), a = H(c), c = null, d = 0), e = 0;
      } else {
        break;
      }
    }
  }
  return b;
};
Mw.prototype.ra = function() {
  return null;
};
function Nw() {
}
Nw.prototype.tag = function() {
  return "u";
};
Nw.prototype.Z = function(a) {
  return a.Pb;
};
Nw.prototype.ra = function(a) {
  return this.Z(a);
};
function Ow(a, b) {
  var c = new Hw, d = new Iw, e = new Jw, f = new Kw, g = new Lw, k = new Mw, l = new Nw, m = Ai.B(P([Ke([ei, Cf, u, $h, oh, F, X, zf, Hf, ih, nh, bi, zi, xh, T, xf, xe, Ci, vi, yi, eh, Fi, Lf, A, zj, Ki, ii], [f, e, f, e, e, e, c, e, e, k, e, e, e, e, k, e, e, g, f, e, e, g, e, d, l, e, e]), Nl.h(b)], 0)), n = Gf(a), t = Dw({objectBuilder:function(a, b, c, d, e, f, g, k, l) {
    return function(m, n, t) {
      return lf(function() {
        return function(a, b, c) {
          a.push(n.h ? n.h(b) : n.call(null, b), t.h ? t.h(c) : t.call(null, c));
          return a;
        };
      }(a, b, c, d, e, f, g, k, l), m);
    };
  }(n, c, d, e, f, g, k, l, m), handlers:function() {
    var a = Ac(m);
    a.forEach = function() {
      return function(a) {
        for (var b = D(this), c = null, d = 0, e = 0;;) {
          if (e < d) {
            var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
            a.j ? a.j(f, g) : a.call(null, f, g);
            e += 1;
          } else {
            if (b = D(b)) {
              We(b) ? (c = Dd(b), b = Ed(b), g = c, d = O(c), c = g) : (c = G(b), g = S(c, 0, null), f = S(c, 1, null), a.j ? a.j(f, g) : a.call(null, f, g), b = H(b), c = null, d = 0), e = 0;
            } else {
              return null;
            }
          }
        }
      };
    }(a, n, c, d, e, f, g, k, l, m);
    return a;
  }(), unpack:function() {
    return function(a) {
      return a instanceof u ? a.o : !1;
    };
  }(n, c, d, e, f, g, k, l, m)}, gj(Le.j(b, Nl)));
  return Cw.j ? Cw.j(n, t) : Cw.call(null, n, t);
}
;function Pw(a) {
  var b = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a;
  a = C.j(b, wo);
  var c = C.j(b, Rn), d = C.j(b, bm), e = C.j(b, Kn), b = C.j(b, Zn), f = y, g = new $q;
  ar(g, Gf(w(a) ? a : sn));
  cr(g, c);
  dr(g, d);
  er(g, e);
  fr(g, b, !0);
  return "" + f(g);
}
function Qw(a) {
  return ap("-", vg.j(bp, dp("" + y(a), /-/)));
}
function Rw(a) {
  return gj(Ii(vg.j(Qw, zh(a)), Ah(a)));
}
function Sw(a, b, c) {
  return Ow(b, c).write(a);
}
function Tw(a) {
  a = ya(Ma(a)) ? null : JSON.parse(a);
  return w(a) ? jj(a, P([kj, !0], 0)) : null;
}
function Uw(a) {
  a = gj(a);
  return JSON.stringify(a);
}
function Vw(a) {
  return xc(function(a, c) {
    var b = dp(c, /:\s+/), e = S(b, 0, null), b = S(b, 1, null);
    return ya(Ma(e)) || ya(Ma(b)) ? a : Je.l(a, e.toLowerCase(), b);
  }, dg, dp(w(a) ? a : "", /(\n)|(\r)|(\r\n)|(\n\r)/));
}
;var Ww, Xw = dg;
Ww = og ? og(Xw) : ng.call(null, Xw);
function Yw(a, b) {
  var c = Ii(vg.j(Qw, zh(b)), Ah(b));
  Li(vg.j(function() {
    return function(b) {
      var c = S(b, 0, null);
      b = S(b, 1, null);
      return a.headers.set(c, b);
    };
  }(c), c));
}
function Zw(a, b) {
  Tt(a, function() {
    if (J.j(ho, b)) {
      return "arraybuffer";
    }
    if (J.j(qm, b)) {
      return "blob";
    }
    if (J.j(jm, b)) {
      return "document";
    }
    if (J.j(Wo, b)) {
      return "text";
    }
    if (J.j(Ok, b) || J.j(null, b)) {
      return Ot;
    }
    throw Error([y("No matching clause: "), y(b)].join(""));
  }());
}
function $w(a) {
  var b = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a, c = C.j(b, um);
  a = C.j(b, rm);
  var d = C.j(b, Ek), b = Vn.h(b), b = w(b) ? b : 0, c = null == c ? !0 : c, e = new Nt;
  Yw(e, a);
  Zw(e, d);
  e.cd = Math.max(0, b);
  e.$e = c;
  return e;
}
var ax = Ke([0, 7, 1, 4, 6, 3, 2, 9, 5, 8], [gm, Rl, Do, to, Zl, zm, lk, Nj, Hn, Vn]);
function bx(a) {
  var b = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a, c = C.j(b, Fo), d = C.j(b, am), e = C.j(b, eo), f = C.j(b, um), g = C.j(b, Gn), k = C.j(b, ao), l = xq(null), m = Pw(b), n = Gf(w(c) ? c : bk), t = Rw(d), r = $w(b);
  sg.H(Ww, Je, l, r);
  ht(r, "complete", function(a, b, c, d, e, f, g, k, l, m, n, t, r) {
    return function(c) {
      c = c.target;
      var d = au(c), f = bu(c), g = du(c), k = Vw(c.getAllResponseHeaders()), l = new T(null, 2, 5, W, [b, String(c.Hd)], null), m;
      m = c.Ic;
      m = ax.h ? ax.h(m) : ax.call(null, m);
      c = new u(null, 7, [Lm, d, Bm, f, eo, g, am, k, yo, l, hm, m, hn, ha(c.pc) ? c.pc : String(c.pc)], null);
      kc(J.j(e.Ic, 7)) && Aq(a, c);
      sg.l(Ww, Le, a);
      w(r) && up(r);
      return up(a);
    };
  }(l, m, n, t, r, a, b, b, c, d, e, f, g, k));
  if (w(k)) {
    var v = function(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
      return function(a, b) {
        return Aq(v, Ai.B(P([new u(null, 2, [Ao, a, pl, b.loaded], null), w(b.lengthComputable) ? new u(null, 1, [tm, b.total], null) : null], 0)));
      };
    }(l, m, n, t, r, a, b, b, c, d, e, f, g, k);
    r.Qf = !0;
    ht(r, "uploadprogress", jg(v, Eo));
    ht(r, "downloadprogress", jg(v, jo));
  }
  r.send(m, n, e, t);
  w(g) && (v = xq(1), Wp(function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, ra) {
    return function() {
      var x = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (vb) {
                    if (vb instanceof Object) {
                      b[5] = vb, oq(b), c = Z;
                    } else {
                      throw vb;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(a, b, c, d, e, f, g, k, l, m, n, t, r, v) {
          return function(a) {
            var b = a[1];
            return 1 === b ? jq(a, 2, v) : 2 === b ? (b = kc(4 == $t(f)), a[7] = a[2], a[1] = b ? 3 : 4, Z) : 3 === b ? (b = f.abort(), a[2] = b, a[1] = 5, Z) : 4 === b ? (a[2] = null, a[1] = 5, Z) : 5 === b ? lq(a, a[2]) : null;
          };
        }(a, b, c, d, e, f, g, k, l, m, n, t, r, v, ra), a, b, c, d, e, f, g, k, l, m, n, t, r, v, ra);
      }(), K = function() {
        var b = x.v ? x.v() : x.call(null);
        b[6] = a;
        return b;
      }();
      return iq(K);
    };
  }(v, l, m, n, t, r, a, b, b, c, d, e, f, g, k)));
  return l;
}
function cx(a) {
  var b = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a, c = C.j(b, Vn), d = C.j(b, el), e = C.j(b, Gn), f = C.l(b, zo, !0), g = xq(null), k = new Ls(Pw(b), d);
  k.vc = c;
  var l = k.send(null, function(a, b, c, d, e, f, g, k, l) {
    return function(b) {
      b = new u(null, 3, [Lm, 200, Bm, !0, eo, jj(b, P([kj, l], 0))], null);
      Aq(a, b);
      sg.l(Ww, Le, a);
      w(k) && up(k);
      return up(a);
    };
  }(g, k, a, b, b, c, d, e, f), function(a, b, c, d, e, f, g, k) {
    return function() {
      sg.l(Ww, Le, a);
      w(k) && up(k);
      return up(a);
    };
  }(g, k, a, b, b, c, d, e, f));
  sg.H(Ww, Je, g, new u(null, 2, [mk, k, Yj, l], null));
  if (w(e)) {
    var m = xq(1);
    Wp(function(a, b, c, d, e, f, g, k, l, m, Q) {
      return function() {
        var n = function() {
          return function(a) {
            return function() {
              function b(b) {
                for (;;) {
                  var c;
                  a: {
                    try {
                      for (;;) {
                        var d = a(b);
                        if (!Y(d, Z)) {
                          c = d;
                          break a;
                        }
                      }
                    } catch (Aa) {
                      if (Aa instanceof Object) {
                        b[5] = Aa, oq(b), c = Z;
                      } else {
                        throw Aa;
                      }
                    }
                  }
                  if (!Y(c, Z)) {
                    return c;
                  }
                }
              }
              function c() {
                var a = [null, null, null, null, null, null, null, null];
                a[0] = d;
                a[1] = 1;
                return a;
              }
              var d = null, d = function(a) {
                switch(arguments.length) {
                  case 0:
                    return c.call(this);
                  case 1:
                    return b.call(this, a);
                }
                throw Error("Invalid arity: " + arguments.length);
              };
              d.v = c;
              d.h = b;
              return d;
            }();
          }(function(a, b, c, d, e, f, g, k, l, m) {
            return function(a) {
              var c = a[1];
              if (1 === c) {
                return jq(a, 2, m);
              }
              if (2 === c) {
                var c = a[2], e = d.cancel(b);
                a[7] = c;
                return lq(a, e);
              }
              return null;
            };
          }(a, b, c, d, e, f, g, k, l, m, Q), a, b, c, d, e, f, g, k, l, m, Q);
        }(), t = function() {
          var b = n.v ? n.v() : n.call(null);
          b[6] = a;
          return b;
        }();
        return iq(t);
      };
    }(m, l, g, k, a, b, b, c, d, e, f));
  }
  return g;
}
;function dx(a) {
  return ya(Ma(a)) ? null : xc(function(a, c) {
    var b = dp(c, /=/), e = S(b, 0, null), b = S(b, 1, null);
    return Je.l(a, Ff.h(dv(e)), dv(b));
  }, dg, dp("" + y(a), /&/));
}
function ex(a) {
  if (ya(Ma(a))) {
    return null;
  }
  a = a instanceof $q ? a.clone() : new $q(a, void 0);
  var b = a.yb, c = Ff.h(a.Wb), d = a.sc;
  return new u(null, 6, [wo, c, Rn, a.ac, bm, w(w(d) ? 0 < d : d) ? d : null, Kn, a.Vb, Zn, kc(b.Ne()) ? "" + y(b) : null, ln, kc(b.Ne()) ? dx("" + y(b)) : null], null);
}
function fx(a, b) {
  return [y(cv(Gf(a))), y("\x3d"), y(cv("" + y(b)))].join("");
}
function gx(a, b) {
  return ap("\x26", vg.j(function(b) {
    return fx(a, b);
  }, b));
}
function hx(a) {
  var b = S(a, 0, null);
  a = S(a, 1, null);
  return Qe(a) ? gx(b, a) : fx(b, a);
}
var Hi = Ii("()*\x26^%$#!+", vg.j(function(a) {
  return [y("\\"), y(a)].join("");
}, "()*\x26^%$#!+"));
function ix(a, b, c, d) {
  c = (d = $f.j(nm, d)) ? (d = $f.j(204, Lm.h(a))) ? Oi(Pi([y("(?i)"), y(kf(y, Gi(c)))].join("")), "" + y(C.l(am.h(a), "content-type", ""))) : d : d;
  return w(c) ? Jg.l(a, new T(null, 1, 5, W, [eo], null), b) : a;
}
function jx(a, b) {
  var c = S(b, 0, null);
  return function(b, c) {
    return function(b) {
      var d;
      d = rm.h(b);
      d = w(d) ? d : c;
      w(d) && (b = Je.l(b, rm, d));
      return a.h ? a.h(b) : a.call(null, b);
    };
  }(b, c);
}
function kx(a, b) {
  var c = S(b, 0, null);
  return function(b, c) {
    return function(b) {
      var d;
      d = Uo.h(b);
      d = w(d) ? d : c;
      w(d) && (b = Ig(b, new T(null, 2, 5, W, [am, "accept"], null), d));
      return a.h ? a.h(b) : a.call(null, b);
    };
  }(b, c);
}
function lx(a, b) {
  var c = S(b, 0, null);
  return function(b, c) {
    return function(b) {
      var d;
      d = pn.h(b);
      d = w(d) ? d : c;
      w(d) && (b = Ig(b, new T(null, 2, 5, W, [am, "content-type"], null), d));
      return a.h ? a.h(b) : a.call(null, b);
    };
  }(b, c);
}
var mx = new u(null, 4, [Gj, Tn, al, dg, Nn, Tn, Sm, dg], null);
function nx(a) {
  var b = new FormData;
  a = D(a);
  for (var c = null, d = 0, e = 0;;) {
    if (e < d) {
      var f = c.aa(null, e), g = S(f, 0, null), f = S(f, 1, null);
      Qe(f) ? b.append(Gf(g), G(f), Fe(f)) : b.append(Gf(g), f);
      e += 1;
    } else {
      if (a = D(a)) {
        We(a) ? (d = Dd(a), a = Ed(a), c = d, d = O(d)) : (d = G(a), c = S(d, 0, null), d = S(d, 1, null), Qe(d) ? b.append(Gf(c), G(d), Fe(d)) : b.append(Gf(c), d), a = H(a), c = null, d = 0), e = 0;
      } else {
        break;
      }
    }
  }
  return b;
}
function ox(a, b) {
  var c = S(b, 0, null);
  return function(b, c) {
    return function(b) {
      var d, e = no.h(b);
      d = w(e) ? e : c;
      if (Pe(d)) {
        return a.h ? a.h(b) : a.call(null, b);
      }
      b = Le.j(b, no);
      e = new T(null, 2, 5, W, [am, "authorization"], null);
      if (w(d)) {
        var f = Te(d) ? vg.j(d, new T(null, 2, 5, W, [hl, Lk], null)) : d;
        d = S(f, 0, null);
        f = S(f, 1, null);
        d = [y("Basic "), y(bv([y(d), y(":"), y(f)].join("")))].join("");
      } else {
        d = null;
      }
      b = Ig(b, e, d);
      return a.h ? a.h(b) : a.call(null, b);
    };
  }(b, c);
}
var px = function(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  return jx(arguments[0], 1 < b.length ? new F(b.slice(1), 0, null) : null);
}(function(a) {
  return function(b) {
    var c = xl.h(b);
    w(c) ? (b = a.h ? a.h(b) : a.call(null, b), c = Fq(b, c)) : c = a.h ? a.h(b) : a.call(null, b);
    return c;
  };
}(function(a) {
  return function(b) {
    var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, ln), e = ex(en.h(c));
    return w(e) ? (b = Jg.l(Le.j(Ai.B(P([c, e], 0)), en), new T(null, 1, 5, W, [ln], null), function(a, b, c, d, e, n) {
      return function(a) {
        return Ai.B(P([a, n], 0));
      };
    }(e, e, b, c, c, d)), a.h ? a.h(b) : a.call(null, b)) : a.h ? a.h(c) : a.call(null, c);
  };
}(function(a) {
  return function(b) {
    var c = Nk.h(b);
    w(c) && (b = Je.l(Le.j(b, Nk), Fo, c));
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  return function(b) {
    var c = un.h(b);
    w(c) && (b = Ig(Le.j(b, un), new T(null, 2, 5, W, [am, "authorization"], null), [y("Bearer "), y(c)].join("")));
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  return ox(arguments[0], 1 < b.length ? new F(b.slice(1), 0, null) : null);
}(function(a) {
  return function(b) {
    b = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b;
    var c = C.j(b, ln);
    w(c) && (b = Je.l(Le.j(b, ln), Zn, ap("\x26", vg.j(hx, c))));
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  return lx(arguments[0], 1 < b.length ? new F(b.slice(1), 0, null) : null);
}(function(a) {
  return function(b) {
    return Iq(function(a) {
      return ix(a, Tw, "application/json", Fo.h(b));
    }, new T(null, 1, 5, W, [a.h ? a.h(b) : a.call(null, b)], null));
  };
}(function(a) {
  return function(b) {
    var c = fk.h(b);
    if (w(c)) {
      var d = Ai.B(P([new u(null, 1, ["content-type", "application/json"], null), am.h(b)], 0));
      b = Je.l(Je.l(Le.j(b, fk), eo, Uw(c)), am, d);
    }
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  return function(b) {
    var c = Ai.B(P([mx, Yn.h(b)], 0)), d = null != c && (c.w & 64 || q === c.M) ? Vf(pg, c) : c, e = C.j(d, Nn), f = C.j(d, Sm);
    return Iq(function(a, c, d, e, f) {
      return function(a) {
        return ix(a, f, "application/transit+json", Fo.h(b));
      };
    }(c, d, e, f, function(a, b, c, d) {
      return function(a) {
        return Gw(c, d).read(a);
      };
    }(c, d, e, f)), new T(null, 1, 5, W, [a.h ? a.h(b) : a.call(null, b)], null));
  };
}(function(a) {
  return function(b) {
    var c = Mk.h(b);
    if (w(c)) {
      var d = Ai.B(P([mx, Yn.h(b)], 0)), e = null != d && (d.w & 64 || q === d.M) ? Vf(pg, d) : d, d = C.j(e, Gj), e = C.j(e, al), f = Ai.B(P([new u(null, 1, ["content-type", "application/transit+json"], null), am.h(b)], 0));
      b = Je.l(Je.l(Le.j(b, Mk), eo, Sw(c, d, e)), am, f);
    }
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  return function(b) {
    return Iq(function(a) {
      return ix(a, Tu, "application/edn", Fo.h(b));
    }, new T(null, 1, 5, W, [a.h ? a.h(b) : a.call(null, b)], null));
  };
}(function(a) {
  return function(b) {
    var c = ko.h(b);
    if (w(c)) {
      var d = Ai.B(P([new u(null, 1, ["content-type", "application/edn"], null), am.h(b)], 0));
      b = Je.l(Je.l(Le.j(b, ko), eo, aj(P([c], 0), cc())), am, d);
    }
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  return function(b) {
    b = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b;
    var c = C.j(b, ro), d = C.j(b, Fo);
    w(w(c) ? (new Ci(null, new u(null, 4, [vk, null, Cl, null, wn, null, Sn, null], null), null)).call(null, d) : c) && (b = Je.l(Le.j(b, ro), eo, nx(c)));
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  return function(b) {
    b = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b;
    var c = C.j(b, Em), d = C.j(b, Fo), e = C.j(b, am);
    w(w(c) ? (new Ci(null, new u(null, 4, [vk, null, Cl, null, wn, null, Sn, null], null), null)).call(null, d) : c) && (d = Ai.B(P([new u(null, 1, ["content-type", "application/x-www-form-urlencoded"], null), e], 0)), b = Je.l(Je.l(Le.j(b, Em), eo, ap("\x26", vg.j(hx, c))), am, d));
    return a.h ? a.h(b) : a.call(null, b);
  };
}(function(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  return kx(arguments[0], 1 < b.length ? new F(b.slice(1), 0, null) : null);
}(function(a) {
  a = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a;
  var b = C.j(a, Fo);
  return J.j(b, mk) ? cx(a) : bx(a);
})))))))))))))))));
function qx(a, b) {
  var c = S(b, 0, null), c = Ai.B(P([c, new u(null, 2, [Nk, bk, en, a], null)], 0));
  return px.h ? px.h(c) : px.call(null, c);
}
;var rx = Pi("/");
function sx(a) {
  if (Pe("" + y(a))) {
    return null;
  }
  a = J.j(a, "/") ? He : dp("" + y(a), rx);
  if (J.j(0, O(a))) {
    return new T(null, 1, 5, W, [Km], null);
  }
  switch(G(a)) {
    case "":
      return Wf(dh, Km, $d(a));
    case ".":
      return Wf(dh, ml, $d(a));
    default:
      return Wf(dh, ml, a);
  }
}
function tx(a) {
  switch(G(a) instanceof X ? G(a).fb : null) {
    case "root":
      return [y("/"), y(ap("/", $d(a)))].join("");
    case "cwd":
      return H(a) ? ap("/", $d(a)) : ".";
    default:
      return ap("/", a);
  }
}
function ux(a) {
  var b = new T(null, 1, 5, W, [G(a)], null);
  for (a = $d(a);;) {
    var c = D(a);
    a = G(c);
    var d = H(c), c = a;
    a = d;
    var d = J, e = c;
    if (w(d.j ? d.j(null, e) : d.call(null, null, e))) {
      return b;
    }
    if (!w(d.j ? d.j("", e) : d.call(null, "", e)) && !w(d.j ? d.j(".", e) : d.call(null, ".", e))) {
      if (w(d.j ? d.j("..", e) : d.call(null, "..", e))) {
        a: {
          for (c = b;;) {
            if (d = H(c), null != d) {
              c = d;
            } else {
              c = G(c);
              break a;
            }
          }
        }
        b = J.j(ml, c) ? Ge.j(b, "..") : J.j("..", c) ? Ge.j(b, "..") : J.j(Km, c) ? b : null == b ? null : Zc(b);
      } else {
        b = Ge.j(b, c);
      }
    }
  }
}
;function vx(a) {
  a = null == a ? null : "" + y(a);
  a = null == a ? null : encodeURIComponent(a);
  return null == a ? null : a.replace("+", "%20");
}
function wx(a) {
  a = null == a ? null : "" + y(a);
  return null == a ? null : decodeURIComponent(a);
}
function xx(a) {
  a = D(a);
  var b = null == a ? null : hf(a);
  a = null == b ? null : vg.j(function() {
    return function(a) {
      var b = S(a, 0, null);
      a = S(a, 1, null);
      return new T(null, 3, 5, W, [vx(Gf(b)), "\x3d", vx("" + y(a))], null);
    };
  }(a, b), b);
  a = null == a ? null : xg(Bg.j(zg("\x26"), a));
  a = null == a ? null : Fg(a);
  return null == a ? null : Vf(y, a);
}
function yx(a) {
  return wg.j(2, Rf.j(dp(a, /=/), zg("")));
}
function zx(a) {
  if (ya(Ma(a))) {
    return null;
  }
  a = dp(a, /&/);
  a = null == a ? null : D(a);
  null == a ? a = null : (a = P([a], 0), a = Vf(Rf, Wf(vg, yx, a)));
  a = null == a ? null : vg.j(wx, a);
  return null == a ? null : Vf(pg, a);
}
function Ax(a, b) {
  return !$f.j(null, b) || !$f.j(-1, b) || 80 === b && J.j(a, "http") || 443 === b && J.j(a, "https") ? null : [y(":"), y(b)].join("");
}
function Bx(a, b, c, d, e, f, g, k, l, m, n) {
  this.protocol = a;
  this.username = b;
  this.password = c;
  this.host = d;
  this.port = e;
  this.path = f;
  this.query = g;
  this.anchor = k;
  this.ta = l;
  this.ca = m;
  this.F = n;
  this.w = 2229667594;
  this.K = 8192;
}
h = Bx.prototype;
h.toString = function() {
  var a;
  a = this.username;
  var b = this.password;
  a = w(a) ? [y(a), y(":"), y(b)].join("") : null;
  return [y(this.protocol), y("://"), y(a), y(w(a) ? "@" : null), y(this.host), y(Ax(this.protocol, this.port)), y(this.path), y(D(this.query) ? [y("?"), y("string" === typeof this.query ? this.query : xx(this.query))].join("") : null), y(w(this.anchor) ? [y("#"), y(this.anchor)].join("") : null)].join("");
};
h.R = function(a, b) {
  return Oc.l(this, b, null);
};
h.N = function(a, b, c) {
  switch(b instanceof X ? b.fb : null) {
    case "protocol":
      return this.protocol;
    case "username":
      return this.username;
    case "password":
      return this.password;
    case "host":
      return this.host;
    case "port":
      return this.port;
    case "path":
      return this.path;
    case "query":
      return this.query;
    case "anchor":
      return this.anchor;
    default:
      return C.l(this.ca, b, c);
  }
};
h.W = function(a, b, c) {
  return Qi(b, function() {
    return function(a) {
      return Qi(b, Xi, "", " ", "", c, a);
    };
  }(this), "#cemerick.url.URL{", ", ", "}", c, Rf.j(new T(null, 8, 5, W, [new T(null, 2, 5, W, [Gk, this.protocol], null), new T(null, 2, 5, W, [hl, this.username], null), new T(null, 2, 5, W, [Lk, this.password], null), new T(null, 2, 5, W, [pm, this.host], null), new T(null, 2, 5, W, [Ol, this.port], null), new T(null, 2, 5, W, [Ej, this.path], null), new T(null, 2, 5, W, [Xn, this.query], null), new T(null, 2, 5, W, [Mn, this.anchor], null)], null), this.ca));
};
h.mb = function() {
  return new th(0, this, 8, new T(null, 8, 5, W, [Gk, hl, Lk, pm, Ol, Ej, Xn, Mn], null), w(this.ca) ? Ld(this.ca) : bg());
};
h.S = function() {
  return this.ta;
};
h.Xa = function() {
  return new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, this.query, this.anchor, this.ta, this.ca, this.F);
};
h.ja = function() {
  return 8 + O(this.ca);
};
h.V = function() {
  var a = this.F;
  return null != a ? a : this.F = a = uf(this);
};
h.I = function(a, b) {
  var c;
  c = w(b) ? (c = this.constructor === b.constructor) ? sh(this, b) : c : b;
  return w(c) ? !0 : !1;
};
h.Tc = function(a, b) {
  return cf(new Ci(null, new u(null, 8, [Ej, null, Gk, null, Lk, null, hl, null, Ol, null, pm, null, Mn, null, Xn, null], null), null), b) ? Le.j(Be(Gg.j(dg, this), this.ta), b) : new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, this.query, this.anchor, this.ta, ag(Le.j(this.ca, b)), null);
};
h.Qb = function(a, b, c) {
  return w(Y.j ? Y.j(Gk, b) : Y.call(null, Gk, b)) ? new Bx(c, this.username, this.password, this.host, this.port, this.path, this.query, this.anchor, this.ta, this.ca, null) : w(Y.j ? Y.j(hl, b) : Y.call(null, hl, b)) ? new Bx(this.protocol, c, this.password, this.host, this.port, this.path, this.query, this.anchor, this.ta, this.ca, null) : w(Y.j ? Y.j(Lk, b) : Y.call(null, Lk, b)) ? new Bx(this.protocol, this.username, c, this.host, this.port, this.path, this.query, this.anchor, this.ta, this.ca, 
  null) : w(Y.j ? Y.j(pm, b) : Y.call(null, pm, b)) ? new Bx(this.protocol, this.username, this.password, c, this.port, this.path, this.query, this.anchor, this.ta, this.ca, null) : w(Y.j ? Y.j(Ol, b) : Y.call(null, Ol, b)) ? new Bx(this.protocol, this.username, this.password, this.host, c, this.path, this.query, this.anchor, this.ta, this.ca, null) : w(Y.j ? Y.j(Ej, b) : Y.call(null, Ej, b)) ? new Bx(this.protocol, this.username, this.password, this.host, this.port, c, this.query, this.anchor, this.ta, 
  this.ca, null) : w(Y.j ? Y.j(Xn, b) : Y.call(null, Xn, b)) ? new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, c, this.anchor, this.ta, this.ca, null) : w(Y.j ? Y.j(Mn, b) : Y.call(null, Mn, b)) ? new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, this.query, c, this.ta, this.ca, null) : new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, this.query, this.anchor, this.ta, Je.l(this.ca, b, c), null);
};
h.ea = function() {
  return D(Rf.j(new T(null, 8, 5, W, [new T(null, 2, 5, W, [Gk, this.protocol], null), new T(null, 2, 5, W, [hl, this.username], null), new T(null, 2, 5, W, [Lk, this.password], null), new T(null, 2, 5, W, [pm, this.host], null), new T(null, 2, 5, W, [Ol, this.port], null), new T(null, 2, 5, W, [Ej, this.path], null), new T(null, 2, 5, W, [Xn, this.query], null), new T(null, 2, 5, W, [Mn, this.anchor], null)], null), this.ca));
};
h.T = function(a, b) {
  return new Bx(this.protocol, this.username, this.password, this.host, this.port, this.path, this.query, this.anchor, b, this.ca, this.F);
};
h.fa = function(a, b) {
  return Ve(b) ? Rc(this, Ic.j(b, 0), Ic.j(b, 1)) : xc(Gc, this, b);
};
function Cx(a, b, c) {
  return J.j(a, b) ? c : a;
}
function Dx(a) {
  var b = new $q(a);
  a = ep(function() {
    var a = b.wc;
    return w(a) ? a : "";
  }(), /:/, 2);
  var c = S(a, 0, null), d = S(a, 1, null);
  return new Bx(b.Wb, function() {
    var a = D(c);
    return a ? c : a;
  }(), function() {
    var a = D(d);
    return a ? d : a;
  }(), b.ac, Cx(b.sc, null, -1), tx(ux(sx(b.Vb))), zx(Cx(b.yb.toString(), "", null)), Cx(b.mc, "", null), null, null, null);
}
function Ex(a) {
  return a instanceof Bx ? a : Dx(a);
}
;function Fx(a, b, c) {
  if (yf(c)) {
    return c = Vf(Bf, vg.j(a, c)), b.h ? b.h(c) : b.call(null, c);
  }
  if ($e(c)) {
    return c = Mi(vg.j(a, c)), b.h ? b.h(c) : b.call(null, c);
  }
  if (Ue(c)) {
    return c = xc(function(b, c) {
      return Ge.j(b, a.h ? a.h(c) : a.call(null, c));
    }, c, c), b.h ? b.h(c) : b.call(null, c);
  }
  Qe(c) && (c = Gg.j(null == c ? null : Ec(c), vg.j(a, c)));
  return b.h ? b.h(c) : b.call(null, c);
}
var Gx = function Gx(b, c) {
  return Fx(jg(Gx, b), b, c);
};
function Hx(a) {
  return Gx(function(a) {
    return function(b) {
      return Te(b) ? Gg.j(dg, vg.j(a, b)) : b;
    };
  }(function(a) {
    var b = S(a, 0, null);
    a = S(a, 1, null);
    return "string" === typeof b ? new T(null, 2, 5, W, [Ff.h(b), a], null) : new T(null, 2, 5, W, [b, a], null);
  }), a);
}
;function Ix(a, b) {
  var c = w(a) ? Ex(a) : Ex(location.href);
  return "" + y(Ig(c, new T(null, 2, 5, W, [Xn, Gf(Ck)], null), b));
}
function Jx(a, b) {
  return function(c) {
    return function() {
      var d = xq(1);
      Wp(function(c, d) {
        return function() {
          var e = function() {
            return function(a) {
              return function() {
                function b(b) {
                  for (;;) {
                    var c;
                    a: {
                      try {
                        for (;;) {
                          var d = a(b);
                          if (!Y(d, Z)) {
                            c = d;
                            break a;
                          }
                        }
                      } catch (z) {
                        if (z instanceof Object) {
                          b[5] = z, oq(b), c = Z;
                        } else {
                          throw z;
                        }
                      }
                    }
                    if (!Y(c, Z)) {
                      return c;
                    }
                  }
                }
                function c() {
                  var a = [null, null, null, null, null, null, null, null, null, null];
                  a[0] = d;
                  a[1] = 1;
                  return a;
                }
                var d = null, d = function(a) {
                  switch(arguments.length) {
                    case 0:
                      return c.call(this);
                    case 1:
                      return b.call(this, a);
                  }
                  throw Error("Invalid arity: " + arguments.length);
                };
                d.v = c;
                d.h = b;
                return d;
              }();
            }(function(c, d) {
              return function(c) {
                var e = c[1];
                if (1 === e) {
                  var e = sg.j(d, je), f = vq(b);
                  c[7] = e;
                  return jq(c, 2, f);
                }
                if (2 === e) {
                  var e = c[2], f = sg.j(d, of), g = 0 === (L.h ? L.h(d) : L.call(null, d));
                  c[8] = e;
                  c[9] = f;
                  c[1] = w(g) ? 3 : 4;
                  return Z;
                }
                return 3 === e ? (e = a.v ? a.v() : a.call(null), c[2] = e, c[1] = 5, Z) : 4 === e ? (c[2] = null, c[1] = 5, Z) : 5 === e ? lq(c, c[2]) : null;
              };
            }(c, d), c, d);
          }(), f = function() {
            var a = e.v ? e.v() : e.call(null);
            a[6] = c;
            return a;
          }();
          return iq(f);
        };
      }(d, c));
      return d;
    };
  }(og ? og(0) : ng.call(null, 0));
}
function Kx(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            if (7 === c) {
              return b[2] = !1, b[1] = 8, Z;
            }
            if (1 === c) {
              return b[1] = w(a) ? 2 : 3, Z;
            }
            if (4 === c) {
              return lq(b, b[2]);
            }
            if (15 === c) {
              var c = b[7], d = b[8], c = [y('"'), y("Wrong gist path: "), y(c), y("\n"), y("gist-id\x3d "), y(a), y("\n"), y("http status: "), y(d), y('"')].join("");
              b[2] = c;
              b[1] = 17;
              return Z;
            }
            if (13 === c) {
              return c = b[9], b[2] = c, b[1] = 14, Z;
            }
            if (6 === c) {
              return c = b[9], d = q === c.M, b[1] = w(c.w & 64 || d) ? 9 : 10, Z;
            }
            if (17 === c) {
              return b[2] = b[2], b[1] = 4, Z;
            }
            if (3 === c) {
              return b[2] = null, b[1] = 4, Z;
            }
            if (12 === c) {
              return c = b[9], c = Vf(pg, c), b[2] = c, b[1] = 14, Z;
            }
            if (2 === c) {
              return c = [y("https://gist.githubusercontent.com/"), y(a), y("/raw"), y("?"), y(1 * Math.random())].join(""), d = Ke([um], [!1]), d = qx(c, P([d], 0)), b[7] = c, jq(b, 5, d);
            }
            if (11 === c) {
              return b[2] = b[2], b[1] = 8, Z;
            }
            if (9 === c) {
              return b[2] = !0, b[1] = 11, Z;
            }
            if (5 === c) {
              return c = b[2], d = kc(null == c), b[9] = c, b[1] = d ? 6 : 7, Z;
            }
            if (14 === c) {
              var d = b[2], c = C.j(d, Lm), d = C.j(d, eo), e = !J.j(c, 200);
              b[10] = d;
              b[8] = c;
              b[1] = e ? 15 : 16;
              return Z;
            }
            return 16 === c ? (d = b[10], b[2] = d, b[1] = 17, Z) : 10 === c ? (b[2] = !1, b[1] = 11, Z) : 8 === c ? (b[1] = w(b[2]) ? 12 : 13, Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}
function Lx(a) {
  return function(b) {
    return function() {
      function c(a) {
        var b = null;
        if (0 < arguments.length) {
          for (var b = 0, c = Array(arguments.length - 0);b < c.length;) {
            c[b] = arguments[b + 0], ++b;
          }
          b = new F(c, 0);
        }
        return d.call(this, b);
      }
      function d(c) {
        if (w(L.h ? L.h(b) : L.call(null, b))) {
          return null;
        }
        rg.j ? rg.j(b, !0) : rg.call(null, b, !0);
        return Vf(a, c);
      }
      c.L = 0;
      c.J = function(a) {
        a = D(a);
        return d(a);
      };
      c.B = d;
      return c;
    }();
  }(og ? og(!1) : ng.call(null, !1));
}
function Mx(a) {
  return function(b) {
    return function() {
      function c(a) {
        var b = null;
        if (0 < arguments.length) {
          for (var b = 0, c = Array(arguments.length - 0);b < c.length;) {
            c[b] = arguments[b + 0], ++b;
          }
          b = new F(c, 0);
        }
        return d.call(this, b);
      }
      function d(c) {
        var d = xq(1);
        Wp(function(b, d) {
          return function() {
            var e = function() {
              return function(a) {
                return function() {
                  function b(b) {
                    for (;;) {
                      var c;
                      a: {
                        try {
                          for (;;) {
                            var d = a(b);
                            if (!Y(d, Z)) {
                              c = d;
                              break a;
                            }
                          }
                        } catch (I) {
                          if (I instanceof Object) {
                            b[5] = I, oq(b), c = Z;
                          } else {
                            throw I;
                          }
                        }
                      }
                      if (!Y(c, Z)) {
                        return c;
                      }
                    }
                  }
                  function c() {
                    var a = [null, null, null, null, null, null, null, null, null];
                    a[0] = d;
                    a[1] = 1;
                    return a;
                  }
                  var d = null, d = function(a) {
                    switch(arguments.length) {
                      case 0:
                        return c.call(this);
                      case 1:
                        return b.call(this, a);
                    }
                    throw Error("Invalid arity: " + arguments.length);
                  };
                  d.v = c;
                  d.h = b;
                  return d;
                }();
              }(function(b, d) {
                return function(b) {
                  var e = b[1];
                  if (1 === e) {
                    return e = L.h ? L.h(d) : L.call(null, d), e = !cf(e, c), b[1] = e ? 2 : 3, Z;
                  }
                  if (2 === e) {
                    return e = Vf(a, c), jq(b, 5, e);
                  }
                  if (3 === e) {
                    return e = L.h ? L.h(d) : L.call(null, d), e = C.j(e, c), b[2] = e, b[1] = 4, Z;
                  }
                  if (4 === e) {
                    return lq(b, b[2]);
                  }
                  if (5 === e) {
                    var e = b[2], f = G(e), f = J.j(Pm, f);
                    b[7] = e;
                    b[1] = f ? 6 : 7;
                    return Z;
                  }
                  return 6 === e ? (e = b[7], e = sg.H(d, Je, c, e), b[2] = e, b[1] = 8, Z) : 7 === e ? (b[2] = null, b[1] = 8, Z) : 8 === e ? (e = b[7], b[8] = b[2], b[2] = e, b[1] = 4, Z) : null;
                };
              }(b, d), b, d);
            }(), f = function() {
              var a = e.v ? e.v() : e.call(null);
              a[6] = b;
              return a;
            }();
            return iq(f);
          };
        }(d, b));
        return d;
      }
      c.L = 0;
      c.J = function(a) {
        a = D(a);
        return d(a);
      };
      c.B = d;
      return c;
    }();
  }(function() {
    var a = dg;
    return og ? og(a) : ng.call(null, a);
  }());
}
var Nx = eval, Ox = Mx(function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            if (7 === c) {
              return b[2] = !1, b[1] = 8, Z;
            }
            if (1 === c) {
              var c = console.info("loading:", a), d = Ke([um], [!1]), d = qx(a, P([d], 0));
              b[7] = c;
              return jq(b, 2, d);
            }
            if (4 === c) {
              return b[2] = !1, b[1] = 5, Z;
            }
            if (13 === c) {
              return b[2] = new T(null, 2, 5, W, [b[8], a], null), b[1] = 14, Z;
            }
            if (6 === c) {
              return b[2] = !0, b[1] = 8, Z;
            }
            if (3 === c) {
              return c = b[9], d = q === c.M, b[1] = w(c.w & 64 || d) ? 6 : 7, Z;
            }
            if (12 === c) {
              var c = b[10], d = console.info("evaluating:", a), e = Nx.h ? Nx.h(c) : Nx.call(null, c), c = new T(null, 2, 5, W, [Pm, a], null);
              b[11] = e;
              b[12] = d;
              b[2] = c;
              b[1] = 14;
              return Z;
            }
            return 2 === c ? (c = b[2], d = kc(null == c), b[9] = c, b[1] = d ? 3 : 4, Z) : 11 === c ? (c = b[2], d = C.j(c, Lm), c = C.j(c, eo), e = J.j(200, d), b[8] = d, b[10] = c, b[1] = e ? 12 : 13, Z) : 9 === c ? (c = b[9], c = Vf(pg, c), b[2] = c, b[1] = 11, Z) : 5 === c ? (b[1] = w(b[2]) ? 9 : 10, Z) : 14 === c ? lq(b, b[2]) : 10 === c ? (c = b[9], b[2] = c, b[1] = 11, Z) : 8 === c ? (b[2] = b[2], b[1] = 5, Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
});
function Px(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            if (7 === c) {
              var d = b[2], c = S(d, 0, null), d = S(d, 1, null), e = J.j(Pm, c);
              b[7] = c;
              b[8] = d;
              b[1] = e ? 8 : 9;
              return Z;
            }
            return 1 === c ? (c = a, b[9] = c, b[2] = null, b[1] = 2, Z) : 4 === c ? (c = b[9], c = G(c), c = "" + y(c), c = Ox.h ? Ox.h(c) : Ox.call(null, c), jq(b, 7, c)) : 6 === c ? (b[2] = b[2], b[1] = 3, Z) : 3 === c ? lq(b, b[2]) : 2 === c ? (c = b[9], c = D(c), b[1] = c ? 4 : 5, Z) : 9 === c ? (b[2] = null, b[1] = 10, Z) : 5 === c ? (b[2] = new T(null, 1, 5, W, [Pm], null), b[1] = 6, Z) : 10 === c ? (c = b[7], d = b[8], c = new T(null, 2, 5, W, [c, d], null), b[10] = b[2], b[2] = c, b[1] = 
            6, Z) : 8 === c ? (c = b[9], c = $d(c), b[9] = c, b[2] = null, b[1] = 2, Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}
var Qx = Mx(Px);
var Rx = null, Sx = Lx(function() {
  return Rx = new SQL.Database;
}), Tx = new u(null, 4, [fn, "text/x-sql", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            if (1 === c) {
              return b[2] = null, b[1] = 4, Z;
            }
            if (2 === c) {
              return lq(b, b[2]);
            }
            if (3 === c) {
              return c = b[2], b[2] = c, oq(b), Z;
            }
            if (4 === c) {
              nq(b, 3, Ok, null, 2);
              var d = Sx.v ? Sx.v() : Sx.call(null), c = SQL.runQuery.call(SQL, Rx, a);
              b[7] = d;
              b[2] = c;
              oq(b);
              return Z;
            }
            return null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 4, 5, W, [Oq("sql"), "https://viebel.github.io/klipse/repo/js/sql-formatter.min.js", "https://viebel.github.io/klipse/repo/js/sql.js", "https://gist.githubusercontent.com/viebel/fc86366093c27aca0adc103b1d20190d/raw"], null), Kl, "--"], null);
Pq("eval-sql", "selector_sql", Tx);
var Ux = eval;
function Vx(a) {
  var b = Babel;
  return b.transform.call(b, a, {presets:["react"]}).code;
}
var Wx = new u(null, 5, [fn, "text/jsx", Bk, "javascript", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            return 1 === c ? (b[2] = null, b[1] = 4, Z) : 2 === c ? lq(b, b[2]) : 3 === c ? (c = "" + y(b[2]), b[2] = c, oq(b), Z) : 4 === c ? (nq(b, 3, Ok, null, 2), c = Vx(a), c = Ux.h ? Ux.h(c) : Ux.call(null, c), b[7] = c, b[2] = "//Evaluation done", oq(b), Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 4, 5, W, [Oq("xml"), Oq("javascript"), Oq("jsx"), "https://cdnjs.cloudflare.com/ajax/libs/babel-standalone/6.18.1/babel.min.js"], null), Kl, "//"], null), Xx = new u(null, 5, [fn, "text/jsx", Bk, "javascript", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            return 1 === c ? (b[2] = null, b[1] = 4, Z) : 2 === c ? lq(b, b[2]) : 3 === c ? (c = "" + y(b[2]), b[2] = c, oq(b), Z) : 4 === c ? (nq(b, 3, Ok, null, 2), c = Vx(a), b[2] = c, oq(b), Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 4, 5, W, [Oq("xml"), Oq("javascript"), Oq("jsx"), "https://cdnjs.cloudflare.com/ajax/libs/babel-standalone/6.18.1/babel.min.js"], null), Kl, "//"], null);
Pq("eval-jsx", "selector_jsx", Wx);
Pq("transpile-jsx", "selector_transpile_jsx", Xx);
var Yx = Lx(function() {
  var a = Opal;
  return a.load.call(a, "opal-parser");
}), Zx = new u(null, 5, [fn, "ruby", Bk, "ruby", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            return 1 === c ? (c = Yx.v ? Yx.v() : Yx.call(null), b[7] = c, b[2] = null, b[1] = 4, Z) : 2 === c ? lq(b, b[2]) : 3 === c ? (c = "" + y(b[2]), b[2] = c, oq(b), Z) : 4 === c ? (nq(b, 3, Object, null, 2), c = Opal.eval.call(Opal, a), c = c.$inspect.call(c), b[2] = c, oq(b), Z) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 3, 5, W, [Oq("ruby"), "https://viebel.github.io/klipse/repo/js/opal.min.js?p", "https://viebel.github.io/klipse/repo/js/opal-parser.min.js?p"], null), Kl, "#"], null);
Pq("eval-ruby", "selector_eval_ruby", Zx);
function $x(a, b) {
  return w(a) ? Tu(a) : b;
}
function ay(a, b) {
  var c = xq(1);
  Wp(function(c) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (v) {
                    if (v instanceof Object) {
                      b[5] = v, oq(b), c = Z;
                    } else {
                      throw v;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(c) {
            var d = c[1];
            if (1 === d) {
              return d = a.dataset.gistId, c[7] = d, c[1] = w(d) ? 2 : 3, Z;
            }
            if (2 === d) {
              return d = c[7], c[2] = d, c[1] = 4, Z;
            }
            if (3 === d) {
              return c[2] = null, c[1] = 4, Z;
            }
            if (4 === d) {
              var e, d = c[2];
              c[8] = d;
              c[1] = w(d) ? 5 : 6;
              return Z;
            }
            return 5 === d ? (e = c[8], d = Kx(e), jq(c, 8, d)) : 6 === d ? (c[2] = null, c[1] = 7, Z) : 7 === d ? lq(c, c[2]) : 8 === d ? (e = c[8], d = c[2], e = [y("https://gist.github.com/"), y(e)].join(""), e = [y("loaded from gist: "), y(e)].join(""), d = [y(b), y(e), y("\n"), y(d)].join(""), c[2] = d, c[1] = 7, Z) : null;
          };
        }(c), c);
      }(), f = function() {
        var a = d.v ? d.v() : d.call(null);
        a[6] = c;
        return a;
      }();
      return iq(f);
    };
  }(c));
  return c;
}
function by(a, b) {
  var c = xq(1);
  Wp(function(c) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (v) {
                    if (v instanceof Object) {
                      b[5] = v, oq(b), c = Z;
                    } else {
                      throw v;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(c) {
            var d = c[1];
            return 1 === d ? (d = ay(a, b), jq(c, 2, d)) : 2 === d ? (d = c[2], c[7] = d, c[1] = w(d) ? 3 : 4, Z) : 3 === d ? (d = c[7], c[2] = d, c[1] = 5, Z) : 4 === d ? (c[2] = a.textContent, c[1] = 5, Z) : 5 === d ? lq(c, c[2]) : null;
          };
        }(c), c);
      }(), f = function() {
        var a = d.v ? d.v() : d.call(null);
        a[6] = c;
        return a;
      }();
      return iq(f);
    };
  }(c));
  return c;
}
function cy(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, hc), e = C.j(c, bl), f = C.j(c, Bo), g = a.dataset, c = $x(g.staticFns, !1), k = $x(g.asyncCode, !1), l = $x(g.verbose, !1), m = $x(g.compileDisplayGuard, !1), f = $x(g.evalContext, f), n = g.maxEvalDuration, d = $x(g.printLength, d), e = $x(g.beautifyStrings, e), g = g.externalLibs, g = w(g) ? g : null, g = w(g) ? vg.j(fp, dp(g, ",")) : null;
  return Ke([Wj, kk, bl, nl, Al, sm, hc, vn, Mo], [g, c, e, k, l, m, d, f, n]);
}
;function dy(a, b) {
  var c;
  c = gj(b);
  c = As("div", c, document.createTextNode(""));
  a.parentNode && a.parentNode.insertBefore(c, a.nextSibling);
  return c;
}
function ey(a, b) {
  a.addEventListener.call(a, "input", b);
}
;if (w(window.initMirrorCustomExtensions)) {
  var fy = window;
  fy.initMirrorCustomExtensions.call(fy);
}
var gy = CodeMirror;
function hy(a, b) {
  a.setValue(b);
  return a;
}
function iy(a, b) {
  a.on("change", b);
}
function jy(a, b) {
  a.setOption("extraKeys", b);
}
if ("undefined" === typeof ky) {
  var ky = function() {
    var a = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), b = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), c = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), d = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), e = C.l(dg, co, mj());
    return new xj(Zd.j("klipse.ui.editors.editor", "beautify-language"), function() {
      return function(a, b) {
        return b;
      };
    }(a, b, c, d, e), Ok, e, a, b, c, d);
  }()
}
yj(ky, Ok, function(a) {
  return a;
});
yj(ky, "text/x-sql", function(a) {
  var b;
  b = sqlFormatter;
  b = b.format.call(b, a.getValue());
  return hy(a, b);
});
function ly(a, b, c) {
  c = null != c && (c.w & 64 || q === c.M) ? Vf(pg, c) : c;
  var d = C.j(c, ak);
  c = C.j(c, Lo);
  if (w(d)) {
    d = gy.commands;
    d.selectAll.call(d, a);
    var d = a.getCursor(!0), e = a.getCursor(!1);
    a.autoIndentRange.call(a, d, e);
    d = gy.commands;
    d.goDocStart.call(d, a);
  }
  a = hy(a, ap("\n", Af(yg(gp, Af(yg(gp, dp(a.getValue(), /\n|\r\n/)))))));
  a = w(c) ? J.j("clojure", b) ? hy(a, ap("\n", Af(yg(jp, Af(dp(a.getValue(), /\n|\r\n/)))))) : a : a;
  return ky.j ? ky.j(a, b) : ky.call(null, a, b);
}
function my(a, b, c, d) {
  var e = null != c && (c.w & 64 || q === c.M) ? Vf(pg, c) : c, f = C.j(e, ol), g = null != d && (d.w & 64 || q === d.M) ? Vf(pg, d) : d, k = C.l(g, ak, !0), l = C.l(g, Lo, !0), m = function() {
    var b = function() {
      return function(b) {
        var c = a.parentNode;
        c && c.replaceChild(b, a);
      };
    }(c, e, e, f, d, g, k, l), m = gj(e);
    return CodeMirror(b, m);
  }();
  return ly(hy(m, b), f, new u(null, 2, [ak, k, Lo, l], null));
}
function ny(a, b, c) {
  var d = P([ak, !1, Lo, !1], 0), e = null != d && (d.w & 64 || q === d.M) ? Vf(pg, d) : d, d = C.l(e, Lo, !1), e = C.l(e, ak, !1);
  return my(dy(a, dg), b, c, P([Lo, d, ak, e], 0));
}
;function oy(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Tk), e = C.j(c, hk), f = C.l(c, Sl, null);
  iy(a, Jx(d, e));
  jy(a, {"Ctrl-S":function(b, c, d, e, f) {
    return function() {
      var b = a.getValue(), b = Ix(f, b);
      bj.B(P([b], 0));
      alert(b);
      return b;
    };
  }(b, c, d, e, f), "Ctrl-R":function(b, c, d, e, f) {
    return function() {
      var b = a.getValue(), b = Ix(f, b);
      return location.replace(b);
    };
  }(b, c, d, e, f), "Ctrl-Enter":d});
}
;var py, qy, ry, sy;
var ty = function ty(b, c) {
  if (null != b && null != b.wd) {
    return b.wd(b, c);
  }
  var d = ty[p(null == b ? null : b)];
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  d = ty._;
  if (null != d) {
    return d.j ? d.j(b, c) : d.call(null, b, c);
  }
  throw qc("Spec.with-gen*", b);
};
if ("undefined" === typeof uy) {
  var uy, vy = dg;
  uy = og ? og(vy) : ng.call(null, vy);
}
function wy(a) {
  return null != a ? a.K & 4096 || q === a.pf ? !0 : !1 : !1;
}
function xy(a, b) {
  return Be(a, Je.l(Oe(a), vm, b));
}
function yy(a) {
  if (w(wy(a))) {
    for (var b = L.h ? L.h(uy) : L.call(null, uy), c = a;;) {
      if (w(wy(c))) {
        c = C.j(b, c);
      } else {
        return w(c) ? xy(c, a) : null;
      }
    }
  } else {
    return a;
  }
}
function zy(a) {
  var b = null != a ? q === a.Yd ? !0 : !1 : !1;
  return b ? a : b;
}
function Ay(a) {
  var b = lo.h(a);
  return w(b) ? a : b;
}
function By(a) {
  var b = function() {
    var b = zy(a);
    if (w(b)) {
      return b;
    }
    b = Ay(a);
    if (w(b)) {
      return b;
    }
    b = wy(a);
    b = w(b) ? yy(a) : b;
    return w(b) ? b : null;
  }();
  return w(Ay(b)) ? xy(Cy.j ? Cy.j(b, null) : Cy.call(null, b, null), b instanceof X ? b : null != b && (b.w & 131072 || q === b.nf) ? vm.h(Oe(b)) : null) : b;
}
function Dy(a) {
  var b = By(a);
  if (w(b)) {
    return b;
  }
  if (w(wy(a))) {
    throw Error([y("Unable to resolve spec: "), y(a)].join(""));
  }
  return null;
}
function Ey(a, b) {
  var c = yy(a);
  if (w(Ay(c))) {
    c = Je.l(c, Jn, b);
  } else {
    var d = Dy(c), c = w(d) ? d : Fy ? Fy(xm, c, null, null) : Gy.call(null, xm, c, null, null), c = ty(c, b)
  }
  return c;
}
function Hy(a, b, c) {
  if (!w(function() {
    var b = wy(a);
    return w(b) ? Ef(a) : b;
  }())) {
    throw Error([y("Assert failed: "), y("k must be namespaced keyword or resolveable symbol"), y("\n"), y("(c/and (named? k) (namespace k))")].join(""));
  }
  b = w(function() {
    var a = zy(c);
    if (w(a)) {
      return a;
    }
    a = Ay(c);
    return w(a) ? a : C.j(L.h ? L.h(uy) : L.call(null, uy), c);
  }()) ? c : Fy ? Fy(b, c, null, null) : Gy.call(null, b, c, null, null);
  sg.H(uy, Je, a, b);
}
var Iy = function Iy(b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Vo), e = C.j(c, Hj), f = C.j(c, Ij), g = C.j(c, Uj), k = C.j(c, Xj), l = C.j(c, pk), m = C.j(c, cl), n = C.j(c, om), t = C.j(c, $m), r = C.j(c, mn), v = C.j(c, An), x = Vf(ug, k), z = Ii(Rf.j(t, l), Rf.j(m, r)), B = function(b, c) {
    return function(b) {
      var d = c.h ? c.h(b) : c.call(null, b);
      return w(d) ? d : b;
    };
  }(x, z, b, c, c, d, e, f, g, k, l, m, n, t, r, v), I = Aj();
  "undefined" === typeof py && (py = function(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B, I, Qa, ab) {
    this.Cg = b;
    this.Rg = c;
    this.dh = d;
    this.Ug = e;
    this.Ec = f;
    this.Wg = g;
    this.Ag = k;
    this.ef = l;
    this.Sg = m;
    this.bh = n;
    this.zg = t;
    this.$g = r;
    this.id = v;
    this.ah = x;
    this.Tg = z;
    this.yg = B;
    this.Vg = I;
    this.Xg = Qa;
    this.Kg = ab;
    this.w = 393216;
    this.K = 0;
  }, py.prototype.T = function() {
    return function(b, c) {
      return new py(this.Cg, this.Rg, this.dh, this.Ug, this.Ec, this.Wg, this.Ag, this.ef, this.Sg, this.bh, this.zg, this.$g, this.id, this.ah, this.Tg, this.yg, this.Vg, this.Xg, c);
    };
  }(x, z, B, I, b, c, c, d, e, f, g, k, l, m, n, t, r, v), py.prototype.S = function() {
    return function() {
      return this.Kg;
    };
  }(x, z, B, I, b, c, c, d, e, f, g, k, l, m, n, t, r, v), py.prototype.Yd = q, py.prototype.wd = function() {
    return function(b, c) {
      var d = Je.l(this.ef, Uj, c);
      return Iy.h ? Iy.h(d) : Iy.call(null, d);
    };
  }(x, z, B, I, b, c, c, d, e, f, g, k, l, m, n, t, r, v), py.cc = function() {
    return function() {
      return new T(null, 19, 5, W, [Qj, zk, Jk, Kk, dl, jl, kl, ul, zl, em, Zm, Bn, $n, io, uo, No, Oo, Yo, im], null);
    };
  }(x, z, B, I, b, c, c, d, e, f, g, k, l, m, n, t, r, v), py.Db = !0, py.ob = "cljs.spec/t_cljs$spec68543", py.Rb = function() {
    return function(b, c) {
      return td(c, "cljs.spec/t_cljs$spec68543");
    };
  }(x, z, B, I, b, c, c, d, e, f, g, k, l, m, n, t, r, v));
  return new py(c, d, e, f, g, k, x, c, l, m, B, n, I, t, r, z, b, v, dg);
};
function Gy(a) {
  for (var b = [], c = arguments.length, d = 0;;) {
    if (d < c) {
      b.push(arguments[d]), d += 1;
    } else {
      break;
    }
  }
  switch(b.length) {
    case 4:
      return Fy(arguments[0], arguments[1], arguments[2], arguments[3]);
    case 5:
      return Jy(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    default:
      throw Error([y("Invalid arity: "), y(b.length)].join(""));;
  }
}
function Fy(a, b, c, d) {
  return Jy(a, b, c, d, null);
}
function Jy(a, b, c, d, e) {
  if (w(zy(b))) {
    return w(c) ? Ey(b, c) : b;
  }
  if (w(Ay(b))) {
    return Cy.j ? Cy.j(b, c) : Cy.call(null, b, c);
  }
  if (w(wy(b))) {
    return a = Dy(b), w(c) ? Ey(a, c) : a;
  }
  "undefined" === typeof qy && (qy = function(a, b, c, d, e, n) {
    this.form = a;
    this.Pf = b;
    this.Ec = c;
    this.zf = d;
    this.Wf = e;
    this.Lg = n;
    this.w = 393216;
    this.K = 0;
  }, qy.prototype.T = function(a, b) {
    return new qy(this.form, this.Pf, this.Ec, this.zf, this.Wf, b);
  }, qy.prototype.S = function() {
    return this.Lg;
  }, qy.prototype.Yd = q, qy.prototype.wd = function(a, b) {
    return Jy(this.form, this.Pf, b, this.zf, this.Wf);
  }, qy.cc = function() {
    return new T(null, 6, 5, W, [Bj, Fl, dl, rl, Mj, ck], null);
  }, qy.Db = !0, qy.ob = "cljs.spec/t_cljs$spec68585", qy.Rb = function(a, b) {
    return td(b, "cljs.spec/t_cljs$spec68585");
  });
  return new qy(a, b, c, d, e, dg);
}
var Ky = function Ky(b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Ko);
  b = D(d);
  var e = G(b);
  b = H(b);
  var f = C.j(c, Hk), g = D(f), k = G(g), g = H(g), l = C.j(c, Go), m = D(l);
  G(m);
  var m = H(m), n = C.j(c, Rj), c = C.j(c, gk);
  if (eg(mf, d)) {
    var t;
    t = null != e && (e.w & 64 || q === e.M) ? Vf(pg, e) : e;
    t = C.j(t, lo);
    t = J.j(kn, t);
    return w(t) ? (d = Rj.h(e), d = Ge.j(n, w(f) ? Eh([k, d], !0, !1) : d), b ? (b = new u(null, 4, [Ko, b, Hk, g, Go, m, Rj, d], null), Ky.h ? Ky.h(b) : Ky.call(null, b)) : new u(null, 2, [lo, kn, Rj, d], null)) : new u(null, 6, [lo, Vl, Ko, d, Rj, n, Hk, f, Go, l, gk, c], null);
  }
  return null;
};
function Ly(a, b, c) {
  return Ky(new u(null, 4, [Hk, a, Ko, b, Go, c, Rj, dg], null));
}
var Cy = function Cy(b, c) {
  "undefined" === typeof ry && (ry = function(b, c, f) {
    this.Te = b;
    this.Ec = c;
    this.Mg = f;
    this.w = 393216;
    this.K = 0;
  }, ry.prototype.T = function(b, c) {
    return new ry(this.Te, this.Ec, c);
  }, ry.prototype.S = function() {
    return this.Mg;
  }, ry.prototype.Yd = q, ry.prototype.wd = function(b, c) {
    return Cy.j ? Cy.j(this.Te, c) : Cy.call(null, this.Te, c);
  }, ry.cc = function() {
    return new T(null, 3, 5, W, [km, dl, cm], null);
  }, ry.Db = !0, ry.ob = "cljs.spec/t_cljs$spec69111", ry.Rb = function(b, c) {
    return td(c, "cljs.spec/t_cljs$spec69111");
  });
  return new ry(b, c, dg);
}, My = function My(b, c, d, e, f, g, k) {
  var l = new u(null, 3, [Dj, b, Rj, d, ek, f], null);
  "undefined" === typeof sy && (sy = function(b, c, d, e, f, g, k, l, I) {
    this.te = b;
    this.se = c;
    this.Ue = d;
    this.Ve = e;
    this.Je = f;
    this.Ie = g;
    this.Ec = k;
    this.Ze = l;
    this.Ng = I;
    this.w = 393472;
    this.K = 0;
  }, sy.prototype.T = function() {
    return function(b, c) {
      return new sy(this.te, this.se, this.Ue, this.Ve, this.Je, this.Ie, this.Ec, this.Ze, c);
    };
  }(l), sy.prototype.S = function() {
    return function() {
      return this.Ng;
    };
  }(l), sy.prototype.R = function() {
    return function(b, c) {
      return C.j(this.Ze, c);
    };
  }(l), sy.prototype.N = function() {
    return function(b, c, d) {
      return C.l(this.Ze, c, d);
    };
  }(l), sy.prototype.Yd = q, sy.prototype.wd = function() {
    return function(b, c) {
      return My.wa ? My.wa(this.te, this.se, this.Ue, this.Ve, this.Je, this.Ie, c) : My.call(null, this.te, this.se, this.Ue, this.Ve, this.Je, this.Ie, c);
    };
  }(l), sy.cc = function() {
    return function() {
      return new T(null, 9, 5, W, [Ak, qk, jn, zn, fl, yl, dl, go, En], null);
    };
  }(l), sy.Db = !0, sy.ob = "cljs.spec/t_cljs$spec69127", sy.Rb = function() {
    return function(b, c) {
      return td(c, "cljs.spec/t_cljs$spec69127");
    };
  }(l));
  return new sy(b, c, d, e, f, g, k, l, dg);
};
Hy(Qo, Bf(Yl, Bf(Im, new T(null, 1, 5, W, [Yk], null), Bf(Pl, Bf(Xl, Dk, Yk), Bf(Xl, mo, Yk))), Bf(Im, new T(null, 1, 5, W, [Hl], null), Bf(Xl, Bf(dn, new T(null, 1, 5, W, [new T(null, 2, 5, W, [an, gl], null)], null), new u(null, 2, [Dk, an, mo, gl], null)), Hl))), Jy(Bf(Im, new T(null, 1, 5, W, [Yk], null), Bf(Zk, Bf(dk, Dk, Yk), Bf(dk, mo, Yk))), function(a) {
  return Ii(vg.j(Dk, a), vg.j(mo, a));
}, null, !0, function(a) {
  return vg.j(function(a) {
    var b = S(a, 0, null);
    a = S(a, 1, null);
    return new u(null, 2, [Dk, b, mo, a], null);
  }, a);
}));
if ("undefined" === typeof Ny) {
  var Ny = !0
}
if ("undefined" === typeof Oy) {
  var Oy = !1
}
;function Py(a) {
  var b = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a;
  a = C.j(b, Am);
  b = C.j(b, Ym);
  a = new u(null, 6, [Vj, 0, Io, xq(null), Om, w(b) ? b.id : null, Ym, b, Uk, w(a) ? a.id : null, Am, a], null);
  return og ? og(a) : ng.call(null, a);
}
function Qy(a) {
  return new u(null, 2, [Nm, "klipse-result", Mm, [y("klipse-result-"), y(a)].join("")], null);
}
function Ry(a) {
  return new u(null, 2, [Nm, "klipse-container", Mm, [y("klipse-container-"), y(a)].join("")], null);
}
function Sy(a, b, c, d, e) {
  var f = null != d && (d.w & 64 || q === d.M) ? Vf(pg, d) : d, g = C.j(f, jk), k = C.j(f, mm), l = xq(1);
  Wp(function(d, f, g, k, l) {
    return function() {
      var m = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (ba) {
                    if (ba instanceof Object) {
                      b[5] = ba, oq(b), c = Z;
                    } else {
                      throw ba;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(d, f, g, k, l) {
          return function(m) {
            var n = m[1];
            if (7 === n) {
              var t = m[7];
              nq(m, 6, Ok, null, 5);
              var t = L.h ? L.h(e) : L.call(null, e), r = kc(null == t);
              m[7] = t;
              m[1] = r ? 8 : 9;
              return Z;
            }
            if (20 === n) {
              var v = m[8], x = m[9], t = m[2], r = v.h ? v.h(t) : v.call(null, t);
              m[9] = t;
              m[10] = r;
              m[1] = w(k) ? 21 : 22;
              return Z;
            }
            if (1 === n) {
              return m[1] = w(c) ? 2 : 3, Z;
            }
            if (4 === n) {
              return v = m[2], m[8] = v, m[2] = null, m[1] = 7, Z;
            }
            if (15 === n) {
              return t = m[7], m[2] = t, m[1] = 16, Z;
            }
            if (21 === n) {
              var v = m[8], x = m[9], z = m[11], B = m[12], K = m[13], I = m[14], V = xq(1), t = Wp(function() {
                return function(c, d, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U) {
                  return function() {
                    var ba = function() {
                      return function(a) {
                        return function() {
                          function b(b) {
                            for (;;) {
                              var c;
                              a: {
                                try {
                                  for (;;) {
                                    var d = a(b);
                                    if (!Y(d, Z)) {
                                      c = d;
                                      break a;
                                    }
                                  }
                                } catch (Pn) {
                                  if (Pn instanceof Object) {
                                    b[5] = Pn, oq(b), c = Z;
                                  } else {
                                    throw Pn;
                                  }
                                }
                              }
                              if (!Y(c, Z)) {
                                return c;
                              }
                            }
                          }
                          function c() {
                            var a = [null, null, null, null, null, null, null, null];
                            a[0] = d;
                            a[1] = 1;
                            return a;
                          }
                          var d = null, d = function(a) {
                            switch(arguments.length) {
                              case 0:
                                return c.call(this);
                              case 1:
                                return b.call(this, a);
                            }
                            throw Error("Invalid arity: " + arguments.length);
                          };
                          d.v = c;
                          d.h = b;
                          return d;
                        }();
                      }(function(c, d, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R) {
                        return function(d) {
                          var g = d[1];
                          if (1 === g) {
                            return d[2] = null, d[1] = 2, Z;
                          }
                          if (2 === g) {
                            var g = W, k = vq(R);
                            return Gq(d, 4, new T(null, 2, 5, g, [f, k], null));
                          }
                          return 3 === g ? lq(d, d[2]) : 4 === g ? (k = d[2], g = S(k, 0, null), k = S(k, 1, null), k = J.j(k, f), g = J.j(g, Fk), d[1] = w(k && g) ? 5 : 6, Z) : 5 === g ? (d[2] = null, d[1] = 7, Z) : 6 === g ? (g = L.h ? L.h(e) : L.call(null, e), g = a.j ? a.j(b, g) : a.call(null, b, g), jq(d, 8, g)) : 7 === g ? (d[2] = d[2], d[1] = 3, Z) : 8 === g ? (g = d[2], g = c.h ? c.h(g) : c.call(null, g), d[7] = g, d[2] = null, d[1] = 2, Z) : null;
                        };
                      }(c, d, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U), c, d, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U);
                    }(), Q = function() {
                      var a = ba.v ? ba.v() : ba.call(null);
                      a[6] = m;
                      return a;
                    }();
                    return iq(Q);
                  };
                }(v, K, z, I, B, x, V, v, x, z, B, K, I, V, n, d, f, g, k, l);
              }());
              m[15] = t;
              m[2] = V;
              m[1] = 23;
              return Z;
            }
            if (13 === n) {
              return m[2] = m[2], m[1] = 10, Z;
            }
            if (22 === n) {
              return m[2] = null, m[1] = 23, Z;
            }
            if (6 === n) {
              return v = m[8], t = m[2], t = v.h ? v.h(t) : v.call(null, t), m[2] = t, oq(m), Z;
            }
            if (17 === n) {
              return m[2] = null, m[1] = 19, Z;
            }
            if (3 === n) {
              return m[2] = mc, m[1] = 4, Z;
            }
            if (12 === n) {
              return m[2] = !1, m[1] = 13, Z;
            }
            if (2 === n) {
              return m[2] = c, m[1] = 4, Z;
            }
            if (23 === n) {
              var v = m[8], x = m[9], z = m[11], B = m[12], K = m[13], I = m[14], U = m[2], Q = xq(1), t = Wp(function() {
                return function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, R) {
                  return function() {
                    var V = function() {
                      return function(a) {
                        return function() {
                          function b(b) {
                            for (;;) {
                              var c;
                              a: {
                                try {
                                  for (;;) {
                                    var d = a(b);
                                    if (!Y(d, Z)) {
                                      c = d;
                                      break a;
                                    }
                                  }
                                } catch (Qn) {
                                  if (Qn instanceof Object) {
                                    b[5] = Qn, oq(b), c = Z;
                                  } else {
                                    throw Qn;
                                  }
                                }
                              }
                              if (!Y(c, Z)) {
                                return c;
                              }
                            }
                          }
                          function c() {
                            var a = [null, null, null, null, null, null, null, null, null, null];
                            a[0] = d;
                            a[1] = 1;
                            return a;
                          }
                          var d = null, d = function(a) {
                            switch(arguments.length) {
                              case 0:
                                return c.call(this);
                              case 1:
                                return b.call(this, a);
                            }
                            throw Error("Invalid arity: " + arguments.length);
                          };
                          d.v = c;
                          d.h = b;
                          return d;
                        }();
                      }(function(a, b, c, d, e, f) {
                        return function(b) {
                          var c = b[1];
                          if (1 === c) {
                            var d = f;
                            b[7] = d;
                            b[2] = null;
                            b[1] = 2;
                            return Z;
                          }
                          return 2 === c ? jq(b, 4, e) : 3 === c ? lq(b, b[2]) : 4 === c ? (d = b[7], c = b[2], d = [y(d), y(c)].join(""), b[8] = d, b[1] = null != c ? 5 : 6, Z) : 5 === c ? (d = b[8], c = a.h ? a.h(d) : a.call(null, d), b[7] = d, b[9] = c, b[2] = null, b[1] = 2, Z) : 6 === c ? (b[2] = null, b[1] = 7, Z) : 7 === c ? (b[2] = b[2], b[1] = 3, Z) : null;
                        };
                      }(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, R), a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, R);
                    }(), U = function() {
                      var a = V.v ? V.v() : V.call(null);
                      a[6] = g;
                      return a;
                    }();
                    return iq(U);
                  };
                }(v, K, z, I, B, x, Q, v, x, z, B, K, I, U, Q, n, d, f, g, k, l);
              }());
              m[16] = U;
              m[17] = t;
              m[2] = Q;
              oq(m);
              return Z;
            }
            if (19 === n) {
              var B = m[12], t = m[2], r = sg.H(e, Jg, new T(null, 1, 5, W, [Vj], null), je), Ja = [y(l), y(b)].join(""), Qa = L.h ? L.h(e) : L.call(null, e), Ja = a.j ? a.j(Ja, Qa) : a.call(null, Ja, Qa);
              m[18] = t;
              m[12] = Ja;
              m[19] = r;
              return jq(m, 20, Ja);
            }
            return 11 === n ? (m[2] = !0, m[1] = 13, Z) : 9 === n ? (m[2] = !1, m[1] = 10, Z) : 5 === n ? lq(m, m[2]) : 14 === n ? (t = m[7], t = Vf(pg, t), m[2] = t, m[1] = 16, Z) : 16 === n ? (K = m[13], I = m[14], t = m[2], z = C.j(t, Io), r = C.j(t, Vj), m[11] = z, m[13] = t, m[14] = r, m[1] = w(0 === r) ? 17 : 18, Z) : 10 === n ? (m[1] = w(m[2]) ? 14 : 15, Z) : 18 === n ? (z = m[11], t = Aq(z, Fk), m[2] = t, m[1] = 19, Z) : 8 === n ? (t = m[7], r = q === t.M, m[1] = w(t.w & 64 || r) ? 11 : 12, 
            Z) : null;
          };
        }(d, f, g, k, l), d, f, g, k, l);
      }(), n = function() {
        var a = m.v ? m.v() : m.call(null);
        a[6] = d;
        return a;
      }();
      return iq(n);
    };
  }(l, d, f, g, k));
  return l;
}
function Ty(a, b, c, d, e, f) {
  return Sy(a, c.getValue(), w(b) ? function(a) {
    var c = new u(null, 2, [ak, !1, Lo, !1], null);
    return ly(hy(b, a), e, c);
  } : null, d, f);
}
function Uy(a, b, c, d, e) {
  var f = c.value;
  return Sy(a, w(f) ? f : c.textContent, w(b) ? jg(Ds, b) : null, d, e);
}
function Vy(a, b) {
  var c = J.j(pc(b), Error) ? [y('\x3cdiv class\x3d"klipse-error"\x3e'), y(b), y("\x3c/div\x3e")].join("") : b;
  a.innerHTML = c;
  return a;
}
Hy(nk, Ll, Te);
Hy(yk, $k, lc);
Hy(cn, Bf(fo, Dj, Bf(xn, Ul, yk, wk, yk, Fj, nk, yn, nk)), My(Fy(Bf(xn, Ul, yk, wk, yk, Fj, nk, yn, nk), Ly(new T(null, 4, 5, W, [Ul, wk, Fj, yn], null), new T(null, 4, 5, W, [yk, yk, nk, nk], null), new T(null, 4, 5, W, [yk, yk, nk, nk], null)), null, null), Bf(xn, Ul, yk, wk, yk, Fj, nk, yn, nk), null, null, null, null, null));
var Wy = new u(null, 2, [Vk, !0, In, "overlay"], null);
function Xy(a, b, c, d) {
  return new T(null, 2, 5, W, [Ai.B(P([Je.l(Wy, ol, a), c], 0)), Ai.B(P([Je.B(Wy, ol, b, P([Hm, !0], 0)), d], 0))], null);
}
if ("undefined" === typeof Yy) {
  var Yy = function() {
    var a = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), b = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), c = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), d = function() {
      var a = dg;
      return og ? og(a) : ng.call(null, a);
    }(), e = C.l(dg, co, mj());
    return new xj(Zd.j("klipse.klipse-editors", "create-editor"), function() {
      return function(a) {
        return a;
      };
    }(a, b, c, d, e), Ok, e, a, b, c, d);
  }()
}
yj(Yy, To, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Wn), e = C.j(c, vo), f = C.j(c, Po), g = C.j(c, Tj), k = C.j(c, ak), l = C.j(c, hk), m = C.j(c, jk), n = C.j(c, uk), t = C.j(c, Bk), r = C.j(c, Wl), v = C.j(c, mm), x = C.j(c, Qm), z = C.j(c, on), B = C.j(c, fn), I = Xy(B, t, f, x), U = S(I, 0, null), V = S(I, 1, null), Q = dy(n, Ry(z)), K = w(e) ? null : dy(n, Qy(z)), E = my(n, r, U, P([ak, k], 0)), ba = new u(null, 2, [jk, m, mm, v], null), R = Py(P([Ym, Q, Am, K], 0));
  w(K) && Ds(K, g);
  oy(E, new u(null, 2, [hk, l, Tk, function(a, b, c, d, e, f, g, k, l, m, n) {
    return function() {
      return Sy(n, f.getValue(), w(e) ? jg(Vy, e) : null, g, k);
    };
  }(I, U, V, Q, K, E, ba, R, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B)], null));
  return function(a, b, c, d, e, f, g, k, l, m, n) {
    return function() {
      return Sy(n, f.getValue(), w(e) ? jg(Vy, e) : null, g, k);
    };
  }(I, U, V, Q, K, E, ba, R, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
});
yj(Yy, Cj, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Wn), e = C.j(c, vo), f = C.j(c, Po), g = C.j(c, Tj), k = C.j(c, ak), l = C.j(c, hk), m = C.j(c, jk), n = C.j(c, uk), t = C.j(c, Bk), r = C.j(c, Wl), v = C.j(c, mm), x = C.j(c, Qm), z = C.j(c, on), B = C.j(c, fn), I = Xy(B, t, f, x), U = S(I, 0, null), V = S(I, 1, null), Q = dy(n, Ry(z)), K = w(e) ? null : ny(n, g, V), E = my(n, r, U, P([ak, k], 0)), ba = new u(null, 2, [jk, m, mm, v], null), R = Py(P([Ym, Q, Am, K], 0));
  oy(E, new u(null, 2, [hk, l, Tk, function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K) {
    return function() {
      return Ty(n, e, f, g, K, k);
    };
  }(I, U, V, Q, K, E, ba, R, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B)], null));
  return function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K) {
    return function() {
      return Ty(n, e, f, g, K, k);
    };
  }(I, U, V, Q, K, E, ba, R, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, B);
});
yj(Yy, Ho, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Wn), e = C.j(c, bo), f = C.j(c, vo), g = C.j(c, Tj), k = C.j(c, hk), l = C.j(c, jk), m = C.j(c, uk), n = C.j(c, Wl), t = C.j(c, mm), r = C.j(c, nn), v = C.j(c, on), x = dy(m, Ry(v)), z = w(f) ? null : dy(m, Qy(v)), B = new u(null, 2, [jk, l, mm, t], null), I = Py(P([Ym, x, Am, z], 0));
  w(z) && Ds(z, g);
  ey(m, function(a, b, c, d, e, f, g, k, l, m, n, t, r) {
    return function() {
      return Uy(g, b, r, c, d);
    };
  }(x, z, B, I, b, c, d, e, f, g, k, l, m, n, t, r, v));
  return function(a, b, c, d, e, f, g, k, l, m, n, t, r) {
    return function() {
      return Uy(g, b, r, c, d);
    };
  }(x, z, B, I, b, c, d, e, f, g, k, l, m, n, t, r, v);
});
var Zy = og ? og(0) : ng.call(null, 0);
function $y() {
  var a = L.h ? L.h(Zy) : L.call(null, Zy);
  sg.j(Zy, je);
  return a;
}
function az(a, b, c, d) {
  var e = a.dataset;
  a = e.editorType;
  var f = $x(e.loopMsec, null), g;
  g = e.preamble;
  g = w(g) ? g : "";
  e = $x(e.evalIdleMsec, null);
  a = hp(new u(null, 4, [hk, e, jk, f, mm, g, sk, a], null));
  a = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a;
  b = C.l(a, hk, b);
  d = C.l(a, sk, d);
  f = C.j(a, mm);
  e = C.j(a, nl);
  a = C.l(a, jk, null);
  return hp(new u(null, 5, [hk, c > b ? c : b, jk, a, mm, f, nl, e, Kj, d], null));
}
function bz(a, b) {
  if (w(a)) {
    return Ho;
  }
  switch(b) {
    case "code-mirror":
      return Cj;
    case "dom":
      return Ho;
    case "html":
      return To;
    default:
      return Cj;
  }
}
function cz(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            var c = b[1];
            if (1 === c) {
              return c = Qx.h ? Qx.h(a) : Qx.call(null, a), jq(b, 2, c);
            }
            if (2 === c) {
              var d = b[2], e = S(d, 0, null), c = S(d, 1, null), d = S(d, 2, null), e = J.j(Pm, e);
              b[7] = c;
              b[8] = d;
              b[1] = e ? 3 : 4;
              return Z;
            }
            return 3 === c ? (b[2] = new T(null, 2, 5, W, [Pm, Pm], null), b[1] = 5, Z) : 4 === c ? (c = b[7], d = b[8], e = W, c = [y("Cannot load script: "), y(d), y("\n"), y("Error: "), y(c)].join(""), b[2] = new T(null, 2, 5, e, [Cn, c], null), b[1] = 5, Z) : 5 === c ? lq(b, b[2]) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}
function dz(a, b, c) {
  var d = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, e = C.l(d, Co, 20), f = C.l(d, Ql, !1), g = C.j(d, tl), k = C.l(d, Ik, 1E3), l = C.l(d, ym, !1), m = C.j(d, Dn), n = C.l(d, po, dg), t = C.l(d, Sj, dg), r = null != c && (c.w & 64 || q === c.M) ? Vf(pg, c) : c, v = C.j(r, fn), x = C.j(r, Bk), z = C.j(r, Wn), B = C.j(r, Kl), I = C.l(r, ll, !0), U = C.l(r, Dl, 0), V = C.l(r, rn, He), Q = C.j(r, $o), K = C.j(r, vo), E = xq(1);
  Wp(function(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, U, Q, Ip) {
    return function() {
      var R = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (On) {
                    if (On instanceof Object) {
                      b[5] = On, oq(b), c = Z;
                    } else {
                      throw On;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U, ba) {
          return function(M) {
            var Q = M[1];
            if (7 === Q) {
              return M[2] = !1, M[1] = 8, Z;
            }
            if (20 === Q) {
              var pa = M[7];
              M[2] = pa;
              M[1] = 21;
              return Z;
            }
            if (27 === Q) {
              var ia = M[8], ra = M[9], va = M[10], Aa = M[11], Ja = M[12], hb = M[13], La = M[14], Na = M[15], Qa = M[16], za = M[17], za = Ke(za, [La, ia, Na, va, a, E, Qa, hb, Ja, t, z, Aa, M[2], ba, n]), za = Yy.j ? Yy.j(ra, za) : Yy.call(null, ra, za);
              M[2] = za;
              M[1] = 4;
              return Z;
            }
            if (1 === Q) {
              return M[1] = w(a) ? 2 : 3, Z;
            }
            if (24 === Q) {
              var Pa = M[18], ia = M[2], Aa = $y(), za = J.j(Pm, Pa);
              M[8] = ia;
              M[11] = Aa;
              M[1] = za ? 25 : 26;
              return Z;
            }
            if (4 === Q) {
              return lq(M, M[2]);
            }
            if (15 === Q) {
              return za = M[19], M[2] = za, M[1] = 17, Z;
            }
            if (21 === Q) {
              return Pa = M[18], La = M[2], za = J.j(Pm, Pa), M[14] = La, M[1] = za ? 22 : 23, Z;
            }
            if (13 === Q) {
              return za = M[20], M[2] = za, M[1] = 14, Z;
            }
            if (22 === Q) {
              return M[2] = I, M[1] = 24, Z;
            }
            if (6 === Q) {
              return za = M[20], ia = q === za.M, M[1] = w(za.w & 64 || ia) ? 9 : 10, Z;
            }
            if (25 === Q) {
              var ab = M[21];
              M[2] = ab;
              M[1] = 27;
              return Z;
            }
            if (17 === Q) {
              return ra = bz(f, M[2]), za = ip(R), za = cz(za), M[9] = ra, jq(M, 18, za);
            }
            if (3 === Q) {
              return M[2] = null, M[1] = 4, Z;
            }
            if (12 === Q) {
              return za = M[20], za = Vf(pg, za), M[2] = za, M[1] = 14, Z;
            }
            if (2 === Q) {
              var vb = M[22], Hb = [Bo, hc, bl], $b = [m, k, l], nc = Ke(Hb, $b), Bc = cy(a, nc), ab = function() {
                return function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, M, Q, V, R) {
                  return function(b, c) {
                    var d = Ai.B(P([a, c], 0));
                    return R.j ? R.j(b, d) : R.call(null, b, d);
                  };
                }(Bc, vb, Hb, $b, nc, Bc, Q, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U, ba);
              }(), za = by(a, K);
              M[22] = Bc;
              M[21] = ab;
              return jq(M, 5, za);
            }
            if (23 === Q) {
              return M[2] = !1, M[1] = 24, Z;
            }
            if (19 === Q) {
              return za = [y(K), y("the evaluation will appear here (soon)...")].join(""), M[2] = za, M[1] = 21, Z;
            }
            if (11 === Q) {
              return M[2] = M[2], M[1] = 8, Z;
            }
            if (9 === Q) {
              return M[2] = !0, M[1] = 11, Z;
            }
            if (5 === Q) {
              return za = M[20], hb = M[2], za = az(a, e, V, g), ia = kc(null == za), M[13] = hb, M[20] = za, M[1] = ia ? 6 : 7, Z;
            }
            if (14 === Q) {
              var za = M[19], qd = M[23], za = M[2], Na = C.j(za, hk), ia = C.j(za, Kj), va = C.j(za, jk), Qa = C.j(za, nl), Ja = C.j(za, mm);
              M[19] = ia;
              M[10] = va;
              M[12] = Ja;
              M[15] = Na;
              M[23] = za;
              M[16] = Qa;
              M[1] = w(ia) ? 15 : 16;
              return Z;
            }
            if (26 === Q) {
              var ra = M[9], Pa = M[18], pa = M[7], va = M[10], Ja = M[12], hb = M[13], Na = M[15], vb = M[22], qd = M[23], Qa = M[16], be = M[24], ab = M[21];
              M[2] = function() {
                return function() {
                  return function() {
                    return xq(null);
                  };
                }(qd, ra, ab, Na, va, be, pa, Qa, Pa, vb, hb, Ja, ra, Pa, pa, va, Ja, hb, Na, vb, qd, Qa, be, ab, Q, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, R, U, ba);
              }();
              M[1] = 27;
              return Z;
            }
            return 16 === Q ? (M[2] = U, M[1] = 17, Z) : 10 === Q ? (M[2] = !1, M[1] = 11, Z) : 18 === Q ? (Pa = M[18], be = M[24], ia = M[2], Aa = S(ia, 0, null), pa = S(ia, 1, null), za = [Tj, ak, hk, jk, uk, Bk, nl, Wl, mm, Qm, fn, on, Wn, vo, Po], La = J.j(Pm, Aa), M[18] = Aa, M[7] = pa, M[24] = ia, M[17] = za, M[1] = La ? 19 : 20, Z) : 8 === Q ? (M[1] = w(M[2]) ? 12 : 13, Z) : null;
          };
        }(b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, U, Q, Ip), b, c, d, e, f, g, k, l, m, n, t, r, v, x, z, E, B, K, I, V, U, Q, Ip);
      }(), ba = function() {
        var a = R.v ? R.v() : R.call(null);
        a[6] = b;
        return a;
      }();
      return iq(ba);
    };
  }(E, b, d, e, f, g, k, l, m, n, t, c, r, r, v, x, z, B, I, U, V, Q, K));
  return E;
}
Hy(So, ql, function(a) {
  return ka(a) && 1 == a.nodeType;
});
Hy(qo, $k, lc);
Hy(so, $k, lc);
Hy(Zj, $l, function(a) {
  var b = ja(a);
  return b ? b : null != a ? q === a.cg ? !0 : a.De ? !1 : oc(zc, a) : oc(zc, a);
});
Hy(Fn, $k, lc);
Hy(xk, wm, bf);
Hy(Wm, Bf(dn, new T(null, 1, 5, W, [Tl], null), Bf(xo, Bf(ik, Tl, !0), Bf(ik, Tl, !1))), function(a) {
  return J.j(a, !0) || J.j(a, !1);
});
Hy(Cm, Bf(Jj, Hj, new T(null, 4, 5, W, [qo, so, Zj, Fn], null)), Iy(Ke([Hj, Ij, Uj, Xj, pk, cl, om, $m, mn, An, Vo], [new T(null, 4, 5, W, [qo, so, Zj, Fn], null), null, null, new T(null, 5, 5, W, [Te, function(a) {
  return cf(a, fn);
}, function(a) {
  return cf(a, Bk);
}, function(a) {
  return cf(a, Wn);
}, function(a) {
  return cf(a, Kl);
}], null), He, new T(null, 4, 5, W, [qo, so, Zj, Fn], null), null, new T(null, 4, 5, W, [fn, Bk, Wn, Kl], null), He, new T(null, 5, 5, W, [Ll, Bf(dn, new T(null, 1, 5, W, [Tl], null), Bf(Jl, Tl, fn)), Bf(dn, new T(null, 1, 5, W, [Tl], null), Bf(Jl, Tl, Bk)), Bf(dn, new T(null, 1, 5, W, [Tl], null), Bf(Jl, Tl, Wn)), Bf(dn, new T(null, 1, 5, W, [Tl], null), Bf(Jl, Tl, Kl))], null), null])));
Hy(Wk, Bf(Jj, Ij, new T(null, 2, 5, W, [xk, Wm], null)), Iy(Ke([Hj, Ij, Uj, Xj, pk, cl, om, $m, mn, An, Vo], [null, new T(null, 2, 5, W, [xk, Wm], null), null, new T(null, 1, 5, W, [Te], null), new T(null, 2, 5, W, [Co, Ql], null), He, null, He, new T(null, 2, 5, W, [xk, Wm], null), new T(null, 1, 5, W, [Ll], null), null])));
Hy(lm, Bf(fo, Dj, Bf(xn, uk, So, vl, Wk, Vm, Cm)), My(Fy(Bf(xn, uk, So, vl, Wk, Vm, Cm), Ly(new T(null, 3, 5, W, [uk, vl, Vm], null), new T(null, 3, 5, W, [So, Wk, Cm], null), new T(null, 3, 5, W, [So, Wk, Cm], null)), null, null), Bf(xn, uk, So, vl, Wk, Vm, Cm), null, null, null, null, null));
ua("klipse.plugin.klipsify", function(a, b, c) {
  var d = (L.h ? L.h(Mq) : L.call(null, Mq)).call(null, c);
  if (w(d)) {
    var e = xq(1);
    Wp(function(c, d, e) {
      return function() {
        var f = function() {
          return function(a) {
            return function() {
              function b(b) {
                for (;;) {
                  var c;
                  a: {
                    try {
                      for (;;) {
                        var d = a(b);
                        if (!Y(d, Z)) {
                          c = d;
                          break a;
                        }
                      }
                    } catch (I) {
                      if (I instanceof Object) {
                        b[5] = I, oq(b), c = Z;
                      } else {
                        throw I;
                      }
                    }
                  }
                  if (!Y(c, Z)) {
                    return c;
                  }
                }
              }
              function c() {
                var a = [null, null, null, null, null, null, null];
                a[0] = d;
                a[1] = 1;
                return a;
              }
              var d = null, d = function(a) {
                switch(arguments.length) {
                  case 0:
                    return c.call(this);
                  case 1:
                    return b.call(this, a);
                }
                throw Error("Invalid arity: " + arguments.length);
              };
              d.v = c;
              d.h = b;
              return d;
            }();
          }(function(c, d) {
            return function(c) {
              var e = c[1];
              return 1 === e ? (e = dz(a, b, d), jq(c, 3, e)) : 2 === e ? lq(c, c[2]) : 3 === e ? (e = c[2], e = e.v ? e.v() : e.call(null), jq(c, 2, e)) : null;
            };
          }(c, d, e), c, d, e);
        }(), g = function() {
          var a = f.v ? f.v() : f.call(null);
          a[6] = c;
          return a;
        }();
        return iq(g);
      };
    }(e, d, d));
  } else {
    e = xq(1), Wp(function(a, b) {
      return function() {
        var d = function() {
          return function(a) {
            return function() {
              function b(b) {
                for (;;) {
                  var c;
                  a: {
                    try {
                      for (;;) {
                        var d = a(b);
                        if (!Y(d, Z)) {
                          c = d;
                          break a;
                        }
                      }
                    } catch (B) {
                      if (B instanceof Object) {
                        b[5] = B, oq(b), c = Z;
                      } else {
                        throw B;
                      }
                    }
                  }
                  if (!Y(c, Z)) {
                    return c;
                  }
                }
              }
              function c() {
                var a = [null, null, null, null, null, null, null];
                a[0] = d;
                a[1] = 1;
                return a;
              }
              var d = null, d = function(a) {
                switch(arguments.length) {
                  case 0:
                    return c.call(this);
                  case 1:
                    return b.call(this, a);
                }
                throw Error("Invalid arity: " + arguments.length);
              };
              d.v = c;
              d.h = b;
              return d;
            }();
          }(function() {
            return function(a) {
              if (1 === a[1]) {
                var b = L.h ? L.h(Mq) : L.call(null, Mq), b = zh(b), b = console.error("cannot find options for mode: ", c, ". Supported modes: ", b);
                return lq(a, b);
              }
              return null;
            };
          }(a, b), a, b);
        }(), e = function() {
          var b = d.v ? d.v() : d.call(null);
          b[6] = a;
          return b;
        }();
        return iq(e);
      };
    }(e, d));
  }
  return e;
});
function ez(a, b, c) {
  var d = (L.h ? L.h(Mq) : L.call(null, Mq)).call(null, c);
  if (w(d)) {
    return dz(a, b, d);
  }
  a = xq(1);
  Wp(function(a, b) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (z) {
                    if (z instanceof Object) {
                      b[5] = z, oq(b), c = Z;
                    } else {
                      throw z;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(a, b) {
          return function(d) {
            var e = d[1];
            return 1 === e ? lq(d, function() {
              return function(a, b, d) {
                return function() {
                  var e = xq(1);
                  Wp(function(a, b, d, e) {
                    return function() {
                      var f = function() {
                        return function(a) {
                          return function() {
                            function b(b) {
                              for (;;) {
                                var c;
                                a: {
                                  try {
                                    for (;;) {
                                      var d = a(b);
                                      if (!Y(d, Z)) {
                                        c = d;
                                        break a;
                                      }
                                    }
                                  } catch (va) {
                                    if (va instanceof Object) {
                                      b[5] = va, oq(b), c = Z;
                                    } else {
                                      throw va;
                                    }
                                  }
                                }
                                if (!Y(c, Z)) {
                                  return c;
                                }
                              }
                            }
                            function c() {
                              var a = [null, null, null, null, null, null, null];
                              a[0] = d;
                              a[1] = 1;
                              return a;
                            }
                            var d = null, d = function(a) {
                              switch(arguments.length) {
                                case 0:
                                  return c.call(this);
                                case 1:
                                  return b.call(this, a);
                              }
                              throw Error("Invalid arity: " + arguments.length);
                            };
                            d.v = c;
                            d.h = b;
                            return d;
                          }();
                        }(function() {
                          return function(a) {
                            if (1 === a[1]) {
                              var b = L.h ? L.h(Mq) : L.call(null, Mq), b = zh(b), b = console.error("cannot find options for mode: ", c, ". Supported modes: ", b);
                              return lq(a, b);
                            }
                            return null;
                          };
                        }(a, b, d, e), a, b, d, e);
                      }(), g = function() {
                        var b = f.v ? f.v() : f.call(null);
                        b[6] = a;
                        return b;
                      }();
                      return iq(g);
                    };
                  }(e, a, b, d));
                  return e;
                };
              }(e, a, b);
            }()) : null;
          };
        }(a, b), a, b);
      }(), e = function() {
        var b = d.v ? d.v() : d.call(null);
        b[6] = a;
        return b;
      }();
      return iq(e);
    };
  }(a, d));
  return a;
}
ua("klipse.plugin.klipsify_no_eval", ez);
function fz(a, b, c) {
  var d = xq(1);
  Wp(function(d) {
    return function() {
      var e = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (x) {
                    if (x instanceof Object) {
                      b[5] = x, oq(b), c = Z;
                    } else {
                      throw x;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(d) {
            var e = d[1];
            if (7 === e) {
              return e = ez(d[8], b, d[7]), jq(d, 10, e);
            }
            if (1 === e) {
              var f = a, e = He;
              d[9] = f;
              d[10] = e;
              d[2] = null;
              d[1] = 2;
              return Z;
            }
            if (4 === e) {
              var f = d[9], e = G(f), g = c.h ? c.h(e) : c.call(null, e);
              d[7] = g;
              d[8] = e;
              d[1] = w(g) ? 7 : 8;
              return Z;
            }
            return 6 === e ? (d[2] = d[2], d[1] = 3, Z) : 3 === e ? lq(d, d[2]) : 2 === e ? (f = d[9], e = D(f), d[1] = e ? 4 : 5, Z) : 9 === e ? (d[2] = d[2], d[1] = 6, Z) : 5 === e ? (e = d[10], d[2] = e, d[1] = 6, Z) : 10 === e ? (f = d[9], e = d[10], g = d[2], f = $d(f), e = Ge.j(e, g), d[9] = f, d[10] = e, d[2] = null, d[1] = 2, Z) : 8 === e ? (f = d[9], e = d[10], g = $d(f), d[9] = g, d[10] = e, d[2] = null, d[1] = 2, Z) : null;
          };
        }(d), d);
      }(), g = function() {
        var a = e.v ? e.v() : e.call(null);
        a[6] = d;
        return a;
      }();
      return iq(g);
    };
  }(d));
  return d;
}
function gz(a, b, c) {
  var d = xq(1);
  Wp(function(d) {
    return function() {
      var e = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (x) {
                    if (x instanceof Object) {
                      b[5] = x, oq(b), c = Z;
                    } else {
                      throw x;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(d) {
            var e = d[1];
            if (7 === e) {
              return d[2] = d[2], d[1] = 4, Z;
            }
            if (1 === e) {
              return e = fz(a, b, c), jq(d, 2, e);
            }
            if (4 === e) {
              return lq(d, d[2]);
            }
            if (15 === e) {
              var f = d[7], e = d[2], g = H(f), k;
              d[8] = 0;
              d[9] = null;
              d[10] = e;
              d[11] = 0;
              d[12] = g;
              d[2] = null;
              d[1] = 3;
              return Z;
            }
            if (13 === e) {
              return f = d[7], e = G(f), e = e.v ? e.v() : e.call(null), jq(d, 15, e);
            }
            if (6 === e) {
              return g = d[12], e = D(g), d[7] = e, d[1] = e ? 9 : 10, Z;
            }
            if (3 === e) {
              return e = d[8], f = d[11], d[1] = w(f < e) ? 5 : 6, Z;
            }
            if (12 === e) {
              var f = d[7], e = Dd(f), f = Ed(f), r = O(e);
              d[8] = r;
              d[9] = e;
              d[11] = 0;
              d[12] = f;
              d[2] = null;
              d[1] = 3;
              return Z;
            }
            return 2 === e ? (g = D(d[2]), d[8] = 0, d[9] = null, d[11] = 0, d[12] = g, d[2] = null, d[1] = 3, Z) : 11 === e ? (d[2] = d[2], d[1] = 7, Z) : 9 === e ? (f = d[7], d[1] = We(f) ? 12 : 13, Z) : 5 === e ? (k = d[9], f = d[11], e = Ic.j(k, f), e = e.v ? e.v() : e.call(null), jq(d, 8, e)) : 14 === e ? (d[2] = d[2], d[1] = 11, Z) : 10 === e ? (d[2] = null, d[1] = 11, Z) : 8 === e ? (e = d[8], k = d[9], f = d[11], g = d[12], r = d[2], d[8] = e, d[9] = k, d[11] = f + 1, d[13] = r, d[12] = g, 
            d[2] = null, d[1] = 3, Z) : null;
          };
        }(d), d);
      }(), g = function() {
        var a = e.v ? e.v() : e.call(null);
        a[6] = d;
        return a;
      }();
      return iq(g);
    };
  }(d));
  return d;
}
function hz(a) {
  return Gg.j(dg, function() {
    return function c(d) {
      return new Hf(null, function() {
        for (var e = d;;) {
          var f = D(e);
          if (f) {
            var g = f, k = G(g), l = a.h ? a.h(k) : a.call(null, k);
            if (w(l) && (f = D(function(a, c, d, e, f) {
              return function z(g) {
                return new Hf(null, function(a, c, d) {
                  return function() {
                    for (;;) {
                      var a = D(g);
                      if (a) {
                        if (We(a)) {
                          var c = Dd(a), e = O(c), f = new Jf(Array(e), 0);
                          a: {
                            for (var k = 0;;) {
                              if (k < e) {
                                var m = Ic.j(c, k);
                                Nf(f, new T(null, 2, 5, W, [m, (L.h ? L.h(Kq) : L.call(null, Kq)).call(null, d)], null));
                                k += 1;
                              } else {
                                c = !0;
                                break a;
                              }
                            }
                          }
                          return c ? Mf(f.ib(), z(Ed(a))) : Mf(f.ib(), null);
                        }
                        f = G(a);
                        return ze(new T(null, 2, 5, W, [f, (L.h ? L.h(Kq) : L.call(null, Kq)).call(null, d)], null), z($d(a)));
                      }
                      return null;
                    }
                  };
                }(a, c, d, e, f), null, null);
              };
            }(e, l, k, g, f)(Ae(document.querySelectorAll(l), 0))))) {
              return Rf.j(f, c($d(e)));
            }
            e = $d(e);
          } else {
            return null;
          }
        }
      }, null, null);
    }(zh(L.h ? L.h(Kq) : L.call(null, Kq)));
  }());
}
function iz(a) {
  var b = Hx(a), c = hz(a), d = zh(L.h ? L.h(Kq) : L.call(null, Kq));
  a = ap(",", Dg(ic, vg.j(a, d)));
  return gz(Ae(document.querySelectorAll(a), 0), b, c);
}
ua("klipse.plugin.init_clj", iz);
function jz(a) {
  return iz(jj(a, P([kj, !1], 0)));
}
ua("klipse.plugin.init", jz);
var kz = {msg_mac:"6GpVqi640U22dcEhfB5C58m0oqAWXuVZr+SQ4sBoTMQ\x3d", time_created:1468951584E3}, lz = function(a) {
  return function(b) {
    return function() {
      function c(a) {
        var b = null;
        if (0 < arguments.length) {
          for (var b = 0, c = Array(arguments.length - 0);b < c.length;) {
            c[b] = arguments[b + 0], ++b;
          }
          b = new F(c, 0);
        }
        return d.call(this, b);
      }
      function d(c) {
        var d = C.l(L.h ? L.h(b) : L.call(null, b), c, Ze);
        d === Ze && (d = Vf(a, c), sg.H(b, Je, c, d));
        return d;
      }
      c.L = 0;
      c.J = function(a) {
        a = D(a);
        return d(a);
      };
      c.B = d;
      return c;
    }();
  }(function() {
    var a = dg;
    return og ? og(a) : ng.call(null, a);
  }());
}(function(a) {
  return new ReplitClient("api.repl.it", 80, a, kz);
});
function lg(a, b, c) {
  return function() {
    var d = a.evaluate;
    return d.call(a, c, {stdout:function() {
      return function(a) {
        return Aq(b, a);
      };
    }(a, d)});
  }().then(function(a) {
    return Pe(a.error) ? Aq(b, [y("Result: "), y(a.data), y("\n")].join("")) : Aq(b, [y("Error: "), y(a.error), y("\n")].join(""));
  }, function(a) {
    return Aq(b, a);
  });
}
function mz(a, b) {
  var c = xq(null), d = lz.h ? lz.h(a) : lz.call(null, a);
  d.connect.call(d).then(kg(d, c, b));
  return c;
}
;if (w(window.ReplitClient)) {
  for (var nz = new u(null, 3, [Pj, "selector_eval_python", Xk, "eval-python", Vm, new u(null, 6, [fn, "python", Bk, "python", Rk, "python3", rn, new T(null, 1, 5, W, [Oq("python")], null), Kl, "#", ll, !1], null)], null), oz = new u(null, 3, [Pj, "selector_eval_csharp", Xk, "eval-csharp", Vm, new u(null, 5, [fn, "text/x-csharp", Bk, "text/x-csharp", rn, new T(null, 1, 5, W, [Oq("clike")], null), Rk, "csharp", Kl, "#"], null)], null), pz = new u(null, 3, [Pj, "selector_eval_go", Xk, "eval-go", Vm, 
  new u(null, 5, [fn, "go", Bk, "go", rn, new T(null, 1, 5, W, [Oq("go")], null), Rk, "go", Kl, "//"], null)], null), qz = D(new T(null, 3, 5, W, [nz, oz, pz], null)), rz = null, sz = 0, tz = 0;;) {
    if (tz < sz) {
      var uz = rz.aa(null, tz), vz = null != uz && (uz.w & 64 || q === uz.M) ? Vf(pg, uz) : uz, wz = C.j(vz, Pj), xz = C.j(vz, Xk), yz = C.j(vz, Vm), zz = Je.l(Le.j(Je.l(yz, Wn, jg(mz, Rk.h(yz))), Rk), Dl, 3E3);
      Pq(xz, wz, zz);
      tz += 1;
    } else {
      var Az = D(qz);
      if (Az) {
        var Bz = Az;
        if (We(Bz)) {
          var Cz = Dd(Bz), Dz = Ed(Bz), Ez = Cz, Fz = O(Cz), qz = Dz, rz = Ez, sz = Fz
        } else {
          var Gz = G(Bz), Hz = null != Gz && (Gz.w & 64 || q === Gz.M) ? Vf(pg, Gz) : Gz, Iz = C.j(Hz, Pj), Jz = C.j(Hz, Xk), Kz = C.j(Hz, Vm), Lz = Je.l(Le.j(Je.l(Kz, Wn, jg(mz, Rk.h(Kz))), Rk), Dl, 3E3);
          Pq(Jz, Iz, Lz);
          qz = H(Bz);
          rz = null;
          sz = 0;
        }
        tz = 0;
      } else {
        break;
      }
    }
  }
}
;function Mz(a, b) {
  var c = [y("\x3cstrong\x3e"), y(te(a, b)), y("\x3c/strong\x3e")].join("");
  return Je.l(a, b, c);
}
var Nz = new u(null, 6, [fn, "text/x-brainfuck", Bk, "text", $o, "html", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            if (1 === b[1]) {
              var c;
              try {
                var d = Fe(G(Cg(mf, vg.j(jg(Ni, /\[in:\s*(.*)\]/), dp(a, /\n|\r\n/))))), e = W, f, n = window;
                f = n.brainfuck.call(n, a, d);
                var t, r = jj(f, P([kj, !0], 0)), v = null != r && (r.w & 64 || q === r.M) ? Vf(pg, r) : r, x = C.j(v, Ml), z = C.j(v, Xo), B = C.j(v, Fm), I = C.j(v, Wo);
                t = [y("\x3ctable\x3e"), y(D(x) ? [y("\x3ctr\x3e\n           \x3ctd\x3eOutput\x3c/td\x3e\x3ctd\x3e"), y(ap(" ", x)), y("\x3c/td\x3e\n         \x3c/tr\x3e")].join("") : null), y("\x3ctr\x3e\n           \x3ctd\x3eData\x3c/td\x3e\x3ctd\x3e"), y(ap(" ", Mz(z, B))), y("\x3c/td\x3e\n         \x3c/tr\x3e\n         \x3ctr\x3e\n           \x3ctd\x3eHead\x3c/td\x3e\x3ctd\x3e"), y(B), y("\x3c/td\x3e\n           \x3c/tr\x3e"), y(D(x) ? [y("\x3ctr\x3e\n           \x3ctd\x3eText\x3c/td\x3e\x3ctd\x3e "), 
                y(I), y("\x3c/td\x3e\n         \x3c/tr\x3e")].join("") : null), y("\x3c/table\x3e")].join("");
                c = new T(null, 2, 5, e, [Pm, t], null);
              } catch (U) {
                c = new T(null, 2, 5, W, [Cn, "" + y(U)], null);
              }
              d = S(c, 0, null);
              c = S(c, 1, null);
              b[7] = d;
              return lq(b, c);
            }
            return null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 2, 5, W, [Oq("brainfuck"), "https://viebel.github.io/klipse/repo/js/brainfuck.js"], null), Kl, ""], null), Oz = new u(null, 5, [fn, "text/x-brainfuck", Bk, "text", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            if (1 === b[1]) {
              var c;
              try {
                var d = W, e, f = brainfuck;
                e = f.text.call(f, a);
                c = new T(null, 2, 5, d, [Pm, e], null);
              } catch (n) {
                c = new T(null, 2, 5, W, [Cn, "" + y(n)], null);
              }
              d = S(c, 0, null);
              c = S(c, 1, null);
              b[7] = d;
              return lq(b, c);
            }
            return null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 2, 5, W, [Oq("brainfuck"), "https://viebel.github.io/klipse/repo/js/brainfuck.js"], null), Kl, ""], null);
Pq("eval-brainfuck", "selector_brainfuck", Nz);
Pq("eval-brainfuck-txt", "selector_brainfuck_txt", Oz);
var Pz = new u(null, 5, [fn, "clojure", Bk, "text", Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            if (1 === b[1]) {
              var c = LAMBDATALK.evaluate.call(LAMBDATALK, a).val;
              return lq(b, c);
            }
            return null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, rn, new T(null, 2, 5, W, ["https://viebel.github.io/klipse/repo/js/lambdaway_eval.js", Oq("clojure")], null), Kl, "[comment]: "], null);
Pq("eval-lambdaway", "selector_eval_lambdaway", Pz);
function Qz() {
  var a = uniter;
  return a.createEngine.call(a, "PHP");
}
var Rz = new u(null, 5, [fn, "text/x-php", Bk, "text/x-php", Wn, function(a) {
  var b = xq(null);
  a = [y("\x3c?php"), y(a)].join("");
  var c = xq(1);
  Wp(function(a, b, c) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (z) {
                    if (z instanceof Object) {
                      b[5] = z, oq(b), c = Z;
                    } else {
                      throw z;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(a, b, c) {
          return function(d) {
            var e = d[1];
            if (1 === e) {
              var f = Qz(), g = f.getStderr, k = g.call(f), l = k.on, m = function() {
                return function(a, b, c, d, e, f, g, k, l, m, n) {
                  return function(a) {
                    return Aq(n, "" + y(a));
                  };
                }(f, k, k, l, f, g, k, l, e, a, b, c);
              }(), n = l.call(k, "data", m), t = f.getStdout, Q = t.call(f), K = Q.on, E = K.call(Q, "data", function() {
                return function(a, b, c, d, e, f, g, k, l, m, n, t, r, v, x, z) {
                  return function(a) {
                    return Aq(z, "" + y(a));
                  };
                }(f, Q, Q, K, f, g, k, l, m, n, t, Q, K, e, a, b, c);
              }()), ba = f.execute.call(f, c);
              d[7] = n;
              d[8] = E;
              return lq(d, ba);
            }
            return null;
          };
        }(a, b, c), a, b, c);
      }(), e = function() {
        var b = d.v ? d.v() : d.call(null);
        b[6] = a;
        return b;
      }();
      return iq(e);
    };
  }(c, b, a));
  return b;
}, rn, new T(null, 6, 5, W, [Oq("xml"), Oq("clike"), Oq("php"), Oq("javascript"), Oq("css"), "https://viebel.github.io/klipse/repo/js/uniter.js?r"], null), Kl, "//"], null);
Pq("eval-php", "selector_eval_php", Rz);
var Sz = new u(null, 3, "immutable https://raw.githubusercontent.com/facebook/immutable-js/master/dist/immutable.min.js jQuery https://code.jquery.com/jquery-2.2.4.min.js underscore http://underscorejs.org/underscore-min.js".split(" "), null), Tz = eval;
function Uz(a) {
  return C.l(Sz, a, a);
}
function Vz(a) {
  try {
    return "" + y(prettyFormat(a));
  } catch (b) {
    if (b instanceof Object) {
      return "" + y(a);
    }
    throw b;
  }
}
function Wz(a) {
  return function() {
    function b(a) {
      var b = null;
      if (0 < arguments.length) {
        for (var b = 0, d = Array(arguments.length - 0);b < d.length;) {
          d[b] = arguments[b + 0], ++b;
        }
        b = new F(d, 0);
      }
      return c.call(this, b);
    }
    function c(b) {
      Aq(a, ap(" ", vg.j(Vz, b)));
      return Aq(a, "\n");
    }
    b.L = 0;
    b.J = function(a) {
      a = D(a);
      return c(a);
    };
    b.B = c;
    return b;
  }();
}
function Xz(a, b) {
  var c = Wz(a), d = [y("(function(console) {"), y(b), y("}(window.klipse_snippet_console))")].join("");
  klipse_snippet_console = {log:c};
  Tz.h ? Tz.h(d) : Tz.call(null, d);
  return "";
}
Pq("eval-javascript", "selector_eval_js", new u(null, 5, [fn, "javascript", Bk, "javascript", Wn, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.l(c, nl, !1), e = C.l(c, Wj, null), f = xq(null), g = xq(1);
  Wp(function(b, c, d, e, f, g) {
    return function() {
      var k = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (E) {
                    if (E instanceof Object) {
                      b[5] = E, oq(b), c = Z;
                    } else {
                      throw E;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(b, c, d, e, f, g) {
          return function(b) {
            var d = b[1];
            if (7 === d) {
              return d = Aq(c, b[2]), b[2] = d, oq(b), Z;
            }
            if (1 === d) {
              return d = vg.j(Uz, g), d = Px(d), jq(b, 2, d);
            }
            if (4 === d) {
              return d = b[7], nq(b, null, null, null, 3), d = J.j(Pm, d), b[1] = d ? 5 : 6, Z;
            }
            if (15 === d) {
              var d = b[2], e = console.log = console.log;
              b[8] = d;
              b[9] = e;
              oq(b);
              return Z;
            }
            if (13 === d) {
              return d = b[2], b[2] = d, oq(b), Z;
            }
            if (6 === d) {
              var e = b[10], k = b[11], d = [y("//Cannot load script: "), y(k), y("\n"), y("//Error: "), y(e)].join("");
              b[2] = d;
              b[1] = 7;
              return Z;
            }
            return 3 === d ? lq(b, b[2]) : 12 === d ? (d = console.log = Wz(c), b[12] = d, b[2] = null, b[1] = 16, Z) : 2 === d ? (k = b[2], d = S(k, 0, null), e = S(k, 1, null), k = S(k, 2, null), b[7] = d, b[10] = e, b[11] = k, b[2] = null, b[1] = 4, Z) : 11 === d ? (d = Xz(c, a), b[2] = d, b[1] = 13, Z) : 9 === d ? (d = "" + y(b[2]), b[2] = d, oq(b), Z) : 5 === d ? (b[2] = null, b[1] = 10, Z) : 14 === d ? (b[2] = b[2], b[1] = 13, Z) : 16 === d ? (nq(b, null, null, 15, 14), d = Tz.h ? Tz.h(a) : 
            Tz.call(null, a), d = Vz(d), b[2] = d, oq(b), Z) : 10 === d ? (nq(b, 9, Ok, null, 8), b[1] = w(f) ? 11 : 12, Z) : 8 === d ? (b[2] = b[2], b[1] = 7, Z) : null;
          };
        }(b, c, d, e, f, g), b, c, d, e, f, g);
      }(), l = function() {
        var a = k.v ? k.v() : k.call(null);
        a[6] = b;
        return a;
      }();
      return iq(l);
    };
  }(g, f, b, c, d, e));
  return f;
}, rn, new T(null, 1, 5, W, ["https://viebel.github.io/klipse/repo/js/pretty_format.js"], null), Kl, "//"], null));
Pq("eval-es2017", "selector_es2017", new u(null, 5, [fn, "javascript", Bk, "javascript", Wn, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, c = C.l(c, nl, !1), d = xq(null);
  try {
    var e, f = Babel;
    e = f.transform.call(f, a, {presets:["es2017"]}).code;
    var g;
    if (w(c)) {
      g = Xz(d, e);
    } else {
      a: {
        var k = console.log;
        console.log = Wz(d);
        try {
          g = Vz(Tz.h ? Tz.h(e) : Tz.call(null, e));
          break a;
        } finally {
          console.log = k;
        }
        g = void 0;
      }
    }
    Aq(d, g);
  } catch (l) {
    Aq(d, "" + y(l));
  }
  return d;
}, rn, new T(null, 3, 5, W, ["https://viebel.github.io/klipse/repo/js/pretty_format.js", "https://cdnjs.cloudflare.com/ajax/libs/babel-standalone/6.18.1/babel.min.js", "https://viebel.github.io/klipse/repo/js/babel_polyfill.min.js"], null), Kl, "//"], null));
var Yz = new u(null, 5, [fn, "markdown", Bk, "htmlmixed", rn, new T(null, 5, 5, W, ["https://viebel.github.io/klipse/repo/js/markdown.min.js?", Oq("xml"), Oq("htmlmixed"), Oq("javascript"), Oq("css")], null), Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            if (1 === b[1]) {
              var c = markdown.toHTML(a);
              return lq(b, c);
            }
            return null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, Kl, "[comment]: "], null);
Pq("eval-markdown", "selector_eval_markdown", Yz);
function Zz(a, b) {
  try {
    var c = gj(new u(null, 1, [Rm, new u(null, 1, [fm, function(a) {
      return Aq(b, a);
    }], null)], null)), d = function() {
      var b = JSCPP;
      return b.run.call(b, a, "", c);
    }();
    return J.j(0, d) ? new T(null, 2, 5, W, [Pm, 0], null) : new T(null, 2, 5, W, [Cn, d], null);
  } catch (e) {
    return new T(null, 2, 5, W, [Hn, e], null);
  }
}
var $z = new u(null, 5, [fn, "text/x-c++src", Bk, "text", rn, new T(null, 2, 5, W, [Oq("clike"), "https://viebel.github.io/klipse/repo/js/JSCPP.es5.min.js"], null), Wn, function(a) {
  var b = xq(null), c = Zz(a, b);
  a = S(c, 0, null);
  c = S(c, 1, null);
  switch(a instanceof X ? a.fb : null) {
    case "ok":
      Aq(b, [y("\nexit code: "), y(c)].join(""));
      break;
    case "error":
      Aq(b, [y("\nexit code:"), y(c)].join(""));
      break;
    case "exception":
      Aq(b, [y("\n"), y(c)].join(""));
      break;
    default:
      throw Error([y("No matching clause: "), y(a)].join(""));;
  }
  return b;
}, Kl, "//"], null);
Pq("eval-cpp", "selector_eval_cpp", $z);
var aA = new u(null, 5, [fn, "text/html", Bk, "text", rn, new T(null, 2, 5, W, [Oq("xml"), Oq("htmlmixed")], null), Wn, function(a) {
  var b = xq(1);
  Wp(function(b) {
    return function() {
      var c = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (r) {
                    if (r instanceof Object) {
                      b[5] = r, oq(b), c = Z;
                    } else {
                      throw r;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function() {
          return function(b) {
            return 1 === b[1] ? lq(b, a) : null;
          };
        }(b), b);
      }(), e = function() {
        var a = c.v ? c.v() : c.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(b));
  return b;
}, Kl, "; "], null);
Pq("eval-html", "selector_eval_html", aA);
function bA(a) {
  if (null == Sk.builtinFiles || null == function() {
    var a = Sk.builtinFiles;
    return w(a) ? (a = a.files, w(a) ? a : null) : null;
  }()[a]) {
    throw [y("File not found: '"), y(a), y("'")].join("");
  }
  return function() {
    var a = Sk.builtinFiles;
    return w(a) ? (a = a.files, w(a) ? a : null) : null;
  }()[a];
}
var cA = Lx(function() {
  var a = Sk;
  a.TurtleGraphics = {};
  return a;
}), dA = new u(null, 6, [fn, "python", Bk, "python", Wn, function(a, b) {
  var c = null != b && (b.w & 64 || q === b.M) ? Vf(pg, b) : b, d = C.j(c, Om);
  cA.v ? cA.v() : cA.call(null);
  var e = xq(null), f = Sk, g = f.configure;
  g.call(f, {output:function(a, b, c) {
    return function(a) {
      return Aq(c, a);
    };
  }(f, g, e, b, c, d), read:bA});
  (function() {
    var f = Sk.misceval, g = f.asyncToPromise;
    return g.call(f, function(b, c, d, e, f, g) {
      return function() {
        Aq(d, "Output:\n");
        var b = Sk, c = b.TurtleGraphics;
        w(c) ? c.target = g : (c = {}, c.target = g, b.TurtleGraphics = c);
        b = Sk;
        return b.importMainWithBody.call(b, "\x3cstdin\x3e", !1, a, !0);
      };
    }(f, g, e, b, c, d));
  })().then(function() {
    return function() {
      var a = console;
      return a.info.call(a, "success to eval skulpt: ");
    };
  }(e, b, c, d), function(a) {
    return function(b) {
      return Aq(a, [y("error: "), y(b)].join(""));
    };
  }(e, b, c, d));
  return e;
}, ll, !1, rn, new T(null, 3, 5, W, [Oq("python"), "https://viebel.github.io/klipse/repo/js/skulpt.min.js", "https://viebel.github.io/klipse/repo/js/skulpt-stdlib.js"], null), Kl, "#"], null);
Pq("eval-python-client", "selector_eval_python_client", dA);
function eA(a) {
  a = gj(new u(null, 2, [tk, new T(null, 1, 5, W, [new u(null, 1, [Gl, a], null)], null), El, "ADVANCED"], null));
  console.log(a);
  a = jj(compile(a), P([kj, !0], 0));
  a = null != a && (a.w & 64 || q === a.M) ? Vf(pg, a) : a;
  var b = C.j(a, Ro), c = C.j(a, Oj);
  C.j(a, Il);
  return D(c) ? [y("//errors during compilation:\n"), y(function() {
    var a = gj(c);
    return JSON.stringify(a);
  }())].join("") : b;
}
Pq("compile-javascript", "selector_compile_js", new u(null, 5, [fn, "javascript", Bk, "javascript", Wn, function(a) {
  var b = xq(null), c = xq(1);
  Wp(function(b, c) {
    return function() {
      var d = function() {
        return function(a) {
          return function() {
            function b(b) {
              for (;;) {
                var c;
                a: {
                  try {
                    for (;;) {
                      var d = a(b);
                      if (!Y(d, Z)) {
                        c = d;
                        break a;
                      }
                    }
                  } catch (x) {
                    if (x instanceof Object) {
                      b[5] = x, oq(b), c = Z;
                    } else {
                      throw x;
                    }
                  }
                }
                if (!Y(c, Z)) {
                  return c;
                }
              }
            }
            function c() {
              var a = [null, null, null, null, null, null, null, null, null];
              a[0] = d;
              a[1] = 1;
              return a;
            }
            var d = null, d = function(a) {
              switch(arguments.length) {
                case 0:
                  return c.call(this);
                case 1:
                  return b.call(this, a);
              }
              throw Error("Invalid arity: " + arguments.length);
            };
            d.v = c;
            d.h = b;
            return d;
          }();
        }(function(b, c) {
          return function(b) {
            var d = b[1];
            if (1 === d) {
              return kq(b, 2, c, "//compiling...\n");
            }
            if (2 === d) {
              var d = b[2], e = vq(0);
              b[7] = d;
              return jq(b, 3, e);
            }
            return 3 === d ? (d = b[2], e = eA(a), b[8] = d, kq(b, 4, c, e)) : 4 === d ? lq(b, b[2]) : null;
          };
        }(b, c), b, c);
      }(), e = function() {
        var a = d.v ? d.v() : d.call(null);
        a[6] = b;
        return a;
      }();
      return iq(e);
    };
  }(c, b));
  return b;
}, Dl, 5E3, Kl, "//"], null));
bj.B(P(["settings: ", window.klipse_settings], 0));
function fA() {
  return window.klipse_settings;
}
ua("klipse.run.plugin_prod.plugin.settings", fA);
jz(fA());

})();

// @license-end